        ;---------------------------------------------
		; 0D_HACK.SRC
    	; BDWM/9042, P/N 16189041   10-11-1993  
		;
    	; REV 5/8/98 ws, Update 8192 data lists
    	;
    	; PCM TYPE $0D, P/N 16196395 PCM, S/S BY PCM 16197427
    	;
    	; MY 94, 5.7L V8 C1 M30 GT4 (3.73) NB2 NB6 TIER 1 
		;
		;  MAP = (n+28.05)/2.71
		;	   = (n*0.369)+10.354
		;      = (n/2.71)+10.354	
		;
		; 0050,#$80 IDLE FLAG
        ;---------------------------------------------
*BACK UP AFTER EACH SESSION*
;
;~~~~~~~~~~~~~~~~~
;-Work pending...
;~~~~~~~~~~~~~~~~~
;
LDEE1
E6B4	


LCC05
AF62
LDC52
F01D
Continue with RTS commenting
1943

D854
D425
b773
b3c8





;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Some conversion stuff...
;>SPARK
; -SA           = X * .351
;>RPM
; -RPM	        = X / 25
; -Scaled RPM   = X / 12.5, (X - 64) x 25
;>TPS
; -A/D TPS	= X * .0039
; -TPS		=(L5B26 x (A/D TPS-base TPS))/64   
;>MAP/VAC
; -SdMap        = ((ADC - 26) x 151) / 128
; -kPa          = (SDMap x .313) + 20.0
; -kPa          = (ADC x 0.369) + 10.415
; -A/D vac	= 256 - 1.18 x (A/D Baro - A/D MAP)
; -VACkPa       = .313 x (256 - A/D Vac)
;
;>Coolant counts conversion table for raw A/D value
;
;	 A/D 	degrees		A/D
; 	counts     C		Inv
; 	------- -------		---
; 	255	    -40		  0
; 	251	    -30		  4
; 	250	    -25		  5
; 	247	    -20		  8
; 	245	    -15		 10
; 	241	    -10		 14
; 	237	    - 5		 18
; 	231	      0		 24
; 	225	      5		 30
; 	218	     10		 37
; 	209	     15		 46
; 	199	     20		 56
; 	189	     25		 66
; 	177	     30		 78
; 	165	     35		 90
; 	152	     40		103
; 	139	     45		116
; 	126	     50		129
; 	114	     55		141
; 	102	     60		153
; 	92	     65		163
; 	81	     70		174
; 	72	     75		183
; 	64	     80		191
; 	56	     85		199
; 	50	     90		205
; 	44	     95		211
; 	39	    100		216
; 	34	    105		221
; 	30	    110		225
; 	26	    115		229
; 	23	    120		232
; 	21	    125		234
; 	18	    130		237
; 	16	    135		239
; 	14	    140		241
; 	13	    145		242
; 	12	    150		243
; 	0	    200		255
;
;>Temp conversion for stored linear counts
; -Deg C = .746 x counts - 40
;
;>Filtered value at any loop pass n is:
;
; n=0
;  Filtered value=initial value
;
; n=1,2,3...infinity
;  Filtered value=initial value + (1-FC) x sum([FC]^k,k=0,n-1) x 
;		  (end value - initial value)
;
; Note: Only valid while intial and end values remain constant 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; RAM Addresses
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L0000	EQU	$0000			;Status word
					; b7=
					; b6=
					; b5=	
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L0001	EQU	$0001			;
;
L0002	EQU	$0002			;Loop counter
L0003	EQU	$0003			;Loop counter, one delayed
L0004	EQU	$0004			;Status word
					; b7=EST circuit failure
					; b6=
					; b5=
					; b4=Hot restarts in effect
					; b3=Bad shutdown
					; b2=RAM refresh incomplete
					; b1=
					; b0=O2 functional
;
L0005	EQU	$0005			;Status word
					; b7=MAP AE in effect
					; b6=TPS AE in effect
					; b5=
					; b4=EPROM failure
					; b3=
					; b2=
					; b1=
					; b0=
;
L0006	EQU	$0006			;Cool temp, linear
L0007	EQU	$0007			;Current IAC steps
L0008	EQU	$0008			;Desired IAC steps
L0009	EQU	$0009			;Status word
					; b7=
					; b6=Throttle kicker failed diags.
					; b5=Stable idle attained, A/C on
					; b4=Stable idle attained, A/C off
					; b3=
					; b2, 0=IAC reset requested
					; b1=First run flag for IAC flow kickdown logic
					; b0, 0=IAC reset in progress
;
L000A	EQU	$000A			;IAC control word
					; b7=
					; b6=
					; b5=
					; b4, 1=Enable IAC
					; b3, 1=Coil state B on
					; b2, 1=Coil state A on
					; b1=
					; b0, 1=Extend IAC
;
L000B	EQU	$000B			;
L000C	EQU	$000C			;
L000D	EQU	$000D			;
L000E	EQU	$000E			;
L000F	EQU	$000F			;
L0010	EQU	$0010			;
L0011	EQU	$0011			;
L0012	EQU	$0012			;
L0013	EQU	$0013			;
L0014	EQU	$0014			;
L0015	EQU	$0015			;Diagnostic checksum
L0016	EQU	$0016			;Error word #1
					; b7=
					; b6=
					; b5=
					; b4=Err 16, VSS error
					; b3=
					; b2=
					; b1=
					; b0=Err 21, high TPS
;
L0017	EQU	$0017			;Error word #2
					; b7=Error 22, low TPS
					; b6=Error 23, low MAT
					; b5=
					; b4=Error 25, high MAT
					; b3=
					; b2=
					; b1=
					; b0=
;
L0018	EQU	$0018			;Error word #3
					; b7= Error 31, Governor
					; b6= Error 32, EGR
					; b5= Error 33, MAP sens. high
					; b4= Error 34, MAP sens. low
					; b3= Error 35, IAC malf.
					; b2= Error 36, Throttle kicker malf.
					; b1= Error 37, TCC brake switch stuck on
					; b0= Error 38, TCC brake switch stuck off
;
L0019	EQU	$0019			;Error word #4
					; b7=
					; b6=Error 41, 1x cam sensor
					; b5=Error 42, EST circuit failure
					; b4=Error 43, Knock sensor circuit
					; b3=Error 44, Lean O2
					; b2=Error 45, O2 rich
					; b1=Error 46, VATS
					; b0=
;	
L001A	EQU	$001A			;Error word #5
					; b7=Err. 48
					; b6=Err. 49
					; b5=Err. 51, EEPROM checksum fail
					; b4=Err. 52, High system voltage, long test
					; b3=Err. 53, High system voltage
					; b2=Err. 54, Low fuel pump volts/faulty relay
					; b1=Err. 55, Faulty PCM
					; b0=Err. 56, quad driver B fault
;
L001B	EQU	$001B			;Error word #6
                    			; b7 1 = ERR 57,
                    			; b6 1 = ERR 58, high trans temp
                    			; b5 1 = ERR 59, low trans temp
                    			; b4 1 = ERR 61,
                    			; b3 1 = ERR 62, 
                    			; b2 1 = ERR 63, high baro pressure
                    			; b1 1 = ERR 64, low baro pressure
                    			; b0 1 = ERR 65,
; 	
L001C	EQU	$001C			;				
L001D	EQU	$001D			;Error word #8
					; b7=Err 75, system voltage low
					; b6=Err 76, 
					; b5=Err 77, MNP switch
					; b4=Err 78, 
					; b3=Err 79, Transmission hot
					; b2=Err 81, Shift sol. A failure
					; b1=Err 82, Shift sol. B failure
					; b0=Err 83, TCC solenoid failure
;
L001E	EQU	$001E			;Error word #9
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=Error 89, max adpt long shift
					; b1= 
					; b0=
;
L001F	EQU	$001F			;Error 21 counter
L0020	EQU	$0020			;Error 22 counter
L0021	EQU	$0021			;Error 24 counter
L0022	EQU	$0022			;Error 28 counter
L0023	EQU	$0023			;Error 37 counter
L0024	EQU	$0024			;Error 38 counter
L0025	EQU	$0025			;Error 68 counter
L0026	EQU	$0026			;Error 66 counter
L0027	EQU	$0027			;Error 67 counter
L0028	EQU	$0028			;Error 68 counter
L0029	EQU	$0029			;Error 72 counter
L002A	EQU	$002A			;Error 73 counter
L002B	EQU	$002B			;Error 81 counter
L002C	EQU	$002C			;Error 82 counter
L002D	EQU	$002D			;Error 83 counter
L002E 	EQU	$002E			;Error 85 counter
L002F	EQU	$002F			;Error 86 counter 
L0030	EQU	$0030			;Error 87 counter
L0031	EQU	$0031			;Error 89 counter
L0032	EQU	$0032			;
L0033	EQU	$0033			;
L0034	EQU	$0034			;
L0035	EQU	$0035			;
L0036	EQU	$0036			;Status word
					; b7=High idle speed
					; b6=Throttle kicker has previously been active
					; b5=P/S compensation in effect
					; b4=Stall saver in effect
					; b3=Closed loop idle in effect
					; b2=Closed loop idle quals met
					; b1, 0=park/neutral, 1=drive
					; b0, 0=A/C off, 1=A/C on
;
L0037	EQU	$0037			;Status word
					; b7, 1=positive derivative idle term
					; b6=Limiting idle proportional action
					; b5=
					; b4=Throttle kicker disable req. flag
					; b3=Throttle kicker disable req. flag
					; b2, 1=Thottle kicker is active
					; b1=reduce thtottle follower action
					; b0=warm engine flag, throttle follower
;
L0038	EQU	$0038			;Status word
					; b7=
					; b6=
					; b5=Sign of added DFCO IAC airflow
					; b4=Initial stored IAC flow updated
					; b3=Update idle int. flag, drive, A/C on
					; b2=Update idle int. flag, drive, no A/C
					; b1=Update idle int. flag, P/N, A/C on
					; b0=Update idle int. flag, P/N, no A/C	
;				
L0039	EQU	$0039			;Status word
					; b7=Throttle open flag
					; b6=Manditory post-DFCO T/F added flow update
					; b5=
					; b4=
					; b3=
					; b2=Throttle kicker diags. performed
					; b1=Post throttle kicker base TPS updated
					; b0=Throttle kicker base TPS updated
;	
L003A	EQU	$003A			;Error word 
					; b7=
					; b6=Bad RAM checksum
					; b5=Loop overran
					; b4=
					; b3=
					; b2=
					; b1=EPROM failure
					; b0=A/D failure
;
L003B	EQU	$003B			;Serial data status word
					; b7=Double byte transmission in progress
					; b6=ALDL transmission in progress
					; b5=
					; b4=In ALDL mode 4
					; b3=
					; b2=Trans. diagnostics disabled
					; b1=In ALDL mode 10 (engine diag.)
					; b0=In ALDL mode 10 (trans diag.)
;
L003C	EQU	$003C			;
L003D	EQU	$003D			;Status word
					; b7=Deliver async pulse
					; b6=Accel enrich active
					; b5=PE underway
					; b4=Decel enlean underway
					; b3=Delay BLM update
					; b2=BLM cell change
					; b1=VATS passed/failed
					; b0=no delta speed entry into PE allowed
;
L003E	EQU	$003E			;Status word
					; b7=In closed loop
					; b6=
					; b5=
					; b4=In async fire
					; b3=Cold choke decay delay complete
					; b2=IAC disabled, batt volts out of range
					; b1=Enabling BLM update
					; b0=Deliver post-DFCO AE pulse
;
L003F	EQU	$003F			;Status word
					; b7=Short BPW flag
					; b6, 1=clear initial idle terms
					; b5=bypass PE delay next pass
					; b4=Sync/async. flag
					; b3=RPMs outside desired idle range (O2 handling)
					; b2=High idle speed, (O2 handling)
					; b1=RPMs changing too rapildy for idle (O2 hand'g)
					; b0=RPMs falling (O2 handling)
;
L0040	EQU	$0040			;
L0041	EQU	$0041			;Status word
					; b7=CCP solenoid energized
					; b6=
					; b5=In P/N
					; b4=A/C on
					; b3=A/C AE delivered
					; b2=
					; b1=MAT SA corr., 1=negative, 0=positive
					; b0=Increment closed linear EGR position
;
L0042	EQU	$0042			;ALDL diag. status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=Transmission diagnostics flag
					; b0=Engine diagnostics flag
;
L0043	EQU	$0043			;Status word
					; b7=
					; b6=
					; b5=
					; b4=Change in fueling state
					; b3=
					; b2=
					; b1=
					; b0=
;
L0044	EQU	$0044			;Status word
					; b7=EST circuit failure
					; b6=EST monitor
					; b5=
					; b4=Ignition off
					; b3=First valid DRP recieved
					; b2=
					; b1=Limit closed loop correction when AE in effect 
					; b0=Factory test required
;
L0045	EQU	$0045			;
L0046	EQU	$0046			;Status word
					; b7=Have entered closed loop since startup
					; b6=BLM cells reset
					; b5=
					; b4=Fuel cut off in effect
					; b3=DFCO in effect
					; b2, 1=AIR enabled
					; b1, 1=Long term fueling is rich, 0=lean 
					; b0=
;
L0047	EQU	$0047			;Status word
					; b7=
					; b6=
					; b5=TCC status
					; b4=A/C status
					; b3=
					; b2=
					; b1=
					; b0=Load transient MAP filter coeff
;
L0048	EQU	$0048			;	
L0049	EQU	$0049			;
L004A	EQU	$004A			;	
L004B	EQU	$004B			;I/O word
					; b7, TCC/throttle kicker, 0=on, 1=off
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L004C	EQU	$004C			;I/O port D word 
					; b7=
					; b6=
					; b5=
					; b4=IAC enable	
					; b3=IAC coil state B
					; b2=IAC coil state A
					; b1=
					; b0=
;
L004D	EQU	$004D			;I/O port C word
					; b7=
					; b6=
					; b5, 0=Park/Neutral
					; b4=
					; b3=
					; b2=
					; b1, 1=brake switch off
					; b0, 1=A/C req.
;
L004E	EQU	$004E			;Status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1, 1=use cool linear temp table for trans temp  
					; b0, 1=use cool linear temp table for engine temp
;
L004F	EQU	$004F			;Status word
					; b7=Engine running
					; b6=EST bypass diag. already performed
					; b5=Reset INT on VE table change
					; b4=Engine above threshold for cranking or off
					; b3=Switched to open VE table
					; b2=Major loop overran 6.25 msec period
					; b1=
					; b0, 1=Negative SA, 0=Positive SA
;
L0050	EQU	$0050			;Status word
					; b7=Engine idling flag
					; b6=Idle SA enabled
					; b5=DRP occured
					; b4=In diagnostics mode
					; b3=In ALDL mode
					; b2=DRP occured, 6.25 msec test
					; b1=Open loop idle enabled
					; b0=Sync. MAP reads
;
L0051	EQU	$0051			;Status word
					; b7=Trans. from double. to single fire in prog.
					; b6=All SA has been ramped in
					; b5=DFCO SA correction enabled
					; b4=High batt. volts
					; b3=Shutdown in effect
					; b2=
					; b1=
					; b0=In single fire mode
;
L0052	EQU	$0052			;Status word
					; b7=In quasi-closed loop
					; b6=Cat overtemp flag
					; b5=A/C anticipated to be on
					; b4=A/C disabled due to high rpms
					; b3=CPI tuning valve enabled
					; b2=Engine idling (BLM routine)
					; b1=Low knock activity (low octaine control)
					; b0=High knock activity (low octaine control)
;
L0053	EQU	$0053			;Status word
					; b7=
					; b6=Single fire alt. exit desired
					; b5=First injector firing pending
					; b4=P/S SA compensation in effect
					; b3=High RPM indicated (trans abuse test)
					; b2=Shiftlight enabled
					; b1=Skip min delta TPS check, decel enlean
					; b0, 1=engine idle overspeed, 0=engine idle underspeed
;
L0054	EQU	$0054			;
L0055	EQU	$0055			;Fuel pump volts x 10
L0056	EQU	$0056			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L0057	EQU	$0057			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L0058	EQU	$0058			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L0059	EQU	$0059			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005A	EQU	$005A			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005B	EQU	$005B			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005C	EQU	$005C			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005D	EQU	$005D			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005E	EQU	$005E			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L005F	EQU	$005F			;DRP period
L0060	EQU	$0060			;
L0061	EQU	$0061			;Scaled RPMs, 0-2400 in 12.5 rpm inc., 2400-4800 in 25 rpm inc.
L0062	EQU	$0062			;RPM/25
L0063	EQU	$0063			;MSB, filtered RPM/12.5
L0064	EQU	$0064			;LSB, filtered RPM/12.5
L0065	EQU	$0065			;RPM/12.5, one delayed
L0066	EQU	$0066			;RPM/12.5, one delayed, O2 handling
L0067	EQU	$0067			;RPM/6.25
L0068	EQU	$0068			;MSB, filtered RPM/6.25
L0069	EQU	$0069			;LSB, filtered RPM/6.25
L006A	EQU	$006A			;MSB, delayed filtered RPM/6.25
L006B	EQU	$006B			;LSB, delayed filtered RPM/6.25
L006C	EQU	$006C			;Transient RPM ratio
L006D	EQU	$006D			;Status word
					; b7=	
					; b6=
					; b5=
					; b4=
					; b3=EGR position error sign, 0=plus/1=minus
					; b2=
					; b1=
					; b0=
;
L006E	EQU	$006E			;Status word
					; b7, 1=EGR enabled
					; b6, 1=RPM threshold for EGR met
					; b5, 1=TPS threshold for EGR met
					; b4, 1=MAP threshold for EGR met
					; b3=Accel enrich now active
					; b2. 1=Vac threshold for EGR met
					; b1=Knock prevention in effect
					; b0=INT reset/BLM cell change (EGR diag.)
;
L006F	EQU	$006F			;Status word
					; b7=
					; b6=Error, high MAP
					; b5=Error, low TPS
					; b4=
					; b3=Error, low MAP
					; b2=Error, High TPS
					; b1=
					; b0=
;
L0070	EQU	$0070			;Status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=EGR diags. in progress
					; b1=
					; b0=EGR failed diagnostics
;
L0071	EQU	$0071			;Status word
					; b7=Diagnostics in effect
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=INT just reset (O2 diag.)
					; b1=
					; b0=
;
L0072	EQU	$0072			;Status word
					; b7=
					; b6=Error 42, O2 lean
					; b5, 1=Linear EGR failed diags
					; b4=
					; b3=
					; b2=
					; b1=Fuel pump volts diagnostics in progress
					; b0=Low fuel pump volts/relay failure
;
L0073	EQU	$0073			;CPU status
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2= VSS pulse ocured
					; b1=
					; b0=
;
L0074	EQU	$0074			;
L0075	EQU	$0075			;Governor status word
					; b7=In MPH govern
					; b6=MPH overspeed
					; b5=
					; b4=
					; b3=
					; b2=RPM overspeed
					; b1=Post derivative TPS return
					; b0=RPM govern in effect
;
L0076	EQU	$0076			;
L0077	EQU	$0077			;
L0078	EQU	$0078			;MSB, filtered cat reaction temp
L0079	EQU	$0079			;LSB. filterec cat reaction temp
L007A	EQU	$007A			;Cat reaction temp
L007B	EQU	$007B			;Flow based cat raction temp				
L007C	EQU	$007C			;Cat reaction temperature filter coeff.
L007D	EQU	$007D			;Cat reaction AFR temperature bias
L007E	EQU	$007E			;Cat overtemp test timer
L007F	EQU	$007F			;Status word
					; b7=
					; b6=
					; b5=
					; b4=Forced to downshift (???)
					; b3=Forced to downshift (???)
					; b2=
					; b1=Forced to upshift (???)
					; b0=Forced to upshift (???)
;
L0080	EQU	$0080			;
L0081	EQU	$0081			;Trans shift status word
					; b7=Shift is complete
					; b6=Heads up requested
					; b5=2-4 jump shift when in OD
					; b4=Shift has started
					; b3= 
					; b2=
					; b1=Derivative shift has started
					; b0=Slope of derivative is negative
;
L0082	EQU	$0082			;Status word
					; b7=Powertrain is in motion
					; b6=ELCO inst. prom is present
					; b5=
					; b4=NV ram update allowed
					; b3=Ign. power is on
					; b2=Force motor pulse in progress
					; b1=
					; b0=Force motor shutoff due to low bat. volts
;
L0083	EQU	$0083			;Trans status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=Hot temp. threshold
					; b0=Disallow shift into OD
;
L0084	EQU	$0084			;
L0085	EQU	$0085			;TCC status word
					; b7=
					; b6=
					; b5=TCC commanded to lock
					; b4=
					; b3=
					; b2=
					; b1=
					; b0= 
;
L0086	EQU	$0086			;
L0087	EQU	$0087			;
L0088	EQU	$0088			;
L0089	EQU	$0089			;					
L008A	EQU	$008A			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0= 
;
L008B	EQU	$008B			;
L008C	EQU	$008C			;
L008D	EQU	$008D			;
L008E	EQU	$008E			;
L008F	EQU	$008F			;
L0090	EQU	$0090			;
L0091	EQU	$0091			;
L0092	EQU	$0092			;Status word
					; b7=Heat related transmission errors set
					; b6=
					; b5=
					; b4=
					; b3=General trans related errors set
					; b2=Trans. press. switch man. error
					; b1=
					; b0=Transmission TPS error
;
L0093	EQU	$0093			;Status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=Error, high system voltage present
					; b2=Error, trans output speed loss
					; b1=Shift error
					; b0=External errors set
;
L0094	EQU	$0094			;Status word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=High system voltage present
					; b2, 0=bump idle tps when in decel
					; b1=
					; b0=
;
L0095	EQU	$0095			;
L0096	EQU	$0096			;Status word
					; b7=
					; b6=
					; b5=
					; b4=Enable kickdown
					; b3=
					; b2=
					; b1=
					; b0=Brakes applied
;
L0097	EQU	$0097			;
L0098	EQU	$0098			;
L0099	EQU	$0099			;Trans shift pattern word
					; b7=
					; b6=
					; b5=
					; b4=
					; b3, 1=Illigal shift pattern
					; b2, 1=Manual pattern requested
					; b1, 1=Performance pattern requested
					; b0, 1=Normal pattern requested
;
L009A	EQU	$009A			;Previous shift pattern 
;
L009B	EQU	$009B			;
L009C	EQU	$009C			;Trans range word
					; b7=Illegal range
					; b6=P/N
					; b5=Reverse
					; b4=
					; b3=4th
					; b2=3rd
					; b1=2nd
					; b0=1st
;
L009E	EQU	$009E			;
L009F	EQU	$009F			;A/D transmission temp
L00A0	EQU	$00A0			;A/D TPS voltage
L00A1	EQU	$00A1			;A/D batt. voltage
L00A2	EQU	$00A2			;Linaer cool temp
L00A3	EQU	$00A3			;Engine temp for transmission
L00A4	EQU	$00A4			;
L00A5	EQU	$00A5			;Cold temp trans term
L00A6	EQU	$00A6			;MSB, trans baro term, filtered
L00A7	EQU	$00A7			;LSB, trans baro term, filtered
L00A8	EQU	$00A8			;
L00A9	EQU	$00A9			;
L00AA	EQU	$00AA			;MSB, transmission TPS, filtered
L00AB	EQU	$00AB			;LSB, transmission TPS, filtered
L00AC	EQU	$00AC			;(???)
L00AE	EQU	$00AE			;Trans temp, linear
L00AF	EQU	$00AF			;MSB, Trans temp, filtered
L00B0	EQU	$00B0			;LSB, Trans temp, filtered
L00B1	EQU	$00B1			;
L00B2	EQU	$00B2			;
L00B3	EQU	$00B3			;
L00B4	EQU	$00B4			;
L00B5	EQU	$00B5			;
L00B6	EQU	$00B6			;
L00B7	EQU	$00B7			;
L00B8	EQU	$00B8			;
L00B9	EQU	$00B9			;
L00BA	EQU	$00BA			;
L00BB	EQU	$00BB			;
L00BC	EQU	$00BC			;
L00BD	EQU	$00BD			;
L00BE	EQU	$00BE			;
L00BF	EQU	$00BF			;
L00C0	EQU	$00C0			;
L00C1	EQU	$00C1			;
L00C2	EQU	$00C2			;
L00C3	EQU	$00C3			;
L00C4	EQU	$00C4			;
L00C5	EQU	$00C5			;
L00C6	EQU	$00C6			;
L00C7	EQU	$00C7			;
L00C8	EQU	$00C8			;MSB, free running counter val. (trans output speed)
L00C9	EQU	$00C9			;LSB, free running counter val. (trans output speed)
L00CA	EQU	$00CA			;Stored accumulated pulse counts (trans output speed)
L00CB	EQU	$00CB			;
L00CC	EQU	$00CC			;
L00CD	EQU	$00CD			;
L00CE	EQU	$00CE			;
L00CF	EQU	$00CF			;
L00D0	EQU	$00D0			;
L00D1	EQU	$00D1			;MSB, MPH, filtered
L00D2	EQU	$00D2			;LSB, MPH, filtered
L00D3	EQU	$00D3			;
L00D4	EQU	$00D4			;
L00D5	EQU	$00D5			;Shift timer (???)
L00D6	EQU	$00D6			;
L00D7	EQU	$00D7			;
L00D8	EQU	$00D8			;
L00D9	EQU	$00D9			;
L00DA	EQU	$00DA			;
L00DB	EQU	$00DB			;
L00DC	EQU	$00DC			;
L00DD	EQU	$00DD			;
L00DE	EQU	$00DE			;
L00DF	EQU	$00DF			;
L00E0	EQU	$00E0			;
L00E1	EQU	$00E1			;
L00E2	EQU	$00E2			;
L00E3	EQU	$00E3			;
L00E4	EQU	$00E4			;
L00E5	EQU	$00E5			;
L00E6	EQU	$00E6			;
L00E7	EQU	$00E7			;
L00E8	EQU	$00E8			;
L00E9	EQU	$00E9			;
L00EA	EQU	$00EA			;
L00EB	EQU	$00EB			;
L00EC	EQU	$00EC			;
L00EE	EQU	$00EE			;
L00EF	EQU	$00EF			;
L00F0	EQU	$00F0			;
L00F1	EQU	$00F1			;MPH, one delayed
L00F2	EQU	$00F2			;
L00F3	EQU	$00F3			;
L00F4	EQU	$00F4			;
L00F5	EQU	$00F5			;Brake status min change state timer
L00F8	EQU	$00F8			;MSB, engine run time
L00F9	EQU	$00F9			;LSB, engine run time
L00FA	EQU	$00FA			;
L00FB	EQU	$00FB			;
L00FC	EQU	$00FC			;
L00FD	EQU	$00FD			;
L00FE	EQU	$00FE			;
L00FF	EQU	$00FF			;
L0100	EQU	$0100			;
L0101	EQU	$0101			;
L0102	EQU	$0102			;
L0103	EQU	$0103			;
L0104	EQU	$0104			;
L0105	EQU	$0105			;
L0106	EQU	$0106			;
L0107	EQU	$0107			;
L0108	EQU	$0108			;
L0109	EQU	$0109			;
L010A	EQU	$010A			;
L010B	EQU	$010B			;
L010C	EQU	$010C			;
L010D	EQU	$010D			;
L010E	EQU	$010E			;
L010F	EQU	$010F			;
L0110	EQU	$0110			;
L0111	EQU	$0111			;
L0112	EQU	$0112			;
L0113	EQU	$0113			;
L0114	EQU	$0114			;
L0115	EQU	$0115			;
L0116	EQU	$0116			;
L0117	EQU	$0117			;
L0118	EQU	$0118			;
L0119	EQU	$0119			;
L011A	EQU	$011A			;
L011B	EQU	$011B			;
L011C	EQU	$011C			;
L011D	EQU	$011D			;
L011E	EQU	$011E			;
L011F	EQU	$011F			;
L0120	EQU	$0120			;
L0121	EQU	$0121			;
L0122	EQU	$0122			;
L0123	EQU	$0123			;
L0124	EQU	$0124			;
L0125	EQU	$0125			;
L0126	EQU	$0126			;
L0127	EQU	$0127			;
L0128	EQU	$0128			;
L0129	EQU	$0129			;
L012A	EQU	$012A			;
L012B	EQU	$012B			;
L012C	EQU	$012C			;
L012D	EQU	$012D			;
L012E	EQU	$012E			;
L012F	EQU	$012F			;
L0130	EQU	$0130			;
L0131	EQU	$0131			;
L0132	EQU	$0132			;
L0133	EQU	$0133			;
L0134	EQU	$0134			;
L0135	EQU	$0135			;
L0136	EQU	$0136			;
L0137	EQU	$0137			;
L0138	EQU	$0138			;
L0138	EQU	$0138			;Start of shift time
L0139	EQU	$0139			;Post shift timer
L013A	EQU	$013A			;Accumulated line pressure
L013A	EQU	$013A			;
L013B	EQU	$013B			;
L013C	EQU	$013C			;
L013D	EQU	$013D			;
L013E	EQU	$013E			;
L013F	EQU	$013F			;
L0140	EQU	$0140			;
L0141	EQU	$0141			;
L0142	EQU	$0142			;
L0143	EQU	$0143			;
L0144	EQU	$0144			;Adaptive pressure modifer 
L0145	EQU	$0145			;Adapytive modifer cell #
L0145	EQU	$0145			;
L0146	EQU	$0146			;
L0147	EQU	$0147			;
L0148	EQU	$0148			;
L0149	EQU	$0149			;
L014A	EQU	$014A			;
L014B	EQU	$014B			;
L014C	EQU	$014C			;Temp value used for force motor (???)
L014D	EQU	$014D			;Upper val. (???)
L014E	EQU	$014E			;Lower val. (???)
L014F	EQU	$014F			;
L0150	EQU	$0150			;
L0151	EQU	$0151			;
L0152	EQU	$0152			;
L0153	EQU	$0153			;
L0154	EQU	$0154			;
L0155	EQU	$0155			;
L0156	EQU	$0156			;
L0157	EQU	$0157			;
L0158	EQU	$0158			;
L0159	EQU	$0159			;
L015A	EQU	$015A			;
L015B	EQU	$015B			;Error 21 timer
L015C	EQU	$015C			;Error 22 timer
L015E	EQU	$015E			;
L015F	EQU	$015F			;
L0160	EQU	$0160			;
L0161	EQU	$0161			;
L0162	EQU	$0162			;
L0163	EQU	$0163			;
L0164	EQU	$0164			;
L0165	EQU	$0165			;
L0166	EQU	$0166			;
L0167	EQU	$0167			;
L0168	EQU	$0168			;
L0169	EQU	$0169			;
L016A	EQU	$016A			;
L016B	EQU	$016B			;
L016C	EQU	$016C			;
L016D	EQU	$016D			;
L016E	EQU	$016E			;
L016F	EQU	$016F			;
L0170	EQU	$0170			;
L0171	EQU	$0171			;
L0172	EQU	$0172			;
L0173	EQU	$0173			;
L0174	EQU	$0174			;
L0175	EQU	$0175			;
L0176	EQU	$0176			;
L0177	EQU	$0177			;
L0178	EQU	$0178			;
L0179	EQU	$0179			;
L017A	EQU	$017A			;
L017B	EQU	$017B			;
L017C	EQU	$017C			;
L017D	EQU	$017D			;
L017E	EQU	$017E			;
L017F	EQU	$017F			;
L0180	EQU	$0180			;
L0181	EQU	$0181			;
L0182	EQU	$0182			;
L0183	EQU	$0183			;
L0184	EQU	$0184			;
L0185	EQU	$0185			;
L0186	EQU	$0186			;
L0187	EQU	$0187			;
L0188	EQU	$0188			;
L0189	EQU	$0189			;
L018A	EQU	$018A			;
L018B	EQU	$018B			;
L018C	EQU	$018C			;
L018D	EQU	$018D			;
L018E	EQU	$018E			;
L018F	EQU	$018F			;
L0190	EQU	$0190			;
L0191	EQU	$0191			;
L0192	EQU	$0192			;A/D coolant
L0193	EQU	$0193			;
L0194	EQU	$0194			;
L0195	EQU	$0195			;
L0196	EQU	$0196			;
L0197	EQU	$0197			;Current %TPS, for engine
L0198	EQU	$0198			;%TPS, one delayed
L0199	EQU	$0199			;%TPS, two delayed
L019A	EQU	$019A			;%TPS, three delayed
L019B	EQU	$019B			;%TPS, four delayed
L019C	EQU	$019C			;
L019D	EQU	$019D			;
L019E	EQU	$019E			;
L019F	EQU	$019F			;
L01A0	EQU	$01A0			;
L01A1	EQU	$01A1			;
L01A2	EQU	$01A2			;
L01A3	EQU	$01A3			;
L01A4	EQU	$01A4			;
L01A5	EQU	$01A5			;
L01A6	EQU	$01A6			;
L01A7	EQU	$01A7			;
L01A8	EQU	$01A8			;
L01A9	EQU	$01A9			;
L01AA	EQU	$01AA			;
L01AB	EQU	$01AB			;
L01AC	EQU	$01AC			;
L01AD	EQU	$01AD			;
L01AE	EQU	$01AE			;
L01AF	EQU	$01AF			;
L01B0	EQU	$01B0			;
L01B1	EQU	$01B1			;
L01B2	EQU	$01B2			;
L01B3	EQU	$01B3			;
L01B4	EQU	$01B4			;
L01B5	EQU	$01B5			;
L01B6	EQU	$01B6			;
L01B7	EQU	$01B7			;
L01B8	EQU	$01B8			;
L01B9	EQU	$01B9			;
L01BA	EQU	$01BA			;
L01BB	EQU	$01BB			;
L01BC	EQU	$01BC			;
L01BD	EQU	$01BD			;
L01BE	EQU	$01BE			;
L01BF	EQU	$01BF			;
L01C0	EQU	$01C0			;
L01C1	EQU	$01C1			;
L01C2	EQU	$01C2			;
L01C3	EQU	$01C3			;
L01C4	EQU	$01C4			;
L01C5	EQU	$01C5			;
L01C6	EQU	$01C6			;
L01C7	EQU	$01C7			;
L01C8	EQU	$01C8			;
L01C9	EQU	$01C9			;
L01CA	EQU	$01CA			;
L01CB	EQU	$01CB			;
L01CC	EQU	$01CC			;
L01CD	EQU	$01CD			;
L01CE	EQU	$01CE			;
L01CF	EQU	$01CF			;
L01D0	EQU	$01D0			;
L01D1	EQU	$01D1			;Desired % liner EGR position
L01D2	EQU	$01D2			;Desired %EGR 
L01D3	EQU	$01D3			;Delta pressure across EGR
L01D4	EQU	$01D4			;%EGR flow
L01D5	EQU	$01D5			;Filtered %EGR flow, MSB
L01D6	EQU	$01D6			;Filtered %EGR flow, LSB
L01D7	EQU	$01D7			;Linear EGR position
L01D8	EQU	$01D8			;MSB, A/D closed EGR pintle pos, lag filtered
L01D9	EQU	$01D9			;LSB, A/D closed EGR pintle pos, lag filtered
L01DA	EQU	$01DA			;MSB, filtered % liner EGR
L01DB	EQU	$01DB			;LSB, filtered % liner EGR
L01DC	EQU	$01DC			;% linear EGR
L01DD	EQU	$01DD			;Linear EGR position error
L01DE	EQU	$01DE			;Desired EGR gain factor
L01DF	EQU	$01DF			;MSB, EGR correction factor
L01E0	EQU	$01E0			;LSB, EGR correction factor
L01E1	EQU	$01E1			;MSB, EGR integral term
L01E2	EQU	$01E2			;LSB, EGR integral term
L01E3	EQU	$01E3			;SD MAP
L01E5	EQU	$01E5			;SD MAP, two delayed
L01E6	EQU	$01E6			;A/D MAP, Filtered, MSB
L01E7	EQU	$01E7			;A/D MAP, Filtered, LSB
L01E8	EQU	$01E8			;Transient MAP apply timer
L01E9	EQU	$01E9			;A/D MAP
L01EA	EQU	$01EA			;AE SD MAP, filtered per cool temp, MSB
L01EB	EQU	$01EB			;AE SD MAP, filtered per cool temo, LSB
L01EC	EQU	$01EC			;Vacuum
L01ED	EQU	$01ED			;Delta MAP for AE
L01EE	EQU	$01EE			;Slo filtered MAP filter coeff.
L01EF	EQU	$01EF			;Baro val. for lookup
L01F0	EQU	$01F0			;RPM threshold for PE, based on Baro
L01F1	EQU	$01F1			;Baro factor for MAP/baro ratio calc
L01F2	EQU	$01F2			;MAP/baro ratio
L01F3	EQU	$01F3			;MSB, Slow filtered O2
L01F4	EQU	$01F4			;LSB, Slow filtered O2
L01F5	EQU	$01F5			;MSB, Slow filtered O2, based on airflow
L01F6	EQU	$01F6			;LSB, Slow filtered O2, based on airflow
L01F7	EQU	$01F7			;A/D O2, one delayed
L01F8	EQU	$01F8			;A/D O2 voltage
L01F9	EQU	$01F9			;CCP duty cycle
L01FA	EQU	$01FA			;Closed loop base CCP duty cycle multiplier
L01FB	EQU	$01FB			;CCP update timer
L01FC	EQU	$01FC			;% TPS
L01FD	EQU	$01FD			;
L01FE	EQU	$01FE			;
L01FF	EQU	$01FF			;AE TPS, filtered per cool temp, MSB
L0200	EQU	$0200			;AE TPS, filtered per cool temp, LSB
L0201	EQU	$0201			;MSB, slow filtered %TPS
L0202	EQU	$0202			;LSB, slow filtered %TPS
L0203	EQU	$0203			;TPS threshold for WOT
L0204	EQU	$0204			;Fast PE delay timer countdown rate
L0205	EQU	$0205			;TPS threshold for PE
L0206	EQU	$0206			;PE TPS baro factor
L0207	EQU	$0207			;Delta TPS AE baro factor
L0208	EQU	$0208			;AE TPS filter coeff. vs. cool temp
L0209	EQU	$0209			;MSB, DRP, two delayed
L020A	EQU	$020A			;LSB, DRP, two delayed
L020B	EQU	$020B			;MSB, DRP period
L020C	EQU	$020C			;LSB, DRP period
L020D	EQU	$020D			;Dynamic dwell
L020F	EQU	$020F			;MSB, outputted dwell
L0210	EQU	$0210			;LSB, outputted dwell
L0211	EQU	$0211			;MSB, total SA
L0212	EQU	$0212			;LSB, total SA
L0213	EQU	$0213			;
L0214	EQU	$0214			;
L0215	EQU	$0215			;MSB, SA ramping multiplier
L0216	EQU	$0216			;LSB, SA ramping multiplier
L0217	EQU	$0217			;MSB, Filtered EGR SA correction
L0218	EQU	$0218			;LSB, Filtered EGR SA correction
L0219	EQU	$0219			;MSB, commanded SA
L021A	EQU	$021A			;LSB, commanded SA
L021B	EQU	$021B			;SA from table lookup
L021C	EQU	$021C			;Cool temp SA correction
L021D	EQU	$021D			;MAT temp for look up
L021E	EQU	$021E			;Altitude SA correction
L021F	EQU	$021F			;PE SA adder
L0220	EQU	$0220			;MSB, final SA
L0221	EQU	$0221			;LSB, final SA
L0222	EQU	$0222			;Startup SA decay multiplier
L0223	EQU	$0223			;Initial added SA decay period
L0224	EQU	$0224			;SA latency correction
L0225	EQU	$0225			;DRP period counter
L0226	EQU	$0226			;MSB, knock counts, one delayed
L0227	EQU	$0227			;LSB, knock counts, one delayed
L0228	EQU	$0228			;MSB, EST circuit info
L0229	EQU	$0229			;LSB, EST circuit info
L022A	EQU	$022A			;Error 43 timer
L022B	EQU	$022B			;DFCO SA correction
L022C	EQU	$022C			;Low octaine SA ramping multiplier
L022D	EQU	$022D			;Low octaine SA retard
L022E	EQU	$022E			;Low octane base SA retard
L022F	EQU	$022F			;Knock retard x 2
L0230	EQU	$0230			;Knock counts
L0231	EQU	$0231			;Burst retard timer
L0232	EQU	$0232			;INTegrator
L0233	EQU	$0233			;DRP counter, used for setting engine running flag
L0234	EQU	$0234			;Transition from crank to run delay DRP counter	
L0235	EQU	$0235			;
L0236	EQU	$0236			;
L0237	EQU	$0237			;
L0238	EQU	$0238			;
L0239	EQU	$0239			;
L023A	EQU	$023A			;
L023B	EQU	$023B			;
L023C	EQU	$023C			;
L023D	EQU	$023D			;
L023E	EQU	$023E			;
L023F	EQU	$023F			;
L0240	EQU	$0240			;Error 23 counter
L0241	EQU	$0241			;Error 25 counter
L0242	EQU	$0242			;
L0243	EQU	$0243			;
L0244	EQU	$0244			;
L0245	EQU	$0245			;
L0246	EQU	$0246			;Err. 32 timer
L0247	EQU	$0247			;
L0248	EQU	$0248			;
L0249	EQU	$0249			;
L024A	EQU	$024A			;
L024B	EQU	$024B			;
L024C   EQU	$024C           	;Err. 34 timer
L024D	EQU	$024D			;Err. 54 timer
L024E	EQU	$024E			;
L024F	EQU	$024F			;
L0250	EQU	$0250			;
L0251	EQU	$0251			;
L0252	EQU	$0252			;MAT temp
L0253	EQU	$0253			;A/D MAT
L0254	EQU	$0254			;
L0255	EQU	$0255			;
L0256	EQU	$0256			;
L0257	EQU	$0257			;Mass of air in cylinder, MSB
L0258	EQU	$0258			;Mass of air in cylinder, LSB
L0259	EQU	$0259			;Inv. air density, MSB
L025A	EQU	$025A			;Inv. air density, LSB
L025B	EQU	$025B			;Max mass of air in cyl., MSB
L025C	EQU	$025C			;Max mass of air in cyl., LSB
L025D	EQU	$025D			;Async pulse time, MSB
L025E	EQU	$025E			;Async pulse time, LSB
L0260	EQU	$0260			;AE temp correction mult.
L0261	EQU	$0261			;MAP AE PW
L0262	EQU	$0262			;TPS AE PW
L0263	EQU	$0263			;Filtering execution timer
L0264	EQU	$0264			;O2 dwell timer
L0265	EQU	$0265			;Decel enlean cool factor
L0266	EQU	$0266			;Min DFCO rpm
L0267	EQU	$0267			;DFCO BPW multiplier
L0268	EQU	$0268			;DFCO exit PW timer
L0269	EQU	$0269			;DFCO delay timer
L026A	EQU	$026A			;Current BLM cell number
L026B	EQU	$026B			;Current BLM 
L026C	EQU	$026C			;BLM, one delayed
L026D	EQU	$026D			;AFR
L026F	EQU	$026F			;MSB, BPW
L0270	EQU	$0270			;LSB, BPW
L0271	EQU	$0271			;Sync BPW, MSB
L0272	EQU	$0272			;Sync BPS, LSB
L0273	EQU	$0273			;MSB, TOC 5 value
L0274	EQU	$0274			;LSB, TOC 4 value
L0275	EQU	$0275			;EGR BPW correction, MSB
L0276	EQU	$0276			;EGR BPW correction, LSB
L0277	EQU	$0277			;MSB, BPW, CPI/PFI mode
L0278	EQU	$0278			;LSB, BPW, CPI/PFI mode
L0279	EQY	$0279			;PW compensation for batt. volts
L027A	EQU	$027A			;MSB, kPa x 256
L027B	EQU	$027B			;LSB, kPa x 256
L027C	EQU	$027C			;Accumulated asnyc BPW, MSB
L027D	EQU	$027D			;Accumulated async BPW, LSB
L027E	EQU	$027E			;Accumulated async BPW, remainder
L027F	EQU	$027F			;Asnyc BPW, MSB
L0280	EQU	$0280			;Async BPW, LSB
L0281	EQU	$0281			;Async BPW, stored remainder
L0282	EQU	$0282			;INT timer
L0283	EQU	$0283			;MSB, time since last DRP
L0284	EQU	$0284			;LSB. time since last DRP
L0285	EQU	$0285			;INT delay term for idling
L0286	EQU	$0286			;delta speed PE entry timer
L0287	EQU	$0287			;MSB, filtered AFR
L0288	EQU	$0288			;LSB, filtered AFR
L0289	EQU	$0289			;Time to filtere AFR on idle to run
L028A	EQU	$028A			;AFR crank transition ratio decay rate
L028B	EQU	$028B			;Elapsed DRPs
L028C	EQU	$028C			;PE timer
L028D	EQU	$028D			;Fuel cut off delay timer
L028E	EQU	$028E			;INT delay timer term
L028F	EQU	$028F			;Mean rich/lean O2 threshold
L0290	EQU	$0290			;Rich O2 threshold
L0291	EQU	$0291			;Lean O2 threshold
L0292	EQU	$0292			;Closed loop fuel correction term
L0293	EQU	$0293			;Choke AFR decay delay period
L0294	EQU	$0294			;Idle timer
L0295	EQU	$0295			;Open loop idle AFR 
L0296	EQU	$0296			;BLM update delay timer
L0297	EQU	$0297			;BLM loop timer
L0298	EQU	$0298			;O2 cross-counts
L0299	EQU	$0299			;PE reset/delay timer
L029A	EQU	$029A			;PE delay timer
L029B	EQU	$029B			;PE ramping multiplier
L029C	EQU	$029C			;Time in PE, AIR inj. management
L029D	EQU	$029D			;Proportional term
L029E	EQU	$029E			;Scaled airflow
L029F	EQU	$029F			;Duration in current fueling state
L02A0	EQU	$02A0			;Cold park to drive transition period
L02A1	EQU	$02A1			;MSB, shutdown timer
L02A2	EQU	$02A2			;LSB, shutdown timer
L02A3	EQU	$02A3			;O2 error
L02A4	EQU	$02A4			;Stored INT delay
L02A5	EQU	$02A5			;Initial cool temp (engine off)
L02A6	EQU	$02A6			;Range limited cool temp
L02A7	EQU	$02A7			;
L02A8	EQU	$02A8			;
L02A9	EQU	$02A9			;MSB, governor TPS
L02AA	EQU	$02AA			;LSB, governor TPS
L02AB	EQU	$02AB			;MSB, Gov'r actuator integral term
L02AC	EQU	$02AC			;LSB, Gov'r actuator integral term
L02AD	EQU	$02AD			;Governor integral term
L02AF	EQU	$02AF			;Previous governor RPM/25
L02B0	EQU	$02B0			;Delta governor RPM/25
L02B1	EQU	$02B1			;Governor RPM/25
L02B2	EQU	$02B2			;
L02B3	EQU	$02B3			;MSB, RPM prop. term
L02B4	EQU	$02B4			;LSB, RPM prop. term
L02B5	EQU	$02B5			;MPH prop. term
L02B6	EQU	$02B6			;Governor RPM error
L02B7	EQU	$02B7			;Governor MPH error
L02B8	EQU	$02B8			;MSB, gov'r actuator prop. term
L02B9	EQU	$02B9			;LSB, gov'r actuator prop. term
L02BA	EQU	$02BA			;MSB, Gov'r actuator integral factor
L02BB	EQU	$02BB			;LSB, Gov'r actuator integral factor
L02BC	EQU	$02BC			;Desired outputted TPS, governor
L02BD	EQU	$02BD			;Gov'r actuator TPS error
L02BE	EQU	$02BE			;MSB, pending RAM addr. block to be refreshed
L02BF	EQU	$02BF			;LSB, pending RAM addr. block to be refreshed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral cells, P/N
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-A/C off
;
L02C0	EQU	$02C0			;MSB, current idle integral term
L02C1	EQU	$02C1			;LSB, current idle integral term
L02C2	EQU	$02C2			;Steady state idle integral term
;
;-A/C on
;
L02C3	EQU	$02C3			;MSB, current idle integral term
L02C4	EQU	$02C4			;LSB, current idle integral term
L02C5	EQU	$02C5			;Steady state idle integral term
;
L02C6	EQU	$02C6			;MSB, coupled IAC flow vs. cool temp
L02C7	EQU	$02C7			;LSB, coupled IAC flow vs. cool temp
L02C8	EQU	$02C8			;MSB, IAC flow vs. cool temp
L02C9	EQU	$02C9			;LSB, IAC flow vs. cool temp 	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral cells, drive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-A/C off
;
L02CA	EQU	$02CA			;MSB, current idle integral term
L02CB	EQU	$02CB			;LSB, current idle integral term
L02CC	EQU	$02CC			;Steady state idle integral term
;
;-A/C on
;
L02CD	EQU	$02CD			;MSB, current idle integral term
L02CE	EQU	$02CE			;LSB, current idle integral term
L02CF	EQU	$02CF			;Steady state idle integral term
;
L02D0	EQU	$02D0			;MSB, coupled IAC flow vs. cool temp
L02D1	EQU	$02D1			;LSB, coupled IAC flow vs. cool temp
L02D2	EQU	$02D2			;MSB, IAC flow vs. cool temp
L02D3	EQU	$02D3			;LSB, IAC flow vs. cool temp 
;
;-End of integrator cells
;
L02D4	EQU	$02D4			;Throttle kicker base TPS
L02D5	EQU	$02D5			;Post throttle kicker base TPS
;
;~~~~~~~~~~~
;-BLM cells
;~~~~~~~~~~~
;
L02D6	EQU	$02D6			;BLM cell #0
L02D7	EQU	$02D7			;BLM cell #1
L02D8	EQU	$02D8			;BLM cell #2
L02D9	EQU	$02D9			;BLM cell #3
L02DA	EQU	$02DA			;BLM cell #4
L02DB	EQU	$02DB			;BLM cell #5
L02DC	EQU	$02DC			;BLM cell #6
L02DD	EQU	$02DD			;BLM cell #7
L02DE	EQU	$02DE			;BLM cell #8
L02DF	EQU	$02DF			;BLM cell #9
L02E0	EQU	$02E0			;BLM cell #10
L02E1	EQU	$02E1			;BLM cell #11
L02E2	EQU	$02E2			;BLM cell #12
L02E3	EQU	$02E3			;BLM cell #13
L02E4	EQU	$02E4			;BLM cell #14
L02E5	EQU	$02E5			;BLM cell #15
;
;-Start of BLM idle cells
;
L02E6	EQU	$02E6			;BLM cell #16
L02E7	EQU	$02E7			;BLM cell #17
L02E8	EQU	$02E8			;BLM cell #18
L02E9	EQU	$02E9			;BLM cell #19
L02EA	EQU	$02EA			;BLM cell #20
;
;-End of BLM cells
;
L02EB	EQU	$02EB			;Stored choke AFR
L02EC	EQU	$02EC			;AFR crank trans. ratio
L02ED	EQU	$02ED			;Choke AFR decay delay timer
L02EE	EQU	$02EE			;Initial SA
L02EF	EQU	$02EF			;Initial SA decay delay timer
L02F0	EQU	$02F0			;DRP counter
L02F1	EQU	$02F1			;Stored DRP counts
L02F2	EQU	$02F2			;Crank fuel PW, MSB
L02F3	EQU	$02F3			;Crank fuel PW, LSB
L02F4	EQU	$02F4			;
L02F5	EQU	$02F5			;
L02F6	EQU	$02F6			;
L02F7	EQU	$02F7			;
L02F8	EQU	$02F8			;
L02F9	EQU	$02F9			;
L02FA	EQU	$02FA			;
L02FB	EQU	$02FB			;
L02FC	EQU	$02FC			;
L02FD	EQU	$02FD			;
L02FE	EQU	$02FE			;
L02FF	EQU	$02FF			;
L0300	EQU	$0300			;
L0301	EQU	$0301			;
L0302	EQU	$0302			;
L0303	EQU	$0303			;
L0304	EQU	$0304			;
L0305	EQU	$0305			;
L0306	EQU	$0306			;
L0307	EQU	$0307			;
L0308	EQU	$0308			;
L0309	EQU	$0309			;
L030A	EQU	$030A			;
L030B	EQU	$030B			;
L030C	EQU	$030C			;
L030D	EQU	$030D			;
L030E	EQU	$030E			;
L030F	EQU	$030F			;
L0310	EQU	$0310			;
L0311	EQU	$0311			;
L0312	EQU	$0312			;
L0313	EQU	$0313			;
L0314	EQU	$0314			;
L0315	EQU	$0315			;
L0316	EQU	$0316			;Baro
L0317	EQU	$0317			;Filtered baro, MSB
L0318	EQU	$0318			;Filtered baro, LSB
L0319	EQU	$0319			;Base TPS for closed throttle, MSB
L031A	EQU	$031A			;Base TPS for closed throttle, LSB
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Adaptive modifier cells 
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-In second gear
;
L031B	EQU	$031B			;Cell #0
L031C	EQU	$031C			;Cell #1
L031D	EQU	$031D			;Cell #2
L031E	EQU	$031E			;Cell #3
;
;-In third gear
;
L031F	EQU	$031F			;Cell #0
L0320	EQU	$0320			;Cell #1
L0321	EQU	$0321			;Cell #2
L0322	EQU	$0322			;Cell #3
;
;-In fourth gear
;
L0323	EQU	$0323			;Cell #0
L0324	EQU	$0324			;Cell #1
L0325	EQU	$0325			;Cell #2
L0326	EQU	$0326			;Cell #3
;

;
L0362	EQU	$0362			;ALDL message length counter
L0363	EQU	$0363			;ALDL message checksum
L0364	EQU	$0364			;Pointer to ALDL transmission string
L0366	EQU	$0366			;ALDL diag. ID
L0367	EQU	$0367			;ALDL message length
L0368	EQU	$0368			;Stored LSB for double byte ALDL transmission
L036E	EQU	$036E			;ALDL data buffer
					;^
					;...
					;^
					;^
					;^
					;End of ALDL data buffer
;
L0390	EQU	$0390			;Engine diagnostics data buffer	
					;^
					;...	
					;^
					;^
					;^
					;End of engine diag. data buffer
;
L039B	EQU	$039B			;Transmission diagnostics data buffer
					;^	
					;...
					;^
					;^
					;^
					;End of transmission diag. data buffer
;
					;End of stack
					;^
					;...
					;^
					;^
					;^
L03FF	EQU	$03FF			;Start of stack
;
;~~~~~~~~~~~~~~~~~~~~~~
; HU RAM (ALDL mode 4)
;~~~~~~~~~~~~~~~~~~~~~~
;
L0400	EQU	$0400			;(???)
L0403	EQU	$0403			;(???)
L0404	EQU	$0404			;(???)
L0414	EQU	$0414			;(???)
;
L0801	EQU	$0801			;(???)
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;
L0802	EQU	$0802			;
L0803	EQU	$0803			;
L0804	EQU	$0804			;
L0805	EQU	$0805			;
L0806	EQU	$0806			;
L0807	EQU	$0807			;
L0808	EQU	$0808			;
L0809	EQU	$0809			;
L080A	EQU	$080A			;
L080B	EQU	$080B			;
L080C	EQU	$080C			;# of VSS pulses recieved since last update
L080D	EQU	$080D			;MSB, VSS counter
L080E	EQU	$080E			;LSB, VSS counter
L080F	EQU	$080F			;MSB, VSS counter, one delayed
L0810	EQU	$0810			;LSB, VSS counter, one delayed
L0811	EQU	$0811			;VSS pulse timer
L0812	EQU	$0812			;MSB, current MPH
L0813	EQU	$0813			;LSB, current MPH
L0814	EQU	$0814			;
L0815	EQU	$0815			;
L0816	EQU	$0816			;
L0817	EQU	$0817			;
L0818	EQU	$0818			;Delta MPH for PE entry
L0819	EQU	$0819			;
L081A	EQU	$081A			;MPH, one delayed
L081B	EQU	$081B			;
L081C	EQU	$081C			;
L081D	EQU	$081D			;INT lock timer, AE
L081E	EQU	$081E			;Exec. delay timer
L081F	EQU	$081F			;MSB, time based delay for inj. firing
L0820	EQU	$0820			;LSB, time based delay for inj. firing 
L0821	EQU	$0821			;MSB, TOC 5 timer val.
L0822	EQU	$0822			;LSB, TOC 5 timer val.
L0823	EQU	$0823			;MSB, TOC 4 timer val.
L0824	EQU	$0824			;LSB, TOC 4 timer val.
L0825	EQU	$0825			;MSB, TOC 5 timer val.
L0826	EQU	#0826			;LSB, TOC 5 timer val.
L0827	EQU	$0827			;MSB, TOC 4 timer val.
L0828	EQU	$0828			;LSB, TOC 4 timer val.
L0829	EQU	$0829			;DRP counter
L082A	EQU	$082A			;Time in double fire mode 
L082B	EQU	$082B			;Delta TPS for decel enlean
L082D	EQU	$082D			;A/D coolant
L082E	EQU	$082E			;A/D MAP, A/D conv.
L082F	EQU	$082F			;ALDL switch voltage
L0830	EQU	$0830			;Enable A/C timer
L0831	EQU	$0831			;Re-enable A/C timer
L0832	EQU	$0832			;High rpm A/C disable timer
L0833	EQU	$0833			;High rpm A/C re-enable timer
L0834	EQU	$0834			;High TPS A/C disable timer
L0835	EQU	$0835			;
L0836	EQU	$0836			;
L0837	EQU	$0837			;Stored RPM/12.5
L0838	EQU	$0838			;MSB, stored RPM/12.5, filtered
L0839	EQU	$0839			;LSB, stored RPM/12.5, filtered
L083A	EQU	$083A			;RPM error/12.5
L083B	EQU	$083B			;Stored SA derivative term for manual trans
L083C	EQU	$083C			;Final MAT SA correction
L083D	EQU	$083D			;MSB, stored RPM/25
L083E	EQU	$083E			;LSB, stored RPM/25
L083F	EQU	$083F			;MSB, stored static dwell
L0840	EQU	$0840			;LSB, stored static dwell
L0841	EQU	$0841			;Low octane RPM mult.
L0842	EQU	$0842			;Burst knock retard
L0843	EQU	$0843			;Knock attack rate
L0844	EQU	$0844			;Max knock retard
L0845	EQU	$0845			;
L0846	EQU	$0846			;
L0847	EQU	$0847			;
L0848	EQU	$0848			;
L0849	EQU	$0849			;
L084A	EQU	$084A			;
L084B	EQU	$084B			;
L084C	EQU	$084C			;Cat converter overtemp timer
L084D	EQU	$084D			;Trans abuse test timer
L084E	EQU	$084E			;Err. 41 counter
L084F	EQU	$084F			;MSB, EGR proportional term
L0850	EQU	$0850			;LSB, EGR proportional term
L0851	EQU	$0851			;MSB, TIC 2 timer val (VATS)
L0852	EQU	$0852			;LSB, TIC 2 timer val (VATS)
L0853	EQU	$0853			;TCC relock delay timer
L0854	EQU	$0854			;
L0855	EQU	$0855			;MAT, linearized A/D output
L0856	EQU	$0856			;
L0857	EQU	$0857			;Desired idle RPMs
L0858	EQU	$0858			;Idle RPM error
L0859	EQU	$0859			;MSB, filtered idle RPM error
L085A	EQU	$085A			;LSB, filtered idle RPM error			
L085B	EQU	$085B			;Idle purge timer
L085C	EQU	$085C			;Added desired idle speed
L085D	EQU	$085D			;Decay period for added idle speed
L085E	EQU	$085E			;Timer to begin decay of added desired idle speed
L085F	EQU	$085F			;Filtered desired idle speed
L0860	EQU	$0860			;Added RPMs for high A/C pressure
L0861	EQU	$0861			;High pressure A/C compensation delay timer
L0862	EQU	$0862			;MSB, stored idle integrator flow
L0863	EQU	$0863			;LSB, stored idle integrator flow
L0864	EQU	$0864			;Closed loop idle enable delay timer
L0865	EQU	$0865			;
L0866	EQU	$0866			;Closed loop idle delay, low idle
L0867	EQU	$0867			;Closed loop idle delay, high idle
L0868	EQU	$0868			;Stall saver activation threshold
L0869	EQU	$0869			;Stall saver duration timer
L086A	EQU	$086A			;Stored steady state idle integral term
L086B	EQU	$086B			;Added initial IAC flow after startup
L086C	EQU	$086C			;Decay period for initial added IAC flow
L086D	EQU	$086D			;Proportional idle term
L086E	EQU	$086E			;MSB, derivative idle term
L086F	EQU	$086F			;LSB, derivative idle term
L0870	EQU	$0870			;Final derivative idle flow term
L0871	EQU	$0871			;MSB, added coupled IAC flow vs. cool temp
L0872	EQU	$0872			;LSB, added coupled IAC flow vs. cool temp
L0873	EQU	$0873			;MSB, stored IAC flow vs. cool temp
L0874	EQU	$0874			;LSB, stored IAC flow vs. cool temp
L0875	EQU	$0875			;IAC flow decay delay timer
L0876	EQU	$0876			;Added IAC flow for A/C on/off transition
L0877	EQU	$0877			;A/C on/off transition timer
L0878	EQU	$0878			;A/C on/off transition flow decay period
L0879	EQU	$0879			;Added IAC flow for trans. shift
L087A	EQU	$087A			;Trans shift transition period
L087B	EQU	$087B			;Added power steering compensation flow
L087C	EQU	$087C			;P/S compensation IAC flow decay period
L087D	EQU	$087D			;MSB, IAC flow, one delayed
L087E	EQU	$087E			;LSB, IAC flow, one delayed
L087F	EQU	$087F			;IAC accel enrich
L0880	EQU	$0880			;MSB, added throttle follower IAC flow
L0881	EQU	$0881			;LSB, added throttle follower IAC flow
L0882	EQU	$0882			;MSB, hi res filtered TPS
L0883	EQU	$0883			;LSB, hi res filtered TPS
L0884	EQU	$0884			;TPS filtering period
L0885	EQU	$0885			;Stored upper limit for closed TPS
L0886	EQU	$0886			;Timer for reducing T/F action during clsd. throt.
L0887	EQU	$0887			;Added IAC flow when in DFCO
L0888	EQU	$0888			;DFCO flow decay rate 
L0889	EQU	$0889			;MSB, finalized IAC flow
L088A	EQU	$088A			;LSB, finalized IAC flow
L088B	EQU	$088B			;Desired IAC airflow, percentage of total flow
L088D	EQU	$088D			;Throttle kicker timer
L088E	EQU	$088E			;Error 35 timer
;
;-Updated idle integral flow, P/N
;
L088F	EQU	$088F			;MSB, updated integral flow, no A/C
L0890	EQU	$0890			;LSB, updated integral flow, no A/C
L0891	EQU	$0891			;MSB, updated integral flow, A/C
L0892	EQU	$0892			;LSB, updated integral flow, A/C
L0893	EQU	$0893			;MSB, Updated initial IAC flow vs. cool temp
L0894	EQU	$0894			;LSB, Updated initial IAC flow vs. cool temp
;
;-Updated idle integral flow, drive
;
L0895	EQU	$0895			;MSB, updated integral flow, no A/C
L0896	EQU	$0896			;LSB, updated integral flow, no A/C
L0897	EQU	$0897			;MSB, updated integral flow, A/C
L0898	EQU	$0898			;LSB, updated integral flow, A/C
L0899	EQU	$0899			;MSB, Updated initial IAC flow vs. cool temp
L089A	EQU	$089A			;LSB, Updated initial IAC flow vs. cool temp
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Registers
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L3000	EQU	$3000			;Port A/Start of CPU regs.
L3008	EQU	$3008			;Port D
					; b7=
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=A/C pressure switch
					; b1=
					; b0=
;
L300E	EQU	$300E			;MSB, 16 bit free running CPU counter
L300F	EQU	$300F			;LSB, 16 bit free running CPU counter
L3012	EQU	$3012			;TIC 2
L3016	EQU	$3016			;TOC 1
L302D	EQU	$302D			;SCI control register 2
L302E	EQU	$302E			;SCI status register
L302F	EQU	$302F			;SCI data register
L3030	EQU	$3030			;A/D Control Reg
L3031	EQU	$3031			;A/D result reg 1
L3032	EQU	$3032			;A/D result reg 2
L3033	EQU	$3033			;A/D result reg 3
L3034	EQU	$3034			;A/D result reg 4
L3060	EQU	$3060			;I/O
					; b7=TCC/Throttle kicker
					; b6=
					; b5=
					; b4=
					; b3=
					; b2=
					; b1=
					; b0=
;	
L3061	EQU	$3061			;
L3062	EQU	$3062			;I/O port D?
L3063	EQU	$3063			;
L3064	EQU	$3064			;I/O port C
L3065	EQU	$3065			;
L306A	EQU	$306A			;PWM TCC output
L306C	EQU	$306C			;PWM output, 3->2 sol./shift light/governor
L306F	EQU	$306F			;Hardware, fuel pump relay control
L3FC0	EQU	$3FC0			;DRP counter
L3FC2	EQU	$3FC2			;65,536 free running TOS counter		
L3FC4	EQU	$3FC4			;VSS counter
L3FC6	EQU	$3FC6			;alternate TOS pulse accumulator
L3FCA	EQU	$3FCA			;EST circuit info
L3FCC	EQU	$3FCC			;
L3FCE	EQU	$3FCE			;Reg. for TBI injector hardware
L3FDC	EQU	$3FDC			;
L3FDE	EQU	$3FDE			;
L3FE0	EQU	$3FE0			;TOS pulse accumulator
L3FE4	EQU	$3FE4			;
L3FE5	EQU	$3FE5			;
L3FE6	EQU	$3FE6			;
L3FE7	EQU	$3FE7			;
L3FE8	EQU	$3FE8			;
L3FE9	EQU	$3FE9			;
L3FEC	EQU	$3FEC			;
L3FED	EQU	$3FED			;
L3FF6	EQu	$3FF6			;EST fall counter
L3FF8	EQU	$3FF8			;Alternate 65,536 Hz free running TOS counter
L3FFA	EQU	$3FFA			;CPU stat. reg.
L3FFC	EQU	$3FFC			;I/O port D?
L3FEA	EQU	$3FEA			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Start of calibration
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	ORG $4000		
;
L4000:	FDB $23AF		;ID BYTE, 9135d
				;
L4002   FDB $FFFF		; Platform ID  
L4004   FDB $FFFF		; Platform ID   
				;
L4006   FDB $0000		;Check sum
L4008	FCB $0D			;Mask ID byte   
				;
L4009   FDB 0481		;6 secs. delay till shutdown
;         
;-AIR FUEL MODE WORDS
;
L400B	FCB $0C			;0000 1100, option byte 
				; b7, 1 = Skip delta TPS check when already in decel enlean
                    		; b6, 1 = MAT sensor
                    		; b5, 1 = 180 deg offset
                    		; b4, 1 = ASDF CRANK (???)
                    		; b3, 1 = Limit closed loop corr. when AE in effect  
                    		; b2, 1 = SYNC FUEL AT IDLE (TBI)
                    		; b1, 1 = Enable AIR
                    		; b0, 1 = CPI/PFI MODE
;	
L400C	FCB $93			;1001 0011, option byte  
                    		; b7, 1 = Enable CCP purge
                    		; b6, 1 = Contitional INT reset on BLM cell change
                    		; b5, 1 = INT reset on AE
                    		; b4, 1 = INT reset in BLM cell change
                    		; b3, 1 = ASDF 
                    		; b2, 1 = CRANK FUEL ALL INJ'S EACH DRP
                    		; b1, 1 = ERR 44/45 BLM LMT
				; b0, 1 = SYNC MAP SENSOR READS
;  
L400D	FCB $A4			;1010 0100, option byte  
                    		; b7, 1 = SINGLE PASS EGR TEST
                    		; b6, 1 = VATS
                    		; b5, 1 = Ese table to look up EGR flow ratio
                    		; b4, 1 = EGR = 0 AT IDLE
                    		; b3, 1 = Disable EGR in open loop
				; b2, 1 = BACK PRESSURE EGR
                    		; b1, 1 = linear EGR, 
				;     0 = Electrinic Vacuum Regulator Valve EGR
                    		; b0, 1 = look up AFR when in open loop
;
L400E   FCB $00			;0000 0000, option byte
				; b7 1 = not used
				; b6 1 = not used
				; b5 1 = LATCH ERR 45
				; b4 1 = USE L496F WITH ASYNC FUEL DELIVERY
				; b3 1 = VAR TUNE CNT'L
				; b2 1 = SHIFT LIGHT ENABLE 
				; b1 1 = Use MAP/Baro ratio for DFCO
				; b0 1 = Use MAP/Baro ratio for BLM cell bounds
; 
L400F	FCB $18			;Option byte, 0001 1000
				; b7=TCC option (1 = MAN, 0 = TCC)
				; b6=TCC only (Non-CC transmission)
                    		; b5= 
                    		; b4=Enable Cat. reaction overtemp protection
                    		; b3=Use knock retard
                    		; b2, 1 = A/C clutch cont., 0 = Var tune
                    		; b1=
                    		; b0, 1=Rev limiter                    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Adaptive A/C clutch control params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; All timer values are seconds x 10
;
L4010   FCB  0			;Upper TPS threshold for A/C to come on
L4011   FCB  0      		;Upper TPS threshold for A/C to remain on
;
L4012   FCB  1      		;.1 sec, min time to enable A/C after A/C requested
L4013   FCB  0      		;0 sec, min time to re-enable A/C 
L4014   FCB  0      		;0 sec, time delay for A/C to come back on after launch mode
L4015   FCB  0      		;0 sec. time delay for A/C to be disabled if high RPMs
L4016   FCB  0      		;0 sec, min time to re-enable A/C after high rpms
;
L4017   FCB  255		;6375 RPM, upper rpm limit for A/C to come on 
L4018   FCB  254		;6350 RPM, upper rpm limit for A/C to remain on
;
L4019   FCB  254		;6350 RPM, upper RPM threshold to disable A/C
;
L401A   FCB  254		;150 deg C, upper cool temp limit for A/C to come on
L401B   FCB  253		;150 deg C, upper cool temp limit for A/C to remain on
;
L401C   FCB  0			;0 MPH, Lower MPH limit for launch mode if A/C on 
L401D   FCB  0			;0 MPH, Lower MPH limit for launch mode for A/C to come on
;
L401E   FCB  254		;99.2% TPS, lower TPS limit for launch mode for A/C to come on
L401F   FCB  255		;99.2% TPS, lower TPS limit for launch mode for A/C on
;
L4020   FDB  0000		;0 sec, min time to re-enable A/C after high TPS
L4022   FDB  0000   		;0 sec, min run time for compressor to come on   
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Closed loop CCP params
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L4024   FCB  240		;5 kPa vac, lower vac threshold to allow CCP DC updates
L4025   FCB  1			;0.4 sec, min time between CCP DC updates
;
;-Desired integrator window during CCP 
;
L4026   FCB 123			;Upper INT bound to begin increasing CCP DC
L4027   FCB 115			;Lower INT bound to begin decreasing CCP DC
;
L4028   FCB 0			;0, multiplier for CCP DC in open loop
L4029   FCB 13			;2.5% per 200 msec, rate to increase CCP if outside INT window 
L402A   FCB 26			;5.1% per 200 msec, rate to decrease CCP if outside INT 
				;window
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Params for allowing CCP
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L402B   FCB 120			;50 deg C, min temp for CCP
L402C   FCB 160			;80 deg C, cool temp threshold for full DC purge on init. run
L402D   FDB 0004		;Engine run time, duration for full DC purge on init. run
L402F   FCB 10			;Lower speed threshpld to clear CCP DC multiplier if CCP not
				;ok'd
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Hyst. pairs for enabling/disabling CCP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4030   FCB  4			;4 MPH, speed threshold to enable CCP
L4031   FCB  35			;35 Kpa, MAP threshold to enable CCP
L4031   FCB  8			;3% TPS, TPS threshold to enable CCP
;
L4033   FCB  3			;3 MPH, speed threshold to disable CCP
L4034   FCB  32			;32 kPa, MAP threshold to disable CCP
L4035   FCB  6			;2.3% TPS, TPS threshold to disable CCP
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Base closed loop CCP duty cycle vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%duty cycle = 
;	val x .390		;gms/sec		
;
L4036   FCB  180		;  0
	FCB  255		; 16
	FCB  255		; 32
	FCB  255		; 48
	FCB  255		; 64
	FCB  255		; 80
	FCB  255		; 96
	FCB  255		;112
	FCB  255		;128
	FCB  255		;144
	FCB  255		;160
	FCB  255		;176
	FCB  255		;192
	FCB  255		;208
	FCB  255		;224
	FCB  255		;240
	FCB  255		;256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Minimum allowed CCP dutycycle vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%duty cycle = 
;	val x .390		;gms/sec		
;
L4047   FCB  90			;  0
	FCB  128		; 16
	FCB  166		; 32
	FCB  179		; 48
	FCB  192		; 64
	FCB  205		; 80
	FCB  218		; 96
	FCB  255		;112
	FCB  255		;128
	FCB  255		;144
	FCB  255		;160
	FCB  255		;176
	FCB  255		;192
	FCB  255		;208
	FCB  255		;224
	FCB  255		;240
	FCB  255		;256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Table of BLM cells that purge is allowed in
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	logic, 1=true, 0=false	;BLM cell #
;
L4058   FCB  0			; 0
	FCB  0			; 1 
	FCB  0			; 2
	FCB  0			; 3
	FCB  0			; 4
	FCB  1			; 5
	FCB  1			; 6
	FCB  1			; 7
	FCB  1			; 8
	FCB  1			; 9
	FCB  1			;10
	FCB  1			;11
	FCB  1			;12
	FCB  1			;13
	FCB  1			;14
	FCB  1			;15
	FCB  0			;16
	FCB  0			;17
	FCB  0			;18
	FCB  0			;19
	FCB  0			;20
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Catalytic converter overtemp protection
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Deg C = value x 3 + 300
;
;-Thresholds used when in closed loop
;
L406D   FCB 255			;1065 deg C, upper allowed cat. converter reaction temp 
L406E   FCB 255			;1065 deg C, upper allowed cat. reaction temp to clear
				;overtemp flag
;
L406F   FCB 255			;1065 deg C, maximum allowed cat. reaction temp
L4070   FCB 255			;1065 deg C, lower reaction temp to clear overtemp flag
;
L4071   FCB 167			;85 deg C, threshold to init cat temp to default value
L4072   FCB 33      		;399 deg C, default cat temp when cool > L4071, temp = val x 3 + 300
;
L4073   FCB 10			;Max time allowed for overtemp before flagging overtemp
				;condition
L4074   FCB 255			;99.6% TPS, upper TPS threshold to mainain current cat reaction
				;temp state after period of time 
L4075   FCB 0			;0 RPM, lower RPM threshold to maintain current cat reaction
				;temp state after period of time    
L4076   FCB 255			;255 sec, time after above thresholds met to stop testing
				;cat. converter for overheating and retain current
				;temperature state set during previous test
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Catalytic converter raction temperature bias vs. AFR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	coeff = val/256		;gms/sec
;
L4077   FCB  1			;  0
	FCB  4			; 16
	FCB  5			; 32
	FCB  6			; 48
	FCB  6			; 64
	FCB  6			; 80
	FCB  7			; 96
	FCB  18			;112
	FCB  20			;128
	FCB  22			;144
	FCB  22			;160
	FCB  22			;176
	FCB  22			;192
	FCB  22			;208
	FCB  22			;224
	FCB  22			;240
	FCB  22			;256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Catalytic converter raction temperature bias vs. AFR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Deg C = value x3 + 300	;AFR
;
L4088   FCB  101		;10.7
	FCB  105		;11.5
	FCB  115		;12.3
	FCB  121		;13.1
	FCB  112		;13.9
	FCB  128		;14.7
	FCB  112		;15.5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Flow based catalytic converter reaction temperature 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L408F   FCB   0			;0 RPM, row offset
	FCB   0			;0 gms/sec, col. offset
	FCB   17		;# cols. per row
;
; Deg C = value x3 + 300
;
;    gms/sec: 0   16   32   48   64   80   96  112  128  144  160  176  192  208  224  240  256;  RPM
;
L4092	FCB  27,  75,  99, 120, 145, 170, 174, 193, 185, 185, 185, 185, 185, 185, 185, 185, 185;    0  
	FCB  27,  75,  99, 120, 145, 170, 174, 193, 185, 185, 185, 185, 185, 185, 185, 185, 185;  800
	FCB  27,  90, 110, 169, 149, 174, 178, 197, 189, 195, 195, 195, 195, 195, 195, 195, 195; 1600  
	FCB  27, 105, 122, 135, 182, 207, 211, 230, 222, 227, 227, 227, 227, 227, 227, 227, 227; 2400 
	FCB  27, 105, 146, 163, 171, 196, 200, 219, 211, 219, 219, 219, 219, 219, 219, 219, 219; 3200
	FCB 102,  85, 150, 176, 181, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187; 4000
	FCB 102,  85, 150, 176, 181, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 255; 4800
	FCB 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255; 5600
	FCB 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255; 6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-CPI variable tuning valve params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L412B   FCB 0			;RPM/25, lower hyst. bound to disable tuning valve
L412C   FCB 0			;RPM/25, lower hyst. bound for valve to remain disabled
;   
L412D   FCB 0			;RPM/25, upper hyst. bound to disable tuning valve   
L412E   FCB 0			;RPM/25, upper hyst. bound for valve to remain disabled
;
L412F   FCB 0			;% TPS, lower hyst. bound to disable tuning valve
L4130   FCB 0			;% TPS, lower hyst. bound for valve to remain disabled
;  
L4131   FCB 0			;-40 deg C, lower cool temp threshold to enable tuning valve
;
;~~~~~~~~~~~
;-VSS param
;~~~~~~~~~~~
;
L4132   FCB 2   		;2 mph, lower allowed threshold for vehicle speed
;
;~~~~~~~~~~~~~~~~~~
;-Spark/DRP params
;~~~~~~~~~~~~~~~~~~
;
L4133   FCB 0			;Base SA 
L4134	FDB 2458		;400 RPM, DRP threshold for engine to be running
L4136	FDB 3574		;275 RPM, DRP threshold to transition from crank to run
;
;~~~~~~~~~~~~~~~~~~~
;-MAP filter params
;~~~~~~~~~~~~~~~~~~~
;
L4138	FCB   200		;Standard MAP filter coeff.
L4139	FCB   250		;Transient MAP filter coeff. 
L413A:  FCB   240		;3 secs, transient MAP apply timer val
L413B:  FCB   1  		;12.5 rpm, delta for transient MAP 
;
;~~~~~~~~~
;-SA bias
;~~~~~~~~~
;
L413C	FCB 28			;10 deg, main SA bias
L413D	FCB 57			;20 deg, cool temp corr. SA bias
L413E:  FCB 29  		;10 deg, 
L413F	FCB 0			;0 Deg, EGR bias
L4140	FCB 0			;0 Deg, bias for MAT SA corr.
;
L4141	FCB  167		; 85c COOL, COLD THRESH FOR NEG SPK not used,
;    
L4142	FCB  8      		;8, number of cylinders 
L4143	FCB  6			; 6 NUM CNT'S SPK RUN FLAG SET IF RPM GT L4134 (400) 
L4144	FCB  2			;#DRPs to transition from crank to run;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-SA advance and retard limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4145   FDB 0119		;42 deg, max SA;
L4147	FDB 65508   		;-10.0 deg, max allowable retard  
L4149	FDB 65514		;-7.4 deg, max allowable retard when in DFCO
L414B	FDB 65514		;-7.4 deg, max retard during torque management fuel cutoff 
;
L414D	FCB 15			;Filter coeff. for SA ramping multiplier, used when 
				;transitioning from crank to run
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decel Fuel Cut Off SA corection parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L414E   FCB 10			;Low %TPS SA ramping mult. filter coeff.  
L414F   FCB 20      		;High %TPS SA ramping mult. filter coeff. 
L4150   FCB 25      		;9.8%, TPS threshold to use high %TPS filter coeff.  
L4151   FCB 28			;10 deg, DFCO SA 
;
L4152   FCB 240			;Filter coeff for RPM/12.5
;
;~~~~~~~~~~~~~~~~~~~
;-Pseudo-Baro quals
;~~~~~~~~~~~~~~~~~~~
;
L4153	FCB 224			;4000 RPM, upper scaled rpm limit for pseudo-baro
L4154   FCB 64      		;1200 RPM, lower scaled rpm limit for pseudo-baro
L4155   FCB 140     		;54.7% TPS, min *TPS for pseudo-baro
L4156   FCB 5       		;2.0% TPS, Min delta %TPS for pseudo-baro
L4157   FCB 128     		;Baro filter coeff.
L4158   FCB 160     		;Min cool temp for pseudo-baro update
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle SA adjustment quals.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4159   FCB 1			;1 MPH, upper limit for idle SA adjustments   
L415A   FCB 4			;1.6% TPS, upper limit for idle SA adjustments, idle SA ok'd  
L415B   FCB 6			;3.2% TPS, upper limit for idle SA adjustments, idle SA 
				;not ok'd   
L415C   FCB 100			;35 deg C, min temp for idle SA adjustments 
L415D   FDB 0030		;30 sec, min run time for idle SA adjustments 
L415F   FCB 0			;0 RPM, offset for desired RPMs if not idling to 
				;check RPM quals. for idle SA adjustments
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Power steering SA compensation
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4160   FCB 255			;151 deg C, cool temp threshold for P/S SA compensation
L4161   FDB 0000		;0 deg SA, fixed SA for P/S compensation
L4163   FCB 0			;0% TPS, upper TPS threshold for enabling P/S compensation
L4164   FCB 0			;0% TPS, threshold for disabling P/S compensation when active 
;
;~~~~~~~~~~~~~~~
;-Main SA table
;~~~~~~~~~~~~~~~
;
; SA = (val - bias) * .351
;
L4165   FCB   0			;0 RPM, row offset
	FCB   0			;0 kPa, col offset
	FCB  17			;# cols./row
;
;	kPa: 20   25   30   35   40   45   50   55   60   65   70   75   80   85   90   95  100 ;  RPM
;
	FCB  85,  85,  85,  85,  85,  80,  77,  63,  60,  54,  46,  40,  37,  34,  31,  28,  26 ;  400
	FCB  85,  85,  85,  85,  85,  80,  77,  63,  60,  54,  46,  40,  37,  34,  31,  28,  28	;  600
	FCB  85,  85,  85,  85,  85,  85,  85,  74,  68,  57,  54,  43,  40,  34,  31,  28,  28	;  800
	FCB  85,  85,  85,  85,  85,  85,  85,  80,  71,  65,  57,  48,  43,  37,  31,  28,  28	; 1000   
 	FCB  85,  85,  85,  85,  85,  85,  85,  80,  74,  68,  60,  54,  48,  43,  37,  34,  31	; 1200
  	FCB  88,  88,  88,  88,  88,  88,  88,  82,  80,  71,  65,  60,  54,  48,  43,  40,  40 ; 1600
	FCB  91,  91,  91,  91,  91,  91,  91,  85,  82,  74,  68,  63,  57,  54,  48,  46,  46	; 2000
	FCB  94,  94,  94,  94,  94,  94,  94,  91,  88,  80,  74,  68,  63,  60,  54,  54,  51	; 2400
	FCB 100, 100, 100, 100, 100, 100, 100,  94,  91,  82,  77,  71,  65,  63,  60,  57,  54 ; 2800
	FCB 102, 102, 102, 102, 102, 102, 102,  97,  94,  91,  80,  77,  74,  68,  65,  63,  60 ; 3200
	FCB 105, 105, 105, 105, 105, 105, 105, 102,  97,  91,  85,  80,  77,  71,  68,  65,  63	; 3600
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 100,  94,  88,  85,  82,  77,  77,  74,  71	; 4000
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  91,  88,  85,  80,  80,  80,  77 ; 4400
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  91,  88,  85,  80,  77,  74,  71	; 4800
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74	; 5200         
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74 ; 5600
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74 ; 6000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Closed throttle SA table
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; SA = (val - bias) * .351
;
L4289   FCB  0			;0 RPM, row offset
	FCB  0			;0 kPa, col offset
	FCB  17			;# of cols. per row
;
;	kPa: 20   25   30   35   40   45   50   55   60   65   70   75   80   85   90   95  100 ;  RPM
;
	FCB  85,  85,  85,  85,  85,  80,  77,  63,  60,  54,  46,  40,  37,  34,  31,  28,  26 ;  400
	FCB  71,  71,  71,  71,  77,  80,  77,  63,  60,  54,  46,  40,  37,  34,  31,  28,  28	;  600
	FCB  71,  71,  71,  71,  77,  85,  85,  74,  68,  57,  54,  43,  40,  34,  31,  28,  28	;  800
	FCB  85,  85,  85,  85,  85,  85,  85,  80,  71,  65,  57,  48,  43,  37,  31,  28,  28 ; 1000
	FCB  85,  85,  85,  85,  85,  85,  85,  80,  74,  68,  60,  54,  48,  43,  37,  34,  31 ; 1200
	FCB  88,  88,  88,  88,  88,  88,  88,  82,  80,  71,  65,  60,  54,  48,  43,  40,  40 ; 1600        
	FCB  91,  91,  91,  91,  91,  91,  91,  88,  85,  80,  71,  68,  60,  57,  48,  46,  46 ; 2000
	FCB  94,  94,  94,  94,  94,  94,  94,  91,  88,  80,  74,  68,  63,  60,  54,  54,  51	; 2400
	FCB 100, 100, 100, 100, 100, 100, 100,  94,  91,  82,  77,  71,  65,  63,  60,  57,  54 ; 2800
	FCB 102, 102, 102, 102, 102, 102, 102,  97,  94,  91,  80,  77,  74,  68,  65,  63,  60 ; 3200
	FCB 105, 105, 105, 105, 105, 105, 105, 102,  97,  91,  85,  80,  77,  71,  68,  65,  63 ; 3600
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 100,  94,  88,  85,  82,  77,  74,  71,  68 ; 4000
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  91,  88,  85,  80,  77,  74,  71 ; 4400
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  91,  88,  85,  80,  77,  74,  71 ; 4800
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74 ; 5200
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74 ; 5600
	FCB 114, 114, 114, 114, 114, 114, 114, 114, 102,  97,  94,  91,  88,  82,  80,  77,  74 ; 6000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Look up cool temp SA correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; SA = (val - bias) * .351
;
L43AD	FCB   0 		;zero val=use vac, non-zero val=use SD MAP
;
	FCB  16			;12 deg C, cool temp offset 
	FCB  0			;0 kPa, vac offset
	FCB  9			;# cols. per row
;
;	kPa: 80	  70   60   50   40   30   20   10    0	;Deg C
;
	FCB  91,  91,  91,  91,  91,  91, 100, 100, 100	;-28
	FCB  91,  91,  91,  91,  91,  91,  97,  97,  97 ;-16 
	FCB  85,  85,  85,  85,  85,  85,  94,  94,  94 ; -4 
	FCB  82,  82,  82,  82,  82,  82,  85,  85,  85 ;  8 
	FCB  54,  54,  54,  54,  54,  57,  60,  63,  63 ; 20 
	FCB  48,  48,  48,  48,  48,  51,  54,  57,  57 ; 32 
	FCB  46,  46,  46,  46,  46,  48,  51,  51,  51 ; 44 
	FCB  46,  46,  46,  46,  46,  48,  51,  51,  51 ; 56 
	FCB  48,  48,  48,  48,  48,  57,  57,  57,  57 ; 68 
	FCB  57,  57,  57,  57,  57,  57,  57,  57,  57 ; 80 
	FCB  57,  57,  57,  57,  57,  57,  57,  57,  57 ; 92 
	FCB  54,  54,  54,  51,  51,  48,  46,  46,  46 ;103   
	FCB  51,  48,  48,  43,  43,  43,  40,  40,  40 ;116 
	FCB  43,  43,  37,  34,  34,  34,  31,  31,  31 ;128 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-SA correction mult. vs MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; SA corr. = (val - bias) x .351 
;
L442F   FCB  0      ;Col. select, 0 = use vac, 1 = use RPM
;
	FCB  80     ;20 deg C, min MAT
	FCB  0      ;Min vac.
	FCB  12     ;# of cols.
;
;
;	kPa   55,   50,   45,   40,   35,   30,   25,   20,   15,   10,    5,    0	;Deg C
;

	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 20 
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 32
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 44
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 55
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 68
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 80
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	; 92	
	FCB    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0	;104
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-MAT SA mult. for negative SA correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Mult.			;kPa
;
L4493	FCB  0			; 20  
	FCB  0			; 25  
	FCB  0      		; 30  
	FCB  0      		; 35  
	FCB  0      		; 40  
	FCB  0      		; 45  
	FCB  0      		; 50  
	FCB  0      		; 55  
	FCB  0      		; 60  
	FCB  0      		; 65  
	FCB  0      		; 70  
	FCB  0      		; 75  
	FCB  0      		; 80
	FCB  0      		; 85
	FCB  0      		; 90
	FCB  0     		; 95
	FCB  0      		;100
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-MAT SA mult. for positive SA correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Mult.			;kPa
;
L44A4	FCB  0			; 20  
	FCB  0			; 25  
	FCB  0      		; 30  
	FCB  0      		; 35  
	FCB  0      		; 40  
	FCB  0      		; 45  
	FCB  0      		; 50  
	FCB  0      		; 55  
	FCB  0      		; 60  
	FCB  0      		; 65  
	FCB  0      		; 70  
	FCB  0      		; 75  
	FCB  0      		; 80
	FCB  0      		; 85
	FCB  0      		; 90
	FCB  0     		; 95
	FCB  0      		;100
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-PE spark corr. vs rpm
;~~~~~~~~~~~~~~~~~~~~~~~
;
;	Deg SA		;RPM
;

L44B5   FCB  0			;   0
	FCB  0			; 400
	FCB  0			; 800
	FCB  3			;1200
	FCB  6			;1600
	FCB  6			;2000
	FCB  6			;2400
	FCB  6			;2800
	FCB  6			;3200
	FCB  6			;3600
	FCB  6			;4000
	FCB  6			;4400
	FCB  6			;4800
	FCB  6			;5200
	FCB  6			;5600
	FCB  6			;6000
	FCB  6			;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-SA decay period vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	period = 5/value
;
L44C6   FCB 19			; 0
        FCB 14			;16
        FCB 8			;32
        FCB 6			;48
        FCB 4			;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Alt. SA correction vs. baro and vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; SA corr. = (val - bias) x .351 
;
	
L44CB	FCB  96			;75 kPa, baro row offset for lookup
	FCB  176		;25 kPa, vacuum col. offset for lookup
	FCB  6			;# cols. per row
;
;  kPa vac:  25   20   15   10    5    0 ;kPa baro 
;
	FCB  28,  28,  25,  25,  25,  28 ; 75     
	FCB  28,  28,  28,  28,  28,  28 ; 85
	FCB  28,  28,  28,  28,  28,  28 ; 95	
	FCB  28,  28,  28,  28,  28,  28 ;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Engine idle overspeed proportional SA correction vs RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Subtracted from SA to lower engine speed
;
L44E6  	FCB   96		;250 RPM, UL for table lookup
;
;	SA corr.=		
;	val x .351		;RPM error
;
	FCB   0			;  0.0  
	FCB   6			; 12.5
	FCB   9			; 25.0
	FCB  11			; 37.5
	FCB  14			; 50.0
	FCB  14			;150.0
	FCB  17			;250.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Engine idle overspeed SA multiplier vs. SD MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L44EE   FCB  128    ;60 kPa, UL for lookup
;
;	% SA corr. =
;	val x .391		;kPa
;
	FCB  255		;20
	FCB  255		;25
	FCB  255		;30
	FCB  255		;35
	FCB  244		;40
	FCB  244		;45
	FCB  232		;50
	FCB  175		;55
	FCB  128		;60
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Engine idle underspeed proportional SA correction vs RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Added SA to raise engine speed
;
L44F8   FCB 96			;250 rpm, UL for lookup
;
;	SA corr.=		
;	val x .351		;RPM error
;
	FCB   0     		;  0.0 
	FCB   3     		; 12.5
	FCB   6     		; 25.0 
	FCB   9     		; 37.5
	FCB  11    		; 50.0
	FCB   9     		;150.0 
	FCB   9     		;250.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Engine idle underspeed SA multiplier vs S/D MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4500   FCB 128     		;60 kPa, UL for lookup
;
;	% SA corr. =
;	val x .391		;kPa
;
	FCB   244		; 20 
	FCB   232    		; 25
	FCB   232    		; 30
	FCB   232    		; 35
	FCB   205    		; 40
	FCB   166    		; 45
	FCB   102    		; 50
	FCB   32     		; 55
	FCB   0      		; 60
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Derivative spark/fuel RPM control params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L450A  FCB   57			;20 deg, SA bias for transient RPM idle SA corr. 
L450B  FCB   11			;3.9 deg, max idle SA correction 
L450C  FCB   64			;1600 RPM, upper limit for derivative RPM term
;
L450D  FCB   221		;Filter coeff, RPM/6.25
L450E  FCB   101		;Filter coeff, RPM derivative term
;
;-Limits for derivative fuel 
;
L450F  FCB   116		;.91, min value for transient RPM ratio
L4510  FCB   141		;1.1, max value for transient RPM ratio
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Transient RPM idle SA corr. vs. rpm ratio
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 	SA = 
;	(val - bias) x .351	;RPM ratio
;
L4511   FCB  50			;0.75000
	FCB  51			;0.78125
	FCB  52			;0.81250     
	FCB  53			;0.84375
	FCB  54			;0.87500
	FCB  55			;0.90625
	FCB  56			;0.93750
	FCB  57			;0.96875
	FCB  57			;1.00000
	FCB  57			;1.03125
	FCB  58			;1.06250
	FCB  59			;1.09375
	FCB  60			;1.12500
	FCB  61			;1.15625
	FCB  62			;1.18750
	FCB  63			;1.21875
	FCB  64			;1.25000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Initial added SA vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4522	FCB 8			;9 line table 
;
;	Deg SA = val x .351	;Deg C		
;
L4523   FCB 28			;-40
	FCB 28			;-16
	FCB 28			;  8
	FCB 28			; 32
	FCB 20			; 56
	FCB 14			; 80
	FCB 14			;104
	FCB 14			;128
	FCB 14			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Initial added SA decay delay vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
L452C	FCB 8			;9 line table
;
;	secs before decay = 
;	val/5			;Deg C
;
L452D   FCB 40			;-40
	FCB 40			;-16
	FCB 25			;  8
	FCB 15			; 32
	FCB 20			; 56
	FCB 10			; 80
	FCB 5			;104
	FCB 5			;128
	FCB 5			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke SA decay multiplier vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4536   FCB  8      ;9 line table
;
;	mult. = val/256		;Deg C
;
L4537   FCB  251		;-40
	FCB  251		;-16
	FCB  248		;  8
	FCB  248		; 32
	FCB  243		; 56
	FCB  235		; 80
	FCB  205		;104
	FCB  205		;128
	FCB  205		;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Spark latency correction vs. RPMs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4540	FCB  192		;4800 rpm, UL for lookup
;
;       usecs = val x 15.26	;RPM
;
L4541	FCB   0			;   0    
	FCB   0			; 400 
	FCB   0			; 800 
	FCB   3			;1200  
	FCB   7			;1600   
	FCB   9			;2000
	FCB   9			;2400  
	FCB   12		;2800
	FCB   11		;3200
	FCB   9			;3600 
	FCB   10 		;4000 
	FCB   10     		;4400 
	FCB   9      		;4800    
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Baro correction table
;~~~~~~~~~~~~~~~~~~~~~~~
;
L454E	FCB   32    ; Min RPM Value, (1200)
	FCB   48    ; Min TPS Value, (37.5%)
	FCB   6     ; # columns/row
;
;-Added Baro counts
;
; 	%TPS   37.5, 50.0, 62.5, 75.0, 87.5,  100	;RPM			
;
	FCB	18,    10,    6,    5,    4,    3	;1200
	FCB	35,    17,   13,    9,    8,    6	;1800
	FCB	54,    27,   22,   16,   14,   11	;2400
	FCB	75,    44,   29,   20,   16,   13	;3000
	FCB	97,    45    38,   26,   21,   16	;3600
	FCB    115,    62,   46,   32,   27,   21	;4200
	FCB    130,    70,   48,   33,   25,   20	;4800	
;
;~~~~~~~~~~~~~~~~~~~~~
;-Max PE knock retard
;~~~~~~~~~~~~~~~~~~~~~
;
;	Max pulled SA=
;	value x .351		;RPM
;
L457B   FCB 46			; 800  
	FCB 46  		;1600 
	FCB 46  		;2400 
	FCB 57  		;3200 
	FCB 57  		;4000
	FCB 57  		;4800
	FCB 57  		;5600
	FCB 57  		;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Max Non-PE retard vs Vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;	Max pulled SA=
;	value x .351		;kPa
;
L4583   FCB 0			; 60  
        FCB 23  		; 50
        FCB 46  		; 40
        FCB 46  		; 30
        FCB 46  		; 20
        FCB 46  		; 10
        FCB 46  		;  0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Knock attack rate vs. rpm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	deg/msec = val. x
;		   .0225 	
;	       			; RPM
;			
L458A   FCB  2			;   0
	FCB  2      		; 400
	FCB  10     		; 800
	FCB  15     		;1200
	FCB  15     		;1600
	FCB  15     		;2000
	FCB  15     		;2400
	FCB  15     		;2800
	FCB  21     		;3200
	FCB  21     		;3600
	FCB  21     		;4000
	FCB  21     		;4400
	FCB  21     		;4800
	FCB  21     		;5200
	FCB  21     		;5600
	FCB  21     		;6000
	FCB  21   	  	;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Retard recovery rate vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	% recovery/sec = 
;	value x 1.953		;RPM
;
L459B   FCB  220		;   0
	FCB  220		; 400
	FCB  48			; 800
	FCB  19			;1200
	FCB  19			;1600
	FCB  19			;2000
	FCB  18			;2400
	FCB  18			;2800
	FCB  16			;3200
	FCB  16			;3600
	FCB  16			;4000
	FCB  16			;4400
	FCB  16			;4800
	FCB  16			;5200
	FCB  16			;5600
	FCB  16			;6000
	FCB  16			;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Low octaine retard params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L45AC   FCB 160			;80 deg C, min temp for low octaine retard
L45AD   FCB 96			;50 kPa, lower SD MAP threshold for low octaine retard 
L45AE   FCB 64			;20 kPa, max rate of change in SD MAP for low octaine retard
;
L45AF   FCB 14			;2.5 deg, lower SA retard threshold to set high knock activity  
L45B0   FCB 11			;1.9 deg, upper SA retard threshold to set low knock activity
;
L45B1   FCB 25			;9.8 %/sec, ramping rate to bring in base low octaine ret. SA
L45B2   FCB 25			;9.8 %/sec, ramping rate to remove base low octaine retard SA
;
L45B3   FCB 14			;5 deg, base low octaine retard SA
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Low octane spark retard mult. vs RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Mult = val/2.56		; RPM
;
L45B4   FCB  0      		;   0
	FCB  0     		; 800
	FCB  204    		;1600
	FCB  204    		;2400
	FCB  204    		;3200
	FCB  230    		;4000
	FCB  255    		;4800
	FCB  255    		;5600
	FCB  255    		;6400
;


;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Low octane SA mult. vs SD MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Mult.			;kPa		
;
L45BD   FCB  0			; 20
	FCB  0			; 25
	FCB  0			; 30
	FCB  0			; 35
	FCB  0			; 40
	FCB  0			; 45
	FCB  128		; 55
	FCB  204		; 55
	FCB  255		; 60
	FCB  255		; 65
	FCB  255		; 70
	FCB  255		; 75
	FCB  255		; 80
	FCB  255		; 85
	FCB  255		; 90
	FCB  255		; 95
	FCB  255		;100
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Min knock counts vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Subtracted out from knock 
; counts before store
;
;	knock counts		;RPM
;
L45D1   FCB  48			;   0
	FCB  48			; 100
	FCB  48			; 200
	FCB  48			; 300
	FCB  48			; 400
	FCB  48			; 500
	FCB  48			; 600
	FCB  48			; 700
	FCB  19			; 800
	FCB  19			; 900
	FCB  19			;1000
	FCB  16			;1100
	FCB  16			;1200
	FCB  16			;1300
	FCB  16			;1400
	FCB  16			;1500
	FCB  16			;1600
	FCB  16			;1700
	FCB  16			;1800
	FCB  16			;1900
	FCB  21			;2000
	FCB  21			;2100
	FCB  21			;2200
	FCB  21			;2300
	FCB  21			;2400
	FCB  21			;2500
	FCB  21			;2600
	FCB  21			;2700
	FCB  41			;2800
	FCB  41			;2900
	FCB  41			;3000
	FCB  41			;3100
	FCB  41			;3200
	FCB  41			;3300
	FCB  41			;3400
	FCB  41			;3500
	FCB  41			;3600
	FCB  32			;3700
	FCB  28			;3800
	FCB  25			;3900
	FCB  21			;4000
	FCB  16			;4100
	FCB  16			;4200
	FCB  16			;4300
	FCB  16			;4400
	FCB  16			;4500
	FCB  16			;4600
	FCB  16			;4700
	FCB  16			;4800
	FCB  16			;4900
	FCB  16			;5000
	FCB  16			;5100
	FCB  16			;5200
	FCB  16			;5300
	FCB  16			;5400
	FCB  16			;5500
	FCB  16			;5600
	FCB  16			;5700
	FCB  16			;5800
	FCB  16			;5900
	FCB  16			;6000
	FCB  16			;6100
	FCB  16			;6200
	FCB  16			;6300
	FCB  16			;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added knock count bias vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Knock count bias	;RPM
;
L4612   FCB  0			;   0
	FCB  0			; 100
	FCB  0			; 200
	FCB  0			; 300
	FCB  0			; 400
	FCB  0			; 500
	FCB  0			; 600
	FCB  0			; 700
	FCB  48			; 800
	FCB  48			; 900
	FCB  48			;1000
	FCB  48			;1100
	FCB  48			;1200
	FCB  48			;1300
	FCB  48			;1400
	FCB  48			;1500
	FCB  48			;1600
	FCB  48			;1700
	FCB  48			;1800
	FCB  48			;1900
	FCB  48			;2000
	FCB  48			;2100
	FCB  48			;2200
	FCB  48			;2300
	FCB  48			;2400
	FCB  48			;2500
	FCB  48			;2600
	FCB  48			;2700
	FCB  48			;2800
	FCB  48			;2900
	FCB  48			;3000
	FCB  48			;3100
	FCB  48			;3200
	FCB  48			;3300
	FCB  48			;3400
	FCB  64			;3500
	FCB  64			;3600
	FCB  64			;3700
	FCB  64			;3800
	FCB  64			;3900
	FCB  64			;4000
	FCB  64			;4100
	FCB  64			;4200
	FCB  64			;4300
	FCB  64			;4400
	FCB  64			;4500
	FCB  64			;4600
	FCB  64			;4700
	FCB  64			;4800
	FCB  64			;4900
	FCB  64			;5000
	FCB  64			;5100
	FCB  64			;5200
	FCB  64			;5300
	FCB  64			;5400
	FCB  64			;5500
	FCB  64			;5600
	FCB  64			;5700
	FCB  64			;5800
	FCB  64			;5900
	FCB  64			;6000
	FCB  64			;6100
	FCB  64			;6200
	FCB  64			;6300
	FCB  64			;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Knock window delay time vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; msec = Table val/131.072
;
L4653   FDB  0426		;   0
	FDB  0426		; 100
	FDB  0426   		; 200
	FDB  0426   		; 300
	FDB  0426   		; 400        
	FDB  0426   		; 500
	FDB  0426   		; 600
	FDB  0426   		; 700
	FDB  0426   		; 800   
	FDB  0426   		; 900
	FDB  0426   		;1000
	FDB  0426  		;1100
	FDB  0426   		;1200
	FDB  0426   		;1300        
	FDB  0426   		;1400
	FDB  0426   		;1500
	FDB  0426   		;1600
	FDB  0361   		;1700        
	FDB  0361   		;1800        
	FDB  0361   		;1900        
	FDB  0361   		;2000        
	FDB  0361   		;2100        
	FDB  0361   		;2200        
	FDB  0328   		;2300        
	FDB  0238   		;2400
	FDB  0328   		;2500        
	FDB  0238   		;2600        
	FDB  0328   		;2700        
	FDB  0238   		;2800        
	FDB  0328   		;2900        
	FDB  0238   		;3000        
	FDB  0328   		;3100        
	FDB  0262   		;3200        
	FDB  0262   		;3300        
	FDB  0262   		;3400        
	FDB  0262   		;3500        
	FDB  0262   		;3600        
	FDB  0262   		;3700        
	FDB  0262   		;3800        
	FDB  0262   		;3900        
	FDB  0262   		;4000        
	FDB  0262   		;4100
	FDB  0262   		;4200        
	FDB  0262   		;4300
	FDB  0219   		;4400        
	FDB  0219   		;4500        
	FDB  0219   		;4600
	FDB  0219   		;4700        
	FDB  0219   		;4800        
	FDB  0219   		;4900        
	FDB  0219   		;5000        
	FDB  0219   		;5100        
	FDB  0219   		;5200        
	FDB  0219   		;5300        
	FDB  0219   		;5400        
	FDB  0219   		;5500        
	FDB  0219   		;5600        
	FDB  0219   		;5700        
	FDB  0219   		;5800        
	FDB  0219   		;5900        
	FDB  0219   		;6000        
	FDB  0219   		;6100        
	FDB  0219   		;6200        
	FDB  0219   		;6300        
	FDB  0219   		;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Knock prevention params.
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L46D5   FCB 96			;50 kPa, upper limit for knock prevention
L46D6   FCB 128			;50% TPS, upper limit for knock prevention
L46D7   FCB 12			;4.7% delta TPS, min delta TPS for knock prevention 
L46D8   FCB 40			;500 msec, time for burst retard to be in effect 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Degrees SA of burst knock retard vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L46D9   FCB 112			;110 deg C, UL for lookup
;
;	deg SA = 
;	val x .351		;Deg C
;
	FCB 0       		; 75
	FCB 3       		; 80
	FCB 6       		; 85
	FCB 6       		; 90
	FCB 6       		; 95
	FCB 9       		;100
	FCB 14      		;105
	FCB 17      		;110
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Engine SA control params, used with manual trans.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-RPMs rising
;
L46E2   FCB 0			;SA derivative gain
L46E3   FCB 0			;SA derivative term bias
L46E4   FCB 0			;Max allowable SA derivative term to be subtracted
;
;-RPMs falling
;
L46E5   FCB 0			;SA derivative gain  
L46E6   FCB 0			;SA derivative term bias  
L46E7   FCB 0			;Max allowable SA derivative term to be added   
L46E8   FCB 255			;151 deg C, lower temp. limit for der. control
L46E9   FCB 0			;-40 deg C, upper temp. limit for der. control
;
;-Filter coeff for RPMs/12.5, used in calc. delta RPMs
;
;	Filt. coeff.		;% TPS
;
L46EA   FCB 0			;  0
	FCB 0			; 25   
	FCB 0			; 50   
	FCB 0			; 75   
	FCB 0			;100   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Quals for enabling/disabling EGR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Startup cool temp EGR params
;
L46EF   FCB 73			;15 deg C, startup cool temp threshold for warm startup
L46F0   FCB 153			;75 deg C, cool temp to enable EGR if warm startup
L46F1   FCB 113			;45 deg C, cool temp to enable EGR if cold startup
;
;-MAT thresholds for EGR
;
L46F2   FCB 0			;-50 deg C, MAT threshold to enable EGR     
L46F3   FCB 0			;-50 deg C, MAT threshold to disable EGR
;
;-Speed threshold for EGR
;
L46F4   FCB 0			;0 MPH, min speed for EGR  
;
;-RPM thresholds for EGR
;
L46F5   FCB 32			;800 RPM, threshold to enable EGR   
L46F6   FCB 30			;750 RPM, threshold to disable EGR
;
;-TPS thresholds for EGR
;
L46F7   FCB 8			;3% TPS, threshold to enable EGR 
L46F8   FCB 5			;2% TPS, threshold to disable EGR
;
;-MAP thresholds for EGR
;
L46F9   FCB 45			;34 kPa, MAP threshold to enable EGR   
L46FA   FCB 38			;32 kPa, MAP threshold to disable EGR  
;
;-VAC thresholds for EGR
;				
L46FB   FCB 240			;5.0 kPa, vac threshold to enable EGR
L46FC   FCB 233			;7.2 kPa, vac threshold to disable EGR
;
L46FD   FCB 166			;65% TPS, max TPS for EGR 
L46FE   FCB 140			;14:1 AFR, max rich AFR for EGR
;
;-Min desired EGR
;
; Linear EGR = desired pintle pos.
; EVRV/back pressure type EGR = duty cycle
;
L46FF	FCB	51		;20%, min allowed desired EGR, less will be cleared
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Desired EGR vs. RPM and load
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;				 
L4700   FCB 0			;EGR load option
				;0 = vacuum
				;1 = SD MAP
				;2 = MAP/Baro ratio
;	 
L4701   FCB 32			;800 RPM offset
        FCB 0			;0 kPa, vac offset
        FCB 9			;# cols. per row
;
; Desired EGR = val x .391 (or pintle posit. for linear EGR)
;
;   Vac	kPa:  80   70   60   50   40   30   20   10    0 : RPM
;
L4704   FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ; 800
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;1200
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;1600
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;2000
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;2400
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;2800
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;3200
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;3600
	FCB, 255, 255, 255, 255, 255, 255, 255, 255, 255 ;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Desired EGR correction factor vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4755   FCB  176 		;92 deg C, upper limit for lookup
;
;	factor = val/128	;Deg C
;
	FCB  128    		; 20      
	FCB  128    		; 32        
	FCB  128    		; 48        
	FCB  128    		; 56      
	FCB  128    		; 68       
	FCB  128    		; 80         
	FCB  128    		; 92
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Desired EGR correction vs. SD MAP and vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L475D   FCB   16		;30 kPa, MAP offset 
	FCB   96		;75 kPa, vac offset
	FCB   4			;# cols. per row
;
; Factor = value/128
;
;  Baro kPa:  75   85   95  105 :MAP kPa
;
L4760   FCB  128, 128, 128, 128 ; 30
	FCB  128, 128, 128, 128 ; 40
	FCB  128, 128, 128, 128 ; 50
	FCB  128, 128, 128, 128 ; 60
	FCB  128, 128, 128, 128 ; 70
	FCB  128, 128, 128, 128 ; 80
	FCB  128, 128, 128, 128 ; 90
	FCB  128, 128, 128, 128 ;100
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Ratio of EGR flow vs. MAP and load
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4780   FCB   16		;800 RPM, RPM offset 
        FCB   0			;0 kPa, min load value for lookup
        FCB   13		;# cols. per row
;
; EGR/total gms flow ratio = value x .0976
; 
;      kPa: 0.0  2.5  5.0  7.5 10.0 12.5 15.0 17.5 20.0 30.0 40.0 50.0 60.0:  RPM
;
L4783	FCB   0,   0,  15,  46, 100, 100, 100, 100, 100, 100, 100, 100, 100 ; 800  
	FCB   0,   0,  15,  46, 100, 100, 100, 100, 100, 100, 100, 100, 100 ;1600 
	FCB   0,   0,  15,  46, 100, 100, 100, 100, 100, 100, 100, 100, 100 ;2400 
	FCB   0,   0,  15,  46, 100, 100, 100, 100, 100, 100, 100, 100, 100 ;3200
	FCB   0,   0,  15,  46, 100, 100, 100, 100, 100, 100, 100, 100, 100 ;3600
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-%EGR flow filter coeff. vs airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L47C4   FCB 230			; 0 
	FCB 230			;16
	FCB 230			;32
	FCB 230			;48
	FCB 230			;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-EGR exhaust back pressure vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	kPa = va lx .3125
;
L47C9   FCB  0			;  0
	FCB  0			; 16
	FCB  0			; 32
	FCB  0			; 48
	FCB  0			; 64
	FCB  0			; 80
	FCB  0			; 96
	FCB  0			;112
	FCB  0			;128
	FCB  0			;144
	FCB  0			;160
	FCB  0			;176
	FCB  0			;192
	FCB  0			;208
	FCB  0			;224
	FCB  0			;240
	FCB  0			;256
;
L47DA   FCB 0			;EGR flow scalar, used in calculation of %EGR flow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-%EGR flow VS. delta kPa and %EGR 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L47DB   FCB   0			;0 kPa, delta Kpa row offset 
        FCB   0			;0%, %EGR col. offset 
        FCB   10		;# cols. per row
;
;      kPa:   0   5  10  15  20  30  40  50  60  70 ;%EGR
; 
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;  0
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 10
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 20
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 30
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 40
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 50
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 60
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 70
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 80
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ; 90
	FCB   0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ;100
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-%EGR flow baro corr. factor vs baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. 			;kPa	
;
L484C   FCB 255			; 75 
	FCB 255			; 85
	FCB 255			; 95
	FCB 255			;105
;
;-Linear EGR quals for EGR flow
;
L4850   FCB 0			;Min linear EGR position for EGR flow
L4851   FDB 0003		;3 secs, min time to enable EGR
;
;-Standard EGR quals for EGR flow
;
L4853   FCB 51			;20%, min %EGR for EGR flow
;
L4854   FCB 5			;EGR SA correction filter coeff.
;
;~~~~~~~~~~~~~~~~~~~
;-EGR SA correction
;~~~~~~~~~~~~~~~~~~~
;
L4855   FCB	1		;EGR load opt. byte, 1=vacuum, 0=%EGR flow
;	
L4856   FCB	16		;800 RPM, row offset
        FCB	0		;0 kPa, column offset
        FCB	13		;# cols per row							  
;
; SA = value x .391
;
;	kPa: 0.0  2.5  5.0  7.5 10.0 12.5 15.0 17.5 20.0 30.0 40.0 50.0 60.0 ; RPM
;
	FCB    0,   0,   0,   3,   3,   6,   9,   9,   9,   9,   9,   9,   9 ; 800 
	FCB    0,   0,   0,   0,   0,   0,   0,   9,   9,   9,   9,   9,   9 ;1600  		
   	FCB    0,   0,   0,   0,   0,   0,   0,   9,   9,   9,   9,   9,   9 ;2400          
	FCB    0,   0,   0,   3,   3,   6,   9,  11,  11,  11,  11,  11,  11 ;3200
	FCB    0,   0,   0,   3,   3,   6,   9,  11,  11,  11,  11,  11,  11 ;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Digital linear EGR pintle position control calib.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L489A   FCB  0			;0, A/D val for EGR pintle pos. scalar
L489B   FCB  0			;Max allowed closed EGR pintle pos. 
L489C   FCB  0	    		;Min allowed closed EGR pintle pos.					
L489D   FCB  0	    		;Filter coeff. for EGR pinle position, EGR closing/closed 
L489E   FCB  0	    		;0, filter coeff. for %EGR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-EGR init vs. % desired EGR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
L489F   FCB 0			;# lines/table
;
;	Init val for EGR int.	;% desired EGR
;
	FCB 0  			;  0
	FCB 0  			; 25
	FCB 0  			; 50   
	FCB 0  			; 75     
	FCB 0  			;100    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-EGR proportional gain vs EGR error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48A5   FCB 0			;# lines/table
;
;	gain = val/256		;%EGR error
;
	FCB 0   		;  0
	FCB 0   		; 25  
	FCB 0   		; 50     
	FCB 0   		; 75     
	FCB 0			;100 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-EGR integral gain vs. EGR error 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48AB   FCB 0   		;# lines/table 
;
;	gain = val/128		;%EGR error
;
	FCB 0   		;  0    
	FCB 0   		; 25     
	FCB 0   		; 50    
	FCB 0   		; 75     
	FCB 0 			;100 
;
;~~~~~~~~~~~~~~~
;-O2 parameters
;~~~~~~~~~~~~~~~
;
L48B1   FCB  15			;65 mV, lower limit for slow filtered O2
L48B2   FCB  208    		;903 mV, upper limit for slow filtered O2
L48B3   FCB  3			;Slow O2 filter coeff for idle
L48B4   FCB  104		;450 mV, init value for O2
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-MAP Accel Enrich params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48B5   FCB  16			;5 kPa, delta MAP threshold for AE
L48B6   FCB  4      		;1.3 kPa, delta MAP threshold for AE if idling 
L48B7   FCB  204		;80% TPS, TPS treshold to double delta MAP AE threshold  
L48B8   FCB  255		;TPS threshold to double MAP AE
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS Accel Enrich params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48B9   FCB  5			;2%, TPS threshold for TPS AE
L48BA   FCB  147		;1.15, TPS AE off-idle multiplier
L48BB   FCB  5      		;MPH threshold to apply off-idle TPS AE mult.
;
;~~~~~~~~~~~~~~~~~~~~~
;-Misc. AE parameters
;~~~~~~~~~~~~~~~~~~~~~
;
L48BC   FCB  100		;6.104 msec, post DFCO AE pulse
L48BD   FCB  20			;1.2 msec A/C off to on accel enrich
L48BE   FCB  1			;0.1 sec, execution interval to filter MAP/TPS
L48BF   FCB  26			;Slow filtered TPS filter coeff
L48C0   FCB  10			;.125 sec, time for INT to remain locked after AE
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Closed loop fueling quals
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48C1   FCB  120		;50 deg C, upper temp limit for extended closed loop delay
L48C2   FCB  203		;112 deg C, initial cool temp threshold for hot restart
;
L48C3   FCB  15			;30 sec, min time for closed loop (cool engine)
L48C4   FCB  60			;120 sec, min time for closed loop (cold engine)
L48C5   FCB  15			;30 sec, min time for full closed loop (hot restart)
;
L48C6   FCB  56			;2 deg C, min temp for closed loop
;
L48C7   FCB  253		;150 deg C, upper limit for AFR lookup in closed loop 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Max time O2 allowed to remain in window to be functional
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48C8   FCB  50			;10 secs, max time for O2 to dwell in window
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-BLM update enable params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48C9   FCB  250		;78.75 kPa, upper vac limit for BLM upate
;
L48CA   FCB  21			;18.9 Kpa, lower MAP limit for BLM update
L48CB   FCB  240		;98.9 kPa, upper MAP limit for BLM update
;
L48CC   FCB  107		;40 deg C, min temp for BLM update enable
L48CD   FCB  140		;3500 RPM, upper RPM limit for BLM update enable
;
;~~~~~~~~~~~~~~~~~
;-Idle parameters
;~~~~~~~~~~~~~~~~~
;
L48CE   FCB  3			;3 MPH, upper limit for idle VE 
L48CF   FCB  4			;4 MPH, max speed to be idling 
L48D0   FCB  7			;2.7% TPS, threshold for idling
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Params for derivative idle RPM control
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L48D1   FCB  5			;2%, max TPS for derivative RPM calc.
L48D2   FCB  2			;2 MPH, max speed for derivative RPM calc. 
L48D3   FCB  153		;75 deg C, min temp for derivative RPM calc.  
;


;
;~~~~~~~~~~~~~~~~~~~~~~
;-Open loop idle quals
;~~~~~~~~~~~~~~~~~~~~~~
;
L48D4   FCB  255		;255 sec, timer threshold to enable open loop idle
L48D5   FCB  0			;Timer threshold to remain in open loop idle
L48D6   FDB  0015		;15 sec, time after startup to clear initial idle terms
L48D8   FCB  100		;35 dec C, threshold to remain in open loop idle
;
;==============================================
; AFR PARAMS
;  BDWM, L05, MD8, ($0D)
;==============================================
;
L48D9   FCB  173		;  90c COOL, OPEN LP, RICH IDLE COOL THRESH 
L48DA   FCB  0			;-40 deg C, lower cool temp for open loop AFR enrichment
L48DB   FCB  254		;151 dec C, upper cool temp for open loop AFR enrichment  
;
L48DC   FCB  200		; 10 Sec's MAX TIME FOR RICH IDLE IF IN DRIVE
				; sec * 20
;
L48DD   FCB  147		;14.7:1, stoich AFR 
;
L48DE   FCB  10			;1.0:1 AFR bias for open loop idle
				; Used prior to TPS action after start up
;
L48DF   FCB  147		;14.7:1 AFR, lower limit for quasi-closed loop
L48E0   FCB  10			;1.0:1, onitiial AFR enrichemnt  
L48E1   FCB  5			;0.5:1, initial AFR enrichment if in park/neutral
L48E2   FCB  6			;Filter coeff. for filtering AFR after transition from idle
;
;~~~~~~~~~~~~
;-BLM params
;~~~~~~~~~~~~
;
L48E3   FCB  8			;450 msec, min time to update BLMS
;
;                   _______|______|_______|______
;                          |      |       |
;                     12   |  13  |  14   |  15    
;                   _______|______|_______|______  80 Kpa MAP
;                          |      |       |
;                      8   |  9   |   10  |  11     
;                   _______|______|_______|______  50 Kpa MAP
;                          |      |       |
;                      4   |  5   |   6   |   7     
;                   _______|______|_______|______  31 Kpa MAP
;                          |      |       |
;                      0   |  1   |   2   |   3
;                   _______|______|_______|______
;                          |      |       |       
;         900  RPM   ______|      |       |
;                                 |       |
;        1600  RPM   _____________|       |
;                                         |
;        2200  RPM   _____________________|
;
;-RPM boundries for BLM cells
;
L48E4	FCB 36			; 900 RPM 
L48E5	FCB 64			;1600 RPM   
L48E6	FCB 88			;2200 RPM  
;
;-MAP boundries for BLM cells
;
L48E7	FCB 36			;23.6 kPa 
L48E8	FCB 96			;45.8 kPa 
L48E9	FCB 192			;81.2 kPa 
;
L48EA	FCB 3			;75 RPM, RPM hyst. to change BLM cells
L48EB	FCB 8			;2 kPa, SD MAP hyst. to change BLM cells  
;
L48EC	FCB $07			;0000 0111, Option byte
				; b7 1 = not used
                		; b6 1 = not used
                		; b5 1 = not used
                		; b4 1 = not used
                		; b3 1 = not used
                		; b2 1 = SEPARATE BLM PK/NEUT CELLS
                		; b1 1 = SEPARATE BLM A/C IDLE CELLS
                		; b0 1 = SEPARATE BLM IDLE CELLS
;
L48ED	FCB 4			;Delta INT threshold to update BLMs
L48EE	FCB 3			;Delta INT threshold to bar open loop idle
;
L48EF	FCB 105			;105, min allowed BLM 
L48F0	FCB 90			;90, Min allowed idle BLM
L48F1	FCB 1			;1, BLM step value 
L48F2	FCB 165			;160, Max allowed BLM
;
;-BLM init limits
;
L48F3	FCB 135			;Upper limit on BLM at init      
L48F4	FCB 126			;Lower limit on BLM at init
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-O2 window boundries to enable learn
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Used to make sure O2 doesnt dwell around stoich, 
; indicating a fault with the O2 sensor. If O2
; dwells, learn is disabled after period of time.
;
;-Closed loop O2 window
;
L48F5	FCB 156			;677 mV, upper bound
L48F6	FCB 64			;277 mV, lower bound
;
;-Open loop O2 window
;
L48F7	FCB 166			;720 mV, upper bound
L48F8	FCB 64			;277 mV, lower bound 
;
;-Closed loop idle O2 window
;
L48F9	FCB 161			;720 mV, upper bound
L48FA	FCB 81			;352 mV, lower bound  
;
;-Open loop idle O2 window
;
L48FB	FCB 169			;733 mV, upper bound 
L48FC   FCB 81			;352 mV, lower bound  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-INTegrator anti-windup params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Params to set BLM cell change and cause INT reset
;
L48FD   FCB 120			;Lower INT thresh to flag BLM cell change when BLM rising
L48FE   FCB 133			;Upper INT thresh to flag BLM cell change when BLM falling
;
L48FF   FCB 3			;Delta BLM thresh to clear BLM cell change if going leaner 
L4900   FCB 5			;Delta BLM thresh to clear BLM cell change if going richer
;
L4901   FCB 48			;28.1 kPa lower MAP treshold for INT reset 
;
L4902	FCB 48			;1200 RPM, lower threshold not to reset INT   
L4903   FCB 100			;2500 RPM, upper treshold not to reset INT 
;
L4904   FCB 15			;15 MPH, speed threshold to reset INT   
L4905   FCB 124			;124, INT threshold to reset INT on VE table change
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-INT/Proportional term limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4906	FCB 40			;40, Min allowed INT  
L4907   FCB 158			;158, Max allowed INT		
L4908   FCB 10			;Proportional term limit when AE in effect      
;
L4909	FCB 160			;Lean AFR limit
;
;~~~~~~~~~~~~~~~~~~~~~
;-Power enrich params
;~~~~~~~~~~~~~~~~~~~~~
;
L490A	FCB 250			;3125 RPM, delta RPM value to bypass PE delay 
;
L490B   FCB 120			;50 deg C, lower cool temp threshold to bypass PE delay/
				;allow for AFR adjustments
L490C   FCB 193			;105 deg C, upper cool temp thresh to bypass PE delay
;
L490D   FCB 13			;5.1%, TPS hysteresis to remain in PE
L490E   FCB 170			;4259 RPM, upper RPM threshold for PE delay/AFR adj. 
L490F   FCB 15			;15 sec, time delay to reset after in PE
;
L4910   FCB 3			;150 msec, delay for PE to become active
L4911   FCB 150			;58.5%/pass, PE ramping rate
L4912   FCB 153			;74 deg C, cool temp thresh for cold PE
;;
L4913   FCB 50			;50 secs, threshold for extended PE\
;
L4914   FCB 195			;106c COOL, upper temp thresh to allow PE AFR adjustments
L4915	FCB 70			;1750 RPM, lower RPM limit for colt PE AFR enrich 
L4916	FCB 25			;25 MPH, MPH limit for cold PE AFR enrichment
;
L4917   FCB 12			;12 MPH min speed for delta MPH fast PE entry
L4918   FCB 255			;99.6%, TPS threshold for delta MPH fast PE entry
L4919   FCB 0       		;Timer thresh to continue to bar fast delta MPH PE entry
;
L491A   FCB 7			;0.7 AFR, cold PE AFR enrichment   
L491B   FCB 15			;1.5 AFR, base PE enleanment AFR  
L491C   FDB 0000		;0 MPH, delta MPH threshold for PE 
;
;~~~~~~~~~~~~~~~~~~~~~~
;-Choke AFR parameters
;~~~~~~~~~~~~~~~~~~~~~~
;
L491E   FCB 243			;95%, choke AFR decay multiplier
L491F   FCB 10			;2 sec, time after startup to decay choke AFR 
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Async/Sync BPW params
;~~~~~~~~~~~~~~~~~~~~~~~
;
L4920	FDB 0046		;702 usec, threshold for asnyc to sync BPW  
				;Also threshold for double to single fire if CPI
L4922   FDB 0033		;500 usec, threshold to transition form double 
				;to single fire mode, CPI/PFI 
;
;-Manditory async thresholds, TBI only
;	
L4924   FCB 96			;45.8 kPa, MAP threshold to transition back to sync fire   
L4925   FCB 48			;1200 RPM, RPM threshold to transition back to sync fire
;
L4926   FCB 112			;51.7 kPa, MAP threshold to enter async fire
L4927   FCB 52			;1300 RPM, RPM threshold to enter async fire
;
L4928   FDB 0786		;12 msec, max async BPW per pass
L492A   FDB 0033		;500 usec, min async BPW 
;
;~~~~~~~~~~~~~~~~~~~~~
;-Decel enlean params
;~~~~~~~~~~~~~~~~~~~~~
;
L492C   FCB 12			;-4.7%, delta TPS threshold for decel enlean  
L492D   FCB 12      		;-14.8 kPa, delta MAP threshold for decel enlean 
;
L492E   FCB 128			;Multiplier for low speed decel enlean  
L492F   FCB 6			;6 MPH, MPH threshold for low speed decel enlean
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decel Fuel Cut Off params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4930	FCB 8			;200 RPM, DFCO RPM hyst.    
;
L4931	FCB 15			;15 MPH, min MPH to enter DFCO   
L4932	FCB 10			;10 MPH, min MPH to remain in DFCO
;
L4933	FCB 8			;13.3 kPa, Lower MAP threshold for manditory DFCO
L4934	FCB 56			;31.0 kPa, Upper MAP limit for DFCO
;
L4935	FDB 0506		;7.72 msec, additional AE if exiting DFCO 
L4937	FCB 65			;6.5 sec, min time to enter DFCO
L4938	FCB 32			;400 msec, duration to sustain post DFCO PW   
L4939	FCB 2			;0.8% per 12.5 msec, decay rate for DFCO multiplier
;
L493A	FCB 127			;55 deg C, min temp for DFCO 
L493B   FCB 254			;3175 RPM, delta RPM threshold for DFCO 
L493C   FCB 254     		;80 kPa, delta SD MAP threshold for DFCO 
;
;~~~~~~~~~~~~~~~
;-O2 PID params
;~~~~~~~~~~~~~~~
;
L493D   FCB 30			;130 mV, O2 mV hyst. for rich/lean  
;
L493E   FCB 6			;6 counts, min slow O2 error to update INT
;  
L493F   FCB 230			;3.59, scalar for airflow used in PID tables
;
;-Idle O2 params
;
L4940   FCB 110			;478 mV, idle rich O2 threshold
L4941   FCB 110			;478 mV, idle lean O2 threshold 
L4942   FCB 110			;478 mV, mean idle rich/lean O2 threshold
;
L4943   FCB 3			;75 msec, proportional duration if idling
;   
L4944   FCB 20			;500 msec, Proportional duration dead band
;
;~~~~~~~~~~~~~~~~~~~~
;-O2 PID idle params
;~~~~~~~~~~~~~~~~~~~~
;
;-Proportional gains if unstable idle present
;
L4945   FCB 4			;0.016, proportional gain if rich  
L4946   FCB 5			;0.020, proportional gain if lean
;
;-Proportional gains if unstable idle present
;
L4947   FCB 16			;0.063, proportional gain if rich
L4948   FCB 20			;0.078, proportional gain if lean
				;(Also indexed for INT delay term)  
;
;-Integrator delay for stable idle 
;
L4949   FCB 20			;500 msec, INT delay term	
;
;-Delta RPM threshold for unstable idle
;				
L494A   FCB 2			;25 RPM, delta RPM threshold for unstable idle  
;		
L494B   FCB 255			;0.996, factor applied to O2 error if going richer 
L494C   FCB 255			;0.996, factor applied to O2 error if idling 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cold park to drive choke AFR params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L494D   FCB 40			;-10 deg C, upper cool temp limit for cold choke park to
				;drive transition    
L494E   FCB 25			;2.5 AFR, lower choke AFR limit during cold park to drive
				;transition
L494F   FCB 25			;5 sec, Park to drive transition period 
;
;~~~~~~~~~~~~~~~~~~~~
;-Hot restart params
;~~~~~~~~~~~~~~~~~~~~
;
L4950   FCB 180			;95 deg C, min previous shutdown temp for hot restard  
L4951   FCB 200     		;110 deg C, min temp for hot restart  					
L4952   FCB 10      		;1:1, AFR bias for hot restart
L4953   FDB 0015    		;15 secs, min time to clear hot restart status 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank to run transition params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4955   FCB 0			;0 DRPs, DRP threshold to transition from crank to run
L4956   FCB 0			;Mult/128, crank BPW mult. for 2nd inj. firing
L4957   FCB 0			;-40c, threshold to add AFR transition ratio in
L4958   FDB 0800		;10 sec., max time to run pump with no DRPs
L495A	FCB 3			;3 DRPs, number of DRPs between each execution of 
				;crank to run transition routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Speed/RPM limiter params
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L495B	FCB 40      		;.5 sec delay to cut fuel if high speed present  
L495C	FCB 40			;1000 RPM, thresold to re-enable fuel if MPH overspeed  
;
L495D	FCB 192			;4800 RPM, RPM threshold to enter fuel cut off
L495E	FCB 164     		;4100 RPM, RPM threshold to exit fuel cut off    
;
L495F	FCB 172     		;4300 RPM, threshold to enter fuel cutoff if trans errors
L4960	FCB 154			;3850 RPM, threshold to exit fuel cutoff if trans errors
;
L4961	FCB 98			;98 MPH, speed threshold to enter fuel cut off
L4962	FCB 96      		;96 MPH, speed threshold to exit fuel cut off
;
;~~~~~~~~~~~~
;-BPW limits
;~~~~~~~~~~~~
;
L4963	FDB 0026		;397 usec, PW threshold for short BPW
L4965	FDB 0026		;397 usec, min allowed BPW
;
L4967	FDB 0026		;397 usec, BPW offset  (used with BPW bias table) 
;
L4969	FCB 0			;Deg = val/128, degree delay from DRP to inj. firing
;
L496A	FCB 0			;Min time to transition back to single fire mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-RPM threshold for PE vs. baro kPa
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	RPM			;kPa
;
L496B   FCB 0			; 75
	FCB 0			; 85
	FCB 0			; 95
	FCB 0			;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Added BPW bias vs. BPW
;~~~~~~~~~~~~~~~~~~~~~~~~
;
; L400E, b4=1 selects use of table
;
;	usecs = val x 15.26	;usec PW
;
L496F   FCB 26			; 488 
	FCB 26			; 732
	FCB 26  		; 976
	FCB 26			;1220
	FCB 26			;1460
	FCB 26			;1708
	FCB 26			;1950
	FCB 26			;2197
	FCB 26			;2440
	FCB 26			;2685
	FCB 26			;2929
	FCB 26			;3170
	FCB 26			;3410
	FCB 26			;3660
	FCB 26			;3900 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-BPW mult. vs. fuel pump volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val/128		
;
L497E   FCB  128		; 0.0
	FCB  128    		; 1.6
	FCB  160		; 3.2
	FCB  160		; 4.8
	FCB  160		; 6.4
	FCB  147		; 8.0
	FCB  147    		; 9.6
	FCB  141    		;11.2
	FCB  137   		;12.8
	FCB  128		;14.4
	FCB  126		;16.0
	FCB  122		;17.6
	FCB  120		;19.2
	FCB  118		;20.8
	FCB  116		;22.4
	FCB  114		;24.0
	FCB  112		;25.6
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Cat overtemp AFR limit vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	AFR = val/10		;gms/sec
;
L498F   FCB  145		;  0
	FCB  130		; 16
	FCB  130		; 32
	FCB  128		; 48
	FCB  128		; 64
	FCB  128		; 80
	FCB  128		; 96
	FCB  128		;112
	FCB  128		;128
	FCB  128		;144
	FCB  128		;160
	FCB  128		;176
	FCB  128		;192
	FCB  128		;208
	FCB  128		;224
	FCB  128		;240
	FCB  128		;256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-BPW alt. correction factor table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L49A0	FCB   0         ;10 kPa MAP, min row value
    	FCB   96        ;75 kPa baro, min col. value
    	FCB   4         ;# cols per row
;
; BPW corr. factor = value/128
;
;  baro kPa:  75   85   95  105 ;MAP kPa
;
	FCB  155, 137, 128, 128 ;10
	FCB  155, 136, 128, 128 ;20
	FCB  148, 135, 128, 128 ;30
	FCB  146, 134, 128, 128 ;40 
	FCB  145, 130, 128, 128 ;50
	FCB  138, 128, 128, 128 ;60
	FCB  135, 128, 128, 128 ;70
	FCB  135, 128, 128, 128 ;80
	FCB  135, 128, 128, 128 ;90
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Alt. comp. value for MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; kPa = .625 x val + 5
;
;				;baro kPa
;	
L49C7	FCB 120			; 79.2
	FCB 136			; 89.2
	FCB 152			; 99.6
	FCB 168			;110.4
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Open throttle VE table
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L49CB	FCB   16		;400 RPM, min row val. for lookup
	FCB   0			;0 kPa, min MAP val. for lookup
	FCB   11		;# cols per row
;
; VE = val. x .390
;
;	kPa:  20   25	  30    35    40    50    60    70    80    90   100 ; RPM
;
	FCB   80,  105,  118,  130,  135,  159,  161,  167,  173,  180,  200 ; 400 
	FCB   95,  116,  144,  163,  173,  177,  183,  186,  190,  197,  210 ; 800
	FCB  122,  151,  175,  188,  190,  197,  207,  206,  210,  212,  214 ;1200
	FCB  143,  183,  193,  197,  212,  219,  225,  225,  225,  226,  220 ;1600
	FCB  150,  199,  204,  208,  210,  218,  224,  232,  232,  232,  235 ;2000
	FCB  150,  205,  210,  212,  214,  225,  232,  242,  242,  242,  240 ;2400
	FCB  150,  207,  210,  214,  215,  225,  235,  237,  238,  238,  235 ;2800
	FCB  153,  190,  205,  211,  212,  224,  242,  240,  240,  242,  242 ;3200
	FCB  150,  185,  190,  197,  207,  224,  230,  236,  240,  240,  245 ;3600
	FCB  125,  185,  190,  195,  207,  222,  235,  233,  231,  233,  220 ;4000
	FCB  125,  185,  190,  190,  203,  215,  220,  225,  230,  230,  230 ;4400
	FCB  125,  185,  190,  190,  193,  205,  210,  215,  220,  222,  222 ;4800
	FCB  125,  166,  190,  192,  193,  205,  210,  225,  230,  236,  236 ;5200
	FCB  125,  166,  190,  192,  193,  205,  210,  225,  230,  236,  236 ;5600
	FCB  125,  166,  190,  192,  193,  205,  210,  225,  230,  236,  236 ;6000
	FCB  125,  166,  190,  192,  193,  205,  210,  225,  230,  236,  236 ;6400
;
;~~~~~~~~~~~~~~~
;-Idle VE table
;~~~~~~~~~~~~~~~
;
L4A7E	FCB   32		;400 RPM, min row val. for lookup
	FCB   0			;20 kPa, min col. val. for lookup
	FCB   11		;# cols. per row
;
; VE = val. x .390
;
;	kPa:  20   25	  30    35    40    50    60    70    80    90   100 ; RPM
;
	FCB   85,  113,  128,  132,  135,  156,  161,  167,  173,  180,  200 ; 400
	FCB   95,  115,  137,  149,  153,  166,  175,  185,  186,  195,  205 ; 600
	FCB  105,  127,  156,  165,  168,  172,  189,  195,  200,  210,  210 ; 800
	FCB  115,  148,  177,  180,  179,  185,  199,  203,  208,  217,  212 ;1000
	FCB  128,  166,  195,  197,  198,  203,  209,  212,  217,  224,  214 ;1200
	FCB  138,  177,  197,  200,  201,  210,  214,  218,  223,  226,  218 ;1400
	FCB  146,  192,  202,  206,  207,  218,  219,  224,  230,  229,  222 ;1600
	FCB  151,  195,  205,  207,  210,  219,  223,  227,  233,  231,  227 ;1800
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-MAT/CTS blend multiplier vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Larger multiplier = more CTS blended into MAT
;
;	Mult = val/128		;g/sec
;
L4AD9   FCB  0			;  0
	FCB  0			; 16
	FCB  0			; 32
	FCB  0			; 48
	FCB  0			; 64
	FCB  0			; 80
	FCB  0			; 96
	FCB  0			;112
	FCB  0			;128
	FCB  0			;144
	FCB  0			;160
	FCB  0			;176
	FCB  0			;192
	FCB  0			;208
	FCB  0			;224
	FCB  0			;240
	FCB  0			;256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Inverse air density @ sea level vs. blended intake temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; l/g = (value x 128 + 29824) / 45064
;
;	val.			;Deg C
;
L4AEA   FCB  0			;-40
	FCB  12			;-28           
	FCB  24			;-16            
	FCB  36			;- 4            
	FCB  48			;  8            
	FCB  60			; 20         
	FCB  72			; 32           
	FCB  84			; 44
	FCB  96			; 56
	FCB  108		; 68          
	FCB  120		; 80          
	FCB  132		; 92          
	FCB  144		;104          
	FCB  156		;116          
	FCB  168		;128          
	FCB  180		;140         
	FCB  192		;152          
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Injector offset vs. batt volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	usecs = val x 15.26	;Batt. volts	
;
L4AFB   FCB  26			; 0.0
	FCB  26			; 1.6
	FCB  50			; 3.2
	FCB  50 		; 4.8
	FCB  48			; 6.4
	FCB  37			; 8.0
	FCB  31			; 9.6
	FCB  26			;11.2
	FCB  26			;12.8
	FCB  26			;14.4
	FCB  22			;16.0
	FCB  19			;17.6
	FCB  19			;19.2
	FCB  19			;20.8
	FCB  19			;22.4
	FCB  19			;24.0
	FCB  19			;25.6
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decel enlean factor vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4B0C   FCB 8			;9 line table
;
;	factor = val/32		;Deg C
;    		
L4B0D   FCB  96			;-40
	FCB  80			;-16
	FCB  64			;  8
	FCB  48			; 32
	FCB  32			; 56
	FCB  32			; 80
	FCB  32			;104
	FCB  30			;128
	FCB  28			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decel enlean PW reduction vs. delta MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%reduction = 
;	val x .396		;kPa
;
L4B16   FCB  0			; 0
	FCB  16			; 5
	FCB  32			;10
	FCB  36			;15
	FCB  40			;20
	FCB  48			;25
	FCB  56			;30
	FCB  64			;35
	FCB  72			;40
	FCB  80			;45
	FCB  88			;50
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decel enlean PW redcutcion vs. delta TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%reduction =
;	val x .396		;% TPS
;
L4B21   FCB  0 			;  0.0
	FCB  13			;  6.3
	FCB  26			; 12.5
	FCB  38			; 18.8
	FCB  51			; 25.0
	FCB  77			; 31.3
	FCB  102		; 37.5
	FCB  102		; 43.8
	FCB  102		; 50.0
	FCB  102		; 56.3
	FCB  102		; 62.5
	FCB  102		; 68.8
	FCB  102		; 75.0
	FCB  102		; 81.3
	FCB  102		; 87.5
	FCB  102		; 93.8
	FCB  102		;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-MAP filter coeff. vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Filter coeff.		;Deg C
;
L4B32   FCB  18     		;-28
	FCB  22     		;-16
	FCB  24     		; -4
	FCB  28     		;  8
	FCB  35     		; 20
	FCB  40     		; 32
	FCB  45     		; 44
	FCB  49     		; 56
	FCB  52     		; 68
	FCB  55     		; 80
	FCB  57     		; 92
	FCB  59     		;104
	FCB  63     		;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Sync accel enrich vs. delta MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4B3F	FCB  4			;5 line table
;
	FCB  5			; 0
	FCB  10			;20
	FCB  12			;40
	FCB  17			;60
	FCB  20			;80
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Accel enrich vs. delta TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	usecs = val x 15.26	;Delta %TPS
;
L4B45   FCB  1			; 0.0
	FCB  8			; 3.1
	FCB  15			; 6.3
	FCB  30			; 9.4
	FCB  35			;12.5
	FCB  38			;15.6
	FCB  41			;18.8
	FCB  44			;21.9
	FCB  47			;25.0
	FCB  49			;28.1
	FCB  51			;31.3
	FCB  53			;34.4
	FCB  55			;37.5
	FCB  57			;40.6
	FCB  62			;43.8
	FCB  66			;46.9
	FCB  69			;50.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Delta TPS AE mult. factor vs. Baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Factor=val/128		;kPa		
;
L4B56	FCB 99			; 80
	FCB 121			; 90
	FCB 128			;100
	FCB 128			;110
;

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-AE TPS filter coeff. vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	corr. = val/256		;Deg C
;
L4B5A	FCB  38     		;-28
	FCB  40 		;-16
	FCB  42     		; -4
	FCB  44     		;  8
	FCB  46     		; 20
	FCB  56     		; 32
	FCB  64     		; 44
	FCB  76     		; 56
	FCB  102    		; 68
	FCB  128    		; 80
	FCB  150    		; 92
	FCB  160    		;104
	FCB  165    		;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Async accel enrich temp correction vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	factor=val/32		;Deg C
;
L4B67   FCB  192		;-40
	FCB  172		;-28
	FCB  163		;-16
	FCB  153		; -4
	FCB  132		;  8
	FCB  110		; 20
	FCB  93			; 32
	FCB  70			; 44
	FCB  54			; 56
	FCB  43			; 68
	FCB  33			; 80
	FCB  32			; 92
	FCB  32			;104
	FCB  24			;116
	FCB  24			;128
	FCB  24			;140
	FCB  24			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS accel entrich temp correction factor vs. MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Factor = val/128	;Dec C	
;
L4B78   FCB  128		;-40
	FCB  128		;-28
	FCB  128		;-16
	FCB  128		; -4
	FCB  128		;  8
	FCB  128		; 20
	FCB  128		; 32
	FCB  128		; 44
	FCB  128		; 56
	FCB  128		; 68
	FCB  128		; 80
	FCB  128		; 92
	FCB  128		;104
	FCB  128		;116
	FCB  128		;128
	FCB  128		;140
	FCB  128		;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Sync Accel enrich temp correction vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val/32		;Cool temp
;
L4B89   FCB  160		;-40
	FCB  144		;-28
	FCB  128		;-16
	FCB  112		;- 4
	FCB  96			;  8
	FCB  88			; 20
	FCB  72			; 32
	FCB  56			; 44
	FCB  48			; 55
	FCB  40			; 67
	FCB  34			; 80
	FCB  32			; 91
	FCB  32			;103
	FCB  28			;115
	FCB  24			;127
	FCB  24			;139
	FCB  24			;150
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Delta MAP AE mult. vs RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4B9A   FCB  128		;3200 RPM, upper lim for lookup
;
;	mult = val/128		;RPM	
;
L4B9B   FCB  215		; 400
	FCB  144		; 800
	FCB  107		;1200
	FCB  78			;1600
	FCB  62			;2000
	FCB  50			;2400
	FCB  45			;2800
	FCB  38			;3200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Lean open loop AFR limit vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		AFR x 10	;Deg C
;
L4BA3   FCB	120		;-40
	FCB	123    		;-28
	FCB	125    		;-16
	FCB	126    		; -4
	FCB	128    		;  8
	FCB	132    		; 20
	FCB	135    		; 32
	FCB	146    		; 44
	FCB	146    		; 56
	FCB	146    		; 68
	FCB	146    		; 80
	FCB	146    		; 92
	FCB	146    		;104
;
;~~~~~~~~~~~~~~~~~~~~~
;-Open loop AFR table
;~~~~~~~~~~~~~~~~~~~~~
;
L4BB0   FCB   0			;Opt bit for lookup, 0=Vac, 1=MAP
;
	FCB   0 		;0 deg C, min row val. for lookup
        FCB   0			;0 kPa, min vac/map val for lookup
        FCB   9			;# of cols. per row
;
;	Vac: 80   70   60   50   40   30   20   10    0 ;Deg C
;	
	FCB 125, 125, 125, 125, 125, 120, 115, 105,  95 ;-40 
	FCB 130, 130, 130, 130, 130, 125, 120, 110, 100 ;-28
	FCB 132, 132, 132, 132, 132, 127, 122, 112, 102 ;-16
	FCB 140, 140, 140, 140, 140, 135, 130, 120, 110 ;- 4
	FCB 145, 145, 145, 145, 145, 140, 135, 125, 115 ;  8
	FCB 160, 160, 160, 150, 145, 140, 140, 135, 130 ; 20
	FCB 160, 160, 160, 150, 145, 140, 140, 135, 130 ; 32
	FCB 160, 160, 160, 150, 145, 140, 140, 135, 130 ; 44
	FCB 160, 160, 160, 150, 145, 140, 140, 135, 130 ; 56
	FCB 160, 160, 160, 155, 150, 145, 140, 140, 130 ; 68
	FCB 160, 160, 160, 155, 150, 145, 140, 140, 130 ; 80
	FCB 160, 160, 160, 155, 150, 145, 140, 140, 130 ; 92
	FCB 160, 160, 160, 155, 150, 145, 140, 140, 130 ;104
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke AFR vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; AFR is subtracted out to enrich the initial AFRs after startup
;
;	AFR = val/10		;Deg C
;
L4C29   FCB  80			;-40
	FCB  75			;-28
	FCB  70			;-16
	FCB  65			; -4
	FCB  50			;  8
	FCB  35			; 20
	FCB  30			; 32
	FCB  30			; 44
	FCB  30			; 56
	FCB  25			; 68
	FCB  20			; 80
	FCB  20			; 92
	FCB  20			;104
	FCB  20			;116
	FCB  20			;128
	FCB  20			;140
	FCB  20			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke AFR decay period vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	period = 5/val		;Deg C
;
L4C3A   FCB  14			;-40
	FCB  14			;-28
	FCB  14			;-16
	FCB  12			; -4
	FCB  11			;  8
	FCB  11			; 20
	FCB  11			; 32
	FCB  11			; 44
	FCB  10			; 56
	FCB  10			; 68
	FCB  10			; 80
	FCB  10			; 92
	FCB  10			;104
	FCB  10			;116
	FCB  10			;128
	FCB  10			;140
	FCB  10			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke AFR decay period mult. vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult = val/128		;gms/sec
;
L4C4B   FCB  166		; 0
	FCB  134		;16
	FCB  96			;32
	FCB  64			;48
	FCB  32			;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS threshold for WOT vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; PE entry is also expedited when TPS is above these
; values
;        		
L4C50   FCB 160			; 4000 RPM UPPER LMT
;
;	%TPS = 
;	value/.391		;RPM
;
	FCB  128		; 800
	FCB  192		;1200
	FCB  217		;1600
	FCB  217		;2000
	FCB  217		;2400
	FCB  217		;2800
	FCB  217		;3200
	FCB  217		;3600
	FCB  217		;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS threshold for PE enable vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4C5A   FCB  160    		;4000 RPM, UL for lookup
;
;	%TPS = val / .391	;RPM	
;
	FCB  102		; 800
	FCB  154		;1200
	FCB  141		;1600
	FCB  110		;2000
	FCB  110		;2400
	FCB  92			;2800
	FCB  92			;3200
	FCB  92			;3600
	FCB  85			;4000
;
;~~~~~~~~~~~~~~~~
;-PE AFR vs. RPM
;~~~~~~~~~~~~~~~~
;
;	AFR=val/10		;RPM		
;
L4C64   FCB  122		;   0
	FCB  122		; 400
	FCB  123		; 800
	FCB  124		;1200
	FCB  125		;1600
	FCB  126		;2000
	FCB  124		;2400
	FCB  121		;2800
	FCB  121		;3200
	FCB  124		;3600
	FCB  125		;4000
	FCB  126		;4400
	FCB  126		;4800
	FCB  126		;5200
	FCB  126		;5600
	FCB  126		;6000
	FCB  126		;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Fast PE entry delay reduction vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
L4C75   FCB 160			; 4000 RPM, upper limit for lookup
;
; Table represents fraction of time needed
; to enter PE relative to the time normally 
; needed. A value of 10 would be 1/10 the 
; time needed to normally enter PE when 
; these values are used instead to compute 
; the delay for PE. Value @ L490F deterimines
; time to enter/exit PE
;
;	Fract = 1/val		;RPM	
;
L4C76   FCB  50			; 800
	FCB  25			;1200
	FCB  25			;1600
	FCB  25			;2000
	FCB  25			;2400
	FCB  25			;2800
	FCB  25			;3200
	FCB  25			;3600
	FCB  25			;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-PE TPS baro factor vs baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Factor is delta TPS needed
; to bypass PE delay
;
;	delta TPS=
;	val/.391		;kPa
;
L4C7F   FCB 254			; 80
        FCB 254			; 90
        FCB 254			;100
        FCB 254			;110
;

    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Min DFCO RPM vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	RPM/25			;Deg C
;
L4C83   FCB  68     		;-28
	FCB  68     		; -4
	FCB  62     		; 20
	FCB  54     		; 44
	FCB  48     		; 68
	FCB  48     		; 92
	FCB  48     		;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS threshold for DFCO vs. RPMs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4C8A   FCB 144			;3600 RPM, UL for lookup 
;
;	%TPS = val x .369	;RPM
;
	FCB  3			; 800
	FCB  4			;1200
	FCB  5			;1600
	FCB  7			;2000
	FCB  10			;2400
	FCB  13			;2800
	FCB  13			;3200
	FCB  13			;3600
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Crank to run transition AFR vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Added or subtracted depending on cool temp threshold in L4957
;
;	AFR = val/10		;Deg C	
;
L4C93   FCB  180		;-40
	FCB  170		;-28
	FCB  160		;-16
	FCB  150		; -4
	FCB  100		;  8
	FCB  90			; 20
	FCB  85			; 32
	FCB  80			; 44
	FCB  65			; 56
	FCB  60			; 68
	FCB  50			; 80
	FCB  0			; 92
	FCB  0			;104
	FCB  0			;116
	FCB  0			;128
	FCB  0			;140
	FCB  0			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank to run AFR decay rate vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 	AFR=val./10   		;Deg C
;
L4CA4	FCB  20			;-40
	FCB  20     		;-28
	FCB  20     		;-16
	FCB  20     		; -4
	FCB  20     		;  8
	FCB  20     		; 20
	FCB  20     		; 32
	FCB  20     		; 44
	FCB  20     		; 56
	FCB  20    		; 68
	FCB  20     		; 80
	FCB  20     		; 92
	FCB  20     		;104
	FCB  10     		;116
	FCB  10     		;128
	FCB  10     		;140
	FCB  10     		;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank to run AFR decay delay DRPs vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Elapsed DRPs		;Deg C
;
L4CB5   FCB  12			;-40
	FCB  12			;-28
	FCB  12			;-16
	FCB  10			; -4
	FCB  8			;  8
	FCB  6			; 20
	FCB  6			; 32
	FCB  6			; 44
	FCB  6			; 56
	FCB  6			; 68
	FCB  5			; 80
	FCB  0			; 92
	FCB  0			;104
	FCB  0			;116
	FCB  0			;128
	FCB  0			;140
	FCB  0			;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank to run AFR decay delay counts multiplier vs DRPs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val./256	;Accumulated DRPs prior to run
;
L4CC6   FCB  0			; 0
	FCB  128		; 4
	FCB  192		; 8
	FCB  204		;12
	FCB  255		;16
	FCB  255		;20
	FCB  255		;24
	FCB  255		;28
	FCB  255		;32 
	FCB  255		;36
	FCB  255		;40
	FCB  255		;44
	FCB  255		;48
	FCB  255		;52
	FCB  255		;56
	FCB  255		;60
	FCB  255		;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Integrator delay vs. scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	msec=valx25		;Airflow counts
;
L4CD7   FCB  16			;  0
	FCB  15			; 16
	FCB  14			; 32
	FCB  13			; 48
	FCB  12			; 64
	FCB  11			; 80
	FCB  10			; 96
	FCB  9			;112
	FCB  8			;128
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Mean rich/lean threshold vs. scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mV=val x 4.34		;Airflow counts
;	
L4CE0   FCB  102		;  0
	FCB  100		; 16
	FCB  98			; 32
	FCB  98			; 48
	FCB  98			; 64
	FCB  98			; 80
	FCB  98			; 96
	FCB  98			;112
	FCB  98			;128
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Rich O2 threshold vs. scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mV=val x 4.34		;Airflow counts
;
L4CE9   FCB  102		;  0
	FCB  100		; 16
	FCB  98			; 32
	FCB  98			; 48
	FCB  98			; 64
	FCB  98			; 80
	FCB  98			; 96
	FCB  98			;112
	FCB  98			;128
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Lean O2 threshold vs. scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mV=val x 4.34		;Airflow counts
;
L4CF2   FCB  102		;  0
	FCB  100		; 16
	FCB  98			; 32
	FCB  98			; 48
	FCB  98			; 64
	FCB  98			; 80
	FCB  98			; 96
	FCB  98			;112
	FCB  98			;128
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Slow O2 filter coeff. vs scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	filter coeff.		;Airflow counts
;
L4CFB   FCB  2			;  0
	FCB  3			; 16
	FCB  4			; 32
	FCB  5			; 48
	FCB  6			; 64
	FCB  9			; 80
	FCB  11			; 96
	FCB  13			;112
	FCB  14			;128
;
;* Note: See 493F for grams/sec airflow scalar used 
;        to scale the airflow for table lookups.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Base proportional counts vs. O2 error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Counts			;O2 error counts
;
L4D04   FCB  4			; 0
	FCB  4			; 8
	FCB  4			;16
	FCB  4			;24
	FCB  4			;32
	FCB  4			;40
	FCB  4			;48
	FCB  5			;56
	FCB  7			;64
	FCB  8			;72
	FCB  9			;80
	FCB  10			;88
	FCB  11			;96
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Proportional duration vs. O2 error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	msec=val x 25		;Error counts
;
L4D11   FCB  20			; 0
	FCB  40			; 8
	FCB  60			;16
	FCB  80			;24
	FCB  100		;32
	FCB  128		;40
	FCB  255		;48
	FCB  255		;56
	FCB  255		;64
	FCB  255		;72
	FCB  255		;80
	FCB  255		;88
	FCB  255		;96
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added proportional duration vs. scaled airflow*
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	msec=val x 25		;Airflow counts
;
L4D1E   FCB  5			;  0
	FCB  10			; 16
	FCB  20			; 32
	FCB  255		; 48
	FCB  255		; 64
	FCB  255		; 80
	FCB  255		; 96
	FCB  255		;112
	FCB  255		;128
;
;* Note: See 493F for grams/sec airflow scalar used 
;        to scale the airflow for table lookups.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Proportional flow gain factor table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4D27   FCB   16		;400 RPM, min row val. for lookup 
        FCB   0			;20 kPa, min col. val. for lookup
        FCB   9			;# cols. per row
;
;       kPa: 20   30   40   50   60   70   80   90  100 ;RPM	
;
	FCB  12,  48,  64, 128, 128, 128, 128, 128, 128	; 400
	FCB  14,  56,  96, 128, 128, 128, 128, 128, 128 ; 800
	FCB  16,  64, 128, 128, 128, 128, 128, 128, 128 ;1200
	FCB  18,  64, 128, 128, 128, 128, 128, 128, 128 ;1600
	FCB  36, 128, 128, 128, 128, 128, 128, 128, 128 ;2000
	FCB  64, 128, 128, 128, 128, 128, 128, 128, 128 ;2400 
	FCB 128, 128, 128, 128, 128, 128, 128, 128, 128 ;2800 
	FCB 128, 128, 128, 128, 128, 128, 128, 128, 128 ;3200 
	FCB 128, 128, 128, 128, 128, 128, 128, 128, 128 ;3600 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Integrator delay mult. vs. O2 error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult.=val/256		;O2 error
;
L4D7B  	FCB   255		; 0
	FCB   255		; 8
	FCB   255		;16 
	FCB   255		;24
	FCB   255		;32
	FCB   255		;40
	FCB   255		;48
	FCB   255		;56
	FCB   232		;64
	FCB   212		;72
	FCB   192		;80
	FCB   172		;88
	FCB   152		;96
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Inj./engine constants
;~~~~~~~~~~~~~~~~~~~~~~~
;
L4D88   FDB  6300		;7.69 g/s, injector flowrate
L4D8A   FCB  159		;.7125L, cylinder volume
;
;~~~~~~~~~~~~~~~~~~~
;-Crank fuel params
;~~~~~~~~~~~~~~~~~~~
;
L4D8B   FCB 15			;DRP threshold to use RPM based crank fuel multipliers
L4D8C   FCB 2			;Init crank DRP counter to 2 on bad shutdown
L4D8D   FCB 2			;2 DRPs, DRP counter limit for fuel pump relay failure
L4D8E   FCB 40			;4 volts, lower FP voltage limit to allow DRP counter to update
L4D8F   FCB 33			;-15 deg C, threshold for cold cranking
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank PW vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L4D90   FDB 8093		;Scalar for table
;
;	msecs = 
;	[(val x scalar)/256] x	;Deg C
;	15.26 x 10^-3	
;
L4D92   FCB  254		;-40
	FCB  225		;-28
	FCB  195		;-16
	FCB  165		;- 4
	FCB  140		;  8
	FCB  110		; 20
	FCB  80			; 32
	FCB  53			; 44
	FCB  47			; 56
	FCB  40			; 68
	FCB  32			; 80
	FCB  28			; 92
	FCB  18			;104
	FCB  17			;116
	FCB  15			;128
	FCB  15			;140
	FCB  14			;152
;	
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank fuel mult vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val/256		;RPM
;
L4DA3  	FCB   255		;  0
	FCB   255		;100
	FCB   192		;200
	FCB   192		;300
	FCB   192		;400
	FCB   192		;500
	FCB   128		;600
	FCB   128		;700
	FCB   128		;800
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Hot restart crank fuel mult. vs RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val/256		;RPM
;
L4DAC  	FCB   255   		;  0
	FCB   255   		;100
	FCB   166   		;200
	FCB   166   		;300
	FCB   128   		;400
	FCB   128   		;500
	FCB   128   		;600
	FCB   128   		;700
	FCB   128   		;800
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank fuel mult. vs. baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	mult. = val / 128	;kPa
;
L4DB5   FCB  96			; 75
	FCB  115		; 85
	FCB  128		; 95
	FCB  134		;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Crank fuel mult. vs TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4DB9	FCB   8			;9 line table
;
;	mult. = val./64
;
L4DBA  	FCB   64		;  0.0
	FCB   67		; 12.5
	FCB   70		; 25.0
	FCB   80		; 37.5
	FCB   83		; 50.0
	FCB   83		; 62.5
	FCB   32		; 75.0
	FCB   3			; 87.5
	FCB   2			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cranking fuel delay vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Delay			;Deg C
;
L4DC3   FCB	0		;-40
	FCB	0		;-28
	FCB	0		;-16
	FCB	0		; -4
	FCB	0		;  8
	FCB	0		; 20
	FCB	0		; 32
	FCB	0		; 44
	FCB	0		; 56
	FCB	0		; 68
	FCB	0		; 80
	FCB	0		; 92
	FCB	0		;104
	FCB	0		;116
	FCB	0		;128
	FCB	0		;140
	FCB	0		;152
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Uses any one of the following tables, depending on the conditions
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cold crank PW mult. vs DRPs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
; Based on cranking fuel counter #2
;
; Temperature < threshold in L4D8F
;
;	Mult. = val./128	;DRPs
;
L4DD4   FCB	230		; 1
	FCB	209		; 2
	FCB	188		; 3
	FCB	166		; 4
	FCB	145		; 5
	FCB	124		; 6
	FCB	103		; 7
	FCB	 83		; 8
	FCB	 79		; 9
	FCB	 75		;10
	FCB	 70		;11
	FCB	 64		;12
	FCB	 60		;13
	FCB	 56		;14
	FCB	 53		;15
	FCB	 51		;16
	FCB	 51		;17
	FCB	 51		;18
	FCB	 51		;19
	FCB	 51		;20
	FCB	 51		;21
	FCB	 51		;22
	FCB	 51		;23
	FCB	 51		;24
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Non hot restart crank PW fuel mult. vs DRPs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
; Based on cranking fuel counter #2
;
; Temperature >= threshold in L4D8F
;
;	mult. = val./128	;DRPs
;
L4DEC   FCB	192    		; 1
	FCB	166    		; 2
	FCB	128    		; 3
	FCB	 83		; 4
	FCB	 60		; 5
	FCB	 56		; 6
	FCB	 52		; 7
	FCB	 44		; 8
	FCB	 42		; 9
	FCB	 41		;10
	FCB	 39    		;11
	FCB	 38    		;12
	FCB	 38    		;13
	FCB	 38    		;14
	FCB	 38    		;15
	FCB 	 38    		;16
	FCB	 38    		;17
	FCB	 38    		;18
	FCB	 38    		;19
	FCB	 38    		;20 
	FCB	 44    		;21
	FCB	 50    		;22
	FCB	 57    		;23
	FCB	 64    		;24
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Hot restart crank PW mult. vs DRPs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Based on cranking fuel counter #2
;
;	mult. = val./128	;DRPs
;
L4E04  	FCB	128		; 1
	FCB	100   		; 2
	FCB   	 70    		; 3
	FCB   	 60    		; 4
	FCB   	 50    		; 5
	FCB   	 45    		; 6
	FCB   	 40    		; 7
	FCB   	 38    		; 8
	FCB   	 38    		; 9
	FCB   	 38    		;10
	FCB   	 38    		;11
	FCB   	 38    		;12
	FCB   	 38    		;13
	FCB   	 38    		;14
	FCB   	 38    		;15
	FCB   	 38    		;16
	FCB   	 40    		;17
	FCB   	 41    		;18
	FCB   	 43    		;19
	FCB   	 44    		;20
	FCB   	 46    		;21
	FCB   	 48    		;22
	FCB   	 50    		;23
	FCB   	 51    		;24
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cycling crank PW mult. vs DRPs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Based on DRP counter #2, use when DRPs > 23
; 
;	Mult. = val./128	;DRPs, lower 3 bits of counter
;
L4E1C	FCB	 64		;0   
	FCB	 52    		;1   
	FCB	 44    		;2   
	FCB	 38    		;3   
	FCB	 35    		;4   
	FCB	 34    		;5   
	FCB	 33    		;6   
	FCB	 32    		;7   
;
;***********************************************
;* DIAGNOSTICS
;*  MY 94, TYPE $0D ECM
;***********************************************
;----------------------------------------------
;    ECM TYPE $0D
;----------------------------------------------
L4E24	FCB 10			; ERR LOG CNST 1, 1.0 SEC'S     
L4E25   FCB 20			; ERR LOG CNST 2, 2.0 SEC'S   
L4E26	FCB 100			; ERR LOG CNST 3, 10 SEC'S 
L4E27	FCB 120			; ERR LOG CNST 4, 12 SEC'S  
;
;------------------------
; ERROR 13
; o2 SENSOR
;------------------------
;
L4E28   FCB 60			; TIME SINCE RUN LIMIT, 120 Sec
L4E29   FCB 10			; 1 SEC MAX DECEL CUT OFF TIME ACCUM
L4E2A   FCB 1			; 100 msec LOWER DECEL CUT OFF TIME THRESH
;
L4E2B   FCB 81			; 351 MV DC, o2 SENSOR LOW LIMIT   
L4E2C   FCB 127			; 551 MV DC, o2 SENSOR HIGH LIMIT
;
L4E2D   FCB 13			; 5%, TPS LIMIT
L4E2E   FCB 30			; 60 Sec, TIME LIMIT
L4E2F	FCB 147			; 70c, WARM (COOL) ENABLE
;
;------------------------
; ERR 16
;  2002 PPM Vss FAIL
;------------------------
;
L4E30   FCB 2			; 2 MPH, Vss LMT
;
L4E31   FCB 38			;  950 RPM LO LMT (RPM RANGE)
L4E32   FCB 176			; 4400 RPM HI LMT
;
L4E33   FCB 15			; 16 Kpa MAP LMT
L4E34   FCB 140			; 65 DEG c, COOL LMT
L4E35   FCB 3			; 3 sec TIME LMT
L4E36   FCB 5			; 2% MAX TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Threshold for setting error 23, low MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E37   FCB 0			;-40 deg C, lower MAT threshold to set error 23 
L4E38   FCB 0			;0 sec, sec = value/10, time threshold to flag error 23 
;       
;--------------------------
; ERR 24 MAN XMISSION ONLY
;--------------------------
;
L4E39   FCB 10			; 1 SEC 
L4E3A   FCB 10			; 10 MPH MAX FOR ERR TMR INCR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Error 23, low MAT, and error 25, high MAT, params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E3B   FDB 0000		;Engine run time, time before performing MAT diags.
L4E3D   FCB 0			;0 MPH, boundry for errors 23 and 25
L4E3E   FCB 0			;-40c, default MAT if error is flagged
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Threshold for setting error 25, high MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E3F   FCB 0			;-40 deg C, upper MAT threshold to set error 25 
L4E40   FCB 0			;0 sec, sec = value/10, time threshold to flag error 23
;
;----------------------------------------------
; ERR 31
;----------------------------------------------
;
L4E41   FCB 0			; 0% D.C. IF GOV INTEGRAL E.Q. or G.T.   
;
;----------------------------------------------
; ERR 32    
; EGR Diag & Err calib
;  TYPE $0D, 5.7l
;----------------------------------------------
;
L4E42   FCB 30			; 30 SEC DIAG CYCLE TIME
;
L4E43   FCB 64			; 34.0 Kpa Low Load EGR TEST disable, (68 Kpa VAC)		 
L4E44   FCB 208			; 87.1 Kpa Hi  load EGR TEST disable, (15 Kpa VAC)
;
L4E45   FCB 15			;  6% Low TPS EGR TEST Disable
L4E46   FCB 77			; 30%  Hi TPS EGR TEST Disable
;
L4E47   FCB 243			; 95% Desired required EGR TEST Err test
;
L4E48   FCB 30			; 3 sec's Err delay timer
L4E49   FCB 3			; 3 Fail counter min
;
L4E4A   FCB 10			; 4% diff TPS to escape EGR test
L4E4B   FCB 25			; 2.5 Sec's integrator test time
L4E4C   FCB 4			; 4 integrator count for err
;
L4E4D   FCB 45			; 45 MPH min for EGR test
;
L4E4E   FCB 12			;300 msec INTegrator delay if EGR diags. underway
;
;----------------------------------------------
; ERR 32B
; LINEAR EGR POSIT FAIL
;----------------------------------------------
;
L4E4F   FCB 0			; 0 A/D PINTLE SETTING   
L4E50   FCB 0			; 0% PINTLE POSIT ERROR
L4E51   FCB 0			; 0  SEC'S TIME THRESH
;
L4E52   FCB 0			; 0% POSIT ERR LMT
L4E53   FCB 0			; 0 Sec's TIME BETWEEN TESTS
L4E54   FCB 0			; 0 Sec's SET ERR IF A/D POSIT L.T. REQ  
L4E55   FCB 0			; 0 Sec's x 2
;
;------------------------
; ERR 33
; ERR 33, MAP SENSOR HI
;------------------------
;
L4E56   FCB 10			; 4% TPS limit
L4E57   FCB 156			; 67.9 Kpa MAP Lmt
L4E58   FCB 50			; 5 Sec's time Lmt
L4E59   FCB 0			; 0 RPM 
;
;------------------------
; ERR 34
; Low MAP Err
;------------------------
;
L4E5A   FCB 5			; 12.2 Kpa MAP Lmt 
L4E5B   FCB 64			; 1200 RPM Max Lmt
L4E5C   FCB 50			; 625 Msec time Lmt
L4E5D   FCB 20			; 8% TPS MAX Lmt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Default MAP params, use when low/high MAP error in effect
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E5E   FCB 218			;91 kPa, default MAP if not running/UL for default MAP value
L4E5F   FCB 112     		;1.75, default MAP TPS coeff.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Default MAP bias vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E60	FCB 64			;3200 RPM, UL for lookup
;
;	Bias val.		;RPM
;
        FCB 90      		; 800 
        FCB 35      		;1600
        FCB 7       		;2400  
        FCB 2       		;3200  
;
;------------------------
; ERR 41
; CAM PULSE ERROR
;------------------------
;
L4E65   FCB 0			; DRP'S W/O CAM PULSE
;
;---------------------
; ERROR 42 EST FAIL
;---------------------
;
L4E66	FCB 4			; RPM LIMIT, 450 RPM
L4E67	FCB 0			;0 counts, delta EST info counter value to set error
L4E68	FCB 4			; NUM EST ERR'S FR 42A
L4E69	FCB 4			; NUM EST FAULT FOR 42B
				; OPEN or GROUNDED BYPASS LINE
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Error 43 params, knock sensor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E6A	FCB 160			;16 sec. time threshold to set error
L4E6B   FCB 230			;4.5 volts, upper threshold to set error 
L4E6C   FCB 20			;0.390 volts. lower threshold to set error 
L4E6D   FCB 23			;4 deg, default SA for knock sensor failure
;
;---------------------
; ERROR 44
; o2 LEAN
;---------------------
;
L4E6E   FCB 34			; 148 Mv LOW o2 SENSOR LMT
L4E6F   FCB 20			; 20  SEC'S ERR TIME LMT
L4E70   FCB 200			; 400 SEC'S ERR PART 2 TIME LMT
L4E71	FCB 146			;14.6 AFR, lean AFR limit if error 44 present
;
;------------------------
; ERR 45
; HIGH o2 SENSOR 
;------------------------
;
L4E72   FCB 255			; 151 DEG c, 
L4E73   FCB 173			; 750 Mv, o2 HI LMT
L4E74   FDB 0060		; 60 SEC'S ERR TIME LMT
				; CAL = SECS
;
L4E76   FDB 0060		; 60 SEC'S ERR TIME LMT
				; CAL = SECS
;
L4E78   FCB 13			; 5% TPS HI LMT
L4E79   FCB 0			; 0% TPS LOW LMT
;
;------------------------
; ERR 46
; VATS ERROR
;------------------------
;
L4E7A   FCB 128			; 12.8 SEC'S VATS TMR FOR ERR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Error 54, low fuel pump volts/relay failure
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4E7B   FCB 5			;500 msec, time threshold to set error 54
L4E7C   FCB 50			;5 volts, lower FP volts threshold to pass init. test
L4E7D   FCB 80			;8 volts, lower FP volts threshold to set error (engine on)
L4E7E   FCB 20			;2 volts, lower batt. volts threshold to set error
;
L4E7F   FCB 2			;Slow filtered O2 coeff.
;
;~~~~~~~~~~~~~~~~~~~~~~
;-AIR management quals
;~~~~~~~~~~~~~~~~~~~~~~
;
L4E80   FCB 192			;2400 RPM, upper RPM threshold for AIR
L4E81   FCB 32			;22 kPa, min MAP threshold for AIR if MAP < DISABLE AIR INJ IF L.T. 22 Kpa 
L4E82   FCB 73			;15 deg C, min temp for AIR
L4E83   FCB 0			;Time threshold in PE to disable air (1 = 1/10 sec)
;
L4E84   FCB 135			;Filter coeff for MPH
;
;~~~~~~~~~~~~~
;-IAC params.
;~~~~~~~~~~~~~
;         
L4E85	FCB  $0A		;IAC opt. word, 0000 1010
				; b7, 1 = Stall saver thresholds are default rpms    
				;     0 = Stall saver thresholds are based on requested rpms    
				; b6=Use MAT based tables for A/C on/off transitions        
				; b5=Init INT with calib const., not running    
				; b4, 1=A/C high pressure switch in use           
				; b3=Use A/C off idle integral cells to reset A/C on integral cells    
				; b2=Throttle kicker is present
				; b1=Maintain T/F action during DFCO            
				; b0 - 1 = Man. trans, disable closed loop idle if quals not met                              
				;      0 = Auto trans, enable closed loop idle if rpms low  
;           
L4E86  FCB  $01			;IAC opt. word, 0000 0001		
				; b7=   
				; b6=    
				; b5=    
				; b4=                          
				; b3=   
				; b2=    
				; b1, 1=power steering switch in use   
				; b0, 1=init current idle integral cells using steady state cells   
;                      
L4E87	FCB  161		;81 deg C, min cool temp threshold to move IAC prior to
				;initial startup    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC counts vs. % desired airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Used to linearize IAC action
;
;	IAC counts		;% airflow
;
L4E88   FCB  0			;  0.0
	FCB  9			;  6.3
	FCB  19			; 12.5
	FCB  27			; 18.8
	FCB  37			; 25.0
	FCB  46			; 31.3
	FCB  56			; 37.5
	FCB  64			; 43.8
	FCB  72			; 50.0
	FCB  79			; 56.3
	FCB  84			; 62.5
	FCB  89			; 68.8
	FCB  94			; 75.0
	FCB  100		; 81.3
	FCB  109		; 87.5
	FCB  125		; 93.8
	FCB  150		;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC baro compensation factor vs baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; kPa = .625 x value + 14.9
;
L4E99   FCB  72			;45 kPa, table offset
;
L4E9A   FCB  72			;(60 kPa + 45 kPa offset) = 105 kPa, UL for lookup
;
L4E9B   FCB  32			;5 kPa per line
;
; 	factor = val/128	;kPa
;	
L4E9C   FCB  166		; 60
	FCB  160		; 65
	FCB  155    		; 70
	FCB  151		; 75
	FCB  147		; 80
	FCB  143		; 85
	FCB  138		; 90
	FCB  130		; 95
	FCB  128		;100
	FCB  128		;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC constants and default values
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4EA6 	FCB  150		;150 steps, park position for IAC
;
L4EA7 	FCB  46			;18% airflow, default value for P/N idle integral cells
;
L4EA8 	FCB  52			;20% airflow, default value for drive idle integral cells
L4EA9 	FCB  51			;20% airflow, added airflow for A/C on integral cells
				;if high engine temps present
L4EAA 	FCB  31			;12% airflow, added airflow for A/C on integral cells
				;if normal engine temps are present
;
L4EAB 	FCB  200		;110 deg C, threshold for high engine temp
;
L4EAC 	FCB  105		;10.5 volts, min batt volts for IAC operation 
;
L4EAD 	FCB  40			;40 MPH, lower speed threshold to perform IAC reset
				; (If non vol mem or IAC is lost)
;
L4EAE 	FCB  50			;19.5% IAC flow, added flow for startup
L4EAF 	FCB  1			;100 msec, decay period for initial added IAC flow 
L4EB0 	FCB  240		;240 secs, time until init. idle speed is decayed out
;
L4EB1 	FCB  3			;300 msec, decay period for added desired idle speed
				; PER 12.5 msecs INT PERIOD 
;
L4EB2 	FCB  192		;1.5, multiplier for added desired idle speed if in P/N 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Initial idle airflow parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4EB3   FCB  250		;97.6%, decay multiplier for intial IAC flows
L4EB4   FCB  245		;95.7%, decay multiplier for coupled flow, P/N
L4EB5   FCB  244		;95.3%, decay multiplier for coupled flow, drive 
L4EB6   FCB  10			;10 MPH, upper MPH limit to decay out initial IAC flow 
L4EB7   FCB  211		;82.4%, initial IAC flow vs. cool temp kickdown mult.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC %flow vs. cool temp (P/N)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%flow = val x .391	;Deg C	
;
L4EB8   FCB  240		;-28
	FCB  230		;-16
	FCB  197		; -4
	FCB  187		;  8
	FCB  166		; 20
	FCB  141		; 32
	FCB  102		; 44
	FCB  77			; 56
	FCB  72			; 68
	FCB  64			; 80
	FCB  64			; 92
	FCB  72			;104
	FCB  115		;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC %flow vs. cool temp (drive)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%flow = val x .391	;Deg C	
;
L4EC5   FCB  218		;-28
	FCB  212		;-16
	FCB  171		; -4
	FCB  166		;  8
	FCB  158		; 20
	FCB  133		; 32
	FCB  100		; 44
	FCB  80			; 56
	FCB  75			; 68
	FCB  67			; 80
	FCB  67			; 92
	FCB  79			;104
	FCB  128		;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC cold offset delay vs. cool temp 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Delay untill initial IAC flow is
; decayed out after startup
;
;	delay = val/10		;Deg C
;
L4ED2   FCB  210		;-28
	FCB  170		;-16
	FCB  160		; -4
	FCB  150		;  8
	FCB  140		; 20
	FCB  120		; 32
	FCB  75			; 44
	FCB  35			; 56
	FCB  25			; 68
	FCB  10			; 80
	FCB  5			; 92
	FCB  5			;104
	FCB  20			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Decay delay multiplier vs airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Used for above table
;
;	mult. = val/128		;gms/sec
;
L4EDF   FCB  154		; 0
	FCB  128		;16
	FCB  115		;32
	FCB  102		;48
	FCB  96			;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Allowable differences between initial IAC flows in P/N and drive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Flows are not saved if significantly different from one another
;
;-In drive, allowable difference from flow in P/N
;
L4EE4   FCB  102		;+40%, max allowable difference
L4EE5   FCB  77			;-30%, min allowable difference 
;
;-In park/neutral, allowed difference from flow in drive
;
L4EE6   FCB  102		;+40%, max allowable difference
L4EE7   FCB  77			;-30%, min allowable difference
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Closed loop idle quals
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L4EE8   FCB 4			;1.56% TPS, upper limit for closed throttle 
L4EE9   FCB 3			;3 MPH,  upper MPH limit for closed loop idle 
L4EEA   FCB 20			;500 msec, closed loop enable delay if quals not met
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC closed loop idle enable delay after start up vs. cool temp (high RPMs)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;	secs. = val/10		;Deg C
;
L4EEB   FCB  30			;-28
	FCB  20			;-16
	FCB  20			; -4
	FCB  15			;  8
	FCB  15			; 20
	FCB  15			; 32
	FCB  15			; 44
	FCB  15			; 56
	FCB  10			; 68
	FCB  10			; 80
	FCB  10			; 92
	FCB  10			;104
	FCB  10			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC closed loop idle enable delay after start up vs. cool temp (low RPMs)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;	secs. = val/10		;Deg C
;
L4EF8   FCB  50			;-28
	FCB  40			;-16
	FCB  30			; -4
	FCB  20			;  8
	FCB  20			; 20
	FCB  20			; 32
	FCB  10			; 44
	FCB  10			; 56
	FCB  5			; 68
	FCB  5			; 80
	FCB  5			; 92
	FCB  5			;104
	FCB  5			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-IAC transition params
;~~~~~~~~~~~~~~~~~~~~~~~
;
L4F05   FCB  5			;2%, delta IAC flow multiplier for A/C on to off transition
;
L4F06   FCB  1			;0.4%, min A/C on to A/C off transition IAC flow
L4F07   FCB  10			;4.0%, max A/C on to A/C off transition IAC flow
;
L4F08   FCB  8			;200 msec, A/C on to off transition period
L4F09   FCB  1			;20 msec, additional added delay for closed loop idle 
				;enable during A/C transition
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Delta IAC flow for A/C on/off transition vs. MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Params for table lookup
;
L4F0A   FCB  0			;-40 deg C, offset for lookup
	FCB  0			;-40 deg C, upper limit for offset value used for lookup
	FCB  0			;0 deg C per line
;
;	% delta IAC flow 
;	= val/2.56		;Deg C
;
L4F0D   FCB  0			;N/A  
	FCB  0			;
	FCB  0			;
	FCB  0			;
	FCB  0			;
;

;
;~~~~~~~~~~~~~~~~~~~~~~~
;-IAC transition params
;~~~~~~~~~~~~~~~~~~~~~~~
;
L4F12 	FCB  77			;30%, flow transition multiplier for A/C change state
; 		
L4F13 	FCB  3			;1.1% flow, min allowed change in airflow for A/C 
				;on/off transition
L4F14 	FCB  13			;5.1% flow, max allowed change in airflow for A/C
				;on/off transition
;
L4F15 	FCB  40			;1000 msec, idle transition period for A/C on/off 
L4F16 	FCB  4			;100 msec, delay for closed loop idle after A/C 
				;on/off transition 
;
L4F17 	FCB  1			;2.6% flow, A/C on/off transition flow decay rate
L4F18 	FCB  3			;300 msec, A/C on/off transition flow decay perod 
;
;-Park to drive
;     				
L4F19 	FCB  10			;3.9% flow, added IAC flow for park to drive trans shift
L4F1A 	FCB  35			;875 msec, period for park to drive shift
L4F1B 	FCB  20			;500 msec, closed loop idle delay for park to drive shift
;
;-Drive to park
;
L4F1C 	FCB  2			;0.8% IAC flow for drive to park/neutral
L4F1D 	FCB  60			;1.5 sec, drive to park transition period
L4F1E 	FCB  60			;1.5 sec, closed loop delay for drive to park shift
;
L4F1F 	FCB  47			;-5 deg C, threshold for cold idle added delays	for
				;transmission shift from P/N or drive
;
;-Park to drive
;
L4F20 	FCB  20			;500 msec, added idle delay for closed loop when cold and 
				;have shifted from park to drive
L4F21 	FCB  60			;1.5 sec, additional park to drive shift transition delay
				;when cold
;
;-Drive to park
;	 			
L4F22 	FCB  20			;500 msec, added idle delay for closed loop when cold and 
				;have shifted from drive to park
L4F23 	FCB  20			;500 msec, additional park to drive shift transition delay
				;when cold
;
;-Power steering compensation
;
L4F24 	FCB  0			;0% flow, added flow for P/S compensation
L4F25 	FCB  0			;0 msec, 100 msec/count, closed loop idle delay if 
				;P/S compensation in effect 
L4F26 	FCB  0			;0 msec, 100 msec/count, P/S compensation IAC flow
				;decay period 
L4F27 	FCB  0			;0% flow, P/S compensation flow decay rate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Desired idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; In P/N and A/C is off
;
;	RPM = val x 12.5	;Deg C
;
L4F28   FCB  70			;-28
	FCB  70			;-16
	FCB  70			; -4
	FCB  70			;  8
	FCB  66			; 20
	FCB  62			; 32
	FCB  58			; 44
	FCB  56			; 56
	FCB  54			; 68
	FCB  53			; 80
	FCB  52			; 92
	FCB  52			; 98
	FCB  52			;104
	FCB  54			;110
	FCB  58			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Desired idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; In P/N and A/C is on
;
;	RPM = val x 12.5	;Deg C
;
L4F37   FCB  70			;-28
	FCB  70			;-16
	FCB  70			; -4
	FCB  70			;  8
	FCB  66			; 20
	FCB  62			; 32
	FCB  58			; 44
	FCB  56			; 56
	FCB  54			; 68
	FCB  53			; 80
	FCB  52			; 92
	FCB  52			; 98
	FCB  52			;104
	FCB  54			;110
	FCB  58			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Desired idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; In drive and A/C is off
;
;	RPM = val x 12.5	;Deg C
;
L4F46   FCB  54			;-28
	FCB  54			;-16
	FCB  54			; -4
	FCB  54			;  8
	FCB  52			; 20
	FCB  50			; 32
	FCB  48			; 44
	FCB  46			; 56
	FCB  44			; 68
	FCB  43			; 80
	FCB  42			; 92
	FCB  42			; 98
	FCB  42			;104
	FCB  46			;110
	FCB  48			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Desired idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; In drive and A/C is on
;
;	RPM = val x 12.5	;Deg C
;
L4F55   FCB  54			;-28
	FCB  54			;-16
	FCB  54			; -4
	FCB  54			;  8
	FCB  52			; 20
	FCB  50			; 32
	FCB  48			; 44
	FCB  46			; 56
	FCB  44			; 68
	FCB  43			; 80
	FCB  42			; 92
	FCB  42			; 98
	FCB  42			;104
	FCB  46			;110
	FCB  48			;116
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added initial desired idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	RPM = val x 12.5	;Deg C
;
L4F64   FCB  4			;-28
	FCB  4			;-16
	FCB  4			; -4
	FCB  4			;  8
	FCB  4			; 20
	FCB  4			; 32
	FCB  4			; 44
	FCB  4			; 56
	FCB  4			; 68
	FCB  3			; 80
	FCB  1			; 92
	FCB  1			;104
	FCB  1			;116
	FCB  2			;128
	FCB  4			;140
;
L4F73   FCB 120			;.47, RPM error gain factor for rough idle
L4F74   FCB 20			;Filter coefficient for filtered idle RPM error
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Default RPM errors for transitions
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4F75   FCB  0			;0 RPM, upper default RPM error if throttle is open
L4F76   FCB  16			;200 RPM, default RPM error for P/N, drive trans shift
L4F77   FCB  20			;250 RPM, default RPM error for A/C on/off transition 
L4F78   FCB  20			;250 RPM, defualt RPM error if P/S active
;
L4F79   FCB  2			;25 RPM, RPM error threshold for rough idle
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Proportional low battery volts correction parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4F7A   FCB  125		;12.5 volts, lower threshold to begin raising RPMs to 
				;compensate for low batt. volts	   
L4F7B   FCB  51			;25 RPM per volt, prop. gain for low batt volts.  
				;gain(RPM/volt) = val x (125/256)
L4F7C   FCB  3			;38 RPM, max added idle speed for low batt volts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-CCP compensation params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4F7D   FCB  107		;Upper BLM limit for idle purge compensation
L4F7E   FCB  20			;20 sec, min time before begining idle purge compensation
L4F7F   FCB  173		;90 deg C, Lower temp threshold for idle purge compensation
L4F80   FCB  6			;75 RPM, idle purge compensation, P/N, A/C off 
L4F81   FCB  4			;50 RPM, idle purge compensation, P/N, A/C on
L4F82   FCB  4			;50 RPM, idle purge compensation, drive, A/C off
L4F83   FCB  2			;25 RPM, idle purge compensation, drive, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Params for raising idle if high A/C pressure detected
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4F84   FCB  80			;1000 RPM, desired RPM for high A/C pressure, P/N
L4F85   FCB  90			;1125 RPM, desired RPM for high A/C pressure, drive
L4F86   FCB  10			;Delay to add in desired RPMs if high load previously
				;present
L4F87   FCB  10			;Delay to add in desired RPMs if high load not previously
				;present
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral gain vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Idle speed low and in P/N
;
;	gain(%flow/RPM)=
;	val x .000122		;RPM error
;
L4F88   FCB  0			;  -0.0
	FCB  0			; -12.5
	FCB  3			; -25.0
	FCB  6			; -37.5
	FCB  6			; -50.0
	FCB  12			;-100.0
	FCB  16			;-150.0
	FCB  16			;-200.0
	FCB  16			;-300.0
	FCB  16			;-400.0
	FCB  16			;-500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral gain vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Idle speed high and in P/N
;
;	gain(%flow/RPM)=
;	val x .000122		;RPM error
;	
L4F93   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  3			; 25.0
	FCB  6			; 37.5
	FCB  6			; 50.0
	FCB  6			;100.0
	FCB  6			;150.0
	FCB  6			;200.0
	FCB  6			;300.0
	FCB  6			;400.0
	FCB  6			;500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral gain vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Idle speed low and in drive
;
;	gain(%flow/RPM)=
;	val x .000122		;RPM error
;
L4F9E   FCB  0 			;  -0.0
	FCB  0			; -12.5
	FCB  4			; -25.0
	FCB  6			; -37.0
	FCB  6			; -50.0
	FCB  8			;-100.0
	FCB  9			;-150.0
	FCB  10			;-200.0
	FCB  11			;-300.0
	FCB  16			;-400.0
	FCB  12			;-500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integral gain vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Idle speed high and in drive
;
;	gain(%flow/RPM)=
;	val x .000122		;RPM error
;
L4FA9   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  4			; 25.0
	FCB  6			; 37.5
	FCB  7			; 50.0
	FCB  8			;100.0
	FCB  9			;150.0
	FCB  10			;200.0
	FCB  11			;300.0
	FCB  16			;400.0
	FCB  12			;500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle integrator parameters and thresholds
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4FB4   FCB	1		;12.5 RPM, upper RPM error limit for steady state idle
;
L4FB5	FCB	167		;85 deg C, lower temp threshold for steady state idle 
				;check
L4FB6	FCB	193		;105 deg C, upper temp threshold for steady state idle
				;check
;
;-Allowable integrator difference for A/C and non-A/C terms, P/N
;	
L4FB7	FCB   7			;2.7% flow, min allowable difference 
L4FB8   FCB  90			;35% flow, max allowable difference 
;
;-Allowable integrator difference for A/C and non-A/C terms, drive
;
L4FB9   FCB  7			;2.7% flow, min allowable difference
L4FBA   FCB  103		;40.2% flow, max allowable difference 
;
;-Allowable integrator difference for drive and P/N terms, both non-A/C and A/C
;				
L4FBB   FCB  38			;15% flow, max allowable difference
L4FBC   FCB  8			;-2.7% flow, min allowable difference 
;
;-Allowable integral difference between steady state and current integral terms,
; checked when not in closed loop idle
;
L4FBD   FCB  255		;99.6% flow, max allowable difference, no A/C
L4FBE   FCB  255		;99.6% flow, max allowable difference, A/C
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Quals for limiting idle proportional action
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L4FBF   FCB  5			;5 MPH, lower threshold to limit proportional action
L4FC0   FCB  3			;3 MPH, upper threshold to restore proportional action
L4FC1   FCB  128		;1600 RPM, upper limit for RPM errror when limiting 
				;proportional action
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low idle and in P/N		
;
;	%flow = val x .391	;RPM error
;
L4FC2   FCB  0			;  -0.0            
	FCB  0			; -12.5
	FCB  0			; -25.0
	FCB  4			; -37.5
	FCB  6			; -50.0
	FCB  9			;-100.0
	FCB  12			;-150.0
	FCB  12			;-200.0
	FCB  12			;-300.0
	FCB  12			;-400.0
	FCB  12			;-500.0
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; High idle and in P/N		
;
;	%flow = val x .391	;RPM error
;
L4FCD   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  0			; 25.0
	FCB  1			; 37.5
	FCB  2			; 50.0
	FCB  4			;100.0
	FCB  5			;150.0
	FCB  6			;200.0
	FCB  7			;300.0
	FCB  8			;400.0
	FCB  9			;500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low idle, A/C off, in drive, and open loop idle		
;
;	%flow = val x .391	;RPM error
;
L4FD8   FCB  0			;  -0.0
	FCB  0			; -12.5
	FCB  0			; -25.0
	FCB  0			; -37.5
	FCB  1			; -50.0 
	FCB  3			;-100.0  
	FCB  5			;-150.0  
	FCB  6			;-200.0 
	FCB  8			;-300.0  
	FCB  12			;-400.0  
	FCB  12			;-500.0   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; High idle, A/C off, in drive, and open loop idle		
;
;	%flow = val x .391	;RPM error
;
L4FE3   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  0			; 25.0
	FCB  0			; 37.5
	FCB  0			; 50.0
	FCB  0			;100.0
	FCB  0			;150.0
	FCB  0			;200.0
	FCB  0			;300.0
	FCB  0			;400.0
	FCB  0			;500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low idle, A/C off, in drive, and closed loop idle		
;
;	%flow = val x .391	;RPM error
;
L4FEE   FCB  0			;  -0.0
	FCB  0			; -12.5
	FCB  2			; -25.0
	FCB  5			; -37.5
	FCB  7			; -50.0
	FCB  10			;-100.0
	FCB  12			;-150.0
	FCB  12			;-200.0
	FCB  12			;-300.0
	FCB  12			;-400.0
	FCB  12			;-500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; High idle, A/C off, in drive, and closed loop idle		
;
;	%flow = val x .391	;RPM error
;			
L4FF9   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  1			; 25.0
	FCB  2			; 37.5
	FCB  4			; 50.0
	FCB  5			;100.0
	FCB  6			;150.0
	FCB  7			;200.0
	FCB  8			;300.0
	FCB  9			;400.0
	FCB  12			;500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low idle, A/C on, in drive, and open loop idle		
;
;	%flow = val x .391	;RPM error
;
L5004   FCB  0			;  -0.0
	FCB  0			; -12.5
	FCB  0			; -25.5
	FCB  0			; -37.5
	FCB  1			; -50.0
	FCB  3			;-100.0
	FCB  5			;-150.0
	FCB  6			;-200.0
	FCB  8			;-300.0
	FCB  12			;-400.0
	FCB  12			;-500.0	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; High idle, A/C on, in drive, and open loop idle		
;
;	%flow = val x .391	;RPM error
;
L500F   FCB  0			;  0.0
	FCB  0			; 12.5	
	FCB  0			; 37.5
	FCB  0			; 25.0
	FCB  0			; 50.0
	FCB  0			;100.0
	FCB  0			;150.0
	FCB  0			;300.0
	FCB  0			;400.0
	FCB  0			;500.0
;
L5019	FCB  0			;Not used	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low idle, A/C on, in drive, and closed loop		
;
;	%flow = val x .391	;RPM error
;
L501A   FCB  0			;  -0.0
	FCB  0			; -12.5
	FCB  3			; -25.0
	FCB  6			; -37.5
	FCB  9			; -50.0
	FCB  12			;-100.0
	FCB  15			;-150.0
	FCB  15			;-200.0
	FCB  15			;-300.0
	FCB  15			;-400.0
	FCB  12			;-500.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional term vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; High idle, A/C on, in drive, and closed loop		
;
;	%flow = val x .391	;RPM error
;
L5025   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  1			; 25.0
	FCB  3			; 37.5
	FCB  5			; 50.0
	FCB  6			;100.0 
	FCB  9			;150.0  
	FCB  12			;200.0 
	FCB  12			;300.0 
	FCB  14			;400.0  
	FCB  14			;500.0
;
;-Filter coeff. for limiting derivative idle action
;
L5030   FCB  32			;Coeff. for positive derivative action
L5031   FCB  16			;Coeff. for negative derivative action 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Idle derivative term vs. transient RPM ratio
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;	%flow = (val - 128)/4	;Transient RPM ratio
;
L5032   FCB  128		;0.75000
	FCB  128		;0.78125
	FCB  128		;0.81250
	FCB  128		;0.84375
	FCB  128		;0.87500
	FCB  128		;0.90625
	FCB  128		;0.93750
	FCB  128		;0.96875
	FCB  128		;0.10000
	FCB  128		;0.10313 
	FCB  140		;0.10625
	FCB  152		;0.10938 
	FCB  164		;0.12500
	FCB  164		;0.15625
	FCB  164		;0.18750
	FCB  164		;0.12188 
	FCB  164		;0.12500
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Stall saver activation thresholds
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; L4E85, b7==0, quals are % multipliers for desired idle to obtain RPM threshold
;        b7==1, quals are RPM thresholds
;
;-In park/neutral
;			 
L5043	FCB  166		;65% desired idle speed, A/C off
L5044   FCB  166		;65% desired idle speed, A/C on
;
;-In drive
;	
L5045   FCB  179		;70% desired idle speed, A/C off
L5046   FCB  179		;70% desired idle speed, A/C on 
;		 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added airflow for stall saver
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-In park/neutral
;			 
L5047   FCB  6			;2.3%, added airflow, A/C off 
L5048   FCB  8			;3.0%, added airflow, A/C on
;
;-In drive
;			
L5049   FCB  10			;4.0%, added airflow, A/C off
L504A   FCB  13			;5.0%, added airflow, A/C on 
;
L504B   FCB  20			;0.5 sec, time for stall saver to be active, P/N
L504C   FCB  40			;1.0 sec, time for stall saver to be active, drive
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IAC throttle follower gain vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	gain = val/64
;
L504D   FCB  96			;-28
	FCB  96			;-16
	FCB  80			; -4
	FCB  74			;  8
	FCB  70			; 20
	FCB  70			; 32
	FCB  70			; 44
	FCB  70			; 56
	FCB  70			; 68
	FCB  64			; 80		
	FCB  64			; 92		
	FCB  64			;104		
	FCB  58			;116	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IAC throttle follower gain vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
L505A   FCB  8			;9 line table
;
;	gain = val/64		;RPM
;
L505B   FCB  110		;   0
	FCB  140		; 400
	FCB  140		; 800
	FCB  140		;1200
	FCB  140		;1600
	FCB  140		;2000
	FCB  140		;2400
	FCB  140		;2800
	FCB  140		;3200
;
L5064   FCB 37			;28.60%, max allowed TPS for P/N throttle follower
L5065   FCB 64			;31.25%, max allowed TPS for T/F in drive
L5066   FCB 37			;TPS throttle follower filtering coeff., P/N
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS filtering period vs. MPH 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Used to filter TPS back down during throttle 
; closing for throttle follower and other items
;
;	secs = val/40		;MPH
;
L5067   FCB   8			; 0
	FCB  30			; 8
	FCB  40			;16
	FCB  60			;24
	FCB  60			;32
	FCB  60			;40
	FCB  60			;48
	FCB  60			;56
	FCB  60			;64
	FCB  60			;72
	FCB  60			;80
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS filtering coeff. vs. MPH
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Filter coeff. for filter TPS back down during throttle 
; closing for throttle follower and other items
;
;	Coeff.			;MPH
;
L5072   FCB  20			; 0
	FCB  12			; 8
	FCB  5			;16
	FCB  5			;24
	FCB  5			;32
	FCB  5			;40
	FCB  5			;48
	FCB  5			;56
	FCB  5			;64
	FCB  5			;72
	FCB  5			;80
;
L507D   FCB  4			;1.6% flow, min delta flow to update throttle follower flow
;
L507E   FCB  20			;26.3 kPa map threshold for scaling down TPS filter coeff.
L507F   FCB  128		;.5, multiplier for reducing filter coeff. when low MAP present 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Lower limit for TPS to ensure some added throttle follower flow during closed throttle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%TPS = (val + 256) x 
;	       .391		;Deg C
;
L5080   FCB  24			;-28
	FCB  24			;-16
	FCB  24			; -4
	FCB  24			;  8
	FCB  24			; 20
	FCB  24			; 32
	FCB  24			; 44
	FCB  24			; 56
	FCB  24			; 68
	FCB  24			; 80
	FCB  24			; 92
	FCB  24			;104
	FCB  28			;116
;
L508D	FCB  40			;4 secs, time after throttle closes to limit
				;throttle follwer action
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added flow for steady state integral cells on initilization
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L508E   FCB  3			;1.0% flow, added to steady state integral on 
				;init, A/C off, drive
L508F   FCB  6			;2.3% flow, added to steady state integral on 
				;init, A/C on, drive
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Note from original hac:
;
;	SPECIAL IDLE AIR MODIFIERS PRIOR TO CAT LIGHT OFF
;
;	Also used by non-cat cals to reduce HC emissions
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L5090   FCB  73			;15 deg c, lower cool temp limit for cool engine
L5091   FCB  113		;45 deg c, upper cool temp limit for cool engine
L5092   FDB  0350		;350 secs, max time to remain in cool engine mode
L5094   FCB  218		;85%, multiplier for reducing T/F action during cool
				;engine operation 
L5095   FCB  220		;86%, multiplier for reducing T/F action during warm
				;engine operation 
L5096   FCB  85			;1.33, multiplier for lower closed throttle TPS limit 
				;when in cool engine mode 
;
L5097   FCB  86			;1.34, added throttle follower gain for cool engine 
				;operation
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Accel enrich vs. delta %IAC flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L5098   FCB  4			;5 line table
;
;	usec=val x 15.26	;Delta %IAC flow
;
L5099   FCB  0			; 0.00
	FCB  1			; 6.25
	FCB  5			;12.50
	FCB  10			;18.75
	FCB  15			;25.00	
;
;~~~~~~~~~~~~~~~~~~~
;-Params for IAC AE
;~~~~~~~~~~~~~~~~~~~
;
L509E   FCB  5			;1.9% flow, lower threshold for IAC AE
L509F   FCB  10			;3.9% TPS, upper threshold for IAC AE
;
L50A0   FDB  65535		;99.998% flow, Max IAC % flow in Pwr Enrich
				;Used by TBI sys to shut down IAC near WOT
				;to improve air fuel dist on dyno [from original hac]
;
L50A2   FCB  0			;0%, flow bias for added IAC flow when in DFCO
				;(following table)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Additional IAC flow vs. RPM for DFCO
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%flow = val/.391	;RPM/25
;
L50A3   FCB  8			;   0
	FCB  46			; 400
	FCB  46			; 800
	FCB  51			;1200
	FCB  62			;1600
	FCB  66			;2000
	FCB  72			;2400
	FCB  77			;2800
	FCB  82			;3200
	FCB  90			;3600
	FCB  96			;4000
	FCB  96			;4400
	FCB  96			;4800
	FCB  96			;5200
	FCB  96			;5600
	FCB  96			;6000
	FCB  96     		;6400
;
;-DFCO flow decay rate per sec = decay ammount/decay time rate
;
L50B4   FCB  4			;16%, DFCO decay ammount
L50B5   FCB  3      		;300 msec, DFCO decay rate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC diagnostic (error 35) params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L50B6   FCB  9			;112.5 RPM, sustained idle RPM error to set IAC fault 
L50B7   FCB  150		;30 sec, time threshold to set IAC fault
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Quals for checking idle integral limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
L50B8   FCB  167		;85 deg C, lower cool temp limit to check integrator					;
L50B9   FCB  166		;65% flow, max allowed idle integrator, no A/C
L50BA   FCB  255		;99.6% flow, max idle integrator, A/C
L50BB   FCB  8 			;100 RPM, error threshold for requesting IAC reset
				;and IAC reposition
L50BC   FCB  $0C		;Counter value, loop counter threshold to begin
				;adding/removing steps
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Throttle kicker params
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L50BD   FCB  0			;-40 deg C, temp threshold to enable throttle kicker
L50BE   FCB  0			;0% flow, subtracted bias when throttle kicker is active
L50BF   FCB  0			;1, airflow multiplier for throttle kicker FACTOR 
L50C0   FCB  0			;0 MPH, threshold to enable throttle kicker (low baro)
L50C1   FCB  0			;0% TPS, threshold to enable throttle kicker (low baro)
L50C2   FCB  0			;0 secs, min time for throttle kicker to be active 
;
L50C3   FCB  0			;0 kPa, upper baro threshold to disable throttle kicer
L50C4   FCB  0			;0 kPa, lower baro threshold to enable throttle kicker
;
L50C5   FCB  0			;0% flow, idle integrator thresh. for disabling T/K 
L50C6   FCB  0			;0% flow, lower idle integrator threshold for 
				;enabling throttle kicker (low baro)
;
L50C7   FCB  0			;RPM error threshold to disable throttle kicker (Drive)
L50C8   FCB  0			;RPM error threshold to disable throttle kicker (P/N)
					;
L50C9   FCB  0			;0 sec, min time for T/K to be active
L50CA   FCB  0			;0%, default base TPS for T/K
L50CB   FCB  0			;0%, base TPS offset for kicker enabled
L50CC   FCB  0			;0% min delta TPS threshold not to set err. 36
					;
L50CD   FCB  10			;(10 + 255) = 265 sec, min time befor re-enabling T/K
;
;~~~~~~~~~~~~~~~~~
;-Governor params
;~~~~~~~~~~~~~~~~~
;
L50CE   FCB  0      		; 0 RPM DESIRED RPM
				; RPM * 25
				;
L50CF   FCB  0			; 0 RPM LO GOVER DISABLE WHEN CLS LP GOV 
				; & ACTUATOR IS OFF
				;
L50D0   FCB  0			;0 MPH, MPH threshold for governor (0 = No MPH governing)
L50D1   FCB  0			;0 MPH, Governor MPH error threshold to exit MPH governing
L50D2   FCB  0			;0 RPM, threshold for governor overspeed light (RPM/25)
;
L50D3   FCB  0      		;RPM prop. gain term
L50D4   FCB  0     		;MPH prop. gain term
;
L50D5   FCB  0			;Desired TPS integral gain term for MPH overspeed
L50D6   FCB  0			;Desired TPS integral gain term for RPM overspeed
;
L50D7   FCB  0			; 0% MAX DESIRED TPS% AT LEAD MODE START
L50D8   FCB  0      		;Min desired TPS for overspeed
;
L50D9   FCB  0			; 0% MAX DESIRED TPS% AT LEAD MODE 
;
L50DA   FCB  0			;Filter coeff for governor rpm  
;
L50DB   FCB  0     		;TPS threshold for return gain factors 
L50DC   FCB  0			;High desired TPS return gain
L50DD   FCB  0      		;Low desired TPS return gain
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Governor integral gain factor vs desired TPS output
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L50DE	FCB  64     		;50% TPS, upper limit
;
;	gain			;%TPS
;
	FCB	0		; 0.0
	FCB	0		;12.5
	FCB	0 		;25.0
	FCB	0		;37.5
	FCB	0		;50.0
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
L50E4   FCB  80     ; TBL MULTIPLIER
;
; RPM        RPM/Sec
;---------------------------------
L50E5   FCB  0      ; 0.0              0	
	FCB  0      ; 0.0          	 400	
	FCB  0      ; 0.0		     800	
	FCB  0      ; 0.0			1200	
	FCB  0      ; 0.0			1600	
	FCB  0      ; 0.0			2000	
	FCB  0      ; 0.0			2400	
	FCB  0      ; 0.0			2800	
	FCB  0      ; 0.0			3200	
	FCB  0      ; 0.0         	3600	
	FCB  0      ; 0.0         	4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Governor, TPS derivative gain vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	gain			;Deg C		
;
L50F0   FCB  0			;-40
	FCB  0			;-16
	FCB  0			;  8
	FCB  0			; 32
	FCB  0			; 56
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Governor actuator proportional gain vs. TPS error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L50F5   FCB  8			;9 lines
;
;	gain			;%TPS error
;
	FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  0			; 25.0
	FCB  0			; 37.5
	FCB  0			; 50.0
	FCB  0			; 62.5
	FCB  0			; 75.0
	FCB  0			; 87.5
	FCB  0			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Governor actuator integral gain vs. TPS error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;			
L50FF   FCB  8			;9 lines
;
;	gain			;%TPS error
;
L5100   FCB  0			;  0.0
	FCB  0			; 12.5
	FCB  0			; 25.0
	FCB  0			; 37.5
	FCB  0			; 50.0
	FCB  0			; 62.5
	FCB  0			; 75.0
	FCB  0			; 87.5
	FCB  0			;100.0
;
;---------------------------------------------
; HIGH ET RATIOS FOR
;
; UPPER ENG RPM/TRANS RPM OF A PAIR USED 
;  ESTABLISH CORRECT GEAR RANGE FOR SPECIFIED GEAR
;  TO SET SHIFT LIGHT TRIP POINT
;---------------------------------------------
;
L5109   FCB  37			; 3.7 RPM/RPM FOR 1st GEAR
L510A   FCB  21			; 2.1 RPM/RPM FOR 2nd GEAR 
L510B   FCB  12			; 1.2 RPM/RPM FOR 3rd GEAR
L510C   FCB  9			; 0.9 RPM/RPM FOR 4th GEAR
;
;---------------------------------------------
; MIN RPM'S FOR ALLOWING
; SHIFT LIGHT
;---------------------------------------------
;
L510D   FCB  64			; 1600 RPM  1st GEAR
L510E   FCB  64			; 1600 RPM  2nd GEAR
L510F   FCB  56			; 1400 RPM  3rd GEAR
L5110   FCB  55			; 1375 RPM  4th GEAR	
;
;---------------------------------------------
; TPS ADJ FACTOR IN SPEC GEAR
; 0 - 2 MULT TO ADJ TPS REL TO SPECIFIC GEAR
; (HI TPS TEST)
;---------------------------------------------
;
L5111   FCB  90			; 0.70 FACTOR, 1st GEAR
L5112   FCB  128		; 1.00 FACTOR, 2nd GEAR
L5113   FCB  128		; 1.00 FACTOR, 3rd GEAR
L5114   FCB  141		; 1.10 FACTOR, 4th GEAR
;
;---------------------------------------------
;  TH700R4, (NON-ELECTRONIC)
;
;---------------------------------------------
;
L5115   FCB  73			; 15 Deg c 
;
L5116   FCB  8			; IF TPS % L.T. 3% & LOWER  GEARS, TURN OFF LIGHT
L5117   FCB  8			; IF TPS % L.T. 3% & HIGHER GEARS, TURN OFF LIGHT 
;
L5118   FCB  180		; IF RPM G.T. 4500 RPM LIGHT ON NOW!
;
L5119   FCB  10			; 1.0 SEC LO GR DELAY PRIOR TO SHFT LIGHT
L511A   FCB  15			; 1.5 SEC HI GR DELAY PRIOR TO SHFT LIGHT
;
;---------------------------------------------
; LOAD LMT Vs. RPM
; TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;  Dissassemby of BDWM
; 
; TBL = %FULL LD * 2.56
;---------------------------------------------
;
L511B   FCB  38			;  14.8         1000
	FCB  38			;  14.8         1400
	FCB  43			;  16.8         1800
	FCB  66			;  25.8         2200
	FCB  89			;  34.8         2600
	FCB  112		;  43.8         3000
	FCB  132		;  51.6         3400
	FCB  204		;  79.7         3800
	FCB  255		;  99.6         4200
	FCB  255		;  99.6         4600
	FCB  255		;  99.6         5000
;
;---------------------------------------------
; LOAD LMT Vs. RPM
; TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;  Dissassemby of BDWM
; 
; TBL = %FULL LD * 2.56
;---------------------------------------------
;
L5126   FCB  26			;  10.2         1000
	FCB  26			;  10.2         1400
	FCB  31			;  12.1         1800
	FCB  54			;  21.1         2200
	FCB  77			;  30.1         2600
	FCB  100		;  39.1         3000
	FCB  120		;  46.9         3400
	FCB  192		;  75.0         3800
	FCB  243		;  94.9         4200
	FCB  255		;  99.6         4600
	FCB  255		;  99.6         5000
;
;---------------------------------------------
; LOAD LMT Vs. RPM
; TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;  Dissassemby of BDWM
;  
; TBL = %FULL LD * 2.56
;---------------------------------------------
;
L5131   FCB  43			;  16.8         1000
	FCB  43			;  16.8         1400
	FCB  71			;  27.7         1800
	FCB  102		;  39.8         2200
	FCB  130		;  50.8         2600
	FCB  178		;  69.5         3000
	FCB  208		;  81.3         3400
	FCB  230		;  89.8         3800
	FCB  242		;  94.5         4200
	FCB  255		;  99.6         4600
	FCB  255		;  99.6         5000
;
;---------------------------------------------
; LOAD LMT Vs. RPM
;  TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;  Dissassemby of BDWM
;  
; TBL = %FULL LD * 2.56
;---------------------------------------------
;
L513C   FCB  31			; 12.1         1000
	FCB  41			; 16.0         1400
	FCB  59			; 23.0         1800
	FCB  90			; 35.2         2200
	FCB  118		; 46.1         2600
	FCB  166		; 64.8         3000
	FCB  192		; 75.0         3400
	FCB  218		; 85.2         3800
	FCB  230		; 89.8         4200
	FCB  255		; 99.6         4600
	FCB  255		; 99.6         5000
;
;---------------------------------------------
; BARO CORRECTION TO TBL'S L5113 th L513E (ABOVE)
; TH700R4, (NON-ELECTRONIC)
;  Dissassemby of BDWM
;  
; TBL = 128 * FACTOR
;---------------------------------------------
;
L5147   FCB  109		;   0.9           75
	FCB  115		;   0.9           85
	FCB  128		;   1.0           95
	FCB  128		;   1.0          105
;
;~~~~~~~~~~~~~~~~~~~~
;-Trans abuse params
;~~~~~~~~~~~~~~~~~~~~
;
L514B   FCB  40			;500 msec, time to perform abuse test in PE
L514C   FCB  3      		;3 MPH, min speed for abuse test
L514D   FCB  255    		;4775 RPM (scaled), RPM threshold to flag high RPMs
L514E   FCB  255    		;4775 RPM (scaled), RPM threshold to clear abuse flag 
L514F   FCB  51			;20% TPS, min TPS for abuse test
;
;~~~~~~~~~~~~~~~~~~~
;-TCC lockup params
;~~~~~~~~~~~~~~~~~~~
;
L5150   FCB  140		;65 deg C, lower temp limit for TCC lockup
L5151   FCB  5			;2% TPS hyst. if TCC locked, used with table L515E
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Delta TPS TCC limits to lock
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L5152   FCB  54			;-.21% TPS/msec, throttle closing limit 
L5153   FCB  45			;.176% TPS/msec, throttle opening limit 
;
;~~~~~~~~~~~~~~~~~~
;-TCC relock delay
;~~~~~~~~~~~~~~~~~~
;					
L5154   FCB  20			;2 sec delay to relock after quals not met
L5155   FCB  25			;2.5 sec coast relock delay
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Manditory lockup thresholds
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L5156   FCB  82			;82 MPH, threshold to lock TCC
L5157   FCB  79			;79 MPH, threshold to unlock TCC after mand. lockup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-RPM thresholds for TCC lockup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	RPM/12.5
;
L5158   FCB  0			;0 rpm, limit for TCC to remain locked	
L5159   FCB  0			;0 rpm, limit for TCC to lock
;
;~~~~~~~~~~~~~~~~~~~~
;-TCC MPH thresholds
;~~~~~~~~~~~~~~~~~~~~
;
;-No A/C 
;
L515A   FCB  30			;30 mph, lower threshold for TCC to lock
L515B   FCB  28			;28 mph, lower threshold for TCC to remain locked			
;
;-A/C 
;			
L515C   FCB  35			;35 mph, lower threshold for TCC to lock
L515D   FCB  33			;33 mph, lower threshold for TCC to remain locked			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Lower load limit for TCC to lock vs mph
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%TPS = val x .391	;MPH
;
L515E	FCB  13			; 0
	FCB  13			;10
	FCB  13			;20
	FCB  13			;30
	FCB  17			;40
	FCB  20			;50
	FCB  22			;60
	FCB  23			;70
	FCB  23			;80
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Upper load limit for TCC to remain locked vs MPH
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%TPS = val x .391	;MPH
;
L5167	FCB  64			;20
	FCB  64			;25
	FCB  73			;30
	FCB  87			;35
	FCB  110		;40
	FCB  128		;45
	FCB  140		;50
	FCB  158		;55
	FCB  158		;60
	FCB  158		;65
	FCB  158		;70
	FCB  158		;75
	FCB  158		;80
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Upper load limit for TCC to lock vs MPH
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	%TPS = val x .391	;MPH
;
L5174  	FCB  51			;20
	FCB  51			;25
	FCB  57			;30
	FCB  64			;35
	FCB  72			;40
	FCB  88			;45
	FCB  96			;50
	FCB  128		;55
	FCB  128		;60
	FCB  128		;65
	FCB  128		;70
	FCB  128		;75
	FCB  128		;80
;
;~~~~~~~~~~~~~
;-VATS params
;~~~~~~~~~~~~~
;
; VATS period (msecs) = val x 7.63 x 10^-3 
;
L5181   FDB  4680		;35.71 msec, 28 Hz, lower freq. limit
L5183   FDB  4096		;31.25 msec, 32 Hz, upper freq. limit    
;
;**********************************************
;* $0D (BDWM) 8192 SERIAL DATA DCB'S 
;* PCM P/N 16196395, S/S BY PCM 16197427
;*
;**********************************************
;
;**********************************************
;* $0D (BDWM)  REMOTE BROADCAST MODE
;*  
;**********************************************
;
;---------------------------------------------
; REMOTE MESSAGE SCHEDULE TABLE 
; (POLLING FORMAT)
;
; (1 FOR EACH MINOR LOOP)
;
; 0000 ADDRESS'S ARE IGNNORED BY PGM
;---------------------------------------------
;
L5185  	FDB 0000		;  0, SEGMENT 0
	FDB 0000		;  1,
	FDB 0000		;  2,
	FDB 0000		;  3,
	FDB 0000		;  4,
	FDB 0000		;  5, 
	FDB 0000		;  6,
	FDB 0000		;  7,
	FDB 0000		;  8,
	FDB 0000		;  9,
	FDB 0000		; 10,
	FDB 0000		; 11,
	FDB 0000		; 12,
	FDB 0000		; 13,
	FDB 0000		; 14,
	FDB 0000		; 15,
;
;---------------------------------------------
; SCAN TOOL POLLING MESSAGE
;
;---------------------------------------------
;
L51A5  	FDB 0000		; NEXT MSG ENTRY ADDR
;
L51A7  	FCB $F0			; DEVICE CODE  
;
L51A8  	FCB $80			; MEM FLAG, TBL FM ROM
L51A9  	FCB 1			; NUM OF WORDS  
;
L51AA  	FDB L036E		; ADD OF OUTPUT BUFFER  
L51AC  	FDB $0000		; ADDR OF INPUT BUFFER 
;
L51AE  	FDB L51B0		; ADDR DATA POINTER
;
L51B0  	FCB $F4			; ENGINE ID
;
;*******************************************
;* MSG ID $F4
;*
;*******************************************
;* 8192 ALDL MESSAGES FOLLOW XDE 5024 STD FORMAT,
;* ALSO SPECIAL FORMATS PER GM ALDL SPEC 12/14/87
;*
;* THE PCM IS A SLAVE, THUS NO OUTPUTED ALDL 
;* POLL MSG'S. THE PCM RESPONDS TO RX'ED ALDL MSGS
;*
;**********************************************
;
L51B1  FDB 65535		; 1638.38 SEC'S ENABLE PERIOD
				; FOR ALDL MODE 4, CONTROLER MODE
;
L51B3  FDB $0000		; 0 SEC'S PREVENT PERIOD
				; FOR ALDL MODE 4, CONTROLER MODE 
;
;***********************************************
;* SERIAL DATA MESSAGES                         
;* DEVICE ID $F4								   
;*			                                   
;***********************************************
;
;  DEVICE ID $F4
;
; MSG RX'ED, ANSWER TO ALDL POLLING MSG
; TYPE $0D PCM
;----------------------------------------------
L51B5  	FDB  L539E		;Next ALDL entry addr.					
L51B7  	FCB  $F4		;Engine diag. ID				
L51B8  	FCB  $00		;
L51B9  	FCB  $80		;Number of bytes to xmit
;
L51BA	FCB  L036E		;Addr. of outgoing data buffer
L51BC  	FCB  L036E		;Addr. of incoming data buffer
;
;-Pointer for parameters for various ALDL modes
;					;
L51BE  	FDB  L51D6		;Mode 0, normal operating mode
L51C0  	FDB  L51E5		;Mode 1, diag. scan mode 
L51C2  	FDB  L537A		;  2, DEVICE ID $F4, MODE 2, 64 ADDR MEM DUMP 
L51C4  	FDB  L5383		;  3, DEVICE ID $F4, MODE 3, SEQUENTIAL 8 ADDR MEM DUMP 					
L51C6  	FDB  L538C		;  4, DEVICE ID $F4, MODE 4, CONTROLER MODE
L51C8  	FDB  $0000		;  5, not used  
L51CA  	FDB  $0000		;  6, not used 
L51CC  	FDB  $0000		;  7, not used
L51CE  	FDB  $0000		;  8, not used
L51D0  	FDB  $0000		;  9, not used
L51D2  	FDB  L5395		; 10, DEVICE ID $F4, MODE 10, ALDL ERR RESET
L51D4  	FDB  $0000		; 11, not used
;
;----------------------------------------------
; DEVICE ID $F4, MODE 0
;
;  RESET NORMAL COMM
;----------------------------------------------
;
L51D6  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L51D8  	FCB  $F4		; DEVICE ID
;
L51D9  	FCB   00		; MEM FLAY
L51DA  	FCB    1		; BYTES TO TX
;
L51DB  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L51DD  	FDB  L036E		; ADDR OF INPUT BUFFER
;
;----------------------------------------------
; MODE 1 SELECTOR TABLE
;
;
;----------------------------------------------
;
L51DF  	FDB  L51E5		; DEVICE ID $F4, MODE 1/0
L51E1  	FDB  L526C		; DEVICE ID $F4, MODE 1/1 
L51E3  	FDB  L52F3		; DEVICE ID $F4, MODE 1/2
;
;----------------------------------------------
; DEVICE ID $F4, MODE 1/0
; TYPE $0D PCM P/N 16196395, S/S BY PCM 16197427
;
;  SCAN TOOL DATA 
;----------------------------------------------
;
L51E5  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L51E7  	FCB  $F4		; DEVICE ID
;
L51E8  	FCB  $80		; MEM FLAG, TBL FROM RAM
L51E9  	FCB   64		; BYTES TO TX
;
L51EA  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L51EC  	FDB  L036E		; ADDR OF INPUT  BUFFER
;
L51EE  	FDB  L4000		;  1, EPROM ID,MSB
L51F0  	FDB  L4000+1		;  2, EPROM ID,LSB
;
L51F2  	FDB  L0004		; 3, NVMW, NON-VOL RAM MODE WD
				; b7 1 = ERR 42, EST MON
				; b6 1 = ERR 24, Vss, (not used)
				; b5 1 = IAC KICK DN, (not used)
				; b4 1 = HOT RESTART PROCEEDING
				; b3 1 = BAD SHUT DOWN
				; b2 1 = RAM REFRESH ERR OCCOURED
				; b1 1 = CLS LP TMR OK
				; b0 1 = o2 SENSOR RDY
;
L51F4  	FDB  L0036		; 4	 DIACMW2, NON-VOL IDLE CNT'L MD WD
				; b7 1 =  IDLE RPM TO HIGH
				; b6 1 =  THROTTLE KICKER HAS BEEN DISABLED ONCE    
				; b5 1 =  PW STEER PRESS LOAD IN WORK
				; b4 1 =  STALL SAVER IN WORK
				; b3 1 =  CLSD LP ON RPM ENABLED
				; b2 1 =  CLSD LP QUALS MET, (clsd tps & low mph)
				; b1 1 =  DRIVE, 0 = PK/NEUT
				; b0 1 =  A/C ON
;
L51F6  	FDB  L0007		; 5, IAC, PRESSENT MOTOR POSIT         
				; 0 to MAX IAC (typ 145)
;
L51F8  	FDB  L000B		; 6, ERROR WD 1  
				; b7 1 = ERR 13, o2 SENSOR 
				; b6 1 = ERR 14, COOL SENSOR, HIGH  
				; b5 1 = ERR 15, COOL SENSOR, LOW 
				; b4 1 = ERR 16, Vss BUFFER, (2002 PPM)
				; b3 1 = ERR 17, RPM SIGNAL PROBLEM (not used)    
				; b2 1 = ERR 18, CAM CRANK ERROR  (not used) 
				; b1 1 = ERR 19, (not used)
				; b0 1 = ERR 21, TPS SENSOR HIGH
;   
L51FA  	FDB  L000C		; 7, ERROR WD 2           	
				; b7 1 = ERR 22, LOW TPS    
				; b6 1 = ERR 23, LOW MAT    
				; b5 1 = ERR 24, LOW OUTPUT SPEED (Vss)  
				; b4 1 = ERR 25, MAT SENSOR HIGH     
				; b3 1 = ERR 26,  (not used)
				; b2 1 = ERR 27,  (not used)
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29, (not used)
;   
L51FC  	FDB  L000D		;  8, ERR MD WD 3		                		
				; b7 1 = ERR 31, GOVENOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SNENSOR LOW      
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, IAC THROTTLE KICKER FAIL (not used)    
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON    
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF    
;    
L51FE  	FDB  L000E		; 9,  ERR WD 4       	
				; b7 1 = ERR 39, TCC STUCK OFF  
				; b6 1 = ERR 41, 1x CAM SENSOR FAIL 
				; b5 1 = ERR 42, IGN ERROR (EST)
				; b4 1 = ERR 43, KNOCK SENSOR CKT    
				; b3 1 = ERR 44, o2 SENSOR LEAN
				; b2 1 = ERR 45, o2 SENSOR RICH 
				; b1 1 = ERR 46, VATS FAIL
				; b0 1 = ERR 47, (not used) 
;    
L5200  	FDB  L000F		; 10,   ERR WD 5   	
				; b7 1 = ERR 48, (not used) 
				; b6 1 = ERR 49, (not used) 
				; b5 1 = ERR 51, EPROM ERROR
				; b4 1 = ERR 52, SYS VDC HI-LONG TEST    
				; b3 1 = ERR 53, HI SYS VOLTAGE  
				; b2 1 = ERR 54, LOW FUEL PUMP VDV 
				; b1 1 = ERR 55, FAULTY COMPUTER (ADU)
				; b0 1 = ERR 56, QUAD DRIVER B FAULT (not used)   
;  
L5202  	FDB  L0008		; 11, IAC MOTOR               	
;    
L5204  	FDB  L0009		; 12, DIACMCW1, IDLE AIR CNT'L NV MODE WD
				; b7    (not used)  
				; b6  = 1st PASS OF ERR 36 HAS FAILED   
				; b5  = WARM IDLE STABLE, A/C ON
				; b4  = WARM IDLE STABLE, A/C OFF    
				; b3    (not used)      
				; b2  = R/S REQUESTED IF BIT CLEAR   
				; b1  = 1st DRIVE AWAY FLAG FOR IAC KICK DOWN LOG   
				; b0  = IAC MOTOR Reset IN WORK
;   
L5206  	FDB  L000A		; 13, DIACMCW2, IDLE AIR CNT'L MODE WD
       				; b7 1 = (not used)   
				; b6 1 = (not used)   
				; b5 1 = (not used)   
				; b4 1 = STEPPER MOTOR 1=ON/0=OFF 	 
				; b3 1 =  COIL B STATE ON 
				; b2 1 =  COIL A STATE ON 
				; b1 1 =  (not used)  
				; b0 1 =  MOTOR DIRECTION, 1=EXTEND  
;    
L5208  	FDB  L0037		; 14, DIACMW4  IAC CNT'L MD WD 
				; b7 1 = ADD DERIV TERM TO g/SEC FLOW, (0 = SUB)
				; b6 1 = PRORP LIMITING ATHORITY BEING EXERSIZED    
				; b5 1 = PART 2 OF DIAG TEST TO BE RUN  
				; b4 1 = THROTTLE KICKER BARO DISABLE REQUESTED    
				; b3 1 = THROTTLE KICKER DISABLE REQUESTED 
				; b2 1 = THROTTLE KICKER ACTIVE    
				; b1 1 = ETC * KONST    
				; b0 1 = ETC ONCE FLAG   
;  
L520A  	FDB  L00A2		; 15, COOL TEMP                     	    
				;      Deg  c = n*.75 - 40
				;      (deg F = 1.35N - 40)
;  
L520C  	FDB  L00A1		; 16, BATTERY A/D                   	    
				; VDC/10    
;  
L520E  	FDB  L00A0		; 17, TPS A/D	
				; BIN = VDC * 50        
;    
L5210  	FDB  L082E		; 18, A/D MAP VALUE	
			        ; BIN = VDC * 50     
;   
L5212  	FDB  L01F8		; 19, o2 VOLTS, (VDC/226)           	    
;   
L5214  	FDB  L003D		; 20, MWAF, AFR MD WORD 0,	
				; b7 1 = DELIVER ASYNC PULSE	
				; b6 1 = ACELLL ENR IS ACTIVE   
				; b5 1 = PWR ENR IS ACTIVE   
				; b4 1 = DECEL ENLEAN IS ACYIVE   
				; b3 1 = DELAY BLM UPDATE   
				; b2 1 = BLK LRN ADDR CHANGE 1 = CHANGED
				; b1 1 = VATS PASS/FAIL    
				; b0 1 = PWR ENR ENR FLAG    
; 
L5216  	FDB  L003B		; 21, SDMW, SERIAL DATA MD WORD	            
				; b7 1 = 2nd BYTE 8192 TX IS PENDING	
				; b6 1 = 8192 TX IN WORK   
				; b5 1 = 8192 TX OVERRUN   
				; b4 1 = IN MODE 4, ($F4),  (not used)   
				; b3 1 = IN MODE 4, ($F5),  (not used)  
				; b2 1 = XMISH DIAG DISABLED   
				; b1 1 = MODE 10 ID $F4 
       	            		; b0 1 = MODE 10 ID $F5      
;  
L5218  	FDB  L0044		; 22, MWBG, MINOR LOOP MODE WD
				; b7 1 = LOCKED IN ERR 42A	
				; b6 1 = 1st GOOD ERR 42A FLAG
				; b5 1 = HIGH MAT CONDITIONS OBSERVED
				; b4 1 = IGNITION OFF
				; b3 1 = 1st DRP VALID 
				; b2 1 = SKIP ERR 43 DUE TO ALDL
				; b1 1 = ACELL ENR CLAMP ACTIVE   
;   
L521A  	FDB  L004F		; 23, MW1, MINOR LOOP MODE WD 1
				;  b7 1 = ENGINE RUNNING	
				;  b6 1 = MAJOR LOOP EST MONITOR ENABLE
				;  b5 1 = VE INT RESET 
				;  b4 1 = RUN FUEL        
				;  b3 1 = OPEN TPS VE FLAG   
				;  b2 1 = LOOP OVERRAN 6,25 MS PERIOD
				;  b1 1 = CHECK ENG LAMP DELAY   
				;  b0 1 = RETARD, 0 = ADVANCE     
; 
L521C  	FDB  L0050		; 24,  MW2, MINOR LOOP MODE WD 2	   
				; b7 1 = IDLE FLAG	
				; b6 1 = IDLE SPARK ENABLED
				; b5 1 = RET PULSE OCCOURED
				; b4 1 = DIAG SW IN DIAG POSIT.    
				; b3 1 = DIAG SW IN FACTORY TEST 
				; b2 1 = DRP OCCOURED 6.25msec TEST   
				; b1 1 = OPN LOOP IDLE FLG FOR AIR SW ENGAGE AT IDLE   
				; b0 1 = SYNC MAP SENSOR READS     
;  
L521E  	FDB  L004D		; 25, I/O D PORT C, I/O PORT C             	  	
       	 		   	; b7 1 = FWD LOW SW (NO) 1=ON  
				; b6     (not used)
				; b5     (not used) 		  
				; b4 1 = RANGE SW 3 OFF 	  						  
				; b3 1 = RANGE SW 2 OFF 	  
				; b2 1 = RANGE SW 1 OFF 	  
				; b1 1 = BK SW ON    		  
				; b0 1 = A/C REQUEST ON 	  
				;
				; PRNDL TABLE:
				; RANGE1  RANGE2 RANGE3  GEAR
				; ---------------------------
				;   0       1      1     Low
				;   1       1      1     Drive2
 				;   1       1      0     Drive3
				;   1       0      0     Drive4
				;   1       0      1     P/N
				;   0       0      1     Reverse
				;
				;     
L5220  	FDB  L0046		; 26, CLCC MW, MAJOR LOOP MODE WD 2
				; b7 1 = HAS BEEN IN CLS LP ONCE SINCE START UP                          	 
				; b6 1 = NON VOL MEM BOMBED   	
				; b5 1 = DECEL FUEL C/O IAC FAST FILTER 
				; b4 1 = OVERSPEED FUEL SHUT OFF    
				; b3 1 = DECEL FUEL C/O    
				; b2 1 = AIR MANAGMENT OFF, 1=ON   
				; b1 1 = SLOW RICH/LEAN, 1 = RICH   
				; b0 1 = SYNC ACELL ENRICH     
;  
L5222  	FDB  L0316		; 27, ADBARO, BARO A/D                  	    
				;	  VDC = N x (5/256)
				;     kPA = (N x 28.06)/2.71
;
L5224  	FDB  L0041		; 28, LCCPWM, TCC A/C & EGR MD WD					                         
       	 			; b7 1 = CCP SOLENOID ON
				; b6 	 (not used)
				; b5 1 = PARK/NEUTRAL
				; b4 1 = A/C PRESSURE SW, (A/C ON)
				; b3 1 = A/C ACEL ENR ENABLED 
				; b2 1 =
				; b1 1 = SPK CORRECTION DUE TO MAT IS NEGITIVE
				; b0 1 = ADJ ... THE EGR OFFSET BY 2 b0 1 =	 (not used)
; 
L5226  	FDB  L003E		; 29,  NWAF1, AIR/FUEL MD WD 1                      	 	
				; b7 1 = CLOSED LOOP FLAG	
				; b6 1 = RICH/ LEAN, 1 = RICH   
				; b5 1 = CLOSED LOOP FOR O/L IDLE CONDITION 
				; b4 1 = ASYNC PULSE FLAG
				; b3 1 = A/F DECAY INT DONE FOR COLD P/D  
				; b2 1 = LOW BATTERY
				; b1 1 = BLM ENABLE    
				; b0 1 = DECELL FUEL C/O TPS ACEL ENRICH    
; 
L5228  	FDB  L0085		; 30, TCCMODE, TCC MODE WD	     
				;  b7 1 = NEG SLIP RECENTLY PREVENTS TCC APPLY
				;  b6 1 = TCC IS BEING APPLIED    
				;  b5 1 = TCC IS IN LOCK ADJ MODE   
				;  b4 1 = TCC IS IN RELEASE MODE SLIPPING   
				;  b3 1 = USE HYST FOR VEHICLE SPEED   
				;  b2 1 = LOW THRESH FOR COPE TCC SELECTED   
				;  b1 1 = TCC ENABLE SOLENIOD VALID   
				;  b0 1 = TCC IS BEING FORCED OFF
;   
L522A  	FDB  L02A7		; 31, FILTMPH,  MPH	 0 - 255 MPH                   	      
				;		MPH/1
				;		KPH = 1.61  
;  
L522C  	FDB  L004C		; 32, IODPORTB,  I/O D PORT B                        
				; b7 1 = M/CLR					
				; b6 1 = REF IRQ CLR   			
				; b5 1 = FORCE MOTOR ENABLE		
				; b4 1 = IAC ENABLE   										
				; b3 1 = IAC COIL B ON   
				; b2 1 = IAC COIL A ON  
				; b1 1 = 2 - 3 SOL ON,	SHIFT B
				; b0 1 = 1 - 2 SOL ON,	SHIFT A
				;
				;
				;  SHIFT B  SHIFT A  GEAR
				;  ----------------------
				;    0        0       3rd
				;    0        1       4th
				;    1        0       2nd
				;    1        1       1st
				;  ----------------------
;   
L522E  	FDB  L0055		; 33, FUEL PUMP                    	     
				; (VDC/10)      	
;   
L5230  	FDB  L0062		; 34, FUEL PUMP, (BATTERY VOLTS * 10)          			       	     
				; 		(VDC/10)     
;     
L5232  	FDB  L3209		; 35, OLDREFPER, LAST MINOR LP DRP FROM ECU (MSB)
L5234  	FDB  L320A		; 36, OLDREFPER+1, LAST MINOR LP DRP FROM ECU (LSB)
				;
				; uSEC / 15.26 8 65536
				;
				; RPM = 983040(MSB*256)+LSB    
				; RPM = ((65536 * 120)/8)/CAL    
				; RPM = 983040/CAL    
				;    
				; CAL = 65536 *(120/(RPM * NUM CYL)    
				;----------------------------- 
;    
L5236  	FDB  L01D2		; 37, EGRDC, EGR D.C                     
				; 	     256/100
;
L5238  	FDB  L0051		; 38, MISC MODE WD	                                   
       				; b7 1 =  TRANSITION FLAG (1 = TRANSITION IN WORK)
				; b6 1 =  START UP SPARK FILTER DONE
				; b5 1 =  DECEL FUEL C/P SPARK FILTER
				; b4 1 =  HIGH BATTERY VOLTAGE     
				; b3 1 =  POWER DOWN IN WORK 
				; b2 1 =  RETEST RAM IN BACKGROUND  
				; b1 1 =  SINGLE FIRE 1st TIME
				; b0 1 =  CPI/PFI SINGLE FIRE, (1 S/F)
;
L523A  	FDB  L30F8		; 39, TIMEENG, ENGINE RUNNING TIME SEC
L523C  	FDB  L30F9		; 40, TIMEENG+1, 
				;	  SEC/1 (16 BIT VALUE)
				; 	  SEC = (MSB * 256) + LSB))  	
;   
L523E  	FDB  L0857		; 41, DESSPD, DESIRED IDLE RPM/12.5               
;  
L5240  	FDB  L0197		; 42, NDTHROPS, TPS FOR ENGINE             	        
				; 	   (CURRENT NON-DEAULT VALUE)   
				;	   % * 2.56
;  
L5242  	FDB  L0052		; 43, MODE WD 4                        	        	
				; b7 1 = QUAIS CLSD LP ENABLED	
				; b6 1 = CAT OVER TEMP
				; b5 1 = A/C ANTICIPATING TO BE ON
				; b4 1 = A/C DISABLED DUE TO HIGH RPM
				; b3 1 = VARIABLE TUNING CNT'L
				; b2 1 = TPS CLOSED, (FOR BLM)
				; b1 1 = ZERO ACTIVITY FLAG (LO OCTANE)
				; b0 1 = HIGH KNOCK ACTIVITY     
; 
L5244  	FDB  L0053		; 44, MODE WD 5 		
				; b7  	 (not used)	
				; b6 1 = SINGLE FIRE ALT EXIT IS DESIRED	    
				; b5 1 = A INJECTOR FIRED AT 1st DRP    
				; b4 1 = PWR STEER CRAMP STALL SAVER    
				; b3 1 = HI RPM INDICATED BY XMISH (ABUSE LOGIC)    
				; b2 1 = SHIFT LIGHT ON    
				; b1 1 = DLATCH ACTIVE    
				; b0 1 = ACTUAL ENGINE RPM OVER DESIRED RPM      
;
L5246  	FDB  L3213		; 45, SAREFFNL FINAL VALUE OF SAREF (MSB)
L5248  	FDB  L3214		; 46, SAREFFNL+1 FINAL VALUE OF SAREF (LSB)
				;	    DEG = N /(256/90)
;
L524A  	FDB  L3226		; 47, PA2OLD, CPU PA1 KNOCK COUNTS FM LAST MINOR LP, (MSB)                     
L524C  	FDB  L3227		; 48, PA2OLD, CPU PA1 KNOCK COUNTS FM LAST MINOR LP, (LSB)
;  
L524E  	FDB  L0232		; 49, INT, CLS LP INTEGRATOR COUNTS                        		
				; 0 - 255    
;   
L5250  	FDB  L02BC		; 50, DESTPS, DESIRED GOVENERING TPS TO BE OUTPUT	
				;	 % * 256/100
;  
L5252  	FDB  L0298		; 51, ALDLCNTR, ALDL RICH LEAN CHAGE COUNTER     
				;    COUNTS
;   
L5254  	FDB  L006E		; 52, EGR MD WD 	                                    
				; b7 1 = EGR ON
				; b6 1 = ERG MPH HYST
				; b5 1 = EGR TPS HYST  
				; b4 1 = EGR MAP HYST  
				; b3 1 = ACELL ENR 1st TIME   
				; b2 1 = EGR HI VAC HYST
				; b1 1 = BURST KNOCK ACTIVE   
				; b0 1 = EGR DIAG INT RESET           
;   
L5256  	FDB  L0075		; 53, GOVMW, ELECTRONIC GOVENOR MD WD                              
				; b7 1 = IN MPH GOVENOR   
				; b6 1 = MPH OVERSPEED   
				; b5 1 =    
				; b4 1 = RPM LEAD TPS RETURN   
				; b3 1 = OVERSPEED LIGHT ON   
				; b2 1 = RPM OVERSPEED
				; b1 1 = GOV LEAD MODE ANTICP RPM GOV'ING
				; b0 1 = IN RPM GOV           
;
L5258  	FDB  L026A		; 54, BLM CELL NUM
				;  (0 - 16)
;
L525A  	FDB  L026B		; 55, BLM MULTIPLIER * 128	
;
L525C  	FDB  L022F		; 56, NOCKRTD, KNOCK RETARD	
				;	  DEG = 45N/256		
				;	  (E6 =  AFR RATIO * 10)	
;	
L525E  	FDB  L326F		; 57, INJ PW, MSB	
L5260  	FDB  L3270		; 58, INJ PW, LSB	
				;	
				; (MSB*256) + LSB))/65.536	
				; 	
				; MSEC/65.536    
;  
L5262  	FDB  L01D1		; 59, DSEGRPOS, DESIRED EGR CMD,	
				; 	   	% * 2.56
;
L5264  	FDB  L01DC		; 60, CCP DUTY CYCLE 	
				; 		%/2.56 
;
L5266  	FDB  L01D7		; 61, AEGRPOS  LINEAR EGR POS  
				;	 (A/D VAL)
;
L5268  	FDB  L01F9		; 62,  PURGEDC, PURGE D.C
				;  	  % * 2.56
;
L526A  	FDB  $0855		; 63, MATDEGA,  NON DEFAULTED MAT
				;	   	N= (DEG C - 40) * 256/192
				;  		N= (DEG C - 40) * 256/192    
;
;---------------------------------------------
; DEVICE ID $F4, MODE 1/1	
;
; 03-05-1996  Dissassemby of BDWM
;
;---------------------------------------------
;
L526C  	FDB  $0000		; NEXT ENRTY ADDRESS	
;
L526E  	FCB  $F4		; DEVICE ID	
;
L526F	FCB  $80		; MEM FLAG, FORM RPM TBL	
L5270  	FDB  64			; NUM OF BYTES TO TX	
;
L5272  	FDB  L036E		; ADDR OF OUTPUT BUFFER	
L5274  	FDB  L036E		; ADDR OF INPUT BUFFER	
;
L5275   FDB L003D 		; 1, AFR MD WORD 0,	
				; b7 1 = DELIVER ASYNC PULSE	
  				; b6 1 = ACELLL ENR IS ACTIVE   
				; b5 1 = PWR ENR IS ACTIVE   
				; b4 1 = DECEL ENLEAN IS ACYIVE   
				; b3 1 = DELAY BLM UPDATE   
				; b2 1 = BLK LRN ADDR CHANGE 1 = CHANGED
				; b1 1 = VATS PASS/FAIL    
				; b0 1 = PWR ENR ENR FLAG    
;    
L5277   FDB L01F8		;  2, o2 VOLTS, (VDC/226)           	    
; 
L5279   FDB L003E		;  3, AFR MD WD 1                      	 	
				; b7 1 = CLOSED LOOP FLAG	
				; b6 1 = RICH/ LEAN, 1 = RICH   
				; b5 1 = CLOSED LOOP FOR O/L IDLE CONDITION 
				; b4 1 = ASYNC PULSE FLAG
				; b3 1 = A/F DECAY INT DONE FOR COLD P/D  
				; b2 1 = LOW BATTERY
				; b1 1 = BLM ENABLE    
				; b0 1 = DECELL FUEL C/O TPS ACEL ENRICH    
;  
L527B   FDB L02EB		;  4, "CHOKE" AFR VALUE
;
L527D   FDB L0315		;  5,
;
L527F   FDB L00A2		;  6, COOL TEMP                     	    
				;   		Deg  c = n*.75 - 40
				;   		(deg F = 1.35N - 40)
;
L5281   FDB L0262		;  7,
;
L5283   FDB L087F		;  8, Acell Enrich PW ADDER
;		  
L5285   FDB L0261		;  9,
;
L5287   FDB L02EE		; 10, SPK
;
L5289   FDB L025E 		; 11,
;
L528B   FDB L026D		; 12, AFR
;
L528D   FDB L01EF		; 13, BARO
;
L528F   FDB L01EA		; 14, OLD MAP
;
L5291   FDB L01FF		; 15, OLD TPS
;
L5293   FDB L026B		; 16, BLM	
;
L5295   FDB L026A		; 18, BLM CELL NUM
				;  (0 - 16)
;
L5297   FDB L0036		; 19, IAC DIAG MD WD 3	       
				; b7 1 = ADD DERIV TERM TO g/SEF FLOW   
				; b6 1 = PRORP LIMITING ATHORITY BEING EXERSIZED    
				; b5 1 = PART 2 OF DIAG TEST TO BE RUN  
				; b4 1 = THROTTLE KICKER BARO DISABLE REQUESTED 
				; b3 1 = THROTTLE KICKER DISABLE REQUESTED 
				; b2 1 = THROTTLE KICKER ACTIVE    
				; b1 1 = ETC * KONST    
				; b0 1 = ETC ONE FLAG   
; 
L5299   FDB L0006		; 20 COOL
;
L529B   FDB L0871		; 21 IAC FLOW 
;
L529D   FDB L02D0		; 22
;
L529F   FDB L0873		; 23
;
L52A1   FDB L02D2		; 24
;
L52A3   FDB L02C8		; 25 IAC FLOW Vs. COOL
;
L52A5   FDB L02C6		; 26  IAC FLOW Vs. COOL
;
L52A7   FDB L0875		; 27 IAC COLD OFFSET DELAY PERIOD
;
L52A9   FDB L0857		; 28, DESSPD, DESIRED IDLE 
				; RPM/12.5        
;
L52AB   FDB L0254		; 29, VE TABLE RESULTS
;
L52AD   FDB L01D1		; 30, DESIRED EGR POSIT 	
				; %/2.56 
;
L52AF   FDB L01D5		; 31
;
L52B1   FDB L022E		; 32. ??? SPK BIAS
;
L52B3   FDB L022D		; 33. LO OCT BASE SPK RETARD SPK
;
L52B5   FDB L02A7		; 34, FILTMPH,  MPH	 0 - 255 MPH                   	      
				;	MPH/1
				;	KPH = 1.61  
;
L52B7   FDB L0882		; 35
;
L52B9   FDB L029E		; 36
;
L52BB   FDB L0255		; 37
;
L52BD   FDB L088B		; 38
;
L52BF   FDB L02CA		; 39
;
L52C1   FDB L02C0		; 40
;
L52C3   FDB L02CC		; 41
;
L52C5   FDB L02C2		; 42
;
L52C7   FDB L02CD		; 43
;
L52C9   FDB L02C3		; 44
;
L52CB   FDB L02CF		; 45
;
L52CD   FDB L02C5		; 46
;
L52CF   FDB L086D		; 47
;
L52D1   FDB L0232		; 48, INTEGRATOR                        		
				; 0 - 255    
;
L52D3   FDB L0862		; 49
;
L52D5   FDB L0007		; 50, IAC, PRESSENT MOTOR POSIT         
				; 0 to MAX IAC (typ 145)
;
L52D7   FDB L027A		; 51, CURRENT MAP VALUE
				;      (n+28.05)/2.71
;
L52D9   FDB L0202		; 52
;
L52DB   FDB L01FC		; 53,  TPS
;
L52DD   FDB L0214		; 54
;
L52DF   FDB L029D		; 55
;
L52E1   FDB L02F1		; 56
;
L52E3   FDB L0859		; 57
;
L52E5   FDB L0217		; 58
;
L52E7   FDB L0219		; 59 SPARK
;
L52E9   FDB L00F9		; 60,                                    
				; b7 1 =    
				; b6 1 =    
				; b5 1 =    
				; b4 1 =    
				; b3 1 =    
				; b2 1 =    
				; b1 1 =    
				; b0 1 =            
;
L52EB   FDB L00B1		; 61
;
L52ED   FDB L00B2		; 62
;
L52EF   FDB L026F		; 63
;
L52F1   FDB L0270		; 64
;
;---------------------------------------------
; DEVICE ID $F4, MODE 1/2 
;
;
;
;---------------------------------------------
;
L52F3  	FDB	$0000		;
;
L52F5  	FCB	$F4		; DEVICE ID
;
L52F6  	FCB	$80		; MEM FLAG, TBL FROM ROM
;			
L52F7  	FCB	 37		; NUM BYTE TO TX
;
L52F8  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L52FA  	FDB  L036E		; ADDR OF INPUT BUFFER
;
L52FC  	FDB  L00B1		;  1,
;
L52FE  	FDB  L00B2		;  2,
;
L5300  	FDB  L027A		;  3, CURRENT MAP VALUE
;
L5302  	FDB  L0214		;  4,
;
L5304  	FDB  L00A2		;  5, COOL TEMP                     	    
				;  Deg  c = n*.75 - 40
				;  (deg F = 1.35N - 40)
;
L5306  	FDB  L0007		;  6, IAC, PRESSENT MOTOR POSIT         
				; 0 to MAX IAC (typ 145)
;
L5308  	FDB  L026D		;  7, AFR
;
L530A  	FDB  L00F9		;  8,                                    
				; b7 1 =    
				; b6 1 =    
				; b5 1 =    
				; b4 1 =    
				; b3 1 =    
				; b2 1 =    
				; b1 1 =    
				; b0 1 =            
;   
L530C  	FDB  L01FC		;  9,  TPS
;
L530E  	FDB  L02A7		; 10, FILTMPH,  MPH	 0 - 255 MPH                   	      
				;	MPH/1
				;	KPH = 1.61  
;   
L5310  	FDB  L0873		; 11,
;
L5312  	FDB  L0871		; 12, IAC FLOW
;
L5314  	FDB  L0889		; 13,
;
L5316  	FDB  L02F1		; 14,
;
L5318  	FDB  L0857		; 15, DESSPD, DESIRED IDLE               
				; RPM/12.5        
;
L531A  	FDB  L088B		; 16,
;
L531C  	FDB  L0862		; 17,
;
L531E  	FDB  L0879		; 18,
;
L5320  	FDB  L0876		; 19, %IAC FLOW MAX STEP FOR A/C OFF/ON
;
L5322  	FDB  L02EB		; 20, "CHOKE" AFR VALUE
;
L5324  	FDB  L026B		; 21,, BLM
;	
L5326  	FDB  L00A1		; 22,, BATTERY A/D                   	    
				; VDC/10    
;
L5328  	FDB  L0232		; 23, INTEGRATOR                        		
				; 0 - 255    
; 
L532A  	FDB  L029E		; 24,
;
L532C  	FDB  L02EE		; 25, SPK
;
L532E  	FDB  L02A3		; 26, 
;
L5330  	FDB  L01F8		; 27, o2 VOLTS, (VDC/226)           	    
;
L5332  	FDB  L022F		; 28,
;
L5334  	FDB  L026A		; 29, BLM CELL NUM
				;  (0 - 16)
;
L5336  	FDB  L0255		; 30,
;
L5338  	FDB  L01F5		; 31,
;
L533A  	FDB  L01EC		; 32, CURRENT VACUUM VALUE
;
L533C  	FDB  L0261		; 33,
;
L533E  	FDB  L0262		; 34,
;
L5340  	FDB  L026F		; 35,
;
L5342  	FDB  L0270		; 36,
;
L5344  	FDB  L01D0		; 37,
;
;----------------------------------------------
; not used
;
;----------------------------------------------
;
L5346  	FDB  L0051		; 38,  
;
L5348  	FDB  L30F7		; 39, 
; 
L534A  	FDB  L30F8		; 40, TIMING, (MSB) ENGINE RUNNING TIME SEC
;
L534C  	FDB  L0857		; 41,  DESSPD, DESIRED IDLE
				;	RPM/12.5
;
L534E  	FDB  L01FA		; 42,
;
L5350  	FDB  L0052		; 43, MODE WD 4                            	       
				; b7 1 = QUAIS CLSD LP ENABLED	
				; b6 1 = CAT OVER TEMP
				; b5 1 = A/C ANTICIPATING TO BE ON
				; b4 1 = A/C DISABLED DUE TO HIGH RPM  
				; b3 1 = VARIABLE TUNING CNT'L
				; b2 1 = TPS CLOSED, (FOR BLM)
				; b1 1 = ZERO ACTIVITY FLAG (LO OCTANE)
				; b0 1 = HIGH KNOCK ACTIVITY     
;    
L5352  	FDB  L0053		; 44,  MODE WD 5 		
				; b7  	 (not used)	
				; b6 1 = SINGLE FIRE ALT EXIT IS DESIRED	    
				; b5 1 = A INJECTOR FIRED AT 1st DRP    
				; b4 1 = PWR STEER CRAMP STALL SAVER    
				; b3 1 = HI RPM INDICATED BY XMISH (ABUSE LOGIC)    
				; b2 1 = SHIFT LIGHT ON    
				; b1 1 = DLATCH ACTIVE    
				; b0 1 = ACTUAL ENGINE RPM OVER DESIRED RPM      
;
L5354  	FDB  L3211		; 45,
; 
L5356  	FDB  L3212		; 46, 
;	
L5358  	FDB  L3224		; 47, 
;
L535A  	FDB  L3225		; 48, 
;
L535C  	FDB  L0230		; 49, 
;
L535E  	FDB  L02BA		; 50, 
;.
L5360  	FDB  L0296		; 51, 
;
L5362  	FDB  L006E		; 52, EGR MD WD 	                              
				; b7 1 = EGR ON
				; b6 1 = ERG MPH HYST
				; b5 1 = EGR TPS HYST  
				; b4 1 = EGR MAP HYST 
				; b3 1 = ACELL ENR 1st TIME   
				; b2 1 = EGR HI VAC HYST
				; b1 1 = BURST KNOCK ACTIVE   
				; b0 1 = EGR DIAG INT RESET           
;
L5364  	FDB  L0075		; 53, ELECTRONIC GOVENOR MD WD                             
				; b7 1 = IN MPH GOVENOR   
				; b6 1 = MPH OVERSPEED   
				; b5 1 =    
				; b4 1 = RPM LEAD TPS RETURN   
				; b3 1 = OVERSPEED LIGHT ON   
				; b2 1 = RPM OVERSPEED
				; b1 1 = GOV LEAD MODE ANTICP RPM GOV'ING
				; b0 1 = IN RPM GOV           
;
L5366  	FDB  L0268		; 54, DECEL FUEL C/O EXIT TIMER
;
L5368  	FDB  L0269		; 55,
;
L536A  	FDB  L026C		; 56,
;
L536C  	FDB  L326D		; 57,
;
L536E  	FDB  L326E		; 58,
;
L5370  	FDB  L01CF		; 59,
;
L5372  	FDB  L01DA		; 60,
;
L5374  	FDB  L01D5		; 61,
;
L5376  	FDB  L01F7		; 62, OLD o2 VDC
;
L5378  	FDB  L0855		; 63, LINEAR MAT VAL   	
				; (DEG C + 40) * (256/192) 
;
;----------------------------------------------
;  DEVICE ID $F4, MODE 2
;  64 ADDRESS SEQUENTIAL MEM DUMP
;
;----------------------------------------------
;
L537A  	FDB  $0000 		; NEXT ENRTY ADDRESS
;
L537C  	FCB  $F4		; DEVICE ID
;
L537D  	FCB  $40		; MEM FLAG, TBL FM RAM
;
L537E  	FCB   65		; NUM BYTES TO TX
					;
L537F  	FCB  L036E		; ADDR OF OUTPUT BUFFER
L5381  	FCB  L036E		; ADDR OF INPUT BUFFER
;----------------------------------------------
;		
;----------------------------------------------
;  DEVICE ID $F4, MODE 3
;
;  SEQUENTIAL 8 ADDRESS MEM DUMP
;----------------------------------------------
;
L5383  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L5385  	FCB  $F4		; DEVICE ID
;
L5386  	FCB  $40		; MEM FLAG, TBL FM RAM
L5387  	FCB    9		; NUM BYTES TO TX
;
L5388  	FCB  L036E		; ADDR OF OUTPUT BUFFER
L538A  	FCB  L036E		; ADDR OF INPUT BUFFER
;---------------------------------------------
;
;---------------------------------------------
;  DEVICE ID $F4, MODE 4  
;
;  'CONTROLER MODE'
;---------------------------------------------
;
L538C  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L538E  	FCB  $F4		; DEVICE ID
;
L538F  	FCB   00		; MEM FLAG, NONE
L5390  	FCB    1		; NUM BYTES TO TX
;
L5391  	FCB  L036E		; ADDR OF OUTPUT BUFFER
L5393  	FCB  L036E		; ADDR OF INPUT BUFFER
;---------------------------------------------
;
;---------------------------------------------
;  DEVICE ID $F4, MODE  10
;
;  MODE 10, ALDL ERR RESET
;---------------------------------------------
;
L5395  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L5397  	FCB  $F4		; DEVICE ID
;
L5398  	FCB    0		; MEM FLAG, NONE
L5399  	FCB    1		; NUM BYTES TO TX
;
L539A  	FCB  L036E		; ADDR OF OUTPUT BUFFER
L539C  	FCB  L036E		; ADDR OF INPUT BUFFER
;---------------------------------------------
;
;**********************************************
;* $F5 TABLES
;*
;**********************************************
;---------------------------------------------
;  DEVICE ID $F5, MODE 
;
;
;---------------------------------------------
;
L539E  	FDB  L53BF		; NEXT ENRTY ADDRESS
;
L53A0  	FCB  $F5		; DEVICE ID
;
L53A1  	FCB    0		; MEM FLAG, NONE
L53A2  	FCB  128 		; NUM BYTES TO TX
;
L53A3  	FCB  L036E		; ADDR OF OUTPUT BUFFER
L53A5  	FCB  L036E		; ADDR OF INPUT BUFFER
;
L53A7  	FDB  L53BF		;  0, DEVICE ID $F5, MODE 0, RESET NORMAL COMM
L53A9  	FDB  L53CE		;  1, DEVICE ID $F5, MODE 1, SCAN TOOL DATA
L53AB  	FDB  L5549		;  2, DEVICE ID $F5, MODE 2, 64 ADDRESS MEM DUMP
L53AD  	FDB  L5552		;  3, DEVICE ID $F5, MODE 3, SEQUENTIAL 8 ADDRESS MEM DUMP
L53AF  	FDB  L555B		;  4, DEVICE ID $F5, MODE 4, CONTROLER MODE
L53B1  	FDB  $0000		;  5, not used 
L53B3  	FDB  $0000		;  6, not used 
L53B5  	FCB  $0000		;  7, not used
L53B7  	FCB  $0000		;  8, not used
L53B9  	FCB  $0000		;  9, not used
L53BB  	FCB  L5564		; 10, DEVICE ID $F5, MODE 10, ALDL ERR RESET
L53BD  	FCB  $0000		; 11, not used
;----------------------------------------------
;
;----------------------------------------------
; DEVICE ID $F5
; MODE 0, RESET NORMAL COMM
;
;    MODE 0 (RETURN TO NORMAL MODE)
;            ALDL REQUEST:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $56
;            - MODE           = $00
;            - SUM CHECK
;
;            ECM RESPONSE:
;              NONE
;----------------------------------------------
;
L53BF  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L53C1  	FCB  $F5		; DEVICE ID
;
L53C2  	FCB    0		;
L53C3  	FCB    1		; NUM BYTES TO TX
;
L53C4  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L53C6  	FDB  L036E		; ADDR OF INPUT BUFFER 
;----------------------------------------------
;	
;----------------------------------------------
L53C8  	FDB  L53CE		; 1, DEVICE ID $F5, MODE 1, MESSAGE 0, (66 bytes)
L53CA  	FDB  L545B		; 2, DEVICE ID $F5, MODE 1, MESSAGE 1, (30 bytes)
L53CC  	FDB  L54A0		; 3, DEVICE ID $F5, MODE 1. MESSAGE 3, (80 bytes) 
;----------------------------------------------
;
;----------------------------------------------
;  DEVICE ID $F5, MODE 1
;  PCM TYPE $0D 
: 
; ALDL MODE 1, MESSAGE 0 DATA LIST
;	TRANSMISSION DATA STREAM INFORMATION MY 94/95 PCM-6 VEHICLES 
;    WITH A 4L60E TRANSMISSION.
;    MODE 1 (TRANSMIT FIXED DATA STREAM)
;            ALDL REQUEST:
;            - MESSAGE ID     = $F5
:            - MESSAGE LENGTH = $57
;            - MODE           = $01
;            - MESSAGE        = $00
;            - SUM CHECK
;
;            THE PCM WILL RESPOND WITH THE FOLLOWING MESSAGE:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $98
;            - MODE           = $01
;            - DATA BYTE 1
;              .
;              .
;            - DATA BYTE 66
;            - SUM CHECK
;
;
; (SCAN TOOL MODE)
;----------------------------------------------
;
L53CE  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L53D0  	FCB  $F5		; DEVICE ID
;
L53D1  	FCB  $80 		; MEM FLAG, TBL FROM ROM
L53D2  	FCB   67		; 66 BYTES TO TX
					;
L53D3  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L53D5  	FDB  L036E		; ADDR OF INPUT BUFFER
;
;-----------------------------
L53D7  	FDB  L000B		;  1, ERR MD WD 1                     	
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, 2002 PPM VEH. SPEED SENSOR FAILURE      
				; b3 1 = ERR 17, not used, (RPM SIGNAL PROBLEM)
				; b2 1 = ERR 18, not used, (CAM CRANK ERROR)
				; b1 1 = ERR 19, not used    
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L53D9  	FDB  L0016		;  2, CURRENT ERR MD 1                    		
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, Vss BUFFER       
				; b3 1 = ERR 17, not used,  (RPM SIGNAL PROBLEM)     
				; b2 1 = ERR 18, not usedC, (CAM CRANK ERROR)
				; b1 1 = ERR 19, not used    
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L53DB  	FDB  L000C		;  3, ERR WD 2                    		
				; b7 1 = ERR 22, LOW TPS     
				; b6 1 = ERR 23, LOW MAT     
				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW     
				; b3 1 = ERR 26	 not used
				; b2 1 = ERR 27	 not used
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29, not used
;-----------------------------    
L53DD  	FDB  L0017		;  4,   CURRENT ERR WD 2
					;	
				; b7 1 = ERR 22, THROTTLE POSITION LOW     
				; b6 1 = ERR 23, MAT SENSOR LOW     
				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW    
				; b3 1 = ERR 26, (not used)
				; b2 1 = ERR 27, (not used)
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29, (not used)
;-----------------------------    
L53DF  	FDB  L000D		;  5, ERR MD WD 3		                		
				; b7 1 = ERR 31, GOVERNOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SNENSOR LOW      
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36,  not used, (IAC THROTTLE KICKER FAIL)     
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON    
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF    
;-----------------------------    
L53E1  	FDB  L0018		;  6,   CURRENT ERR WD 3	
				; b7 1 = ERR 31, GOVERNOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SENSOR LOW    
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, not used, (IAC THROTTLE KICKER FAIL)
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON   
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF  
;-----------------------------    
L53E3  	FDB  L000E		;  7, ERR MD WD 4		                 		
				; b7 1 = ERR 39, TCC STUCK OFF     
				; b6 1 = ERR 41, 1x CAM SENSOR     
				; b5 1 = ERR 42, IGN ERROR    
				; b4 1 = ERR 43, KNOCK SENSOR CKT     
				; b3 1 = ERR 44, OXYGEN SENSOR LEAN    
				; b2 1 = ERR 45, OXYGEN SENSOR RICH     
				; b1 1 = ERR 46, VATS FAIL    
				; b0 1 = ERR 47, not used    
;-----------------------------    
L53E5  	FDB  L0019		;  8,  CURRENT ERR WD #4	
				;  b7 1 = ERR 39, TCC STUCK OFF   
				;  b6 1 = ERR 41, 1x CAM SENSOR   
				;  b5 1 = ERR 42, IGN ERROR    
				;  b4 1 = ERR 43, KNOCK SENSOR CKT    
				;  b3 1 = ERR 44, OXYGEN SENSOR LEAN    
				;  b2 1 = ERR 45, OXYGEN SENSOR RICH     
				;  b1 1 = ERR 46, VATS FAIL    
				;  b0 1 = ERR 47, (not used)    
;-----------------------------    
L53E7  	FDB  L000F		; 9, ERR MD WD 5				        	
				; b7 1 = ERR 48. (not used)   
				; b6 1 = ERR 49, (not used)  	
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, SYSTEM VOLTAGE HIGH-LONG TEST    
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, FUEL PUMP RELAY MALFUNCTION    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, QUAD DRIVER B FAULT    
;-----------------------------    
L53E9  	FDB  L001A		; 10, CURRENT ERR WD 5	
				; b7 1 = ERR 48. (not used)   
				; b6 1 = ERR 49, (not used)	
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, MISSING FUEL CALPACK     
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, LOW FUEL PUMP VDC    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, not used, (QUAD DRIVER B FAULT)
;-----------------------------    
L53EB  	FDB  L0010		; 11, MALFFLG6, ERROR WD 6
				; b7 1 = ERR 57. (not used)
				; b6 1 = ERR 58, TRANSMISSION TEMPERATURE HI
				; b5 1 = ERR 59, TRANSMISSION TEMPERATURE LO
				; b4 1 = ERR 61, TURBO BOOST SENSOR HIGH
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW 
				; b2 1 = ERR 63, BAROMETRIC PRESSURE SENSOR HI
				; b1 1 = ERR 64, BAROMETRIC PRESSURE SENSOR	LO
				; b0 1 = ERR 65, not used
;-----------------------------
L53ED  	FDB  L001B		; 12,  CURMALF5, CURRENT ERROR WD 6 
				; b7 1 = ERR 57. (not used)
				; b6 1 = ERR 58, TRANSMISSION TEMPERATURE HI
				; b5 1 = ERR 59, TRANSMISSION TEMPERATURE LOW
				; b4 1 = ERR 61, TURBO BOOST SENSOR HI
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW
				; b2 1 = ERR 63, BAROMETRIC  SENSOR HI
				; b1 1 = ERR 64, BAROMETRIC  SENSOR LOW
				; b0 1 = ERR 65. (not used)
;-----------------------------    
L53EF  	FDB  L0011		; 13,  MALFFLG7, ERROR WD 7
				; b7 1 = ERR 66  3-2 DS QDM2/SOLENOID FAILURE
				; b6 1 = ERR 67  TCC EN QDM2/SOLENOID FAILURE
				; b5 1 = ERR 68  TRANSMISSION COMPONENT SLIPPING
				; b4 1 = ERR 69  TCC ON
				; b3 1 = ERR 71  ENGINE SPEED LOW
				; b2 1 = ERR 72  OUTPUT SPEED LOSS
				; b1 1 = ERR 73  FORCE MOTOR CURRENT
				; b0 1 = ERR 74  INPUT SPEED SENSOR
;-----------------------------
L53F1  	FDB  L001C		; 14, CURMALF7, CURRENT ERROR WD 7
				; b7 1 = ERR 66, 3-2 DS QDM2/SOLENOID FAIL
				; b6 1 = ERR 67, TCC EN QDM2/SOLENOID FAIL
				; b5 1 = ERR 68, XMISH COMPONENT SLIPPING
				; b4 1 = ERR 69, TCC ON
				; b3 1 = ERR 71, ENGINE SPEED LOW
				; b2 1 = ERR 72, OUTPUT SPEED LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, INPUT SPEED SENSOR
;-----------------------------    
L53F3  	FDB  L0012		; 15, MALFFLG8, ERROR WD 8
				; b7 1 = ERR 75  SYSTEM VOLTAGE LOW
				; b6 1 = ERR 76  not used
				; b5 1 = ERR 77  MNP SWITCH
				; b4 1 = ERR 78  not used
				; b3 1 = ERR 71, ENGINE SPEED LOW
				; b2 1 = ERR 72, OUTPUT SPEED LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, INPUT SPEED SENSOR
;-----------------------------
L53F5  	FDB  L001D		; 16, CURMALF8, CURRENT ERROR WD 8
				; b7 1 = ERR 75, SYSTEM VDC LOW
				; b6 1 = ERR 76, (not used)
				; b5 1 = ERR 77, NMP SWITCH
				; b4 1 = ERR 78, (not used) 
				; b3 1 = ERR 79, XMISH HOT
				; b2 1 = ERR 81, SHIFT SOLENOID B FAIL
				; b1 1 = ERR 82, SHIFT SOLENOID A FAIL
				; b0 1 = ERR 83, TCC SOLENOID FAIL
;-----------------------------
L53F7  	FDB  L0013		; 17,   MALFFLG9, CURRENT ERROR WD 9
				; b7 1 = ERR 84  not used
				; b6 1 = ERR 85  RATIO-UNDEFINED REGION
				; b5 1 = ERR 86  SOLENOID B STUCK ON
				; b4 1 = ERR 87  SOLENOID B STUCK OFF 
				; b3 1 = ERR 88	 not used
				; b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				; b1 1 = ERR 91  not used
				; b0 1 = ERR 92  not used
;-----------------------------
L53F9  	FDB  L001E		; 18,  CURMALF9, CURRENT ERROR WD 9
				; b7 1 = ERR 84  not used
				; b6 1 = ERR 85  RATIO-UNDEFINED REGION
				; b5 1 = ERR 86  SOLENOID B STUCK ON
				; b4 1 = ERR 87  SOLENOID B STUCK OFF 
				; b3 1 = ERR 88	 not used
				; b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				; b1 1 = ERR 91  not used
				; b0 1 = ERR 92  not used
;-----------------------------
L53FB  	FDB  L00A0 		; 19,  17, TPS A/D	
				; BIN = VDC * 50        
;-----------------------------    
L53FD  	FDB  L00A6		; 20, BARO, BAROMETRIC PRESSURE
				;   	   	VOLTS = N * (5/256)
				;   	   	(kpa = (N + 28.06)/2.71)
;-----------------------------
L53FF  	FDB  L319D		; 21,  NE,   ENGINE SPEED, (MSB)
L5401  	FDB  L319E		; 22,  NE+1, ENGINE SPEED, (LSB)
;		RPM/8
;-----------------------------
L5403  	FDB  L30BC		; 23, NT,   ENGINE SPEED, (MSB)
L5405  	FDB  L30BD		; 24, NT+1, ENGINE SPEED, (LSB)
				;		RPM/8
;-----------------------------
L5407  	FDB  L30C0		; 25, FILTERED TURBINE SPEED MSB
L5409  	FDB  L30C1		; 26, FILTERED TURBINE SPEED LSB
				;		RPM/8    
;-----------------------------
L540B  	FDB  L00D1		; 27, VEHSPEEN,  VEHICLE SPEED (FILTERED
				;		MPH/2
;-----------------------------
L540D  	FDB  L00DC		; 28, PRESSURE, CURRENT TQ SIG PRESS
				; 		PSI/1
;----------------------------
L540F  	FDB  L0147		; 29, CURRENT, REF CURRENT FORCE MTR CKT
				;		AMP = N/51.2
;----------------------------
L5411  	FDB  L0148		; 30, CURRENT, ACTUAL FM CURRENT FM SHUNT (A/D)
				;		AMP = N/51.2
;----------------------------
L5413  	FDB  L0146		; 31, FMDC, FORCE MOTOR D.C.
				; 		% = N/2.56
;----------------------------
L5415  	FDB  L009C		; 32, PRNDLFLG, CURRENT STATE OF XMISH RANGE SEL				
				; 		b7 1 = ILLEGAL RANGE
				; 		b6 1 = PK/NEUT
				; 		b5 1 = REVERSE
				; 		b4 1 = (ot used)
				; 
				; 		b3 1 = DRIVE 4
				; 		b2 1 = DRIVE 3
				; 		b1 1 = DRIVE 2
				; 		b0 1 = LOW GEAR
;-----------------------------
L5417  	FDB  L00A1		; 33, ADBAT, BATTERY VOLTS                   	    
				; 				VDC/10    
;-----------------------------
L5419  	FDB  L3124		; 34,  TCCDC,   TCC PWM SOLENOID DC, (MSB)
L541B  	FDB  L3125		; 35,  TCCDC+1, TCC PWM SOLENOID DC, (MSB)
				;	  % = (256MSB + LSB)/655.36
;-----------------------------
L541D  	FDB  L30F3		; 36,  RATIO,   XMISH (INPUT SPD/OUTPUT SPD) NI/NO, (MSB)
L541F  	FDB  L30F4		; 37,  RATIO+1, XMISH (INPUT SPD/OUTPUT SPD) NI/NO, (MSB)
				;				RATIO = N/16384
;-----------------------------
L5421  	FDB  L00D3		; 38, GEAR, CURRENT GEAR
				;		GEAR = N + 1
;----------------------------
L5423  	FDB  L0145		; 39, CURCELL, CURRENT ADPTIVE MOD'ER INDEX W/IN TBL
				; 		CELL = N
;----------------------------
L5425  	FDB  L0144		; 40,  CURADP, CURRENT ADAPTIVE MODIFIER 
				;		ADPT/1
;----------------------------
L5427  	FDB  L0082		; 41, TRSTATUS, 
				; b7 1 = POWERTRAIN IS IN MOTIION (SOME SPEED <> 0)
				; b6  	 ELCO INSTRUMENTATION PROM IS PRESEN
				; b5  	 (not used)
				; b4  	 NV RAM UPDATING IS ALLOWED
				; b3 1 = POWER IS ON (IGN1 > THRESH)
				; b2 1 = FORCE MOTOR PULSE IN PROGRESS
				; b1 1 = not usedT
				; b0 1 = FORCE MOTOR SHUT OFF DUE TO LOW BATTERY VOLTAGE
;----------------------------
L5429  	FDB  L012D		; 42, ADAPTBL, ADAPT WORD FOR SERVICE
				; b7 1 = TPS CHANGED TOO MUCH
				; b6 	 not used
				; b5 1 = LONG SHIFT DELAY TIME
				; b4 1 = VEHICLE SPEED CHANGED TOO MUCH 	 
				; b3 	 not used
				; b2 1 = TPS OUT OF RANGE 	 
				; b1 1 = THROTTLE OUT OF RANGE
				; b0 1 = LAST SHIFT WAS USABLE FOR ADAPTING  0 = UNUSABLE
;----------------------------
L542B  	FDB  L012C		; 43, TCCSTAT, TCC STATUS FOR SERVICE
				; b7 1 = SLIP CONTINGENCY FORCED TCC OFF 
				; b6 1 = A/C  CONTINGENCY FORCED TCC OFF  
				; b5 1 = TCC IS IN LOCK ADJ MODE	 
				; b4 1 = NEG DELTA TPS FORCED TCC OFF
				; b3 1 = BRAKE ON FORCED TCC OFF
				; b2  	 (not used) 
				; b1 1 = MIN TPS CONTINGENCY FORCED TCC OFF 
				; b0 1 = RANGE CONTINGENCY FORCED TCC OFF
;----------------------------
L542D  	FDB  L0135		; 44, ERROR12, ERR BETWEEN DESIRED & ACTUAL SHIFT TIMES 
				;			   FOR LATEST 1-2 UPSHIFT  1=1/32 SEC
				;			    SEC. = N/40
;-----------------------------
L542F  	FDB  L0136		; 45, ERR0R23, ERR BETWEEN DESIRED & ACTUAL SHIFT TIMES 
				;			   FOR LATEST 2 -> 3 1=1/32 SEC
				;					SEC = N/40
;-----------------------------
L5431  	FDB  L30E5		; 46, SLIP,   ABSOLUTE VAL OF SLIP (MSB)
L5433  	FDB  L30E6		; 47, SLIP+1, ABSOLUTE VAL OF SLIP (LSB)
				;	   TPM/8 (signed value)
;-----------------------------
L5435  	FDB  L0132		; 48, TIME12, TIME OF LATEST 1->2 SHIFT
				;		SEC = N/40
;-----------------------------
L5437  	FDB  L0133		; 49, TIME23, TIME OF LATEST 3->3 SHIFT
				;		SEC = N/40
				;
;-----------------------------
L5439  	FDB  L0083		; 50, TEMPMW       TEMPER STATUS WORD 
				; b7 1 = not used
				; b6 1 = not used
				; b5 1 = not used
				; b4 1 = not used   	 
				; b3 1 = not used   
				; b2 1 = not used
				; b1 1 = HOT  TEMPERATURE THRESHOLD
				; b0 1 = COLD TEMPERATURE THRESHOLD
;-----------------------------
L543B  	FDB  L0096		; 51, DIRFLAGS, BIT STATUS WORD
				; b7 1 = DIAGNOSTICS REQUESTED
				; b6 1 = CRUISE LOW ACTIVE
				; b5 1 = 4 WD LOW ACTIVE
				; b4 1 = KICK DN PATTERN ACTIVE  	 
				; b3     (not used)
				; b2 1 = PWR ENRICH ACTIVE
				; b1 1 = A/C COMPRESSOR ENGAGED
				; b0 1 = BRAKE ON
;-----------------------------
L543D  	FDB  L004B		; 52, IODPORTA,  I/O D PORT A
				; b7 1 = TCC ENABLE			0=OFF  1=ON	  
				; b6 1 = BYPASS (FROM REST)		  
				; b5 1 = BYPASS MONTR (FROM REST) 
				; b4 1 = BYPASS CTRL (FROM REST)  
				; b3 1 = 3->2 DN SHIFT FEEDFBACK 	0=ON    1=OFF
				; b2 1 = TCC R\ENABLE FEEDFBACK		0=ON    1=OFF
				; b1 1 = SHIFT B FEEDFBACK		0=ON    1=OFF
				; b0 1 = SHIFT A FEEDFBACK		0=ON    1=OFF
;---------------------------------
L543F  	FDB  L004C		; 53, IODPORTB,  I/O D PORT B
				;	  SOLENOID COMBINATION FOR DIGITAL EGR
				; b7 1 = M/CLR			SFTB   SFTA  GR
				; b6 1 = REF IRQ CLR    	  0     0    3rd
				; b5 1 = FORCE MOTOR ENABLE	  0     1    4th
				; b4 1 = IAC ENABLE   		  1     0    2nd 							  1     1    1st
				; b3 1 = IAC COIL B ON   
				; b2 1 = IAC COIL A ON  
				; b1 1 = 2 - 3 SOL ON,	SHIFT B
				; b0 1 = 1 - 2 SOL ON,	SHIFT A
;---------------------------------
L5441  	FDB  L004D		; 54, IODPORTC, I/O PORT C  (L3064)
				; b7 1 = FWD LOW SW (NO) 1=ON
				; b6     (not used)
				; b5     (not used) 		  R1  R2  R3  GR
				; b4 1 = RANGE SW 3 OFF 	  0   1   1   LOW						  1   1   1   DR2
				; b3 1 = RANGE SW 2 OFF 	  1   1   0   DR3
				; b2 1 = RANGE SW 1 OFF 	  1   0   0   DR4
				; b1 1 = BK SW ON    		  1   0   1   P/N
				; b0 1 = A/C REQUEST ON 	  0   0   1   REV
;---------------------------------
L5443  	FDB  L4000		; 55, FIRST  PROM I.D. WORD (MSB)
L5445  	FDB  L4001		; 56, SECOND PROM I.D. WORD (LSB)
				;	   ID = MSB*256 + LSB
;-----------------------------
L5447  	FDB  L012E		; 57,DSSDC  3-2 PWM SOL % DUTY CYCLE
				;  	% = N / 2.56
;-----------------------------
L5449  	FDB  L0098		; 58, FAULTFLG     DISCRETE FAULT FLAGS
				;	b7  not used
				;	b6  not used
				;	b5  1 = SHIFT SOLENOID B VALID
				;	b4  1 = SHIFT SOLENOID A VALID
				;	b3  1 = INJECTOR 2 FAULT DETECTED
				;	b2  1 = INJECTOR 1 FAULT DETECTED
				;	b1  1 = QDM 2 FAULT DETECTED
       	   			;	b0  1 = QDM 1 FAULT DETECTED
;---------------------------------
L544B  	FDB  L0081		; 59, SHIFTED      SHIFT WORD
				;	b7 1 = SHIFT IS COMPLETE
				;	b6 not used
				;	b5 1 = 2-4 JUMP SHIFT WHEN PRNDL = D3
				;	b4 1 = SHIFT HAS STARTED
				;	b3 not used
				;	b2 not used
				;	b1 1 = DERIVATIVE SHIFT STARTED
				;	b0 1 = SLOPE OF DERIVATIVE IS NEGATIVE
;-----------------------------    
L544D  	FDB  L0099		; 60,  PATTERN,  MNP PATTERN
				;	b7   not used
				;	b6   not used
				;	b5   not used
				;	b4   not used
				;	b3   1 = ILLEGAL PATTERN REQUESTED
				;	b2   1 = "MANUAL" PATTERN REQUESTED
				;	b1   1 = "PERFORMANCE" PATTERN REQUESTED
				;	b0   1 = "NORMAL" PATTERN REQUESTED
;-----------------------------    
L544F  	FDB  L02A7		; 61,  FILTMPH,  MPH	 0 - 255 MPH                   	      
				;		MPH/1
				;		KPH = 1.61  
;-----------------------------    
L5451  	FDB  L30C6		; 62, RAW OUTPUT SPEED(MSB)
L5453  	FDB  L30C7		; 63, RAW OUTPUT SPEED(LSB)
				;	  	RPM = N/8
;-----------------------------
L5455  	FDB  L0197		; 64, NDTHROPS, TPS FOR ENGINE
				; 	   (CURRENT NON-DEAULT VALUE)   
				;	   % * 2.56
;-----------------------------    
L5457  	FDB  L00A2		; 65, COOLDEGA, COOL TEMP
				;   		Deg  c = n*.75 - 40
				;   		(deg F = 1.35N - 40)
;-----------------------------    
L5459  	FDB  L00AE		; 66, TRANSDEGA, NORMALIZED TRANSMISSION FLUID TEMPERATURE
				;		NON-DEFAULTED
				;   DEGREES C = N*.75 - 40                  
				;   (deg F = 1.35N - 40)
				;
;-------------------------------------------------
;
;-------------------------------------------------
;  DEVICE ID $F5
;  MODE 1, MESSAGE 1
;
;    MODE 1 (TRANSMIT FIXED DATA STREAM)
;            ALDL REQUEST:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $57
;            - MODE           = $01
;            - MESSAGE        = $01
;            - SUM CHECK
;
;            THE PCM WILL RESPOND WITH THE FOLLOWING MESSAGE:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $74
;            - MODE           = $01
;            - DATA BYTE 1
;              .
;              .
;            - DATA BYTE 30
;            - SUM CHECK
;
;-------------------------------------------------
;
L545B  	FCB  $0000		; NEXT ENRTY ADDRESS
;
L545D  	FCB  $F5		; DEVICE ID
;
L545E  	FCB  $80		; MEM FLAG,TBL FROM ROM
;
L545F  	FCB   31		; 30 BYTES TO TX
;
L5460  	FDB  L036E 		; ADDR OF OUTPUT BUFFER
L5462  	FDB  L036E		; ADDR OF INPUT BUFFER
;
L5464  	FDB  L000B		;  1, ERR MD WD 1                     
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, Vss BUFFER     
				; b3 1 = ERR 17, RPM SIGNAL PROBLEM     
				; b2 1 = ERR 18, CAM CRANK ERROR     
				; b1 1 = ERR 19,     
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L5466  	FDB  L0016		;  2, CURRENT ERR MD 1                    		
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, Vss BUFFER      
				; b3 1 = ERR 17, not used,  (RPM SIGNAL PROBLEM)     
				; b2 1 = ERR 18, not usedC, (CAM CRANK ERROR)
				; b1 1 = ERR 19, not used    
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L5468  	FDB  L000C		;  3, ERR MD WD 2                    		
				; b7 1 = ERR 22, LOW TPS     
				; b6 1 = ERR 23, LOW MAT     
 				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW        
				; b3 1 = ERR 26	 not used
				; b2 1 = ERR 27	 not used
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29	 not used
;-----------------------------    
L546A  	FDB  L0017		;  4,   CURRENT ERR WD 2
				; b7 1 = ERR 22, LOW TPS     
				; b6 1 = ERR 23, LOW MAT     
				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW     
				; b3 1 = ERR 26	 not used
				; b2 1 = ERR 27	 not used
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29	 not used
;-----------------------------    
L546C  	FDB  L000D		;  5, ERR MD WD 3		                		
				; b7 1 = ERR 31, GOVENOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SENSOR LOW    
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, IAC THROTTLE KICKER FAIL     
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON    
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF    
;-----------------------------    
L546E  	FDB  L0018		;  6,   CURRENT ERR WD 3	
				; b7 1 = ERR 31, GOVENOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SNENSOR LOW      
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, IAC THROTTLE KICKER FAIL
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON   
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF  
;-----------------------------    
L5470  	FDB  L000E		; 7, ERR MD WD 4		                 		
				; b7 1 = ERR 39, TCC STUCK OFF     
				; b6 1 = ERR 41, 1x CAM SENSOR     
				; b5 1 = ERR 42, IGN ERROR    
				; b4 1 = ERR 43, KNOCK SENSOR CKT     
				; b3 1 = ERR 44, LEAN    
				; b2 1 = ERR 45, RICH     
				; b1 1 = ERR 46, VATS FAIL    
				; b0 1 = ERR 47, not used    
;-----------------------------    
L5472  	FDB  L0019		;  8,  CURRENT ERR WD #4	
				;  b7 1 = ERR 39, TCC STUCK OFF   
				;  b6 1 = ERR 41, 1x CAM SENSOR   
				;  b5 1 = ERR 42, IGN ERROR    
				;  b4 1 = ERR 43, KNOCK SENSOR CKT   
				;  b3 1 = ERR 44, LEAN    
				;  b2 1 = ERR 45, RICH     
				;  b1 1 = ERR 46, VATS FAIL    
				;  b0 1 = ERR 47, not used    
;-----------------------------    
L5474  	FDB  L000F		; 9, ERR MD WD 5				        		
				; b7     ERR 48  not used
				; b6  	 ERR 49  not used
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, SYSTEM VOLTAGE HIGH-LONG TEST        
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, LOW FUEL PUMP VDV    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, not used    
;-----------------------------    
L5476  	FDB  L001A		; 10, CURRENT ERR WD 5	
				; b7     ERR 48  not used
				; b6  	 ERR 49  not used
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, SYSTEM VOLTAGE HIGH-LONG TEST       
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, LOW FUEL PUMP VDV    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, not used    
;-----------------------------    
L5478  	FDB  L0010		; 11,	  MALFUNCTION WORD 6
				; b7 1 = ERR 57. (not used)
				; b6 1 = ERR 58, XMISH TEMP HI
				; b5 1 = ERR 59, XMISH TEMP LOW
				; b4 1 = ERR 61, TURBO BOOST SENSOR HI
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW
				; b2 1 = ERR 63, BARO SENSOR HI
				; b1 1 = ERR 64, BARO SENSOR LOW
				; b0 1 = ERR 65. (not used)
;-----------------------------
L547A  	FDB  L001B		; 12,  CURRENT ERR WD 6, ERROR WD 6
				; b7 1 = ERR 57. (not used)
				; b6 1 = ERR 58, XMISH TEMP HI
				; b5 1 = ERR 59, XMISH TEMP LOW
				; b4 1 = ERR 61, TURBO BOOST SENSOR HI
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW
				; b2 1 = ERR 63, BARO SENSOR HI
				; b1 1 = ERR 64, BARO SENSOR LOW
				; b0 1 = ERR 65. (not used)
;-----------------------------    
L547C  	FDB  L0011		; 13, MALFUNCTION WORD 7
				;	b7 1 = ERR 66  3-2 DS QDM2/SOLENOID FAILURE
				;	b6 1 = ERR 67  TCC EN QDM2/SOLENOID FAILURE
				;	b5 1 = ERR 68  TRANSMISSION COMPONENT SLIPPING
				;	b4 1 = ERR 69  TCC ON
				;	b3 1 = ERR 71  ENGINE SPEED LOW
				;	b2 1 = ERR 72  OUTPUT SPEED LOSS
				;	b1 1 = ERR 73  FORCE MOTOR CURRENT
				;	b0 1 = ERR 74  INPUT SPEED SENSOR
;-----------------------------
L547E  	FDB  L001C		; 14, CURRENT MALFUNCTION WORD 7
				;	b7 1 = ERR 66  3-2 DS QDM2/SOLENOID FAILURE
				;	b6 1 = ERR 67  TCC EN QDM2/SOLENOID FAILURE
				;	b5 1 = ERR 68  TRANSMISSION COMPONENT SLIPPING
				;	b4 1 = ERR 69  TCC ON
				;	b3 1 = ERR 71  ENGINE SPEED LOW
				;	b2 1 = ERR 72  OUTPUT SPEED LOSS
				;	b1 1 = ERR 73  FORCE MOTOR CURRENT
				;	b0 1 = ERR 74  INPUT SPEED SENSOR
;-----------------------------
L5480  	FDB  L0012		; 15, MALFUNCTION WORD 8
				;	b7 1 = ERR 75  SYSTEM VOLTAGE LOW
				;	b6 1 = ERR 76  not used
				;	b5 1 = ERR 77  MNP SWITCH
				;	b4 1 = ERR 78  not used
				;	b3 1 = ERR 79  TRANSMISSION HOT
				;	b2 1 = ERR 81  SHIFT SOLENOID B FAILURE
				;	b1 1 = ERR 82  SHIFT SOLENOID A FAILURE
				;	b0 1 = ERR 83  TCC SOLENOID FAILURE
;----------------------------
L5482  	FDB  L001D		; 16, CURRENT MALFUNCTION WORD 8
				;	b7 1 = ERR 75  SYSTEM VOLTAGE LOW
				;	b6 1 = ERR 76  not used
				;	b5 1 = ERR 77  MNP SWITCH
				;	b4 1 = ERR 78  not used
				;	b3 1 = ERR 79  TRANSMISSION HOT
				;	b2 1 = ERR 81  SHIFT SOLENOID B FAILURE
				;	b1 1 = ERR 82  SHIFT SOLENOID A FAILURE
				;	b0 1 = ERR 83  TCC SOLENOID FAILURE
;-----------------------------    
L5484  	FDB  L0013		; 17, MALFUNCTkON WORD 9
				;	b7 1 = ERR 84  not used
				;	b6 1 = ERR 85  RATIO-UNDEFINED REGION
				;	b5 1 = ERR 86  SOLENOID B STUCK ON
				;	b4 1 = ERR 87  SOLENOID B STUCK OFF
				;	b3 1 = ERR 88  not used
				;	b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				;	b0 1 = ERR 92  not used
				;	b1 1 = ERR 91  not used
;-----------------------------
L5486  	FDB  L001E		; 18,  CURRENT ERR WD 9
				;	b7 1 = ERR 84  not used
				;	b6 1 = ERR 85  RATIO-UNDEFINED REGION
				;	b5 1 = ERR 86  SOLENOID B STUCK ON
				;	b4 1 = ERR 87  SOLENOID B STUCK OFF
				;	b3 1 = ERR 88  not used
				;	b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				;	b0 1 = ERR 92  not used
				;	b1 1 = ERR 91  not used
;-----------------------------    
L5488  	FDB  L012D		; 19, ADAPTABL   ADAPT WORD FOR SERFICE
				;	b0  1 = LAST SHIFT WAS USABLE FOR ADAPTING  0 = UNUSABLE
				;	b1  1 = HOT TEMPERATURE THRESHOLD
				;	b2  1 = THROTTLE OUT OF RANGE
				;	b3  not used
       	   			;
				;	b4  1 = VEHICLE SPEED CHANGED TOO MUCH
				;	b5  1 = LONG SHIFT DELAY TIME
				;	b6  not used
				;	b7  1 = THROTTLE CHANGED TOO MUCH
;-----------------------------    
L548A  	FDB  L00DB		; 20,LSTADEL    LAST CHANGE TO ADAPTIVE MODIFIER
       	   			;				PSI = N/4
;-----------------------------    
L548C  	FDB  L0144		; 21, CURADPT   CURRENT ADAPTIVE MODIFIER
       	   			;				N = STATUS
;-----------------------------    
L548E  	FDB  L0145		; 22,CURCELL    CURRENT ADAPTIVE MODIFIER INDEX WITHIN TABLE
       	   			;				N = CELL
;-----------------------------    
L5490  	FDB  L031B		; 23, EADPT2    PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------  
L5492  	FDB  L031C		; 24, EADPT2+1  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------  
L5494  	FDB  L031D		; 25, EADPT2+2  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------  
L5496  	FDB  L031E		; 26, EADPT2+3  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;--------------------------------------
L5498  	FDB  L031F		; 27, EADPT3,   PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;-----------------------------  
L549A  	FDB  $0320		; 28, EADPT3+1, PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;-----------------------------  
L549C  	FDB  L0321		; 29, EADPT3+2 	PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;-----------------------------  
L549E  	FDB  L0322		; 30, EADPT3+3 	PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;				
;---------------------------------------------
;  MSG ID $F5,
;  MODE 1, MESSAGE 3					
;
;
;---------------------------------------------
;
L54A0  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L54A2  	FCB  $F5		; DEVICE ID
L54A3  	FCB  $80		; MEM FLAG, TBL FROM ROM
L54A4  	FCB   81		; 80 BYTES TO TX
;
L54A5  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L54A7  	FDB  L036E		; ADDR OF INPUT BUFFER
;-----------------------------
L54A9  	FDB  L000B		;  1, ERR MD WD 1                     	
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, Vss BUFFER     
				; b3 1 = ERR 17, RPM SIGNAL PROBLEM     
				; b2 1 = ERR 18, CAM CRANK ERROR     
				; b1 1 = ERR 19,     
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L54AB  	FDB  L0016		;  2, CURRENT ERR MD 1                    		
				; b7 1 = ERR 13, o2 SENSOR     
				; b6 1 = ERR 14, COOL SENSOR, HIGH    
				; b5 1 = ERR 15, COOL SENSOR, LOW    
				; b4 1 = ERR 16, Vss BUFFER      
				; b3 1 = ERR 17, not used,  (RPM SIGNAL PROBLEM)     
				; b2 1 = ERR 18, not usedC, (CAM CRANK ERROR)
				; b1 1 = ERR 19, not used    
				; b0 1 = ERR 21, TPS SENSOR HIGH    
;----------------------------    
L54AD  FDB  L000C		;  3, ERR MD WD 2                    		
				; b7 1 = ERR 22, LOW TPS     
				; b6 1 = ERR 23, LOW MAT     
				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW      
				; b3  1 = ERR 26
				; b2  1 = ERR 27
				; b1  1 = ERR 28, PRESS SW MANIFOLD   
				; b0  1 = ERR 29
;-----------------------------    
L54AF  FDB  L0017		;  4,   CURRENT ERR WD 2
				; b7 1 = ERR 22, LOW TPS     
				; b6 1 = ERR 23, LOW MAT     
				; b5 1 = ERR 24, LOW Vss    
				; b4 1 = ERR 25, MAT LOW       
				; b3 1 = ERR 26
				; b2 1 = ERR 27
				; b1 1 = ERR 28, PRESS SW MANIFOLD   
				; b0 1 = ERR 29
;-----------------------------    
L54B1  FDB  L000D		;  5, ERR MD WD 3		                		
				; b7 1 = ERR 31, GOVENOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SNENSOR LOW      
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, IAC THROTTLE KICKER FAIL     
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON    
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF  
;-----------------------------    
L54B3  FDB  L0018		;  6,   CURRENT ERR WD 3	
				; b7 1 = ERR 31, GOVENOR    
				; b6 1 = ERR 32, EGR ERROR     
				; b5 1 = ERR 33, MAP SENSOR HI    
				; b4 1 = ERR 34, MAP SNENSOR LOW     
				; b3 1 = ERR 35, IAC ERROR    
				; b2 1 = ERR 36, IAC THROTTLE KICKER FAIL
				; b1 1 = ERR 37, TCC BRAKE SW STUCK ON   
				; b0 1 = ERR 38, TCC BRAKE SW STUCK OFF 
;-----------------------------    
L54B5  FDB  L000E		;  7, ERR MD WD 4		                 		
				; b7 1 = ERR 39, TCC STUCK OFF     
				; b6 1 = ERR 41, 1x CAM SENSOR     
				; b5 1 = ERR 42, IGN ERROR    
				; b4 1 = ERR 43, KNOCK SENSOR CKT     
				; b3 1 = ERR 44, LEAN    
				; b2 1 = ERR 45, RICH     
				; b1 1 = ERR 46, VATS FAIL    
				; b0 1 = ERR 47,     
;-----------------------------    
L54B7  FDB  L0019		;  8,  CURRENT ERR WD #4	
				;  b7 1 = ERR 39, TCC STUCK OFF   
				;  b6 1 = ERR 41, 1x CAM SENSOR   
				;  b5 1 = ERR 42, IGN ERROR    
				;  b4 1 = ERR 43, KNOCK SENSOR CKT
				;  b3 1 = ERR 44, LEAN    
				;  b2 1 = ERR 45, RICH     
				;  b1 1 = ERR 46, VATS FAIL    
				;  b0 1 = ERR 47,     
;-----------------------------    
L54B9  FDB  L000F		; 9, ERR MD WD 5				        		
				; b7     
				; b6  	
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, MISSING FUEL CALPACK    
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, LOW FUEL PUMP VDV    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, QUAD DRIVER B FAULT  
;-----------------------------    
L54BB  FDB  L001A		; 10, CURRENT ERR WD 5	
				; b7    (not used)   
				; b6    (not used)	
				; b5 1 = ERR 51, EPROM ERROR    
				; b4 1 = ERR 52, MISSING FUEL CALPACK         
				; b3 1 = ERR 53, HI SYS VOLTAGE      
				; b2 1 = ERR 54, LOW FUEL PUMP VDC    
				; b1 1 = ERR 55, FAULTY COMPUTER    
				; b0 1 = ERR 56, QUAD DRIVER B FAULT  
;-----------------------------    
L54BD  FDB  L0010		; 11, MALFFLG5, ERROR WD 6
				; b7 1 = ERR 57, (not used)
				; b6 1 = ERR 58, XMISH TEMP HI
				; b5 1 = ERR 59, XMISH TEMP LOW
				; b4 1 = ERR 61, TURBO BOOST SENSOR HI
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW
				; b2 1 = ERR 63, BARO SENSOR HI
				; b1 1 = ERR 64, BARO SENSOR LOW
				; b0 1 = ERR 65. (not used)
;-----------------------------    
L54BF  FDB  L001B		; 12, CURRENT ERR WD 6
				; b7 1 = ERR 57. (not used)
				; b6 1 = ERR 58, XMISH TEMP HI
				; b5 1 = ERR 59, XMISH TEMP LOW
				; b4 1 = ERR 61, TURBO BOOST SENSOR HI
				; b3 1 = ERR 62, TURBO BOOST SENSOR LOW
				; b2 1 = ERR 63, BARO SENSOR HI
				; b1 1 = ERR 64, BARO SENSOR LOW
				; b0 1 = ERR 65. (not used)
;-----------------------------    
L54C1  FDB  L0011		; 13,  MALFFLG7, ERROR WD 7
				; b7 1 = ERR 66  3-2 DS QDM2/SOLENOID FAILURE
				; b6 1 = ERR 67  TCC EN QDM2/SOLENOID FAILURE
				; b5 1 = ERR 68  TRANSMISSION COMPONENT SLIPPING
				; b4 1 = ERR 69  TCC ON
				; b3 1 = ERR 71  ENGINE SPEED LOW
 				; b2 1 = ERR 72  OUTPUT SPEED LOSS
				; b1 1 = ERR 73  FORCE MOTOR CURRENT
				; b0 1 = ERR 74  INPUT SPEED SENSOR
;-----------------------------
L54C3  FDB  L001C		; 14, CURMALF7, CURRENT ERROR WD 7
				; b7 1 = ERR 66, 3-2 DS QDM2/SOLENOID FAIL
				; b6 1 = ERR 67, TCC EN QDM2/SOLENOID FAIL
				; b5 1 = ERR 68, XMISH COMPONENT SLIPPING
				; b4 1 = ERR 69, TCC ON
				; b3 1 = ERR 71, ENGINE SPEED LOW
				; b2 1 = ERR 72, OUTPUT SPEED LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, INPUT SPEED SENSOR
;-----------------------------
L54C5  FDB  L0012		; 15, MALFFLG8, ERROR WD 8
				; b7 1 = ERR 75  SYSTEM VOLTAGE LOWL
				; b6 1 = ERR 76  not used
				; b5 1 = ERR 77  MNP SWITCH
				; b4 1 = ERR 78  not used
				; b3 1 = ERR 71, ENGINE SPEED LOW
				; b2 1 = ERR 72, OUTPUT SPEED LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, INPUT SPEED SENSOR
;-----------------------------
L54C7  FDB  L001D		; 16, CURMALF8, CURRENT ERROR WD 8
				; b7 1 = ERR 75, SYSTEM VDC LOW
				; b6 1 = ERR 76, (not used)
				; b5 1 = ERR 77, NMP SWITCH
				; b4 1 = ERR 78, (not used) 
				; b3 1 = ERR 79, XMISH HOT
				; b2 1 = ERR 81, SHIFT SOLENOID B FAIL
				; b1 1 = ERR 82, SHIFT SOLENOID A FAIL
				; b0 1 = ERR 83, TCC SOLENOID FAIL
;-----------------------------    
L54C9  FDB  L0013		; 17,  MALFFLG9, CURRENT ERROR WD 9
				; b7 1 = ERR 84  not used
				; b6 1 = ERR 85  RATIO-UNDEFINED REGION
				; b5 1 = ERR 86  SOLENOID B STUCK ON
				; b4 1 = ERR 87  SOLENOID B STUCK OFF 
				; b3 1 = ERR 88	 not used
				; b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				; b1 1 = ERR 91  not used
				; b0 1 = ERR 92  not used
;-----------------------------
L54CB  FDB  L001E		; 18,   CURMALF9, CURRENT ERROR WD 9
				; b7 1 = ERR 84  not used
				; b6 1 = ERR 85  RATIO-UNDEFINED REGION
				; b5 1 = ERR 86  SOLENOID B STUCK ON
				; b4 1 = ERR 87  SOLENOID B STUCK OFF 
				; b3 1 = ERR 88	 not used
				; b2 1 = ERR 89  MAXIMUM ADAPT LONG SHIFT
				; b1 1 = ERR 91  not used
				; b0 1 = ERR 92  not used
;-----------------------------
L54CD  FDB  L00A0		; 19,  TPS A/D	
				; BIN = VDC * 50        
;-----------------------------    
L54CF  FDB  L00A6		; 20, BARO, BAROMETRIC PRESSURE
				;   	   	VOLTS = N * (5/256)
				;   	   	(kpa = (N + 28.06)/2.71)
;-----------------------------
L54D1  FDB  L319D		; 21,  NE,   ENGINE SPEED, (MSB)
L54D3  FDB  L319E		; 22,  NE+1, ENGINE SPEED, (LSB)
				;	 	RPM/8
;------------------------------
L54D5  FDB  L30BC		; 23, NT,   ENGINE SPEED, (MSB)
L54D7  FDB  L30BD		; 24, NT+1, ENGINE SPEED, (LSB)
				;	 	RPM/8
;------------------------------
L54D9  FDB  L30C0		; 25, FILTERED TURBINE SPEED MSB
L54DB  FDB  L30C1		; 26, FILTERED TURBINE SPEED LSB
				;		  RPM/8    
;------------------------------
L54DD  FDB  L00D1		; 27, VEHSPEEN,  VEHICLE SPEED (FILTERED
				;		MPH/2
;-----------------------------
L54DF  FDB  L00DC		; 28, PRESSURE, CURRENT TQ SIG PRESS
				; 		PSI/1
;----------------------------
L54E1  FDB  L0147		; 29, CURRENT, REF CURRENT FORCE MTR CKT
				;		AMP = N/51.2
;----------------------------
L54E3  FDB  L0148		; 30, CURRENT, ACTUAL FM CURRENT FM SHUNT (A/D)
				;		AMP = N/51.2
;----------------------------
L54E5  FDB  L0146		; 31, FMDC, FORCE MOTOR D.C.
				; 		% = N/2.56
;----------------------------
L54E7  FDB  L009C		; 32, PRNDLFLG, CURRENT STATE OF XMISH RANGE SEL
				; 		b7 1 = ILLEGAL RANGE
				; 		b6 1 = PK/NEUT
				; 		b5 1 = REVERSE
				; 		b4 1 = (ot used)
				; 		b3 1 = DRIVE 4
				; 		b2 1 = DRIVE 3
				; 		b1 1 = DRIVE 2
				; 		b0 1 = LOW GEAR
;-----------------------------
L54E9  FDB  L00A1		; 33, BATTERY A/D                   	    
				; 		VDC/10    
;-----------------------------
L54EB  FDB  L3124		; 34, TCCDC,   TCC PWM SOLENOID DC, (MSB)
L54ED  FDB  L3125		; 35, TCCDC+1, TCC PWM SOLENOID DC, (MSB)
				;	   % = (256MSB + LSB)/655.36
;-----------------------------
L54EF  FDB  L30F3		; 36,  RATIO,   XMISH (INPUT SPD/OUTPUT SPD) NI/NO, (MSB)
L54F1  FDB  L30F4		; 37,  RATIO+1, XMISH (INPUT SPD/OUTPUT SPD) NI/NO, (MSB)
				;			RATIO = N/16384
;-----------------------------
L54F3  FDB  L00D3		; 38, GEAR, CURRENT GEAR
				;		GEAR = N + 1
;----------------------------
L54F5  FDB  L00D4		; 39,
;----------------------------
L54F7  FDB  L00DB		; 40,LSTADEL    LAST CHANGE TO ADAPTIVE MODIFIER
          			;				PSI = N/4
;-----------------------------    
L54F9  FDB  L0145		; 41, CURCELL, CURRENT ADPTIVE MOD'ER INDEX W/IN TBL
				; 		CELL = N
;----------------------------
L54FB  FDB  L0135		; 42, ERROR12, ERR BETWEEN DESIRED & ACTUAL SHIFT TIMES 
				;			   FOR LATEST 1-2 UPSHIFT  1=1/32 SEC
				;			    SEC. = N/40
;-----------------------------
L54FD  FDB  L0136		; 43, ERR0R23, ERR BETWEEN DESIRED & ACTUAL SHIFT TIMES 
				;			   FOR LATEST 2 -> 3 1=1/32 SEC
				;					SEC = N/40
;-----------------------------
L54FF  FDB  L0137		; 44,
;-----------------------------
L5501  FDB  L00F7		; 45,
;-----------------------------
L5503  FDB  L00DF		; 46,
;-----------------------------
L5505  FDB  L00E0		; 47,
;-----------------------------
L5507  FDB  L30E5		; 48, SLIP,   ABSOLUTE VAL OF SLIP (MSB)
L5509  FDB  L30E6		; 49, SLIP+1, ABSOLUTE VAL OF SLIP (LSB)
				;	    TPM/8 (signed value)
;------------------------------
L550B  FDB  L0132		; 50, TIME12, TIME OF LATEST 1->2 SHIFT
				;		SEC = N/40
;-----------------------------
L550D  FDB  L0133		; 51, TIME23, TIME OF LATEST 3->3 SHIFT
				;		SEC = N/40
;-----------------------------
L550F  FDB  L0083		; 52, TEMPMW       TEMPER STATUS WORD 
				; b7 1 = not used
				; b6 1 = not used
				; b5 1 = not used
				; b4 1 = not used  	 
				; b3 1 = not used   
				; b2 1 = not used
				; b1 1 = HOT  TEMPERATURE THRESHOLD
				; b0 1 = COLD TEMPERATURE THRESHOLD
;-----------------------------
L5511  FDB  L031B		; 53, EADPT2    PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------
L5513  FDB  L031C		; 54, EADPT2+1  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------
L5515  FDB  L031D		; 55, EADPT2+2  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;-----------------------------
L5517  FDB  L031E		; 56, EADPT2+3  PRESSURE MODIFIER (ADAPTIVE) - 2nd GEAR
				;				PSI = N/4
;--------------------------------------
L5519  FDB  L031F		; 57, EADPT3,   PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR				PSI = N/4
;--------------------------------------
L551B  FDB  L0320		; 58, EADPT3+1  PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;--------------------------------------
L551D  FDB  L0321		; 59, EADPT3+2  PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;--------------------------------------
L551F  FDB  L0322		; 60, EADPT3+3, PRESSURE MODIFIER (ADAPTIVE) - 3rd GEAR
				;				PSI = N/4
;--------------------------------------
L5521  FDB  L0323		; 61,
;--------------------------------------
L5523  FDB  L0324		; 62,
;--------------------------------------
L5525  FDB  L0325		; 63,
;--------------------------------------
L5527  FDB  L0326		; 64,
;--------------------------------------
L5529  FDB  L0096		; 65, DIRFLAGS, BIT STATUS WORD
 				; b7 1 = DIAGNOSTICS REQUESTED
				; b6 1 = CRUISE LOW ACTIVE
				; b5 1 = 4 WD LOW ACTIVE
				; b4 1 = KICK DN PATTERN ACTIVE 	 
				; b3     (not used)
				; b2 1 = PWR ENRICH ACTIVE
				; b1 1 = A/C COMPRESSOR ENGAGED
				; b0 1 = BRAKE ON
;-----------------------------
L552B  FDB  L004B		; 66, IODPORTA,  I/O D PORT A
				; b7 1 = TCC ENABLE			0=OFF  1=ON	  
				; b6 1 = BYPASS (FROM REST)	  
				; b5 1 = BYPASS MONTR (FROM REST) 
				; b4 1 = BYPASS CTRL (FROM REST)    	
				; b3 1 = 3->2 DN SHIFT FEEDFBACK 	0=ON    1=OFF
				; b2 1 = TCC R\ENABLE FEEDFBACK		0=ON    1=OFF
				; b1 1 = SHIFT B FEEDFBACK		0=ON    1=OFF
				; b0 1 = SHIFT A FEEDFBACK		0=ON    1=OFF
;---------------------------------
L522C  FDB  L004C		; 67 IODPORTB,  I/O D PORT B                        
				; b7 1 = M/CLR				SFTB   SFTA  GR
				; b6 1 = REF IRQ CLR   			0     0    3rd
				; b5 1 = FORCE MOTOR ENABLE		0     1    4th
				; b4 1 = IAC ENABLE   			1     0    2nd							  1     1    1st
				; b3 1 = IAC COIL B ON   
				; b2 1 = IAC COIL A ON  
				; b1 1 = 2 - 3 SOL ON,	SHIFT B
				; b0 1 = 1 - 2 SOL ON,	SHIFT A
;-----------------------------    
L552F  FDB  L004D		; 68, IODPORTC, I/O PORT C             	  	
        		   	; b7 1 = FWD LOW SW (NO) 1=ON  
				; b6     (not used)
				; b5     (not used)		R1  R2  R3  GR
				; b4 1 = RANGE SW 3 OFF 	0   1   1   LOW 			  1   1   1   DR2
				; b3 1 = RANGE SW 2 OFF		1   1   0   DR3 
				; b2 1 = RANGE SW 1 OFF		1   0   0   DR4 
				; b1 1 = BK SW ON 		1   0   1   P/N
				; b0 1 = A/C REQUEST ON		0   0   1   REV 
;-----------------------------      
L5531  FDB  L4000		; 69, EPROM ID,MSB
L5533  FDB  L4001		; 70, EPROM ID,LSB
;-----------------------------
L5535  FDB  L012E		; 71,DSSDC  3-2 PWM SOL % DUTY CYCLE
				;   		% = N / 2.56
;-----------------------------
L5537  FDB  L0098		; 72, FAULTFLG     DISCRETE FAULT FLAGS
				;	b7  not used
				;	b6  not used
				;	b5  1 = SHIFT SOLENOID B VALID
				;	b4  1 = SHIFT SOLENOID A VALID
				;	b3  1 = INJECTOR 2 FAULT DETECTED
				;	b2  1 = INJECTOR 1 FAULT DETECTED
				;	b1  1 = QDM 2 FAULT DETECTED
				;	b0  1 = QDM 1 FAULT DETECTED
;---------------------------------
L5539  FDB  L0081		; 73, SHIFTED      SHIFT WORD
				;	b7 1 = SHIFT IS COMPLETE
           			;	b6 not used
           			;	b5 1 = 2-4 JUMP SHIFT WHEN PRNDL = D3
           			;	b4 1 = SHIFT HAS STARTED
           			;	b3 not used
           			;	b2 not used
           			;	b1 1 = DERIVATIVE SHIFT STARTED
           			;	b0 1 = SLOPE OF DERIVATIVE IS NEGATIVE
;-----------------------------    
L553B  FDB  L0099		; 74,  PATTERN,  MNP PATTERN
           			;	b7   not used
           			;	b6   not used
           			;	b5   not used
           			;	b4   not used
           			;	b3   1 = ILLEGAL PATTERN REQUESTED
           			;	b2   1 = "MANUAL" PATTERN REQUESTED
           			;	b1   1 = "PERFORMANCE" PATTERN REQUESTED
           			;	b0   1 = "NORMAL" PATTERN REQUESTED
          			;
;-----------------------------    
L553D  FDB  L02A7		; 75, FILTMPH,  MPH	 0 - 255 MPH                   	      
				;		MPH/1
				;		KPH = 1.61  
;-----------------------------    
L553F  FDB  L30C6		; 76, RAW OUTPUT SPEED(MSB)
L5541  FDB  L30C7		; 77, RAW OUTPUT SPEED(LSB)
				;	  	RPM = N/8
;-----------------------------
L5543  FDB  L0197		; 78, NDTHROPS, TPS FOR ENGINE
				; 	   (CURRENT NON-DEAULT VALUE)   
				;	   % * 2.56
;-----------------------------    
L5545  FDB  L00A2		; 79, COOL TEMP
				;   		deg c = n*.75 - 40
				;   		deg F = 1.35N - 40
;-----------------------------    
L5547  FDB  L00AE		; 80, TRANSDEGA, NORMALIZED TRANSMISSION FLUID TEMPERATURE
				;		NON-DEFAULTED
				;   	deg c = N*.75 - 40                  
				;   	deg f = 1.35N - 40
;---------------------------------------------
;				
;---------------------------------------------
;  DEVICE ID $F5, MODE 2
;				
; SEQUENTIAL MEMORY DUMP 
;---------------------------------------------
;
L5549  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L554B  	FCB  $F5		; DEVICE ID
;
L554C  	FCB  $40		; MEM FLAG, TBL FROM RAM
L554D  	FCB   65		; NUM BYTES TO TX  
;
L554E  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L5550  	FDB  L036E		; ADDR OF INPUT BUFFER
;---------------------------------------------
;
;---------------------------------------------
; DEVICE ID $F5, MODE 3
;
;  8 ADDRESS RAMDOM MEM DUMP
;---------------------------------------------
;
L5552  	FDB  $0000		; NEXT ENRTY ADDRESS
;
L5554  	FCB  $F5		; DEVICE ID
L5555  	FCB  $40		; MEM FLAG, TBL FROM RAM
L5556  	FCB  $9			; NUM BYTES TO TX 
;		
L5557  	FDB  L036E		; ADDR OF OUTPUT BUFFER
L5559  	FDB  L036E		; ADDR OF INPUT BUFFER
;---------------------------------------------
;
;---------------------------------------------
;  DEVICE ID $F5, MODE 4
;
; 'CONTROLLER MODE'
;---------------------------------------------
;
L555B  FCB  $0000		; NEXT ENRTY ADDRESS
;
L555D  FCB  $F5			; DEVICE ID
;
L555E  FCB  $00			; MEM FLAG, NONE
L555F  FCB    1			; NUM BYTES TO TX
;
L5560  FDB  L036E		; ADDR OF OUTPUT BUFFER
L5562  FDB  L036E		; ADDR OF INPUT BUFFER
;-------------------------------------------------
;
;-------------------------------------------------
;  DEVICE ID $F5, MODE 10
;
;    MODE 10 (CLEAR MALFUNCTION CODES)
;            ALDL REQUEST:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $56
;            - MODE           = $0A
;            - SUM CHECK
;
;            THE PCM WILL RESPOND WITH THE FOLLOWING MESSAGE:
;            - MESSAGE ID     = $F5
;            - MESSAGE LENGTH = $56
;            - MODE           = $0A
;            - SUM CHECK
;
;  RESET ERR'S
;-------------------------------------------------
;
L5564  FDB  $0000		; NEXT ENRTY ADDRESS
;
L5566  FCB  $F5			; DEVICE ID
;
L5567  FCB  $00			; MEM FLAG, NONE
L5568  FCB    1			; NUM BYTES TO TX
;
L5569  FDB  L036E		; ADDR OF OUTPUT BUFFER
L556B  FDB  L036E		; ADDR OF INPUT BUFFER
;----------------------------------------------
;
;----------------------------------------------
; INSTRUMENTION CALIB PARAM
;
;
;----------------------------------------------
;
	ORG	$55EE		
;
L55EE  	FDB   L0086		; DISP VAL SAVED TO THIS ADDR ON HI LIGHTS
L55F0  	FCB   L00D3		; DISP VAL SAVED TO THIS ADDR ON CAL POSIT NUM
;----------------------------------------------
;
;***********************************************
;* END OF ENGINE CALIBRATION
;*
;***********************************************
;
;***********************************************
;* DIAGNOSTIC MODE WORDS
;* ENGINE      
;*
;*  Dissassemby of BDWM TYPE $0D ECM
;*
;***********************************************
;----------------------------------------------
; DEFINED ENGINE ERRORS
;----------------------------------------------
;       ERR 13 o2 fail
;       ERR 14 HI COOL TEMP
;       ERR 15 LO COOL TEMP
;       ERR 16 2002 PPM Vss FAIL
;       ERR 21 HI TPS
;       ERR 22 LO TPS
;       ERR 23 MAT LOW
;       ERR 24 LO OUTPUT XMISH SPD
;       ERR 25 MAT HIGH
;       ERR 27 XMISH PRESS MANIFOLD
;       ERR 31 GOVERNER FAIL
;       ERR 32 EGR FAIL
;       ERR 33 MAP HI
;       ERR 34 MAP LOW
;       ERR 35 IAC FAIL
;       ERR 36 IAC TPS KICKER FAIL      
;       ERR 37 BRAKE ON
;       ERR 38 BRAKE OFF
;       ERR 41 TX, (CAM) PULSE SENSOR FAIL
;       ERR 42 EST MONITOR ERROR
;       ERR 43 KNOCK SYS FAIL
;       ERR 44 o2 LEAN
;       ERR 46 VATS FAIL
;       ERR 51 EPROM CKS SUM FAIL       
;       ERR 52 HI SYS VOLTAGE, LONG TEST
;       ERR 53 HI SYS VOLTAGE 
;       ERR 54 FUEL PUMP RELAY FAIL
;       ERR 58 HI XMIXH TEMP    
;       ERR 58 HI XMISH TEMP
;       ERR 59 LO XMISH TEMP
;       ERR 63 HIGH BARO PRESS
;       ERR 64 LOW BARO PRESS
;       ERR 66 3 -> 2 SHFT QUAD DVR FAIL       
;       ERR 67 TCC ENAB QUAD DVR FAIL
;       ERR 68 XMISH SLIPPING
;       ERR 69 TCC ON
;       ERR 71 LOW ENGINE SPD 
;       ERR 72 OUTPUT SPD LOSS
;       ERR 73 FORCE MOTOR CURRENT
;       ERR 74 TURBINE SPEED
;       ERR 75 LOW SYS VOLTAGE,
;       ERR 77 MNP SWITCH
;       ERR 79 HOT XMISH
;       ERR 81 QUAD DVR 1 & SHFT B ERR
;       ERR 82 QUAD DVR 1 & SHFT A ERR
;       ERR 83 QUAD DVR 1 ERR
;----------------------------------------------
;
	ORG	$5B00
;
;------------------------------
L5B00   FCB $F1			; 1111 0001, ERR MASK 1
				; b7 1 = ERR 13, o2 fail
				; b6 1 = ERR 14, HIGH COOLANT TEMP
				; b5 1 = ERR 15, LOW COOLANT TEMP
				; b4 1 = ERR 16, 2002 PPM Vss FAIL
				; b3 1 = ERR 17
				; b2 1 = ERR 18
				; b1 1 = ERR 19
				; b0 1 = ERR 21,        HIGH TPS
;------------------------------
L5B01   FCB $A2			; 1010 0010, ERR MASK 2
				; b7 1 = ERR 22, TPS LOW 
				; b6 1 = ERR 23, MAT LOW
				; b5 1 = ERR 24, OUTPUT XMISH SPD LOW
				; b4 1 = ERR 25, MAT HIGH
				; b3 1 = ERR 26,  
				; b2 1 = ERR 27, XMISH PRESS MANIFOLD
				; b1 1 = ERR 28,
				; b0 1 = ERR 29,
;------------------------------
L5B02   FCB $7B			; 0111 1011, ERR MASK 3
				; b7 1 = ERR 31, GOVERNER FAIL
				; b6 1 = ERR 32, EGR FAIL
				; b5 1 = ERR 33, MAP HI
				; b4 1 = ERR 34, MAP LOW
				; b3 1 = ERR 35, IAC FAIL
				; b2 1 = ERR 36, THROTTLE KICKER FAIL
				; b1 1 = ERR 37, BRAKE ON
				; b0 1 = ERR 38, BRAKE OFF
;
L5B03   FCB $3C			;0011 1100, Error mask 4
				; b7 1 = Error 39,
				; b6 1 = Error 41, TX, (CAM) pulse sensor failure
				; b5 1 = Error 42, EST mon. failure
				; b4 1 = Error 43, ESC failure
				; b3 1 = Error 44, O2 lean
				; b2 1 = Error 45, O2 rich
				; b1 1 = Error 46  VATS
				; b0 1 = Error 47,
;
L5B04   FCB $3C			; 0011 1100, ERR MASK 5
				; b7 1 = ERR 48, 
				; b6 1 = ERR 49,
				; b5 1 = ERR 51, EPROM CKS SUM FAIL
				; b4 1 = ERR 52, HI SYS VDC ERR, LONG TEST
				; b3 1 = ERR 53,, HI SYS VDC ERR 
				; b2 1 = ERR 54, FUEL PUMP RELAY FAIL
				; b1 1 = ERR 55,
				; b0 1 = ERR 56,
;------------------------------
L5B05   FCB $60			; 0110 0000, ERR MASK 6
				; b7 1 = ERR 57,
				; b6 1 = ERR 58, HI XMISH TEMP
				; b5 1 = ERR 59, LO XMISH TEMP
				; b4 1 = ERR 61,
				; b3 1 = ERR 62, 
				; b2 1 = ERR 63, HIGH BARO PRESS
				; b1 1 = ERR 64, LOW BARO PRESS
				; b0 1 = ERR 65, 
;------------------------------
L5B06   FCB $D6			; 1101 0110, ERR MASK 7
				; b7 1 = ERR 66, 3 -> 2 SHFT QUAD DVR FAIL
				; b6 1 = ERR 67, TCC ENAB QUAD DVR FAIL
				; b5 1 = ERR 68, XMISH SLIPPING
				; b4 1 = ERR 69, TCC ON
				; b3 1 = ERR 71, LOW ENGINE SPD 
				; b2 1 = ERR 72, OUTPUT SPD LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, TURBINE SPEED
;------------------------------
L5B07   FCB $8E			; 1000 1110, ERR MASK 8
				; b7 1 = ERR 75, LOW SYS VOLTAGE,
				; b6 1 = ERR 76,
				; b5 1 = ERR 77, MNP SWITCH
				; b4 1 = ERR 78,
				; b3 1 = ERR 79, HOT XMISH
				; b2 1 = ERR 81, QUAD DVR 1 & SHFT B ERR
				; b1 1 = ERR 82, QUAD DVR 1 & SHFT A ERR
				; b0 1 = ERR 83, QUAD DVR 1 ERR
;------------------------------
L5B08   FCB $00			; 0000 0000, ERR MASK 9
				; b7 1 = ERR 84,
				; b6 1 = ERR 85, RATIO UN-DEFINED OP REGION
				; b5 1 = ERR 86, LOW RATIO
				; b4 1 = ERR 87, HIGH RATIO
				; b3 1 = ERR 88, 
				; b2 1 = ERR 89,  MAX ADPT LONG SHFT
				; b1 1 = ERR 91,
				; b0 1 = ERR 92,
;------------------------------
L5B09   FCB $F1			; 1111 0001, ERR MASK CK XMISH
				; b7 1 = ERR 13, o2 SENSOR FAIL
				; b6 1 = ERR 14, HI COOLANT TEMP
				; b5 1 = ERR 15, LO COOLANT TEMP
				; b4 1 = ERR 16, 2002 PPM Vss FAIL
				; b3 1 = ERR 17
				; b2 1 = ERR 18
				; b1 1 = ERR 19
				; b0 1 = ERR 21,        HIGH TPS
;------------------------------
L5B0A   FCB $80			; 1000 0000, ERR  MASK CK XMISH
				; b7 1 = ERR 22, TPS LOW 
				; b6 1 = ERR 23, MAT LOW
				; b5 1 = ERR 24, OUTPUT XMISH SPD LOW
				; b4 1 = ERR 25, MAT HIGH
				; b3 1 = ERR 26, 
				; b2 1 = ERR 27, XMISH PRESS MANIFOLD
				; b1 1 = ERR 28,
				; b0 1 = ERR 29,
;------------------------------
L5B0B   FCB $78			; 0111 1000
				; b7 1 = ERR 31, GOVERNER FAIL
				; b6 1 = ERR 32, EGR FAIL
				; b5 1 = ERR 32, MAP HI
				; b4 1 = ERR 34, MAP LOW
				; b3 1 = ERR 35, IAC FAIL
				; b2 1 = ERR 36, IAC TPS KICKER FAIL
				; b1 1 = ERR 37, BRAKE ON
				; b0 1 = ERR 38, BRAKE OFF
;------------------------------
L5B0C   FCB $3C			; 0011 1100
				; b7 1 = ERR 39,
				; b6 1 = ERR 41, TX, (CAM) PULSE SENSOR FAIL
				; b5 1 = ERR 42, EST MONITOR ERROR
				; b4 1 = ERR 43, KNOCK SYS FAIL
				; b3 1 = ERR 44, o2 LEAN
				; b2 1 = ERR 45, o2 RICH
				; b1 1 = ERR 46, VATS FAIL
				; b0 1 = ERR 47,
;------------------------------
L5B0D   FCB $24			; 0010 0100
				; b7 1 = ERR 48, 
				; b6 1 = ERR 49,
				; b5 1 = ERR 51, EPROM CKS SUM FAIL
				; b4 1 = ERR 52, HI SYS VDC ERR, LONG TEST
				; b3 1 = ERR 53,, HI SYS VDC ERR 
				; b2 1 = ERR 54, FUEL PUMP RELAY FAIL
				; b1 1 = ERR 55,
				; b0 1 = ERR 56,
;------------------------------
L5B0E   FCB $00			; 0000 0000
				; b7 1 = ERR 57,
				; b6 1 = ERR 58, HI XMISH TEMP
				; b5 1 = ERR 59, LO XMISH TEMP
				; b4 1 = ERR 61,
				; b3 1 = ERR 62, 
				; b2 1 = ERR 63, HIGH BARO PRESS
				; b1 1 = ERR 64, LOW BARO PRESS
				; b0 1 = ERR 65, 
;------------------------------
L5B0F   FCB $00			; 0000 0000
				; b7 1 = ERR 66, 3 -> 2 SHFT QUAD DVR FAIL
				; b6 1 = ERR 67, TCC ENAB QUAD DVR FAIL
				; b5 1 = ERR 68, XMISH SLIPPING
				; b4 1 = ERR 69, TCC ON
				; b3 1 = ERR 71, LOW ENGINE SPD 
				; b2 1 = ERR 72, OUTPUT SPD LOSS
				; b1 1 = ERR 73, FORCE MOTOR CURRENT
				; b0 1 = ERR 74, TURBINE SPEED
;------------------------------
L5B10   FCB $00			; 0000 0000
				; b7 1 = ERR 75, LOW SYS VOLTAGE,
				; b6 1 = ERR 76,
				; b5 1 = ERR 77, MNP SWITCH
				; b4 1 = ERR 78,
				; b3 1 = ERR 79, HOT XMISH
				; b2 1 = ERR 81, QUAD DVR 1 & SHFT B ERR
				; b1 1 = ERR 82, QUAD DVR 1 & SHFT A ERR
				; b0 1 = ERR 83, QUAD DVR 1 ERR
;------------------------------
L5B11   FCB $00			; 0000 0000
				; b7 1 = ERR 84,
				; b6 1 = ERR 85, RATIO UN-DEFINED OP REGION
				; b5 1 = ERR 86, LOW RATIO
				; b4 1 = ERR 87, HIGH RATIO
				; b3 1 = ERR 88, 
				; b2 1 = ERR 89,  MAX ADPT LONG SHFT
				; b1 1 = ERR 91,
				; b0 1 = ERR 92,
;-----------------------------------
;
;***********************************************
;* RESET STORED ERR PARAM'S		       *
;***********************************************
;
L5B12   FCB 50			; 50 PWR UP WITH NO ERR RESET ERR'S
;
;***********************************************
;* ERR QUALIFICTIONS
;*
;***********************************************
;
;------------------------------
; ERR 14/15 PARAMS
;
; L5B00	ENG ERR MASK'S
; b6 1 = ERR 14, HIGH COOLANT TEMP
; b5 1 = ERR 15, LOW COOLANT TEMP
;------------------------------
;
L5B13   FCB 42			; 42d, A/D BIN COOLANT MAX TO ENBLE ERR 14 
L5B14   FCB 5			; 1 SEC REG FOR ERR 14
;
L5B15   FCB 254			; A/D BIN COOLANT MIN TO ENBLE ERR 15  
L5B16   FCB 10			; 2 SEC REG FOR ERR 15
;
L5B17   FCB 173			;90 deg C, default cool temp
;
L5B18   FDB 0060    		;Engine runtime thresh to use high default cool temp
L5B1A	FCB 138     		;63.5 deg C, high default linear cool temp, used during run
L5B1B   FCB 80      		;20 deg C, low default linear cool temp, used during inital startup
;
;---------------------------------------------
; ERR 21/22
;                                  
;---------------------------------------------
;
L5B1C   FCB  249		; A/D TPS MIN FOR ERR 21
L5B1D   FCB  160		; 4 SEC QUAL TIME FOR ERR 21
L5B1E	FCB  255		;Threshold to set error 221 
;
L5B1F   FCB  8			; A/D TPS MAX FOR ERR 22
L5B20   FCB  160		; 4 SEC QUAL TIME FOR ERR 22
L5B21   FCB  5			;Threshold to set error 22
;
L5B22   FCB  90			;35%, default TPS
L5B23   FCB  9			; 9 A/D TPS COUNTS DEFAULT
;
;~~~~~~~~~~~~~~~~~~~~~~
;-TPS self zero params
;~~~~~~~~~~~~~~~~~~~~~~
;
L5B24   FCB  64			;25%, max idle %TPS
L5B25   FCB  16			;Filter coeff for idle %TPS 
L5B26   FCB  92     		;1.44, scalar for %TPS              
L5B27   FCB  240    		;%TPS filter coeff.
;
;~~~~~~~~~~~~~~~~~~~~~
;-Kickdown TPS params
;~~~~~~~~~~~~~~~~~~~~~
;
L5B28   FCB  255		;Filter coeff, trans. TPS 
L5B29   FCB  1			; TPS OFFSET INCR for EACH DECEL
L5B2A   FCB  10			; 5 MPH Vss TO QULIFY DECEL for TPS INCREASE
;---------------------------------------------
;
;---------------------------------------------
; XMSISH DIAGNOSTIC PARAM'S
;
;---------------------------------------------
;---------------------------------------------
; DEFINED XMISH ERRORS
;---------------------------------------------
;       Err 14 HI COOL TEMP
;       Err 15 LO COOL TEMP
;       Err 21 HI TPS
;       Err 22 LO TPS
;       Err 24 LO OUTPUT XMISH SPD
;       Err 28 PRESS SW MANAFOLD
;       Err 37 BRAKE ON
;       Err 38 BRAKE OFF
;       Err 52 HI SYS VOLTAGE, LONG TEST
;       Err 53 HI SYS VOLTAGE 
;       Err 58 HI XMIXH TEMP
;       Err 59 LO XMISH TEMP
;       Err 63 HI BARO PRESS
;       Err 64 LO BARO PRESS
;       Err 66 3 -> 2 SHFT QUAD DVR FAIL
;       Err 67 TCC ENAB QUAD DVR FAIL
;       Err 68 XMISH SLIPPING
;       Err 69 TCC ON
;       Err 71 LOW ENGINE SPD 
;       Err 72 OUTPUT SPD LOSS
;       Err 73 FORCE MOTOR CURRENT
;       Err 75 SYSTEM LOW VOLTAGE       
;       Err 79 HOT XMISH
;       Err 81 QUAD DVR 1 & SHFT B ERR
;       Err     82 QUAD DVR 1 & SHFT A ERR
;       Err     83 QUAD DVR 1 ERR
;       Err     86 LO RATIO
;       Err     87 HI RATIO
;       Err     89 MAX ADPT LONG SHIFT
;---------------------------------------------	
;
;~~~~~~~~~~~~~~~~~~~
;-Diag. word  masks
;~~~~~~~~~~~~~~~~~~~
;
;-1 = Recognize error
;
L5B2B   FCB $61			;1100 0001, Error word #1 mask
                    		; b7, 1=Err 13, O2 error
                    		; b6, 1=Err 14, High cool temp
                    		; b5, 1=Err 15, Low cool temp
                    		; b4, 1=Err 16, 2002 PPM VSS error
                    		; b3, 1=Err 17
                    		; b2, 1=Err 18
                    		; b1, 1=Err 19
                    		; b0, 1=Err 21, High TPS error
;        
L5B2C   FCB $A2     		;1010 0010, Error word #2 mask
                    		; b7, 1=Err 22, TPS low 
                    		; b6, 1=Err 23, MAT low
                    		; b5, 1=Err 24, output trans. speed low
                    		; b4, 1=Err 25, MAT high
                    		; b3, 1=Err 26,  
                    		; b2, 1=Err 27, 
                    		; b1, 1=Err 28, Trans. press. manifold
                    		; b0, 1=Err 29,
;
L5B2D   FCB $33     		;0011 0011 Error word #3 mask
                    		; b7 1 = Err 31, Governer fail
                    		; b6 1 = Err 32, EGR fail
                    		; b5 1 = Err 32, MAP high
                    		; b4 1 = Err 34, MAP low
                    		; b3 1 = Err 35, IAC fail
                    		; b2 1 = Err 36, IAC TPS kicker fail
                    		; b1 1 = Err 37, Brake sw. on
                    		; b0 1 = Err 38, Brake sw. off
;------------------------------
L5B2E   FCB $00			; 0000 0000 MASK XMISSH ERR WD 4
				; b7 1 = Err 39,
				; b6 1 = Err 41, TX, (CAM) PULSE SENSOR FAIL
				; b5 1 = Err 42, EST MONITOR ERROR
				; b4 1 = Err 43, KNOCK SYS FAIL
				; b3 1 = Err 44, o2 LEAN
				; b2 1 = Err 45, o2 RICH
				; b1 1 = Err 46, VATS FAIL
				; b0 1 = Err 47,
;------------------------------
L5B2F   FCB $18     		;0001 1000, Diag. word #5 mask 
                    		; b7 1 = Err 48, 
                   		; b6 1 = Err 49,
                    		; b5 1 = Err 51, EPROM check sum fail
                    		; b4 1 = Err 52, Hi system voltage, long test
                    		; b3 1 = Err 53, Hi system voltage
                    		; b2 1 = Err 54, Fuel pump relay failure
                    		; b1 1 = Err 55,
                    		; b0 1 = Err 56,
;
L5B30   FCB $60			; 0110 0000, Diag. word #6 mask
				; b7 1 = Err 57,
                    		; b6 1 = Err 58, High trans temp
                    		; b5 1 = Err 59, Low trans temp
                    		; b4 1 = Err 61,
                    		; b3 1 = Err 62, 
                    		; b2 1 = Err 63, High baro pressure
                    		; b1 1 = Err 64, Low baro pressure
                    		; b0 1 = Err 65, 
;
L5B31	FCB $D6			;1101 0110, Diag. word #7 mask
                    		; b7, 1 = Err 66, 3 -> 2 shift quad driver fail
                    		; b6, 1 = Err 67, TCC enable quad driver fail
                    		; b5, 1 = Err 68, Trans. slipping
         			; b4, 1 = Err 69, TCC on
               			; b3, 1 = Err 71, Low engine speed 
               			; b2, 1 = Err 72, Output speed loss
               			; b1, 1 = Err 73, Force motor current
               			; b0, 1 = Err 74, Turbine speed
;
L5B32   FCB $8E			; 1000 1110,  ERR WD 8
				; b7 1 = Err 75, LOW SYS VOLTAGE,
				; b6 1 = Err 76,
				; b5 1 = Err 77, MNP SWITCH
				; b4 1 = Err 78,
				; b3 1 = Err 79, HOT XMISH
				; b2 1 = Err 81, QUAD DVR 1 & SHFT B ERR
				; b1 1 = Err 82, QUAD DVR 1 & SHFT A ERR
				; b0 1 = Err 83, QUAD DVR 1 ERR
;
L5B33   FCB $0			; 0000 0000, Trans. diag. word #9 mask
                    		;
                    		; b7 1 = Err 84,
                    		; b6 1 = Err 85, Ratio undefined op region
                    		; b5 1 = Err 86, Low ratio
                    		; b4 1 = Err 87, High ratio
                    		; b3 1 = Err 88, 
                    		; b2 1 = Err 89, Max adapt long shift
                    		; b1 1 = Err 91,
                    		; b0 1 = Err 92,
;
;~~~~~~~~~~~~~
;-Diag. words
;~~~~~~~~~~~~~
;
;-0 = enable error
;
L5B34   FCB $0			;0000 0000, Diag. word #1
                   	 	; b7, 0=Err 13, o2 error
                    		; b6, 0=Err 14, High cool temp
                    		; b5, 0=Err 15, Low cool temp
                    		; b4, 0=Err 16, 2002 PPM VSS error
                    		; b3, 0=Err 17
                    		; b2, 0=Err 18
                    		; b1, 0=Err 19
                    		; b0, 0=Err 21, High TPS error
;                                        
L5B35   FCB $0      		;0000 0000, Diag. word #2
                    		; b7, 0=Err 22, TPS low 
                    		; b6, 0=Err 23, MAT low
                    		; b5, 0=Err 24, output trans. speed low
                    		; b4, 0=Err 25, MAT high
                    		; b3, 0=Err 26,  
                    		; b2, 0=Err 27, trans. press. manifold
                    		; b1, 0=Err 28,
                    		; b0, 0=Err 29,
;------------------------------
L5B36   FCB $0			; 0000 0000 XMISH ERR WD 3 ALT
				; b7 1 = Err 31, GOVERNER FAIL
				; b6 1 = Err 32, EGR FAIL
				; b5 1 = Err 32, MAP HI
				; b4 1 = Err 34, MAP LOW
				; b3 1 = Err 35, IAC FAIL
				; b2 1 = Err 36, IAC TPS KICKER FAIL
				; b1 1 = Err 37, BRAKE ON
				; b0 1 = Err 38, BRAKE OFF
;------------------------------
L5B37   FCB $0			; 0000 0000 XMISH ERR WD 4 ALT
				; b7 1 = Err 39,
				; b6 1 = Err 41, TX, (CAM) PULSE SENSOR FAIL
				; b5 1 = Err 42, EST MONITOR ERROR
				; b4 1 = Err 43, KNOCK SYS FAIL
				; b3 1 = Err 44, o2 LEAN
				; b2 1 = Err 45, o2 RICH
				; b1 1 = Err 46, VATS FAIL
				; b0 1 = Err 47,
;------------------------------
L5B38   FCB $0			; 0000 0000 XMISH ERR WD 5 ALT
				; b7 1 = Err 48, 
				; b6 1 = Err 49,
				; b5 1 = Err 51, EPROM CKS SUM FAIL
				; b4 1 = Err 52, HI SYS VDC ERR, LONG TEST
				; b3 1 = Err 53,, HI SYS VDC ERR 
				; b2 1 = Err 54, FUEL PUMP RELAY FAIL
				; b1 1 = Err 55,
				; b0 1 = Err 56,
;------------------------------              
L5B39   FCB $0      		; 0000 0000 XMISH ERR WD 6 ALT
                    		; b7 1 = Err 57,
                    		; b6 1 = Err 58, HI XMISH TEMP
                    		; b5 1 = Err 59, LO XMISH TEMP
                    		; b4 1 = Err 61,
                    		; b3 1 = Err 62, 
                    		; b2 1 = Err 63, HIGH BARO PRESS
                    		; b1 1 = Err 64, LOW BARO PRESS
                    		; b0 1 = Err 65, 
;
L5B3A   FCB $0			;0000 0000, Diag. word #7
				; b7, 0 = Err 66, 3 -> 2 shift quad driver fail
				; b6, 0 = Err 67, TCC enable quad driver fail
				; b5, 0 = Err 68, Trans. slipping
				; b4, 0 = Err 69, TCC on
				; b3, 0 = Err 71, Low engine speed 
				; b2, 0 = Err 72, Output speed loss
				; b1, 0 = Err 73, Force motor current
				; b0, 0 = Err 74, Turbine speed
;
L5B3B   FCB $0			;0000 0000 XMISH ERR WD 8 ALT
				; b7 1 = Err 75, LOW SYS VOLTAGE,
				; b6 1 = Err 76,
				; b5 1 = Err 77, MNP SWITCH
				; b4 1 = Err 78,
				; b3 1 = Err 79, HOT XMISH
				; b2 1 = Err 81, QUAD DVR 1 & SHFT B ERR
				; b1 1 = Err 82, QUAD DVR 1 & SHFT A ERR
				; b0 1 = Err 83, QUAD DVR 1 ERR
;
L5B3C   FCB $0			;0000 0000 Diag. word #9 
				; b7 0 = Error 84
				; b6 0 = Err 85, Ratio undefined op region
				; b5 0 = Err 86, low ratio
				; b4 0 = Err 87, high ratio
				; b3 0 = Err 88, 
				; b2 0 = Err 89,  Max adapt long shift
				; b1 0 = Err 91,
				; b0 0 = Err 92,
;
;---------------------------------------------
; ERR 24,  LO OUTPUT XMISH SPD
;                                  
;---------------------------------------------
;
L5B3D   FDB 2000		; 250 XMISH OUTPUT SPD MAX TO SET ERR 24
L5B3F   FDB 24000		; 3000 RPM MINTO SET ERR 24 
;
L5B41   FCB  120		; 3 sec TIME QUALIFICATION FOR ERR 24
L5B42   FCB  255		;Min threshold to set error 24
;
L5B43   FDB  37519		;2.289:1, ratio for reverse gear 
;
L5B45   FCB  100		; IF  LD L.T. 100 Kpa,   DISABLE Err 24 TEST
L5B46   FCB  255		; IF  LD G.T. 255 Kpa,   DISABLE Err 24 TEST
L5B47   FCB  26			; IF TPS L.T. 10% TPS,   DISABLE Err 24 TEST
L5B48   FCB  255		; IF TPS G.T. 99.6% TPS, DISABLE Err 24 TEST
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Transmission gear ratios
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Gear ratio = val/16384		;Gear #
;
L5B49   FDB  50135			;1st 
	FDB  26705			;2nd 
	FDB  16384			;3rd 
	FDB  11468			;4th 
;
;--------------------------------------------------
; ERR 28, PRESS SW MANAFOLD
;                                  
;--------------------------------------------------
;
L5B51   FCB  80			; 2 Sec CRITERIA FOR ERR 28
L5B52   FCB  255		;Threshold to set error
;
;--------------------------------------------------
; ERR 37,  BRAKE ON 
;                                  
;--------------------------------------------------
;
L5B53   FCB  10			; IF 5 MPH, CK FOR HI MPH BRAKE ON
L5B54   FCB  40			; IF 20 MPH & BRAKE STILL ON SET ERR 37
L5B55   FCB  60			; 6 SECS CRITERIA FOR ERR 37 
L5B56   FCB  60			; 6 SECS CRITERIA FOR ERR 37
L5B57   FCB  7			; 7 ERR CNTS MIN TO ENABLE ERR 37
L5B58	FCB  255		;Threshold to set error
;
;--------------------------------------------------
; ERR 38, BRAKE OFF 
;                                  
;--------------------------------------------------
;
L5B59   FCB  40			; IF G.T. 20 MPH CK LO MPH BRAKE OFF
L5B5A   FCB  10			; IF L.T. 5 MPH CK LO MPH BRAKE OFF
;
L5B5B   FCB  60 		; 6 SECS CRITERIA FOR ERR 38 
L5B5C   FCB  60			; 6 SECS CRITERIA FOR ERR 38
L5B5D   FCB  7			; 7 ERR CNTS MIN TO ENABLE ERR 37
L5B5E   FCB  255		;Threshold to set error
;
;--------------------------------------------------
; ERR 52, HI SYS VOLTAGE, LONG TEST 
;                                  
;--------------------------------------------------
l
L5B5F   FCB  160		; IF BATT G.T. 16 VDC ENABLE ERR 52
L5B60   FDB  65535		; IF COND G.T 6553.5 SEC, SET ERR 52
;
;--------------------------------------------------
; ERR 53, HI SYS VOLTAGE 
;                                  
;--------------------------------------------------
;
L5B62   FCB  195		; IF BATT G.T. 19.5 VDC ENABLE ERR 53 
L5B63   FCB  20			; IF COND G.T 2 SEC, SET ERR 53
;
;--------------------------------------------------
; ERR 58,  HI XMIXH TEMP
;                                  
;--------------------------------------------------
;
L5B64   FCB  17			; IF TRANS TEMP (A/D) L.T. 17 ENABLE ERR 58
L5B65   FCB  5			; 1 SEC CRITERIA
L5B66   FCB  227		;130 deg C, default trans temp
;
;--------------------------------------------------
; ERR 59,  LO XMISH TEMP
;                                  
;--------------------------------------------------
;
L5B67   FCB  251		; IF TRANS TEMP (A/D) GT. 251 INABLE ERR 59
L5B68   FCB  5			; 1 SEC CRITERIA 
;
;--------------------------------------------------
; ERR 63,  HI BARO PRESS
;                                  
;--------------------------------------------------
;
L5B69   FCB  249		; IF BARO (A/D) G.T. 249 INABLE ERR 63
L5B6A   FCB  20			; 0.5 SEC CRITERIA 
L5B6B	FDB  32768		; DEFAULT 100 Kpa BARO IF ERR 63
;
;--------------------------------------------------
; ERR 64, LO BARO PRESS 
;                                  
;--------------------------------------------------
;
L5B6D   FCB  3			; IF BARO (A/D) L.T. 3 INABLE ERR 64
L5B6E   FCB  20			; 0.5 SEC CRITERIA 
L5B6F   FDB  32768		; DEFAULT 100 Kpa BARO IF ERR 64
;
;--------------------------------------------------
; ERR 66,  3 -> 2 SHIFT QUAD DVR FAIL
;                                  
;--------------------------------------------------
;
L5B71   FCB  40			; 4 SEC CRITERIA FOR ERR 66
L5B72   FCB  255		; 255 ERR CNTS MIN TO SET ERR 66
;
;--------------------------------------------------
; ERR 67,  TCC ENAB QUAD DVR FAIL
;                                  
;--------------------------------------------------
;
L5B73   FCB  20			; 2 SEC CRITERIA FOR ERR 67
L5B74   FCB  255		;Threshold to set error
;
;--------------------------------------------------
; ERR 68, XMISH SLIPPING 
;                                  
;--------------------------------------------------
;
L5B75   FDB  0320		; IF SLIP G.T. 100 RPM, TCC NOT LOCKED
L5B77   FCB  255		;sec. x 10 threshold to set error
L5B78   FCB  10			;Threshold to set error
L5B79   FCB  10			;Threshold to set error	
;
;--------------------------------------------------
; ERR 69,  TCC ON 
;                                  
;--------------------------------------------------
;
L5B7A   FDB  0160		; IF SLIP G.T. 20 RPM, TCC UN-LOCKED
L5B7C   FDB  65376		; IF SLIP L.T or E.Q. -20 RPM, TCC UN-LOCKED 

L5B7E   FCB  40			; 4 SECS CRITERIA FOR ERR 69  
L5B7F   FCB  64			; IF TPS L.T oR E.Q 25% DISABLE ERR 69
;
;--------------------------------------------------
; ERR 71,  LOW ENGINE SPD  
;                                  
;--------------------------------------------------
;
L5B80   FDB  1600		; IF ENG SPD L.T  200 RPM ENABLE ERR 71

L5B82   FCB  80			; 2 SECS CRITERIA FOR ERR 71   

L5B83   FDB  2400		; IF ENG SPD L.T 300 RPM ENABLE ERR 71
;
;--------------------------------------------------
; ERR 72, OUTPUT SPD LOSS 
;                                  
;--------------------------------------------------
;
L5B85   FDB  8000		; IF ABS G.T. 1000 RPM ENABLE ERR 72
				; USED IF NOT IN PK/NEUT
;                    
L5B87   FDB  16384		; IF ABS G.T. 2048 RPM ENABLE ERR 72
				; USED IF NOT IN PK/NEUT
;                    
L5B89   FDB  1600		; IF NE L.T. 200 RPM SKIP TEST
;
L5B8B   FCB  255		; IF ERR CNT'R G.T. 255 SET ERR 72
L5B8C   FCB  80			; 2 SECS CRITERIA FOR ERR 72   
;
;--------------------------------------------------
; ERR 73,  FORCE MOTOR CURRENT
;                                  
;--------------------------------------------------
;
L5B8D   FCB  8			; IF CURRENT G.T 160 MA ERR 73
				; CAL = AMPS * 51.2
L5B8E   FCB  20			; 2 SECS CRITERIA FOR ERR 73 
L5B8F   FCB  10			; IF ERR CNT'R G.T. 10 SET ERR 72
;
;--------------------------------------------------
; ERR 75, SYSTEM LOW VOLTAGE
;                                  
;--------------------------------------------------
;
L5B90   FCB  73			;  7.3 VDC LO TEMP VOLTAGE 
L5B91   FCB  114		; 11.4 VDC HI TEMP VOLTAGE
L5B92   FCB  83			;  8.3 VDC LO TEMP RECOVERY VOLTAGE 
L5B93   FCB  124		; 12.4 VDC HI TEMP RECOVERY VOLTAGE
;
L5B94   FCB  40			; 4 SECS CRITERIA FOR ERR 75 
L5B95   FDB  1600		; IF NE L.T. 200 RPM SKIP TEST
;
;--------------------------------------------------
; ERR 77, MNP SWITCH
;                                  
;--------------------------------------------------
;
L5B97   FCB  40			; 1 SECS CRITERIA FOR ERR 77
;
;--------------------------------------------------
; ERR 79,  HOT XMISH
;                                  
;--------------------------------------------------
;
L5B98   FCB  236		; Clear ERR IF TEMP L.T. 137 Deg c 
L5B99   FCB  248		; SET ERR IF TEMP G.T. 146 Deg c  
;
L5B9A   FDB  18000		; 1800 SEC CRITERIA FOR ERR 79 
;
;--------------------------------------------------
; ERR 81, QUAD DVR 1 & SHFT B ERR 
;                                  
;--------------------------------------------------
;
L5B9C   FCB  20			; 2 SEC CRITERIA FOR ERR 81
L5B9D   FCB  255    		;Threshold to set error
;
;--------------------------------------------------
; ERR 82, QUAD DVR 1 & SHFT A ERR 
;                                  
;--------------------------------------------------
;
L5B9E   FCB  20			; 2 SEC CRITERIA FOR ERR 82
L5B9F   FCB  255		; IF ERR CNT'R G.T. 255 SET ERR 82
;
;--------------------------------------------------
; ERR 83,  QUAD DVR 1 ERR
;                                  
;--------------------------------------------------
;
L5BA0   FCB  20			; 2 SEC CRITERIA FOR ERR 83
L5BA1   FCB  5			;Threshold to set error
;
;~~~~~~~~~
;Error 85 
;~~~~~~~~~
;
L5BA2   FCB  10     		;Threshold to set error
;
;--------------------------------------------------
; ERR 86,  LO RATIO
;                                  
;--------------------------------------------------
;
L5BA3   FCB  65535		; IF L.T 16383.6:1  SET ERR 86
;
L5BA5   FCB  255		; IF TPS L.T or E.Q 99.6% SKIP
L5BA6   FCB  255		; IF MPH L.T or E.Q 127.5 SKIP
L5BA7   FCB  255		; 25.5SEC CRITERIA FOR ERR 86 
L5BA8   FCB  255    		;Threshold to set error
;
;--------------------------------------------------
; ERR 87, HI RATIO 
;                                  
;--------------------------------------------------
;
L5BA9   FDB  0000		; IF L.T 0:1  SET ERR 87
;
L5BAB   FCB  255		; IF TPS L.T or E.Q 99.6% SKIP
L5BAC   FCB  255		; IF XMISH TEMP G.T 151 ENABLE 87
L5BAD   FCB  255		; 25.5SEC CRITERIA FOR ERR 87
L5BAE   FCB  255    		;Threshold to set error
;
;--------------------------------------------------
; ERR 89,  MAX ADPT LONG SHIFT
;                                  
;--------------------------------------------------
;
L5BAF   FCB  0			; IF XMISH TEMP L.T. or E.Q. -40 ENABLE 89
L5BB0   FCB  0			; IF TPS L.T. or E.Q. 0% SKIP 89
L5BB1   FCB  255		; IF MPH L.T. or E.Q. 127.5 SKIP 89
;
L5BB2   FCB  0			; IF 1 -> 2 TIME L.T. or E.Q. 0 SKIP 89 
L5BB3   FCB  0			; IF 2 -> 3 TIME L.T. or E.Q. 0 SKIP 89 
L5BB4   FCB  0			; IF 3 -> 4 TIME L.T. or E.Q. 0 SKIP 89 
;
L5BB5   FCB  0			; IF ERR CNT'R G.T. 0 SET ERR 89, (1 -> 2)
L5BB6   FCB  0			; IF ERR CNT'R G.T. 0 SET ERR 89, (2 -> 3)
L5BB7   FCB  0			; IF ERR CNT'R G.T. 0 SET ERR 89, (3 -> 4)
L5BB8   FCB  0			;Threshold to set error
;
;************************************
;* END OF XMISSION DIAGNOSTIC PARAMS
;************************************
;
; BDWM 94 5.7L V8
; TYPE 0D ECM
;
;***************************************************
;* BDWM/9042   P/N 16189041   10-11-1993  15:54:04
;* 3/4/94 WAS
;* 
;*
;*   5.7L V8 C1 M30 GT4 (3.73) NB2 NB6 TIER 1 
;*   ECM TYPE $0D
;*   ECM P/N 16196395 ECM
;*
;*   4L60E XMISSION PARAMS
;*   TYPE $0D ECM
;*   5.7l L05
;* 
;*************************************************** 
;		
        ORG $5D00
;      
L5D00   FDB $9CB6		; EPROM ID FOR XMISH
;
L5D02	FCB $21			;0010 0001, Option byte
                    		; b7=
                    		; b6=
                    		; b5, 1 = Force 2nd gear if in OD and not in manualFORCE 2ND GR IF IN D2 AND NOT MANUAL
                    		; b4, 0 = Output speed from dig. ratio adaptor.   
                    		; b3=
                    		; b2, 1=Use MAP and baro, 0=MAP only
                    		; b1=
                    		; b0, 1 = Allow TPS hyst. buffer every 25 msecs
;
L5D03   FCB $1F			; 0001 1111, BYTE 2, filter mode wd
				;
				; b7
				; b6
				; b5
				; b4 1 = Filter 4 wheel drive low input 
				; b3 1 = Filter cruise input
				; b2 1 = Filter A/C input
				; b1 1 = Filter pattern inputs
				; b0 1 = Filter range inputs  
;
L5D04   FCB 4			;val./160 = .025 sec, min time for brake switch change state  
;
L5D05   FCB 121     		;5.1 kPa/256 counts, trans baro scalar 
L5D06   FDB 3513    		;7.31 kPa, trans baro bias   
L5D08   FCB 64			; 87 msec, baro filt time const
;
L5D09   FCB 101			;Transmission temperature filter coeff.
L5D0A   FCB 12     		;Engine coolant for transmission filter coeff.
L5D0B   FCB 52			; 0.303, converter slip filter
;
L5D0C   FCB 3			; 70 msec, power train rest time thresh
L5D0D   FCB 0			; FLAG, 0, non z to disable manual mode
L5D0E   FCB 21			; 21 samples for derivative calc
;
;==============================================
; SPEED SENSOR CALIBRATION PARAM'S
; (2^14 TIME BASE)
;
;==============================================
;
; FILTER CONSTANTS
;
L5D0F	FCB 64			; 0.260, RPM filter
L5D10	FCB 252			; 0.984, INPUT SPD FILTER 
L5D11   FCB 252			; 0.984, XMISH INPUT SPD FILTER 
				;			(TOS filt const)
;
L5D12	FCB 1			;20 msec max time to wait for TOS signal before signal
				;considered lost

L5D13   FDB 43686		; 0.750:1, Overdirve Ratio
				; 0.5 to 2:1,   2^15/Ratio 

L5D15   FCB 252			;Transmission output speed filter
;
L5D16   FDB 44564		2.72:1, 4WD low reduction ratio
;
L5D18   FDB 45773		; 44.70:1 NO/VS RATIO <-------***** 
				; VAL = RATIO * 1024
				;
				; Ratio = (Tire Rev's Mile x Gear Ratio)/60
				; 		= (721 x 3.73)/60 = 44.82
				;		   [721 = 235/75R16], 95 TAHOE
;
L5D1A	FCB 252			;  0.984, Vss filter
;
;~~~~~~~~~~~~~~~~~~~~~
;-Kickdown TPS params
;~~~~~~~~~~~~~~~~~~~~~
;
L5D1B	FCB 242			;95% TPS, threshold to enable kickdown
L5D1C   FCB 230			;90.2% TPS, threshold to disable kickdown
;
;----------------------------------------------
; POWER TRAIN MOTION PARAMS 
;
;----------------------------------------------
;
L5D1D   FDB 1600		; 200 RPM MIN FOR PT IN MOTION
				; RPM * 8  
;
L5D1F   FDB 65535		; 8191.9 RPM VEH SPD MIN FOR IN MOTION
				; RPM * 8  
;
L5D21   FDB 65535		; 8191.9 RPM TURBINE SPD MIN FOR IN MOTION
				; RPM * 8 
; 
;---------------------------------------------- 
; 4WD LOW PARAMS
;   
;---------------------------------------------- 
;
L5D23   FDB 160			; 4 sec DISABLE ERR 72 4 SEC DURING 4WD 
				; LO -> HI/HI -> LO
;
;***********************************************
;* DATA SHIFT POINT CONTROL
;* (shift pattern params)
;***********************************************
;
L5D24   FCB 0			; 0 SEC'S, TCC off time prior to dn shift
;
L5D25   FCB 10			; 10 SEC'S, 3 -> 2 shift delay     
;
L5D26   FCB 2			;  2 Sec's, 4 -> 2 shift delay lo lmt      
L5D27   FCB 15			; 15 Sec's, 4 -> 2 shift delay hi lmt   
;
L5D28   FCB 29			; -18c COOL, Lo lmt for 4th Gear disable 
L5D29   FCB 33			; -15c COOL, Lo lmt for 4th Gear ok
;
L5D2A   FCB 93			;30 deg C, lower cold shift bound
L5D2B   FCB 100			;35 deg C, upper cold shift bound 
;
L5D2C   FCB 128			; 0 BASE SHIFT POINT COMP GAIN
;
;---------------------------------------------- 
;  SOFT LANDING ROUTINE ???
;
;---------------------------------------------- 
;
L5D2D   FDB 5200		; 650 RPM  
;   
;---------------------------------------------- 
; MIN/MAX SHIFT POINT VAL'S
;
;---------------------------------------------- 
;
L5D2F   FCB 0			; 0 MPH MIN VAL FOR SHIFT POINT, 
				; MUST BE A 0 
;
L5D30   FCB  255		; 1275. MAX VAL FOR SHIFT POINT, 
				; must be 255
;
;---------------------------------------------- 
; LOW PK/NEUT PARAMS MANUAL LOW 
; (WILL FORCE 1 -> 2)
;---------------------------------------------- 
;
L5D31   FCB 56			; 28 MPH LOW MODE 1 -> 2 SHIFT THRESH 
L5D32   FCB 52			; 26 MPH LOW MODE 2 -> 1 SHIFT THRESH 
;
;***********************************************
;* The following table are 'AND' with
;* RPM kickdown tables, (3)
;*
;* MY94 TYPE $0D, BDHM
;***********************************************
;
;----------------------------------------------
; KICK DOWN MODE Vs GEAR THRESH TABLE, (NORMAL)
; 6 LINES 
;
; SEE RPM QUALIFIER AT L5D45 (3 LINE TBL)
;
; TBL VAL = MPH * 2
;----------------------------------------------
;
       	ORG $5D33		
;			
				;  RPM            GEAR SHIFT       
;
L5D33   FCB 56			;  28.0  MPH        1 -> 2
L5D34   FCB 106			;  53.0  MPH        2 -> 3
L5D35   FCB 254			; 127.0  MPH        3 -> 4
;
L5D36   FCB 46			;  23.0  MPH        2 -> 1
L5D37   FCB 98			;  49.0  MPH        3 -> 2
L5D38   FCB 250			; 125.0  MPH        4 -> 3
;
;----------------------------------------------
; KICK DOWN MODE  THRESH TABLE, (HOT)
; 6 LINES 
;
; SEE RPM QUALIFIER AT L5D4B (3 LINE TBL)
;
; TBL VAL = MPH * 2
;----------------------------------------------
;
       	ORG $5D39
;	
				;  RPM            GEAR SHIFT       
;
L5D39   FCB 55			;  25.0 MPH         1 -> 2  
L5D3A   FCB 101			;  50.5 MPH         2 -> 3 
L5D3B   FCB 254			; 127.0 MPH         3 -> 4
;
L5D3C   FCB 45			;  22.5 MPH         2 -> 1  
L5D3D   FCB 93			;  41.5 MPH         3 -> 2  
L5D3E   FCB 244			; 122.0 MPH         4 -> 3  
; 
;----------------------------------------------
; KICK DOWN MODE  THRESH TABLE, (COLD MODIFER)
; 6 LINES 
;
; TBL VAL = MPH -128  (128 = 0 MPH MOD)
;----------------------------------------------	
;
				;  RPM            GEAR SHIFT       
;
L5D3F   FCB 124			; -2   MPH          1 -> 2  
L5D40   FCB 122			; -3   MPH          2 -> 3  
L5D41   FCB 128			;  0   MPH          3 -> 4 
;
L5D42   FCB 124			; -2   MPH          2 -> 1   
L5D43   FCB 122			; -3   MPH          3 -> 2   
L5D44   FCB 128			;  0   MPH          4 -> 3  
;
;----------------------------------------------
; KICK DOWN MODE THRESH TABLE, (NORMAL)
; 3 LINES 
;
; TBL VAL = RPM * 8
;----------------------------------------------
;
				;  RPM            GEAR SHIFT       
;
L5D45   FDB 32000		; 4000   RPM        1 -> 2   
L5D47   FDB 32000		; 4000   RPM        2 -> 3  
L5D49   FDB 65535		; 8192   RPM        3 -> 4         
;
;----------------------------------------------
; KICK DOWN MODE  THRESH TABLE, (HOT)
; 3 LINES 
;
; TBL VAL = RPM * 8
;----------------------------------------------
;
       	ORG $5D4B	

				;  RPM            GEAR SHIFT       
;
L5D4B   FDB 30370		; 3796   RPM        1 -> 2  
L5D4D   FDB 30370		; 3796   RPM        2 -> 3 
L5D4F   FDB 65535		; 8192   RPM        3 -> 4 
;
;----------------------------------------------
; KICK DOWN MODE  THRESH TABLE, (COLD MOD)
; 3 LINES 
; TBL VAL =
;----------------------------------------------
;

				;  RPM            GEAR SHIFT       
L5D51   FDB 63936		;	-200  RPM           1 -> 2   
L5D53   FDB 63936		;	-200  RPM           2 -> 3     
L5D55   FDB 63936		;	-200  RPM           3 -> 4 
;
;***********************************************
;* MANUAL UP SHIFT CALIBRATIONS
;*
;***********************************************
;
;----------------------------------------------
; MANUAL 1 -> 2 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
				;  MPH             %TPS
;
L5D57  	FCB   0			;     0.0           0.0
	FCB   0			;     0.0           6.3
	FCB   0			;     0.0          12.5
	FCB   0			;     0.0          18.8
	FCB   0			;     0.0          25.0
	FCB   0			;     0.0          31.3
	FCB   0			;     0.0          37.5
	FCB   0			;     0.0          43.8
	FCB   0			;     0.0          50.0
	FCB   0			;     0.0          56.3
	FCB   0			;     0.0          62.5
	FCB   0			;     0.0          68.8
	FCB   0			;     0.0          75.0
	FCB   0			;     0.0          81.3
	FCB   0			;     0.0          87.5
	FCB   0			;     0.0          93.8
	FCB   0			;     0.0         100.0
;
;***********************************************
;* MANUAL DOWN SHIFT CALIBRATIONS
;*
;***********************************************
;
;----------------------------------------------
; MANUAL 2 -> 1 SHIFT Vs. %TPS
;
;
;
; TBL = MPH * 2
;----------------------------------------------
;
				;  MPH             %TPS
;
L5D68  	FCB   0			;     0.0           0.0
	FCB   0			;     0.0           6.3
	FCB   0			;     0.0          12.5
	FCB   0			;     0.0          18.8
	FCB   0			;     0.0          25.0
	FCB   0			;     0.0          31.3
	FCB   0			;     0.0          37.5
	FCB   0			;     0.0          43.8
	FCB   0			;     0.0          50.0
	FCB   0			;     0.0          56.3
	FCB   0			;     0.0          62.5
	FCB   0			;     0.0          68.8
	FCB   0			;     0.0          75.0
	FCB   0			;     0.0          81.3
	FCB   0			;     0.0          87.5
	FCB   0			;     0.0          93.8
	FCB   0			;     0.0         100.0
;
;***********************************************
;* NORM/CRUISE DOWN SHIFT CALIBRATIONS
;*
;***********************************************
;
;----------------------------------------------
; NORM/CRUISE 2 -> 3 SHIFT Vs. %TPS
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
				;  MPH             MPH
;
L5D79   FCB  38			;  19.0            0.0
	FCB  38			;  19.0            6.3
	FCB  41			;  20.5           12.5
	FCB  51			;  25.5           18.8
	FCB  61			;  30.5           25.0
	FCB  67			;  33.5           31.3
	FCB  71			;  35.5           37.5
	FCB  75			;  37.5           43.8
	FCB  79			;  39.5           50.0
	FCB  83			;  41.5           56.3
	FCB  87			;  43.5           62.5
	FCB  91			;  45.5           68.8
	FCB  94			;  47.0           75.0
	FCB  97			;  48.5           81.3
	FCB  102		;  51.0           87.5
	FCB  106		;  53.0           93.8
	FCB  106		;  53.0          100.0
;
;----------------------------------------------
; NORM/CRUISE 3 -> 4 SHIFT
;
; Vss Vs. % TPS
;
;  Dissassemby of 
;
; TBL = MPH * 2
;---------------------------------------------
;
				;  MPH              %TPS
;
L5D8A   FCB  55			;  27.5            0.0
	FCB  55			;  27.5            6.3
	FCB  57			;  28.5           12.5
	FCB  66			;  33.0           18.8
	FCB  76			;  38.0           25.0
	FCB  86			;  43.0           31.3
	FCB  95			;  47.5           37.5
	FCB  226		; 113.0           43.8
	FCB  226		; 113.0           50.0
	FCB  226		; 113.0           56.3
	FCB  226		; 113.0           62.5
	FCB  226		; 113.0           68.8
	FCB  226		; 113.0           75.0
	FCB  226		; 113.0           81.3
	FCB  226		; 113.0           87.5
	FCB  226		; 113.0           93.8
	FCB  226		; 113.0          100.0
;
;
;**********************************************
;* NORM/CRUISE UP SHIFT CALIBRATIONS
;*
;**********************************************
;
;---------------------------------------------
; NORM/CRUISE 3 -> 2 SHIFT Vs. %TPS
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;---------------------------------------------
;
				; MPH             %TPS
;
L5D9B   FCB 36			;  18.0            0.0
	FCB 36			;  18.0            6.3
	FCB 36			;  18.0           12.5
	FCB 36			;  18.0           18.8
	FCB 36			;  18.0           25.0
	FCB 36			;  18.0           31.3
	FCB 36			;  18.0           37.5
	FCB 36			;  18.0           43.8
	FCB 47			;  23.5           50.0
	FCB 58			;  29.0           56.3
	FCB 63			;  31.5           62.5
	FCB 69			;  34.5           68.8
	FCB 73			;  36.5           75.0
	FCB 79			;  39.5           81.3
	FCB 85			;  42.5           87.5
	FCB 90			;  45.0           93.8
	FCB 98			;  49.0          100.0
;
;---------------------------------------------
; NORM/CRUISE 4 -> 3 SHIFT Vs. %TPS
;  
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;---------------------------------------------
;
				; MPH             %TPS
;
L5DAC   FCB 48			;  24.0            0.0
	FCB 48			;  24.0            6.3
	FCB 48			;  24.0           12.5
	FCB 49			;  24.5           18.8
	FCB 54			;  27.0           25.0
	FCB 60			;  30.0           31.3
	FCB 66			;  33.0           37.5
	FCB 70			;  35.0           43.8
	FCB 76			;  38.0           50.0
	FCB 84			;  42.0           56.3
	FCB 91			;  45.5           62.5
	FCB 100			;  50.0           68.8
	FCB 113			;  56.5           75.0
	FCB 220			; 110.0           81.3
	FCB 220			; 110.0           87.5
	FCB 220			; 110.0           93.8
	FCB 220			; 110.0          100.0
;
;**********************************************
;* NORMAL UP SHIFT
;*
;**********************************************
;
;---------------------------------------------
; NORMAL 1 -> 2 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;---------------------------------------------
;
				;  MPH             %TPS
;
L5DBD   FCB 20			;  10.0            0.0
	FCB 20			;  10.0            6.3
	FCB 24			;  12.0           12.5
	FCB 28			;  14.0           18.8
	FCB 33			;  16.5           25.0
	FCB 36			;  18.0           31.3
	FCB 38			;  19.0           37.5
	FCB 40			;  20.0           43.8
	FCB 42			;  21.0           50.0
	FCB 44			;  22.0           56.3
	FCB 46			;  23.0           62.5
	FCB 48			;  24.0           68.8
	FCB 50			;  25.0           75.0
	FCB 52			;  26.0           81.3
	FCB 54			;  27.0           87.5
	FCB 56			;  28.0           93.8
	FCB 56			;  28.0          100.0
;
;---------------------------------------------
; NORMAL 2 -> 3 SHIFT Vs. %TPS
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;---------------------------------------------
;
				; MPH             %TPS
;
L5DCE   FCB 38			;  19.0            0.0
	FCB 38			;  19.0            6.3
	FCB 41			;  20.5           12.5
	FCB 51			;  25.5           18.8
	FCB 61			;  30.5           25.0
	FCB 67			;  33.5           31.3
	FCB 71			;  35.5           37.5
	FCB 75			;  37.5           43.8
	FCB 79			;  39.5           50.0
	FCB 83			;  41.5           56.3
	FCB 87			;  43.5           62.5
	FCB 91			;  45.5           68.8
	FCB 94			;  47.0           75.0
	FCB 97			;  48.5           81.3
	FCB 102			;  51.0           87.5
	FCB 106			;  53.0           93.8
	FCB 106			;  53.0          100.0
;
;---------------------------------------------
; NORMAL 3 -> 4 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;---------------------------------------------
;
				;  MPH             %TPS
;
L5DDF   FCB	55		;  27.5            0.0
	FCB	55		;  27.5            6.3
	FCB	57		;  28.5           12.5
	FCB	66		;  33.0           18.8
	FCB	76		;  38.0           25.0
	FCB	86		;  43.0           31.3
	FCB	95		;  47.5           37.5
	FCB	103		;  51.5           43.8
	FCB	111		;  55.5           50.0
	FCB	121		;  60.5           56.3
	FCB	226		; 113.0           62.5
	FCB	226		; 113.0           68.8
	FCB	226		; 113.0           75.0
	FCB	226		; 113.0           81.3
	FCB	226		; 113.0           87.5
	FCB	226		; 113.0           93.8
	FCB	226		; 113.0          100.0
;
;**********************************************
;* NORMAL DOWN SHIFT
;*
;**********************************************
;
;---------------------------------------------
; NORMAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS
;
;  Dissassemby of BDWM
;
;
; TBL = MPH -128
;---------------------------------------------
;
				; MPH           TPS
;
L5DF0   FCB  16			;   8.0            0.0
	FCB  16			;   8.0            6.3
	FCB  16			;   8.0           12.5
	FCB  16			;   8.0           18.8
	FCB  16			;   8.0           25.0
	FCB  16 		;   8.0           31.3
	FCB  16			;   8.0           37.5
	FCB  16			;   8.0           43.8
	FCB  16			;   8.0           50.0
	FCB  16			;   8.0           56.3
	FCB  16			;   8.0           62.5
	FCB  16			;   8.0           68.8
	FCB  18			;   9.0           75.0
	FCB  23			;  11.5           81.3
	FCB  31			;  15.5           87.5
	FCB  43			;  21.5           93.8
	FCB  43			;  21.5          100.0
;
;---------------------------------------------
; NORMAL DN SHIFT, 3 -> 2 SHIFT Vs. %TPS
;
;  Dissassemby of BDWM
;
;
; TBL = MPH * 2
;---------------------------------------------
;
				;  MPH            %TPS
;
L5E01   FCB  36			;  18.0            0.0
	FCB  36			;  18.0            6.3
	FCB  36			;  18.0           12.5
	FCB  36			;  18.0           18.8
	FCB  36			;  18.0           25.0
	FCB  36			;  18.0           31.3
	FCB  36			;  18.0           37.5
	FCB  36			;  18.0           43.8
	FCB  47			;  23.5           50.0
	FCB  58			;  29.0           56.3
	FCB  63			;  31.5           62.5
	FCB  69			;  34.5           68.8
	FCB  73			;  36.5           75.0
	FCB  79			;  39.5           81.3
	FCB  85			;  42.5           87.5
	FCB  90			;  45.0           93.8
	FCB  98			;  49.0          100.0
;
;---------------------------------------------
; NORMAL DN SHIFT, 4 -> 3 SHIFT Vs. %TPS TBL
;
; Vss Vs. %TPS
;
;  Dissassemby of BBWM
;
;
; TBL = MPH * 2
;---------------------------------------------
;
				;  MPH             %TPS
;
L5E12	FCB  48			;  24.0            0.0
	FCB  48			;  24.0            6.3
	FCB  48			;  24.0           12.5
 	FCB  49			;  24.5           18.8
	FCB  54			;  27.0           25.0
	FCB  60			;  30.0           31.3
	FCB  66			;  33.0           37.5
	FCB  70			;  35.0           43.8
	FCB  76			;  38.0           50.0
	FCB  84			;  42.0           56.3
	FCB  91			;  45.5           62.5
	FCB  100		;  50.0           68.8
	FCB  113		;  56.5           75.0
	FCB  220		; 110.0           81.3
	FCB  220		; 110.0           87.5
	FCB  220		; 110.0           93.8
	FCB  220		; 110.0          100.0
;
;**********************************************
;* XMISH COLD UP SHIFT MODIFICATIONS CAIBRATION
;*
;**********************************************
;
;---------------------------------------------
; COLD (MOD) 1 -> 2 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;---------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E23  	FCB   128		;     0.0           0.0
	FCB   128		;     0.0           6.3
	FCB   124		;    -2.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;--------------------------------------------------
; COLD (MOD) 2 -> 3 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;-------------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E34  	FCB   128		;     0.0           0.0
	FCB   128		;     0.0           6.3
	FCB   124		;    -2.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;---------------------------------------------
; COLD (MOD) 3 -> 4 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;---------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E45  	FCB   128		;     0.0           0.0
	FCB   128		;     0.0           6.3
	FCB   128		;     0.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;**********************************************
;* XMISH COLD DN SHIFT MODIFICATIONS CAIBRATION
;*
;**********************************************
;
;---------------------------------------------
; COLD (MOD) 2 -> 1 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;---------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E56	FCB   128		;     0.0           0.0
	FCB   124		;    -2.0           6.3
	FCB   124		;    -2.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;---------------------------------------------
; COLD (MOD) 3 -> 2 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;---------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E67	FCB   128		;     0.0           0.0
	FCB   124		;    -2.0           6.3
	FCB   124		;    -2.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;---------------------------------------------
; COLD (MOD) 4 -> 3 SHIFT Vs. %TPS
;
;
;  Dissassemby of BDWM
;
; TBL = (MPH * 2) - 64
;---------------------------------------------
;
				; MPH, (MOD)       %TPS
;
L5E78	FCB   128		;     0.0           0.0
	FCB   124		;    -2.0           6.3
	FCB   124		;    -2.0          12.5
	FCB   124		;    -2.0          18.8
	FCB   124		;    -2.0          25.0
	FCB   124		;    -2.0          31.3
	FCB   124		;    -2.0          37.5
	FCB   124		;    -2.0          43.8
	FCB   124		;    -2.0          50.0
	FCB   124		;    -2.0          56.3
	FCB   124		;    -2.0          62.5
	FCB   124		;    -2.0          68.8
	FCB   124		;    -2.0          75.0
	FCB   124		;    -2.0          81.3
	FCB   124		;    -2.0          87.5
	FCB   124		;    -2.0          93.8
	FCB   124		;    -2.0         100.0
;
;**********************************************
;* 3 -> 2 DOWNSHIFT PATTERN 1994 4L60E XMISSION
;*
;**********************************************
;
L5E89	FCB $0F			; ENABLE FLAGS 1994 4L60E XMISSION 
				; b7 = not used
				; b6 = not used
				; b5 = not used
				; b4 = not used
				; b3 = not used    
				; b2 =  1 = A/C  comp enabled
				; b1 =  1 = temp comp enabled
				; b0 = not used
;
L5E8A	FCB 00			; 0%,  MIN ALLOWED %D.C. FOR 3 -> 2 SHIFT
L5E8B	FCB 230 		; 90%, MAX ALLOWED %D.C. FOR 3 -> 2 SHIFT 
;
L5E8C	FCB 0			; 0 % D.C. OVERRIDE IN D3 - D2
L5E8D	FCB 0			; 0%, 2 - 3 SHFT IN CASE OF NO LOSS
L5E8E	FCB 40			; 2 SEC'S, PERIOD OF 3 -> 2 SHIFT
;
L5E8F	FCB 135			; 2.7% D.C., A/C COMP OFFSET
;
;---------------------------------------------
; BASE D.C. Vs. MPH Vs. BARO
;
;  Dissassemby of BDWM
; 17 x 17 TABLE
;
; TBL = %D.C. * 2.56
;---------------------------------------------
;
L5E90   FCB   0    	; Min BARO Kpa Val, (128/BARO)
        FCB   0    	; Min MPH Value, (10 MPH, SCALED)
        FCB   17   	; COL'S/ROW
;
;	MPH: 10   14   18   22   26   30   34   38   42   46   50   54   58   62   66   70   74 :kPa baro
;
L5E93	FCB  25,  25,  25,  97, 172, 192, 212, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 50
	FCB  25,  25,  25,  97, 172, 192, 212, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 54 
	FCB  25,  25,  25,  97, 172, 192, 212, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 58         
	FCB  25,  25,  25,  97, 172, 192, 212, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 62          
	FCB  25,  25,  25,  89, 164, 184, 204, 224, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 66 
	FCB  25,  25,  25,  81, 156, 176, 196, 216, 230, 230, 230, 230, 230, 230, 230, 230, 230 ; 70 
	FCB  25,  25,  25,  73, 148, 168, 188, 208, 228, 230, 230, 230, 230, 230, 230, 230, 230 ; 74 
	FCB  25,  25,  25,  65, 140, 160, 180, 200, 220, 230, 230, 230, 230, 230, 230, 230, 230 ; 78 
	FCB  25,  25,  25,  57, 132, 152, 172, 192, 212, 230, 230, 230, 230, 230, 230, 230, 230 ; 82 
	FCB  25,  25,  25,  49, 124, 144, 164, 184, 204, 224, 224, 224, 224, 224, 224, 224, 224 ; 86      
	FCB  25,  25,  25,  41, 116, 136, 156, 176, 196, 216, 216, 216, 216, 216, 216, 216, 216 ; 90 
	FCB  25,  25,  25,  33, 108, 128, 148, 168, 188, 208, 208, 208, 208, 208, 208, 208, 208 ; 94 
	FCB  25,  25,  25,  25, 100, 120, 140, 160, 180, 200, 200, 200, 200, 200, 200, 200, 200 ; 98 
	FCB  25,  25,  25,  25, 100, 120, 140, 160, 180, 200, 200, 200, 200, 200, 200, 200, 200 ;102 
	FCB  25,  25,  25,  25, 100, 120, 140, 160, 180, 200, 200, 200, 200, 200, 200, 200, 200 ;106 
	FCB  25,  25,  25,  25, 100, 120, 140, 160, 180, 200, 200, 200, 200, 200, 200, 200, 200 ;110
	FCB  25,  25,  25,  25, 100, 120, 140, 160, 180, 200, 200, 200, 200, 200, 200, 200, 200 ;114
;
;---------------------------------------------
; TEMP COMPENSATION %DC Vs. XMISH TEMP
;
;  Dissassemby of BDWM
;
;  TBL = %DC * 1.27+128 IF DC E.Q. or G.T. 0
;  TBL = %DC * 1.28+128 IF DC L.T. 0
;---------------------------------------------
;
				; %DC         	DEG c
;
L5FB4   FCB   96		; -25.0    	 	-40
	FCB   96		; -25.0    	 	-28
	FCB   96		; -25.0    	 	-16
	FCB   100		; -22.0    	 	- 4
	FCB   105		; -18.0    	 	  8
	FCB   110		; -14.0    	 	 20
	FCB   120		; - 6.0    	 	 32
	FCB   123		; - 4.0    	 	 44
	FCB   128		; 	0          	 56
	FCB   128		; 	0          	 68
	FCB   128		; 	0          	 80
	FCB   128		; 	0          	 92
	FCB   128		; 	0          	104
	FCB   128		; 	0          	116
	FCB   128		; 	0          	128
	FCB   128		; 	0          	140
	FCB   128		; 	0          	152
;
;**********************************************
;* FORCE MOTOR CALIB VALUES
;*
;**********************************************
;
L5FC5	FCB 0			; 0 SEC'S MIN TIME FOR ADPATIVE RATIO CHANGE
				; SEC'S * 40 
;                      
L5FC6   FCB 48			; 1.2 SEC'S MAX TIME FOR ADPATIVE 1 -> 2 SHIFT  
				; SEC'S * 40 
L5FC7   FCB 48			; 1.2 SEC'S MAX TIME FOR ADPATIVE 2 -> 3 SHIFT  
				; SEC'S * 40   
L5FC8   FCB 48			; 1.2 SEC'S MAX TIME FOR ADPATIVE 3 -> 4 SHIFT  
				; SEC'S * 40   
;
L5FC9   FCB 40			; 1.0 SEC'S  TIME CK FOR JUMP SHFT AFTER 1 -> 2
; 
L5FCA   FCB 40			; 1.0 SEC'S  TIME CK FOR JUMP SHFT AFTER 2 -> 3
;
L5FCB   FCB 80			; 2.0 SEC'S  TIME PERIOD FOR NEXT LINE  
L5FCC   FCB 20			; 20 PSI ADDED FOR 1 -> 3 SHIFT 
;
L5FCD   FCB 80			; 2.0 SEC'S  TIME  PERIOD FOR NEXT LINE   
L5FCE   FCB 20			; 20 PSI ADDED FOR 1 -> 4 SHIFT   
;
L5FCF	FCB 80			; 2.0 SEC'S  TIME  SUB'ED  PERIOD FOR NEXT LINE
L5FD0   FCB 10			; 10 PSI ADDED FOR 2 -> 4 SHIFT 
;  
;-------------------------------
; 6 LINE 16 BIT TABLE
;-------------------------------
;
L5FD1   FCB 65475		; 1 -> 2 SHIFT STARTING DERIVITIVE, (-61)       
L5FD3   FCB 65416		; 2 -> 3 SHIFT STARTING DERIVITIVE (-120) 
L5FD5   FCB 65400		; 3 -> 4 SHIFT STARTING DERIVITIVE (-136)  
;
L5FD7   FCB 65475		; 1 -> 2 SHIFT STOPING DERIVITIVE, (-61)         
L5FD9   FCB 65416		; 2 -> 3 SHIFT STOPING DERIVITIVE, (-120)  
L5FDB   FCB 65400		; 3 -> 4 SHIFT STOPING DERIVITIVE, (-136) 
;
;-------------------------------
; GARAGE SHIFT PARAM'S
;-------------------------------
;
L5FDD   FCB 8			; 0.2 SEC'S, DRIVE, GARAGE SHIFT LIMIT
L5FDE   FCB 0			; 0 PSI DRIVE, GARAGE SHIFT OFFSET  
;
L5FDF   FCB 10			; 0.2 SEC'S, REV, GARAGE SHIFT LIMIT
L5FE0   FCB 0			; 0 PSI REV, GARAGE SHIFT OFFSET   
;
L5FE1   FCB 16			; 8 MPH GRARAGE SHIFT SPEED LMT, (PK/NEUT) 
L5FE2   FCB 16			; 8 MPH GRARAGE SHIFT SPEED LMT, (DRV/REV)   
;
L5FE3   FCB 5			; 5 PSI DRIVE, GARAGE LO LMT, (PK/NEUT)   
L5FE4   FCB 5			; 5 PSI DRIVE, GARAGE LO LMT, (DRIVE)   
L5FE5   FCB 5			; 5 PSI GRARAGE SHFT PRESS LO LMT, (REV)
;
;--------------
; 3 LINE TBL
;--------------
;
L5FE6	FCB 80			; 2 SEC PERIOD FOR 2 -> 1 MODIFIER
        FCB 80			; 2 SEC PERIOD FOR 3 -> 2 MODIFIER  
        FCB 0			; 0 SEC PERIOD FOR 4 -> 3 MODIFIER  
;
L5FE9	FCB 0			; 0 PSI SUBED FOR A/C ON IN 1st GR 
L5FEA   FCB 3			; 3 PSI SUBED FOR A/C ON IN 2nd GR   
L5FEB   FCB 5			; 5 PSI SUBED FOR A/C ON IN 3rd GR   
L5FEC	FCB 5			; 5 PSI SUBED FOR A/C ON IN 4th GR 
;   
;*********************************
;*  ADAPTIVE LEARNING PARAMS
;*********************************
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Adaptive modifer cell limits to change cells
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Defines TPS range to change from one cell to another
;
L5FED   FCB 64			;25%, upper TPS limit for cell #1  
L5FEE	FCB 59			;23%, lower TPS limit for cell #1
;
L5FEF	FCB 102			;40%, upper TPS limit for cell #2
L5FF0	FCB 97			;38%, lower TPS limit for cell #2 
;
L5FF1	FCB 178			;69.8%, upper TPS limit for cell #3 
L5FF2	FCB 173			;68.0%, lower TPS limit for cell #3
;
;---------------------------------------------- 
; REVERSE THE 2 FOLLOWING TEMPERATURE VAL'S TO 
; ENABLE ADAPTIVE MODIFIERS
;----------------------------------------------
; 
L5FF3   FCB 133			; 60 DEG c COLD ADPTIVE TEMP THRESH
L5FF4   FCB 200			; 110 DEG c HOT ADPTIVE TEMP THRESH
;
;-----------------------
; 3 LINE TBL
; ADAPTIVE TPS LO LMTS
;-----------------------
;         
L5FF5   FCB 64			; 25%   TPS 1st GR
        FCB 255			; 99.9% TPS 2st GR 
        FCB 255			; 99.9% TPS 3st GR 
;
;------------------------
; 3 LINE TBL
; ADAPTIVE TPS HI LMTS
;------------------------  
;      
L5FF8   FCB 255			; 99.9% TPS 1st GR 
        FCB 0			; 0%    TPS 2st GR   
        FCB 0			; 0%    TPS 3st GR  
;      
L5FFB   FCB 13			; 5%  APAPT TPS CHANGE THRESH
  
L5FFC   FCB 236			; -5 PSI ADAPT MOD'ED LOWER LMT
L5FFD   FCB 40			; 10 PSI ADAPT MOD'ED UPPER LMT
  
L5FFE   FCB 80			; 2 SEC, COAST DOWM SHIFT TIME 
L5FFF   FDB 65526		; IF SLIP -1.3 RPM ENABLE ENG BRAKING
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Break points used for temp based press. comp. tables
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Used with tables L624B, 
; L627A, and L62A9
;
;	%TPS = val/.390		;Table offset		
;
L6001   FCB 0			; 0
L6002	FCB 38			;16
L6003   FCB 102			;32
L6004   FCB 178			;48
;
;----------------------------
; 3 LINE TABLE
;
; MINIMIM TIME BETWEEN SHIFTS
; FOR ADAPTIVE MOD
; TABL = SEC * 40
;-----------------------------
;
L6005   FCB 80			; 2 SEC'S, 1 -> 2 
        FCB 80			; 2 SEC'S, 2 -> 3   
        FCB 80			; 2 SEC'S, 3 -> 4 
;
;----------------------------
; 3 LINE TABLE
;
; DELAY AFTER RANGE CHANGE   
; FOR ADAPTIVE SHIFT
;
; TABL = SEC * 40
;----------------------------
;
L6008   FCB 240			; 6 6EC'S 1 -> 2
        FCB 240			; 6 6EC'S 2 -> 3 
        FCB 240			; 6 6EC'S 3 -> 4 
;
;----------------------------
; 3 LINE TABLE
;
; MAX SPD CHANGE FOR 
; ADAPTIVE SHIFT
;
; TBL = MPH * 2
;----------------------------
;
L600B   FCB 40			; 20 MPH 1 -> 2
        FCB 40			; 20 MPH 2 -> 3 
        FCB 0			;  0 MPH 3 -> 4 
;
;----------------------------
; 3 LINE TABLE
;
; LARGE SHIFT TIME ERROR
; & PRESSURE MODIFIER
; ADAPTIVE SHIFT
; TBL = 
;----------------------------
;
L600E	FCB 244			; -300 msec 1 -> 2 
        FCB 244			; -300 msec 2 -> 3
        FCB 244			; -300 msec 3 -> 4
;
L6010	FCB 8			; 2 PSI MOD 1 -> 2 
        FCB 8			; 2 PSI MOD 2 -> 3   
        FCB 8			; 2 PSI MOD 3 -> 4
;
;----------------------------
; 3 LINE TABLE
; 
; LARGE DELAY TIME ERROR
; FOR  ADAPTIVE SHIFT
; TBL =  SEC * 40
;----------------------------
;
L6014   FCB 32			; 800 Msec, 1 -> 2
        FCB 0			;   0 Msec, 2 -> 3   
        FCB 0			;   0 Msec, 3 -> 4   
;
;----------------------------
; 3 LINE UPSHIFT TABLE
; MIN TIME LMT
;----------------------------
;
L6017	FCB 20			; 500 msec      1 -> 2  
        FCB 20			; 500 msec      2 -> 3       
        FCB 255			; 6.38 SEC'S    3 -> 4
;
;-------------------------------
; 3 LINE TABLE
; LONG SHIFT DELAY PRESS MOD'ER 
;-------------------------------
;
L601A   FCB 12			; 3  PSI     
        FCB 16			; 4  PSI
        FCB 0			; 0  PSI
;
L601D   FCB 1			; 0000 0001, shift contingency 
				; b7
				; b6
				; b5
				; b4
				; b3
				; b2
				; b1
				; b0 1 = NO Long shift contingency enabled
;
L601E   FCB 90			; 90 PSI MAX FORCE MOTOR PRESSURE
;
;--------------------------
; 3 LINE TBL
; PRESSURE MODE TIME LMT'S
;--------------------------
;
L601F   FCB 48			; 1.2 SEC'S, 1 -> 2 
	FCB 48			; 1.2 SEC'S, 2 -> 3  
	FCB 48			; 1.2 SEC'S, 3 -> 4  
;
;**********************************************
;*  POWER ENRICH MODE 
;*
;**********************************************
;
;---------------------------------------------
; POWER ENRICH PRESS MOD TABLE
;
; LINE PRESSURE Vs. XMISH RPM
;
;  Dissassemby of BBWM
; 
;
; TBL = PSI - 128
;---------------------------------------------
;
				; PSI        ENG RPM
;
L6022   FCB 	128		; 0              0
	FCB 	128		; 0            512 
	FCB 	128		; 0           1024 
	FCB 	128		; 0           1536 
	FCB 	128		; 0           2048 
	FCB 	128		; 0           2560
	FCB 	128		; 0           3072 
	FCB 	128		; 0           3584 
	FCB 	128		; 0           4096 
	FCB 	128		; 0           4608 
	FCB 	128		; 0           5120
	FCB 	128		; 0           5632 
	FCB 	128		; 0           6144 
	FCB 	128		; 0           6656 
	FCB 	128		; 0           7168 
	FCB 	128		; 0           7680
	FCB 	128		; 0           8192 
;
;---------------------------------------------
; MAT TEMPERATURE PRESSURE OFFSET TBL
;
;  Dissassemby of BBWM
; 
; TBL = PSI -128
;---------------------------------------------
;
				; PSI        MAT, Deg c
;
L6033   FCB 	128		; 0           -4
	FCB     128		; 0            2
	FCB     128		; 0            8
	FCB     128		; 0           14
	FCB     128		; 0           20
	FCB     128		; 0           26
	FCB     128		; 0           32
	FCB     128		; 0           38
	FCB     128		; 0           44
	FCB     128		; 0           50
	FCB     128		; 0           56
	FCB     128		; 0           62
	FCB     128		; 0           68
	FCB     128		; 0           74
	FCB     128		; 0           80
	FCB     128		; 0           86
	FCB     128		; 0           92
;
;***********************
;* DESIRED SHIFT TIME 
;* ALTITUDE GAIN 
;***********************
;
;---------------------------------------------
; DESIRED SHIFT TIME ALTITUDE GAIN 
; 2nd GEAR
;
;  Dissassemby of BBWM
;
;
; TABLE = FACTOR * 1.28
;---------------------------------------------
;
				; FACTOR          %TPS
;
L6044   FCB  0			;   0.0            0.0
	FCB  0			;   0.0            6.3
	FCB  0			;   0.0           12.5
	FCB  0			;   0.0           18.8
	FCB  0			;   0.0           25.0
	FCB  0			;   0.0           31.3
	FCB  0			;   0.0           37.5
	FCB  0			;   0.0           43.8
	FCB  0			;   0.0           50.0
	FCB  0			;   0.0           56.3
	FCB  0			;   0.0           62.5
	FCB  0			;   0.0           68.8
	FCB  0			;   0.0           75.0
	FCB  0			;   0.0           81.3
	FCB  0			;   0.0           87.5
	FCB  0			;   0.0           93.8
	FCB  0			;   0.0          100.0
;
;----------------------------------------------
; DESIRED SHIFT TIME ALTITUDE GAIN 3rd GR
;
;
;  Dissassemby of BBWM
;
;
; TABLE = FACTOR * 1.28
;----------------------------------------------
;
				; FACTOR          %TPS
;
L6055   FCB  0			;   0.0            0.0
	FCB  0			;   0.0            6.3
	FCB  0			;   0.0           12.5
	FCB  0			;   0.0           18.8
	FCB  0			;   0.0           25.0
	FCB  0			;   0.0           31.3
	FCB  0			;   0.0           37.5
	FCB  0			;   0.0           43.8
	FCB  0			;   0.0           50.0
	FCB  0			;   0.0           56.3
	FCB  0			;   0.0           62.5
	FCB  0			;   0.0           68.8
	FCB  0			;   0.0           75.0
	FCB  0			;   0.0           81.3
	FCB  0			;   0.0           87.5
	FCB  0			;   0.0           93.8
	FCB  0			;   0.0          100.0
;
;---------------------------------------------
; DESIRED SHIFT TIME ALTITUDE GAIN 4th
;
;
;  Dissassemby of BDWM
;  10-27-1993, 11:58:44
;
; TABLE = FACTOR * 1.28
;---------------------------------------------
;
				;   FACTOR          %TPS
;
L6066   FCB  0			;   0.0            0.0
	FCB  0			;   0.0            6.3
	FCB  0			;   0.0           12.5
	FCB  0			;   0.0           18.8
	FCB  0			;   0.0           25.0
	FCB  0			;   0.0           31.3
	FCB  0			;   0.0           37.5
	FCB  0			;   0.0           43.8
	FCB  0			;   0.0           50.0
	FCB  0			;   0.0           56.3
	FCB  0			;   0.0           62.5
	FCB  0			;   0.0           68.8
	FCB  0			;   0.0           75.0
	FCB  0			;   0.0           81.3
	FCB  0			;   0.0           87.5
	FCB  0			;   0.0           93.8
	FCB  0			;   0.0          100.0
;
;**********************
;* PRESSURE ALTITUDE 
;* GAIN FACTOR 
;* (3 TABLES)
;**********************
;
;----------------------------------------------
; PRESSURE ALTITUDE GAIN FACTOR Vs. %TPS
; 2nd GEAR
;
;  Dissassemby of BBWM
; 
; (INDEXED ADDRESS TBL AT LBB80)
;
; TABLE = FACTOR * 1.28
;----------------------------------------------
;
				; FACTOR          %TPS
;
L6077   FCB 0			;   0.0            0.0
	FCB 0			;   0.0            6.3
	FCB 0			;   0.0           12.5
	FCB 0			;   0.0           18.8
	FCB 0			;   0.0           25.0
	FCB 0			;   0.0           31.3
	FCB 0			;   0.0           37.5
	FCB 0			;   0.0           43.8
	FCB 0			;   0.0           50.0
	FCB 0			;   0.0           56.3
	FCB 0			;   0.0           62.5
	FCB 0			;   0.0           68.8
	FCB 0			;   0.0           75.0
	FCB 0			;   0.0           81.3
	FCB 0			;   0.0           87.5
	FCB 0			;   0.0           93.8
	FCB 0			;   0.0          100.0
;
;---------------------------------------------
; PRESSURE ALTITUDE GAIN FACTOR Vs. %TPS
; 3rd GEAR
;
;  Dissassemby of BBWM
;  (INDEXED ADDRESS TBL AT LBB80)
;
; TABLE = FACTOR * 1.28
;---------------------------------------------
;
				; FACTOR          %TPS
;
L6088   FCB  0			;   0.0            0.0
	FCB  0			;   0.0            6.3
	FCB  0			;   0.0           12.5
	FCB  0			;   0.0           18.8
	FCB  0			;   0.0           25.0
	FCB  0			;   0.0           31.3
	FCB  0			;   0.0           37.5
	FCB  0			;   0.0           43.8
	FCB  0			;   0.0           50.0
	FCB  0			;   0.0           56.3
	FCB  0			;   0.0           62.5
	FCB  0			;   0.0           68.8
	FCB  0			;   0.0           75.0
	FCB  0			;   0.0           81.3
	FCB  0			;   0.0           87.5
	FCB  0			;   0.0           93.8
	FCB  0			;   0.0          100.0
;
;----------------------------------------------
; PRESSURE ALTITUDE GAIN FACTOR Vs. %TPS
; 4th GEAR
;
;  Dissassemby of BDWM
;   (INDEXED ADDRESS TBL AT LBB80)
;
; TABLE = FACTOR * 1.28
;----------------------------------------------
;
				; FACTOR          %TPS
;
L6099   FCB  	0		;   0.0            0.0
	FCB  	0		;   0.0            6.3
	FCB  	0		;   0.0           12.5
	FCB  	0		;   0.0           18.8
	FCB  	0		;   0.0           25.0
	FCB  	0		;   0.0           31.3
	FCB  	0		;   0.0           37.5
	FCB  	0		;   0.0           43.8
	FCB  	0		;   0.0           50.0
	FCB  	0		;   0.0           56.3
	FCB  	0		;   0.0           62.5
	FCB  	0		;   0.0           68.8
	FCB  	0		;   0.0           75.0
	FCB  	0		;   0.0           81.3
	FCB  	0		;   0.0           87.5
	FCB  	0		;   0.0           93.8
	FCB  	0		;   0.0          100.0
;
;***********************
;* ENGINE BRAKING 
;***********************
;
;----------------------------------------------
; ENGINE BRAKING LINE PRESSURE Vs. MPH
; 1st GEAR 
;
;  Dissassemby of BBWM
; 
; TBL = PSI
;----------------------------------------------
;
				; PSI             MPH
;
L60AA   FCB 	40		;  40.0            0
	FCB 	40		;  40.0            8
	FCB 	40		;  40.0           16
	FCB 	40		;  40.0           24
	FCB 	40		;  40.0           32
	FCB 	40		;  40.0           40
	FCB 	40		;  40.0           48
	FCB 	90		;  90.0           56
	FCB 	90		;  90.0           64
	FCB 	90		;  90.0           72
	FCB 	90		;  90.0           80
	FCB 	90		;  90.0           88
	FCB 	90		;  90.0           96
	FCB 	90		;  90.0          104
	FCB 	90		;  90.0          112
	FCB 	90		;  90.0          120
	FCB 	90		;  90.0          128
;
;----------------------------------------------
; ENGINE BRAKING LINE PRESSURE Vs. MPH
; 2nd GEAR 
;
;  Dissassemby of BBWM
;
; TBL = PSI
;----------------------------------------------
;
				;PSI             MPH
;
L60BB   FCB    40		;  40.0            0
	FCB    40		;  40.0            8
	FCB    40		;  40.0           16
	FCB    40		;  40.0           24
	FCB    40		;  40.0           32
	FCB    40		;  40.0           40
	FCB    50		;  50.0           48
	FCB    60		;  60.0           56
	FCB    80		;  80.0           64
	FCB    90		;  90.0           72
	FCB    90		;  90.0           80
	FCB    90		;  90.0           88
	FCB    90		;  90.0           96
	FCB    90		;  90.0          104
	FCB    90		;  90.0          112
	FCB    90		;  90.0          120
	FCB    90		;  90.0          128
;
;----------------------------------------------
; ENGINE BRAKING LINE PRESSURE Vs. MPH
;  3rd GEAR 
;
;  Dissassemby of BBWM
;
; TBL = PSI
;----------------------------------------------;
				; PSI             MPH
;
L60CC   FCB    0		;   0.0            0
	FCB    0		;   0.0            8
	FCB    0		;   0.0           16
	FCB    0		;   0.0           24
	FCB    0		;   0.0           32
	FCB    0		;   0.0           40
	FCB    0		;   0.0           48
	FCB    0		;   0.0           56
	FCB    0		;   0.0           64
	FCB    0		;   0.0           72
	FCB    0		;   0.0           80
	FCB    0		;   0.0           88
	FCB    0		;   0.0           96
	FCB    0		;   0.0          104
	FCB    0		;   0.0          112
	FCB    0		;   0.0          120
	FCB    0		;   0.0          128
;
;----------------------------------------------
; GARAGE SHIFT LINE PRESSURE, Vs. COOL Vs. RPM 
; IN DRIVE 
;
; Dissassemby of BBWM
; 17 x 8 TBL
;
; TBL = PSI
;----------------------------------------------
;
L60DD   FCB   0			; Min -40 deg C Val, (deg c+40)
        FCB   0			; Min 0 RPM Value (RPM/8)
        FCB   17		; COL'S/ROW
;
;   TOS RPM:   0  128  256  512  384  640  768  896 1024 1152 1280 1408 1536 1664 1792 1920 2048 :Deg C    
;
	FCB   25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25 ;-40
	FCB   20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 ;-20
	FCB   10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10 ;  0
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 20
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 40
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 60
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 80
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ;100
;
;----------------------------------------------
; GARAGE LINE PRESSURE IN REVERSE Vs. COOL Vs. RPM
;
;  Dissassemby of BBWM
; 17 x 8 TBL
; 
; TBL = PSI
;----------------------------------------------
;
L6168   FCB   0   	; Min -40 c
        FCB   0   	; Min 0 RPM 
        FCB   17  	; COL'S/ROW
;
;   TOS RPM:   0  128  256  512  384  640  768  896 1024 1152 1280 1408 1536 1664 1792 1920 2048 :Deg C    
;
	FCB   25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25 ;-40
	FCB   25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25,  25 ;-20
	FCB    5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5 ;  0
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 20
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 40
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 60
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ; 80
	FCB    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ;100
;
;
;----------------------------------------------
; GARAGE ROLLING SHIFT LINE PRESSURE Vs. %TPS Vs. MPH
;  Dissassemby of BDWM
;
; TBL = PSI 
;----------------------------------------------
;			
L61F3   FCB   0			; Min %TPS Val
        FCB   0			; Min 0 MPH Value
        FCB   5			; COL'S/ROW
;
;       MPH:  0    4   8    12   19 ;%TPS
;
	FCB 128, 128, 138, 148, 148 ;  0.00
	FCB 128, 133, 138, 138, 138 ;  6.25 
	FCB 128, 138, 138, 138, 138 ; 12.50
	FCB 128, 160, 160, 160, 160 ; 18.27 
	FCB 160, 160, 160, 160, 160 ; 25.00 
	FCB 255, 255, 255, 255, 255 ; 31.25 
	FCB 255, 255, 255, 255, 255 ; 37.50
	FCB 255, 255, 255, 255, 255 ; 43.75
	FCB 255, 255, 255, 255, 255 ; 50.00
	FCB 255, 255, 255, 255, 255 ; 56.25
	FCB 255, 255, 255, 255, 255 ; 62.50
	FCB 255, 255, 255, 255, 255 ; 68.75
	FCB 255, 255, 255, 255, 255 ; 75.00
	FCB 255, 255, 255, 255, 255 ; 81.25
	FCB 255, 255, 255, 255, 255 ; 87.50
	FCB 255, 255, 255, 255, 255 ; 93.75
	FCB 255, 255, 255, 255, 255 ;100.00 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Trans temp based line pressure correction, 2nd gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Line press corr = val - 128
;
L624B   FCB   0     	;0 %TPS, min %TPS
        FCB   0     	;-40 deg C, min trans temp 
        FCB   11    	;# cols.
;
;    Deg C: -40, -20,   0,  20,  40,  60,  80, 100, 120, 140, 160 ;%TPS
;
				;
	FCB 133, 128, 122, 122, 123, 123, 123, 128, 128, 131, 134 ; 0
	FCB 138, 133, 122, 123, 123, 123, 123, 128, 128, 131, 134 ;38
	FCB 138, 133, 122, 122, 122, 122, 123, 128, 128, 134, 140 ;40 
	FCB 138, 133, 123, 123, 123, 123, 123, 128, 128, 134, 140 ;70   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Trans temp based line pressure correction, 3rd gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Line press corr = val - 128
;
L627A   FCB   0     	;0 %TPS, min %TPS
        FCB   0     	;-40 deg C, min trans temp 
        FCB   11    	;# cols.
;
;    Deg C: -40, -20,   0,  20,  40,  60,  80, 100, 120, 140, 160 ;%TPS
;
	FCB 153, 148, 148, 143, 123, 123, 123, 128, 132, 131, 134 ; 0
	FCB 153, 148, 148, 143, 123, 118, 123, 128, 132, 131, 134 ;38
	FCB 153, 148, 148, 143, 123, 118, 123, 128, 134, 134, 140 ;40         
	FCB 153, 148, 148, 143, 123, 118, 123, 128, 134, 134, 140 ;70
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Trans temp based line pressure correction, 4th gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Line press corr = val - 128
;
L62A9   FCB   0     	;0 %TPS, min %TPS
        FCB   0     	;-40 deg C, min trans temp 
        FCB   11    	;# cols.
;
;    Deg C: -40, -20,   0,  20,  40,  60,  80, 100, 120, 140, 160 ;%TPS
;
	FCB 133, 128, 128, 128, 128, 128, 128, 128, 128, 131, 134 ; 0
	FCB 138, 133, 128, 128, 128, 128, 128, 128, 128, 131, 134 ;38
	FCB 138, 133, 133, 128, 128, 128, 128, 128, 128, 131, 134 ;40
	FCB 138, 133, 133, 128, 128, 128, 128, 128, 128, 131, 134 ;70
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Load based line pressure, 0-64 MPH
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; psi=val.
;						
L62D8   FCB   0		;0%, min TPS
        FCB   0		;0 mph, min mph x 4
        FCB   17	;# cols.
;
;	MPH:  0    4    8   12   16   20   24   28   32   36   40   44   48   52   56   60   64 ; %TPS	
;
	FCB   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0	;  0.00  
	FCB  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12 ;  6.25     
	FCB  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 ; 12.50     
	FCB  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27 ; 18.75     
	FCB  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32 ; 25.00
	FCB  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37 ; 31.25
	FCB  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42 ; 37.50 
	FCB  90,  90,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46 ; 43.75  
	FCB  90,  90,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49 ; 50.00
	FCB  90,  90,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52 ; 56.25
	FCB  90,  90,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54 ; 62.50 
	FCB  90,  90,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56 ; 68.75  
	FCB  90,  90,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58 ; 70.00
 	FCB  90,  90,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 81.25  
	FCB  90,  90,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 87.50
	FCB  90,  90,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 93.75  
	FCB  90,  90,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ;100.00
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Load based line pressure, 64 MPH +
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; psi=val.
;
L63FC	FCB   0		;0%, min %tps
        FCB   0		;64 mph, min (mph - 64) x 4
        FCB   17	;# cols
;
;	MPH:  64  68   72   76   80   84   88   92   96  100  104  108  112  116  120  124  128 ; %TPS
;
	FCB   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0	;  0.00
	FCB  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12,  12 ;  6.25 
	FCB  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 ; 12.50  
	FCB  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27 ; 18.75 
	FCB  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32 ; 25.00
	FCB  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37,  37 ; 31.25
	FCB  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42 ; 37.50 
	FCB  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46 ; 43.75	
	FCB  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49,  49 ; 50.00  
	FCB  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52 ; 56.25
	FCB  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54 ; 62.50
	FCB  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56,  56 ; 68.75 
	FCB  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58,  58 ; 75.00  
	FCB  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 81.25
	FCB  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 87.25
	FCB  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ; 93.75
	FCB  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59 ;100.00 
;
;***********************************************
;* PRESSURE OFFSET NORMAL MODE
;*
;***********************************************
;
;----------------------------------------------
; PRESSURE OFFSET, NORMAL MODE Vs. %TPS
; 2nd GR
; NORMAL MODE
;
;
;  Dissassemby of BDWM LINES =  17 
;  03-04-1994, 09:33:09
;
;  TBL =  PSI + 128
;----------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-2nd gear load based pressure offset
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	line pressure = val - 128	;%TPS
;
L6520   FCB  128			;  0.0
	FCB  120    			;  6.3
	FCB  116    			; 12.5
	FCB  113    			; 18.8
	FCB  113    			; 25.0
	FCB  112    			; 31.3
	FCB  112    			; 37.5
	FCB  113   			; 43.8
	FCB  115    			; 50.0
	FCB  118    			; 56.3
	FCB  119    			; 62.5
	FCB  119    			; 68.8
	FCB  119    			; 75.0
	FCB  119    			; 81.3
	FCB  119    			; 87.5
	FCB  119    			; 93.8
	FCB  119    			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-3rd gear load based pressure offset
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	line pressure = val - 128	;%TPS
;
L6531   FCB  128    			;  0.0
	FCB  123    			;  6.3
	FCB  119    			; 12.5
	FCB  118    			; 18.8
	FCB  117    			; 25.0
	FCB  117    			; 31.3
	FCB  117    			; 37.5
	FCB  121    			; 43.8
	FCB  124    			; 50.0
	FCB  129    			; 56.3
	FCB  129    			; 62.5
	FCB  129    			; 68.8
	FCB  129    			; 75.0
	FCB  129    			; 81.3
	FCB  129    			; 87.5
	FCB  129    			; 93.8
	FCB  129    			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-4th gear load based pressure offset
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	line pressure = val - 128	;%TPS
;
L6542   FCB  128			;  0.0
	FCB  128			;  6.3
	FCB  128			; 12.5
	FCB  128			; 18.8
	FCB  128			; 25.0
	FCB  128			; 31.3
	FCB  128			; 37.5
	FCB  128			; 43.8
	FCB  128			; 50.0
	FCB  128			; 56.3
	FCB  128			; 62.5
	FCB  128			; 68.8
	FCB  128			; 75.0
	FCB  128			; 81.3
	FCB  128			; 87.5
	FCB  128			; 93.8
	FCB  128			;100.0
;
;**********************************************
;* PRESSURE MOD
;* NORMAL RANGE
;* (3 TABLES)
;**********************************************
;
;---------------------------------------------
; 2 -> 1 PRESSURE MOD, NORMAL RANGE
; LINE PRESSURE Vs. Vss
;
;  Dissassemby of BBWM
;  (INDEXED ADDR TABLE AT LBB66)
;
;  TBL =  1  * (PSI MOD + 128 
;---------------------------------------------
;
L6553   FCB 0			; 0 MPH, Vss MIN
L6554   FCB 128			; 64 MPH Vss RANGE
L6555   FCB 32			; 4 MPH Vss INCR, (128/MPH)
;
				;  PSI MOD         MPH
;
L6556   FCB  128		;   0.0           30
	FCB  128		;   0.0           34
	FCB  128		;   0.0           38
	FCB  128		;   0.0           42
	FCB  128		;   0.0           46
	FCB  128		;   0.0           50
	FCB  128		;   0.0           54
	FCB  128		;   0.0           58
	FCB  128		;   0.0           62
	FCB  128		;   0.0           66
	FCB  128		;   0.0           70
	FCB  128		;   0.0           74
	FCB  128		;   0.0           78
	FCB  128		;   0.0           82
	FCB  128		;   0.0           86
	FCB  128		;   0.0           90
	FCB  128		;   0.0           94
;
;---------------------------------------------
; PRESSURE MOD, NORMAL RANGE,  
; LINE PRESSURE Vs. Vss
; 3 -> 2 SHIFT
;
;  Dissassemby of BDWM
;  (INDEXED ADDR TABLE AT LBB66)
;
; TABLE = PSI+ 128
;---------------------------------------------
;
L6567   FCB 28			; 14 MPH, Vss MIN
L6568   FCB 128			; 64 MPH Vss RANGE
L6569   FCB 32			; 4 MPH Vss INCR, (128/MPH)
;
				;    PSI Mod         MPH
;
L656A   FCB  137		;       9.0           14.0
	FCB  137		;       9.0           18.0
	FCB  135		;       7.0           22.0
	FCB  123		;      -5.0           26.0
	FCB  112		;     -16.0           30.0
	FCB  106		;     -22.0           34.0
	FCB  106		;     -22.0           38.0
	FCB  106		;     -22.0           42.0
	FCB  106		;     -22.0           46.0
	FCB  106		;     -22.0           50.0
	FCB  106		;     -22.0           54.0
	FCB  106		;     -22.0           58.0
	FCB  106		;     -22.0           62.0
	FCB  128		;       0.0           66.0
	FCB  128		;       0.0           70.0
	FCB  128		;       0.0           74.0
	FCB  128		;       0.0           78.0
;
;---------------------------------------------
; PRESSURE MOD, NORMAL RANGE,  
; LINE PRESSURE Vs. Vss
; 4 -> 3 SHIFT
;
;  Dissassemby of BDWM
;  (INDEXED ADDR TABLE AT LBB66)
;
; TABLE = PSI +128
;---------------------------------------------
;
L657B   FCB 60			; 30 MPH, Vss MIN
L657C   FCB 128			; 64 MPH Vss RANGE
L657D   FCB 32			; 4 MPH Vss INCR, (128/MPH)
;
    				;   PSI           MPH
;
L657E   FCB 128			;   0.0           30
	FCB 128			;   0.0           34
	FCB 128 		;   0.0           38
	FCB 128			;   0.0           42
	FCB 128			;   0.0           46
	FCB 128			;   0.0           50
	FCB 128			;   0.0           54
	FCB 128			;   0.0           58
	FCB 128			;   0.0           62
	FCB 128			;   0.0           66
	FCB 128			;   0.0           70
	FCB 128			;   0.0           74
	FCB 128			;   0.0           78
	FCB 128			;   0.0           82
	FCB 128			;   0.0           86
	FCB 128			;   0.0           90
	FCB 128			;   0.0           94
;
;********************
;* DESIRED SHIFT
;* TIME
;********************
;
;---------------------------------------------
;  DESIRED SHIFT TIME
;  1 -> 2 SHFT
;
; 10-07-1997  Dissassemby of BDWM  Lines= 17 
;
;  TBL =  .04  * msec
;---------------------------------------------
;
				;      msec            %TPS
;
L658F   FCB  34			;       850            0.0
	FCB  34			;       850            6.3
	FCB  29			;       725           12.5
	FCB  30			;       750           18.8
	FCB  33			;       825           25.0
	FCB  35			;       875           31.3
	FCB  35			;       875           37.5
	FCB  33			;       825           43.8
	FCB  33			;       825           50.0
	FCB  35			;       875           56.3
	FCB  35			;       875           62.5
	FCB  34			;       850           68.8
	FCB  35			;       875           75.0
	FCB  35			;       875           81.3
	FCB  36			;       900           87.5
	FCB  37			;       925           93.8
	FCB  37			;       925          100.0
;
;---------------------------------------------
; DESIRED SHIFT TIME
; 2 -> 3 SHFT
;
; 10-07-1997  Dissassemby of BDWM  Lines= 17 
;
;  TBL =  .04  * msec
;---------------------------------------------
;
				;      msec           %TPS
;
L65A0   FCB  32			;       800            0.0
	FCB  32			;       800            6.3
	FCB  32			;       800           12.5
	FCB  34			;       850           18.8
	FCB  34			;       850           25.0
	FCB  34			;       850           31.3
	FCB  34			;       850           37.5
	FCB  34			;       850           43.8
	FCB  34			;       850           50.0
	FCB  38			;       950           56.3
	FCB  38			;       950           62.5
	FCB  38			;       950           68.8
	FCB  38			;       950           75.0
	FCB  40			;      1000           81.3
	FCB  40			;      1000           87.5
	FCB  40			;      1000           93.8
	FCB  40			;      1000          100.0
;
;-------------------------------------------------
; DESIRED SHIFT TIME
; 3 -> 4 SHFT   
;
; 10-07-1997  Dissassemby of BDWM  Lines= 17 
;
;  TBL =  .04  * msec
;-------------------------------------------------
;
				;    msec            %TPS
;
L65B1   FCB  32     ;       800            0.0
	FCB  32     ;       800            6.3
	FCB  32     ;       800           12.5
	FCB  32     ;       800           18.8
	FCB  32     ;       800           25.0
	FCB  32     ;       800           31.3
	FCB  32     ;       800           37.5
	FCB  32     ;       800           43.8
	FCB  32     ;       800           50.0
	FCB  32     ;       800           56.3
	FCB  32     ;       800           62.5
	FCB  32     ;       800           68.8
	FCB  32     ;       800           75.0
	FCB  32     ;       800           81.3
	FCB  32     ;       800           87.5
	FCB  32     ;       800           93.8
	FCB  32     ;       800          100.0
;
;********************
;* ADAPTIVE MODIFIER
;* CALIBRATIONS
;********************
;
;---------------------------------------------
; ADAPTIVE PRESSURE MODIFIER
; LINE PRESSURE Vs. SHIFT TIME ERROR
; 1 -> 2 SHIFT
;
;  Dissassemby of BDWM
;
;   TBL = PSI * 4, -200 Msec to +200 Msec/25 MS
;---------------------------------------------
;
				;  PSI        SEC'S SHIFT ERROR
;
L65C2   FCB 8			;   2.0         -200
	FCB 6			;   1.5         -175
	FCB 5			;   1.3         -150
	FCB 4			;   1.0         -125
	FCB 3			;   0.8         -100
	FCB 2			;   0.5          -75
	FCB 1			;   0.3          -50
	FCB 0			;   0.0          -25
	FCB 0			;   0.0            0
	FCB 0			;   0.0           25
	FCB 255			;  63.8           50
	FCB 254			;  63.5           75
	FCB 253			;  63.3          100
	FCB 252			;  63.0          125
	FCB 251			;  62.8          150
	FCB 250			;  62.5          175
	FCB 248			;  62.0          200
;
;---------------------------------------------
; ADAPTIVE PRESSURE MODIFIER
; LINE PRESSURE Vs. SHIFT TIME ERROR
; 2 -> 3 SHIFT
;
;  Dissassemby of BDWM
;
; TBL= PSI * 4
;---------------------------------------------
;
				;  PSI        SEC'S SHIFT ERROR
;
L65D3   FCB  8			;   2.0         -200
	FCB  6			;   1.5         -175
	FCB  5			;   1.3         -150
	FCB  4			;   1.0         -125
	FCB  3			;   0.8         -100
	FCB  2			;   0.5          -75
	FCB  1			;   0.3          -50
	FCB  0			;   0.0          -25
	FCB  0			;   0.0            0
	FCB  0			;   0.0           25
	FCB  255		;  63.8           50
	FCB  254		;  63.5           75
	FCB  253		;  63.3          100
	FCB  252		;  63.0          125
	FCB  251		;  62.8          150
	FCB  250		;  62.5          175
	FCB  248		;  62.0          200
;
;---------------------------------------------
; ADAPTIVE PRESSURE MODIFIER
; LINE PRESSURE Vs. SHIFT TIME ERROR
; 3 -> 4 SHIFT
;
;  Dissassemby of BDWM
;
; TBL= PSI * 4
;---------------------------------------------
;
				; PSI         sec ERROR TIME
;
L65D3   FCB  8			;   2.0         -200
	FCB  6			;   1.5         -175
	FCB  5			;   1.3         -150
	FCB  4			;   1.0         -125
	FCB  3			;   0.8         -100
	FCB  2			;   0.5          -75
	FCB  1			;   0.3          -50
	FCB  0			;   0.0          -25
	FCB  0			;   0.0            0
	FCB  0			;   0.0           25
	FCB  255		;  63.8           50
	FCB  254		;  63.5           75
	FCB  253		;  63.3          100
	FCB  252		;  63.0          125
	FCB  251		;  62.8          150
	FCB  250		;  62.5          175
	FCB  248		;  62.0          200
;
;---------------------------------------------
; ADAPTIVE PRESSURE MODIFIER
;
;  Dissassemby of BDWM
;
; TBL= PSI * 4
;---------------------------------------------
;
				;  PSI         sec ERROR TIME
;
L65E4   FCB  8      ;   2.0 		  -200
	FCB  6      ;   1.5 		  -175
	FCB  5      ;   1.3 		  -150
	FCB  4      ;   1.0 		  -125
	FCB  3      ;   0.8 		  -100
	FCB  2      ;   0.5 		   -75
	FCB  1      ;   0.3 		   -50
	FCB  0      ;   0.0 		   -25
	FCB  0      ;   0.0 		     0
	FCB  0      ;   0.0 		    25
	FCB  255    ;  63.8 		    50
	FCB  254    ;  63.5 		    75
	FCB  253    ;  63.3 		   100
	FCB  252    ;  63.0 		   125
	FCB  251    ;  62.8 		   150
	FCB  250    ;  62.5 		   175
	FCB  248    ;  62.0 		   200
;
;**********************************************
;* PRESURE OFFSETS, 2nd, 3rd & 4TH GEAR
;* TYPE $0D ECM
;*
;* LK UP ROUTINE AT  $
;**********************************************
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-2nd gear pressure offset vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	PSI = val - 128			;%TPS
;
L65F5   FCB  128    			;  0.0
	FCB  128    			;  6.3
	FCB  128    			; 12.5
	FCB  128    			; 18.8
	FCB  128    			; 25.0
	FCB  128    			; 31.3
	FCB  128    			; 37.5
	FCB  128    			; 43.8
	FCB  128    			; 50.0
	FCB  128    			; 56.3
	FCB  128    			; 62.5
	FCB  128    			; 68.8
	FCB  128    			; 75.0
	FCB  128    			; 81.3
	FCB  128    			; 87.5
	FCB  128    			; 93.8
	FCB  128    			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-3rd gear pressure offset vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	PSI = val - 128			;%TPS
;
L6606   FCB  128    			;  0.0
	FCB  128    			;  6.3
	FCB  128    			; 12.5
	FCB  128    			; 18.8
	FCB  128    			; 25.0
	FCB  128    			; 31.3
	FCB  128    			; 37.5
	FCB  128    			; 43.8
	FCB  128    			; 50.0
	FCB  128    			; 56.3
	FCB  128    			; 62.5
	FCB  128    			; 68.8
	FCB  128    			; 75.0
	FCB  128    			; 81.3
	FCB  128    			; 87.5
	FCB  128    			; 93.8
	FCB  128    			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-4th gear pressure offset vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	PSI = val - 128			;%TPS
;   				
L6617   FCB  128    			;  0.0
	FCB  128    			;  6.3
	FCB  128    			; 12.5
	FCB  128    			; 18.8
	FCB  128    			; 25.0
	FCB  128    			; 31.3
	FCB  128    			; 37.5
	FCB  128    			; 43.8
	FCB  128    			; 50.0
	FCB  128    			; 56.3
	FCB  128    			; 62.5
	FCB  128    			; 68.8
	FCB  128    			; 75.0
	FCB  128    			; 81.3
	FCB  128    			; 87.5
	FCB  128    			; 93.8
	FCB  128    			;100.0
;
;**********************************************
;* PRESURE RAMP DELAY
;* (TO QUAL, SEE TIME CALIB AT L5D1F)
;*
;* 1 -> 2  SHIFT
;* 2 -> 3  SHIFT
;* 3 -> 4  SHIFT
;*
;* LK UP AT $
;*********************************************
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-1->2 pressure ramp delay time vs %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L6628	FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  18			; 37.5
	FCB  18			; 43.8
	FCB  18			; 50.0
	FCB  18			; 56.3
	FCB  18			; 62.5
	FCB  18			; 68.8
	FCB  18			; 75.0
	FCB  18			; 81.3
	FCB  18			; 87.5
	FCB  18			; 93.8
	FCB  18			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-2->3 pressure ramp delay time vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L6639   FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  0			; 37.5
	FCB  0			; 43.8
	FCB  0			; 50.0
	FCB  0			; 56.3
	FCB  0			; 62.5
	FCB  0			; 68.8
	FCB  0			; 75.0
	FCB  0			; 81.3
	FCB  0			; 87.5
	FCB  0			; 93.8
	FCB  0			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-3->4 pressure ramp delay time vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L664A   FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  0			; 37.5
	FCB  0			; 43.8
	FCB  0			; 50.0
	FCB  0			; 56.3
	FCB  0			; 62.5
	FCB  0			; 68.8
	FCB  0			; 75.0
	FCB  0			; 81.3
	FCB  0			; 87.5
	FCB  0			; 93.8
	FCB  0			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-1->2 pressure ramp extention time vs %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L665B   FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  0			; 37.5
	FCB  0			; 43.8
	FCB  0			; 50.0
	FCB  0			; 56.3
	FCB  0			; 62.5
	FCB  0			; 68.8
	FCB  0			; 75.0
	FCB  0			; 81.3
	FCB  0			; 87.5
	FCB  0			; 93.8
	FCB  0			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-2->3 pressure ramp extention time vs %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L666C   FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  0			; 37.5
	FCB  0			; 43.8
	FCB  0			; 50.0
	FCB  0			; 56.3
	FCB  0			; 62.5
	FCB  0			; 68.8
	FCB  0			; 75.0
	FCB  0			; 81.3
	FCB  0			; 87.5
	FCB  0			; 93.8
	FCB  0			;100.0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-3->4 pressure ramp extention time vs %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Sec = val/40			;%TPS
;
L667D   FCB  0			;  0.0
	FCB  0			;  6.3
	FCB  0			; 12.5
	FCB  0			; 18.8
	FCB  0			; 25.0
	FCB  0			; 31.3
	FCB  0			; 37.5
	FCB  0			; 43.8
	FCB  0			; 50.0
	FCB  0			; 56.3
	FCB  0			; 62.5
	FCB  0			; 68.8
	FCB  0			; 75.0
	FCB  0			; 81.3
	FCB  0			; 87.5
	FCB  0			; 93.8
	FCB  0			;100.0
;
;----------------------------------------------
; 1 -> 2 PRESSURE DIFF vs %TPS
;
;  Dissassemby of BDWM
;  11-23-1993, 10:54:40
;
; TBL = (PSI/SEC) * 64 / (1.6 + 128)
;----------------------------------------------
;
				; PSI/SEC           %TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;- 1->2 pressure diff. vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;
L668E   FCB  128    			;  0.0
	FCB  128    			;  6.3
	FCB  128    			; 12.5
	FCB  128    			; 18.8
	FCB  128    			; 25.0
	FCB  128    			; 31.3
	FCB  128    			; 37.5
	FCB  128    			; 43.8
	FCB  128    			; 50.0
	FCB  128    			; 56.3
	FCB  128    			; 62.5
	FCB  128    			; 68.8
	FCB  128    			; 75.0
	FCB  128    			; 81.3
	FCB  128    			; 87.5
	FCB  128    			; 93.8
	FCB  128    			;100.0
;
;----------------------------------------------
; 2 -> 3 PRESSURE DIFF vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = (PSI/SEC) * 64 / (1.6 + 128)
;----------------------------------------------
;
					; PSI/SEC        %TPS
;
L669F   FCB  128			;   0.0            0.0   
	FCB  128			;   0.0            6.3
	FCB  128			;   0.0           12.5
	FCB  128			;   0.0           18.8
	FCB  128			;   0.0           25.0
	FCB  128			;   0.0           31.3
	FCB  128			;   0.0           37.5
	FCB  128			;   0.0           43.8
	FCB  128			;   0.0           50.0
	FCB  128			;   0.0           56.3
	FCB  128			;   0.0           62.5
	FCB  128			;   0.0           68.8
	FCB  128			;   0.0           75.0
	FCB  128			;   0.0           81.3
	FCB  128			;   0.0           87.5
	FCB  128			;   0.0           93.8
	FCB  128			;   0.0          100.0
;
;----------------------------------------------
; 3 -> 4 PRESSURE DIFF vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = (PSI/SEC) * 64 / (1.6 + 128)
;----------------------------------------------
;
				; PSI/SEC          %TPS
;
L66B0   FCB  128			;   0.0            0.0
	FCB  128			;   0.0            6.3
	FCB  128			;   0.0           12.5
	FCB  128			;   0.0           18.8
	FCB  128			;   0.0           25.0
	FCB  128			;   0.0           31.3
	FCB  128			;   0.0           37.5
	FCB  128			;   0.0           43.8
	FCB  128			;   0.0           50.0
	FCB  128			;   0.0           56.3
	FCB  128			;   0.0           62.5
	FCB  128			;   0.0           68.8
	FCB  128			;   0.0           75.0
	FCB  128			;   0.0           81.3
	FCB  128			;   0.0           87.5
	FCB  128			;   0.0           93.8
	FCB  128			;   0.0          100.0
;
;--------------------------------------------------
; 1 -> 2 RAMP 2 PRESSURE DIFF vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = (PSI/SEC) * 64/ (K + 128)
;--------------------------------------------------
;
					; PSI/SEC          %TPS
;
L66C1   FCB  128			;   0.0            0.0
	FCB  128			;   0.0            6.3
	FCB  128			;   0.0           12.5
	FCB  128			;   0.0           18.8
	FCB  128			;   0.0           25.0
	FCB  128			;   0.0           31.3
	FCB  128			;	0.0		37.5
	FCB  128			;	0.0			  43.8
	FCB  100			;				  50.0
	FCB  100			;				  56.3
	FCB  90				;				  62.5
	FCB  90				;				  68.8
	FCB  90				;				  75.0
	FCB  85				;				  81.3
	FCB  85				;				  87.5
	FCB  85				;				  93.8
	FCB  85				;				 100.0
;
;--------------------------------------------------
; 2 -> 3 RAMP 2 PRESSURE DIFF
;
;  Dissassemby of BDWM
;  11-23-1993, 11:28:14
;
; TBL = (PSI/SEC) * 64/ (K + 128)
;--------------------------------------------------
;
					; PSI/SEC           %TPS
;
L66D2   FCB  128			;   0.0            0.0
	FCB  128			;   0.0            6.3
	FCB  128			;   0.0           12.5
	FCB  128			;   0.0           18.8
	FCB  128			;   0.0           25.0
	FCB  128			;   0.0           31.3
	FCB  128			;   0.0           37.5
	FCB  128			;   0.0           43.8
	FCB  128			;   0.0           50.0
	FCB  128			;   0.0           56.3
	FCB  128			;   0.0           62.5
	FCB  128			;   0.0           68.8
	FCB  128			;   0.0           75.0
	FCB  128			;   0.0           81.3
	FCB  128			;   0.0           87.5
	FCB  128			;   0.0           93.8
	FCB  128			;   0.0          100.0
;
;--------------------------------------------------
; 3 -> 4 RAMP 2 PRESSURE DIFF
;
;  Dissassemby of BDWM
;
; TBL = (PSI/SEC) * 64/ (K + 128)
;--------------------------------------------------
;
					; PSI/SEC        %TPS
;
L66E3   FCB  128			;   0.0            0.0
	FCB  128			;   0.0            6.3
	FCB  128			;   0.0           12.5
	FCB  128			;   0.0           18.8
	FCB  128			;   0.0           25.0
	FCB  128			;   0.0           31.3
	FCB  128			;   0.0           37.5
	FCB  128			;   0.0           43.8
	FCB  128			;   0.0           50.0
	FCB  128			;   0.0           56.3
	FCB  128			;   0.0           62.5
	FCB  128			;   0.0           68.8
	FCB  128			;   0.0           75.0
	FCB  128			;   0.0           81.3
	FCB  128			;   0.0           87.5
	FCB  128			;   0.0           93.8
	FCB  128			;   0.0          100.0
;
;--------------------------------------------------
; 1 -> 2 PRESSURE RAMP 2 TIME vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = SEC'S * K
;--------------------------------------------------
;
					; sec's        %TPS
;
L66F4   FCB  0				;   0.0            0.0
	FCB  0				;   0.0            6.3
	FCB  0				;   0.0           12.5
	FCB  0				;   0.0           18.8
	FCB  0				;   0.0           25.0
	FCB  0				;   0.0           31.3
	FCB  0				;   0.0           37.5
	FCB  0				;   0.0           43.8
	FCB  0				;   0.0           50.0
	FCB  0				;   0.0           56.3
	FCB  0				;   0.0           62.5
	FCB  0				;   0.0           68.8
	FCB  0				;   0.0           75.0
	FCB  0				;   0.0           81.3
	FCB  0				;   0.0           87.5
	FCB  0				;   0.0           93.8
	FCB  0				;   0.0          100.0
;
;---------------------------------------------
; 2 -> 3 PRESSURE RAMP 2 TIME vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = SEC'S * K
;---------------------------------------------
;
					;  sec's           %TPS
;
L6705   FCB  0				;   0.0            0.0
	FCB  0				;   0.0            6.3
	FCB  0				;   0.0           12.5
	FCB  0				;   0.0           18.8
	FCB  0				;   0.0           25.0
	FCB  0				;   0.0           31.3
	FCB  0				;   0.0           37.5
	FCB  0				;   0.0           43.8
	FCB  0				;   0.0           50.0
	FCB  0				;   0.0           56.3
	FCB  0				;   0.0           62.5
	FCB  0				;   0.0           68.8
	FCB  0				;   0.0           75.0
	FCB  0				;   0.0           81.3
	FCB  0				;   0.0           87.5
	FCB  0				;   0.0           93.8
	FCB  0				;   0.0          100.0
;
;------------------------------------------
; 3 -> 4 PRESSURE RAMP 2 TIME vs %TPS
;
;  Dissassemby of BDWM
;
; TBL = SEC'S * K
;------------------------------------------
;
					; sec's       	%TPS
;
L6716   FCB  0				;   0.0            0.0
	FCB  0				;   0.0            6.3
	FCB  0				;   0.0           12.5
	FCB  0				;   0.0           18.8
	FCB  0				;   0.0           25.0
	FCB  0				;   0.0           31.3
	FCB  0				;   0.0           37.5
	FCB  0				;   0.0           43.8
	FCB  0				;   0.0           50.0
	FCB  0				;   0.0           56.3
	FCB  0				;   0.0           62.5
	FCB  0				;   0.0           68.8
	FCB  0				;   0.0           75.0
	FCB  0				;   0.0           81.3
	FCB  0				;   0.0           87.5
	FCB  0				;   0.0           93.8
	FCB  0				;   0.0          100.0
;
;*******************************************************
;* TCC CALIBRATIONS, BDWM
;* TYPE $0D ECM
;* 1994 5.7l (L05)
;*
;*******************************************************
;

L6727	FCB $6F				; 0110 1111     TCC ENABLES
					; b7 = gradual release
					; b6 = TCC off for cold engine
					; b5 = TCC off for cold xmish
					; b4 = not used	IN MY94, see MY95
					; b3 = some pk/nt sw posits turn off TCC
  					; b2 = very low tps turns off TCC
					; b1 = Rapid tps decel turns off TCC
					; b0 = dn shift turns off TCC
;
L6728	FCB $1C				; 0001 1100     TCC ENABLES  
					; b7 = not used 
					; b6 = not used
					; b5 = not used
					; b4 = upshift turns off TCC
					; b3 = specific errors turn off TCC
					; b2 = min TPS turns off TCC
					; b1 = A/C on & not in hot mode turns off TCC
					; b0 = slip & not in hot mode turnsd off TCC
;
; ENGINE Cool thresholds
;
L6729 	FCB  133			; 60c COLD ENG THRESH FOR TCC OFF
L672A   FCB  128			; 56c COLD ENG THRESH FOR TCC ON
;
; XMISH Temperature thresholds
;
L672B   FCB  80				; 20c COLD XMISH THRESH FOR TCC OFF
L672C   FCB  76				; 17c COLD XMISH THRESH FOR TCC ON
;
L672D   FCB  233			;135 deg C, threshold to set flag, hot trans.
L672E   FCB  222			;127 deg C, threshold to clear flag, hot trans.
;
;-----------------
;  6 LINE TABLE
; VAL = MPH * 2
;-----------------
;
L672F   FCB  0				; 0 MPH Vss LMT 2nd W A/C ON, TCC ON
L6730   FCB  0				; 0 MPH Vss LMT 3rd W A/C ON, TCC ON 
L6731   FCB  0				; 0 MPH Vss LMT 4th W A/C ON, TCC ON    
;
L6732   FCB  0				; 0 MPH Vss LMT 2nd W A/C ON, TCC OFF
L6733   FCB  0				; 0 MPH Vss LMT 3rd W A/C ON, TCC OFF 
L6734   FCB  0				; 0 MPH Vss LMT 4th W A/C ON, TCC OFF
;
;-----------------
; 2  LINE TABLE
; IF TCC OFF FOR ERRORS
; & TEMP LT or GT 
;-----------------
;
L6735   FCB  222			; 127c, XMISH LO TEMP THRESH, (LT, TCC OFF)
L6736   FCB  233			; 135c, XMISH LO TEMP THRESH, (GT, TCC OFF) 
;
L6737   FDB  57352			; -1023 RPM, IF SLP L.T. , THEN TCC OFF 
L6739   FCB  63936			; -200 RPM, IF OFF, STAY OFF TILL SLP GT 200
;  
L673B   FCB  76				; 38 MPH Vss THRESH FOR TPS THRESH  
L673C   FCB  72				; 36 MPH Vss THRESH FOR TPS THRESH 
					; IF Vss LT, USE 
;                 
L673D   FCB  2				; 0.8%, VERY LO SPD TPS THRESH
L673E   FCB  4				; 1.6%, LO SPD TPS THRESH
L673F   FCB  5				; 2%, HI SPD TPS THRESH 
L6440   FCB  7				; 2.7%, HI SPD TPS THRESH  
;
L6741   FCB  245			; 173%/SEC, DIFF TPS 
L6742   FCB  9				; 141%/SEC, DIFF TPS RELEASE THRESH  
;
L6743   FCB  0				; STAY IN RELEASE 0 SEC'S
L6744   FCB  0				; DIFF TPS OFF 0 SEC'S
;
L6745   FCB  31				; 0.75 SEC'S DWN SHFT OFF TIME
L6746   FCB  31				; 0.75 SEC'S  UP SHFT OFF TIME 

L6747   FCB  255			; DIFF TPS CHANG TCC DC BY 4000%/SEC,
					; IF DISS TPS G.T. L6742  
;
;------------------------
; CAL FOR TCC BUSYNESS
;------------------------
;
L6748   FDB  0				; 0 SEC MIN LK DLY TIME
;
L674A   FDB  0160			; 4 SEC MAX BETWEEN COAST RELEASES 
					; PRIOR TO DELAY IS INCR
;
L674C   FDB  0160			; 4 SEC INTERVAL USED TO INCR DELAY
;
L674E   FDB  0000			; 0.0 Sec AMT TO INCREMENT DELAY
L6750   FDB  0020			; 0.5 Sec AMT TO DECREMENT DELAY
;
L6752   FCB  40				; 1 SEC TO CONTINUE
;
;********************************
;* TCC ON/OFF PARAMS
;* CPM $0D, L05
;********************************
;
L6753   FCB   0				;
L6754   FCB   0				;
;
L6755   FCB  251			; 125.5 MPH 2ND GR ENGAGE DETENT THRESH
L6756   FCB  150			;  75   MPH 3RD GR ENGAGE DETENT THRESH 
L6757   FCB  150			;  75   MPH 4TH GR ENGAGE DETENT THRESH
;
L6758   FCB  250			; 125   MPH 2ND GR RELEASE DETENT THRESH
L6759   FCB  146			;  73   MPH 3RD GR RELEASE DETENT THRESH
L675A   FCB  146			;  73   MPH 4TH GR RELEASE DETENT THRESH
;
L675B   FCB  251			; 125.5 MPH 2ND GR HOT ENGAGE DETENT THRESH 
L675C   FCB  150			;  75   MPH 3RD GR HOT ENGAGE DETENT THRESH 
L675D   FCB  75				;  34   MPH 4TH GR HOT ENGAGE DETENT THRESH
;
L675E   FCB  250			; 125   MPH 2ND GR HOT RELEASE DETENT THRESH 
L675F   FCB  146			;  73   MPH 3RD GR HOT RELEASE DETENT THRESH
L6760   FCB  72				;  36   MPH 4TH GR HOT RELEASE DETENT THRESH
;
;********************				    
;* NORMAL CONTROLED
;* TCC RELEASE
;********************
;
;----------------------------------------------
; NORM CONTROLED RELEASE THRESH IN MPH Vs. %TPS
; 2nd GEAR
; 
; TBL = MPH * 2
;----------------------------------------------
;
					; MPH           %TPS
;
L6761 	FCB  250			; 125            0.0
	FCB  250			; 125            6.3
	FCB  250			; 125           12.5
	FCB  250			; 125           18.8
	FCB  250			; 125           25.0
	FCB  250			; 125           31.3
	FCB  250			; 125           37.5
	FCB  250			; 125           43.8
	FCB  250			; 125           50.0
	FCB  250			; 125           56.3
	FCB  250			; 125           62.5
	FCB  250			; 125           68.8
	FCB  250			; 125           75.0
	FCB  250			; 125           81.3
	FCB  250			; 125           87.5
	FCB  250			; 125           93.8
	FCB  250			; 125          100.0
;
;----------------------------------------------
; NORM CONTROLED RELEASE THRESH IN MPH Vs. %TPS
; 3rd GR
;
;  Vss Vs. %TPS
;
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					; MPH             %TPS
;
L6772   FCB  72				;  36          	  0.0
	FCB  72				;  36          	  6.3
	FCB  72				;  36          	 12.5
	FCB  72				;  36          	 18.8
	FCB  73				;  36          	 25.0
	FCB  77				;  38          	 31.3
	FCB  82				;  41          	 37.5
	FCB  86				;  43          	 43.8
	FCB  94				;  47          	 50.0
	FCB  106			;  53          	 56.3
	FCB  118			;  58          	 62.5
	FCB  146			;  73          	 68.8
	FCB  146			;  73          	 75.0
	FCB  146			;  73          	 81.3
	FCB  146			;  73          	 87.5
	FCB  146			;  73          	 93.8
	FCB  146			;  73          	100.0
;
;----------------------------------------------
; NORM CONTROLED RELEASE THRESH IN MPH Vs. %TPS
; 4th GR
;
;  Vss Vs. %TPS
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					;  MPH             %TPS
;
L6783   FCB  72				;  36.0            0.0
	FCB  72				;  36.0            6.3
	FCB  72				;  36.0           12.5
	FCB  72				;  36.0           18.8
	FCB  73				;  36.5           25.0
	FCB  76				;  38.5           31.3
	FCB  80				;  41.0           37.5
	FCB  84				;  43.0           43.8
	FCB  88				;  47.0           50.0
	FCB  96				;  53.0           56.3
	FCB  106			;  58.5           62.5
	FCB  118			;  73.0           68.8
	FCB  146			;  73.0           75.0
	FCB  146			;  73.0           81.3
	FCB  146			;  73.0           87.5
	FCB  146			;  73.0           93.8
	FCB  146			;  73.0          100.0
;
;********************
;* HOT CONTROLED
;* TCC RELEASE
;********************
;
;----------------------------------------------
; CONTROLED HOT TCC RELEASE THRESH Vs. %TPS
; 2nd GR
;
;  Vss Vs. %TPS
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					; MPH          %TPS
;
L6794  	FCB   250			; 125            0.0
	FCB   250			; 125            6.3
	FCB   250			; 125           12.5
	FCB   250			; 125           18.8
	FCB   250			; 125           25.0
	FCB   250			; 125           31.3
	FCB   250			; 125           37.5
	FCB   250			; 125           43.8
	FCB   250			; 125           50.0
	FCB   250			; 125           56.3
	FCB   250			; 125           62.5
	FCB   250			; 125           68.8
	FCB   250			; 125           75.0
	FCB   250			; 125           81.3
	FCB   250			; 125           87.5
	FCB   250			; 125           93.8
	FCB   250			; 125          100.0
;
;----------------------------------------------
; CONTROLED HOT TCC RELEASE THRESH, MPH Vs. %TPS
; 3rd GR
;  Vss Vs. %TPS
;
; 10-07-1997  Dissassemby of BDWM  Lines= 17 
;
;  TBL =  2  * MPH
;---------------------------------------------
;
					;    MPH             %TPS
;
L67A5   FCB  72				;      36.0            0.0
	FCB  72				;      36.0            6.3
	FCB  72				;      36.0           12.5
	FCB  72				;      36.0           18.8
	FCB  73				;      36.5           25.0
	FCB  77				;      38.5           31.3
	FCB  82				;      41.0           37.5
	FCB  86				;      43.0           43.8
	FCB  94				;      47.0           50.0
	FCB  106			;      53.0           56.3
	FCB  117			;      58.5           62.5
	FCB  146			;      73.0           68.8
	FCB  146			;      73.0           75.0
	FCB  146			;      73.0           81.3
	FCB  146			;      73.0           87.5
	FCB  146			;      73.0           93.8
	FCB  146			;      73.0          100.0
;
;--------------------------------------------------
; CONTROLED HOT TCC RELEASE THRESH, MPH Vs. %TPS
; 4th GR
;
;  Vss Vs. %TPS
; 
;  Dissassemby of BDWM
;  TBL = MPH * 2
;--------------------------------------------------
;
					; MPH             %TPS
;
L67B6   FCB   72			;  36.0            0.0
	FCB   72			;  36.0            6.3
	FCB   72			;  36.0           12.5
	FCB   72			;  36.0           18.8
	FCB   72			;  36.0           25.0
	FCB   72			;  36.0           31.3
	FCB   72			;  36.0           37.5
	FCB   72			;  36.0           43.8
	FCB   72			;  36.0           50.0
	FCB   72			;  36.0           56.3
	FCB   72			;  36.0           62.5
	FCB   72			;  36.0           68.8
	FCB   72			;  36.0           75.0
	FCB   72			;  36.0           81.3
	FCB   72			;  36.0           87.5
	FCB   72			;  36.0           93.8
	FCB   72			;  36.0          100.0
;
;*****************************
;* CRUISE CONTROLED
;* TCC RELEASE
;* 3rd & 4th GEAR
;*****************************
;
;----------------------------------------------
; CRUISE CONTROLED TCC RELEASE THRESH, 
; MPH Vs. %TPS
; 3rd GR
; 
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					; MPH             %TPS
;
L67C7   FCB 72				;  36.0            0.0
	FCB 72				;  36.0            6.3
	FCB 72				;  36.0           12.5
	FCB 72				;  36.0           18.8
	FCB 73				;  36.5           25.0
	FCB 77				;  38.5           31.3
	FCB 82				;  41.0           37.5
	FCB 86				;  43.0           43.8
	FCB 94				;  47.0           50.0
	FCB 106				;  53.0           56.3
	FCB 117				;  58.5           62.5
	FCB 146				;  73.0           68.8
	FCB 146				;  73.0           75.0
	FCB 146				;  73.0           81.3
	FCB 146				;  73.0           87.5
	FCB 146				;  73.0           93.8
	FCB 146				;  73.0          100.0
;
;----------------------------------------------
; CRUISE CONTROLED TCC RELEASE THRESH 
; MPH Vs. %TPS
; 4th GR
;
;  Vss Vs. %TPS
;
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					; MPH              %TPS
;
L67D8   FCB 72				;  36.0            0.0
	FCB 72				;  36.0            6.3
	FCB 72				;  36.0           12.5
	FCB 72				;  36.0           18.8
	FCB 73				;  36.5           25.0
	FCB 77				;  38.5           31.3
	FCB 82				;  41.0           37.5
	FCB 86				;  43.0           43.8
	FCB 94				;  47.0           50.0
	FCB 106				;  53.0           56.3
	FCB 117				;  58.5           62.5
	FCB 146				;  73.0           68.8
	FCB 146				;  73.0           75.0
	FCB 146				;  73.0           81.3
	FCB 146				;  73.0           87.5
	FCB 146				;  73.0           93.8
	FCB 146				;  73.0          100.0
;
;***********************************************
;* >> TCC ENGAGE THRESHOLDS <<
;*
;***********************************************
;***********************************************
;* NORMAL ENGAGE
;* THRESHOLDS
;* 2nd, 3rd & 4th GEAR
;***********************************************
;----------------------------------------------
; NORMAL ENGAGE THRESHOLDS, MPH Vs. %TPS
; 2nd GEAR
;
; MPH Vs. %TPS
;
;  Dissassemby of BDWM
;  
;
;   TBL = MPH * 2
;----------------------------------------------
;
					;  MPH             %TPS
;
L67E9   FCB  250			; 125.0            0.0
	FCB  250			; 125.0            6.3
	FCB  250			; 125.0           12.5
	FCB  250			; 125.0           18.8
	FCB  250			; 125.0           25.0
	FCB  250			; 125.0           31.3
	FCB  250			; 125.0           37.5
	FCB  250			; 125.0           43.8
	FCB  250			; 125.0           50.0
	FCB  250			; 125.0           56.3
	FCB  250			; 125.0           62.5
	FCB  250			; 125.0           68.8
	FCB  250			; 125.0           75.0
	FCB  250			; 125.0           81.3
	FCB  250			; 125.0           87.5
	FCB  250			; 125.0           93.8
	FCB  250			; 125.0          100.0
;
;----------------------------------------------
; NORMAL ENGAGE THRESHOLDS, MPH Vs. %TPS
; 3rd GEAR
;
; MPH Vs. %TPS
;
;  Dissassemby of BDWM
;
;   TBL = MPH * 2
;----------------------------------------------
;
					;   MPH          %TPS
;
L67FA   FCB 75				;  37.5            0.0
	FCB 75				;  37.5            6.3
	FCB 75				;  37.5           12.5
	FCB 77				;  38.5           18.8
	FCB 84				;  42.0           25.0
	FCB 93				;  46.5           31.3
	FCB 100				;  50.0           37.5
	FCB 106				;  53.0           43.8
	FCB 114				;  57.0           50.0
	FCB 150				;  75.0           56.3
	FCB 150				;  75.0           62.5
	FCB 150				;  75.0           68.8
	FCB 150				;  75.0           75.0
	FCB 150				;  75.0           81.3
	FCB 150				;  75.0           87.5
	FCB 150				;  75.0           93.8
	FCB 150				;  75.0          100.0
;
;***************************
;* NORMAL TCC THRESHOLDS
;***************************
;
;----------------------------------------------
; NORMAL CONTROLLED ENGAGE THRESH, MPH Vs. %TPS
; 4th GEAR
; 
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;  MPH          %TPS
;
L680B   FCB  75				;  37.5            0.0
	FCB  75				;  37.5            6.3
	FCB  75				;  37.5           12.5
	FCB  77				;  38.5           18.8
	FCB  84				;  42.0           25.0
	FCB  93				;  46.5           31.3
	FCB  100			;  50.0           37.5
	FCB  106			;  53.0           43.8
	FCB  114			;  57.0           50.0
	FCB  150			;  75.0           56.3
	FCB  150			;  75.0           62.5
	FCB  150			;  75.0           68.8
	FCB  150			;  75.0           75.0
	FCB  150			;  75.0           81.3
	FCB  150			;  75.0           87.5
	FCB  150			;  75.0           93.8
	FCB  150			;  75.0          100.0
;
;*****************************
;* HOT CONTROLED
;* TCC ENGAGE
;* 2nd, 3rd & 4th GEAR
;*****************************
;
;----------------------------------------------
; HOT CONTROLLED ENGAGE THRESH, MPH Vs. %TPS
; 2nd GEAR
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;  MPH         %TPS
;
L681C   FCB  250			; 125.0            0.0
	FCB  250			; 125.0            6.3
	FCB  250			; 125.0           12.5
	FCB  250			; 125.0           18.8
	FCB  250			; 125.0           25.0
	FCB  250			; 125.0           31.3
	FCB  250			; 125.0           37.5
	FCB  250			; 125.0           43.8
	FCB  250			; 125.0           50.0
	FCB  250			; 125.0           56.3
	FCB  250			; 125.0           62.5
	FCB  250			; 125.0           68.8
	FCB  250			; 125.0           75.0
	FCB  250			; 125.0           81.3
	FCB  250			; 125.0           87.5
	FCB  250			; 125.0           93.8
	FCB  250			; 125.0          100.0
;
;----------------------------------------------
; HOT CONTROLLED ENGAGE THRESH, MPH Vs. %TPS
; 3rd GEAR
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;  MPH          %TPS
;
L682D   FCB  75				;  37.5            0.0
	FCB  75				;  37.5            6.3
	FCB  75				;  37.5           12.5
	FCB  77				;  38.5           18.8
	FCB  84				;  42.0           25.0
	FCB  93				;  46.5           31.3
	FCB  100			;  50.0           37.5
	FCB  106			;  53.0           43.8
	FCB  114			;  57.0           50.0
	FCB  150			;  75.0           56.3
	FCB  150			;  75.0           62.5
	FCB  150			;  75.0           68.8
	FCB  150			;  75.0           75.0
	FCB  150			;  75.0           81.3
	FCB  150			;  75.0           87.5
	FCB  150			;  75.0           93.8
	FCB  150			;  75.0          100.0
;
;----------------------------------------------
; 4TH GR HOT CONTROLLED ENGAGE THRESH,
; MPH Vs. %TPS
; 4tH GEAR
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
					;  MPH           %TPS
;
L683E   FCB  75				;  37.5            0.0
	FCB  75				;  37.5            6.3
	FCB  75				;  37.5           12.5
	FCB  75				;  37.5           18.8
	FCB  75				;  37.5           25.0
	FCB  75				;  37.5           31.3
	FCB  75				;  37.5           37.5
	FCB  75				;  37.5           43.8
	FCB  75				;  37.5           50.0
	FCB  75				;  37.5           56.3
	FCB  75				;  37.5           62.5
	FCB  75				;  37.5           68.8
	FCB  75				;  37.5           75.0
	FCB  75				;  37.5           81.3
	FCB  75				;  37.5           87.5
	FCB  75				;  37.5           93.8
	FCB  75				;  37.5          100.0
;
;**************************
;* CRUISE CONTROLLED ENGAGE
;**************************
;
;*****************************
;* CRUSIE CONTROLED
;* TCC ENGAGE
;* 3rd & 4th GEAR
;*****************************
;
;----------------------------------------------
; CRUISE CONTROLLED ENGAGE THRESH, MPH Vs. %TPS
; 3rd GEAR
; Vss Vs. %TPS
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;   MPH           %TPS
;
L684F   FCB  75				;  37.5            0.0
	FCB  75				;  37.5            6.3
	FCB  75				;  37.5           12.5
	FCB  77				;  38.5           18.8
	FCB  84				;  42.0           25.0
	FCB  93				;  46.5           31.3
	FCB  150			;  75.0           37.5
	FCB  150			;  75.0           43.8
	FCB  150			;  75.0           50.0
	FCB  150			;  75.0           56.3
	FCB  150			;  75.0           62.5
	FCB  150			;  75.0           68.8
	FCB  150			;  75.0           75.0
	FCB  150			;  75.0           81.3
	FCB  150			;  75.0           87.5
	FCB  150			;  75.0           93.8
	FCB  150			;  75.0          100.0
;
;----------------------------------------------
; CRUISE CONTROLLED ENGAGE THRESH, MPH Vs. %TPS
; 4th GEAR
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;  MPH           %TPS
;
L6860   FCB  75				;  37.5            0.0
	FCB  75				;  37.5            6.3
	FCB  75				;  37.5           12.5
	FCB  77				;  38.5           18.8
	FCB  84				;  42.0           25.0
	FCB  93				;  46.5           31.3
	FCB  150			;  75.0           37.5
	FCB  150			;  75.0           43.8
	FCB  150			;  75.0           50.0
	FCB  150			;  75.0           56.3
	FCB  150			;  75.0           62.5
	FCB  150			;  75.0           68.8
	FCB  150			;  75.0           75.0
	FCB  150			;  75.0           81.3
	FCB  150			;  75.0           87.5
	FCB  150			;  75.0           93.8
	FCB  150			;  75.0          100.0
;
;******************************************
;* >> TCC RELEASE CAILBRATIONS <<
;* TYPE $0D ECM 1994 5.7L l05
;******************************************
;
;********************************
;* NORMAL TCC RELEASE THRESHOLS
;* GEAR
;********************************
;
;----------------------------------------------
; RELEASE OPERATING POINT NORMAL MODE CONDITION
; %D.C. Vs. %TPS
;
; GEAR 3
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					;  %D.C.          %TPS
;
L6871   FCB  0				;   0.0            0.0
	FCB  0				;   0.0            6.3
	FCB  0				;   0.0           12.5
	FCB  0				;   0.0           18.8
	FCB  0				;   0.0           25.0
	FCB  0				;   0.0           31.3
	FCB  0				;   0.0           37.5
	FCB  0				;   0.0           43.8
	FCB  0				;   0.0           50.0
	FCB  0				;   0.0           56.3
	FCB  0				;   0.0           62.5
	FCB  0				;   0.0           68.8
	FCB  0				;   0.0           75.0
	FCB  0				;   0.0           81.3
	FCB  0				;   0.0           87.5
	FCB  0				;   0.0           93.8
	FCB  0				;   0.0          100.0
;
;----------------------------------------------
; RELEASE OPERATING POINT NORMAL MODE CONDITIONS
; %D.C. Vs. %TPS
;
; GEAR 3
;
;  Dissassemby of BDWM
;
; TBL = MPH * 2
;----------------------------------------------
;
					; %D.C.         %TPS
;
L6882   FCB  0				;   0.0            0.0
	FCB  0				;   0.0            6.3
	FCB  0				;   0.0           12.5
	FCB  0				;   0.0           18.8
	FCB  0				;   0.0           25.0
	FCB  0				;   0.0           31.3
	FCB  0				;   0.0           37.5
	FCB  0				;   0.0           43.8
	FCB  0				;   0.0           50.0
	FCB  0				;   0.0           56.3
	FCB  0				;   0.0           62.5
	FCB  0				;   0.0           68.8
	FCB  0				;   0.0           75.0
	FCB  0				;   0.0           81.3
	FCB  0				;   0.0           87.5
	FCB  0				;   0.0           93.8
	FCB  0				;   0.0          100.0
;
;**********************
;* NORMAL TCC RELEASE
;* RATE
;**********************
;
;----------------------------------------------
; NORMAL RELEASE RATE, %D.C./SEC Vs. %TPS
; 3rd GEAR
;
;  Dissassemby of BDWM
;
; TLB =  %D.C./SEC * 204
;----------------------------------------------
;
    					; %/S   		   %TPS

L6893   FCB  255			; 125.0            0.0
	FCB  255			; 125.0            6.3
	FCB  255			; 125.0           12.5
	FCB  255			; 125.0           18.8
	FCB  255			; 125.0           25.0
	FCB  255			; 125.0           31.3
	FCB  255			; 125.0           37.5
	FCB  255			; 125.0           43.8
	FCB  255			; 125.0           50.0
	FCB  255			; 125.0           56.3
	FCB  255			; 125.0           62.5
	FCB  255			; 125.0           68.8
	FCB  255			; 125.0           75.0
	FCB  255			; 125.0           81.3
	FCB  255			; 125.0           87.5
	FCB  255			; 125.0           93.8
	FCB  255			; 125.0          100.0
;
;----------------------------------------------
; NORMAL RELEASE RATE, %D.C./SEC Vs. %TPS
; 4th GEAR
;
;
;  Dissassemby of BDWM
;
;  TLB =  %D.C./SEC * 204
;----------------------------------------------
;
					; %/S   		   %TPS
;
L68A4   FCB  255			; 125.0            0.0
	FCB  255			; 125.0            6.3
	FCB  255			; 125.0           12.5
	FCB  255			; 125.0           18.8
	FCB  255			; 125.0           25.0
	FCB  255			; 125.0           31.3
	FCB  255			; 125.0           37.5
	FCB  255			; 125.0           43.8
	FCB  255			; 125.0           50.0
	FCB  255			; 125.0           56.3
	FCB  255			; 125.0           62.5
	FCB  255			; 125.0           68.8
	FCB  255			; 125.0           75.0
	FCB  255			; 125.0           81.3
	FCB  255			; 125.0           87.5
	FCB  255			; 125.0           93.8
	FCB  255			; 125.0          100.0
;
;********************************
;* NORMAL TCC OPERATING POINT
;* 
;********************************
;
;----------------------------------------------
; NORMAL ENGAGE OPERATING POINT, %D.C. Vs. %TPS
; 3rd GEAR 
;
;  Dissassemby of BDWM
;
;  TLB = %D.C. * 2.56
;----------------------------------------------
;
					; %D.C.           %TPS
;
L68B5   FCB  255			; 100          	  0.0
	FCB  255			; 100          	  6.3
	FCB  255			; 100          	 12.5
	FCB  255			; 100          	 18.8
	FCB  255			; 100          	 25.0
	FCB  255			; 100          	 31.3
	FCB  255			; 100          	 37.5
	FCB  255			; 100          	 43.8
	FCB  255			; 100          	 50.0
	FCB  255			; 100          	 56.3
	FCB  255			; 100          	 62.5
	FCB  255			; 100          	 68.8
	FCB  255			; 100          	 75.0
	FCB  255			; 100          	 81.3
	FCB  255			; 100          	 87.5
	FCB  255			; 100          	 93.8
	FCB  255			; 100          	100.0
;
;----------------------------------------------
; NORMAL ENGAGE OPERATING POINT, %D.C. Vs. %TPS
; 4th GEAR 
;
;  Dissassemby of BDWM
;
;  TLB = %D.C. * 2.56
;----------------------------------------------
;
					;  %D.C.           %TPS
;
L68C6   FCB  255			; 100.0            0.0
	FCB  255			; 100.0            6.3
	FCB  255			; 100.0           12.5
	FCB  255			; 100.0           18.8
	FCB  255			; 100.0           25.0
	FCB  255			; 100.0           31.3
	FCB  255			; 100.0           37.5
	FCB  255			; 100.0           43.8
	FCB  255			; 100.0           50.0
	FCB  255			; 100.0           56.3
	FCB  255			; 100.0           62.5
	FCB  255			; 100.0           68.8
	FCB  255			; 100.0           75.0
	FCB  255			; 100.0           81.3
	FCB  255			; 100.0           87.5
	FCB  255			; 100.0           93.8
	FCB  255			; 100.0          100.0
;
;----------------------------------------------
; NORMAL ENGAGE RATE,  %D.C./SEC Vs. %TPS
; 3rd GEAR
;
;
;  Dissassemby of BDWM
;
; TLB =  %D.C./SEC * 204
;----------------------------------------------
;
					; %DC/SEC                 %TPS
;
L68D7   FCB  255			; 125.0            0.0
	FCB  255			; 125.0            6.3
	FCB  255			; 125.0           12.5
	FCB  255			; 125.0           18.8
	FCB  255			; 125.0           25.0
	FCB  255			; 125.0           31.3
	FCB  255			; 125.0           37.5
	FCB  255			; 125.0           43.8
	FCB  255			; 125.0           50.0
	FCB  255			; 125.0           56.3
	FCB  255			; 125.0           62.5
	FCB  255			; 125.0           68.8
	FCB  255			; 125.0           75.0
	FCB  255			; 125.0           81.3
	FCB  255			; 125.0           87.5
	FCB  255			; 125.0           93.8
	FCB  255			; 125.0          100.0
;
;----------------------------------------------
; NORMAL ENGAGE RATE, %D.C./SEC Vs. %TPS 
; 4th GEAR
; %D.C./SEC Vs. %TPS
;
;  Dissassemby of BDWM
;
; TLB =  %D.C./SEC * 204
;----------------------------------------------
					;  %D.C./SEC               %TPS
;
L68E8   FCB  255			; 125            0.0
	FCB  255			; 125            6.3
	FCB  255			; 125           12.5
	FCB  255			; 125           18.8
	FCB  255			; 125           25.0
	FCB  255			; 125           31.3
	FCB  255			; 125           37.5
	FCB  255			; 125           43.8
	FCB  255			; 125           50.0
	FCB  255			; 125           56.3
	FCB  255			; 125           62.5
	FCB  255			; 125           68.8
	FCB  255			; 125           75.0
	FCB  255			; 125           81.3
	FCB  255			; 125           87.5
	FCB  255			; 125           93.8
	FCB  255			; 125          100.0
;
;********************************
;* LOCKED TCC CALIBRATIONS
;* TYPE $0D ECM, 95 L05
;********************************
;
;----------------------------------------------
; LOCKED TCC CALIBRATIONS
;
; MAX TCC D.C. Vs. PSI 
;
; TBL = %D.C. * 2.56
;----------------------------------------------
;
					;  %D.C.            PSI
;	
L68F9   FCB  230			;  90.2            0.0
	FCB  230			;  90.2            8.0
	FCB  230			;  90.2           16.0
	FCB  230			;  90.2           24.0
	FCB  230			;  90.2           32.0
	FCB  230			;  90.2           40.0
	FCB  230			;  90.2           48.0
	FCB  230			;  90.2           56.0
	FCB  230			;  90.2           64.0
	FCB  230			;  90.2           72.0
	FCB  230			;  90.2           80.0
	FCB  230			;  90.2           88.0
	FCB  230			;  90.2           96.0
	FCB  230			;  90.2          104.0
	FCB  230			;  90.2          112.0
	FCB  230			;  90.2          120.0
	FCB  230			;  90.2          128.0
;
;----------------------------------------------
; OPERATING POINT MULT Vs. LINE PRESSURE
;
;  Dissassemby of BDWM
;
; TBL = MULT * 128
;----------------------------------------------
;
					; MULT         	PSI
;
L690A   FCB  128			;   1.0            0.0
	FCB  128			;   1.0            8.0
	FCB  128			;   1.0           16.0
	FCB  128			;   1.0           24.0
	FCB  128			;   1.0           32.0
	FCB  128			;   1.0           40.0
	FCB  128			;   1.0           48.0
	FCB  128			;   1.0           56.0
	FCB  128			;   1.0           64.0
	FCB  128			;   1.0           72.0
	FCB  128			;   1.0           80.0
	FCB  128			;   1.0           88.0
	FCB  128			;   1.0           96.0
	FCB  128			;   1.0          104.0
	FCB  128			;   1.0          112.0
	FCB  128			;   1.0          120.0
	FCB  128			;   1.0          128.0
;
L691B   FDB 0000			; 0% MIN TPS D.C.
;
L691D   FCB 12				; 6 MPH VSS FOR MAX TCC D.C. 
L691E   FCB 8				; 4 MPH VSS FOR MIN TCC D.C. 
;
L691F   FCB 0				; 0 SEC'S DELAY ENGAGE TO SOLONOID ON
L6920   FCB 0				; 0 SEC'S DELAY SOLONOID ON TO ENGAGE
;
L6921   FCB 0				; 0 SEC'S  DELAY FM END OF RELEASE TO SOLONOID OFF      
L6922   FCB 0				; 0 SEC'S  DELAY FM SOLONIOD OFF TO TCC DC MAX   
L6923   FCB 0				; 0 SEC'S ENGAGE DURATION   
L6924   FCB 0				; 0 SEC'S RELEASE DURATION
;
;***********************************************
;* >>> END OF TCC CALIBRATIONS <<<
;***********************************************
;
;***********************************************
;* >>> FORCE MOTOR CALIBRATIONS <<<
;* TYPE $0D ECM, 1994 L05
;***********************************************
;
;*************************
;*  FORCE MOTOR CONSTANTS
;*************************
;
L6925   FCB 80				; 0.5 SEC FOR SHORT DETECT 
;
L6926   FCB 73				;  7.3 VDC LO VDC THRESH AT -40 Deg c 
					; FOR SHORT DETECT
;                  
L6927   FCB 114				; 11.4 VDC, HI VDC  THRESH AT 152 DEG C 
					; FOR SHORT DETECT
;                   
L6928   FCB 78				;  7.8 VDC HI VDC THRESH AT -40 Deg c
L6929   FCB 119				; 11.9 VDC HI VDC THRESH AT 152 Deg c
;
;*************************
;*  FORCE CALIBRATIONS
;* (MAIN LINE PRESSURE)
;*************************
;
;----------------------------------------------
; POSITIVE PRESSSURE CHANGE
;
; FORCE MOTOR CURRENT Vs. PRESSURE & XMSISH TEMP
;
;  Dissassemby of BDWM, 17 x 17 TABLE
;
; CURRENT Vs. PRESSURE & XMISH TEMP
;
; TBL = AMPS * 51.2
;----------------------------------------------
;
L692A	FCB   0				; Min DEG c Val
        FCB   0				; Min PSI MIN Value
        FCB   17			; COL'S/ROW
;
;	PSI:   0    6   12   18   24   30   36   42   48   54   60   66   72   78   84   90   96 ;Deg C
;
	FCB   55,  45,  45,  45,  43,  41,  39,  37,  36,  32,  31,  28,  25,  21,  17,  11,  11 ;-40 
	FCB   55,  47,  46,  45,  43,  41,  39,  37,  35,  33,  30,  28,  24,  21,  17,  11,  11 ;-28
	FCB   55,  47,  46,  45,  43,  41,  40,  38,  36,  33,  31,  28,  25,  22,  18,  13,  13 ;-16        
	FCB   55,  47,  46,  45,  43,  41,  40,  38,  36,  33,  31,  28,  25,  22,  18,  12,  12 ; -4 
	FCB   55,  48,  46,  45,  43,  41,  39,  37,  35,  33,  30,  28,  24,  21,  17,  11,  11 ;  8
	FCB   55,  48,  46,  45,  43,  41,  39,  37,  35,  32,  30,  27,  24,  20,  16,  10,  10 ; 20 
	FCB   55,  48,  46,  44,  42,  41,  39,  37,  35,  32,  30,  27,  23,  20,  15,   9,   9 ; 32   	
	FCB   55,  47,  46,  44,  42,  40,  39,  36,  34,  32,  29,  26,  23,  19,  15,   8,   8 ; 44 
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  15,   7,   7 ; 56 
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  15,   7,   7 ; 68
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ; 80 
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ; 92
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;104
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;116
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;128 
	FCB   55,  47,  45,  43,  42,  40,  38,  36,  34,  31,  29,  26,  23,  19,  14,   7,   7 ;142
	FCB   55,  47,  45,  43,  42,  40,  38,  36,  34,  31,  29,  26,  23,  19,  14,   6,   6 ;152
;
;----------------------------------------------
; NEGITIVE PRESSURE CHANGE 
;
;  CURRENT Vs. PRESSURE & TRANS TEMP
;
;   
;  Dissassemby of BDWM,  17 x 17 TABLE
;
; TBL = AMPS * 51.2
;----------------------------------------------
;
L6A4E	FCB   0				; Min DEG c Val
        FCB   0				; Min PSI MIN Value
        FCB   17			; COL'S/ROW
;
;	PSI:   0    6   12   18   24   30   36   42   48   54   60   66   72   78   84   90   96 ;Deg C
;
	FCB   55,  45,  45,  45,  43,  41,  39,  37,  36,  32,  31,  28,  25,  21,  17,  11,  11 ;-40 
	FCB   55,  47,  46,  45,  43,  41,  39,  37,  35,  33,  30,  28,  24,  21,  17,  11,  11 ;-28
	FCB   55,  47,  46,  45,  43,  41,  40,  38,  36,  33,  31,  28,  25,  22,  18,  13,  13 ;-16 
	FCB   55,  47,  46,  45,  43,  41,  40,  38,  36,  33,  31,  28,  25,  22,  18,  12,  12 ; -4 
	FCB   55,  48,  46,  45,  43,  41,  39,  37,  35,  33,  30,  28,  24,  21,  17,  11,  11 ;  8
	FCB   55,  48,  46,  45,  43,  41,  39,  37,  35,  32,  30,  27,  24,  20,  16,  10,  10 ; 20 
	FCB   55,  48,  46,  44,  42,  41,  39,  37,  35,  32,  30,  27,  23,  20,  15,   9,   9 ; 32
	FCB   55,  47,  46,  44,  42,  40,  39,  36,  34,  32,  29,  26,  23,  19,  15,   8,   8 ; 44
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  15,   7,   7 ; 56 
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  15,   7,   7 ; 68
	FCB   55,  47,  46,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ; 80 
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ; 92
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;104
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;116
	FCB   55,  47,  45,  44,  42,  40,  38,  36,  34,  32,  29,  26,  23,  19,  14,   7,   7 ;128 
	FCB   55,  47,  45,  43,  42,  40,  38,  36,  34,  31,  29,  26,  23,  19,  14,   7,   7 ;142
	FCB   55,  47,  45,  43,  42,  40,  38,  36,  34,  31,  29,  26,  23,  19,  14,   6,   6 ;152
;
;----------------------------------------------
; DIFF PRESSURE Vs. XMISH TEMPERATURE 
;
; TYPE $0D ECM, 94 L05
;
; TBL = PSI
;----------------------------------------------
;
					; PSI        XMISH TEMP Deg c
;
L6B72   FCB  1				;   1.0           -40
	FCB  1				;   1.0           -36
	FCB  1				;   1.0           -32
	FCB  1				;   1.0           -28
	FCB  1				;   1.0           -24
	FCB  1				;   1.0           -20
	FCB  1				;   1.0           -16
	FCB  1				;   1.0           -12
	FCB  1				;   1.0           -8.
	FCB  1				;   1.0           -4.
	FCB  1				;   1.0            0.
	FCB  1				;   1.0            4.
	FCB  1				;   1.0            8.
	FCB  1				;   1.0           12.
	FCB  1				;   1.0           16.
	FCB  1				;   1.0           20.
	FCB  1				;   1.0           24.
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; Start of main code
;
;~~~~~~~~~~~~~~~~~~~~~~
;
L7200	LDS     #$03FF			;Load stack @ 0x3FF
	LDX     #$1000			;Base CPU address
	LDAA    #$03			;New base address for Regs.
	STAA    $3D,X			;Save it, Regs. now init. at 0x3000
	LDX     #$3000			;New base address
	LDAA    #$B8			;1011 1000
	STAA    $39,X			;Option Reg.
					; b7=ADC powerup bit
					; b6=Clock select
					; b5=Configure IRQ
					; b4=Enable startup delay
					; b3=Clock monitor
					; b2= -
					; b1=CR1, COP timer rate select 
					; b0=CR0, COP timer rate select 
;
	LDAA    #$03			;0000 0011, select E/16, or 524 kHz for 16 bit counter
	STAA    $24,X			;TMSK2(Timer Mask Register 2) Reg.
					; b7=Timer overflow interrupt enable
					; b6=Real time interrupt enable
					; b5=Pulse Accumulator Interrrupt enable 
					; b4=Pulse Accumulator Interrupt edge Interrupt enable
					; b3= -
					; b2= -
					; b1=PR1, Timer Prescale select
					; b0=PR0, Timer Prescale select
;
	BCLR    $38,X,#$20		;Clr b5=, OPT 2 REG
	LDAA    #$1B			;0001 1011
	STAA    $35,X			;BPROT (EEPROM block protect) REG
					; b7= -
					; b6= -
					; b5= -
					; b4=Protect Config Reg.
					; b3=BPRT3 (Block Protect) 0xB6E0-0xB7FF
					; b2=BPRT2 (Block Protect) 0xB660-0xB6DF
					; b1=BPRT1 (Block Protect) 0xB620-0xB65F
					; b0=BPRT0 (Block Protect) 0xB600-0xB61F
;
	JSR     LCA8A			;Reg. config routine
;
;-Perform additional clears/resets
;
	CLRA 				;Preclear A   
	STAA    0,X			;Port A
	STAA    $08,X			;Port D
	LDAA    #$7F			;
	LDAB    #$FF			;
	STD     L306E			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SET UP HARDWARE FOR CPI/PFI MODE
; or TBI MODE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #$B93A			;TBI mode
	LDY     #L400B			;mode word  
	BRCLR   0,Y,#$01,L723A		;Bra if b0=0, In TBI mode
;
;-In CPI/PFI mode
;											
	LDX     #$B91A			;CPI/PFI fuel mode
;
;-Here to store 
;
L723A	STX     L3FFC          		;I/O D Port 
	JSR     LF08A			;RTS, Delay
	LDD     L3FFC          		;I/O D Port
	JSR     LF08A          		;RTS, short delay
	ANDB    #$FB			;1111 1011, clear b2
	ORAB    #$08			;Set b3
	STD     L3FFC          		;I/O D PORT 
;
;-Serial Data
;
	LDX     #L3000			;Reg. base addr.
	LDD     $2E,X			;Access SCI status register
	LDAB    #$26			;0010 0110 
	STAB    $2D,X			;SCI Contol Reg. 2
					; b7=Transmit interrupt enable
					; b6=Transmit complete interrupt enable
					; b5=Recieve interrupt enable
					; b4=Idle line interrupt enable
					; b3=Transmit enable
					; b2=Recieve enable
					; b1=Reciever wake up
					; b0=Send break 
;
;-Clear varous regs.
;
	LDX     #$3FC0			;DRP
	CLRA 				;Preclear A   
	CLRB 				;Preclear B   
L725B	STD     0,X			;Clear reg.
	INX 				;+1    
	INX  				;+1   
	CPX     #$3FFA			;Last address to clear
	BNE     L725B			;Bra if !=, continue	
;			
	LDX     #$0036			;Start address of RAM to clear
	LDD     #0197			;197, #of bytes to clear
	JSR     LEF9A			;RAM clear routine
;
	LDX     #$0100			;Start address to clear
	LDD     #$01C0			;448, number of bytes to clear
	JSR     LEF9A			;Ram clear routine
;
	LDX     #$0800			;Start address to clear
	LDD     #$0100			;256, number of bytes to clear
	JSR     LEF9A			;RAM clear routine
;
;-Perform additional clears
;
	LDX     #$0362			;Start address		
L7282	CLR     0,X			;Clear address
	INX    				;+1, next addresss 
	CPX     #$03FF			;Last address to clear
	BNE     L7282			;Bra to contine if not at last address
;
	JSR	LEEAA			;A/D routine with multi-channel read
;		
	JSR     LEEE2			;A/D routine, multi-channel read
;
	JSR     LC3BA			;Read in fuel pump volts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Check ALDL switch position
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for normal operation
;
	LDAA    L082F			;ALDL switch voltage
	CMPA    #100			;2 V
	BCC     L72C3			;Bra if >=
;
;-Check for field test mode
;
	CMPA    #40			;800 mV
	BCS     L72C3			;Bra if <
;
;-In factory test mode
;											
	BSET    L0050,#$08		;Set b3,  In factory test mode
	LDAA    L00A0          		;A/D TPS
	CMPA    #252           		;4.92 V
	BCS     L72C3          		;Bra if TPS <
;                                                           
	LDAA    L082D          		;A/D coolant
	CMPA    #252           		;149 deg C
	BCS     L72C3          		;Bra if cool temp is less
;
	LDAA    L009F          		;Transmission temp
	CMPA    #5			;-40c
	BHI     L72C3          		;Bra if trans. temp is >
;
	BSET    L0044,#$01		;Status word, set b0, factory test requested 
	CLR     L0001          		;(MAX TERM CNT MJR LP SEG)

	LDX     #$B93A			;
	STX     L3FFC          		;I/O Port D
	JMP     L7548			;
                                     
;
;~~~~~~~~~~~~~~
;-Check EPROM
;~~~~~~~~~~~~~~
;
L72C3	BCLR    L0005,#$10		;Status word, clear b4=bad EPROM CLR b4, BAD EPROM FLAG
	LDAA    L303F          		;System config reg.
	CMPA    #$0B           		;0000 1011, Disable COP, enable ROM, enable EEPROM
	BEQ     L72D2			;EPROM checksum routine
;
	BSET    L003A,#$04     		;Status word, set b2
	BRA     L72EC			;bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
; EPROM checksum routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L72D2	LDX     #$4008			;Start of EPROM area to check
	JSR     LEF47			;Checksum routine
;
	LDAA    L4008			;Mask ID byte										
	CPY     L4006			;Checksum
	BNE     L72E5			;Bran if !=, check for test mode
;												
	CMPA    #$0D			;Mask ID 
	BEQ     L730C			;Bra if == to mask ID
;
;-Check for test mode
;												
L72E5	CMPA    #$AA			;Test mode
	BEQ     L730C			;Bra if ==
;
;~~~~~~~~~~~~~~~~~~~	
;-Here to set error
;~~~~~~~~~~~~~~~~~~~	
	BSET    L003A,#$02		;Set b1, EPROM failure
L72EC	BSET    L0005,#$10		;Set b4, EPROM error
											
	LDD     L3FFC			;I/O D Port
	JSR     LF08A			;RTS, short delay
	ANDB    #$F7			;1111 1110
	STD     L3FFC          		;I/O D Port
	BSET    L001A,#$20		;Set b5 
	BSET    L000F,#$20		;Set b5,  Error 51, EPROM failure
	JSR     LEFC3			;RAM checksum routine
;
	STAA    L0015	        	;Save it, diag. checksum
;
;-Check ALDL switch status
;	
	LDAA    L082F			;ALDL A/D voltage
;	
L7308	CMPA    #100			;2 V
	BCC     L7308			;Bra if votage >, loop and wait to reset
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if not setting error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L730C	JSR     LEFC3			;RAM checksum routine
	CMPA    L0015			;Diag. checksum 
	BEQ     L733C			;Bra if equal
;
;-Clear RAM if bad checksum
;     
	LDX     #$0000			;Start addr.
	LDD     #0012			;# of bytes to clear
	JSR     LEF9A			;RAM clear routine
;
	LDX     #$000B			;Start addr.
	LDD     #42			;# of bytes to clear
	JSR     LEF9A			;RAM clear routine
;
	LDX     #$02C0			;Start addr.
	LDD     #117			;# of bytes to clear 
	JSR     LEF9A			;RAM clear routine
;
	LDAA    L5B24			;Max alowed base TPS 
	LDAB    #128			;
	STD     L0319			;Save it, Base TPS for closed throttle

	JSR     LEF1D			;BLM reset routine
;
	BSET    L0046,#$40		;Status word, set b6, BLMs reset
L733C	BSET    L0082,#$08		;(???) SET b3, 1 = UPSHIFT TQ REDUCTION TE RUESTED 
;
;-Perform additional checksum
;
	LDX     #$0327			;Uppermost address
	LDAB    #$0D			;# of bytes to check
	CLRA				;    
	PSHB    			;# of bytes to check to stack

L7346	ADDA    0,X			;Add value stored at address
	DEX  				;-1, move to next address   
	DECB  				;-1, # of bytes to check  
	BNE     L7346			;Bra if !=0, continue

	PULB				;# of bytes to check    
	TSTA    			;Test checksum
	BEQ     L735A			;Bra if ==0
;
	CLRA				;
; 
;-Clear RAM if checksum !=0
;   
L7351	INX     			;+1, step back to previous address
	STAA    0,X			;Clear address
	DECB    			;-1 from # of bytes
	BNE     L7351			;Bra if !=0, continue
;
	BSET    L003A,#$40		;Set b6, bad RAM checksum

L735A	LDAA    L4133			;Base SA
	CLRB				;    
	STD     L0219			;Save it, commanded SA

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Error count checking
;
;  Used to keep track of # times error 
;  flagged. If flagged certain # of times, 
;  perm. store error. Else, clear error this 
;  time around.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check error 21, Hi TPS, counter
;
	LDAA    L001F			;Error 21 counter
	BEQ     L736D			;Bra if ==0
               
	CMPA    L5B1E			;Threshold to set error 21
	BCC     L736D			;Bra if >=  
;							                
	DECA				;-1, error 21 counter                 
	STAA    L001F			;save it
;
;-Check error 22, low TPS, error
;
L736D	LDAA    L0020			;Error 22 counter
	BEQ     L7379			;
											
	CMPA    L5B21			; 
	BCC     L7379			;
;                 
	DECA				;     
	STAA    L0020			;
;
;-Check error 24 low output trans speed, counter
;
L7379	LDAA    L0021			;Error 24 counter
	BEQ     L7385			;
;							                                
	CMPA    L5B42			;
	BCC     L7385			;
;							                              
	DECA				;       
	STAA    L0021			;
;
;-Check error 28, man. pressure switch, counter
;
L7385	LDAA    L0022			;Error 28 counter
	BEQ     L7391			;
;                
	CMPA    L5B52			;
	BCC     L7391			;
;							                                
	DECA				;    
	STAA    L0022			; 
;
;-Check error 37, brake on, counter
;
L7391	LDAA    L0023			;Error 37 counter
	BEQ     L739D			;
;							                                
	CMPA    L5B58			; 
	BCC     L739D			; 
;							                                 
	DECA				;        
	STAA    L0023			; 
;
;-Check error 38, brake off, counter
;
L739D	LDAA	L0024			;Error 38 counter
	BEQ     L73A9			;
;							                                 
	CMPA    L5B5E			;
	BCC     L73A9			; 
;							                               
	DECA				;       
	STAA    L0024			;
;
;-Check error 68, trans. slipping, counter
;
L73A9	LDAA    L0025			;Error 68 counter
	BEQ     L73B5			;
;							                                
	CMPA    L5B78			;
	BCC     L73B5			;
;							                               
	DECA				;     
	STAA    L0025			;

;-Check error 66, 3-2 shift quad dvr. fail, counter
;
L73B5	LDAA    L0026			;Error 66 counter
	BEQ     L73C1			;
;               
	CMPA    L5B72			;
	BCC     L73C1			;
;							                                 
	DECA				;    
	STAA    L0026			; 
;
;-Check error 67, TCC quad dvr. fail, counter
;
L73C1	LDAA    L0027			;Error 67 counter
	BEQ     L73CD			;
;                
	CMPA    L5B74			;
	BCC     L73CD			;
;							                              
	DECA				;       
	STAA    L0027			;
;
;-Check error 68 counter
;
L73CD	LDAA    L0028			;Error 68 counter
	BEQ     L73D9			; 
;             
	CMPA    L5B79			; 
	BCC     L73D9			; 
							                              
	DECA				;          
	STAA    L0028			; 
;
;-Check error 72, output spd loss, counter
;
L73D9	LDAA    L0029			;Error 72 counter
	BEQ     L73E5			;
;              
	CMPA    L5B8B			; 
	BCC     L73E5			;
;            
	DECA				;    
	STAA    L0029			; 
;
;-Check error 73, force motor current, error
;
L73E5	LDAA    L002A			;Error 73 counter
	BEQ     L73F1			;
;                 
	CMPA    L5B8F			; 
	BCC     L73F1			; 
;                
	DECA				;
	STAA    L002A			; 
;
;-Check error 81, quad dvr. 1 & shif B err., counter
;
L73F1	LDAA    L002B			;Error 81 counter
	BEQ     L73FD			;
;                
	CMPA    L5B9D			;
	BCC     L73FD			;
;                
	DECA				;    
	STAA    L002B			; 
;
;-Check error 82, quad dvr. 1 & shift A err., counter
;
L73FD	LDAA    L002C			;Error 82 counter
	BEQ     L7409			; 
;							                                 
	CMPA    L5B9F			;
	BCC     L7409			;
;							                                 
	DECA				;     
	STAA    L002C			;  
;
;-Check error 83, quad dvr. 1 error, counter 
;
L7409	LDAA    L002D			;Error 83 counter
	BEQ     L7415			;
;                
	CMPA    L5BA1			; 
	BCC     L7415			;
;                 
	DECA				; 
	STAA    L002D			; 
;
;-Check error 85 counter
;
L7415	LDAA    L002E			;Error 85 counter
	BEQ     L7421			;
;               
	CMPA    L5BA2			;
	BCC     L7421			;
;                 
	DECA				;
	STAA    L002E			; 
;
;-Check error 86, low ratio, counter
;
L7421	LDAA    L002F			;Error 86 counter
	BEQ     L742D			; 
;                 
	CMPA    L5BA8			;
	BCC     L742D			;
;                 
	DECA				;    
	STAA    L002F           	;
;
;-Check error 87, high ratio, counter 
;           
L742D	LDAA    L0030			;Error 87 counter
	BEQ     L7439			;
;                
	CMPA    L5BAE			;
	BCC     L7439			;
;               
	DECA				;
	STAA    L0030			;
;
;-Check error 89, Max adpt long shift, counter
;
L7439	LDAA    L0031			;Error 89 counter
	BEQ     L7445			; 
;               
	CMPA    L5BB8			;
	BCC     L7445			;
;                 
	DECA				;   
	STAA    L0031			;

L7445	BRCLR   L001E,#$04,L7457	;Error word #9, bra if b2==0, no error 89 flagged
;
;-Error 89 flagged
;
	LDAA    L0031			;Error 89 counter
	CMPA    L5BB8			;Compare to threshold to set error
	BCC     L7457			;Bra if >=, set error
;
;-Not setting error here
;											
	INCA    			;+1
	INCA  				;+1  
	STAA    L0031			;Save it, error 89 counter
	BCLR    L001E,#$04      	;Clear b2, not setting error yet
;
;-Here if perm. setting error, continue
;
L7457	BCLR    L0019,#$04		;Clear b2, error 45, O2 rich
	BCLR    L0019,#$02		;Clear b1, error 46, VATS
;
;-Check if TCC present
;
	LDX     #L400F			;Option byte, 0000 1000  
	BRCLR   0,X,#$80,L7467		;Bra if b7=0, TCC present
;
;-No TCC here, dont set VSS error
;
	BCLR    L0017,#$20         	;Clear b5, ERR 24, Low VSS if no TCC present
;
;------------------------------------
; CK ERR CNT'S
; AND ??? to B IF ERROR > THRESH 
;------------------------------------
;                  
;-----------------------
; XMISH ERR HANDER
; MAX ADP LONG SHIFT
; ERR 89 (L5BB5)
;-----------------------
;
L7467	LDX	#L5B00			;Start of diag. word masks
	LDAA    L0032			; ERR 89 CNT'S
	CMPA    $B5,X			; IF ERR CNT'R G.T. 0 SET ERR 89, 
	BCS     L7472			; (1 -> 2) 
;											; .. else
	STAB    L0032			; ERR 89 CNT'S                 
;
;-----------------------
; MAX ADP LONG SHIFT
; ERR 89 (L5BB6) 
;-----------------------
;
L7472	LDAA    L0033			; ERR 89 CNT'R, IF ERR CNT'R G.T. 0 SET ERR 89
	CMPA    $B6,X			; (2 -> 3)
	BCS     L747A			; ... else                 
;							                
	STAB    L0033			; SAVE ERR 89 CN'S
;
;-----------------------
; MAX ADP LONG SHIFT
; ERR 89 (L5BB7) 
;-----------------------
;
L747A	LDAA    L0034			; ERR 89 CNT'R 
	CMPA    $B7,X			;
	BCS     L7482			;
;
	STAB    L0034			; ERR 89 CNT'R
;									
;-----------------------
; MAX ADP LONG SHIFT
; ERR 89 (L5BB7) 
;-----------------------
;
L7482	LDAA    L082E			;A/D MAP, A/D conv.
	STAA    L01E9			;A/D MAP
;
;~~~~~~~~~~~~~~~~~~
;-Do S/D MAP conv.
;~~~~~~~~~~~~~~~~~~
;         
;S/D MAP=(151x(MAP-26))/128 
;
	STAA    L01E6			;A/D MAP, filtered
	SUBA    #26			;A/D MAP-26
	LDAB    #151			;
	MUL				;151x(A/D MAP-26)
	ADDD    #64			;+64 to round if needed
	ASLD				;x2
	BCC     L7499			;Bra if no overflow
;										
	LDD     #$FFF			;Clear overflow
;
L7499	STAA    L01E3			;Save it, SD MAP
	STAA    L01EA			;Save it, SD MAP, filtered
;
	JSR     LC45F			;Baro init and lookup routine


	BSET    L004E,#$01		;Set b0=
	BSET    L0043,#$80		;Set b7=
;	
	BCLR    L0004,#$10		;Clear b4, hot restart in effect
;
	LDAA    L0006			;Cool temp, linear
	PSHA				;To the stack    
	JSR     LC78A			;Cool temp lookup routine		
;
	JSR     LC805			;Routine to do look ups based on cool temp.
;
	JSR     LC879			;Routine to do lookups related to SA and knock						

	LDAA    L0006			;Cool temp, linear
	STAA    L02A5			;Initial cool temp (engine off)
;
	PULB				;Get coolant back
	CMPB    L4950			;95 Deg c, previous run temp, min temp for hot restart
	BCS     L74CA			;Bra if cool temp is <
;											
	CMPA    L4951			;110 Deg c, min temp for hot restart 
	BCS     L74CA			;Bra if cool temp is <
;
	BSET    L0004,#$10		;Status word, non-vol. ram, set b4=hot restart
;
L74CA	JSR     L9341			;Power-on idle initialization routine
;
;-Init O2
;
	LDAA    L48B4			;450 mV, O2 init value 450 Mv
	STAA    L01F8			;A/D O2 volts
	STAA    L01F3			;Filtered O2
	STAA    L01F5			;Slow filtered O2 volts (based on airflow)
	JSR     LB24D			;Idle %TPS routine
;
	JSR     LB185			;Do trans. tps based params.
;
;-Init TPS
;
	LDAA    L01FC			;TPS
	STAA    L01FF			;AE TPS, filtered per cool temp			
	STAA    L01FD			;(???)
	STAA    L01FE			;TPS, one delayed
	STAA    L0201			;slow filtered %TPS
;
	LDAA    L489B			;Max position for closed EGR pintle
	STAA    L01D8			;Save it, closed EGR pintle pos.
	JSR     LD075			;Linear EGR routine
;
	LDAA    L0192			;Cool temp
	CLRB    			;Clear LSB
	STD     L0193			;
	JSR     L755E			;
;
	CLRB				;    
	LDAA    L00A2			;Load linear cool temp
	CMPA    L4071			;Threshold to init cat temp to default value
	BCS     L750C			;Bra if cool temp less then threshold
;
;-Cool temp > threshold, init cat temp to default val, otherwise, clear cat temp 
;
	LDAB    L4072			;Cat init temp when cool temp is hot
;
L750C	STAB    L0078			;Cat temp
	LDD     L3FCA			;EST circuit info
	STD     L0228			;Store it, EST circuit info
;
	LDD     L3012			;TIC 2
	STD     L0851			;TIC 2 result
;
	LDAA    L48DD			;14.7:1, stoich AFR
	STAA    L026D			;AFR
	LDAA    #$0E			;dec 14
	STAA    L0002			;Loop counter
	LDAA    #128			;
	STAA    L026B			;BLM multiplier
	LDAA    #$14			;dec 20
	STAA    L0049			;Major loop counter
	JSR     LEF2B			;BLM clamp routine
;
;-Do COP
;
	LDAA    #$55			;0101 0101
	STAA    L303A			;COP reset reg
;
	LDAA    #$AA			;1010 1010
	STAA    L303A			;COP reset reg
;
	LDAA    #$40			;0100 0000 
	STAA    L004C			;Port C
;
	BRCLR   L0004,#$08,L7548	;Status word, bra if b3==0, last shut down
;
;-Bad shutdown
;									
	LDAA    L4D8C			;Init value for DRP counter on bad shutdown
	STAA    L02F1			;Stored DRP counts.
;
;-Here if no bad shutdown
;
L7548	LDAA    #255			;1111 1111
	STAA    L3023			;Timer interrups flag register 1
;
;-Set TOC 3 value
;
	LDD     L300E			;16 bit free running CPU counter
	ADDD    #$08			;
	STD     L301A			;Save it, Timer output compare 3
;
	LDAA    #$A0			;1010 0000
	STAA    L3022			;Timer interrupt mask reg. 1
;
	JMP     L7BE6			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; (???)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L755E	CLR     L012E			;
	CLRB 				;   
	LDAA    #$51			;
	CMPA    #$51			;
	BCS     L756A			;Bra if <=

	BRA     L756C			;

L756A	LDAA    #$51			;
;
L756C	STAA    L012F			;
	STD     L306C			;
;
	LDAA    #$01			;Set b1, normal shift pattern requested
	STAA    L0099			;Trans shift pattern word
;
	LDD     #$DFFF			;
;
	LDX     #L400F			;Option byte 
	BRCLR   0,X,#$40,L7583		;Bra if b6==0, using electronic trans 
;																	; 
	LDD     #$D000			;
;
L7583	STD     L3FCC			;
	JSR     LF08A			;RTS, delay
;
	LDD     #$D000
	STD     L3FEA
	JSR     LF08A			;Short delay
;
	LDAA    #$02			;2nd gear
	STAA    L00D3			;Gear number 
	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; DRP/crank fuel/injector handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7597	BRCLR   L0044,#$01,L759E	;Bra if b0==0, factory test not requested
;
;~~~~~~~~~~~~~~~~~~~~~~~~		
; Factory test requested
;~~~~~~~~~~~~~~~~~~~~~~~~
;
	JMP     LF8BB			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; No factory test req., continue
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L759E	LDD     L300E			;Load 16 bit free running counter
	PSHB 				;Push counter to stack   
	PSHA				;    
;
;-Look up knock window delay time vs RPM
;
	LDAB    L0062			;RPM/25
	LSRB				;/2
	ANDB    #$FE			;Clear b0, double byte offset
	LDX     #L4653			;Knock window delay time vs. RPM
	ABX				;Add offset into X     
	PULA				;Get free running counter val. back    
	PULB 				;   
	ADDD    0,X			;Add in delay to counter
	STD     L3016			;Save it Timer output compare 1
;
	LDX     #L3062			;I/O port D
	BCLR    0,X,#$40		;Clear b6
	BSET    0,X,#$40		;Set b6
;
	BRSET   L0044,#$10,L75C3	;Bra if b4==1, ignition off
;											
	BSET    L0050,#$20		;Set b5, DRP ocured 
;
L75C3	LDAB    #255			;1111 1111
	STAB    L306F			;Hardware, fuel pump relay control
	BRCLR   L0050,#$01,L75DB	;Bra if b0==0, dont read in MAP yet
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Read in A/D channel 5, MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    #$05			;0000 0101, A/D channel 5
	STAA    L3030			;A/D control reg 
	ASLD				;33 cycle delay for A/D channel conv.    
	MUL 				;    
	MUL     			;
	MUL     			;
	LDAA    L3031			;Get A/D MAP
	STAA    L082E			;Save it, A/D MAP val.
;
L75DB	BRCLR   L004F,#$10,L75E2	;Bra if b4==0, engine not above crank to run threshold
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine above crank to run threshold
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	JMP     L76FD			;Transition from crank to run
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine not yet above crank to run threshold here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L75E2	LDD     L0068			;Filtered RPM/6.26
	STD     L006A			;Delayed filtered RPM/6.25  
	BRSET   L0044,#$10,L75F5	;Status word, bra if b4==1, ignition off
;
;-Here if not shutting down
;										
	LDAB    L02F0			;DRP counter
	INCB				;+1
	BEQ     L75FF			;Bra if roll-over
;										
	STAB    L02F0			;Save it, DRP counter
	BRA     L75FF			;Bra to continue
;
;-Here if shutting down/not time for fuel yet
;
L75F5	LDX     #L3000			;Load base CPU reg addr.
;											
	LDAA    #$01			;0000 0001
	STAA    $23,X			;Reset TIC3 flag, TFLG1 reg.
	JMP     L7873			;Return from interrupt
;
;-Here if not shutting down
;
L75FF	LDAA    L0006			;Cool temp, linear
	LDX     #L4DC3			;Crank fueling delay vs. cool temp table
	JSR     LF15E			;2D lookup
;							 
	CMPA    L02F0			;DRP counter
	BCC     L75F5			;Bra if DRPs less, Reset TIC3/TFLG1 and RTI
;
;-Here if its time to run the loop
;
	LDX     #L400C			;Opt. byte 
	BRCLR   0,X,#$04,L7626		;Bra if b2==0, dont fire all inj. each DRP
;
	LDD     L02F2			;PW
	JSR     L78D4			;Cranking PW correction routine
	STD     L026F			;Sync BPW
	LDX     #L400B			;Opt. byte
	BRSET   0,X,#$10,L7629		;Bra if b4==1, async. double fire 
;
	JMP     L76D7			;Output BPW to harware and continue
;
L7626	JMP     L76DD			;Continue 
;
;-Check for err 41, cam sensor
;
L7629	BRCLR   L0019,#$40,L7634	;Err. word #4, bra if no error 41, 1x cam sens.
;
;-Here if err. 41
;										
	LSRD				;PW/2 for double fire
	STD     L026F			;Save it, BPW
	JMP     L76D7			;Output to hardware and contine
;
;-Here if err. 41 not set
;
L7634	ADDB    L0279			;Add in bias to comp. for batt volts
	ADCA    #0			;Perform carry if needed
	BPL     L763E			;Bra if < 32767
;											
	LDD     #$7FFF			;Clear overflow
L763E	STD     L0273			;Save it, TOC 5 value	 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Handle startup injector firings
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L3000			;Base CPU reg. addr.										;
	BRSET   $23,X,#$01,L76A4	;Bra if edge detected for TIC3, do TOC 4
;										
	LDAA    L02F0			;DRP counter
	CMPA    #$01			;
	BNE     L7654			;Bra if !=1
;											
	BSET    L0053,#$20		;Status word, set b5, inj. firing pending											
	BRA     L7678			;
											
L7654	BRCLR   L0053,#$20,L7678	;Bra if injector firing is not pending
;	
;-Injector firing is pending 
;										
	PSHX 				;Push CPU addr, to stack
	LDX     #L0273			;Addr. of TOC 4/5 val
	LDAA    L4956			;Crank BPW mult. for 2nd inj. firing
	JSR     LF1ED			;8x16 mult. routine
;											
	PULX				;Get base CPU addr. back
	ASLD				;BPW x 2
	BCC     L7669			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L7669	STD     L0273			;Save as TOC 4/5 value											
	LDAA    L02F1			;DRP counter
	DECA				;-1, maintain at zero
	CMPA    #255			;Check for underflow
	BNE     L7675			;Bra if no underflow
											
	INCA				;+1 
;   
L7675	STAA    L02F1			;DRP counter
;
;-Here if DRPs > 1/no inj. firing pending
;
L7678 	BSET    $20,X,#$03		;TCTL1, set TOC 5 output line to 1
	BSET    $0B,X,#$08		;CFORC, force output level for TOC 5
	JSR     L7907			;Check for cam sens. error
;											
	LDD     L0273			;TOC 4/5 value
	ASLD				;x2, double counts to match free running counter
	BCC     L768A			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L768A	ADDD    $0E,X			;Add in free running counter
	STD     L0825			;Save it, outputted val. to TOC 5											
	BCLR    $20,X,#$01		;Clear b0, set TOC 5 output line to 0										
	LDD     $0E,X			;16 bit free running timer
	ADDD    #$02			;+2
	CPD     L0825			;TOC 5 value
	BPL     L76A0			;Bra if interrupt not pending
;											
	LDD     L0825			;Load previous value instead
;
L76A0	STD     $1E,X			;Save it, TOC 5 
	BRA     L76DD			;Bra to continue			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if edge detected for TIC3
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L76A4	LDAA    #$01			;0000 0001
	STAA    $23,X			;Reset TIC3 flag, TFLG1 reg.
	CLR     L084E			;Err. 41 counter
;											
	BSET    $20,X,#$0C		;Set b2,b3, set TOC3 on successful compare, 
	BSET    $0B,X,#$10		;Set b4, force compare for TOC4 
;											
	BCLR    L0053,#$20		;Status word, clear b5, injector fired at first DRP 
;											
	LDD     L0273			;TOC 4/5 value
	ASLD				;x2, double counts to match free running counter
	BCC     L76BD			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L76BD	ADDD    $0E,X			;Add in 16 bit free running counter
	STD     L0827			;Save as TOC 4 value
;											
	BCLR    $20,X,#$04		;Clear TOC 4 line on interrupt
;											
	LDD     $0E,X			;16 bit free running counter
	ADDD    #$02			;+2 counts
	CPD     L0827			;TOC 4 value
	BPL     L76D3			;Bra if >=
;											
	LDD     L0827			;Load TOC 4 instead if still pending
;
L76D3	STD     $1C,X			;Save it, TOC 4 timer val.
	BRA     L76DD				
;											
L76D7	LDD     L026F			;Sync BPW
	JSR     L862B			;Output BPW to hardware
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to increment DRP counter and limit in case of FP relay failure
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L76DD	LDAA    L02F1			;Load DRP counter
	INCA				;+1
	BNE     L76E5			;Bra if no roll-over
;											
	LDAA    #$F0			;Reset to 240 after roll-over
;
L76E5	STAA    L02F1			;Save it
	LDAB    L0055			;Load fuel pump volts
	CMPB    L4D8E			;Lower voltage threshold for fuel pump functioning
	BHI     L76FA			;Bra if greater then threshold
;	
	CMPA    L4D8D			;Upper counts limit when pump volts low/zero
	BLS     L76FA			;Bra if counter is less
;											
	LDAA    L4D8D			;Load max
;
	STAA    L02F1			;Save it, cranking fuel counter #2
L76FA	JMP     L7873			;Return from interrupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to transition from crank to run
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L76FD	LDAA    L02EC			;AFR crank transition AFR
	BEQ     L7743			;Bra if ==0
;											
	LDAA    L028B			;Elapsed DRPs 
	INCA				;+1
	BEQ     L770B			;Bra if roll-over
;											
	STAA    L028B			;If no roll-over, save it
;
;-Look up transition decay delay DRP value 
;
L770B	LDX     #L4CB5			;Addr. of table
	LDAA    L0006			;Load cool temp, linear
	JSR     LF15E			;2D look up
;
	TAB				;Looked up val. to B   
;
;-Transition decay delay multiplier 
;
	LDX     #L4CC6			;Table addr.
	LDAA    L02F1			;Stored DRP counts
	ASLA				;x2
	ASLA				;x2   
	BCC     L7720			;Bra if no overflow
											
	LDAA    #255			;Clear overflow
;
L7720	JSR     LF15E			;2D lookup
	MUL				;
;
;-# of elapsed DRPs to delay = (DRPs x delay multipier)/256 
;				 
	CMPA    L028B			;Elapsed DRPs
	BCC     L7743			;Bra if timer <=
;
;-Run the routine on every third count of L081E, skip otherwise
;										
	INC     L081E			;+1, execution delay timer
	LDAA    L081E			;exec. delay timer
	CMPA    L495A			;# counts to run routine
	BCS     L7743			;Bra if timer less, skip transition adj.

	CLR     L081E			;Reset timer for next pass
	LDAA    L02EC			;AFR crank transition ratio
	SUBA    L028A			;Sub. AFR decay rate vs cool temp
	BCC     L7740			;Bra if no underflow
;										
	CLRA 				;Clear underflow   
;
L7740	STAA    L02EC			;AFR crank transition ratio
;
L7743	LDAA    L400C			;Option byte  
	BITA    #$08			;Test b3, Asnyc/single fire 
	BEQ     L7786			;Bra if ==0, Async fueling instead
;	
;~~~~~~~~~~~~~~~~~~~~
; Here if CPI in use
;~~~~~~~~~~~~~~~~~~~~
;										
	BRSET   L0019,#$40,L7786	;Bra if b6==1, err 41, 1x cam sensor 
;										
	BRSET   L0051,#$01,L7767	;Status word, bra if b0==1, in single fire mode 
;											
	BRCLR   L0053,#$40,L77C9	;Status word, bra if b6==0, 1=Single fire alt. exit desired
;									
	BCLR    L0053,#$40		;Clear b4, single fire alt exit desired
;
	LDD     L0277			;Sync. BPW
	ASLD 				;x2 for single fire mode
	BCC     L7762			;Bra if no overflow
										
	LDD     #$FFFF			;Clear overflow
;
L7762	STD     L0277			;Save it BPW
	BRA     L77AF			;Bra to continue if BPW maxed out
;
;-Here if in single fire
;
L7767	INC     L0829			;+1, DRP counter
	LDAA    L0829			;DRP counter
	CMPA    #$03			;3 DRPs
	BCC     L7789			;Bra if >=
;
;-Check for async/single fire mode
;
	LDD     L0277			;Sync. BPW
	CPD     L4920			;Threshold for double to single fire mode
	BCS     L77C9			;Bra if BPW less
;
;-In sync/double fire mode here
;											
	LDAA    L0829			;Load DRP counter
	CMPA    #$01			;1 DRP
	BNE     L77BF			;Bra if !=
;
	BSET    L0053,#$40		;Set b6, single fire alt. exit desired
	BRA     L77BF			;	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if tbi in use instead
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
;
L7786	JMP     L7812			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if 3 or more DRPs have occured
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7789	LDX     #L3000			;Load base CPU reg. addr.
					;
	LDAA    #$01			;Set b0, TIC 3 flag
	STAA    $23,X			;Save it, timer interrupts flag reg. 1
;											
	LDD     L0277			;sync BPW
	CPD     L4920			;Threshold for single to double fire mode 
	BCC     L77A5			;Bra if sync BPW is >
;		
;-Still in single fire mode
;									
	LDAA    L0829			;DRP counter
	CMPA    #$04			;4 drps to reset counter
	BNE     L7812			;Bra if !=, continue
;											
	CLR     L0829			;Clear DRP counter
	BRA     L7812			;Bra to continue
;
;-Above threshold to transition to double fire mode
;
L77A5	LDAA    L0829			;DRP counter		
	CMPA    #$04			;4 DRPs
	BNE     L77AF			;Bra if !=
;											
	BSET    L0053,#$40		;Set b6, single fire alt. exit desired

L77AF	LDD     L0277			;BPW
	ADDB    L0279			;Batt volts BPW correction
	ADCA    #$0000			;round if needed
	BPL     L77BC			;Bra if no signed overflow

	LDD     #$7FFF			;Load max BPW
;
L77BC	STD     L0273			;TOC 4/5 value
;
L77BF	BCLR    L0051,#$01		;Status word, clear b0, CPI single fire mode
	CLRA 				;   
	STAA    L082A			;Time in double fire mode
	STAA    L0829			;DRP counter
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Transition from double to single fire mode
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L77C9	LDY     #L400B			;Load option byte
	BRSET   0,Y,#$20,L77D5		;Bra if b5==1, 180 deg offset
;											
	BSET    L0051,#$80		;Set b7, transition from double to single fire mode
;											
L77D5	LDX     #L3000			;Load base CPU reg. addr.
	BRCLR   $23,X,#$01,L77F9	;Bra if TIC 3 flag not set
;											
	LDAA    #$01			;
	STAA    $23,X			;Reset TIC 3 
	CLR     L084E			;Err. 41 counter 
	BRSET   0,Y,#$20,L7801		;Bra if b5==1. 180 deg offfset
;
;-No offset
;											
L77E8	JSR     L78A4			;Routine to set up TOC 4 interrupt
;										
	BRSET   L0051,#$80,L7812	;Bra if transition already flagged
;											
	BSET    L0051,#$80		;Set b7, transition in progress
;		
	CLRA				;Clear time based delay for next pass
	CLRB				;
	STD     L081F			;Time based delay for injector firing
	BRA     L7801			;Bra to continue				
;											
	JSR     L7907			;Routine to check for cam sens. error
;											
	BRSET   0,Y,#$20,L77E8		;Bra if b5==1, 180 deg offset
											
L7801	JSR     L7874			;Routine to set up for TOC 5 interrupt
;											
	BRSET   L0051,#$80,L7812	;Status word, bra if b7==1, transitioning from
					;double to single fire mode
;											
	BSET    L0051,#$80		;Set b7, transition in progress					
	CLRA				;
	CLRB				;
	STD     L081F			;Clear time delay for injector firing
	BRA     L77E8			;Bra to continue				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue and return from interrupt
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;			
L7812	LDD     L3FFA			;CPU status
	ORAA    L0073			;CPU status word
	BCLR    L0073,#$40		;CPU status word, clear b6
;											
	BITA    #$40			;Test b6
	BEQ     L7873			;Bra if ==0, return											
;
;-Check quals for limiting RPM derivative term
;
	LDAB    L0067			;RPM/6.25
	CMPB    L450C			;Upper RPM limit for derivative RPM term
	BCS     L783B			;Bra if RPMs <
;
	LDAB    L01FC			;%TPS
	CMPB    L48D0			;TPS threshold for idling
	BHI     L783B			;Bra if TPS >, limit derivative term											
;
;-Filter RPM derivative term
;
	LDD     L0068			;Filtered RPM/6.25
	LDX     #$006A			;Delayed filtered RPM/6.25
	LDY     #L450E			;Filter coeff.
	JSR     LF116			;Lag filter routine
;
	BRA     L783D			;Bra to save
;
;-Here to skip filtering
;
L783B	LDD     L0068			;Filtered RPM/6.25
;
L783D	STD     L006A			;Save it, delayed filtered RPM
	LDAA    L400B			;Opt. byte
	BITA    #$01			;Test b0
	BEQ     L7873			;Bra if not in CPI/PFI mode
;
;-In CPI/PFI mode here
;
	LDAA    L400C			;Opt byte 
	BITA    #$08			;Test b3
	BEQ     L7851			;Bra if async double fire mode
;
	BRCLR   L0019,#$40,L7873	;Err. word, bra if b6==0, no err. 41 
;											
L7851	BRCLR   L0051,#$01,L7865	;Bra if b0==0, not in single fire mode
;											
	BRCLR   L003F,#$10,L7870	;Status word, bra if b4==0, sync/async flag
;
;-Check if ok to exit single fire mode
;											
	LDD     L0277			;BPW
	CPD     L4920			;Threshold to go from single to double fire mode
	BLS     L7865			;Bra if BPW <=
;
;-Here to exit single fire
;
	BCLR    L0051,#$01		;Status word, clear b0, not in single fire mode
;
L7865	BCLR    L003F,#$10		;Clear b4, sync/async flag											;
	JSR     L7874			;Routine to set up for TOC 5 interrupt
	JSR     L78A4			;Routine to set up for TOC 4 interrupt
;					
	BRA     L7873			;Bra to return
;
L7870	BSET    L003F,#$10		;Set b4, sync/async flag
;
;-Jump here if ign. off
;										
L7873	RTI				;Return from interrupt     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to set up for TOC 5 interrupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7874	LDX     #$3000			;Base CPU reg. addr.
;
L7877	LDD     L081F			;Time based delay for inj. firing
	CPD     #$0006			;11.4 usec, min delay 
	BCC     L7883			;Bra if >=
;
	LDD     #$06			;Load min allow. value
;	
L7883	ADDD    $0E,X			;Add to 16 bit counter
	STD     L0821			;Save it, TOC 5 timer value
;											
	LDAA    #$08			;Set b3, Reset TOC 5
	STAA    $23,X			;TFLG1 reg.
;
	BSET    $22,X,#$08		;Set b3, TMSK1, req. TOC 5 interrupt
	BRCLR   0,X,#$08,L789B		;Bra if b3 of port A (TOC 5) ==0
;
;-Interrupt has already occured here
;											
	LDD     L0821			;TOC 5 counter val
	CPD     $1E,X			;Timer val at TOC 5 reg.
	BPL     L78A3			;Bra if >= TOC 5 timer val 
;
;-If previous interrupt not pending, reset and continue
;
L789B	BSET    $20,X,#$03		;Set b1, b0 of Timer Control Reg. 1 (TCTL1),
					;set output line to 1 on compare 						
	LDD     L0821			;TOC 5 counter value
	STD     $1E,X			;Save it TOC 5
;										
L78A3	RTS  				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 					
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to set up TOC 4 interrupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L78A4	LDX     #L3000			;Base CPU reg. addr.
	LDD     L081F			;Time based delay for inj. firing
	CPD     #$0006			;11.4 usec, min delay
	BCC     L78B3			;Bra if >=
;											
	LDD     #$06			;Load min allowed value
;
L78B3	ADDD    $0E,X			;Add in to free running counter val.
	STD     L0823			;Save it, TOC 4 counter val.
;											
	LDAA    #$10			;0001 0000
	STAA    $23,X			;Reset TOC 4, TFLG1 reg.
;											
	BSET    $22,X,#$10		;Set b4, TOC 4 interrupt req.
	BRCLR   0,X,#$10,L78CB		;Bra if b4 of port A (TOC 4) ==0
;
;-Interrupt has already occured here
;											
	LDD     L0823			;TOC 4 counter val.
	CPD     $1C,X			;Compare to timer val. @ TOC 4 reg
	BPL     L78D3			;Bra if >= TOC 4 
;
;-If previous interrupt not pending, reset and continue
;											
L78CB	BSET    $20,X,#$0C		;Set b2, b3 of Timer Control Reg. 1 (TCTL1),
					;set output line to 1 on compare 										
	LDD     L0823			;Load TOC 4 counter val 
	STD     $1C,X			;Save it, TOC 4 
;
L78D3	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Cranking PW correction routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L78D4	PSHB				;Push pulsewidth to stack  
	PSHA    			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Choose one of the below tables as the multipliers to use depending on the conditions
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L02F1			;Load stored DRP counts
	CMPB    #23			;23 counts
	BLS     L78E4			;Bra if counts <= 23
;
;-Counts > 23 here, use table to cycle the fueling
;											
	ANDB    #$07			;0000 0111, clear all but b0-b2, cycle crank fuel if cranking longer then this
;
;-Do cycling crank fuel mult. vs counts when counts > 23
;
	LDX     #L4E1C			;Addr. of cycling crank fuel mult. vs crank fuel counter
	BRA     L78F8			;Jump to do indexed lookup
;
;-Use hot restart crank fuel mult. if hot restart in effect
;
L78E4	LDX     #L4E04			;Addr. of hot restart crank fuel mult. vs cranking fuel counter									;
	BRSET   L0004,#$10,L78F8	;Bra if hot restart in effect, do lookup
;
;-Use cold crank mult. vs cranking counts if cool temp < 15 deg C
;
	LDX     #L4DEC			;Address of cold cranking mult. vs cool temp											;
	LDAA    L0006			;Cool temp, linear
	CMPA    L4D8F			;Lower threshold to use table
	BCC     L78F8			;Bra if cool temp is greater, do lookup
;
;-Use this table if cool temp >= 15 deg C
;
	LDX     #L4DD4			;Crank fuel mult. vs cranking counts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here to do indexed lookup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L78F8	ABX				;Add in cranking fuel counter #2
	LDAA    0,X			;Get address of mult. from selected table
	TSX				;Get current stack pointer into X
	JSR     LF1ED			;(A x X*)/256
;		
	PULX				;Clean up stack, get PW  back
	ASLD				;Result x 2, now (mult. x PW)/128 
	BCC     L7906			;Bra if no overflow, return
;											
	LDD     #$FFFF			;Clear overflow
;
L7906	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Error 41, cam pulse sensor fail
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7907	LDAA    L5B03			;Error mask 4
	BITA    #$40			;Test b6, error 41, cam pulse sens. fail
	BEQ     L7921			;Bra if not checking error, return
;											
	LDAA    L084E			;Error 41 counter
	CMPA    #255			;
	BEQ     L7919			;Bra if ==255, compare to threshold to set err
;											
	INCA				;+1, error 41 counter
;
	STAA    L084E			;Save it
L7919	CMPA    L4E65			;Threshold to set error
	BLS     L7921			;Bra if less dont set error yet
;
;-Error counter above threshold
;
	BSET    L0019,#$40		;Set b6, error 41, 1x cam sens. 
;
L7921	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; TOC 5 interrupt routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7922	LDX     #L3000			;Base CPU adr.
	LDAA    #$08			;Set b3, clear TOC 5 flag
	STAA    $23,X			;TFLG1 reg.
;
;-TOC 5 line ==1, reset TOC
;
	BRCLR   0,X,#$08,L7972		;Reg A, bra if TOC 5 line ==0
;											
	BCLR    $22,X,#$08		;TMSK1 reg, clear b3==0, disable TOC 5 interrupt
	BCLR    $20,X,#$01		;TCTL1 reg, clear b1, clear TOC 5 line on inter.
;
	BRCLR   L0046,#$01,L7954	;Status word, bra if ==0, no sync AE this pass
;
;-Here if sync AE requested
;

	LDD     L0273			;TOC 4/5 value
	ADDD    L025D			;Add in stored async pulse time for sync output
	BCS     L7942			;Bra if overflow 
;											
	ASLD				;x2 for single injector firing
	BCC     L7945			;Bra if no overflow
;										
L7942	LDD     #$FFFF			;Clear overflow
;
L7945	ADDD    $1E,X			;Add in TOC 5 value
	STD     L0825			;TOC 5 counter value
	CLRA				; 						  
	CLRB				;
	STD     L025D			;Clear stored async pulse time, outputted to injectors
;
	BCLR    L0046,#$01		;Status word, clear b0, reset sync AE flag
	BRA     L7962			;				
;
;-No sync AE this pass
;		
L7954	LDD     L0273			;TOC 4/5 value
	ASLD				;x2, match free running counter
	BCC     L795D			;Bra if no overflow
;				
	LDD     #$FFFF			;Clear overflow
;
L795D	ADDD    $1E,X			;Add in TOC 5 reg.
	STD     L0825			;TOC 5 timer value
;
L7962	LDD     $0E,X			;Free running CPU counter
	ADDD    #$02			;+2 counts
	CPD     L0825			;TOC 5 counter value
	BPL     L7983			;Bra if interrupt not pending
;
;-Interrupt pending
;											
	LDD     L0825			;Load TOC 5 value
	BRA     L7983			;Bra to store and return				
;									
L7972	BSET    $20,X,#$01		;TCTL1 reg, set b0, set TOC 5 line on inter.
	LDD     $0E,X			;Free running CPU counter
	ADDD    #$02			;+2 counts
	CPD     L0821			;TOC 5 counter value
	BPL     L7983			;Bra if interrupt not pending
;			
	LDD     L0821			;Load TOC 5 counter value				
;
L7983	STD     $1E,X			;Save it, TOC 5
	RTI				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; TOC 4 interrupt routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7986	LDX     #L3000			;Base CPU reg.
	LDAA    #$10			;0001 0000, clear TOC 4 flag
	STAA    $23,X			;TFLG 1 reg  
	BRCLR   0,X,#$10,L79D6		;Reg A, bra if TOC 4 line ==0
;
;-TOC 4 line ==1, reset TOC
;											
	BCLR    $22,X,#$10		;TMSK1 reg, clear b4==0, disable TOC 4 interrupt
	BCLR    $20,X,#$04		;TCTL1 reg, clear b2, clear TOC 4 line on inter.
;
	BRCLR   L0046,#$01,L79B8	;Status word, bra if ==0, no sync AE this pass
;
;-Here if sync AE requested
;
	LDD     L0273			;TOC 4/5 value
	ADDD    L025D			;Add in stored async pulse time for sync output
	BCS     L79A6			;Bra if overflow
;											
	ASLD				;x2 for single injector firing
	BCC     L79A9			;Bra if no overflow
;											
L79A6	LDD     #$FFFF			;Clear overflow
;
L79A9	ADDD    $1C,X			;Add in TOC 4 timer value
	STD     L0827			;TOC 4 counter value
	CLRA				;
	CLRB				;
	STD     L025D			;Clear stored async pulse time
	BCLR    L0046,#$01		;Status word, clear b0, reset sync AE flag
	BRA     L79C6			;
;
;-No sync AE this pass
;
L79B8	LDD     L0273			;TOC 4/5 value
	ASLD				;x2, match free running counter
	BCC     L79C1			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L79C1	ADDD    $1C,X			;Add in TOC 4 reg.
	STD     L0827			;TOC 4 timer value
											
L79C6	LDD	$0E,X			;CPU counter
	ADDD    #02			;+2 counts
	CPD     L0827			;TOC 4 counter value
	BPL     L79E7			;Bra if interrupt not pending
;
;-Interrupt pending
;											
	LDD     L0827			;TOC 4 counter value
	BRA     L79E7			;Bra to save and return
;
L79D6	BSET    $20,X,#$04		;TCTL1 reg, set b2, set TOC 4 line on inter.
	LDD     0E,X			;Free running CPU counter
	ADDD    #$02			;+2 counts
	CPD     L0823			;TOC 4 counter value
	BPL     L79E7			;Bra if interrupt not pending
;
;-Interrupt pending
;											
	LDD     L0823			;Load TOC 4 counter value
;
L79E7	STD     $1C,X			;Save it, TOC 4
	RTI				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   					
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; Main vector handler
; 
;-Run every 6.25 msec
;
;~~~~~~~~~~~~~~~~~~~~~~
;
;-Set up for next interrupt
;
L79EA	LDD     L301A			;TOC 3 reg
	ADDD    #0819			;819, 6.25 msec
	STD     L301A			;Save it, time to next TOC 3 interrupt

	LDAA    #$20			;0010 0000, Reset TOC 3 flag
	STAA    L3023			;TFLG 1 reg.
	BSET    L0000,#$01		;Set b0, 
;
;-Check for factory test
; 
	BRCLR   L0044,#$01,L7A05	;Status word, bra if b0==0, no factory test req.
;
;-Factory test req.
;
	INC     L0002			;Loop count			
	JMP     LF705			;Go do factory test
;
;-No factory test req., check for loop overrun
;
L7A05	BRSET   L003A,#$20,L7A17	;Status word, bra of b5==1, loop overrun already flagged  
	BRCLR   L004F,#$04,L7A14	;Status word, bra if b2==0, loop didnt overrun 
;
;-Here if loop overran
;											
	LDAA    L0002			;Loop counter
	STAA    L0003			;Loop counter, one delayed
	BSET    L003A,#$20		;Status word, set b5, loop overrun flagged 
;
L7A14	BSET    L004F,#$04		;Status word, reset b2, loop overrun flag
;
L7A17	TSX				;Get stack pointer into X
	CPX     #L03F7			;
	BEQ     L7A20			;
;											
	BSET    L003A,#$08		;Status word, set b3==1, 
;
L7A20	LDS     #L03FF			;Load stack @ 0x3FF
	BRCLR   L003B,#$10,L7A3B	;Serial data status word, bra if b4==0, not in mode 4 
;	
;-In mode 4, check and enable SES light if requested
;										
	LDAB    L0390+1			;Load in data from ALDL diag. data buffer (ALDL output
					;enables)
	BITB    #$04			;Test b2
	BEQ     L7A3B			;Bra if ==0, no discrete enables
;											
	BCLR    L0072,#$80		;Status word, clear b7, turn off SES light
;
	LDAB    L0390+2			;Load in data from ALDL diag. data buffer (ALDL output
					;states)
	BITB    #$04			;Test b2
	BEQ     L7A3B			;Bra if ==0, no request to turn on SES light
;
	BSET    L0072,#$80		;Status word, set b7, turn on SES light
;
L7A3B	JSR     L9286			;IAC control routine	
;
	JSR     LF08B			;I/O routine
;
	LDAA    L082E			;A/D MAP val.
	LDAB    L006F			;Status word
	BITB    #$48			;Test b6=High MAP err, b3=Low MAP err.
	BEQ     L7A73			;Bra if ==0, no map errors set
;
	BRCLR   L004F,#$10,L7A70	;Status word, bra if b4==0, engine off/cranking
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Low/High map errors set, generate default MAP val.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
	LDAA    L4E5F			;Load TPS coeff. for default MAP
	LDAB    L01FC			;TPS
	MUL				;Coeff x TPS
	ASLD				;x2
	BCS     L7A70			;Bra if overflow
											
	ASLD				;x2
	BCS     L7A70			;Bra if overflow
											
	PSHA				;Push to stack    
;
;-Get default MAP bias
;
	LDAA    L0062			;RPM/25 
	LSRA 				;/2 for lookup
	LDX     #L4E60			;Default MAP bias vs. RPM
	LDAB    #16			;800 RPM offset
	JSR     LF137			;2D lookup with UL
;
	PULB				;    
	ABA   				;Add in the bias 
	BCS     L7A70			;Bra if overflow
;
;-Default MAP = (TPS x default MAP coeff.)/64 + default MAP bias
;
	CMPA    L4E5E			;Upper limit for default MAP 
	BLS     L7A73			;Bra if less, use calculated default MAP
;
;-Here to load default MAP if overflow from prev. ops./not running
;
L7A70	LDAA    L4E5E			;90.8 Kpa default MAP, if not running/overflow from default MAP calc.
;
L7A73	LDAB    L4139			;Transient MAP filter coeff
	BRSET   L0047,#$01,L7A7D	;Bra if b0==1, load transient MAP filter coeff.
;
	LDAB    L4138			;Load standard MAP filter coeff
L7A7D	LDX     L01E6			;Load old filtered MAP
	JSR     LF0F6			;Lag filter routine
	STD     L01E6			;Save filtered MAP
	ASLB				;Shift LSB left    
	ADCA    #$0			;Round if LSB >= 128
	STAA    L01E9			;Save it, current MAP
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Read in force motor current
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	SEI				;Disable interrupts
	LDAA    #$07			;0000 0111, 4 consec. reads of channel 7
	STAA    L3030			;A/D control reg. (ADCTL)
;
;
;
	LDX     #L3000			;Base CPU reg. addr.
L7A95	BRCLR   $30,X,#$80,L7A95	;ADCTL, bra if b7==0, A/D conversion not done yet 
;
;-A/D conversion complete, average readings
;
	CLRA				;Preclear A
	LDAB    L3031			;A/D result reg. 1, first A/D read
	ADDB    L3032			;Add in second result from A/D read
	ADCA    #$00			;Perform carry if needed
	ADDB    L3033			;Add in third result
	ADCA    #$00			;Carry if needed
	ADDB    L3034			;Add in fourth result
	ADCA    #$00			;Carry if needed
	LSRD				;/2
	LSRD				;/2
	ADCB    #$00			;Round up if needed
	STAB    L0148			;Save it, average of four reads 

	JSR     LEEE2			;Read in TPS, MAP, and O2 A/D vals.	
;											
	CLI				;Enable interrupts    
	JSR     L7CF6			;Force motor control routine
;											
	SEI				;Disable interrupts
	LDD     L3FFA			;CPU status
	STD     L0073			;Save it
	CLI				;Re-enable interrupts     
	BITA    #$04			;Test b2, 
	BEQ     L7AD4			;Bra if b2==0, No VSS pulses			
;
	LDD     L3FC4			;VSS counter
	CPD     L080D			;Stored VSS counter val. from previous pass
	BEQ     L7AD4			;Bra if no change
;
	INC     L080C			;+1, VSS pulse ocured
	STD     L080D			;Save VSS counter

L7AD4	LDAB    L0146			;Force motor DC
	LDAA    #$06			;
	STD     L3068			;Output to hardware
;
	JSR     L7E04			;Brake switch handling routine
;
	LDAA    L0002			;Loop counter
	INCA				;+1    
	CMPA    #160			;1 second
	BNE     L7B00			;Bra if !=, continue
;
;-Here to increment engine run time
;
	LDAB    L0043			;
	EORB    #$20			;Toggle b5,
	STAB    L0043			;Save it
	BRCLR   L004F,#$80,L7AFF 	;Status word, bra if b7==0, engine not running
;
	LDX     L00F8			;Load engine run time
	INX				;+1
	BEQ     L7AF7			;Bra if roll-over
										
	STX     L00F8			;Engine run time
L7AF7	CPX     L4953			;Min run time to clear hot restart
	BCS     L7AFF			;Bra if run time <
;
;-Clear hot restart status
;
	BCLR    L0004,#$10		;Status word, clear b4, hot restart in effect
L7AFF	CLRA				;Preclear A   
;
;-Here if 1 sec has not yet passed
; 
L7B00	STAA    L0002			;Loop counter
	SEI 				;Disable interrupts    
	LDAA    L003B			;Serial data status word 
	ANDA    #$FB			;Clear b2, diagnostics disabled
	BRSET   L0051,#$08,L7B0F	;Bra if shutdown in effect, disable diagnostics
;
	BITA    #$18			;Test b3=in mode 4, b4=in mode 4
	BEQ     L7B11			;Bra if ==0, dont disable diag.
;
L7B0F	ORAA    #$04			;Set b2, disable diagnostics
;
L7B11	STAA    L003B			;Save serial data status word
	CLI				;Re-enable interrupts    
;
	BRCLR   L001A,#$20,L7B2D	;Bra if b5==0, No err 51 set, faulty prom
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; Err. 51, faulty prom set
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0002,#$01,L7B7C	;Loop counter, bra if b1==0, run every other pass
;
	BSET    L0043,#$80		;Set b7, 
	JSR     LAD0C			;RPM calc. routine
;
;-Do COP
;
	LDD     #$AA55			;1010 1010 0101 0101
	STAA    L303A			;COP
	STAB    L303A			;COP
	BRA     L7B7C			;Bra to run real time subroutines
;
;-No err 51 set.
;
L7B2D	BRSET   L0002,#$01,L7B51	;Loop counter, bra if b0 set, run every other pass
;
;~~~~~~~~~~~~~~~~~~~~~
; First 80 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~
;
	JSR     L924A			;I/O control routine
;
	JSR     LA53C			;Spark minor loop
;
	JSR     LD075			;EGR pos. read in routine
;
	JSR     LD11D			;EGR pos. PID control routine
;
	JSR     LF285			;ALDL scheduled message transmission routine
;
;-Alternate passes for each set of loops
;
	BRCLR   L0002,#$02,L7B49	;Loop counter, bra if b1==0, run second cluster
;
;~~~~~~~~~~~~~~~~~~~~~
; First 20 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~
;
	JSR     LB773			;
;
	BRA     L7B7C			;
;
;~~~~~~~~~~~~~~~~~~~~~~
; Second 20 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~~
;
L7B49	JSR     LCF65			;
;
	JSR     LAF40			;
;
	BRA     L7B7C			;
;
;~~~~~~~~~~~~~~~~~~~~~~
; Second 80 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~~
;
;
L7B51	JSR     L7E2E			;Main fuel loop
;
	JSR     LCC05			;
;
; CK  SDMW, SERIAL DATA MD WORD STATUS
;  CK FOR  ENG CONTROLLER MODE
;
	BRCLR   L003B,#$10,L7B6A	; BR IF NOT b4, IN MODE 4, ($F4)
;											
	LDAA    L0393			;
	BITA    #$80			;
	BEQ     L7B6A			;
;
;-----------------------------    
; MINOR LOOP MODE WD	
; 	b2 1 = SKIP ERR 43 DUE TO ALDL
;-----------------------------  
;  
	BSET    L0044,#$04		; SET b2
	BSET    L0043,#$80		;
	BRA     L7B6D			;
;
;-Here if no mode 4, 
;
L7B6A	JSR     LF081			;Hardware routine

L7B6D	BRCLR   L0002,#$02,L7B79	;Loop counter, bra if b1==0, dont run routines yet
;
;~~~~~~~~~~~~~~~
;
; 40 Hz cluster
;
;~~~~~~~~~~~~~~~
;
7B71	JSR     L94B3			;
;
	JSR     LC307			;
;
	BRA     L7B7C			;
;
L7B79	JSR     LB3B5			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Execute Real Time Subroutines
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7B7C	LDAB    L0002			;Loop counter
	ANDB    #$0F			;Clear all but lower 4 bits
	LDX     #L7BEA			;Addr. of RTS table
	ASLB				;x2 for double byte values
	ABX				;Add in as offset
	LDX     0,X			;Load RTS addr.
	JSR     0,X			;Go run the routine
;
;~~~~~~~~~~~~~~~~
; Back from loop
;~~~~~~~~~~~~~~~~
;								
	BCLR    L004F,#$04		;Status word, clear b2, loop overrun flag
	BRCLR   L0082,#$40,L7BA9	;Status word, bra if b6==0, no HU (mode 4 diags.)
;
;~~~~~~~~~~~~~~~~~~
; Mode 4 in effect
;~~~~~~~~~~~~~~~~~~
;				
	LDAB    L0002			;	
	ANDB    #$0F			;
	ASLB				;
	LDX     #L02F6			;
	ABX				
;
	LDD     L300E			; 
	SUBD    L301A			; 
	ADDD    #$0333			; 
	CPD     0,X			;
	BLS     L7BA9			;
;											
	STD     0,X			;
;
;~~~~~~~~~~~~~
; Refresh RAM 
;~~~~~~~~~~~~~
;
L7BA9	LDX     L02BE			;Pending RAM block to refresh
;
L7BAC	CPX     #$0400			;
	BNE     L7BB7			;Bra if current addr != $0400
;
;-Skip to next block of addressable memory to refresh
;											
	LDX     #$0800			;Move to $0800
	STX     L02BE			;
;
L7BB7	CPX     #$0900			;
	BEQ     L7BE6			;Bra if == $0900, all addressable RAM has been 
					;refreshed
;											
	SEI				;Disable interrupts 
;
;-Refresh 16 byte block of RAM
;    
	LDD     0,X			;
	STD     0,X			;

	LDD     $02,X			;
	STD     $02,X			;

	LDD     $04,X			;
	STD     $04,X			;

	LDD     $06,X			;
	STD     $06,X			;

	LDD     $08,X			;
	STD     $08,X			;

	LDD     $0A,X			;
	STD     $0A,X			;

	LDD     $0C,X			;
	STD     $0C,X			;

	LDD     $0E,X			;
	STD     $0E,X			;
;
;-Move on to next 16 byte block on next pass
;
	LDAB    #$10			;16 bytes
	ABX				;Add it in
	STX     L02BE			;Save it, pending RAM block to refresh
	CLI				;Enable interrupts     
	BRA     L7BAC			;Bra to continue 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Here to wait for interrupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7BE6	CLI				;Clear interrupt bit, enable interrupts
	WAI				;Wait for interrupts
	BRA     L7BE6			;Loop				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Real Time Subroutine table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;RTS #
;
L7BEA	FDB	L7C0B			; 0
	FDB	L7C12			; 1	
	FDB	L7C1C			; 2
	FDB	L7C22			; 3
	FDB	L7C35			; 4
	FDB	L7C6B			; 5
	FDB	L7C7C			; 6
	FDB	L7C83			; 7
	FDB	L7C9C			; 8
	FDB	L7CA0			; 9
	FDB	L7CAA			;10
	FDB	L7CAE			;11
	FDB	L7CBE			;12
	FDB	L7CC2			;13
	FDB	L7CCC			;14
	FDB	L7CDD			;15
;
L7C0A	RTS				;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C0B	JSR     LC3BA			;A/D leadin to retrieve FP volts
	JSR     LCD23			;(???)
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #1
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C12	JSR     LC3CE			;MAP/Baro handling
	JSR     LC4B3			;Trans baro handling
	JSR     LAE65			;Non CC trans TCC handling
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #2
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C1C	SEI				;Disable interrupts			     
	JSR     LEEAA			;Lead-in for A/D routine, multi channel read
	CLI				;Enable interrupts
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #3
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C22	JSR     LF26C			;Heads up routine
	JSR     LD425			;
;
;
;
	LDX     #L400F			;Opt. byte
	BRCLR   0,X,#$C0,L7C31		;Bra if b6, non-CC transmission, and b7, manual 
					;transmission/TCC, ==0, run routine
;									
	BRA     L7C34			;Bra to return			   
;										   
L7C31	JSR     LC32A			;
;											
L7C34	RTS				;Return    					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #4
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L7C35	JSR     LC6D1			;Trans related routines
;
	BRCLR   L0002,#$10,L7C4A	;Loop counter, bra if ==0, run second cluster
;
;~~~~~~~~~~~~~~~~~~~~
; First 5 Hz cluster
;~~~~~~~~~~~~~~~~~~~~
;
	JSR     LE860			;
;
	JSR     LE893			;
;
	JSR     LC6F6			;Routine to look up linear trans temp
;
	JSR     LC71D			;Routine to handle trans temp related items
;										
	BRA     L7C59			;Bra to continue				
;
;~~~~~~~~~~~~~~~~~~~~~
; Second 5 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~
;								
L7C4A	JSR     LE50E			;
;										
	JSR     LE542			;
;											
	JSR     LC78A			;Look up linear cool temp
;											
	JSR     LC7E0			;Routine to generate cool temp for trans
;											
	JSR     LC805			;Lookup routine of various temp. based items
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check for TPS errors
;~~~~~~~~~~~~~~~~~~~~~~
;											
L7C59	BCLR    L006F,#$24		;Status word, clear b2, high TPS, and b5, 
					;low TPS error flags
	BRCLR   L0016,#$01,L7C63	;Error word #2, bra if b0==0, err 21, high TPS not set
;
;-Error 21 has been set, flag error
;		
	BSET    L006F,#$04		;Set b2, high TPS
;
L7C63	BRCLR   L0017,#$80,L7C6A	;Error word #3, bra if b7==0, error 22, low TPS not set
;
;-Error 22 has been set, flag error
;
	BSET    L006F,#$20		;Set b5, low TPS
;
L7C6A	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C6B	JSR     LD2D7			;Routine to check for catalytic converter reaction 
					;overtemp
;
	JSR     LD399			;CPI manifold variable tune routine
;
; CK DIG I/O MD WD
;
	LDX     #L400F			; MODE WD, DIG I/O
	BRSET   0,X,#$40,L7C7B		; BR IF b6, TCC (Non Elect xmish)
; 												; ... else
	JSR     LC506			;Shiftlight/TCC routine
;
L7C7B	RTS     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #6
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C7C	JSR     LC923			;Adaptive A/C control routine
;
	JSR     LCC1E			;Low octane handling routine
;
	RTS     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #7
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
		;
		; CK DIG I/O MD WD
		;
L7C83	LDX     #L400F			; MODE WD, DIG I/O
	BRCLR   0,X,#$C0,L7C8C		; BR IF NOT b6 & B7
;											 	b7 1 = MAN, (0 = TCC)
; 	b6 1 = TCC (Non Elect xmish)
;	
	BRA     L7C8F			;
;
L7C8C	JSR	LC32A			;
;
L7C8F	JSR     LF279			;Routine to init heads up (ALDL mode 4)
;
	JSR     L9F7C			;Initial startup idle handling and 
					;idle integrator coordination routine
;
	JSR     LC879			;Routine to do SA and Knock related look ups
;
	JSR     LAD62			;
;
	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #8
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7C9C	JSR     LCCC9			;
;
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #9
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CA0	JSR	LCE3D			;Routine to check params for EGR
;
	JSR	LA386			;Routine to decay out various idle terms
;
	JSR	LD414			;MPH filtering routine
;
	RTS				;Return 		    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #10
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CAA	JSR     LD1D9			;Charcoal canister purge routine
;
	RTS 				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #11
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CAE	JSR     LD425			;
;
; CK DIG I/O MD WD
;
	LDX     #L400F			; MODE WD, DIG I/O
	BRCLR   0,X,#$C0,L7CBA		; BR IF NOT b6 & b7
;
;	b7 1 = MAN, (0 = TCC)
; 	b6 1 = TCC (Non Elect xmish) 
;
	BRA     L7CBD			;
;
L7CBA	JSR     LC32A			;
;
L7CBD	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #12
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CBE	JSR     LCA43			;
;
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #13
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CC2	JSR     LCACF			;Output handling routine
;
	JSR     LD9BB			;Routine to handle MAT 
;
	JSR     LDA49			;
;
	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #14
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check and reset pending RAM addr. block to refresh when complete
;
L7CCC	LDX     L02BE			;Pending RAM addr. to be refreshed
	CPX     #$0900			;Value when RAM refresh complete
	BEQ     L7CD9			;Bra if ==, reset and continue
;
;-RAM refresh was interrupted
;
	BSET    L0004,#$04		;Status word, set b2, RAM refresh incomplete 
	BRA     L7CDC			;Bra to return
;
;-RAM refresh complete
;
L7CD9	CLR     L02BE			;Clear pending RAM addr. to be refreshed
;
L7CDC	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Real time subroutine #14
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
; CK DIG I/O MD WD
;
L7CDD	LDX     #L400F			; MODE WD, DIG I/O
	BRCLR   0,X,#$C0,L7CE6		;  	b7 1 = MAN, (0 = TCC)
;                       		; 	b6 1 = TCC (Non Elect xmish)
	BRA     L7CE9			;
;
L7CE6	JSR     LC32A			;
;
L7CE9	JSR     LC30B			;
;
	JSR     LE3ED			;
;
	JSR     LE4B9			;
;
	JSR     LE046			;
;
	RTS				;Return  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7CF6	BRSET   L004C,#$20,L7D08	; BR IF b5, I/O PORT D
;											
	CLRA				;Perform clears
	CLRB				;
	STD     L014A			;									
	STAA    L0146			;
	STAA    L0149			;
	JMP     L7D8B			;				
;
L7D08	LDAA    L0149			;previous delta Force Motor Current 
	LDAB    L014E			;previous deltaFMC multiplier vs trans. temp
	MUL				;
	TST     L0149			;Test previous deltaFMC value
	BPL     L7D17			;Bra if previous deltaFMC is positive
;											
	SUBA    L014E			;Subtract mult, now = -multipler x |previous deltaFMC val.|
;
L7D17	PSHB				;Push to stack
	PSHA				;
	LDAA    L0147			;Desired force motor current
	CMPA    #57			;1113 mA
	BLS     L7D22			;Bra if <=
;											
	LDAA    #57			;Load max
;
L7D22	SUBA    L0148			;-A/D force motor current
	RORA				;Rotate right 
	ROLA				;rotate left
	BVC     L7D2D			;Bra if overflow clear
;
;-Clear invalid result
;
	LDAA    #127			;Load max deltaFMC
	ADCA	#00			; 
;
L7D2D	CMPA    #01			;Delta = 1
	BEQ     L7D35			;Bra if ==, clear deltaFMC
;
	CMPA    #255			;Delta = -1
	BNE     L7D36			;Bra if !=, continue
;
L7D35	CLRA 				;Clear delta value
;
L7D36	STAA    L0149			;Save it, deltaFMC = (DFMC - ADFMC) 
	LDAB    L014D			;multiplier vs. trans temp
	MUL				;multiplier x delta 
	TST     L0149			;
	BPL     L7D45			;Bra if result was positive
;
	SUBA    L014D			;Subtract mult, now = -multipler x |delta val.|
;
L7D45	TSX				;Get stack pointer into X
	SUBD    0,X			;subtract previous result, D = multipler x deltaFMC - previous delta multipler...
;					;			       x previous deltaFMC	
	BVC     L7D51			;Bra if oveflow clear
;
;-Clear invalid result
;											
	LDD     #$8000			;
	SBCB    #00			;
	SBCA    #00			;
;
L7D51	ASRA				;
	RORB				;/2
	ASRA				;
	RORB				;/2
	ADCB    #00			;Round if needed
	ADCA    #00			;
	PULX				;Clean up the stack
	TSTA				;
	BMI     L7D6B			;Bra if negative result
;
;-Positive result
;											
	ADDD    L014A			;
	CPD     #$0E00			; 3584d
	BLS     L7D79			;
											
	LDD     #$0E00			; 3584d
	BRA     L7D79			;
											
L7D6B	ADDD    L014A			;
	BCC     L7D76			;
;											
	CPD     #$0000			;
	BCC     L7D79			;
											
L7D76	LDD     #$0000			;
L7D79	STD     L014A			;
;											
L7D7C	LDX     #$0E00			; 3584d
	FDIV				;
	XGDX				;
	ADDD    #128			;
	BCC     L7D88			;
;											
	LDAA    #255			;Max force motor DC
;
L7D88	STAA    L0146			;Force motor DC
;
;
;
L7D8B	BRSET   L008A,#$80,L7DC6	; BR IF b7
;											
	BRSET   L0082,#$01,L7DC6	; BR IF b0, 1 = REIVE OR REV GEAR
;
	LDD     L014A			;
	CPD     #$0E00			; 3584d
	BNE     L7DC6			;
;											
	LDAA    L00F6			; FORCE MTR SHORT DETECT TIMER
	INCA				; INCRFORCE MTR SHORT DETECT TIMER
	CMPA    L6925			; 0.5 SEC FOR SHORT DETECT (FORCE MTR)
	BLS     L7DC4			;
;												
	CLR     L00F6			; FORCE MTR SHORT DETECT TIMER
	LDAA    L6927			; 11.4 VDC, HI VDC  THRESH AT 152 DEG C (short detect
	SUBA    L6926			;  7.3 VDC LO VDC THRESH AT -40 Deg c (short detect)
	LDAB    L00AF  			; XMISH TEMP
	MUL				; 
	ADDD    #128			;
	ADDA    L6926			; 7.3 VDC LO VDC THRESH AT -40 Deg c
	CMPA    L00A1			; BATTERY A/D
	BLS     L7DBF			; BR IF 
;											
	BSET    L0082,#$01		; SET b0, 1 = REIVE OR REV GEAR 
;
	BRA     L7DC6			;

L7DBF	BSET    L008A,#$80		; SET b7
;
	BRA     L7DC6			;
;
	STAA    L00F6			; FORCE MTR SHORT DETECT TIMER
L7DC6	BRSET   L008A,#$80,L7DDA	; BR IF b7
;											
	BRSET   L0082,#$01,L7DDA	; BR IF b0,  1 = REIVE OR REV GEAR
;											
	LDD     L014A			;
	CPD     #$0E00			; 3584d
	BCC     L7DDA			;
;											
	CLR     L00F6			; FORCE MTR SHORT DETECT TIMER
;
L7DDA	BRCLR   L0082,#$01,L7E03	; BR IF NOT b0, 1 = REIVE OR REV GEAR
; 
	LDAA    L6929			; 11.9 VDC HI VDC THRESH AT 152 Deg c
	SUBA    L6928			;  7.8 VDC HI VDC THRESH AT -40 Deg c
	LDAB    L00AF			; XMISH TEMP
	MUL				;
	ADDD    #128			;
	ADDA    L6928			;  7.8 VDC HI VDC THRESH AT -40 Deg c
	CMPA    L00A1			; BATTERY A/D
	BCC     L7E03			; BR IF BATTERY LT THRESH 
;											
	LDAA    L00F6			; FORCE MTR SHORT DETECT TIMER
	INCA				;
	CMPA    L6925			; 0.5 SEC FOR SHORT DETECT (FORCE MTR)
	BLS     L7E01			;
;											
	CLR     L00F6			; FORCE MTR SHORT DETECT TIMER
	BCLR    L0082,#$01		; CLR b0, 1 = REIVE OR REV GEAR 
	BRA     L7E03			;
;
L7E01	STAA    L00F6			; FORCE MTR SHORT DETECT TIMER
;
L7E03	RTS 				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Brake status routine 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-L004D, 1=brakes not applied, 0=brakes applied
; 
L7E04	BRCLR	L004D,#$02,L7E0E	;Port C I/O word, bra if brake switch on
; 
;-Brakes not applied here
;
	BRSET   L0096,#$01,L7E17	;Status word, bra if brakes where previously applied
;											
	BRA     L7E12			;Bra, no change in state 
;
;-Brakes applied here
;
L7E0E	BRCLR   L0096,#$01,L7E17	;Status word, bra if brakes whre previously not applied
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-No change in state, clear timer and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7E12	CLR     L00F5			;Clear brake status min change state timer
	BRA     L7E2D			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Change in state, update if state remains the same for long enough
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7E17	LDAB    L00F5			;Brake status min change state timer
	CMPB    L5D04			;Min time to change state 
	BCC     L7E23			;Bra if >=
;											
	INCB				;+1
	STAB    L00F5			;Save it, brake status min change state timer
	BRA     L7E2D			;Bra to return
;
;-Here to update
;
L7E23	BCLR    L0096,#$01		;Status word, preclear b1, brake status bit
	BRSET   L004D,#$02,L7E2D	;Port C I/O word, bra if brakes not applied
;											
	BSET    L0096,#$01		;Status word, set b0, brakes applied
;
L7E2D	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~
;
; Main fuel loop
;
;~~~~~~~~~~~~~~~~
;
L7E2E	LDX     L02A1			;Shutdown timer  
	BRCLR   L0044,#$10,L7E73	;Status word, bra if b4==0, ignition is still on	
;
;~~~~~~~~~~~~~~~~~~~~	
; Shutting down here
;~~~~~~~~~~~~~~~~~~~~
;						
	CPX     #$0008			;
	BCS     L7E90			;
;
	BCLR    L0004,#$83		;Status word, clear b7, EST error,
					;b1, Closed loop timer, and 
					;b0, O2 sensor ready
	BCLR    L0019,#$40		;Clear b6. error 41, 1x cam sens. CLR b6, ERR 41, 1x CAM SENSOR
	BCLR    L0019,#$20		;Clear b5, Err 42, EST  
	CLRA				;    
	CLRB				;    
	STD     L00F8			;Clear engine run time
	STD     L026F			;Clear (???)
	STAA    L0062			;Clear rpm/25
	STAA    L02F0			;Clear DRP counter
	STAA    L02F1			;Clear DRP counts
	STAA    L028B			;Clear elapsed DRP
	BSET    L0051,#$08		;Status word, set b3, shutdown in effect
	BCLR    L0082,#$08		;Status word, clear b3, ignition is off
	BCLR    L004F,#$80		;Status word, clear b7, engine running flag
	BCLR    L004F,#$10		;Clear b4, engine off
;
	BCLR    L0004,#$08		;Status word, clear b3, bad shutdown
	CPX     L4009			;Timer threshold for shutdown
	BCS     L7E90			;Bra if less, not shutting down yet	
;
;-Momentarily shut down the MCU
;										
	LDD     #$5008			;0101 0000 0000 1000
					;CCR: Allow stops, mask XIRQ, disable interrupts,
					;and set carry bit
					;Opt. reg: Enable clock monitor
	STAB    L3039			;Save B to option reg.
	TAP				:Load cond. code reg. from A
	STOP				;Stop MCU clocks
L7E71	BRA     L7E71			;Loop here if stop not allowed			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not shutting down
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L7E73	BRCLR   L0051,#$08,L7E8A	;Status word, bra if b3==0, not shutting down
;											; ... else
	BCLR    L0051,#$08		;Clear b3, not shutting down yet
	BCLR    L0046,#$80		;Status word, clear b7, have been in closed lp once
					;since startup
	BCLR    L0044,#$08		;Status word, clear b3, first valid DRP recieved
	BCLR    L003E,#$08		;Status word, clear b3, A/F decay int done for cold P/D
;											
	CLRA				;
	STAA    L0246			;Clear error 32 timer
	STAA    L02A0			;Clear cold P/N timer
;
L7E8A	BSET    L0082,#$08		;Status word, set b3, ingition is on
	LDX     #$FFFF			;Clear engine shutdown timer
;
L7E90	INX				;+1
	STX     L02A1			;Save it shutdown timer
;
;-Service COP
;
	LDAA    #$55			;0101 0101
	STAA    L303A			;COP reset reg.
	LDAA    L0041			;Status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for transient MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	ANDA    #$10			;Clear all but b4, A/C on/off flag 
	TST     L400F			;Opt. byte
	BMI     L7EA7			;Bra if b7==1, manual trans in use 
;
;-Here if TCC in use
;											
	LDAB    L0085			;Status word
	ANDB    #$20			;Clear all but b5, TCC commanded to lock flag
	ABA				;Add it into A
;
;-Here if manual tran in use
;
L7EA7	LDAB    L0047			;Status word
	ANDB    #$FE			;Mask all but b0
	CBA				;Compare A + B
	BNE     L7ECA			;Bra if !=, change in status
;
;-No changes in A/C, TCC status here
;											
	LDAB    L0063			;Load RPM/12.5
	SUBB    L0065			;RPM/12.5, one delayed
	BCC     L7EB5			;Bra if RPMs rising
;
;-RPMs falling here
;										
	NEGB				;Get abs. value of delta RPMs
;
L7EB5	CMPB    L413B			;Delta RPM theshold for transient MAP
	BHI     L7ECA			;Bra if delta RPMs greater
;											
	BRCLR   L0050,#$80,L7ECA	;Status word, bra if b7==0, not idling
;											
	BRCLR   L003E,#$A0,L7ECA	;Status word, bra if b5, b7==0
					;not in closed loop, no open loop idle condition
;											
	LDAB    L01E8			;Load transient MAP apply timer
	BEQ     L7ED2			;Bra if ==0, no transient MAP
;
;-Here to apply transient MAP for time specified
;											
	DECB				;-1,  
	BRA     L7ECD			;Bra to save and set flag				 
;
;-Here to apply transient MAP
;										
L7ECA	LDAB    L413A			;Transient MAP apply timer val.
;
L7ECD	STAB    L01E8			;Save it, transient MAP apply timer 
	ORAA    #$01			;Set b0, do transient MAP
;
;-Here for no transient MAP
;
L7ED2	STAA    L0047			;Save it, status word
	LDAA    L01FC			;Load %TPS
;
	STAA    L01FD			;TPS, one delayed
	JSR     LB270			;Routine to construct TPS
;
	BRSET   L0092,#$01,L7EE6	;Status word, bra if b0==1, trans TPS error
;											
	STAA    L01FC			;Save it, TPS
	BRA     L7EEC			;Bra to continue
;
;-Here if TPS fault
;
L7EE6	LDAA    L5B23			;Default TPS if error
	STAA    L01FC			;Save it, %TPS
;
;~~~~~~~~~~~~~~~
; Filter the O2
;~~~~~~~~~~~~~~~
;
L7EEC	LDAB    L48B3			;Slow O2 idle filter coeff.
	BRSET   L0050,#$80,L7EFD	;Status word, bra if b7==1, idling
;
;-Not idling here, load slow filter coeff.
;
	LDAA    L029E			;Scaled airflow
	LDX     #L4CFB			;Slow O2 filter coeff. vs airflow table
	JSR     LF15E			;2D lookup
;											
	TAB				;O2 filter coeff. to B
;
;-Check lower O2 limit for filtering
;
L7EFD	LDAA    L48B1			;Lower O2 limit for slow filtering
	CMPA    L01F8			;O2 A/D volts
	BHI     L7F10			;Bra if O2 <
;
;-Check upper O2 limit for filtering
;											
	LDAA    L48B2			;Upper O2 limit for slow filtering
	CMPA    L01F8			;O2 A/D volts
	BCS     L7F10			;Bra if O2 >
;
;-Load O2 volts
;
	LDAA    L01F8			;O2 A/D volts
;
;-Here to limit slow O2 
;
L7F10	LDX     L01F5			;Slow filtered O2
	JSR     LF0F6			;Lag filter routine
;											
	STD     L01F5			;Save it, slow filtered O2
	LDAA    L400F			;Opt. byte
	ANDA    #$01			;Clear all but b0, governor opt.
	BEQ     L7F23			;Bra if ==0, no governor present
;									
;-Here if using governor
;		
	JSR     L91B6			;Governor actuator subroutine 	
;
;-Calculate actual kPa x 256 from A/D map
;			
L7F23	LDAB    L01E9			;A/D MAP
	CLRA 				;  					
	LDX     #0694			;256 x .369
	FDIV				;Fractional Div
	XGDX 				;Get result into D
	ADDD    #2649			;+2649, 256 x 10.34
	STD     L027A			;MAP value, kPa x 256
;											
	BRSET   L004F,#$10,L7F89	;Status word, bra if b4==1, engine running
;
;~~~~~~~~~~~~~~~~~
; Engine off here
;~~~~~~~~~~~~~~~~~
;											
	JSR     LAF17			;VATS routine
;
	CLRB				;
	LDAA    L01E3			;SD MAP
	STD     L01EA			;SD MAP, filtered per cool temp
;											
	LDAA    L01FC			;TPS
	STD     L0201			;(???)
	STD     L01FF			;TPS, filtered based on cool temp
;											
	JSR     L8695			;Crank fuel lookup routine
;											
	ASLD				;BPW x2
	BCC     L7F52			;Bra if no overflow
											
	LDD     #$FFFF			;Clear overflow
;
L7F52	STD     L02F2			;Save it, cranking PW
	JSR     LC3BA			;FP volts A/D lead-in
;
;-Look up BPW correction vs. fuel pump volts
;
	LDAA    L0055			;Load fuel pump volts
	LDX     #L497E			;BPW mult. vs fuel pump volts
	JSR     LF15E			;2D lookup
;
	LDX     #L02F2			;Cranking PW
	JSR     LF1ED			;(A x X*)/256
;											
	STD     L02F2			;Save it, cranking PW
;
;-Check and perform crank fueling delay per DRPs
;
	LDX     #L400C			;Option byte 
	BRSET   0,X,#$04,L7F7D		;Bra if b2==1, no DRP adjustments to crank fueling
;
	LDAA    L0006			;Cool temp, linear
	LDX     #L4DC3			;Crank fueling delay vs. cool temp table
	JSR     LF15E			;2D lookup
;											
	CMPA    L02F0			;Compare to DRP counter
	BLS     L7F80			;Bra if <= to DRP counter
;
;-Here if not enough DRPs for crank fueling yet
;											
L7F7D	JMP     L860F			;Skip save
;
;-Enough DRPs for crank fueling here
;				
L7F80	LDD     L02F2			;Crank PW
	JSR     L78D4			;Crank PW correction routine
;											
	JMP     L85D8			;Go save and continue				
;
;~~~~~~~~~~~~~~~~~~~~~
; Engine running here
;~~~~~~~~~~~~~~~~~~~~~
;
L7F89	JSR     LAF17			;VATS routine
;
;-Check for VATS fail
;
	BRSET   L003D,#$02,L7F95	;Status word, bra if b1==1, VATS passed
;
;-Here if VATS failed
;		
	CLRA				;Clear PW
	CLRB				;
	JMP     L85D8			;Bra to save and continue				
;											
L7F95	CLRB				;
	LDAA    L01E3			;SD MAP
	SUBD    L01EA			;SD MAP, filtered per cool temp
	BLS     L7FFA			;Bra if MAP falling, no MAP AE
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; MAP rising, see about accel enrich
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										   	
	ADDD    #128			;Round up
	STAA    L01ED			;Save it, delta MAP for AE
;
;-Check quals for MAP AE
;										   	
	LDAB    L48B6			;delta MAP threshold for AE if idling
	BRSET   L0050,#$80,L7FAE	;Status word, bra if b7==1, iding
;
	LDAB    L48B5			;Delta MAP threshold for AE
;
;-Double delta MAP threshold if TPS high enough
;										
L7FAE	LDAA    L01FC			;TPS
	CMPA    L48B7			;TPS threshold to double delta MAP threshold
;											
	BHI     L7FBB			;Bra if TPS >
;											
	ASLB				;Delta MAP threshold x2
	BCC     L7FBB			;Bra if no overflow
;											
	LDAB    #255			;Clear overflow
;											
L7FBB	LDAA    L01ED			;Delta MAP for AE
	CBA				;Compare to threshold
	BLS     L7FFD			;Bra if delta MAP AE is less
;
;~~~~~~~~~~~~~~~~~
; Do delta MAP AE
;~~~~~~~~~~~~~~~~~
;
	LDX     #L4B3F			;MAP AE anyc PW vs delta MAP
	JSR     LF153			;2D lookup
;
;-Check if enough TPS to double MAP AE
;
	LDAB    L01FC			;%TPS
	CMPB    L48B8			;TPS threshold to double MAP AE
	BLS     L7FD4			;Bra if TPS <=
;
	ASLA				;AE x 2
	BCC     L7FD4			;Bra if no overflow
;											
	LDAA    #255			;Clear overflow
;
;-Perform RPM correction
;
L7FD4	PSHA				;Push sync AE to stack   
	LDAA    L0062			;RPM/25
	LDAB    #16			;400 RPM, lower limit for lookup
	LDX     #L4B9A			;MAP AE 
	JSR     LF137			;2D lookup with UL
;
	PULB				;Get sync AE back    
	MUL				;AE x RPM correction factor     
	ASLD				;x2    
	BCC     L7FE6			;Bra if no overflow
;						
	LDAA    #255			;Clear overflow
;
;-Perform temp correction
;
L7FE6	LDAB    L0260			;AE temp correction mult.
	MUL				;AE x mult.     
	LSRD				;/2
	LSRD				;/2    
	LSRD				;/2    
	LSRD				;/2
	LSRD				;/2, now AE mult divided by 32    
	TSTA				;Test MSB    
	BEQ     L7FF4			;Bra if no overflow
;
	LDAB    #255			;Clear overflow
;
L7FF4	TBA				;Get AE into A     
	BSET    L0005,#$80		;Status word, set b7, MAP AE in effect
	BRA     L8001			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~
; Here if no MAP AE
;~~~~~~~~~~~~~~~~~~~
;
L7FFA	CLR     L01ED			;Clear delta SD MAP for AE
;
L7FFD	CLRA				;clear MAP AE
	BCLR    L0005,#$80		;Clear b7, MAP AE no longer in effect
;
;-Here to continue with AE
;											
L8001	STAA    L0261			;Save it, MAP AE PW
;
;~~~~~~~~~~~~~~~~
; Perform TPS AE
;~~~~~~~~~~~~~~~~
;											
	LDAA    L01FC			;TPS
	SUBA    L01FF			;AE TPS, filtered based on cool temp
	BLS     L804F			;Bra if TPS is falling, no AE
;
;-TPS is rising
;											
	TST     L0200			;Test LSB
	BPL     L8014			;Bra if < 128
;											
	DECA				;Round down
	BEQ     L804F			;Bra if ==0, no TPS AE
;											
L8014	BRSET   L0005,#$40,L801D	;Bra if TPS AE already in effect 
;
;-Check quals for TPS AE
;											
	CMPA    L48B9			;TPS threshold for TPS AE
	BLS     L804F			;Bra if TPS <=, no TPS AE
;											
L801D	ASLA				;Delta TPS x2
	BCC     L8022			;Bra if no overflow
;											
	LDAA    #255			;Clear overflow
;
;-Look up AE
;
L8022	LDX     #L4B45			;AE vs delta TPS
	JSR     LF15E			;2D lookup
;
	LDAB    L02A7			;MPH
	CMPB    L48BB			;MPH threshold to apply multiplier
	BCC     L803D			;Bra if MPH >=
;
;-Apply off-idle TPS AE multiplier
;										    
	LDAB    L48BA			;TPS AE off-idle multiplier
	MUL				;AE x multiplier    
	ADDD    #64			;round if needed
	ASLD				;x2, now /128    
	BCC     L803D			;Vra if no overflow
											
	LDD     #65525			;Clear overflow
;
L803D	LDAB    L0207			;Delta TPS AE baro factor
	MUL				;Baro factor x AE     
	ADDD    #64			;Round if needed
	ASLD				;x2. now /128    
	BCC     L804A			;Bra if no overflow
;										  	
	LDD     #65525			;Clear overflow
;
L804A	BSET    L0005,#$40		;Status word, set b6, TPS AE in effect
	BRA     L8053			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~
; Here if no TPS AE
;~~~~~~~~~~~~~~~~~~~
;
L804F	CLRA				;Clear AE    
	BCLR    L0005,#$40		;Clear b6, TPS AE no longer in effect
;
L8053	STAA    L0262			;Save it, TPS AE
	BRCLR   L0002,#$02,L8069	;Loop counter, bra if b1==0, no filtering this pass
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to filter TPS @ 40 Hz
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L0208			;AE TPS filtering coeff.
	LDAA    L01FC			;TPS
	LDX     L01FF			;AE TPS, filtered based on cool temp
	JSR     LF0F6			;Filter routine
;
	STD     L01FF			;Save it, filtered TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Construct needed fueling terms
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Scale SD MAP for lookup, 20-40 in 5 kPa incs., 40+ in 10 kPa incs.
;
L8069	LDAB    L01E3			;SD MAP
	CMPB    #64			;40 kPa
	BLS     L8075			;
;											
	LSRB				;Div. MAP by 2 
	ADCB    #$00			;Round if needed
	ADDB    #32			;Add in 40 kPa offset
;
;-Check TPS quals for idle VE 
;
L8075	LDAA    L01FC			;TPS
	CMPA    L48D0			;TPS threshold for idling
	BCC     L808B			;Bra if TPS >=
;
;-Check MPH quals for idle VE 
;
	LDAA    L02A7			;MPH
	CMPA    L48CE			;Upper MPH limit for idle VE table
	BCC     L808B			;Bra if MPH >=
; 
;-Check RPM limits for idle VE
;
	LDAA    L0062			;RPM/25
	CMPA    #72			;1800 RPM
	BCS     L8098			;Bra if RPMs <=, use idle VE table
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Use open throttle VE table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L808B	LDAA    L0062			;RPM/25
	LDX     #L49CB			;Open throttle VE table
	BSET    L004F,#$08		;Status word, set b3, switch to open VE table
	JSR     LF17B			;3D lookup
;
	BRA     L80B8			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to use idle VE table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8098	LDAA    L0063			;RPM/12.5
	CMPA    #144			;1800 rpm, max val. for lookup
	BLS     L80A0			;Bra if RPMs <=
;											
	LDAA    #144			;Load max
;
L80A0	LDX     #L4A7E			;Addr. of idle VE table
	JSR     LF17B			;3D lookup
	BRCLR   L004F,#$08,L80B8	;Bra if b3==0, not previously using open throttle VE
;
;-Reset INT if needed
;												
	LDAB    L0232			;Current INT
	CMPB    L4905			;Lower INT threshold to reset if switching tables 
	BHI     L80B5			;Bra if INT >, no reset
;											
	BSET    L004F,#$20		;Status word, set b5, reset INT on VE table change
L80B5	BCLR    L004F,#$08		;Clear b3, switch to open VE table
;
;-Here if using open throttle VE table
;
L80B8	STAA    L0254			;Save it, VE
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Calculate mass of air in cylinder
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		           [kPa x 256] x [VE x 256] x [cyl. volume x 222]
; Mass of air term [g]  = ------------------------------------------------
;		                     [air density x 45064]
;
; Note: kPa ref pressure incorperated into air density multiplier
;
;
	LDD     L027A			;MAP kPa x 256
	LDX     L0259			;Inv. air density val.
	FDIV				;kPa / Inv. air density val.    
	PSHX				;Result to stack   
	TSX				;Get current stack pointer     
	LDAA    L4D8A			;Cyl volume
	JSR     LF1ED			;(A x X*)/256
;											
	PULX				;Get previous result back
	STD     L025B			;Save it, max mass of air in cyl.term
	LDAA    L0254			;Load VE
	LDX     #L025B			;Addr. of max. mass of air
	JSR     LF1ED			;(A x X*)/256
;											
	STD     L0257			;Save it, mass of air in cyl. x 32768
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Calculate overall airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		              g/cyl x 32768
; Airflow [g/s] = 256 x 2 x ---------------- x revs/sec x 4
;			          65536
;
;
;
	LDX     L020B			;Load DRP period
	IDIV				;Int. div., divide airflow by drp period    
	PSHX				;Result to stack    
	LDX     L020B			;DRP period
	FDIV				;Fract. divide, resolve remainder    
	XGDX				;Get result into D   
	TAB				;Divide result by 256     
	PULA				;Get MSB of airflow    
	TSTA				;Test MSB of result   
	PULA				;Get LSB of result    
	BNE     L80ED			;Bra if MSB !=0, result out of range
;											
	ASLD				;Result x 2, now gms/sec x 256    
	BCC     L80F0			;Bra if no overflow
											
L80ED	LDD     #$FFFF			;Clear overflow
;
L80F0	STD     L0255			;Save it, gms/sec x 256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Divide mass air in cyl by AFR to get needed mass of fuel
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;			            g/cyl
; mass of fuel [g] = 819.2 x 256 x -------
;				     AFR
;
	LDX     L0257			;grams of air per cyl. x 32768
	LDAA    L026D			;AFR x 10
	CLRB				;Clear LSB for divide    
	XGDX				;Swap AFR and g/cyl.    
	LSRD				;/2  
	LSRD				;/2    
	FDIV				;([g/cyl x 8192]/[AFR x 2560]) x 65536    
	XGDX				;Get result into D    
;
;-Make mass fuel needed a time based PW
;
	LDX     L4D88			;Injector  flowrate 
	IDIV				;Int. divide, mass of fuel / mass flowrate    
	PSHX				;Push result to stack    
	LDX     L4D88			;Injector flowrate into X
	FDIV				;Fract. divide, resolve remainder    
	XGDX 				;Get result into D   
	TAB				;/256     
	PULA				;MSB of idiv result    
	TSTA				;Test MSB    
	PULA				;Get LSB or result into A  
	BEQ     L8112			;Bra if MSB ==0, result is within range
;											
	LDD     #65535			;Clear out of range result
;
;		  grams of fuel/cyl
; BPW = 65536 x ---------------------
;		 flowrate of injector
;
L8112	STD     L0271			;Save it, sync BPW
;
;-Adjust injector pw to compensate for EGR
;
	LDD     L01D5			;%EGR flow
	ADDD    #128			;Round if needed
	LDX     #L0271			;Sync BPW
	JSR     LF1ED			;(A x X*)/256
;											
	LSRD				;/2
	LSRD				;/2    
	STD     L0275			;Save it, EGR BPW correction
;
	LDD     L0271			;Sync BPW
	SUBD    L0275			;-EGR BPw correction
	STD     L0271			;Save it, sync BPW
;
;-Apply BLM
;
	LDAA    L026B			;BLM
	BMI     L8138			;Bra if BLM >= 128, apply correction regardless
;
;-Check for PE operation
;
	BRSET   L003D,#$20,L813B	;Status word, bra if b5==1, in PE 
;											
L8138	JSR     L81D1			;Go add blm correction to the BPW
;
;-In PE here
;
L813B	BRSET   L0016,#$10,L817F	;Error word #1, bra if b4==1, VSS error 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform trans abuse test
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L400F			;Opt. byte
	BRSET   0,X,#$80,L8156		;Bra if b7==1, manual trans in use
;										
	LDAA    L514B			;Time to perform test in PE
	BRSET   L0041,#$20,L8153	;Status word, bra if b5==1, in P/N
;											
	LDAA    L084D			;Trans abuse test timer
	BEQ     L817F			;Bra if ==0, skip test
;											
	DECA				;-1
;
L8153	STAA    L084D			;Trans abuse test timer
;											
L8156	LDAA    L0812			;MPH
	CMPA    L514C			;Min MPH threshold for test
	BHI     L817F			;Bra if VSS <, skip test
;											
	LDAA    L01FC			;TPS
	CMPA    L514F			;Min TPS threshold for test
	BLS     L817F			;Bra if TPS <=, skip test
;											
	LDAA    L514D			;RPM threshold to flag high rpms
	BRCLR   L0053,#$08,L8170	;Bra if b3==0, high rpm not yet flagged 
;	
	LDAA    L514E			;RPM threshold to clear high rpm flag
;
L8170	CMPA    L0061			;Scaled RPMs
	BCS     L8179			;Bra if RPMs >
;											
	BCLR    L0053,#$08		;Clear b3, high RPM not present
														 
	BRA     L817F			;Bra to continue
;
;-Excessive RPMs present
;
L8179	BSET    L0053,#$08		;Set b3, high RPMs flagged
	JMP     L8300			;Bra to decay out fuel
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check and limit excessive engine RPMs/vehicle speed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L817F	LDX     #L400F			;Opt. byte
;
L8182	BRCLR   0,X,#$01,L818A		;Bra if b0==0, governor option not selected
;
;-Here if governor in use, use routine if errors
;		
	BRCLR   L006F,#$34,L81E9	;Bra if b2,high TPS, b4, b5, low TPS==0 
;											
L818A	LDX	#L495D			;RPM limit to enter fuel cut-off
	LDY     #L4961			;MPH limit enter fuel cut-off
;											
	BRCLR   L0046,#$10,L8198	;Status word, bra if b4==0, no fuel cut-off
;
;-Fuel cut-off in effect
;									
	INX				;+1, RPM limit to exit fuel cut-off
	INY				;+1, MPH threshold to exit fuel cut-off
;
L8198	BRSET   L0016,#$10,L81A0	;Err. word 31, bra if b4==1, VSS error
;											
	BRCLR   L0093,#$03,L81A2	;Status word, bra if b0==0, no external errors, 
					;and b1==0, no shift error
;
;-Trans errors present
;											
L81A0	INX				;+1
	INX				;+1, index alternate fuel cut-off threshold
;
;-Check for high RPMs and cut fuel 
;
L81A2	LDAB    L0062			;RPM/25
	CMPB    0,X			;Threshold to cut fuel
	BHI     L81C5			;Bra if RPMs >, cut fuel
;
;-Check for high speed and cut fuel if needed 
;											
	LDAB    L02A7			;MPH
	CMPB    0,Y			;MPH threshold to cut fuel
	BLS     L81E9			;Bra if MPH <=
;	
;-High speed present
;										
	LDAB    L0062			;RPM/25
	CMPB    L495C			;RPM threshold to re-enable fuel 	
	BLS     L81E9			;Bra if RPMs <=
;											
	LDAB    L028D			;Fuel cut-off delay timer
	CMPB    L495B			;Delay to cut fuel
;											 
	BCC     L81C5			;Bra if timer >=
;											
	INCB				;+1
	STAB    L028D			;Fuel cut-off delay timer
	BRA     L81EC			;Bra
;
;-High RPMs/speed present
;
L81C5	BSET    L0046,#$10		;Status word, set b4, fuel cut-off in effect
	LDD     #$0000			;
	STD     L0271			;Clear sync BPW
	JMP     L8300			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to apply BLM to BPW
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L81D1	PSHA				;BLM to stack   
	LDD     L0271			;Sync BPW
	ASLD				;x2
	BCC     L81DB			;Bra if no overflow
;											
	LDD     #65535			;Clear overflow
;
L81DB	STD     L0271			;Save it
;
	PULA				;Get BLM back
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Entrance point to add item to BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
L81DF	LDX     #L0271			;Sync BPW
	JSR     LF1ED			;(A x X*)/256
	STD     L0271			;Sync BPW
	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Here to exit fuel cut-off
;
L81E9	CLR     L028D			;Clear fuel cut-off delay timer
;
L81EC	BCLR    L0046,#$10		;Status word, clear b4, no fuel cut-off
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Start summing up async AE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L087F			;Stored IAC AE
;
;-Deliver post-DFCO AE pulse if needed
;
	BRCLR   L003E,#$01,L81FE	;Status word, bra if b0==0, no post-DFCO AE pulse
;										
	BCLR    L003E,#$01		;Status word, clear b0, post-DFCO AE pulse delivered
	ADDA    L48BC			;Post DFCO AE pulse
	BCS     L8218			;Bra if overflow
;
;-Check if A/C on AE needed
;											
L81FE	BRSET   L0041,#$10,L8207	;Status word, bra if b4==1, AC has come on
;
	BCLR    L0041,#$08		;Clear b3, no A/C AE needed
	BRA     L8213			;Bra to continue
;
L8207	BRSET   L0041,#$08,L8213	;Status word, bra if b3==1, A/C AE delivered
;
	BSET    L0041,#$08		;Set b3, A/C AE has been delivered
	ADDA    L48BD			;Add in A/C on AE
	BCS     L8218			;Bra if overflow
;
;-Add in TPS AE
;											
L8213	ADDA    L0262			;Add in stored TPS AE
	BCC     L821A			;Bra if no overflow
;
;-Here to clear overflow
;										
L8218	LDAA    #255			;Clear overflow
;
;-Here if no overflow set
;
L821A	BNE     L8222			;Bra if !=0
;
;-Async AE ==0, check for MAP AE
;
	BRSET   L0005,#$80,L822F	;Status word, bra if b7==1, MAP AE in effect		
;
;-No AE needed here
;
	BRA     L8247			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if non-zero asnync PW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Perform cool temp correction
;
L8222	LDAB    L025F			;AE temperature correction factor
	MUL				;temp correction x async AE				     
	LSRD				;/2    
	LSRD				;/2    
	LSRD				;/2    
	ADDD    L025D			;Add in stored async pulse time
	STD     L025D			;Save it, async pulse time
;             
L822F	BRSET   L003D,#$40,L8236	;Status word, bra if b6==1, AE already flagged 
;											
	BSET    L006E,#$08		;Status word, set b3, AE just became active
;          
L8236	BSET    L003D,#$C0		;Status word, set b6, AE active and
					;b7, deliver async pulse
	BSET    L006E,#$01		;(???) SET b0, EGR DIAG INT RESET
	BSET    L0044,#$02		;Status word, set b1, limit closed loop 
					;correction when AE active
;
	LDAA    L48C0			;Time to lock INT
	STAA    L081D			;INT lock timer
	BRA     L8258			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~
; Here if no AE needed
;~~~~~~~~~~~~~~~~~~~~~~
;
L8247	BCLR    L003D,#$40		;Status word, clear b6, AE no longer active
	LDAA    L081D			;INT lock timer
	BEQ     L8255			;Bra if ==0, unlock INT
;											
	DECA				;-1
	STAA    L081D			;Save it, INT lock timer
	BRA     L8258			;Bra, dont unlock INT yet
;
;-Here to remove closed loop correction limits after AE
;
L8255	BCLR    L0044,#$02		;Status word, clear b1, reset flag for limiting
;
;~~~~~~~~~~~~~~~~~~~~
; Decel Fuel Cut-Off
;~~~~~~~~~~~~~~~~~~~~
;
;-Check quals for DFCO
;
L8258	LDAA    L0006			;Cool temp, linear
	CMPA    L493A			;Min temp for DFCO
	BCC     L8262			;Bra if cool temp >=
;											
	JMP     L8330			;Bra, no DFCO
;
L8262	BRSET   L0041,#$20,L82CA	;Status word, bra if b5==1, in P/N
;											
	LDAB    L006F			;Status word
	BITB    #$24			;Test b2, high tps, b5, low TPS error
	BNE     L8284			;Bra if TPS errors set
;
	LDAB    #32			;800 RPM, lower limit for lookup
;
;-Check RPM threshold for DFCO
;
	LDAA    L0062			;RPM/25
	LDX     #L4C8A			;Addr of tps threshold vs. rpm
	JSR     LF137			;2D lookup with UL
;											
	CMPA    L01FC			;%TPS
	BHI     L8284			;Bra if TPS <
;	
;-Here to skip/exit DFCO
;										
	BRCLR   L0046,#$08,L82E0	;Status word, bra if b3==0, not previously in DFCO
;											
	BSET    L003E,#$01		;Status word, set b0, post-DFCO AE pulse
	BRA     L82E0			;Bra to exit DFCO
;
;-Check delta RPM threshold
;
L8284	LDAA    L0065			;RPM/12.5, one delayed
	SUBA    L0063			;Subtract RPM/12.5
	BLS     L828F			;Bra if RPMs rising
;											
	CMPA    L493B			;Delta RPM threshold for DFCO
	BHI     L82CA			;Bra if >, exit DFCO
;											
L828F	LDAB    L006F			;Status word
	BITB    #$48			;Test b6, high MAP, and b3, low MAP error
	BNE     L82B8			;Bra if !=0, MAP errors
;
;-Check delta MAP 
;											
	LDAA    L01ED			;Delta SD MAP
	CMPA    L493C			;Delta SD MAP threshold for DFCO
	BHI     L82CA			;Bra if delta MAP >
;											
	LDAA    L01F2			;MAP/baro ratio
;
	LDAB    L400E			;Opt. byte
	BITB    #$02			;Test b1, use MAP/baro ratio for DFCO
;                             				
	BNE     L82AA			;Bra if ==1
;											
	LDAA    L01E3			;Load SD MAP
;
;-Check MAP limits and perform DFCO if MAP low enough
;
L82AA	CMPA    L4933			;Lower MAP threshold for mand. DFCO
	BCS     L82B8			;Bra if MAP <, perform DFCO
;											
	BRCLR   L0046,#$08,L82E3	;Status word, bra if b3==0, not in DFCO
;											
	CMPA    L4934			;Upper MAP limit for DFCO
	BCC     L82E3			;Bra if MAP >=, no DFCO
;
;-Check RPM limits for DFCO
;											
L82B8	LDAA    L0266			;RPM threshold for DFCO
;											
	BRSET   L0046,#$08,L82C6	;Bra if b3==1, already in DFCO
;											
	ADDA    L4930			;RPM hysteresis if already in DFCO
	BCC     L82C6			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
L82C6	CMPA    L0062			;RPM/25
	BCS     L82E8			;Bra if RPMs >
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here for post-DFCO AE to set up for exit
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L82CA	LDAA    L0268			;DFCO exit PW timer
	BEQ     L82E0			;Bra if ==0
;											
	LDD     L025D			;Async pulse time
	ADDD    L4935			;Add'l PW for exiting DFCO
	BCC     L82DA			;Bra if no overflow
											
	LDD     #32767			;Load max asnyc PW
;
L82DA	STD     L025D			;Save it, async pulse time
	BSET    L003D,#$80		;Status word, set b7, deliver async pulse
;
;~~~~~~~~~~~~~~~~~~~
; Here to exit DFCO
;~~~~~~~~~~~~~~~~~~~
;
L82E0	CLR     L0268			;Clear DFCO timer
;
L82E3	LDAA    L4937			;Min time to enter DFCO
	BRA     L8325			;Bra to sae and continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue with DFCO 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L82E8	BRSET   L0016,#$10,L82FB	;Error word #1, bra if b4==1, VSS error 
;
;-Check MPH limits for DFCO
;											
	LDAA    L4931			;Min MPH to enter DFCO DFCO
	BRCLR   L0046,#$08,L82F6	;Status word, bra if b3==0, not in DFCO 
;											
	LDAA    L4932			;Min MPH to remain in DFCO
;
L82F6	CMPA    L02A7			;MPH
	BHI     L82CA			;Bra if MPH >, exit DFCO
;
L82FB	LDAA    L0269			;DFCO delay timer
	BNE     L831E			;Bra if !=0, no DFCO yet
;
;-DFCO delay timer has elapsed, perform DFCO
;
L8300	BSET    L0046,#$08		;Status word, set b3, DFCO active
	LDAA    L4938			;Duration to sustain post-DFCO PW
	STAA    L0268			;Post-DFCO timer              
	BSET    L003D,#$10		;Status word, set b4, decel enlean underway
	LDAA    L0267			;DFCO BPW multiplier
	SUBA    L4939			;Subtract DFCO decay rate												(Decrement % per 12.5 msec LP) 
	BCC     L8315			;Bra if still decaying out fuel
;											
	CLRA				;Clear out BPW multiplier
;
L8315	STAA    L0267			;DFCO multiplier
	JSR     L81DF			;Routine to add to BPW
;											
	JMP     L83D0			;Bra to continue
;
;-Decrement DFCO delay timer if not time for DFCO yet
;
L831E	LDAB    L0002			;Loop counter
	ANDB    #$0E			;Mask all but b1-b3
	BNE     L8325			;Bra if !=0
;
;-10th of a second has elapsed
;											
	DECA				;-1 from timer   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if its not time for DFCO yet
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
L8325	STAA    L0269			;DFCO delay timer
	LDAA    L0268			;Post-DFCO timer
	BEQ     L8330			;Bra if ==0
											
	DEC     L0268			;-1, post-DFCO timer
;
;-Here if no DFCO
;											
L8330	BCLR    L0046,#$08		;Status word, clear b3, no DFCO
	LDAA    #255			;
	STAA    L0267			;Reset DFCO decay multiplier
	LDD     L0201			;Slow filtered TPS
	ASLB				;    
	ADCA    #$0000			;Round up if needed
	BCC     L8341			;Bra if no overflow
;
	DECA				;Roll back if overflow
; 	   
L8341	SUBA    L01FC			;Subtract TPS
	BCC     L8349			;Bra if no underflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if TPS rising, no decel enlean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	JMP     L83CA			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue with decel enlean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8349	STAA    L082B			;Delta TPS for decel enlean
	LDX     #L400B			;Option byte
	BRCLR   0,X,#$80,L8357		;Bra if b7==0, perorm min delta TPS test each pass
;											
	BRSET   L0053,#$02,L8362	;Status word, bra if b1==1, skip min delta TPS check
;
;-Check delta TPS threshold for decel enlean
;											
L8357	LDAA    L082B			;Delta TPS for decel enlean
	CMPA    L492C			;Threshold for decel enlean
;											
	BLS     L83CA			;Bra if delta TPS <=
;
	BSET    L0053,#$02		;Set b1, skip delta TPS check when in decel enlean 
;
L8362	LDD     L01EA			;SD MAP, filtered per cool temp
	ASLB				;    
	ADCA    #$0000			;Round if needed
	BCC     L836B			;Bra if no overflow
;
	DECA				;Roll back MSB
; 
;-Check delta MAP threshold for decel enlean
;   
L836B	SUBA    L01E3			;Subtract SD MAP
	BCS     L83CA			;Bra if MAP is rising, no decel enlean
;											
	CMPA    L492D			;Delta MAP threshold for decel enlean
	BLS     L83CA			;Bra if delta MAP <=, no decel enlean
;											
	CMPA    #160			;50 kPa, max delta MAP for lookup
	BLS     L837B			;Bra if <=
;
	LDAA    #160			;Load max for lookup
;
L837B	LDX     #L4B16			;PW reduction vs. delta MAP table
	JSR     LF15E			;2D lookup
;
	TAB				;Get result into B     
	LDX     #L4B21			;PW reduction vs. delta TPS table
	LDAA    L082B			;Delta TPS for decel enlean
	JSR     LF15E			;2D lookup
;
	ABA				;Add the reduction multipliers together     
	BCC     L8390			;Bra if no overflow
;
	LDAA    #$00FF			;Clear overflow
;
L8390	LDAB    L0265			;Decel enlean cool factor
	MUL				;Cool factor x PW multiplier     
	ASLD				;x2    
	BCS     L839D			;Bra if overflow
;
	ASLD				;x2    
	BCS     L839D			;Bra if overflow
;
	ASLD				;x2, now divided by 32   
	BCC     L839F			;Bra if no overflow

L839D	LDAA    #255			;Clear overflow
;
	LDAB    L02A7			;MPH
	CMPB    L492F			;MPH threshold to scale down decel enlean 
	BCC     L83B4			;Bra if MPH >=
;
;-Scale decel enlean if vehicle not moving/moving at low speeds
;											
	LDAB    L492E			;Multiplier for low speed decel enlean
	MUL				;Multiplier x decel enlean PW factor     
	ADDD    #$40			;Round up if needed
	ASLD				;x2    
	BCC     L83B4			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Apply decel enlean to asyc and sync PW's
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L83B4	NEGA				;256 - decel enlean factor    
	BEQ     L83CA			;Bra if no decel enlean
;
	BSET    L003D,#$10		;Status word, set b4, decel enlean underway
	PSHA				;Push decel enlean mult. to stack    
	LDX     #L025D			;Async pulse time
	JSR     LF1ED			;(A x X*)/256
;											
	STD     L025D			;Save it, async pulse time
	PULA				;Get decel enlean mult. back    
	JSR     L81DF			;Go add it to the BPW
	BRA     L83D0			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no decel enlean
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L83CA	BCLR    L003D,#$10		;Status word, clear b4, no decel enlean
	BCLR    L0053,#$02		;Status word, clear b1, check delta TPS 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if DFCO active, skip decel enlean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check lower RPM limit for derivative RPM term
;
L83D0	LDAA    L0067			;RPM/6.25
	CMPA    L450C			;RPM limit for constructing derivative term
	BCS     L83EE			;Bra if RPMs <, no derivative term
;
;-Check TPS limit for derivative RPM term
;
	LDAA    L01FC			;TPS
	CMPA    L48D1			;Upper TPS limit for derivative RPM term
	BHI     L83EE			;Bra if TPS >, no derivative term
;
;-Check MPH limit for derivative RPM term
;											
	LDAA    L02A7			;MPH
	CMPA    L48D2			;Max speed for derivative RPM calc
	BHI     L83EE			;Bra if MPH >, no derivative term
;
;-Check cool limit for derivative RPM term
;											
	LDAA    L0006			;Cool temp
	CMPA    L48D3			;Lower temp limit for derivative RPM calc
	BCC     L83F4			;Bra if temp >=, perform calc
;
;-Here if quals not passed
;											
L83EE	LDAA    #128			;Load neutral value 
	STAA    L006C			;Transient RPM ratio
	BRA     L8425			;Bra to continue
;
;-Quals passed, calc. transient RPM ratio
;
L83F4	LDD     L006A			;Delayed filtered RPM/6.25
	LSRD				;/2
	LDX     L0068			;Filtered RPM/6.25
	FDIV				;Fract. divide    
	XGDX				;Get result into D    
	ADDD    #128			;Round if needed
	BCC     L8402			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;-Transient rpms = 128 x ([delayed RPM/6.25]/[RPM/6.25])
;
L8402	STAA    L006C			;Save it, transient RPM ratio
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform derivative fuel control to smooth idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check limits for transient RPM term
;
	CMPA    L4510			;Upper limit for transient RPM ratio
	BCS     L840E			;Bra if transient ratio <
											
	LDAA    L4510			;Load limit instead
	BRA     L8416			;Bra to continue

L840E	CMPA    L450F			;Lower limit for transient RPM ratio
	BCC     L8416			;Bra if transient ratio >=
;											
	LDAA    L450F			;Use limit instead
;
;-Apply derivative action
;
L8416	LDX     #L0271			;Sync BPW addr.
	JSR     LF1ED			;(A x X*)/256
;											
	ASLD				;x2, now /128
	BCC     L8422			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L8422	STD     L0271			;Sync BPW
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform altitude correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; kPa MAP val for lookup = .625 x A/D MAP + 10
;
L8425	LDAA    L01E9			;A/D MAP
	CMPA    #216			;87.5 kPa, upper limit for lookup
	BLS     L842E			;Bra if MAP <=
;											
	LDAA    #216			;87.5 Kpa
;
L842E	LDAB    #151			;Multiplier to scale MAP for lookup
	MUL				;MAP x multiplier     
	ADDD    #145			;Bias, lookup starts at 10 kPa
	LDAB    L01EF			;Load baro
;
	LDX     #L49A0			;Addr. of BPW corr. table
	JSR     LF17B			;3D lookup table
;											
	LDX     #L0271			;Sync BPW
	JSR     LF1ED			;(A x X*)/256
;
	ASLD				;x2, now /128
	BCC     L8449			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L8449	ASLD				;x2 for batt compensation  
	BCC     L844F			;Bra if no overflow
;											
	LDD     #$FFFF			;Clera overflow
;
L844F	STD     L0271			;Sync BPW
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform batt. volts compensation
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0055			;A/D fuel pump volts
	LDX     #L497E			;Addr. of BPW mult. table
	JSR     LF15E			;2D lookup
;
	LDX     #L0271			;Sync BPW
	JSR     LF1ED			;(A x X*)/256
;											
	STD     L0271			;Save it, sync BPW
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform closed loop fuel correction to BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CLRA				;Preclear A   
	LDAB    L0292			;closed loop fuel correction term
	BMI     L8473			;Bra if coorection <= 0
;
;-Adding fuel
;											
	ADDD    L0271			;Add in sync BPW
	BCC     L847F			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
	BRA     L847F			;Bra to continue
;
;-Removing fuel
;
L8473	NEGB				;Get abs. value    
	SUBD    L0271			;Subtract sync BPW
	BCS     L847B			;Bra if sync BPW >
;
;-Sync BPW is less then corrections
;											
	CLRA				;Clear BPW    
	CLRB				;
;    
L847B	NEGA				;Switch sign, now BPW - fuel correction    
	NEGB				;    
	SBCA    #$0000			;Perform carry if needed
;
L847F	STD     L0271			;Save it, sync BPW
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Add in the MAP AE to the sync BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CLRA				;    
	LDAB    L0261			;Stored Map AE PW
	ADDD    L0271			;Sync BPW
	BCC     L848E			;Bra if overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L848E	STD     L0271			;Sync BPW
	STD     L0277			;BPW, CPI/PFI mode
;
;~~~~~~~~~~~~~~~~~~~~
; Check for shutdown
;~~~~~~~~~~~~~~~~~~~~
;   
	BRCLR   L0044,#$10,L84A0	;Status word, bra if b4==0, ignition is on 
;
;-Ignition off/shutting down here
;
	CLRA				; 	   
	CLRB				;    
	STD     L0271			;Clear sync BPW
	JMP     L859F			;Bra to continue
;
;-Engine running here
;
L84A0	LDX     #L400B			;Opt. byte
	BRCLR   0,X,#$01,L84DE		;Bra if b0==0, in TBI mode
;											
	BRCLR   L0051,#$01,L84AD	;Status word, bra if b0==0, not in single fire mode
;											
	BRA     L84D3
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In CPI/PFI mode, check for short BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L84AD	SEI				;Disable interrupts     
	LDAA    L082A			;Time in double fire mode
	INCA				;+1
	BEQ     L84B7			;Bra if roll-over
;											
	STAA    L082A			;Save it, time in double fire mode
;
L84B7	CLI				;Re-enable interrupts
	LDY     L0277			;BPW, CPI/PFI mode
	CPY     L4922			;Threshold to transition from double to single fire
	BHI     L84DC			;Bra if BPW is >
;
;-Check time limit for transition
;											
	LDAA    L082A			;Time in double fire mode	
	CMPA    L496A			;Min time to transition back to single fire mode
	BCS     L84DC			;Bra if <, no single fire mode yet
;
;-Transition from double to single fire mode
;											
	BSET    L0051,#$01		;Status word, set b0, in single fire mode
	BSET    L003F,#$10		;Status word, set b4, sync/async flag											
	LDD     L0271			;Sync BPW
;
L84D3	ASLD				;x2 for single fire mode 
	BCC     L84D9			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L84D9	STD     L0271			;Save it, sync BPW
;
L84DC	BRA     L8555			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In TBI mode, check for short BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L84DE	LDX     #L400B			;Opt. byte
	BRCLR   0,X,#$04,L84E9		;Bra if b2==0, dont force sync idle
;											
	BRSET   L0050,#$80,L854C	;Status word, bra if b7==1, engine idling
;
;-Allow async idle here
;											
L84E9	LDX     #L4920			;Addr. of sync/async thresholds
	BRSET   L003E,#$10,L84F2	;Status word, bra if b4==1, in async fire
;
;-In sync fire
;											
	INX				;+1
	INX				;+1, advance to sync to async thresholds
;
;-Check PW threshold to enter/remain in async
;											
L84F2	BSET    L003E,#$10		;Preset b4==1, async flag
	LDD     4,X			;Load MAP/RPM quals
	LDX     0,X			;PW threshold async
	CPX     L0271			;Compare PW to sync BPW
	BCC     L8507			;Bra if sync BPW <= 
;
;-Check MAP threshold
;											
	CMPA    L01E3			;SD MAP
	BCC     L854C			;Bra if MAP <= threshold, dont enter async
;											
	CMPB    L0062			;RPM/25
	BCC     L854C			;Bra if RPMs <= threshold, dont enter async
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to enter asnyc fire, convert sync BPW to async firing time
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L8507	CLRA				;
	CLRB				;Clear out sync BPW
	STD     L3FCE			;TBI injector driver hardware
	JSR     LF08A			;Short delay
;
;-Convert BPW to a duty cycle
;
	LDD     L3FC0			;DRP
	ASLD				;x2 for quad injector firings
	BCC     L8518			;Bra if no overflow
;											
	LDD     #$FFFF			;Clear overflow
;
L8518	XGDX				;Swap result into X    
	LDD     L0271			;Sync BPW
	FDIV				;BPW/DRP x 65536, now %DC 
;
;-%DC x (1/80 firings), or 12.5 msec per asnyc firing
;  
	LDD     #0080			;80 firings/sec when in async
	XGDX				;Swap result back into D    
	IDIV				;Int. divide, result/80    
	PSHX				;Push quotient to stack    
	LDX     #0080			;80 firings/sec when in async
	FDIV				;/80, resolve remainder    
	XGDX				;Swap remainder into D    
	PULX				;Get quotient back    
	ADDD    #0128			;Round if needed
	STAA    L0281			;Save remainder			
	XGDX				;Get quotient into D    
	BCC     L8535			;Bra if no overflow from round op
;
	ADDD    #0001			;Round if needed
;
L8535	STD     L027F			;Save it, async BPW
;
;-Save accumulated async PW
;
	LDD     L027D			;Load lower two bytes of accumulated async PW
	ADDD    L0280			;Add in async BPW
	STD     L027D			;Save it, async PW
;
	LDAA    L027C			;Uppermost byte of accumulated async PW
	ADCA    L027F			;Add in async BPW and perform carry if needed
	STAA    L027C			;Save it, async PW
	BRA     L8559			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~
; Here if in sync fire
;~~~~~~~~~~~~~~~~~~~~~~
;
L854C	BCLR    L003E,#$10		;Clear b4, no async firings
;
	LDX     #$0000			;
	STX     L027C			;Clear accumulated async PW
;
;-Check for async pulse
;
L8555	BRCLR   L003D,#$80,L859F	;Status word, bra if b7==0, no async pulse needed
;
;-Check async limits
;											
L8559	LDD     L027C			;Stored async PW
	ADDD    L025D			;Add in async pulse time
	CPD     L4928			;Max async PW
	BHI     L8576			;Bra if PW >
;										
	CPD     L492A			;Min async PW to fire
	BLS     L8599			;Bra if PW <=, sync firing this pass
;
;-Empty async accumulators for injector firing
;											
	LDX     #$0000			; 
	STX     L025D			;Clear async pulse time 
	STX     L027C			;Clear stored async PW
	BRA     L858C			;Bra to continue
;
;-Here if excess PW
;
L8576	LDD     L027C			;Stored async PW
	SUBD    L4928			;- max async firing time
	BCC     L8586			;Bra if no underflow
;											
	ADDD    L025D			;Add into async pulse time, sub out PW next pass
	STD     L025D			;Save it, async pulse time											;
	CLRA				;Clear out async PW
	CLRB				;
;
L8586	STD     L027C			;Save it, stored async PW
	LDD     L4928			;Load max async firing time
;
;-Here to output async PW
;
L858C	SEI				;Disable interrupts
	JSR     L862B			;Routine to output pulsewidth
	CLI				;Re-enable interrupts
	BSET    L003D,#$80		;Status word, set b7, async pulse flag
	BCLR    L0046,#$01		;Status word, clear b0, sync AE
	BRA     L859F			;Bra to continue				
;
;-Here if short BPW, switch to sync AE instead
;											
L8599	BSET    L0046,#$01		;Status word, set b0, enable sync AE
	BCLR    L003D,#$80		;Clear b7, async pulse
;
;-Here if no async pulse needed
;											
L859F	LDD     L0271			;Sync BPW
	BRCLR   L003E,#$10,L85AE	;Status word, bra if b4==1, async firings
;
;-Async firings here
;											
	STD     L026F			;Outputted BPW
	BCLR    L003F,#$80		;Status word, clear b7, short BPW flag 
	BRA     L860F			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Sync firings here, check if BPW bias needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L85AE	BEQ     L85D8			;Bra if PW ==0
;											
	CPD     #0256			;3.9 msec 
	BCC     L85C9			;Bra if PW >=
;
;-BPW is short enough for bias
;											
	TBA				;Get BPW into A
	LDAB    #32			;488 usec bias for lookup
	LDX     #L496F			;BPW offset vs. BPW table
	JSR     LF15A			;2D lookup with SBA
;											
	TAB				;Get offset into B 
	CLRA				;
	ADDD    L0271			;Add offset into BPW
	SUBD    L4967			;Subtract bias
	BCS     L85D2			;Bra if BPW <, set flag
;
;-Clear short BPW flag
;
L85C9	BCLR    L003F,#$80		;Status word, clear b7, short BPW
	CPD     L4963			;PW threshold to set short BPW flag
	BCC     L85D8			;Bra if BPW >=
;
;-Set short BPW flag
;
L85D2	BSET    L003F,#$80		;Set b7, short BPW 
	LDD     L4965			;Load min allowed BPW
;
L85D8	STD     L026F			;Outputted BPW
	BEQ     L85EB			;Bra if BPW ==0
;
	ADDB    L0279			;Add in batt. volts compensation
	ADCA    #$00			;Perform carry if needed
	CPD     #32767			;Upper limit for PW
	BCS     L85EB			;Bra if PW <
;
	LDD     #32767			;Load max value
;
L85EB	STD     L0273			;Save PW, TOC 4/5 value
	LDX     #L400B			;Opt. byte
	BRSET   0,X,#$01,L85FA		;Bra if b0==1, in CPI/PFI mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In TBI mode, output to hardware
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	STD     L3FCE			;TBI injector driver hardware
	BRA     L860F			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if in CPI/PFI mode, calc. time based delay for inj. firing
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Time based delay = 4 x (deg delay x DRP) / 256
;
;                                                
L85FA	LDAA    L4969			;Load deg delay from DRP to injector firing
	LDX     #L005F			;Load DRP period
	JSR     LF1ED			;8 x 16 multiply routine
;
;-Scale to sync with free running MCU counter
;
	ASLD				;x2
	BCS     L8609			;Bra if overflow
;
	ASLD				;x2 
	BCC     L860C			;Bra if overflow
;
L8609	LDD     #$FFFF			;Clear overflow
;
L860C	STD     L081F			;Save it, time based delay for injector firing
;
;-Here to continue with 40 hZ routines
;
L860F	BRSET   L0002,#$02,L861B	;Loop counter, bra if b1==1
;
;~~~~~~~~~~~~~~~~~~~~~
; First 40 hZ cluster
;~~~~~~~~~~~~~~~~~~~~~
;
	JSR     L8720			;O2 PID routine
	JSR     LD3CA			;VSS handling routine
	BRA     L862A			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~
; Second 40 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~~
;
L861B	JSR     L86F6			;Check for ignition on/off
	BRCLR   L0002,#$04,L8627	;Loop counter, bra b2==0, run second cluster
;
;~~~~~~~~~~~~~~~~~~~~~
; First 20 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~
;
	JSR     L8A01			;Misc. fueling and BLM handling routine
	BRA     L862A			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~
; Second 20 Hz cluster
;~~~~~~~~~~~~~~~~~~~~~~
;
L8627	JSR     L8F97			;Governor PID subroutine
;
L862A	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to output inj. pulsewidth
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L862B	LDX     #L400E			;Opt. byte
	BRCLR   0,X,#$10,L864F		;Bra if b4==0, no added injector bias
;
	CPD     #$0100			;3907 usecs
	BCC     L864F			;Bra if BPW >=
;
;-Here if BPW < 3907 usecs, look up BPW inj. offset
;
	PSHB				;Push BPW to stack    
	PSHA				;    
	TBA				;Get LSB into A for lookup     
;
;-Look up injector bias based on BPW
;
	LDAB    #32			;488 usecs offset for lookup
	LDX     #L496F			;BPW offset table
	JSR     LF15A			;2D lookup with SBA
;
	TAB				;Get offset into B   	
	PULX				;Get BPW back    
	ABX				;Add in the offset     
	XGDX				;Get the result into D    
	SUBD    L4967			;Subtract offset
	BCC     L864F			;Bra if no underflow

	LDD     #$0000			;Clear underflow
;
L864F	ADDB    L0279			;Batt. volts. BPW bias correction
	ADCA    #0			;Perform carry if needed
	STD     L3FF2			;Save it, outputted BPW
;
	JSR     LF08A			;Short delay
;
	LDD     L3FFC			;I/O D port
	ANDA    #$FB			;Clear b2= 
	JSR     LF08A			;Short delay
;
	STD     L3FFC			;Save it.
;
	ORAA    #$04			;Set b2
	JSR     LF08A			;Short delay
;
	STD     L3FFC			;Save it, I/O D port
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; RPM/6.25 calc. routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;                                          
L866E	LDX     L3FC0			;DRP counter
	LDAA    L4142			;# of cyls.
	LDAB    #32			;32, calc DRP relative to 8 cyl.
	MUL				;(# cyls. x 32)    
	TBA				;/ result by 256    
	BEQ     L8681			;Bra if 8 cyl in use
;
;-Here if less then 8 cyl.
;
	PSHX				;DRP counts to stack   
	TSX				;Get current stack pointer				     
	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Get DRP counts back    
	XGDX				;Swap result into X 
;
;-Here if 8 cyl. present.
;   
L8681	CPX     #$0000			;0 DRP counts
	BHI     L8689			;Bra if !=0
;
	CLRA				;Clear RPMs    
	BRA     L8694			;Bra to return
;
L8689	LDD     #614			;9.37 msec, 1600 RPM
	FDIV				;Fract. divide    
	XGDX				;Get result into D, now RPMs/6.25    
	CMPA    #127			;800 RPM limit
	BLS     L8694			;Bra if <=
;
	LDAA    #127			;Return with limit instead
;
L8694	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Crank fuel lookup routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8695	LDAA    L0006			;Cool temp, linear
	LDX     #L4D92			;Crank BPW vs. cool temp
	JSR	LF15E 			;2D lookup
;
	LDX     #L4D90			;Scalar for crank BPW
	JSR     LF1ED			;(A x X*)/256
;											
	PSHB				;Push crank BPW to stack    
	PSHA				;    
	LDAA    L02F1			;DRP counter
	CMPA    L4D8B			;DRP threshold to use RPM multipliers
	BLS     L86C4			;Bra if DRPs <=
;
	JSR     L866E			;RPM/6.25 calc. routine
;
;-Perform crank fuel corr. based on RPMs
;
	LDX     #L4DA3			;Crank fuel mult. vs RPM
	BRCLR   L0004,#$10,L86BA	;Status word, bra if b4==0, no hot restart
;
;-Hot restart in effect
;
	LDX     #L4DAC			;Hot restart crank fuel mult. vs RPM
;
L86BA	JSR     LF15E			;2D lookup
;
	TSX				;Current stack pointer into X     
	JSR     LF1ED			;(A x X*)/256
;										
	PULX				;Get old crank BPW back
	PSHB				;Push crank BPW to stack    
	PSHA				;    
;
;-Perform baro correct
;
L86C4	LDAA    L01EF			;Baro
	LDAB    #96			;Offset for lookup
	LDX     #L4DB5			;Crank fuel mult. vs baro table
	JSR     LF15A			;2D lookup with SBA
;
	TSX				;Get current stack pointer into X     
	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Get crank BPW    
	ASLD				;x2, now /128    
	BCC     L86DA			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
L86DA	BCS     L86F5			;Bra if overflow, return
;
;-Perform TPS crank fuel correction
;
	PSHB				;Crank BPW to stack    
	PSHA				;    
	LDAA    L01FC			;TPS
	LDX     #L4DB9			;Crank fuel mult. vs TPS table
	JSR     LF153			;2D lookup w/ linecount
;
	TSX				;Get current stack pointer     
	JSR     LF1ED			;(A x X*)/256  
;
	PULX				;Get old BPW back off the stack   
	ASLD				;x2   
	BCS     L86F2			;Bra if overflow
;
	ASLD				;x2, now /64    
	BCC     L86F5			;Bra if no overflow
;
L86F2	LDD     #$FFFF			;Clear overflow
;
L86F5	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for ignition on/off
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for low batt. volts
;
L86F6	LDAA    L00A1			;A/D battery volts
	CMPA    #90			;9 volts
	BCC     L8708			;Bra if batt volts >=
;
;-Check for ignition off
;
	CMPA    #40			;4 volts, threshold for ignition off
	BCC     L871F			;Bra if batt. volts >=, return w/o updating
;
;-Ignition is off
;    
	BSET    L0044,#$10		;Status word, set b4, ignition is off
	BCLR    L0050,#$01		;Status word, clear b0, sync. MAP reads 
	BRA     L871F			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Batt volts > 9 volts and ignition is on
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   
L8708	BRCLR   L0044,#$10,L8712	;Bra if ignition on already flagged
;
;-Update EST info
;
	LDX     L3FCA			;EST circuit info
	STX     L0228			;Save it, EST circuit info
;  
;-Update status word
;
L8712	BCLR    L0044,#$10		;Clear b4, ignition is on
;
;-Check for sync MAP reads
;
	LDAA    L400C			;Opt. byte
	BITA    #$01			;Check b0, sync MAP reads
	BEQ     L871F			;Bra if ==0, no sync MAP reads
;
	BSET    L0050,#$01		;Set b0, sync MAP reads
;
L871F	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~
;
; O2 PID algorithm
;
;~~~~~~~~~~~~~~~~~~
;
L8720	BRCLR   L004F,#$10,L8745	;Status word, bra if b4==0, engine not running
;
;-Check O2 window, learn disabled if O2 dwells within window long enough
;
	LDX     #L48F5			;O2 window 
	BRCLR   L0050,#$80,L872E	;Status word, bra if b7==0, not idling
;
	LDX     #L48F9			;Load O2 window for idle
;
L872E	BRSET   L003E,#$80,L8734	;Status word, bra if b7==1, in closed loop	
;
;-Load open loop O2 window
;
	INX				;+1
	INX				;+1, open loop O2 window
;  
;-Check upper O2 window boundry
; 
L8734	LDAA    L01F8			;O2 A/D volts
	CMPA    0,X			;Upper O2 boundry
	BHI     L873F			;Bra if O2 >, O2 is functional
;
;-Check lower O2 window boundry
;
	CMPA    1,X			;Lower O2 boundty
	BCC     L8745			;Bra if O2 >, O2 still dwelling in window
;
;-O2 isnt dwelling within window, clear learn disable timer, enable learn
;
L873F	CLR     L0264			;Clear O2 dwell timer
	BSET    L0004,#$01		;Status word, set b0, O2 functional
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Scale airflow and look up airflow based parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
L8745	LDAA    L0255			;Gms/sec airflow
	LDAB    L493F			;Scalar for airflow 
	MUL				;Gms/sec x scalar     
	ASLD				;x2    
	BCS     L8756			;Bra if overflow
;
	ASLD				;x2    
	BCS     L8756			;Bra if overflow
;
	CMPA    #128			;Upper limit for scaled airflow
	BLS     L8758			;Bra if airflow is less			
;
L8756	LDAA    #128			;Load limit
;
L8758	STAA    L029E			;Save it, scaled airflow
	LDAB    #$03			;4 table lookups
	BRCLR   L0050,#$80,L876E 	;Status word, bra if b7==0, not idling
;
;-Idling here
;
	LDD     L4940			;Rich O2 threshold if idling 
	STD     L0290			;Save it, rich and lean O2 thresholds
	LDAA    L4942			;Mean rich/lean O2 threshold if idling
	STAA    L028F			;Save it, mean rich/lean O2 threshold						
	CLRB				;Clear # of table lookups, just look up INT delay
; 
;-Loop and perform four table lookups based on airflow
; 
; 0x4CD7, integrator delay vs airflow table
; 0x4CE0, mean rich/lean O2 threshold
; 0x4CE9, rich O2 threshold vs airflow
; 0x4CF2, lean O2 threshold vs airflow 
;
; 0x028E, stored INT delay
; 0x028F, stored mean rich/lean O2 threshold 
; 0x0290, stored rich O2 threshold
; 0x0291, stored lean O2 threhsold
;
L876E	PSHB				;Push # of tables to stack    
	LDAA    #$09			;9 lines/table
	MUL				;# lines/table x # of tables     
	LDX     #L4CD7			;Start of tables
	ABX				;Add in offset     
	LDAA    L029E			;Load scaled airflow
	JSR     LF15E			;2D lookup
;
	LDX     #L028E			;Start of stored params
	PULB				;Get table # off stack    
	TSTB				;Test B    
	BEQ     L8789			;Bra if # of tables remaining is ==0
;
	ABX				;Add in offset to X     
	STAA    0,X			;Save param to memory
	DECB				;-1 from # of tables    
	BRA     L876E			;Loop to continue
;
;-Check if EGR diagnostics are in effect
;
L8789	BRCLR   L0070,#$04,L8790	;Status word, bra if b2==0, EGR diags. not underway
;
	LDAA    L4E4E			;Default INT delay if EGR diags. in effect
;
L8790	STAA    L028E			;Save it, INT delay
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Determine direction of O2
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L003E			;Status word
	LDAA    L028F			;Mean rich/lean threshold
	ADDA    L493D			;Add rich/lean O2 mV hyst.
	BCS     L87A2			;Bra if overflow
;
;-Check rich O2 limit
;
	CMPA    L01F8			;A/D O2 volts
	BCS     L87BB			;Bra if O2 volts greater
;
;-Check lean O2 limit
;
L87A2	LDAA    L028F			;Rich/lean O2 threshold
	SUBA    L493D			;Subtract rich/lean O2 mV hyst. 
	BCS     L87AF			;Bra if underflow

	CMPA    L01F8			;A/D O2 volts
	BHI     L87B7			;Bra if >=
;
;-O2 mV neither overly high or low, check direction of O2
;
L87AF	LDAA    L01F8			;Current A/D O2
	CMPA    L01F7			;A/D O2, one delayed
	BHI     L87BB			;Bra if O2 is going richer
;
;-Going leaner here
;
L87B7	ANDB    #$BF			;Clear b6 of L003E, going leaner
	BRA     L87BD			;Bra to continue
;
;-Going richer here
;
L87BB	ORAB    #$40			;Set b6, going richer
;
L87BD	CMPB    L003E			;Status word
	BEQ     L87CA			;Bra if no change in fueling status
;
	INC     L0298			;Increment O2 cross-counts
	BSET    L0043,#$10		;Status word, set b4, change in fueling state
	CLRA				;Preclear A to reset timer
	BRA     L87D0			;Bra to save and continue				
;
;-Here if no change in fueling
;											
L87CA	LDAA    L029F			;Duration in current fueling state 
	INCA				;+1
	BEQ     L87D3			;Bra if rollover
;
L87D0	STAA    L029F			;Save timer
;
L87D3	STAB    L003E			;Save status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if INT reset needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for mode 4 operation
;
	BRCLR   L003B,#$10,L87E9	;Status word, bra of b4==0, no mode 4

	LDX     #L0393			;			
	BRCLR   0,X,#$01,L87E9		;
;
	BRCLR   1,X,#$01,L87E6		;
;
	BRA     L885C			;Bra to reset INT
;
L87E6	JMP     L8873			;
;
;-Here if normal operation
;
L87E9	BRSET   L003E,#$80,L87F1	;Status word, bra if b7==1, in closed loop 
;
	BRCLR   L0052,#$80,L885F	;Status word, bra if b7==0, no quasi-closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for quasi-closed and full closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L87F1	BRSET   L0046,#$08,L8859	;Status word, bra if b3==1, DFCO in effect 
;
;-Check for PE
;
	BRSET   L003D,#$20,L8859	;Status word, bra if in power enrich
;
	BRSET   L0052,#$40,L8859	;Status word, bra if b6==1, cat overtemp
;
;-Check if AE has just become active
;
	LDX     #L400C			;Opt. byte
	BRCLR   0,X,#$20,L880D		;Bra if b5==0, no INT reset when AE in effect 
;
	BRCLR   L006E,#$08,L880D	;Status word, bra if b3==0, AE has not
					;just become active
;
	BCLR    L006E,#$08		;Reset AE became active flag
	BRA     L885C			;Bra to reset INT
;
;-Reset INT on BLM cell change, if specified
;
L880D	LDX     #L400C			;Opt. byte
	BRSET   0,X,#$10,L8818		;Bra if b4==1, allow INT reset on BLM cell change 
;
	BRCLR   0,X,#$40,L881C		;Bra if b6==1, reset INT on BLM cell change
;
L8818	BRSET   L003D,#$04,L885C	;Status word, bra if b2==1, BLM cell has changed 
;
;-Check for change in VE table
;
L881C	BRCLR   L004F,#$20,L8825	;Status word, bra if b5==0, no change in VE tables
;
	BCLR    L004F,#$20		;Clear b5, reset VE table change flag
	BRA     L885C			;Bra to reset INT
;
;-Check for decel enlean
;
L8825	BRCLR   L003D,#$10,L8834	;Status word, bra if b4==0, no decel enlean
	BRSET   L003E,#$40,L8873	;Status word, bra if b6==1, going richer 
;
	LDAA    L0232			;INTegrator
	BPL     L8873			;Bra if currently leaning out fueling
;
	BRA     L885C			;Bra to reset the INT
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check MAP/RPM/MPH limits to prevent INT windup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check MAP limit
;
L8834	LDAB    L01E3			;SD MAP
	CMPB    L4901			;Lower MAP threshold to reset INT 
	BHI     L8873			;Bra if MAP >, no INT reset
;
;-Check RPM window for reset
;
	LDAB    L0062			;RPM/25
	CMPB    L4902			;Lower RPM threshold to reset INT
	BLS     L8873			;Bra if RPMs <=, no INT reset
;
	CMPB    L4903			;Upper threshold to reset INT
	BHI     L8873			;Bra if RPMs >, no INT reset
;
;-Check MPH threshold
;
	LDAB    L02A7			;MPH
	CMPB    L4904			;Lower threshold to reset INT
	BCS     L8873			;Bra if speed <=
;
;-Check direction of fueling and reset if needed
;
	BRSET   L003E,#$40,L8873	;Status word, bra if b6==1, going richer
;
;-Going leaner here
;
	LDAA    L0232			;INT
	BPL     L8873			;Bra if < 128, still leaning out fueling
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to reset integrator and other closed loop terms
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8859	BSET    L0071,#$04		;Status word, set b2, INT just reset (O2 diag.)
;
L885C	BSET    L006E,#$01		;Status word, set b0, INT just reset (EGR diag.)
;
L885F	LDAA    #128			;
	STAA    L0232			;Reset the INT
;
;-Reset the slow filtered O2 term
;
	LDAA    #102			;442 mV
	STAA    L01F5			;Save it, slow filtered O2
;
;-Clear other terms
;
	CLRA				;
	STAA    L0282			;Clear INT timer
	STAA    L029D			;Clear prop. term
	JMP     L89F4			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not resetting INT, calculate slow O2 error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check direction of long term fueling
;
L8873	LDAA    L01F5			;Slow filtered O2
	CMPA    L0290			;Rich O2 threshold
	BHI     L8889			;Bra if O2 going richer
;
;-Long term fueling leaning out here
;
	SUBA    L0291			;Lean O2 threshold
	BCS     L8883			;Bra if O2 less then threshold
;
;-O2 between lean and rich threhsolds
;
	CLRA				;Clear O2 error    
	BRA     L88A1			;Bra to save O2 error
;
;-Going leaner here
;
L8883	NEGA				;Get abs. val. of O2 error   
	BCLR    L0046,#$02		;Status word, clear b1, long term fueling lean
	BRA     L8893			;Bra to continue
;
;-Long term fueling going richer here
;
L8889	SUBA    L0290			;Subtract rich O2 threshold 
	LDAB    L494B			;Factor applied to O2 error if going richer 
	MUL				;Factor x O2 error				
	BSET    L0046,#$02		;Set b1, long term fueling rich
;
;-Check for idle
;
L8893	BRCLR   L0050,#$80,L889B	;Status word bra if b7==0, not idling
	LDAB    L494C			;Factor applied to O2 error if idling 
	MUL				;Factor x O2 error
;     
L889B	CMPA    #96			;Upper limit for O2 error
	BLS     L88A1			;Bra if O2 error is less
;
	LDAA    #96			;Load max O2 error
;
L88A1	STAA    L02A3			;Save it, O2 error
	ASLA				;x2
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up base proportional counts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4D04			;Base proportional counts vs. O2 error
	JSR     LF15E			;2D lookup
;
	STAA    L029D			;Save it, proportional term
;
	BRCLR   L0050,#$80,L88F6	;Status word, bra if b7==0, not idling
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine idling here, load idle specific params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
	LDAA    L4943			;Idle prop. duration term										
	PSHA				;To stack    
	LDX     #L4945			;Start addr. of idle proportional gain terms
	LDY     #L4948			;Start addr. of idle integrator delay terms
	BRSET   L003E,#$40,L88C9	;Status word, bra if if b6==1, going richer
;
;-Going leaner here, exec. every other time
;
	SEI				;Disable interrupts
	LDAA    L003F			;Status word
	EORA    #$05			;Toggle b0, RPMs falling, and b2, High idle speed
	STAA    L003F			;Save status word
	CLI				;Re-enable interrupts
;
;-Going richer here
;
L88C9	BRSET   L003F,#$03,L88DB	;Bra if b0==1, RPMs falling, and b1==1, 
					;RPMs changing too rapidly for idle 
;
	BRSET   L003F,#$0C,L88DB	;Bra if b2==1, high idle speed, and b3==1,
					;RPMs out of desired idle range
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Stable target idle here, allow greater fueling corrections
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    1,Y			;Load integrator delay term
	STAA    L0285			;Save it, integrator delay
	INX				;+1,
	INX				;+1,  
	BRA     L88E6			;Bra to continue				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Unstable idle here, lessen fueling corrections
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~						
;					
L88DB	LDAA    0,Y			;Integrator delay term
	STAA    L0285			;Save it, INT delay term
	BRSET   L003E,#$40,L88E6	;Status word, bra if b6==1, going richer
;
;-Going leaner
;
	INX				;+1, index lean params     
;	
;-Apply idle based gains
;
L88E6	LDAA    0,X			;Load prop. gain term
	LDAB    L029D			;Proportional term
	MUL     			;Proportional term x gain
	ASLD				;x2, 
	BCS     L88F2			;Bra if overflow
;
	ASLD				;x2, now /64
	BCC     L891F			;Bra if no overflow
;
L88F2	LDAA    #255			;Clear overflow
	BRA     L891F			;Bra to continue	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine not idling, load standard parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Look up prop. duration
;			
L88F6	LDAA    L029E			;Scaled airflow
	LDX     #L4D1E			;Proportional duration vs. airflow
	JSR     LF15E			;2D lookup
;											
	PSHA				;Push duration to stack
;
;-Look up proportional flow gain 
;
	LDAA    L0062			;RPM/25
	CMPA    #144			;3600 RPM, UL for lookup
	BLS     L8908			;Bra if RPMs less
;
	LDAA    #144			;3600 RPM, upper limit
;
L8908	LDAB    L01E3			;SD MAP
	LSRB				;/2 for lookup 
	LDX     #L4D27			;Proportional gain table
	JSR     LF17B			;3D lookup
;	
;-Apply gain
;		
	LDAB    L029D			;Prop. term
	MUL				;Prop. term x gain
	ADDD    #64			;Round up
	ASLD				;x2, now /128
	BCC     L891F			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
;-Here if idling
;
L891F	STAA    L029D			;Save it, prop. term
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up prop. duration based on O2 error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L02A3			;O2 error
	ASLA				;x2 for lookup
	LDX     #L4D11			;Prop. duration vs. O2 error table
	JSR     LF15E			;2D lookup
;
	PULB				;Pull prop. duration back off stack   
	ABA				;Add in prop. duration vs O2 error     
	BCC     L8932			;Bra if no overflow
;																		
	LDAA    #255			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up INT delay based on O2 errror
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8932	PSHA				;Push prop. duration to stack 
	LDAA    L02A3			;O2 error
	ASLA				;x2 for lookup
	LDX     #L4D7B			;INT delay mult. vs. O2 error			
	JSR     LF15E			;2D lookup
;
	LDAB    L028E			;INT delay
	MUL				;Delay x mult.     
	BRCLR   L0050,#$80,L894C	;Status word, bra if b7==0, not idling
;
;-Idling here, add in additional delay
;
	ADDA    L0285			;Add in INT delay term for idling
	BCC     L894C			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
L894C	STAA    L028E			;Save it, INT delay
	STAA    L02A4			;Stored INT delay
;
	LDAA    L0046			;Status word
	ANDA    #$02			;Clear all but b1, long term fueling status
;
	LDAB    L003E			;Status word
	ANDB    #$40			;Clear all but b6, rich/lean flag
	ABA				;Add together     
	PULB				;Get prop. duration off stack   
	BEQ     L8962			;Bra if ind. bits==0, going leaner overall
;
	CMPA    #$42			;Test fueling indicator bits
	BNE     L89B0			;Bra if no overall trend in fueling 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Going richer or leaner overall here, update integrator
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8962	LDAA    L02A3			;Slow O2 error
	ASLA				;x2    
	CMPA    L493E			;Min error threshold to update INT
	BHI     L8970			;Bra if error >
;
;-Not a large enough error to update
;
	CLR     L0282			;Clear INT timer
	BRA     L89B0			;Bra to continue
;
;-Enough error, update INT
;
L8970	LDAA    L0282			;INT delay timer
	CMPA    L028E			;INT delay
	BCS     L897B			;Bra if INT timer <, dont update
;
	CLRA				;Reset INT delay timer    
	BRA     L897C			;Bra to update INT
;
;-Not time to update INT yet
;
L897B	INCA				;+1, INT delay timer
;    
L897C	STAA    L0282			;Save INT delay timer
	BNE     L89B0			;Bra if !=0, dont update yet
;
;-Time to update the INT
;
LDAA	L0232				;INTegrator
	BRSET   L0046,#$02,L8998	;Status word, bra if b1==1, long term fueling rich
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Long term fueling is lean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CMPA    L4907			;Max allowed INT
	BEQ     L89AD			;Bra if INT maxed out
;										
	BRCLR   L0052,#$80,L8995	;Status word, bra if b7==0, no quasi-closed loop
;
;-Using INT alone for initial corrections, limit INT to removing fuel only
;
	CMPA    #128			;Neutral INT
	BCC     L89AD			;Bra if INT >= 128
;
;-Full closed loop here
;
L8995	INCA				;+1, increment INT
	BRA     L89AD			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Long term fueling is rich
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8998	LDX     #L400B			;Opt. byte
	BRCLR   0,X,#$08,L89A3		;Bra if b3==0, dont limit INT when AE in effect
;
;-Check if INT movement needs to be limited due to AE
; 
	BRSET   L0044,#$02,L89B0	;Status word, bra if b1==1, limit closed loop 
					;correction if AE active
;
L89A3	CMPA    L4906			;Min allowed INT
	BEQ     L89AD			;Bra if INT == min INT
;
;-Check for short PW
;
	BRSET   L003F,#$80,L89AD	;Status word, bra if b7==1, short BPW
;
	DECA				;-1 from INT
;
;-Here to skip INT adjustment
;
L89AD	STAA    L0232			;Save it, INT
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Limit time prop. term can be active for
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L89B0	LDAA    L029F			;Duration in current fueling state 
	CBA				;Compare timer to proportional duration value    
	BLS     L89C5			;Bra if timer is <= prop. duration
;
	ADDB    L4944			;Add in hyst. for prop. duration dead band
	BCC     L89BD			;Bra if no overflow
;
	LDAB    #255			;Clear overflow
;
L89BD	CBA				;Compare timer to proportional duration value				     
	BCC     L89C5			;Bra if timer >
;
;-Clear proportional term, INT correction only if within dead band
;
	CLR     L029D			;Clear proportional term			
	BRA     L89CC			;Bra to continue
;
L89C5	BRCLR   L0052,#$80,L89CC	;Status word, bra if b7==0, quasi-closed loop
;
;-Clear proportional term, INT correction only for initial corrections
;
	CLR     L029D			;Clear proportional term

L89CC	LDAA    L029D			;Load proportional term
	BRCLR   L003E,#$40,L89F4	;Status word, bra if b6==0, going leaner
;
;-Going richer here, check if AE active
;
	LDX     #L400B			;Opt. byte
	BRCLR   0,X,#$08,L89E9		;Bra if b3==0, not limiting corrections
; 
	BRCLR   L0044,#$02,L89E9	;Bra if b1==0, AE is not in effect
;
;-AE in effect, limit closed loop corrections
;
	LDAA    L4908			;Prop. term limit when AE in effect											; ACELL LMT IN EFFECT     
	CMPA    L029D			;Compare to prop. term
	BCC     L89E9			;Bra if prop. term is <=
;
	STAA    L029D			;Use limit instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Construct final closed loop control output
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Going richer
;
L89E9	LDAA    L0232			;INTegrator
	SUBA    L029D			;Sub. proportional term			
	BCC     L89FB			;Bra if no underflow
;
	CLRA				;Clear underflow    
	BRA     L89FB			;Bra to save and return
;
;-Here when going leaner
;
L89F4	ADDA    L0232			;Add prop. term to INT
	BCC     L89FB			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
L89FB	SUBA    #128			;Subtract neutral value
	STAA    L0292			;Save it, closed loop fuel correction term
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Misc. fueling and BLM handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8A01	LDAA    L48DD			;Stoich AFR 
	LDAB    L003E			;Status word
	BITB    #$A0			;Check b5, (???) and b7, closed loop
	BEQ     L8A1B			;Bra if ==0
;
;-In closed loop here
;
	STAA    L026D			;Save stoich AFR as AFR 
	LDX     #L400D			;Opt byte
	BRCLR   0,X,#$01,L8A50		;Bra if b0==0, dont look up open loop AFR 
					;when in closed loop 
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L48C7			;Upper cool temp limit for AFR lookup 
					;when in closed loop
	BHI     L8A35			;Bra if cool temp greater
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Look up open loop AFR
;~~~~~~~~~~~~~~~~~~~~~~~
;
L8A1B	LDX     #L4BB0			;Start addr. of table and opt. bit
	LDAB    L01EC			;Load Vac
	LDAA    0,X			;Index opt. bit
	BEQ     L8A28			;Bra if ==0
;
	LDAB    L01E3			;SD MAP
;
L8A28	INX				;+1, move to start of table
	LSRB				;MAP,Vac/2 for lookup
	LDAA    L0006			;Cool temp, linearized
	CMPA    #192			;104 deg C, upper limit for lookup
	BLS     L8A32			;Bra if cool temp <=
;
	LDAA    #192			;Load max cool temp
;
L8A32	JSR     LF17B			;3D lookup
;
;-Subtract out choke AFR
;
L8A35	SUBA    L02EB			;Stored cranking choke AFR
	BCC     L8A3B			;Bra if no underflow
;
	CLRA				;Clear underflow
;
L8A3B	BRCLR   L0050,#$80,L8A52	;Status word, bra if b7==0, not idling 
;
;~~~~~~~~~~~~~
; Idling here
;~~~~~~~~~~~~~
;
	CMPA    L0295			;Open loop idle AFR
	BLS     L8A47			;Bra if AFR >=
;
	LDAA    L0295			;Open loop idle AFR
;
L8A47	LDAB    #60			;1.5 secs	
	STAB    L0289			;Time to filter AFR on idle to run										
	CLRB				;Clear LSB
	STD     L0287			;Save it, filtered AFR
L8A50	BRA     L8A7B			;Bra to continue
;
;~~~~~~~~~~~~~~~~~
; Not idling here
;~~~~~~~~~~~~~~~~~
;
;-Check if AFR needs to be filtered after idling
;
L8A52	LDAB    L0289			;Load time to filter AFR 
	BEQ     L8A6B			;Bra if ==0 
;
	DECB				;-1 
	STAB    L0289			;Save timer
	CMPA    L0287			;Filtered AFR
	BLS     L8A6B			;Bra if current AFR is >= 
;
;-AFR is leaner then previous AFR
;
	LDX     L0287			;Idle AFR
	LDAB    L48E2			;Filter coeff. for filtering AFR
	JSR     LF0F6			;Filter routine
;
	BRA     L8A71			;Bra to save
;
;-Here if not filtering AFR
;
L8A6B	CLRB				;Clear LSB    
	STD     L0287			;Save current AFR as filtered AFR
	BRA     L8A7B			;Bra to continue
;
;-Here to save filtered AFR
;
L8A71	STD     L0287			;Save it, filtered AFR
	ASLB				;Shift LSB left
	ADCA    #$00			;Round if needed
	BCC     L8A7B			;Bra if no overflow
;											
	LDAA    #255			;Clear overflow			
;
L8A7B	STAA    L026D			;Save it, stored AFR
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for idling
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check speed threshold
;
	LDAA    L02A7			;MPH
	CMPA    L48CF			;Max speed to be idling
	BHI     L8AEE			;Bra if speed is >
;
;-Check TPS threshold
;
	LDAA    L01FC			;TPS
	CMPA    L48D0			;2.7% TPS, max TPS threshold to be idling
	BHI     L8AEE			;Bra if TPS is >
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; MPH and TPS within limits to be idling, check quals for open loop idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BSET    L0050,#$80		;Status word, set b7, idling
	LDAA    L0295			;Open loop idle AFR 
	CMPA    L026D			;Compare to stored AFR
	BHI     L8AFC			;Bra if AFR < open loop idle AFR, disable 
					;open loop idle
;
;-AFR is richer then lean idle AFR limit here
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L48D8			;Threshold to remain in open loop idle
	BLS     L8AE9			;Bra if less, remain in open loop idle
;
	LDAB    L48D4			;Timer threshold to enable open loop idle 
	BEQ     L8AC9			;Bra if ==0, check INT thresholds
;
	LDX     #L400B			;Opt. byte
	BRSET   0,X,#$02,L8AB0		;Bra if b1==1, AIR enabled
;
;-Disable AIR if not enabled in opt. word
;
	BRSET   L0041,#$20,L8AFC	;Status word, bra if b5==1,in park/neutral
;
;-Here if AIR is enabled
;
L8AB0	BRCLR   L0050,#$02,L8AC1	;Status word, bra if not in open loop idle
;
;~~~~~~~~~~~~~~~~~~~
; In open loop idle
;~~~~~~~~~~~~~~~~~~~
;
	LDAB    L0294			;Idle timer
	CMPB    L48D5			;Timer threshold to remain in open loop idle 
	BLS     L8AD9			;Bra if timer <=, increment timer and cont.
;
;-Here to remain in open loop idle
;
	LDAA    L0295			;Open loop idle AFR
	BRA     L8B05			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Not in open loop idle, check quals to enter
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8AC1	LDAB    L48D4			;Timer threshold to enable open loop idle
	CMPB    L0294			;Idle timer
	BCC     L8AD9			;Bra if timer is <=, no open loop idle
;
;-Check INT thresholds for open loop idle
;
L8AC9	LDAB    #128			;Neutral INT value
	LDAA    L0232			;INT
	CMPA    #128			;Compare to neutral value
	BCC     L8AD3			;Bra if adding fuel
;
;-Fueling is leaning out
;
	NEGA				;Negate INT
;
L8AD3	ABA				;Sub out neutral INT to get diff. from neutral val.
	CMPA    L48EE			;Delta INT threshold to bar open loop idle
	BLS     L8AE4			;Bra if delta INT is less
;
;-INT threshold not yet met for open loop idle and AIR
;
L8AD9	LDAB    L0002			;Loop counter
	CMPB    #$27			;Counter val to update timer
	BNE     L8B02			;Bra if !=
;
	INC     L0294			;+1, idle timer
	BRA     L8B02			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to enable open loop idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8AE4	BSET    L0050,#$02		;Status word, set b1, open loop idle
	BRA     L8AFF			;Bra to continue
;
;-Alternate entry point if not resetting idle timer
;
L8AE9	BSET    L0050,#$02		;Status word, set b1, open loop idle
	BRA     L8B05			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~
; Here if not idling
;~~~~~~~~~~~~~~~~~~~~
;
L8AEE	LDD     L00F8			;Engine run time
	CPD     L48D6			;Engine run time to clear initial idle terms
	BCS     L8AF9			;Bra if timer is <
;
	BSET    L003F,#$40		;Status word, set b6, clear initial added IAC flow
;											
L8AF9	BCLR    L0050,#$80		;Status word, clear b7, idle flag
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here to disable open loop idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:
L8AFC	BCLR    L0050,#$02		;Clear open loop idle flag
;											
L8AFF	CLR     L0294			;Clear idle timer
;											
L8B02	LDAA    L026D			;Stored AFR
											 
L8B05	BRSET   L003E,#$80,L8B3F	;Status word, bra if b7==1, in closed loop
;
;~~~~~~~~~~~~~~~~~~~
; In open loop here
;~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0004,#$10,L8B13	;Status word, bra if b4==0, no hot restart
;
;-Hot restart in effect
;										   	
	SUBA    L4952			;Subtract AFR bias for hot restart 
	BCC     L8B13			;Bra if no underflow
;
	CLRA				;Clear underflow
;
;-Hot restart not in effect, check temp limits for open loop AFR enrichment
;
L8B13	LDAB    L0006			;Cool temp, linear
	CMPB    L48DA			;Lower temp limit for open loop enrichment
	BLS     L8B3F			;Bra if cool temp <=
;										   	
	CMPB    L48DB			;Upper temp limit for open loop enrichment
	BCC     L8B3F			;Bra if temp >=
;										   	
	BRSET   L0041,#$20,L8B39	;Status word, bra if b5==1, in park/neutral
;	
;-In drive
;									  	
	LDAB    L082C			;Initial AFR enrichment timer
	CMPB    L48DB			;Upper temp limit for open loop enrichment
	BHI     L8B3F			;Bra if timer >
;										  	
	INCB				;+1
	BEQ     L8B31			;Bra if roll over
;										  	
	STAB    L082C			;Save timer
;	
;-Apply initial AFR enrichment 
;										
L8B31	SUBA    L48E0			;Subtract initial AFR entrichment
	BCC     L8B3F			;Bra if no overflow
;										  	
	CLRA				;Clear overflow
	BRA     L8B3F			;Bra to continue				
;
;-Here if in park/neutral 
;											
L8B39	SUBA    L48E1			;Park/neutral open loop AFR enrichment
	BCC     L8B3F			;Bra if no overflow
;
	CLRA				;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if closed loop flagged
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8B3F	LDAB    L4909			;Lean AFR limit
	BRCLR   L0072,#$40,L8B49	;Status word, bra if b6=0, no err 44, lean O2
;
;-Error 44 present
;
	LDAB    L4E71			;Lean AFR limit if err 44
;
L8B49	CBA				;Compare AFR to AFR limit
	BLS     L8B4D			;Bra if AFR is richer
;
	TBA				;Use AFR limit instead
;
;-Check for transition to run
;
L8B4D	LDAB    L028B			;Elapsed DRPs
	CMPB    L4955			;DRP threshold to transition from crank to run
	BCS     L8B6B			; 
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L4957			;Threshold to add AFR transition ratio in
	BHI     L8B64			;Bra if Cool temp >, add it in
;
;-Subtracting AFR, richen transition
;
	SUBA    L02EC			;Subtract AFR crank transition ratio
	BCC     L8B6B			;Bra if no underflow
;
	CLRA				;Clear underflow
	BRA     L8B6B			;Bra to continue					
;
;-Adding AFR, lean out transition
;
L8B64	ADDA    L02EC			;Add AFR crank transition ratio
	BCC     L8B6B			;Bra if no overflow
;
	LDAA    #$FF			;Clear overflow
;
L8B6B	STAA    L026D			;Save it, AFR
	BRSET   L004F,#$10,L8B75	;Status word, bra if b4==1, engine running 
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Engine not running yet
;~~~~~~~~~~~~~~~~~~~~~~~~
;
	JMP     L8D50			;				
;
;~~~~~~~~~~~~~~~~~~~~~
;-Engine running here
;~~~~~~~~~~~~~~~~~~~~~
;
;-check thresholds to bar delta speed fast entry into PE
;	
L8B75	LDAA    L02A7			;MPH
	CMPA    L4917			;Min speed threshold for delta MPH fast
					;entry into PE
	BCC     L8B8D			;Bra if MPH greater
;
	LDAA    L01FC			;TPS
	CMPA    L4918			;TPS threshold for delta MPH fast entry into PE
	BHI     L8B8D			;Bra if TPS >
;
;-Bar delta speed entry into PE here if low speed/throttle present
;
	BSET    L003D,#$01		;Set b0, no delta speed entry into PE allowed
	CLR     L0286			;Clear delta speed PE entry timer
	BRA     L8B9C			;Bra to continue
;
;-Here to bar delta speed entry into PE for period of time
;										
L8B8D	LDAA    L0286			;Delta PE entry timer
	CMPA    L4919			;Threshold to continue to bar delta speed entry
	BCC     L8B9C			;Bra if timer >=
;
	INCA				;+1
	STAA    L0286			;Save PE entry timer										
	BSET    L003D,#$01		;Set b0, delta speed fast PE entry not allowed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Lookup TPS threshold for WOT vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8B9C	LDAB    #32			;800 RPM, offset for lookups
	LDX     #L4C50			;TPS threshold for WOT table
	LDAA    L0062			;RPM/25
	JSR     LF137			;2D lookup with UL
;
	STAA    L0203			;Save it, TPS threshold for WOT
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Lookup fast PE delay timer countdown rate vs. RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Decreases time to enter PE if TPS > L0203
;
	LDX     #L4C75			;Fast PE delay timer countdown rate 
	LDAA    L0062			;RPM/25
	JSR     LF137			;2D lookup with UL
;											
	STAA    L0204			;Fast PE delay timer countdown rate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Lookup TPS threshold for PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4C5A			;TPS threshold for PE table 
	LDAA    L0062			;RPM/25
	JSR     LF137			;2D lookup with UL
;											
	STAA    L0205			;Save it, TPS threshold for PE
	TAB				;Get threshold into B     
;  
	BRCLR   L003D,#$20,L8BCA	;Status word, bra if b5==0, not in PE
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Check threshold for PE
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;-In PE here, apply hysteresis
;
	SUBB    L490D			;TPS hyst. remain in PE
	BCC     L8BCA			;Bra if no underflow
;
	CLRB				;Clear underflow  
;
;-Not in PE here
;  
L8BCA	CMPB    L01FC			;Compare to TPS
	BCS     L8BD2			;Bra if TPS >, continue with PE quals.
;
;-TPS is less then that needed to enter PE
;
	JMP     L8CDF			;Skip PE
;
L8BD2	BRSET   L003F,#$20,L8C34	;Status word, bra if b5==1, bypass PE delay 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals to bypass PE delay
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0063			;RPM/12.5
	SUBA    L0065			;RPM/12.5, one delayed
	BCC     L8BDD			;Bra if RPMs rising
;
;-RPMs falling here
;
	CLRA				;Clear delta RPM/12.5    
;
L8BDD	CMPA    L490A			;Delta RPM to bypass PE delay
	BLS     L8BE8			;Bra if delta RPMs <= 
;
;-RPMs rising fast enough to bypass PE delay
;

	BSET    L003F,#$20		;Status word, set b5, bypass PE delay 
	JMP     L8C34			;Jump to enter PE
;
L8BE8	LDAB    L0006			;Cool temp, linearized
;
;-Check upper cool temp threshold to bypass PE delay
;
	CMPB    L490C			;Upper cool temp threshold to bypass PE delay
	BHI     L8C34			;Bra if cool temp >, bypass delay
;
;-Check lower cool temp threshold to bypass PE delay
;
	CMPB    L490B			;lower cool temp threshold to bypass PE delay/
					;allow for AFR adjustments
	BLS     L8C34			;Bra if cool temp less, bypass delay
;
;-Check for high RPMs
;
	LDAB    L490E			;Upper RPM threshold for PE delay/AFR adj.
	CMPB    L0062			;RPMs/25
	BLS     L8C34			;Bra if RPMs >=
;
;-Check TPS baro factor for PE 
;
	LDAA    L0206			;TPS baro correction factor
	LDAB    L01FC			;TPS
	SUBB    L01FE			;TPS, one delayed
	BCS     L8C09			;Bra if TPS is falling
;
;-TPS rising here
;
	CBA				;Compare delta TPS baro factor to delta TPS     
	BLS     L8C31			;Bra if TPS is greater, bypass PE delay
;
L8C09	LDAA    L01F0			;Baro PE RPM threshold 
	CMPA    L0062			;RPM/25
	BLS     L8C17			;Bra if RPMs >=
;
;-RPMs less then baro threshold here
;  
	BRSET   L003D,#$20,L8C17	;Status word, bra if PE in effect
; 
	JMP     L8CDF			;Bar entry into PE if not already in effect
;
L8C17	BRSET   L003D,#$01,L8C1E	;Status word, bra if b0==1, delta speed fast PE
					;entry not allowed
;
;-Jump to check delta MPH threshold for fast PE entry
;  
	JMP     L8CD6			;Continue, check delta MPH theshold to enter PE
;
;-Here if delta MPH fast PE entry not allowed
;
L8C1E	LDAB    L029A			;PE delay timer
	CMPB    L4910			;Delay for PE to become active											; SLEW RATE
	INCB				;+1
	BCS     L8C3A			;Bra if PE delay timer is <
;
	LDAB    L029B			;PE ramping multiplier
	ADDB    L4911			;Add in ramping rate
	BCC     L8C36			;Bra if no overflow
;	
	BRA     L8C34			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to bypass PE delay
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8C31	BSET    L003F,#$20		;Status word, set b5, bypass PE delay next pass
;	
L8C34	LDAB    #255			;Clear overflow from previous op.
;
L8C36	STAB    L029B			;Save it, PE ramping multiplier
;
L8C39	CLRB				;Reset PE delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if timer less then threshold to bring in PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
L8C3A	STAB    L029A			;Save PE delay timer   
	BSET    L003D,#$20		;Status word, set b5, PE now underway
;
;-Look up PE AFR
;
	LDX     #L4C64			;PE AFR vs. RPM table
	LDAA    L0062			;RPM/25
	JSR     LF15E			;2D lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for short term PE AFR enleanment
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	TAB				;Get PE AFR into B     
	LDAA    L028C			;PE timer
	CMPA    L4913			;Threshold for extended PE
	BHI     L8CA4			;Bra if if time in PE >
;
;-Not in extended PE yet
;
	LDAA    L0002			;Loop counter
	CMPA    #$07			;Counter val, 1 sec
	BNE     L8C5A			;Bra if !=, dont inc timer
;
	INC     L028C			;PE timer
;
;-Check RPM/cool temp to allow PE AFR adjustments
;
L8C5A	LDAA    L0062			;RPM/25			
	CMPA    L490E			;Upper RPM threshold for PE delay/AFR adj.											; BYPASS PE DELAY  
	BCC     L8CA4			;Bra if RPMs greater
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L4914			;Upper cool temp threshold to allow adjustments
	BHI     L8CA4			;Bra if cool temp >
;
	CMPA    L490B			;lower cool temp threshold to bypass PE delay/
					;allow for AFR adjustments
	BLS     L8CA4			;Bra if cool temp is <=
		
	LDAA    L01FC			;TPS
	CMPA    L0203			;TPS threshold for WOT
	BHI     L8CA4			;Bra if TPS >, skip adjustments
;
;-Lean PE AFR out if needed to smooth engagement of PE
;
	SUBA    L0205			;Subtract TPS threshold for PE
	BCC     L8C7C			;Bra if no underflow
;
;			          TPS - TPS threshold for PE
;-Ratio for enleanment = ------------------------------------------
;			  WOT TPS threshold - TPS threshold for PE
;
	LDAA    #$0000			;Clear underflow
	PSHB				;Push PE AFR to stack
	PSHA				;Push delta TPS to stack
	LDAA    L0203			;TPS threshold for WOT
	SUBA    L0205			;Subtract TPS threshold for PE
	BCC     L8C88			;Bra if no underflow
;
	LDAA    #$0000			;Clear underflow
;
;-Adjustment = Enleanment AFR - Enleanment AFR x ratio
;
L8C88	CLRB				;Preclear B
	XGDX				;Swap result into X
	PULA				;Get delta TPS back
	CLRB				;
	FDIV				;Divide delta TPS above PE threshold
					;by delta WOT TPS above threshold
	XGDX				;Get FDIV result into D
	LDAB    L491B			;Base PE enleanment AFR 
	MUL				;Ratio x AFR
	ADCA    #$00			;Round if needed
	TAB				;Get result into B
	LDAA    L491B			;Load enleanment AFR 
	SBA				;Subtract result
	BCC     L8C9D			;Bra if no underflow
;
	LDAA    #$0000			;Clear underflow
;
L8C9D	PULB				;Get PE AFR back
	ABA				;Add in adjustment
	BCC     L8CA3			;Bra if no overflow
;
	LDAA    #$FF			;Clear overflow
;
L8CA3	TAB				;Get result into B
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to skip PE AFR adjustments
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8CA4	LDAA    L0006			;Cool temp
	CMPA    L4912			;Threshold for cold PE
	BHI     L8CC0			;Bra if cold temp >
;
;-Cool PE in effect
;
	LDAA    L0062			;RPM/25
	CMPA    L4915			;Lower RPM limit for cold PE AFR enrichment
	BCC     L8CC0			;Bra if RPMs >
;
	LDAA    L02A7			;MPH
	CMPA    L4916			;MPH limit for cold PE AFR enrichment
	BCC     L8CC0			;Bra if MPH >=
;
;-Low speed cold PE in effect
;
	SUBB    L491A			;Subtract cold PE AFR enrichment
	BCC     L8CC0			;Bra if no underflow
;
	CLRB				;Clear underflow
;
L8CC0	LDAA    L026D			;AFR
	SBA				;Subtract modified PE AFR, now delta AFR for PE
	BLS     L8D1B			;Bra if current AFR is equal or richer
;
;-Ramp the PE AFR in for a smooth entry into PE
;
	LDAB    L029B			;PE ramping multiplier
	MUL				;Mult. x delta AFR
	ADCA    #00			;Round if needed
	TAB				;Get MSB of result into B
	LDAA    L026D			;AFR
	SBA				;Subtract delta AFR
	STAA    L026D			;Save it, AFR
	BRA     L8D1B			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to check delta MPH threshold for PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8CD6	LDD     L0818			;Delta MPH
	CPD     L491C			;Delta MPH threshold for PE 										; ENRICH IF L.T. 0 MPH  
	BCC     L8CF0			;Bra if delta MPH are greater, enter PE
;
;~~~~~~~~~~~~~~~~~
; Here to exit PE
;~~~~~~~~~~~~~~~~~
;
L8CDF	LDAB    L0299			;PE reset/delay timer
	CMPB    L490F			;Time out of PE to reset
	INCB				;+1
	BCS     L8D0C			;Bra if timer is less, dont reset yet
;
;-Here to reset for next power enrich
;										
	CLR     L029B			;PE AFR ramping multiplier
	CLR     L028C			;PE timer
	BRA     L8D15			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~
; Here to enter PE
;~~~~~~~~~~~~~~~~~~
;
L8CF0	LDAB    L0299			;PE reset/delay timer
	BNE     L8CFB			;Bra if timer !=0, have not reset yet
;
;-PE delay timer has expired, check quals for PE
;  
	BSET    L003D,#$01		;Status word, set b0, bar delta speed fast entry
					;into PE and check quals
	JMP     L8C39			;Bra to check quals for PE
;
;-Here if recently in PE
;
L8CFB	LDAA    L01FC			;TPS
	CMPA    L0203			;TPS threshold for WOT
	BLS     L8D0B			;Bra if TPS <=, not at WOT
;
;-Wide open throttle preset
;
	SUBB    L0204			;Fast PE delay timer countdown rate
	BCC     L8D0C			;Bra if no underflow
;
	CLRB				;Clear underflow
	BRA     L8D0C			;Bra to continue
;
;-Here if intermediate throttle position
;
L8D0B	DECB				;-1, PE reset/delay timer
;
L8D0C	LDAA    L0002			;Loop counter
	CMPA    #$0017			;
	BNE     L8D15			;Bra if timer !=, dont decrement/increment counter
;
	STAB    L0299			;PE reset/delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to exiting or delaying entry into PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
L8D15	BCLR    L003D,#$21		;Status word, clear b0, b5, PE flags
	BCLR    L003F,#$20		;Status word, clear b5, bypass PE flag
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if PE already underway
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
L8D1B	LDAA    L01FC			;TPS
	STAA    L01FE			;Save it, TPS, one delayed
	BRCLR   L0052,#$40,L8D36	;Status word, bra if b6==0, no cat overtemp
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Cat overtemp present, limit AFRs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0255			;Gms/sec airflow
	LDX     #L498F			;AFR limit for cat overtemp table
	JSR     LF15E			;2D lookup
	CMPA    L026D			;Compare to current AFR
	BHI     L8D36			;Bra if current AFR is richer
;
	STAA    L026D			;Save AFR limit instead
;
;~~~~~~~~~~~~~~~~~~~~~
; Check ALDL status
;~~~~~~~~~~~~~~~~~~~~~
;
L8D36	BRCLR   L003B,#$10,L8D49	;Status word, bra if b4==0, not in mode 4 
;
;-In mode 4
;
	LDAA    L0397			;				
	BITA    #$04			;
	BEQ     L8D49			;
;
	LDAA    L0399			;
	STAA    L026D			; 
	BRA     L8D50			;
;
;~~~~~~~~~~~~~~~~~~~~ 
; Check for heads up
;~~~~~~~~~~~~~~~~~~~~
;
L8D49	BRCLR   L0082,#$40,L8D50	;Status word, bra if b6==0, no HU
;
	JSR     L1800			;
;
L8D50	LDAA    L026D			;AFR
	STAA    L026E			;Stored AFR
;
;-Check if its time to update delta MPH
;
	LDAA    L0002			;Loop counter
	CMPA    #$9F			;
	BNE     L8D71			;Bra if counter !=, dont update yet
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Compute delta MPH term for PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDD     L02A7			;MPH
	SUBD    L081A			;MPH, one delayed
	BCC     L8D68			;Bra if no underflow
;
	NEGA				;Negate, get abs. value 		   
	NEGB				;		    
	SBCA    #$00			;Perform carry if needed
;
L8D68	STD     L0818			;Save it, delta MPH for PE entry
	LDD     L02A7			;MPH
	STD     L081A			;Save it, MPH, one delayed
;
;~~~~~~~~~~~~~~~~~~~
; BLM cell handling
;~~~~~~~~~~~~~~~~~~~
;    
L8D71	BCLR	L003D,#$04		;Status word, clear b2, BLM cell change
;									
	LDAA    L48EC			;Opt. byte
	BITA    #$01			;Test b0, use seperate idle cells
	BEQ     L8DAE			;Bra if ==0. dont use seperate cells
;
;-Check TPS threshold for idling
;
	LDAB    L01FC			;TPS
	CMPB    L48D0			;TPS threshold to be idling
	BCC     L8DAE			;Bra if TPS >=, not idling
;
;-Check MPH threshold for idling
;
	LDAB    L02A7			;MPH
	CMPB    L48CF			;Max speed to be idling
	BCC     L8DAE			;Bra if VSS >=
;
;-Check if using seperate cells for A/C 
;
	LDAB    #16			;Start of idle BLM cells 
	BITA    #$02			;Test b1, seperate idle BLM cell when A/C on
	BEQ     L8D96			;Bra if ==0, dont use seperate cells
;
	BRCLR   L0041,#$10,L8D96	;Status word, bra if b4==0, A/C not on 
;
	INCB				;+1, advance to A/C idle cells
;
;-Check if using seperate cell for P/N
;
L8D96	BITA    #$04			;Test b2, seperate park/neutral cell
	BEQ     L8DA0			;Bra if ==0
;
	BRCLR   L0041,#$20,L8DA0	;Status word, bra if not in P/N
;
	ADDB    #2			;+2, advance to park/neutral cell
;
;-Check for single fire mode
;	
L8DA0	BRCLR   L0051,#$01,L8DA6	;Bra if b0==0, not in single fire mode
;
	LDAB    #20			;Use cell #20 if in single fire
;
L8DA6	CMPB    L026A			;Current BLM cell #
	BEQ     L8E1D			;Bra if still using the same cell
;
;-BLM cell has changed
;	
	JMP     L8E56			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not idling, check BLM cell bounds
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8DAE	LDAB    L026A			;Load current BLM cell #
	CMPB    #16			;Start of idle cells
	BCC     L8E1F			;Bra if currently using an idle BLM cell
;
;-Not currently in an idle cell, check RPM bounds
;
	ANDB    #$03			;Clear all but lower 2 bits
	LDX     #L48E4			;Index start of BLM boundries
	ABX				;add in current BLM cell #    
	DEX				;-1, move to previous boundry  
;
;-Check lower RPM bound
;   
	TSTB				;Test BLM cell #    
	BEQ     L8DCE			;Bra if currently at the lowest RPM bound
;
	LDAA    0,X			;Load RPM boundry
	SUBA    L48EA  			;Subtract RPM hyst. for cell change
	BCS     L8DCA			;Bra if underflow
;
	CMPA    L0062			;RPM/25
	BHI     L8E1F			;Bra if RPMs <, bra to change cells
;
;-Check current RPM boundry
;
L8DCA	CMPB    #3			;Upper RPM boundry
	BEQ     L8DD9			;Bra if already at upper RPM boundry
;
L8DCE	LDAA	1,X			;Get current RPM boundry
	ADDA    L48EA 			;Add in RPM hyst. for cell change
	BCS     L8DD9			;Bra if overflow	
;
	CMPA    L0062			;Compare to RPM/25
	BCS     L8E1F			;Bra if RPMs >change cells
;
;-Check MAP boundries
;
L8DD9	LDAB    L026A			;Get current BLM
	ANDB    #$0C			;Clear all but bits 2 and 3
	LSRB				;Shift right to get BLM boundry #
	LSRB				;Shift right again  
	LDX     #L48E7			;Get start addr of BLM MAP boundries
	ABX				;Add in BLM cell # as offset
	DEX				;-1, move to previous boundry     
	TSTB				;Test boundry #    
	BEQ     L8E04			;Bra if already at lowermost boundry
;
;-Check lower MAP boundry
;
	LDAA    0,X			;Load lower MAP boundry
	SUBA    L48EB			;Subtract MAP hyst. for cell change 
	BCS     L8E00			;Bra if underflow
;
	LDY     #L400E			;Opt. byte
	CMPA    L01F2			;MAP/baro ratio
	BRSET   0,Y,#$01,L8DFE		;Opt. byte, bra if b0==1, use MAP/baro ratio 
					;for BLM map boundries
;
	CMPA    L01E3			;Compare to SD MAP instead
;
L8DFE	BHI     L8E1F			;Bra if MAP <, change cells
;
L8E00	CMPB    #3			;Uppermost BLM cell #
	BEQ     L8E1A			;Bra if already at uppermost cell
;
;-Check current MAP boundry
;
L8E04	LDAA    1,X			;Load in current MAP boundry
	ADDA    L48EB			;Add in hyst. for cell change
	BCS     L8E1A			;Bra overflow
;
	CMPA    L01F2			;MAP/baro ratio
;
	LDX     #L400E			;Opt. byte
	BRSET   0,X,#$01,L8E18		;Opt. byte, bra if b0==1, use MAP/baro ratio 
					;for BLM map boundries
;											 
	CMPA    L01E3			;Compare to SD MAP instead
;
L8E18	BCS     L8E1F			;Bra if MAP is >, change cells
;
L8E1A	LDAB    L026A			;Load in current BLM cell #
;
L8E1D	BRA     L8E5C			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to change cells based on RPM/MAP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8E1F	CLRB				;Clear cell # 
	LDAA    L0062			;Load RPM/25
	CMPA    L48E4			;Lowermost RPM boundry
	BCS     L8E34			;Bra if RPMs <, use current boundry
;
	INCB				;+1, adv. BLM to next set of cells
	CMPA    L48E5			;Middle RPM boundry
	BCS     L8E34			;Bra if RPMs <, use current boundry
;
	INCB				;+1, adv. BLM to next set of cells 
	CMPA    L48E6			;Uppermost RPM boundry
	BCS     L8E34			;Bra if RPMs <, use current boundry
;
	INCB				;+1, adv. BLM to next set of cells
;
L8E34	LDAA    L01F2			;MAP/baro
;
	LDX     #L400E			;Opt. byte, use MAP/baro ratio
	BRSET   0,X,#$01,L8E41		;Bra if b0==1, use ratio for cell change
;
	LDAA    L01E3			;Load SD MAP instead
;
L8E41	CMPA    L48E7			;Lower BLM MAP boundry
	BCS     L8E56			;Bra if MAP >, use current cell row
;
	ADDB    #$04			;+4, advance to next row 
	CMPA    L48E8			;Middle BLM MAP boundry
	BCS     L8E56			;Bra if MAP >, use current cell row
;
	ADDB    #$04			;+4, adv. to next cell row
	CMPA    L48E9			;Uppermost BLM cell boundry
	BCS     L8E56			;Bra if MAP >, use current cell row
;
	ADDB    #$04			;+4, advance to uppermost cell row
;
;-Here if idling
;   
L8E56	BSET    L003D,#$0C		;Status word, set b2, BLM cell change, and 
					;b3, delay BLM update
	BSET    L006E,#$01		;Status word, set b0, BLM cell change (EGR diags.)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Get current BLM and check limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8E5C	LDX     #L02D6			;Start of BLM cells
	ABX				;Add in offset to get current BLM cell    
	LDAA    0,X			;Load BLM
	CMPA    L48F2			;Upper limit to adjust BLM
	BHI     L8E75			;Bra if BLM >, no update
;
	CMPB    #16			;Start of BLM idle cells
	BCS     L8E70			;Bra if in an idle cell 
;
	CMPA    L48F0			;Min BLM if not idling
	BRA     L8E73			;
;
;-Here if in an idle cell, check alternate limit for BLM
;
L8E70	CMPA    L48EF			;Min BLM if idling
;
L8E73	BCC     L8E7B			;Bra if BLM is >= threshold
;
;-Reset BLM cells if BLM falls below lower bound
;
L8E75	BSET    L0046,#$40		;Status word, set b6, BLM cells reset
	JSR     LEF1D			;BLM cell reset routine
;
L8E7B	STAA    L026B			;Save BLM
	STAB    L026A			;Save BLM cell #
	LDX     #L400C			;Opt. byte
	BRSET   0,X,#$10,L8ED2		;Bra if b4==1, always flag cell change
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals to flag BLM cell change
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L01FC			;TPS
	CMPA    L48D0			;TPS threshold to be idling
	BCS     L8E99			;Bra if TPS <=, idling
;
;-Not idling here
;
	BRCLR   L0052,#$04,L8EA2	;Status word, bra if b2==0, idle bit cleared already
;	
	BCLR    L0052,#$04		;Clear b2, engine idling (BLM routine)
	BRA     L8ECC			;Bra to continue
;
;-Here if idling
;
L8E99	BRSET   L0052,#$04,L8EA2	;Bra if idle already flagged
;
	BSET    L0052,#$04		;Status word, set b2, engine idling (BLM routine)
	BRA     L8ECC			;Bra to continue
;
;-Here if no change in status (idle/open throttle)
;
L8EA2	LDAA    L026C			;BLM, one delayed
	SUBA    L026B			;Current BLM
	BEQ     L8EC9			;Bra if no change
;
;-BLM has changed
;
	BMI     L8EBB			;Bra if BLM falling
;
;-BLM is rising here, check delta limit to flag BLM cell change
;
	CMPA    L48FF			;Rising delta BLM threshold to clear BLM cell change 
	BCS     L8EC9			;Bra if BLM change < no dont flag change
;
	LDAA    L0232			;INT
	CMPA    L48FD			;Lower INT threshold to flag change in BLMs
	BHI     L8EC9			;Bra if INT higher, dont flag change if going
					;leaner overall
;
	BRA     L8ECC			;Bra, will be flagging BLM cell change
;
;-Here if BLM falling
;
L8EBB	NEGA				;Get abs. value    
	CMPA    L4900			;Falling delta BLM threshold to clear BLM cell
					;change
	BCS     L8EC9			;Bra if BLM cell change <, dont flag change
;
	LDAA    L0232			;Current INT
	CMPA    L48FE			;Upper INT threshold to flag change
	BCC     L8ECC			;Bra if INT >=
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Little or no change in BLM, dont flag BLM cell change
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8EC9	BCLR    L003D,#$04		;Status word, clear b2, BLM cell change
;
;-Here if flagging cell change
;
L8ECC	LDAA    L026B			;Load BLM
	STAA    L026C			;Save it, BLM, one delayed
;
L8ED2	LDAA    L0263			;Filtering execution timer
	BNE     L8EFD			;Bra if !=0, dont perform filtering yet
;
	LDAA    L48BE			;Execution interval
	STAA    L0263			;Save it, timer
;
;-Filter the TPS
;
	LDAB    L48BF			;Slow filtered TPS filter coeff.
	LDX     L0201			;Slow filtered TPS
	LDAA    L01FC			;TPS
	JSR     LF0F6			;Filter routine
;
	STD     L0201			;Save it, slow filtered TPS
;
;-Filter the MAP
;
	LDAB    L01EE			;Cool temp based filter coeff.
	LDX     L01EA			;SD MAP, filtered per cool tmp
	LDAA    L01E3			;SD MAP
	JSR     LF0F6			;Filter routine
;
	STD     L01EA			;Save it, S/D MAP, filt'd per cool tmp
	BRA     L8F00			;
;
;-Here if not executing filtering yet
;
L8EFD	DEC     L0263			;-1, Exec. timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Update BLMs based on INT and direction of fueling
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8F00	BRCLR   L003E,#$02,L8F4B	;Status word, bra if b1==0, not enabling BLM update
;
	BRSET   L003D,#$08,L8F4B	;Status word, bra if b3==1, delaying update
;
	LDAA    L0232			;INTegrator
	CMPA    #128			;Compare to neutral value
	BEQ     L8F4B			;Bra if INT is neutral
;
	LDAB    L0297			;BLM loop timer 
	INCB				;+1
	BMI     L8F1E			;Bra if >= 127, continue
;
;-Check to see if INT has updated yet
;
	STAB    L0297			;Save it
	ASLB				;x2 to match loop execution speed of parent loop   
	CMPB    L028E			;Compare to INT delay timer
	BCS     L8F89			;Bra if <, dont update BLM yet until INT
					;has updated
;
;-Check to see if enough time has passed to update the BLM
;
L8F1E	LDAB    L0296			;BLM update delay timer
	INCB				;+1   
	BEQ     L8F2C			;Bra if rollover
;
	STAB    L0296			;Save timer
	CMPB    L48E3			;BLM update frequency
	BCS     L8F89			;Bra if timer is <, no update
;
;-Update the BLMs
;
L8F2C	LDX     #L48ED			;Delta INT to update BLMs (also used in EGR test)
	LDY     #L48EF			;Lower BLM limit

	LDAB    L026A			;Load BLM cell #
	CMPB    #16			;Start of idle cells
	BCS     L8F3D			;Bra if not in an idle cell
;
;-In an idle cell
;
	INX				;Delta INT to update idle BLMs    
	INY				;Lower idle BLM limit
;     
L8F3D	SUBA    #128			;Subtract neutral value from INT
	BCS     L8F4E			;Bra if INT is < 128
;
;-Adding fuel here
;
	CMPA    0,X			;Delta INT needed to update BLM
	BLS     L8F89			;Bra if delta INT <=, no update
;
	BRSET   L003E,#$40,L8F89	;Status word, bra if b6==1, going richer, no update
;
;-Going leaner overall
;
	BRA     L8F57			;Bra to continue
;
;-Here if neutral INT
;
L8F4B	JMP     L8F82			;Exit routine
;
;-Removing fuel here
;
L8F4E	NEGA				;Get abs. value    
	CMPA    0,X			;Delta INT to update BLMs
	BLS     L8F89			;Bra if <=, no update
;
	BRCLR   L003E,#$40,L8F89	;Bra if b6==0, going leaner, no update
;
L8F57	LDX     #L02D6			;Start addr. of BLMs
	ABX				;Add in offset of current BLM
	LDAA    0,X			;Load current BLM
;
	BRCLR   L003E,#$40,L8F70	;Bra if going leaner
;
;-Decrement BLM
;
	SUBA    L48F1			;Subtract BLM step
	BCS     L8F6B			;Bra if underflow
;
	CMPA    0,Y			;Lower limit for BLM
	BCC     L8F7D			;Bra if BLMs >=, bra to save
;
L8F6B	LDAA    0,Y			;Load limit instead
	BRA     L8F7D			;Bra to save 
;
;-Increment BLM
;
L8F70	ADDA    L48F1			;Add in BLM step
	BCS     L8F7A			;Bra if overflow
;
	CMPA    L48F2			;Max BLM
	BLS     L8F7D			;Bra if BLMs <=
;
L8F7A	LDAA    L48F2			;Load limit instead
;
L8F7D	STAA    0,X			;Save BLM
	STAA    L026B			;Save as current BLM
;
;-Here to exit routine and reset timers
;
L8F82	CLRB				;   
	STAB    L0297			;Clear BLM loop timer
	STAB    L0296			;Clear BLM update timer
;
;-Here to exit routine
;
L8F89	BCLR    L003D,#$08		;Status word, clear b3, reset delay BLM update flag
	LDAA    L0063			;Load RPM/12.5
	STAA    L0065			;Save it, RPM/12.5, one delayed
;
	LDAA    L01F8			;A/D O2
	STAA    L01F7			;A/D O2, one delayed
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Engine governor PID subroutine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L8F97	LDX     #L400F			;Option byte
	BRCLR   0,X,#$01,L8FA6		;Bra if b0==0, no governor
;	
	BRCLR   L004F,#$80,L8FA6	;Status word, bra if b7==0, engine not running
;
;-Check for errors
;
	BRCLR   L006F,#$34,L8FAC	;Bra if b2, high TPS, b4, ???, and b5, low TPS error
					;flags not set
;
;-Here to disable governor
;
L8FA6	LDAA    #255			;Load max TPS
;
L8FA8	STAA    L02BC			;Save desired TPS output
	RTS				;Return     
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Here for RPM governor
;~~~~~~~~~~~~~~~~~~~~~~~
;
L8FAC	BCLR    L0075,#$04		;Status word, clear b2, RPM overspeed
;
	LDAA    L50CE			;Load upper RPM/25 threshold
	SUBA    L02B1			;Subtract governor RPM/25
	BCC     L8FBB			;Bra if delta rpms >=0
;
;-Engine speed greater then upper threshold
;
	NEGA				;Get abs. value    
	BSET    L0075,#$04		;Status word, set b2, RPM overspeed
;
;-Engine speed less then upper threshold
;											
L8FBB	STAA    L02B6			;Save it, RPM error
	BRCLR   L0082,#$40,L8FC7	;Status word, bra if b6==0, no HU
;
	JSR     L1809			;Do HU
;
	BCS     L8FA8			;Bra if carry set, save and return
;
;-Check MPH limit
;
L8FC7	LDAA    L50D0			;Upper MPH threshold
	BEQ     L901B			;Bra if ==0, skip speed governing 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to check for MPH overspeed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDD     L02A7			;MPH
	SUBA    L50D0			;Subtract upper MPH limit
	BCS     L8FFA			;Bra if MPH less
;
	ASLD				;MPH error x 2
	BCS     L8FDA			;Bra if overflow
;
	ASLD				;MPH error x 2
	BCC     L8FDD			;Bra if overflow
;
L8FDA	LDD     #$FFFF			;Clear overflow
;
L8FDD	STAA    L02B7			;Save it, MPH error											;
	BSET    L0075,#$40		;Status word, set b6, MPH overspeed
;
	BRSET   L0075,#$80,L9016	;Status word, bra if b7==1, in MPH govern 
;
;-Limit and update TPS if entering MPH govern
;
	LDAA    L50D7			;Upper limit for governor TPS
	CMPA    L01FC			;%TPS
	BCS     L8FF2			;Bra if TPS >, save limit instead
;
	LDAA    L01FC			;Load TPS
;
L8FF2	STAA    L02A9			;Save it, governor TPS
;											
	BSET    L0075,#$80		;Set b7, in MPH govern
	BRA     L9016			;Bra to continue
;
;-Here if MPH less then threshold
;
L8FFA	NEGA				;Get abs. value    
	NEGB				;    
	SBCA    #$00			;Perform carry if needed
	ASLD				;x2
	BCS     L9004			;Bra if overflow
;
	ASLD				;x2
	BCC     L9007			;Bra if overflow
;
L9004	LDD     #$FFFF			;Clear overflow
;
L9007	STAA    L02B7			;Save it, MPH error
	BCLR    L0075,#$40		;Clear b6, no MPH overspeed
	BRCLR   L0075,#$80,L901B	;Bra if b7==0, not in MPH govern  

	CMPA    L50D1			;Governor MPH error threshold to exit MPH govern
	BCC     L901B			;Bra if error >= 
;
;-Here to exit RPM governor if governing MPH
;
L9016	BCLR    L0075,#$13		;Status word, clear b4, post-derivative TPS return,
					;b1, derivative action anticipated, 
					;and b0, in RPM govern
	BRA     L901E			;Bra to continue
;
;-Here if not governing MPH
;
L901B	BCLR    L0075,#$80		;Clear b7, in MPH govern
;
L901E	BRCLR   L0075,#$04,L9039	;Bra if b2==0, no RPM overspeed 
;						
	LDAB    L0075			;Status word
	BITB    #$81			;Test b7, gov. MPH, and b0, gov. RPM
	BNE     L9033			;Bra if performing RPM or MPH governing
;
;-Update governor TPS
;
	LDAA    L01FC			;%TPS
	CMPA    L02A9			;Governor TPS
	BHI     L9033			;Bra if TPS >=, no update
;
	STAA    L02A9			;Save TPS as governor TPS
;
L9033	BSET    L0075,#$01		;Set b0, in RPM govern
	BCLR    L0075,#$12		;Clear b4, TPS post derivative return, and 
					;b1, derivative action anticipated
L9039	LDAB    L0075			;Status word
	BITB    #$81			;Test b7, MPH govern, and b0, RPM govern
	BNE     L9042			;Bra if !=0
;
	JMP     L90F3			;
;
L9042	LDX     #L50DE			;Proportional gain table vs. desired TPS output
	LDAA    L02BC			;Desired TPS output
	LSRA				;/2     
	JSR     LF136			;2D lookup with UL
;
	LDAB    L02B7			;Load MPH error
	LDX     #L50D5			;Start of governor params
	BRCLR   L0075,#$01,L905A	;Bra if b0==0, not in RPM govern
;
;-Load RPM error and terms instead if in RPM govern
;
	INX				;+1, in RPM govern     
	LDAB    L02B6			;Load RPM error
;
L905A	MUL				;Gain term x error     
	ASLD				;x2
	BCS     L9064			;Bra if overflow
;
	ASLD				;x2    
	BCS     L9064			;Bra if overflow
;
	ASLD				;x2, prescale to div. by 32    
	BCC     L9067			;Bra if no overflow
;
L9064	LDD	#$FFFF			;Clear overflow
;
L9067	STD     L02AD			;Save it, governor integral term 
	LDAA    0,X			;Load prop. multiplier term
	LDX     #L02AD			;Addr. of integral term
	JSR     LF1ED			;(A x X*)/256
;										
	STD     L02AD			;Save it, governor integral term
	LDAA    L50D3			;RPM prop. gain mult.
	LDAB    L02B6			;RPM error
	MUL				;RPM error x gain     
	ASLD				;x2    
	BCS     L9082			;Bra if no overflow
;
	ASLD				;x2   
	BCC     L9085			;Bra if no overflow
;
L9082	LDD     #$FFFF			;Clear overflow
;
L9085	STD     L02B3			;RPM prop. term
	CLR     L02B5			;Clear MPH prop. term
	BRCLR   L0075,#$80,L90AF 	;Bra if b7==0, not in MPH govern
;
;-Here if in MPH govern
;
	LDAA    L02B7			;Load MPH error
	LDAB    L50D4			;MPH proportioning gain term
	MUL				;MPH error x gain term
	ASLD				;x2
	BCS     L90A2			;Bra if overflow
;
	ASLD				;x2
	BCS     L90A2			;Bra if overflow
;
	ASLD				;x2
	BCS     L90A2			;Bra if overflow
;		
	ASLD				;x2
	BCC     L90A5			;Bra if no overflow

L90A2	LDD     #$FFFF			;Clear overflow
;
L90A5	STAA    L02B5			;Save it, MPH prop. term
	BRSET   L0075,#$04,L90AF	;Status word, bra if b2==1,  RPM overspeed 
;
	STD     L02B3			;RPM prop. term
;
L90AF	LDAB    L0075			;Status word
	BITB    #$44			;Test b2, RPM overspeed, b6, MPH overspeed
	BEQ     L90DB			;Bra if no overspeed
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; RPM/MPH overspeed here
;~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDD     L02A9			;Load governor TPS
	SUBD    L02AD			;Gov'r integral term
	BCS     L90C2			;Bra if underflow
;
	CMPA    L50D8			;Min desired TPS for overspeed
	BCC     L90C8			;Bra if governor TPS >=
;
L90C2	LDAA    L50D8			;Load min desired TPS
	JMP     L9176			;
;
L90C8	STD     L02A9			;Save it, governor TPS 
	SUBD    L02B3			;Subtract RPM/MPH prop. term
	BCS     L90D5			;Bra if underflow

	CMPA    L50D8			;Min desired TPS
	BCC     L90D8			;Bra if TPS >=

L90D5	LDAA    L50D8			;Load min desired TPS
;
L90D8	JMP     L917A			;Bra to exit
;
;~~~~~~~~~~~~~~~~~~~~~~
; Here if no overspeed
;~~~~~~~~~~~~~~~~~~~~~~
;
L90DB	LDD     L02A9			;Load governor TPS
	ADDD    L02AD			;Governor integral term
	BCC     L90E6			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
L90E6	STD     L02A9			;Save it, governor TPS
	ADDD    L02B3			;RPM/MPH governing prop. term
	BCC     L90F0			;Bra if overflow
;
	LDAA    #255			;Clear overflow
;
L90F0	JMP     L917A			;Bra to exit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if derivative action is needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L90F3	CLR     L02B5			;Clear MPH prop. term
	BRSET   L0075,#$02,L9120 	;Bra if b1==1, derivative action anticipated
;
	LDAA    L02B0			;Delta governor RPMs/25
	BMI     L9144			;Bra if RPMs falling
;
;-RPMs rising here
;
	CMPA    #32			;800 rpm, allowed upper limit for delta RPM
	BLS     L9105			;Bra if <=			
;
	LDAA    #32			;Load max rpms
;
L9105	LDX     #L50E4			;Derivative RPM thresholds vs delta RPMs table
	JSR     LF153			;2D lookup with line count
;
	CMPA    L02B1			;Governor RPM/25			
	BCC     L9144			;Bra if  gov'r RPM/25 <=
;
;-RPMs high enough for derivative action
;
	BSET    L0075,#$02		;Set b1, derivative action anticipated
	LDAA    L50D7			; 0% MAX DESIRED TPS% AT LEAD MODE START
	CMPA    L01FC			; TPS
	BLS     L916E			;Bra if TPS >=
;
	LDAA    L01FC			;Load TPS
;
	BRA     L916E			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Apply derivative action if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9120	BRSET   L0075,#$10,L912A	;Bra if b4==1, post-derivative TPS return
;
	CLRA				;Preclear A    
	SUBA    L02B0			;Delta gov'r RPM/25
	BLT     L9148			;Bra if gov'r RPMs rising
;
;-RPMs falling here, allow throttle to return
;
L912A	BSET    L0075,#$10		;Set b4, post-derivative TPS return 
	LDAA    L02BC			;Desired governing TPS to be outputted
	LDAB    L50DC			;High desired TPS return gain
	CMPA    L50DB			;Threshold for high desired TPS 
	BCC     L913B			;Bra if >=
;
	LDAB    L50DD			;Low desired TPS return gain
;
L913B	LDAA    L02B6			;RPM error
	MUL				;RPM error x gain factor     
	ADDD    L02A9			;Add in governor TPS
	BCC     L9177			;Bra if no overflow
;
L9144	LDAA    #255			;Load max TPS
	BRA     L9176			;
;
;-RPMs rising here, apply derivative action
;
L9148	LDX     #L50F0			;TPS derivative gain factor vs. cool temp
	LDAA    L0006			;Cool temp, linear
	CMPA    #128			;56 deg C, upper limit for lookup
	BLS     L9153			;Bra if cool temp <=
;
	LDAA    #128			;Load max, 56 deg C
;
L9153	LSRA				;cool temp/2 for lookup
	JSR     LF15E			;2D lookup
;
	LDAB    L02B0			;Load delta gov'r RPMs/25
	MUL				;delta RPMs x gain    
	ASLD				;x2    
	BCS     L9161			;Bra if overflow
;
	ASLD				;x2    
	BCC     L9164			;Bra if no overflow 
;
L9161	LDD     #$FFFF			;Clear overflow
;
L9164	TAB				;Get result into B     
	LDAA    L02A9			;Governor TPS
	SBA				;Subtract derivative term      
	LDAB    L02AA			;Load LSB of gov'r tps
	BCS     L9173			;Bra if underflow
;
L916E	CMPA    L50D9			;Min desired TPS for derivative action
	BCC     L9176			;Bra if TPS >=
;
L9173	LDAA    L50D9			;Load  min TPS
;
L9176	CLRB				;Clear LSB
;
L9177	STD     L02A9			;Save it, governor TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to save desired outputted TPS and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L917A	LDAB	L0075			;Status word
	BITB    #$84			;Test b7, in MPH govern, and b2, RPM overspeed 
	BEQ     L919A			;Bra if ==0
;
	BRSET   L0075,#$40,L918D	;Bra if b6==1, MPH overspeed
;
;-No MPH overspeed, add in MPH prop. term
;
	ADDA    L02B5			;Add in MPH prop. term
	BCC     L919A			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
	BRA     L919A			;
;
;-Here if MPH overspeed, subtract MPH prop. term
;
L918D	SUBA    L02B5			;Subtract MPH prop. term
	BCS     L9197			;Bra if undrflow
;
	CMPA    L50D8			;Min desired TPS
	BCC     L919A			;Bra if outputted TPS is >=

L9197	LDAA    L50D8			;Load min desired TPS
;
L919A	STAA    L02BC			;Save it, desired outputted TPS
	BITB    #$11			;Test b4, RPM TPS lead return, and b0, 
;					;RPM govern in effect
	BEQ     L91B5			;Bra if ==0
;
	LDAB    L02AB			;Actuator integral term
	BNE     L91B5			;
;
	BRCLR   L0075,#$01,L91B2	;Bra if b0==1, not in RPM govern
;
	LDAA    L02B1			;Governor RPM/25
	CMPA    L50CF			;Min governor RPM
	BCC     L91B5			;Bra if RPMs >=
;
L91B2	BCLR    L0075,#$13		;Clear b4, RPM TPS lead, b1, 
;
L91B5	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Governor actuator PID control routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L91B6	LDAB    L02BC			;Desired TPS to be outputted
	SUBB    L01FC			;Subtract current TPS
	BCC     L91BF			;Bra if TPS error >=0
;
;-TPS error < 0
;
	NEGB				;Get abs val
;    
L91BF	STAB    L02BD			;Save it, TPS error
;
;-Compute actuator prop. gain
;
	LDX     #L50F5			;Actuator %DC prop. gain vs. %TPS error table
	LDAA    L02BD			;TPS error
	JSR     LF153			;2D lookup with line count
;
	LDAB    L02BD			;Load TPS error
	MUL				;TPS error x prop. gain      
	ASLD				;x2
	BCS     L91D5			;Bra if overflow
;
	ASLD				;x2
	BCC     L91D8			;Bra if no overflow
;
L91D5	LDD     #$FFFF			;Clear overflow
;
L91D8	STD     L02B8			;Save it, actuator prop. term
;
;-Compute actuator integral gain
;
	LDX     #L50FF			;Actuator integral gain vs. %TPS error table
	LDAA    L02BD			;TPS error
	JSR     LF153			;2D lookup with line count
;
	LDAB    L02BD			;TPS error
	MUL				;TPS error x integral gain     
	STD     L02BA			;Save it, integral factor
;
	XGDX				;Swap result into X    
	LDAA    L02BC			;Desired TPS to be outputted
	CMPA    L01FC			;Compare to current TPS
	XGDX				;Swap result back in    
	BCC     L920E			;Bra if TPS <=
;
;-Here to add in the integral and prop. term
;
	ADDD    L02AB			;Add in integral factor to actuator integral term
	BCC     L91FD			;Bra if no overflow

	LDD     #$FF00			;Clear overflow
;
L91FD	STD     L02AB			;Save it, actuator integral term
;
	ADDD    L02B8			;Add in act. prop. term
	BCS     L920A			;Bra if overflow

L9205	ADDD    #0128			;Round up if needed
	BCC     L9221			;Bra if no overflow
;
L920A	LDAA    #255			;Clear overflow
	BRA     L9221			;
;
;-Here to subract the integral and prop. term
;
L920E	LDD     L02AB			;Load actuator integral term
	SUBD    L02BA			;Subtract integral factor			
	BCC     L9218			;Bra if no underflow
;
	CLRA				;Clear underflow    
	CLRB				;    	
;
L9218	STD     L02AB			;Save it, integral term
	SUBD    L02B8			;Subtract prop. term
	BCC     L9205			;Bra if no underflow

	CLRA				;Clear underflow
;    
L9221	LDAB    L02BC			;Desired governing TPS to be outputted
	CMPB    #$FF			;255 = No governing
	BNE     L922E			;Bra if != 255			
;
	LDX     #$0000			;
	STX     L02AB			;Clear actuator integral term
;
L922E	TAB				;Governing TPS to B     
	BRCLR   L0051,#$10,L9236	;Status word, bra if b4==0, no high batt. volts 
;
;-High batt volts, clear desired TPS
;
	CLRB				;    
	BRA     L9244			;
;
L9236	BRCLR   L003B,#$10,L9244	;Status word, bra if b4==0, not in mode 4
;
	LDAA    L0395			;
	BITA    #$01			;Test b0
	BEQ     L9244			;Bra if ==0
;
	LDAB    L0396			;
;
L9244	LDAA    #$1F			;
	STD     L306C			;Hardware
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
; I/O control routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L924A	LDAB    #$AA			;1010 1010
	STAB    L303A			;COP
;
;-Check opt. byte to see if A/C is present
;
	LDAA    L400F			;Opt. byte
	BITA    #$04			;Test b2, using adaptive A/C control
	BNE     L9268			;Bra if ==1, skip A/C routine
;
;-Using standard on/off control, check A/C status
;
	BRSET   L004D,#$01,L9262	;Bra if b0==1, A/C requested 
;
;-No A/C requested here
;
	BCLR    L0052,#$20		;Clear b5, A/C not requested
	BCLR    L0041,#$10		;Clear b4, A/C off
	BRA     L9268			;Bra to continue
;
;-A/C requested
;
L9262	BSET    L0052,#$20		;Set b5, A/C requested
	BSET    L0041,#$10		;Set b4, A/C on
;
;-Check to see if in P/N
;
L9268	BCLR    L0041,#$20		;Preclear b5, park/neutral 
;
	LDX     #L400F			;Opt. byte
	BRSET   0,X,#$40,L927C		;Bra if b6==1, non-electronic trans present
;
;-Elec. trans here
;
	LDAA    L004D			;I/O port C word		
	ANDA    #$1C			;Clear all but b2-b4
	CMPA    #$14			;0001 0100
	BNE     L9285			;Bra if b2,b4 !=0, not in P/N 
;
	BRA     L9282			;
;
;-Non elec. trans here
;
L927C	LDAA    L004D			;I/O port C word
	BITA    #$10			;Test b4, P/N switch
	BNE     L9285			;Bra if !=0
;
L9282	BSET    L0041,#$20		;Set b5, in P/N
;
L9285	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; IAC control routine
;
;~~~~~~~~~~~~~~~~~~~~~~
;
L9286	LDAB    L000A			;IAC control word
;
	LDAA    L00A1			;A/D battery voltage
	CMPA    #169			;16.9 V, max batt volts for IAC operation
	BLS     L9292			;Bra if batt volts <=
;
	ANDB    #$EF			;Clear b4, disable IAC
	BRA     L929B			;Bra				
;
L9292	BRSET   L0044,#$10,L92A0	;Bra if b4==1, ignition off Skip low volts check

	CMPA    L4EAC			;Min batt volts for IAC operation
	BHI     L92A0			;Bra to continue

L929B	BSET    L003E,#$04		;Status word, set b2, batt volts out of range for IAC operation
	BRA     L92E3			;Bra to skip IAC adj.

L92A0	BCLR    L003E,#$04		;Status word, clr b2, batt volts within range for IAC operation
;
	ORAB    #$10			;Set b4, enable IAC
	LDAA    L0007			;Current IAC steps
	CMPA    L0008			;Desired IAC steps
	BNE     L92AF			;Bra if !=, continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if delta IAC counts ==0
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	ANDB    #$FE			;Clr b1 of IAC control word, set up to retract IAC next pass
	BRA     L92E3			;Bra to save and skip IAC adj.
;  
L92AF	BRCLR   L0009,#$01,L92B7	;Bra if resetting IAC, force IAC to step if needed 
;
	BRSET   L0002,#$03,L92E3	;Loop counter, bra if b1,b2 set, skip IAC adj.
;
L92B7	BCC     L92C2			;Bra if current IAC counts >= IAC counts, extend IAC
;
;~~~~~~~~~~~~~~~~~~~~~
; Here to retract IAC
;~~~~~~~~~~~~~~~~~~~~~
;
	ANDB    #$FE			;Clr b1, retract IAC
	BRSET   L000A,#$01,L92E3	;Status word, bra if b==1, previously exteding IAC, skip routine this time around
;
	INCA 				;+1 to current IAC steps   
	BRA     L92C9			;Bra to save it
;
;~~~~~~~~~~~~~~~~~~~~
; Here to extend IAC
;~~~~~~~~~~~~~~~~~~~~
;
L92C2	ORAB    #$01			;Set b1, extend IAC
	BRCLR   L000A,#$01,L92E3	;Bra if b0==0, previously where retracting IAC, skip routine this time around
;
	DECA				;-1 from current IAC counts 
;
;-Save IAC control word
;   
L92C9	STAA    L0007			;Current IAC counts 
;
;~~~~~~~~~~~~~~~~
;-Test IAC state
;~~~~~~~~~~~~~~~~
;
; b3, 1=Coil B state on
; b2, 1=Coil A state on
;
					;IAC control word
	BRSET   L000A,#$0C,L92D9	;Bra if b2,b3==1, coil A,B on
;
	BRCLR   L000A,#$0C,L92D9	;Bra if b2,b3==0, coil A,B off
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if neither coil simultaniously on/off
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BITB    #$01			;Test b1, extend IAC
	BNE     L92DD			;Bra if ==1, extend IAC
;											
	BRA     L92E1			;Bra if retracting IAC
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if both coils simultaniously on/off
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L92D9	BITB    #$01			;Test b1, extend IAC
	BNE     L92E1			;Bra if extending IAC
;
;-Here to toggle coil A
;
L92DD	EORB    #$04			;Toggle coil A state	
;
	BRA     L92E3			;Bra to save
;
;-Here to toggle coil B 
;
L92E1	EORB    #$08			;Toggle coil B state
;
;-Here to skip IAC adj./Output to hardware
;
L92E3	STAB    L000A			;Save status word
	SEI 				;Momentarily disable interrupts
	LDAA    L004C			;I/O port D
	ANDA    #$E3			;Mask, 1110 0011,
	ANDB    #$1C			;Mask, 0001 1100
	ABA 				;Update port D val.    
	STAA    L004C			;					
	CLI				;Re-enable interrupts
	RTS 				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to disable throttle kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L92F1	BCLR    L0037,#$18		;Status word, clear b3, throttle kicker disable req., 
					;b4, throttle kicker disable request
	BRCLR	L0037,#$04,L92FE	;Status word, bra if b2==0, throttle kicker 
					;not previously disabled
;
;-Throttle kicker previously disabled
;
	CLR     L088D			;Clear throttle kicker time
	BCLR    L0037,#$04		;Clear b2, throttle kicker no longer active 
;
L92FE	BRSET   L0036,#$40,L9305	;Bra if b6==1, T/K has been previously active					;already
;
	BSET    L0036,#$40		;Set b6, throttle kicker was just active
;
L9305	BSET    L004B,#$80		;I/O word, set b7, de-energize the throttle kicker
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;Routine to enable the throttle kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9309	BRSET   L0037,#$04,L931F	;Status word, bra if b2==1, throttle kicker 
					;already enabled
;
;-Load quals for throttle kicker being active
;
	LDAA    L02D4			;Stored base closed throttle tps
	ADDA    L50CB			;Add in active T/K closed throttle offset 
	STAA    L0319			;Save it, base closed throttle TPS
	LDAA    L50C9			;Min time to disable throttle kicker
	STAA    L088D			;Throttle kicker time
	BSET    L0037,#$04		;Status word, set b2, throttle kicker
					;enabled
;
L931F	BCLR    L004B,#$80		;I/O word, clear b7, energize throttle kicker
	RTS     			;Return		
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to enable IAC
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;											
L9323	LDX	#L004C		;I/O port D control word
	BSET    0,X,#$10	;Set b4, enable IAC
	RTS			;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check if 4WD low is engaged
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L932A	BRSET   L004D,#$80,L9331	;I/O word, bra if b7==1, 4WD low not engaged
;
	SEC				;Set carry, 4WD low engaged   
	BRA     L9332			;Bra to return
;
L9331	CLC				;Clear carry, 4WD low not engaged 
;    
L9332	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check status of A/C high pressure switch
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9333	PSHA				;Push desired idle to stack
	LDAA    L3008			;Port D
	BITA    #$04			;Test b2, A/C high pressure switch status
	PULA				;Get desired idle back 
	BEQ     L933F			;Bra if switch is open
;
;-Switch closed
;
	SEC				;Set carry, high pressure indicated
	BRA     L9340			;Return
;
;-Switch open
;			
L933F	CLC				;Clear carry high pressure not indicated
;
L9340	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    					
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Power-on idle initialization routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9341	LDAA    L4EE8			;1.56 %TPS, upper limit for closed throttle	
	ASLA				;x2
	ASLA				;x2
	STAA    L0885			;Save it, upper TPS limit for closed throttle
;
	BRCLR   L0046,#$40,L9355	;Bra if b6=0, non vol. mem. intact
;
;-Non-vol. memory lost, perform resets
;
	LDAA    L4EA6			;IAC park position
	STAA    L0007			;Save it, IAC steps
	JSR     L9387			;Routine to reset idle integral cells
;
;-Non-vol. memory intact
;
L9355	BRSET   L0004,#$08,L935E	;Bra if b3==1, bad shutdown 
;
	JSR     L93D4			;Routine to init. idle integral cells
	BRA     L9361			;Bra to continue
;				
;-Here if bad shutdown
;						
L935E	JSR     L94A8			;Routine to reset IAC status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if throttle kicker is present
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9361	LDAA    L4E85			;IAC option word #1
	BITA    #$04			;Test b2, throttle kicker option bit
	BEQ     L937F			;Bra if ==0, no throttle kicker
;
;-Check Baro quals for throttle kicker
;											
	LDAA    L0317			;Baro 
	CMPA    L50C4			;Baro for enabling the throttle kicker
	BLS     L9377			;Bra if baro <=, enable throttle kicker
;
;-Check cool quals for throttle kicker
;											
	LDAA    L0006			;Cool temp, linear
	CMPA    L50BD			;Upper thresh. for throttle kicker
	BCC     L937C			;Bra if cool temp is greater
;
;-Here to disable throttle kicker
; 
L9377	BSET    L0037,#$04		;Set b2, throttle kicker enabled
	BRA     L937F			;Bra to save and return															
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to disable the throttle kicker
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;							
L937C	JSR     L92F1			;Routine to disable the throttle kicker
;	
;-Here if no throttle kicker
;										
L937F	LDAA    L0007			;Current IAC steps
	STAA    L0008			;Desired IAC steps
	JSR     L9323			;Routine to enable IAC
;											
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;			
; Routine to reset idle integral cells
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
;-Reset integral cells for drive
;					
L9387	LDAA    L0006			;Cool temp, linear
	CMPA    L4EAB			;Temp threshold for hot engine		
	TPA				;Cond. Code Reg. to A   						;
  										
	LDAB    L4EA8			;Default flow value for idle integrator term            						
	STAB    L02CA			;Save it, current idle integrator, drive, no A/C
	STAB    L02CC			;Steady state idle integraotr, drive, no A/C

	TAP				;Load CCR from A
	BCS     L93A0			;Bra if stored cool temp < 110 deg C
;
;-Cool temp > 110 deg C
;
	ADDB    L4EA9			;Added flow for A/C on idle integral cells,
					;high engine temp
	BCS     L93A5			;Bra if overflow	
;
	BRA     L93A7			;Bra to store
;
;-Cool temp <= 110 deg C
;
L93A0	ADDB    L4EAA			;Added flow for A/C on idle integral cells,
					;normal engine temp
	BCC     L93A7			;Bra if no overflow

L93A5	LDAB    #$FF			;Clear overflow
;
;-Here to save flows
;
L93A7   STAB    L02CD			;Current idle integral term, drive, A/C on 
	STAB    L02CF			;Steady state idle integral term, drive, A/C on
;
;-Reset P/N integral cells
;
	LDAB    L4EA7			;Default flow for P/N idle integral cells
	STAB    L02C0			;Current idle integral term, P/N, A/C off	
	STAB    L02C2			;Steady state idle integral term, P/N, A/C off
	TAP				;Load CCR from A     
	BCS     L93C0			;Bra if cool temp < 110 deg C
;
;-Cool temp >= 110 deg C
;

	ADDB    L4EA9			;Added flow for A/C on idle integral cells, 
					;high engine temp
	BCS     L93C5			;Bra if overflow
;
	BRA     L93C7			;Bra to store
;
;-Cool temp <= 110 deg C
;
L93C0	ADDB    L4EAA  			;Added flow for A/C on idle integral cells,
					;normal engine temp
	BCC     L93C7			;Bra if no overflow
;	
L93C5	LDAB    #$FF			;Clear overflow
;
;-Here to save the flow
;
L93C7	STAB    L02C3			;Current idle integral term, P/N, A/C on
	STAB    L02C5			;Steady state idle integral term, P/N, A/C off
;	
;-Reset base throttle kicker TPS
;
	LDAA    L50CA			;Default T/K base TPS
	STAA    L02D4			;T/K base TPS
	RTS     			;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to initialize idle integral cells
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if stable idle was attained with A/C off
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L93D4	BRCLR   L0009,#$10,L93F2	;Status word, bra if b4==0, stable idle not 
					;previously attained on last run
;
;-Stable idle was attained on last run
;
	LDAA    L02CC			;Steady state idle integral term, drive, A/C off
	CLRB				;Preclear B
	ADDA    L508E			;Added flow when ignition is off
	BCC     L93E4			;Bra if no overflow

	LDAA    L50B9			;Load max allowed flow for integral, A/C off
;
L93E4	STAA    L02CC			;Save it, steady state integral term, drive, A/C off
	CMPA    L02CA			;Compare, current idle integral term, drive, no A/C
	BLS     L93EF			;Bra if current integral term wasl <=
;
;-Current integral term was <, clamp integral term to steady state integral term
;
	STD     L02CA			;Save steady state integral as current integral term
;
;-Current integral term was >=, dont clamp
;
L93EF	BCLR    L0009,#$10		;Clear b4, steady idle flag
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if stable idle was attained with A/C on
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;				
L93F2	BRCLR   L0009,#$20,L9410	;Bra if b5==0, stable idle not attained on last run 
;
;-Stable idle was attained on last run
;
	CLRB				;Preclear B
	LDAA    L02CF			;Steady state integral term, drive, A/C on
	ADDA    L508F			;Added flow when ignition is off
	BCC     L9402			;Bra if no overflow
;
	LDAA    L50BA			;Load max allowed flow for integral, A/C on
;
L9402	STAA    L02CF			;Save it, steady state integral, drive, A/C on
	CMPA    L02CD			;Compare, current integral term, drive, A/C on
	BLS     L940D			;Bra if current integral was <=
;
;-Current integral term was <, clamp integral term to steady state integral term
;
	STD     L02CD			;Save steady state integral as current integral
;
;-Current integral term was >=, dont clamp
;
L940D	BCLR    L0009,#$20		;Clear b5, steady idle flag, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Reset current non-A/C integral cells using SS cells if optioned 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9410	LDAB    L4E86			;Opt. byte
	BITB    #$01			;Test b0, reset current integral cells
					;to steady state values
	BEQ     L9423			;Bra if ==0, no reset
;
;-Reset current integral to steady state values
;
	LDAA    L02C2			;Steady state integral term, P/N, no A/C
	STAA    L02C0			;Save as current integral term, P/N, no A/C										;
	LDAA    L02CC			;Steady state integral term, drive, no A/C
	STAA    L02CA			;Save as current integral term, drive, no A/C
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Use non-A/C cells to reset A/C on cells if optioned
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
L9423	LDAA    L4E85			;Option byte
	BITA    #$08			;Test b3, use A/C off integral cells to reset A/C
					;on integral cells
	BEQ     L9494			;Bra if ==0, not using this method to reset cells
;
;-Reset park/neutral A/C on cells
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L4EAB			;Temp threshold for hot engine
	TPA				;CCR to A
	LDAB    L02C0			;Idle integral term, P/N, no A/C
	TAP				;Restore CCR     
	BCS     L943D			;Bra if engine temp was <, cool engine
;
;-High engine temps present
;
	ADDB    L4EA9			;Added flow for A/C idle cell init, high engine 
					;temps
	BCS     L9442			;Bra if overflow
;
	BRA     L9447			;No overflow, bra to save
;
;-Normal engine temps preset
;
L943D	ADDB    L4EAA			;Added flow for A/C idle cell init, normal 
					;engine temps
	BCC     L9447			;Bra if no overflow
; 
L9442	LDAB    #255			;Load max for idle cell
	STAB    L02C4			;LSB. idle integral term, P/N, A/C on
;
;-Reset steady state A/C idle integral cell
;
L9447	STAB    L02C3			;MSB, idle integral term, P/N, A/C on
;
	LDAB    L02C2			;Steady state idle integral term, P/N, no A/C			
	TAP				;Restore CCR to previous state     
	BCS     L9457			;Bra if engine temp < threshold for hot engine
;
;-High engine temps present
;
	ADDB    L4EA9			;Added flow for A/C idle cell init, high engine 
					;temps
;
	BCS     L945C			;Bra if overflow
;
	BRA     L945E			;Bra to save
;
;-Normal engine temps preset
;
L9457	ADDB    L4EAA			;Added flow for A/C idle cell init, normal 
					;engine temps
;
	BCC     L945E			;Bra to save			
;
L945C	LDAB    #$00FF			;Clear overflow
;
L945E	STAB    L02C5			;Save it, steady state integral cell, P/N, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Reset A/C on integral cells for drive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L02CA			;Current idle integral term, no A/C, drive 
	TAP				;Restore CCR to previous state     
	BCS     L946E			;Bra if engine temp was < temp threshold
;
;-High engine temps present
;
	ADDB    L4EA9			;Added flow for A/C idle cell init, high engine 
					;temps
;
	BCS     L9473			;Bra if overflow
;
	BRA     L9478			;Bra to save
;
;-Normal engine temps preset
;
L946E	ADDB    L4EAA			;Added flow for A/C idle cell init, normal 
					;engine temps
;
	BCC     L9478			;Bra if no overflow
;
L9473	LDAB    #$00FF			;Load max for idle cell
	STAB    L02CE			;LSB, current idle integral term, A/C, drive
;
L9478	STAB    L02CD			;MSB, current idle integral term, A/C, drive
;
;-Reset steady state A/C on integral cell
;
	LDAB    L02CC			;Steady state integral term, A/C on, drive			
	TAP				;Restore CCR to previous state    
	BCS     L9488			;Bra if engine temp was < temp threshold
;
	ADDB    L4EA9			;Added flow for A/C idle cell init, high engine 
					;temps
;
	BCS     L948D			;Bra if overflow
;
	BRA     L948F			;Bra to return

L9488	ADDB    L4EAA			;Added flow for A/C idle cell init, normal 
					;engine temps
	BCC     L948F			;Bra if no overflow

L948D	LDAB    #$FF			;Clear overflow
;
L948F	STAB    L02CF			;Save it, steady state idle integral term, drive
					;A/C on
	BRA     L94A7			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not using A/C off integral cells to reset A/C on integral cells
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Use steady state cells to reset current A/C on integral cells if optioned
;
L9494	LDAB    L4E86			;Opt byte
	BITB    #$01			;Test b0, reset current integral cells to
					;steady state values
	BEQ     L94A7			;Bra if ==0, dont reset using this method
;
	LDAA    L02C5			;Load steady state integral term, A/C on, P/N
	STAA    L02C3			;Save it, current integral term, A/C on, P/N
;
	LDAA    L02CF			;Load steady state integral term, A/C on, drive
	STAA    L02CD			;Save it, current integral term, A/C on, drive
;
L94A7	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to reset IAC status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
; b3==1, coil B on
; b2==1, coil A on
;
L94A8	BRSET   L0009,#$01,L94B2	;Bra if b0==1, IAC reset in progress
;
	LDAA    L000A			;
	ANDA    #$0C			;0000 1100, clear all but b2, b3
	STAA    L000A			;
;
L94B2	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~
;
; Main idle routine
;
;~~~~~~~~~~~~~~~~~~~
;
L94B3	BRCLR   L0082,#$40,L94BA	;Status word, bra if b6==0, no heads up
;
	JSR     L1803			;HU vector table
;						
L94BA	BCLR    L0038,#$40		;
	BRCLR   L003B,#$10,L94C4	;Status word, bra if b4==0, no mode 4 (ALDL)
;
	JSR     LA4DD			;ALDL IAC routine
;    
L94C4	BRCLR   L0009,#$01,L94DC	;Status word, bra if b0==0, IAC reset not in 
					;progress
;
	CLR     L0008			;Clear desired IAC steps
	TST     L0007			;Test current IAC steps
	BEQ     L94D3			;Bra if ==0, IAC closed
;											
	JMP     L997E			;Jump to return
;  
L94D3	BCLR    L0009,#$01		;Clear b0, IAC reset in progress
	BSET    L0009,#$04		;Set b2, IAC reset not requested
	JSR     L9387			;Routine to reset idle integral cells
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not resetting IAC
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
L94DC	BRCLR   L0044,#$10,L94ED	;Status word, bra if b4==0, ignition is on
;
;~~~~~~~~~~~~~~~~~~~~~~
; Ignition is off here
;~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0009,#$04,L94EA	;Status word, bra if b2==0, IAC reset requested
;
	LDAA    L4EA6			;IAC park steps
	JMP     L997C			;Save and return
;
;-IAC reset was requested
;
L94EA	JMP     LA4D0			;Go close and seat IAC
;
;~~~~~~~~~~~~~~~~~~~~~
; Ignition is on here
;~~~~~~~~~~~~~~~~~~~~~
;
L94ED	BRCLR   L004F,#$80,L94F4	;Bra if b0==0, engine not running
;
;-Engine running
;
	JMP     L961A			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine is off here, look up various parameters for startup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L94F4	LDAA    L02A6			;Range limited cool temp
	LDX     #L4EEB			;Closed loop delay for high RPMs vs cool temp
	JSR     LF15E			;2D lookup
;
	STAA    L0866			;Save it, IAC closed loop delay (high rpms)
;
	LDAA    L02A6			;Range limited cool temp 
	LDX     #L4EF8			;Closed loop delay for low RPMs vs cool temp
	JSR     LF15E			;2D lookup
;
	STAA    L0867			;IAC closed loop delay (high rpms)
;
;-Load initial IAC flow
;
	LDAA    L4EAE			;Initial added IAC flow for startup
	STAA    L086B			;Initial added IAC flow
;
	LDAA    L4EAF  			;Decay period for initial added IAC flow
	STAA    L086C			;Save it, initial IAC flow decay period
;
;-Scale coolant temp for lookup
;
	LDAA    L02A6			;Range limited cool temp
	CMPA    #160			;92 deg C
	BLS     L9524			;Bra if cool temp <=
;
	SUBA    #160			;-160 for scaling 
	ASLA				;x2
	ADDA    #160			;+160
;
; Cool temp = .75 x val - 28 when <= 92 deg C
;
; Cool temp = .375 x val + 32 when > 92 deg C
;
L9524	PSHA				;Push term to stack
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up desired idle speed based on cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4F28			;Desired idle speed vs. cool temp
	LDAB    L4E85			;IAC option byte
	BITB    #$01			;Test b0
	BEQ     L9532			;Bra if b0==0, auto in use
;
;-Here if manual in use, use A/C on table instead
;
	LDX     #L4F46			;Desired idle speed vs. cool temp
;
L9532	JSR     LF15E			;2D lookup
	PULB				;Get cool temp back    
	PSHA				;Push desired idle speed to stack    
	TBA				;Get cool temp into B
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up added idle speed vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4F64			;Added initial desired idle speed vs. cool temp
	JSR     LF15E			;2D lookup
;
	STAA    L085C			;Save it, added desired idle speed
;
;-Check to see if manual in use
;                     
	LDAB    L4E85			;IAC option byte
	BITB    #$01			;Test b0
	BNE     L9551			;Bra if ==1, manual trans in use
;
;-Auto is in use here, apply multiplier for added idle speed
;
	LDAB    L4EB2			;Load multiplier 
	MUL				;Added initial desired idle speed x multiplier     
	ASLD				;x2, now /128    
	BCC     L9551			;Bra if no overflow
;
	LDAA    #$FF			;Clear overflow
;
;-Manual in use here
;
L9551	PULB				;Get desired idle speed off stack				    
	ABA				;Add in added initial desired idle sped     
	STAA    L0857			;Save it, desired idle speed
;
;~~~~~~~~~~~~~~~~
; Perform resets
;~~~~~~~~~~~~~~~~
;
	LDAA    L4EB1			;Decay period for added initial idle speed
	STAA    L085D			;Added initial idle speed decay period
;
	LDAA    L4EB0			;Time untill init. idle speed is decayed 
	STAA    L085E			;Timer for decaying out init. added idle speed
;
;-Perform clears
;
	CLRA				;Preclear A    
	STAA    L086D			;Proportional idle term
	STAA    L0879			;Added IAC flow for trans. shift
	STAA    L087A			;Transmission shift transition period
	STAA    L0876			;Added flow for A/C transition 
	STAA    L0877			;Transition period for A/C on to off 
	STAA    L0887			;IAC flow when in DFCO
	STAA    L087B			;P/S compensation flow
	STAA    L0864			;IAC closed loop enable delay timer
	LDAA    #080			;Load neutral value
	STAA    L086E			;Stored idle derivative term
;
	BCLR    L0036,#$BD		;Status word, clear the following:
					; b7=High idle speed flag
					; b5=
					; b4=Stall saver in effect
					; b3=Closed loop idle in effect
					; b2=Closed loop idle quals met
					; b0, 0=A/C off, 1=A/C on
; 
	BCLR    L0037,#$9B		;Status word, clear the following:
					; b7, 1=positive derivative idle term
					; b4=Throttle kicker disable req. flag
					; b3=Throttle kicker disable req. flag
					; b1=reduce thtottle follower action
					; b0=warm engine flag, throttle follower
;

	BCLR    L0038,#$0F		;Status word, clear the following:
					; b3=Update idle int. flag, drive, A/C on
					; b2=Update idle int. flag, drive, no A/C
					; b1=Update idle int. flag, P/N, A/C on
					; b0=Update idle int. flag, P/N, no A/C
;	
	BCLR    L0038,#$70		;Status word, clear the following
					; b6=
					; b5=Sign of added DFCO IAC airflow
					; b4=Initial stored IAC flow updated
;
	BCLR    L0039,#$C7		;Status word, clear the following
					; b7=Throttle open flag
					; b6=Manditory post-DFCO T/F added flow update
					; b2=Throttle kicker diags. performed
					; b1=Post throttle kicker base TPS updated
					; b0=Throttle kicker base TPS updated
;
	LDAA    L4FB4			;Upper RPM limit for updating SS idle cells
	STAA    L0859			;Filtered RPM error
	BCLR    L0009,#$02		;Status word, clear b1, First run flag for
					;IAC flow kickdown logic 
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Look up IAC %flowrates
;~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L02A6			;Range limited cool temp
	LDX     #L4EC5			;IAC flow vs. cool temp table (drive)
	JSR     LF15E			;2D lookup
;
	CLRB				;Clear LSB    
	STD     L02D0			;Coupled IAC flow vs. cool temp (drive)
	STD     L02D2			;IAC flow vs. cool temp (drive)
;
	LDAA    L02A6			;Range limited cool temp
	LDX     #L4EB8			;IAC flow vs. cool temp table (park/neutral)
	JSR     LF15E			;2D lookup
;
	CLRB				;Clear LSB  
	STD     L02C6			;Coupled IAC flow vs. cool temp, (P/N)
	STD     L02C8			;IAC flow vs. cool temp, (P/N)
;
	LDAA    L02A6			;Range limited cool temp
	LDX     #L4ED2			;IAC cold offset delay period vs. cool temp table
	JSR     LF15E			;2D lookup
;
	STAA    L0875			;IAC flow decay delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Init idle integrator flow using either default values or idle integral terms
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L4E85			;IAC opt. byte
	BITA    #$20			;Test b5, init INT with calib const., not running 
	BEQ     L95DA			;Bra if ==0, 
;
	CLRB				;Preclear B    
	BITA    #$01			;Test b0, manual/auto trans flag
	BNE     L95D5			;Bra if ==1, manual trans in use
;
;-Auto in use here
;
	LDAA    L4EA7			;Default flow for P/N idle cells
	BRA     L95EB			;Bra to save
;
;-Manual in use here
;
L95D5	LDAA    L4EA8			;Default flow for drive idle cells
	BRA     L95E6			;Bra to save and continue
;
;-Here if init. using idle integral terms
;
L95DA	BITA    #$01			;Test b0, manual/auto trans flag
	BNE     L95E3			;Bra if ==1, manual in use
;
;-Auto in use
;
	LDD     L02C0			;Load current idle integral term, P/N
	BRA     L95EB			;Bra to save and continue
;
;-Manual in use
;
L95E3	LDD     L02CA			;Load current idle integral term, drive
;
L95E6	LDX     L02D0			;IAC flow vs. cool temp, drive
	BRA     L95EE			;Bra to save
;
;-Continue here if auto in use
;
L95EB	LDX     L02C6			;Load coupled IAC flow vs. cool temp, P/N
;
L95EE	STD     L0862			;Save idle term as idle integrator idle flow
	STX     L0871			;Save IAC flow vs. cool temp as added IAC flow
					;vs. cool temp
;
	LDX     #$FFFF			;Max flow
	STX     L087D			;stored IAC flow, used in AE routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Move IAC prior to start if cool temp is great enough
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L4E87  			;Temp threshold to move IAC prior to start
	BCS     L9614			;Bra if cool temp <, park IAC and return
;
;-Cool temp high engouh to move IAC
;
	LDD     L0862			;Load idle integrator flow
	ADDA    L086B			;Add in initial added IAC flow
	BCS     L960E			;Bra if overflow
;
	ADDD    L0871			;Add in IAC flow vs. cool temp
	BCC     L9611			;Bra if no overflow
;
L960E	LDD     #$FFFF			;Clear overflow
;
L9611	JMP     L9920			;Go save as desired flow
;
;-Temp not high enough to move IAC
;
L9614	LDAA    L4EA6			;IAC park steps
	JMP     L997C			;Go park IAC
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Here if engine running
;~~~~~~~~~~~~~~~~~~~~~~~~
;
L961A	LDAB    L0036			;Status word
	PSHB				;Push to stack
;
	LDAA    L400F			;Opt. byte
	BITA    #$40			;Test b6
	BEQ     L962A			;Bra if ==0, not using TCC alone
;
;-TCC only in use
;
	BRSET   L0041,#$20,L9654	;Status word, Bra if b5==1, in P/N
;
	BRA     L9632			;Bra to continue
;
;-Electronic trans in use here
;
L962A	BRSET   L009C,#$40,L9654	;Trans range word, bra if b6==1, in P/N
;
;-Not in P/N
;
	BRSET   L009C,#$10,L9654	;Trans range word, bra if b4==1, 
;
;-Here to flag drive being set
;
L9632	BSET    L0036,#$02		;Status word, set b2, in drive
	BITB    #$02			;Test previous state 
	BNE     L9684			;Bra if already in drive
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Vehicle has shifted from park to drive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L4F19			;Added IAC %flow for park to drive
	PSHA    
	LDAA    L4F1B			;Load closed loop idle delay
	LDAB    L4F1A			;Period to transition from park to drive
	XGDX				;Swap vals into X 	   
	LDAA    L0006			;Cool temp
	CMPA    L4F1F			;Threshold for cold idle added delays
	XGDX				;Get looked up vals back    
	BCC     L9674			;Bra if cool temp is >= threshold
;
;-Cold engine temp present
;
	ADDA    L4F20			;Additional delay for closed loop when cold
	ADDB    L4F21			;Additional transition delay when cold
	BRA     L9674			;Bra to save and continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Vehicle in park/neutral here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9654	BCLR    L0036,#$02		;Status word clear b1, now in P/N 
	BITB    #$02			;Test previous state
	BEQ     L9684			;Bra if already in P/N
;
;-Have shifted from drive to park/neut.
;
	LDAA    L4F1C			;Add'l IAC flow for drive to park/neutral			
	PSHA				;Push to stack    
	LDAA    L4F1E			;Load closed loop delay
	LDAB    L4F1D			;Load drive to park transition period
	XGDX				;Swap into X    
	LDAA    L0006			;Load cool temp
	CMPA    L4F1F			;Threshold for cold idle added delays
	XGDX				;Get values back     
	BCC     L9674			;Bra if cool temp >= threshold 
;
;-Cold engine temp present
;
	ADDA    L4F22			;Add in addition closed loop delay
	ADDB    L4F23			;Add in addition transition time
;
L9674	STAB    L087A			;Save trans shift transition period
	ABA				;Add in transition time to closed loop delay    
	PULB				;Get added flow off stack    
	STAB    L0879			;Save it, added IAC flow for trans shift			
;
	CMPA    L0864			;IAC closed loop enable delay timer
	BLS     L9684			;Bra if calculated delay is <=
;
;-Calculated delay was >
;
	STAA    L0864			;Save it, closed loop enable delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no change in P/N or drive status
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Generate delta flow term for A/C transition
;
L9684	BRSET   L0036,#$02,L9690  	;Status word, bra if b1==1, in drive
;
;-In P/N
;
	LDAA    L02C3			;Current idle integrator, P/N, A/C on
	SUBA    L02C0			;-Current idle integrator, P/N, A/C off
	BRA     L9696			;Bra to continue
;
;-In drive
;
L9690	LDAA    L02CD			;Current idle integrator, drive, A/C on
	SUBA    L02CA			;-Current idle integrator, drive, A/C off
;
;~~~~~~~~~~~~~~~~~~~~~
; Check status of A/C
;~~~~~~~~~~~~~~~~~~~~~
;
L9696	PULB				;Pull status word back off stack and into B  
	PSHB				;Push it back on   
	BRSET   L0052,#$20,L96C5	;Status word, bra if b5==1, A/C anticipat'g to be on 
;
;-A/C currently off here
;
	BCLR    L0036,#$01		;Clear b0, A/C off
	BITB    #$01			;Test b0, previous state			
	BEQ     L970F			;Bra if ==0, A/C already off
;
;-A/C has just turned off
;
	TST     L0877			;IAC period for A/C on to off 
	BNE     L970F			;Bra if !=0, recently changed state
;
;-Enough time has passed for A/C to be off, transition from A/C running to off IAC flow
;
	LDAB    L4F05			;Delta flow multiplier for on to off transition
	MUL				;Delta flow x multiplier, now sub'd flow to 
					;to transition from A/C on to off     
	CMPA    L4F06			;Min A/C on to off transition flow
	BCC     L96B4			;Bra if >=
;
	LDAA    L4F06			;Load min flow
;
L96B4	CMPA    L4F07			;Max A/C on to off transition flow
	BLS     L96BC			;Bra if <=
;
	LDAA    L4F07			;Load max flow
;
L96BC	LDAB    L4F09			;Additional added delay for closed loop idle enable
	PSHB				;Push to stack    
	LDAB    L4F08			;A/C on to off transition period
	BRA     L96FF			;Bra to save and continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if A/C is going to be on
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L96C5	BSET    L0036,#$01		;Set b0, A/C active
	BITB    #$01			;Test b0 of B, previous state
	BNE     L970F			;Bra if A/C was already active
;
;-A/C has just become active
;
	LDAB    L4F18			;Decay period for added A/C transition flow
	STAB    L0878			;Save it, A/C transition flow decay period
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; A/C has just changed state
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L4E85			;IAC opt. byte
	BITB    #$40			;Test b6, use MAT based table for A/C on off trans.
	BEQ     L96E4			;Bra if ==0, use constants instead
;
;-Using MAT based table for delta A/C transition flow
;
	LDX     #L4F0A			;A/C transition delta flow vs. MAT temp
	LDAA    L0252			;Load MAT temp
	JSR     LF141			;2D lookup with offset and upper limit
;
	BRA     L96F8			;Bra to continue
;
;-Here if not using MAT based table for added IAC flow
;
L96E4	LDAB    L4F12			;Flow transition multiplier for A/C change state
	MUL				;Airflow x multiplier
	CMPA    L4F13			;Min allowed change in airflow for A/C transition
	BCC     L96F0			;Bra if change in airflow was >=
;
	LDAA    L4F13			;Load min change in flow
;
L96F0	CMPA    L4F14			;Max allowed change in airflow for A/C transition
	BLS     L96F8			;Bra if change in flow was <= 
;
	LDAA    L4F14			;Load max change in flow
;
L96F8 	LDAB    L4F16			;Delay for closed loop after A/C transition
	PSHB 				;Push to stack
;									
	LDAB    L4F15			;Idle transition period for A/C change state
;									
L96FF	STAA    L0876			;Save added flow for A/C transition 
	STAB    L0877			;Save delay, idle transition period for A/C
					;change state
	PULA				;Pull closed loop delay    
	ABA				;Add in idle delay   
	CMPA    L0864			;Compare delay to closed loop enable delay timer
	BLS     L970F			;Bra if enable delay timer is >=
;
	STAA    L0864			;Save delay, closed loop enable delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no change in A/C status, check if integral terms need updating
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L970F	PULA				;Get status word off stack    
	PSHA				;Push it back on   
;
	EORA    L0036			;EOR with current status word
	ANDA    #$03			;Clear all but b0, A/C status, and b1, drive/PN
	BNE     L971A			;Bra if change in A/C status or drive/PN
;
;-No change in status
;
	PULA				;Retrieve status word    
	BRA     L9781			;Bra to continue
;
;-Change in status has ocured, check for updates
;
L971A	LDAB    L0036			;Status word
	BITB    #$02			;Test b1, drive/PN
	BNE     L973C			;Bra if ==1, in drive
;
;-In P/N 
;
	BITB    #$01			;Test b1, A/C status
	BNE     L9730			;Bra if ==1, A/C is on
;
;-In P/N, no A/C
;
	BRCLR   L0038,#$01,L9756	;Bra if b0==0, update integral flag, P/N, no A/C,
					;has not been set
;
;-Here to update P/N, no A/C integral term
;
	LDX     L088F			;Updated integral term, P/N, no A/C
	STX     L02C0			;Save it, integral term, P/N, no A/C
	BRA     L9756			;Bra to continue
;
;-In P/N, A/C on
;
L9730	BRCLR   L0038,#$02,L9756	;Bra if b1==1, update integral flag, P/N, A/C on, 
					;has not been set
; 
;-Here to update P/N, A/C on idle cell
;
	LDX     L0891			;Updated integral term, P/N, A/C
	STX     L02C3			;Save it, integral term, P/N, A/C
	BRA     L9756			;Bra to continue
;
;-Here if in drive
;
L973C	BITB    #$01			;Test b0, A/C status 
	BNE     L974C			;Bra if ==1, A/C on
;
;-In drive, A/C off
;
	BRCLR   L0038,#$04,L9756	;Bra if b2==0, update integral flag, drive, A/C off,
					;has not been set
;
;-Here to update drive, A/C off idle cells
;
	LDX     L0895			;Updated integral term, drive, no A/C
	STX     L02CA			;Save it, integral term, drive, no A/C
	BRA     L9756			;Bra to continue
;
;-In drive, A/C on
;
L974C	BRCLR   L0038,#$08,L9756	;Bra if b2==0, update integral flag, drive, A/C on,
					;has not been set
;											
	LDX     L0897			;Updated integral term, drive, A/C on
	STX     L02CD			;Save it, integral term, drive, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not updating int. terms, check if initial flows need updating
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9756	PULB				;Get status word back
	BRCLR   L0038,#$10,L977E	;Bra if b4==0, initial IAC flows not updated
;											
	LDAA    L02C8			;IAC flow vs. cool tempm P/N
	ORAA    L02D2			;IAC flow vs. cool temp, drive
	BEQ     L977B			;Bra if flows decayed out
;
;-Flows not yet decayed out, check for change in state
;
	EORB    L0036			;Ex. or with stord status word
	BITB    #$02			;Test b1, P/N, drive status 
	BEQ     L977E			;Bra if no chang in state
;
;-Have shifted between P/N, drive
;
	BRSET   L0036,#$02,L9775	;Bra if b1==1, in drive
;
;-In P/N
;
	LDD     L0893			;Updated initial IAC flow vs. cool temp (P/N)
	STD     L02C6			;Save it, coupled IAC flow vs. cool temp (P/N)
	BRA     L977B			;Bra to continue
;
;-Here if in drive
;
L9775	LDD     L0899			;Updated initial IAC flow vs. cool temp (drive)
	STD     L02D0			;Save it, coupled IAC flow vs. cool temp (drive)
;
L977B	BCLR    L0038,#$10		;Status word, clear b4, update initial IAC flows
					;flag
;
L977E	BCLR    L0038,#$0F		;Clear lower four update integral flags
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if power steering switch is in use
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9781	LDAA    L4E86			;Opt. byte
	BITA    #$02			;Test b1, power steering press. switch in use
	BEQ     L97A5			;Bra if ==0, not using switch
;
;-Switch in use here
;
	JSR     L932A			;Go read in state of switch
;
	BCC     L97A2			;Bra if carry clear, P/S not active
;
	BSET    L0036,#$20		;Status word, set b5, power steering compensation
					;in progress
;
	LDAA    L4F24			;Added air for P/S compensation
	STAA    L087B			;Save it, P/S compensation flow
;	
	LDAA    L4F26			;P/S compensation flow decay period
	STAA    L087C			;Save it 
;
	LDAA    L4F25			;Closed loop idle delay if P/S comp. enabled
	STAA    L0864			;Closed loop idle enable delay timer
;
L97A2	BCLR    L0036,#$20		;Clear b5, P/S compensation in progress
;
;~~~~~~~~~~~~~~~~~~
; Decrement timers
;~~~~~~~~~~~~~~~~~~
;
L97A5	LDAA    L087A			;Trans shift transition timer			
	BNE     L97AF			;Bra if !=0
;
;-Trans shift complete
;
	STAA    L0879			;Added IAC flow for trans shift
	BRA     L97B3			;Bra to continue
;
;-Still in transition
;
L97AF	DECA				;-1, trans shift transition timer    
	STAA    L087A			;Save timer
;
;-Decrement A/C transition timer
;
L97B3	LDAA    L0877			;A/C on/off transition timer
	BEQ     L97BC			;Bra if ==0
;
	DECA				;-1 from timer   
	STAA    L0877			;Save it
;
;-Decrement stall saver duration timer
;
L97BC	LDAA    L0869			;Stall saver duration timer
	BNE     L97C6			;Bra if ==0
;
	BCLR    L0036,#$10		;Status word, clear b4, stall saver in 
					;progress flag
	BRA     L97CA			;
;
;-Stall saver still in effect
;
L97C6	DECA				;-1
	STAA    L0869			;Save it, stall saver duration timer
;
;-Decrement TPS filtering delay timer
;
L97CA	LDAA    L0884			;TPS filtering period
	BEQ     L97D3			;Bra if ==0
;
	DECA				;-1    
	STAA    L0884			;Save it, TPS filtering period
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check engine speed against desired idle speed 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L97D3	LDAA    L0063			;RPM/12.5
	SUBA    L0857			;Subtract desired RPMs
	BSET    L0036,#$80		;Status word, set b7, high idle speed
	BCC     L97E1			;Bra if RPMs where greater then desired idle speed
;
;-Idle speed is less then desired idle 
;
	NEGA				;Get abs. value    
	BCLR    L0036,#$80		;Clear b7, low idle speed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if IAC compensation is in effect and use default errors if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
;
;-Check for manual park/drive trans. shift
;									
L97E1	STAA    L0858			;Save it, idle speed RPM error
	CLRB				;   
	TST     L087A			;Trans shift transition period 
	BEQ     L97ED			;Bra if ==0
;
	LDAB    L4F76			;Default RRM error when shifting from park to drive
					;and vice versa
;
;-Check for A/C on off transition
;			
L97ED	TST     L0877			;A/C on/off transition period
	BEQ     L97FA			;Bra if ==0
;
	CMPB    L4F77			;Compare to default A/C transition RPM error
	BCC     L97FA			;Bra if current RPM error >=

	LDAB    L4F77			;Use default RPM error instead
;
;-Check if power steering pump under load
;
L97FA	TST     L087C			;Decay period for power steering active
	BEQ     L9807			;Bra if ==0			
;
	CMPB    L4F78			;Default error if power steering under load
	BCC     L9807			;Bra if idle RPM error is >=
;
	LDAB    L4F78			;Use default RPM error instead
;
L9807	PSHB				;Push error to stack    
	LDAB    L0882			;Filtered TPS 
	CMPB    L0885			;Upper limit for closed TPS
	PULB				;Get error back    
	BLS     L9819			;Bra if TPS is less
;
;-Throttle is open
;
	CMPB    L4F75			;Upper default RPM error limit for open throttle
	BCC     L9819			;Bra if error is >
;
	LDAB    L4F75			;Load limit instead
;
;-Throttle is closed
;
L9819	TSTB				;Test default RPM error    
	BEQ     L9820			;Bra if ==0
;
	TBA				;Get default RPM error instead     
	CLRB				;    
	BRA     L9829			;Bra to save and continue

L9820	LDX     L0859			;Filtered RPM error
	LDAB    L4F74			;Filter coeff. for RPM error
	JSR     LF0F6			;Filter routine
;
L9829	STD     L0859			;Save it, filtered RPM error
	JSR     L9AA8			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Start constructing the desired IAC airflow 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	JSR     L9D03			;Routine to look up proportional idle term
;
	JSR     L9D89			;Routine to generate derivative idle term
;
	LDD     L0862			;Load stored idle integrator
	ADDD    L0871			;added coupled IAC flow vs. cool temp
	BCC     L9840			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Add in proportional idle term
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9840	BRSET   L0036,#$80,L984E	;Status word, bra if b7==1, high idle
;
;-Low idle
;
	ADDA    L086D			;Add in proportional idle term
	BCC     L9855			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     L9855			;Bra to continue
;
;-High idle
;
L984E	SUBA    L086D			;Subtract out proportional idle term
	BCC     L9855			;Bra if no underflow
;
	CLRA				;Clear underflow 	   
	CLRB				;    	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Add in derivative idle term
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9855	BRCLR   L0037,#$80,L9863	;Status word, bra if b7==0, negative derivative
					;term
;
;-Positive derivative term
;
	ADDA    L0870			;Add in derivative idle term
	BCC     L986A			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     L986A			;Bra to continue
;
;-Negative derivative term
;
L9863	SUBA    L0870			;Subtract out derivative idle term
	BCC     L986A			;Bra if no underflow
;
	CLRA				;Clear underflow    
	CLRB				;   
; 
;-Add in initial flow after startup
;
L986A	ADDA    L086B			;Initial added IAC flow
	BCS     L9874			;Bra if overflow

	ADDA    L087B			;Add in P/S compensation flow
	BCC     L9877			;Bra if no overflow
;
L9874	LDD     #$FFFF			;Clear overflow
;
;-Add in A/C transition flow if needed
;
L9877	TST     L0876			;Added flow for A/C on/off transition
	BEQ     L9891			;Bra if added flow was ==0, transition 
					;complete
;
	BRCLR   L0036,#$01,L988A	;Status word, bra if b0==0, no A/C
;
;-A/C has come on, add in the flow
;										   
	ADDA    L0876			;Add in added flow
	BCC     L9891			;Bra if no overflow
;
	LDD     #$FFFF			;clear overflow										;
	BRA     L9891			;Bra to continue				
;
;-Here if A/C has gone off, subtract out the flow
;																						
L988A	SUBA    L0876			;Subtract out added flow
	BCC     L9891			;Bra if no underflow
;											
	CLRA				;Clear underflow
	CLRB				;
;
L9891	ADDA    L0879			;Added IAC flow for trans shift
	BCC     L9899			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if IAC accel enrich is needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
L9899	LDX     L087D			;Load stored IAC flow
	STD     L087D			;Update stored IAC flow
;
;-Check TPS threshold for IAC AE
;											
	PSHA				;MSB to stack
	LDAA    L01FC			;TPS
	CMPA    L509F			;TPS threshold for IAC AE
	PULA				;Get MSB back
	BCC     L98B5			;Bra if TPS >=, no AE
;											
	PSHX				;Push stored IAC flow to stack
	TSX				;Get stack pointer into X
	SUBD    0,X			;Subtract stored flow from current flow
	PULX				;Get stored flow back
	BCS     L98B5			;Bra if stored flow was greater			
;
;-IAC flow is rising, check flow threshold for IAC AE
;
	CMPA    L509E			;Flow threshold for IAC AE
	BCC     L98B8			;Bra if flow >=, enough for AE 
;
;-No IAC AE here
;
L98B5	CLRA				;Clear out AE
	BRA     L98C6			;Bra to save				
;
;-Continue with AE calcs
;											
L98B8	ASLD				;Delta flow x2
	BCS     L98BE			;Bra if overflow
;
	ASLD				;x2
	BCC     L98C0			;Bra if no overflow
;
L98BE	LDAA    #$FF			;Clear overflow
;
;-Look up needed AE
;
L98C0	LDX     #L5098			;Accel enrich vs. delta IAC flow table
	JSR     LF153			;2D lookup with line count
;	
;-Here if no AE
;
L98C6	STAA    L087F			;Save it, IAC flow AE
	LDD     L087D			;Get IAC flow back
	ADDA    L0880			;Add in throttle follower flow
	BCC     L98D6			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     L9913			;Bra to continue
;
L98D6	BRCLR   L0046,#$08,L98FD	;Status word, bra if b3==0, no DFCO
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-DFCO in effect, look up added IAC flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	PSHB				;Push flow to stack    
	PSHA				;   
;
	LDX     #L50A3			;Additional IAC flow vs. RPM for DFCO
	LDAA    L0062			;RPM/25
	JSR     LF15E 			;2D lookup
;	
	SUBA    L50A2			;Subtract flow bias for table
	BCS     L98EE			;Bra if underflow
;
;-Added flow positive here
;
	BCLR    L0038,#$20		;Status word, clear b5, added DFCO IAC flow 
					;is positive 			
	BRA     L98F2			;				
;
;-Added flow negative here
;
L98EE	BSET    L0038,#$20		;Set b5, added DFCO IAC flow negative
	NEGA				;Get absolute value
;
L98F2	STAA    L0887			;Save it, added IAC flow when in DFCO
	LDAA    L50B5			;DFCO decay rate
	STAA    L0888			;Save it, DFCO flow decay rate
;
	PULA				;Get IAC flow back
	PULB				;
;
L98FD	BRSET   L0038,#$20,L990B	;Status word, bra if added DFCO flow negative
;
;-Adding flow
;
	ADDA    L0887			;Add in DFCO flow
	BCC     L9913			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     L9913			;Bra to continue
;
;-Subtracting flow
;
L990B	SUBA    L0887			;Subtract DFCO flow
	BCC     L9913			;Bra if no underflow
;
	LDD     #$0000			;Clear underflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Adjust IAC if PE in effect
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9913	BRCLR   L003D,#$20,L9920	;Status word, bra if b5==0, no PE 
;
;-In PE
;
	CPD     L50A0			;Compare flow to IAC flow limit when in PE
	BLS     L9920			;Bra if IAC flow is <=
;
	LDD     L50A0			;Load limit instead
;
;-Here to save IAC flow
;
L9920	STD     L0889			;Save it, finalized IAC flow 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Apply baro compensation
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4E99			;IAC altitude compensation vs. baro
	LDAA    L01EF			;Baro value for lookup
	JSR     LF141			;2D lookup with additional quals
;
	LDX     #L0889			;finalized IAC air flow
	JSR     LF1ED			;(A x X*)/256
;	
	ASLD				;Result x 2, now /128    
	BCC     L9938			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check and compensate for throttle kicker if active
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9938	LDX     #L4E85			;IAC option byte
	BRCLR   0,X,#$04,L9963		;Bra if b2==0, no throttle kicker 
;
;-Throttle kicker in use
;
	BRCLR   L0037,#$04,L994F	;Status word, bra if b2==0, throttle kicker
					;not active
;
	SUBA    L50BE			;Subtracted % airflow bias when throttle 
					;kicker is active
	BCC     L994F			;Bra if no underflow
;
;-Excess throttle kicker action, request T/K disable
;
	BSET    L0037,#$08		;Status word, set b3, disable throttle 
					;kicker request
	CLRA				;Clear desired flow    
	CLRB				;    
	BRA     L9963			;Bra to save and continue				
;
;-Throttle kicker action within limits, apply % flow multiplier
;
L994F	XGDX				;Swap airflow into X    
	PSHX				;To stack   
	PSHX				;To stack    
	TSX				;Get current stack pointer into X    
;
	LDAA    L50BF			;% airflow multiplier for throttle kicker
	JSR     LF1ED			;(A x X*)/256
;	
	PULX				;Clean up stack   
	TSX				;Get current stack pointer into X     
	ADDD    0,X			;Add in old airflow
	PULX				;Clean up stack    
	BCC     L9963			;Bra if no overflow
;		
	LDD     #$FFFF			;Clear overflow
;
L9963	STD     L088B			;Save it, desired airflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up IAC counts from flowrate
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4E88			;IAC steps vs. airflow
	LSRD				;/2    
	LSRD				;/2    
	LSRD				;/2    
	LSRD				;/2, airflow /16 for lookup
	ADCB    #$00			;perform carry if needed
	ADCA    #$00			;perform carry if needed				
	PSHB				;Push LSB to stack   
	TAB				;Get airflow into B, use as offset	     
	ABX				;Add in offset     
	LDD     0,X			;Load in IAC counts  
;
;-Interpolate result
;
	SBA				;Subtract IAC counts in next cell from 
					;current to get slope    
	PULB				;Get LSB back    
	NEGA				;Flip sign of slope    
	MUL				;LSB of airflow x IAC counts     
	ADCA    0,X			;Add in to looked up IAC counts to 
					;interpolate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Entry point to park IAC
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
L997C	STAA    L0008			;Save as desired IAC steps
;
L997E	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to construct desired RPM term
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L997F	BRCLR   L0038,#$40,L9986	; 
;
	JMP     L9AA7			;Return
;
;-Scale cool temp for lookup
;
L9986	LDAA    L02A6			;Range limited cool temp
	CMPA    #160			;92 deg C			
	BLS     L9992			;Bra if cool temp is greater
;
; Cool temp = .75 x val - 28 when <= 92 deg C
;
; Cool temp = .375 x val + 32 when > 92 deg C
;
	SUBA    #160			;-160
	ASLA				;x2    
	ADDA    #160			;+160
;
;-Check if A/C is on
;
L9992	BRCLR   L0036,#$01,L99A2	;Status word, bra if b0==0, no A/C 
;
;-A/C requested here
;
	LDX     #L4F37			;Desired idle speed table for P/N and A/C on
;
;-Check if in park/neutral
;
	BRCLR   L0036,#$02,L99AC	;Status word, bra if b1==0, in P/N 
;
;-In drive and A/C is on
;
	LDX     #L4F55			;Desired idle speed table for drive and A/C is on
	BRA     L99AC			;Go do lookup
;
;-No A/C here
;				
L99A2	LDX     #L4F28			;Desired idle speed table for P/N and A/C off
;
;-Check if in park/neutral
;
	BRCLR   L0036,#$02,L99AC	;Status word, bra if b1==0, in P/N
;
;-In drive and A/C is off
;
	LDX     #L4F46			;Desired idle speed table for drive and A/C is off
;
L99AC	JSR     LF15E			;2D lookup
	PSHA				;Push looked up value to stack
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Check and correct for low batt volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L4F7A			;Lower threshold for batt volt correction
	SUBB    L00A1			;A/D batt volts
	BLS     L99C6			;Bra if batt volts >=
;
;-Batt volts lower then threshold
;
	LDAA    L4F7B			;Prop. gain for batt volts
	MUL				;Gain x delta batt volts     
	CMPA    L4F7C			;Upper limit for added RPM
	BCS     L99C3			;Bra if RPM corrections less
;
	LDAA    L4F7C			;Load max
;
L99C3	PULB				;Get desired RPMs back off of stack    
	ABA				;Add in corrections     
	PSHA				;Push desired RPM back to stack   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Appy gain to RPM error to generate added desired idle RPMs based on RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L99C6	LDAB    L0859			;Load filtered RPM error
	LDAA    L4F73			;Gain factor for RPM error
	MUL				;Gain x RPM error     
	CMPA    L4F79			;Upper added RPM limit for rough idle
	BCS     L99D5			;Bra if RPM error is <=
;
	LDAA    L4F79			;Load upper limit instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if CCP purge compensation is necessary
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
L99D5	PULB				;Get desired RPM back    
	ABA				;Add in the additional RPMs    
	LDAB    L026A			;Get current BLM cell #
	CMPB    #16			;Start of idle cells
	BCS     L99ED			;Bra if not in idle cell
;
;-In an idle cell
;
	LDAB    L026B			;Current BLM
	CMPB    L4F7D              	;BLM threshold to add hot idle purge compensation
	BCC     L99ED			;Bra if BLM >=
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L4F7F			;Min cool temp for hot idle purge compensation
	BHI     L99F2			;Bra if cool temp is >
;
;-Here to skip purge compensation
;
L99ED	CLR     L085B			;Clear idle purge timer
	BRA     L9A20			;Bra to continue
;
;-Here if purge compensation ok'd
;
L99F2	LDAB    L085B			;Load idle purge timer
	CMPB    L4F7E			;Timer threshold to begin compensation
	BCC     L9A05			;Bra if timer >=, continue with compensation
;
;-Not time for idle purge compensation yet
;
	BRCLR   L0002,#$F0,L9A00	;Loop counter, bra if b0-b3 are clear, inc. timer
;
	BRA     L9A20			;Skip compensation
;
L9A00	INC     L085B			;+1, idle purge timer
	BRA     L9A20			;Bra to skip compensation
;
;-Here to continue with idle purge compensation
;
L9A05	BRSET   L0036,#$02,L9A15	;Bra if b1==1, in drive
;
;-In P/N
;
	LDAB    L4F80			;Added RPM for P/N purge comp.
	BRCLR   L0036,#$01,L9A1F	;Status word, bra if b0==0, no A/C
;
;-In P/N and A/C is on
;
	LDAB    L4F81			;Added RPM for P/N + A/C purge comp.
	BRA     L9A1F			;Bra to continue
;
;-In drive
;
L9A15	LDAB    L4F82			;Added RPM for drive purge compensation
	BRCLR   L0036,#$01,L9A1F	;Status word, bra if b0==0, A/C off
;
;-In drive and A/C is on
;
	LDAB    L4F83			;Added RPm for drive + A/C purge compensation
;
L9A1F	ABA 				;Add it into the desired RPMs
;
;-Here to skip purge compensation
;   
L9A20	PSHA				;Push desired RPM term to stack    
	LDAA    L085C			;Added desired idle speed
	BEQ     L9A31			;Bra if ==0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to add in additional desired idle speed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L0036,#$02,L9A31	;Status word, bra if b1==1, in drive
;
;-In neutral
;
	ASLA				;Added desired idle x2    
	LDAB    L4EB2			;Multiplier for P/N
	MUL				;added desired idle speed x multiplier     
	ADCA    #$0000			;Round if needed
;
L9A31	PULB				;Get desired idle speed term back    
	ABA				;Add in the additional desired idle speed     
	CMPA    L085F			;Filtered desired idle speed term
	BCC     L9A3C			;Bra if desired RPMs are rising
;
;-Desired idle speed falling, gradually bring down stored idle speed term down to match
;
	LDAA    L085F			;Filtered desired idle speed term
	DECA				;-1 
;   
L9A3C	STAA    L085F			;Save it, filtered desired idle speed term
	LDX     #L4E85			;IAC option word
	BRCLR   0,X,#$10,L9A8B		;Bra if b4==0, no A/C high pressure switch in use
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; A/C high pressure switch in use, increase idle speed if needed to help
; improve airflow through condensor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;

	LDAB    L4F84			;Desired RPMs for high A/C press. (P/N)
	BRCLR   L0036,#$02,L9A50	;Status word, bra if b1==0, in P/N
;
	LDAB    L4F85			;Desired RPMs for high A/C press (drive)		
;
L9A50	CBA				;Compare to filtered desired RPM term     
	BCS     L9A56			;Bra if stored desired RPMs are <
;
;-Desired RPMs are greater then those for high A/C pressure 
;
	CLRA				;Clear added A/C high pressure RPMs    
	BRA     L9A7F			;Bra to save and continue
;
;-Desired RPMs are less
;
L9A56	JSR     L9333			;Routine to test status of high pressure switch
;
	BCS     L9A6B			;Bra if A/C high pressure switch is closed
;
;-Excessive pressure on high side of A/C not indicated
;
	LDAA    L0860			;Added desired RPMs for high A/C pressure
	BEQ     L9A66			;Bra if ==0
;
	LDAB    L0861			;High A/C pressure delay timer
	BNE     L9A7B			;Bra if !=0, added RPMs still in effect
;
	DECA				;-1, decay out added RPMs
;    
L9A66	LDAB    L4F87			;Load time delay for added RPMs for high A/C press.
	BRA     L9A82			;Bra to save and continue
;
;-Here if excessive high side pressure is indicated
;
L9A6B	CMPB    L0857			;Compare desired A/C RPMs to desired RPMs
	BHI     L9A73			;Bra if desired RPMs are less
;
	TBA				;Get desired A/C RPMs into A instead     
	BRA     L9A8B			;Bra to save and continue
;
;-Stored desired RPMs are less then desired RPMs for high A/C press.
;
L9A73	LDAA    L0860			;Added desired RPMs
	LDAB    L0861			;High A/C pressure delay timer
	BEQ     L9A7E			;Bra if timer ==0, begin add
;
L9A7B	DECB				;-1 from timer    
	BRA     L9A82			;Bra
;
;-Timer has run out, add in additional desired RPM to help improve airflow through
; condensor
;
L9A7E	INCA				;+1, added A/C high pressure desired RPMs
;    
L9A7F	LDAB    L4F86			;Delay to add in desired RPMs if high load
					;previously present
;
L9A82	STAA    L0860			;Save it, A/C high pressure added RPMs
	ADDA    L085F			;Add stored filtered desired RPM term in
	STAB    L0861			;Save high A/C pressure delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if A/C high pressure switch isnt in use
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9A8B	STAA    L0857			;Save as desired idle RPM
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Calculate stall saver activation threshold
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L5043			;Start of stall saver multipliers
	LDAB    #$03			;Mask b0 and b1
;
; L0036
;  b1, 1=Drive, 0=P/N
;  b0, 1=A/C on, 0= A/C off
;
	ANDB    L0036			;Mask lower two bits
	ABX				;Add in as offset     	
	LDAB    L4E85			;IAC option byte
	BITB    #$80			;Test b7, use default RPM threshold for stall saver
	BEQ     L9AA1			;Bra if ==0, use desired RPM and multiplier instead
;
	LDAA    0,X			;Load RPM threshold
	BRA     L9AA4			;Bra to save
;
;-Use multiplier here
;
L9AA1	LDAB    0,X			;Load multiplier
	MUL				;Desired RPM x multiplier     
L9AA4	STAA    L0868			;Save it, stall saver threshold
L9AA7	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to update the integrator 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Items on stack:
; 
; 0: MSB, Delta integrator term
; 1: LSB, Delta integrator term
; 2: MSB, Coupled IAC flow vs. cool temp
; 3: LSB, Coupled IAC flow vs. cool temp
; 4: MSB, Current integrator idle airflow term
; 5: LSB, Current integrator idle airflow term
;
L9AA8	LDX     #L02CA			;start of idle integrator cells, drive
	BRSET   L0036,#$02,L9AB2	;Status word, bra if b1==1, in drive
;
;-In park/neutral
;
	LDX     #L02C0			;Start of idle integrator cells, park/neutral
;
;-Here if in drive
;
L9AB2	LDD     3,X			;Load current idle integrator flow term, A/C
	BRSET   L0036,#$01,L9ABA	;Bra if b0==1, A/C is on
;
;-A/C is off
;
	LDD     0,X			;Load current idle integrator flow term, no A/C
;
;-Here if A/C is on
;
L9ABA	PSHB				;Push current integrator term to stack    
	PSHA 				;   
	LDD     6,X			;Load coupled IAC flow vs. cool temp
	PSHB				;Push to stack    
	PSHA				;    
	CLRB				;Pre-clear two bytes for delta integrator term    
	PSHB				;    
	PSHB				;    
	TSY				;Get current stack pointer into Y     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for closed loop idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L01FC			;TPS
	CMPA    L4EE8			;1.56 %TPS, upper threshold for closed throttle
	BCS     L9AD2			;Bra if TPS <
;
	BSET    L0039,#$80		;Status word, set b7, throttle is open
	BRA     L9ADD			;Bra to continue
;
L9AD2	BCLR    L0039,#$80		;Clear b7, throttle closed									
	LDAA    L02A7			;MPH
	CMPA    L4EE9			;Upper MPH limit for closed loop idle
	BCS     L9AE8			;Bra if MPH less
;
;-Closed loop quals not met
;
L9ADD	LDAB    L4EEA			;Closed loop enable delay if quals not met
	STAB    L0864			;Closed loop idle enable delay timer
	BCLR    L0036,#$04		;Status word, clear b2, closed loop idle quals 
					;not met
	BRA     L9B10			;Bra to continue
;
;-Closed loop idle quals met
;
L9AE8	BSET    L0036,#$04		;Status word, set b2, closed loop quals met
	LDAA    L0882			;High res filtered TPS
	CMPA    L0885			;Upper limit for closed TPS, hi res term
	BHI     L9B10			;Bra if throttle is open
;
;-Closed loop quals met and throttle is closed
;
	LDAA    L0864			;Closed loop idle delay timer
	BEQ     L9AFE			;Bra if ==0, continue
;
;-Closed loop idle timer has not yet run out
;
	DECA				;-1, 
	STAA    L0864			;Save it, closed loop idle delay timer
	BRA     L9B10			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; closed loop quals and delay have been met, check quals for enabling closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check delay for entering closed loop
;
L9AFE	BRSET   L0036,#$80,L9B09	;Status word, bra if b7==1, idle RPM high
;
;-Low idle
;
	LDAA    L0866			;Closed loop idle delay, low idle
	BEQ     L9B2A			;Bra if ==0, continue
;
	BRA     L9B3B			;Bra, no closed loop
;
;-Here if idle high
;
L9B09	LDAA    L0867			;Closed loop idle delay, high idle
	BEQ     L9B2A			;Bra if ==0, continue
;
	BRA     L9B3B			;Bra, no closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Timer to ok closed loop entry not yet met or throttle is open
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9B10	BRSET   L0036,#$80,L9B3B	;Status word, bra if b7==1, high idle, bar entry 
					;into closed loop
;
;-Check for a transition or timer that has not yet been met
;
	LDAA    L0866			;Closed loop idle delay, low idle
	ORAA    L087A			;Trans shift transition timer
	ORAA    L0877			;A/C on/off transition timer
	BNE     L9B3B			;Bra if in transition or still delaying closed loop
;
;-Check if closed loop quals already met
;
	BRSET   L0036,#$04,L9B2A	;Status word, bra if b2==1, closed loop quals met
;
;-Check if manual is in use, and bar entry into closed loop if delays not yet met 
;
	LDAA    L4E85			;Option byte
	BITA    #$01			;Test b0
	BNE     L9B3B			;Bra if ==1, manual trans in use
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if ok to enter closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9B2A	BRSET   L003E,#$04,L9B3B	;Status word, bra if b2==1, batt volts too low 
					;for IAC, no closed loop
;
;-Check if throttle kicker is active
;
	BRCLR   L0037,#$04,L9B41	;Status word, bra if b2==0, throttle kicker not 
					;active, enter closed loop idle
;
;-Throttle kicker is active
;
	LDD     L088B			;Desired IAC airflow
	BNE     L9B41			;Bra if !=, allow closed loop idle
;
;-Desired airflow is ==0, check for low idle
;
	BRCLR   L0036,#$80,L9B41	;Bra if b7==0, low idle, allow closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if closed loop idle not ok'd
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9B3B	BCLR    L0036,#$08		;Clear b3, no closed loop idle
	JMP     L9CE9			;Bra to continue				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to ok closed loop idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9B41	BSET    L0036,#$08		;Set b3, now in closed loop idle
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if stall is pending
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0036,#$10,L9B50	;Bra if b4==0, stall saver not active
;
;-Stall saver active, check if engine has recovered
;
	BRCLR   L0036,#$80,L9B82	;Bra if b7==0, low idle, engine has not yet
					;recovered
;
;-Engine recovered, clear stall saver timer and added flow
;
	CLRA				;
	CLRB				;
	BRA     L9B70			;Bra to save and continue
;
;-No stall saver, check if engine below threshold for stall saver
;										
L9B50	LDAA    L0868			;Stall saver activation threshold
	CMPA    L0063			;RPM/12.5
	BLS     L9B82			;Bra if RPMs >= to threshold
;
;-RPMs below threshold for stall saver
;
	BSET    L0036,#$10		;Set b4, stall saver now active
	PSHX				;    
;
;-Look up added airflow
;				 
	LDX     #L5047			;Start of added stall saver flow
	LDAB    #$03			;Mask out lower two bytes 
	ANDB    L0036			;And with status word 
	ABX				;Add in as 
	LDAA    0,X			;Load in added flow 
	PULX				;
	LDAB    L504B			;Time for stall saver to be active, P/N
	BRCLR   L0036,#$02,L9B70	;Status word, bra if b1==1, in P/N
;
;-In drive
;
	LDAB    L504C			;Time for stall saver to be active, drive
;			
L9B70	STAB    L0869			;Save it, stall saver duration timer			
	CLRB				;
	ADDD    4,Y			;Add in the stall saver flow to the current 
					;idle integrator
	BCC     L9B7C			;Bra if no overflow

	LDD     #$FFFF			;Clear overflow
;
L9B7C	STD     4,Y			;Save the integrator to stack
	JMP     L9CBD			;Bra to continue			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Scale RPM error for lookup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 200 RPM < RPM error 
;  value for lookup = (RPM error/6.25) + 80
;
; 50 RPM < RPM error <= 200 RPM
;  value for lookup = (RPM error/3.125) + 48
;
; RPM error <= 50 RPM
;  value for lookup = (RPM error/.78125) 
;
L9B82	LDAA    L0858			;Idle speed RPM error
	CMPA    #40			;500 RPM
	BLS     L9B8D			;Bra if RPM error <=

	LDAA    #160			;500 RPM, max scaled RPM for lookup 
	BRA     L9BA1			;Bra to continue
;
;-RPM error <= 500 RPM
;
L9B8D	ASLA				;x2
	CMPA    #32			;200 RPM
	BLS     L9B96			;Bra if RPMs <=
;
;-RPM error > 200 RPM
;
	ADDA    #80			;Add in  offset
	BRA     L9BA1			;Bra to continue
;
;-RPM error <= 200 RPM
;
L9B96	ASLA				;x2
	CMPA    #16			;50 RPM
	BLS     L9B9F			;Bra if RPMs <=
;
;-RPM error > 50 RPM
;
	ADDA    #48			;Add in offset
	BRA     L9BA1			;Bra to continue
;
;-RPM error <= 50 RPM
;
L9B9F	ASLA				;x2    
	ASLA				;x2
;
L9BA1	PSHX				;Push addr. to stack   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up idle integral gain 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L0036,#$80,L9BB2	;Status word, bra if b7==1, idle too high
;
;-Idle speed low and in drive
;
	LDX     #L4F9E			;Idle integral gain vs. RPM error (low RPM & drive)
	BRSET   L0036,#$02,L9BBC	;Bra if b1==1 in drive
;
;-Idle speed low and in P/N
;
	LDX     #L4F88			;Idle integral gain vs. RPM error (low RPM and P/N)
	BRA     L9BBC			;Bra to continue
;
;-Idle speed high and in drive
;
L9BB2	LDX     #L4FA9			;Idle integral gain vs. RPM error (hi RPM and drive)
	BRSET   L0036,#$02,L9BBC	;Bra if b1==1, in drive
;
;-Idle speed high and in P/N
;
	LDX     #L4F93			;Idle integral gain vs. RPM error (hi RPM and P/N)
;
L9BBC	JSR     LF15E			;2D lookup
	PULX				;Restore addr.
	LDAB    L0858			;RPM error 
	MUL				;RPM error x integral gain
	STD     0,Y			;Save to stack, delta integral term
;
;-Check condition of idle
;
	BRSET   L0036,#$80,L9C31	;Status word, bra if b7==1, high idle
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Low idle here, check if IAC reset is needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L50B8			;Lower cool temp limit to check integrator 
	BLS     L9BF9			;Bra if cool temp <=
;
;-Cool temp threshold met, check for pending integrator wind up
;
	LDAA    L50B9			;Upper limit for integral idle term if no A/C
	BRCLR   L0036,#$01,L9BDC	;Bra if b0==0, on A/C
;
;-A/C on
;
	LDAA    L50BA			;Upper limit for integral idle term if A/C on
;
L9BDC	CMPA    4,Y			;Compare to integrator
	BCC     L9BF9			;Bra if integrator <=, within limits
;
	BRSET   L003B,#$10,L9BF9	;Status word, bra if b4==1, in mode 4
;
	BRSET   L0050,#$10,L9BF9	;Status word, bra if b4==1, in diagnostics
;
;-Excessive integrator detected, actual and stored positions differ, reposition IAC
;
	BCLR    L0009,#$04		;Status word, clear b2, IAC reset requested
	LDAA    L0002			;Loop counter
	CMPA    L50BC			;Counter val., time threshold to begine removing
					;steps and force IAC to retract
	BCC     L9BF6			;Bra if counter is <=, dont pull steps yet
;
	DEC     L0007			;-1 from stored current IAC steps
;
L9BF6	JMP     L9CE9			;Bra to exit															
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if integrator is within limits or temp threshold not yet met
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9BF9	LDD     L088B			;Desired IAC airflow
	CPD     #65535			;100% airflow
	BEQ     L9C5F			;Bra if ==, airflow maxed out
;
	LDAA    2,X			;Steady state integrator term, A/C off
	BRCLR   L0036,#$01,L9C0A	;Status word, bra if b0==0, no A/C
;
;-A/C on
;
	LDAA    5,X			;Steady state integrator term, A/C on
;
L9C0A	CMPA    4,Y			;Compare to integrator term on stack
	BHI     L9C23			;Bra if current integrator has fallen
;
;-Here if current integrator term is rising with respect to steady state value
;
	LDD     6,X			;Coupled IAC flow vs. cool temp
	CPD     8,X			;IAC flow vs. cool temp
	BCC     L9C23			;Bra if coupled flow is >=
;
;-Add delta integrator term to IAC flow vs. cool temp instead
;
	ADDD    0,Y			;Add in delta integrator term
	BCC     L9C1E			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
L9C1E	STD     2,Y			;Save it, coupled IAC flow vs cool temp on stack
	BRA     L9C5F			;Bra to continue
;
;-Current integrator term has fallen with respect to steady state value
;
L9C23	LDD     4,Y			;Current integrator
	ADDD    0,Y			;Add in delta integrator term
	BCC     L9C2E			;Bra if no overflow

	LDD     #$FFFF			;Clear overflow
;
L9C2E	JMP     L9CBD			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if high idle is present
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Provide additional decay for added flows if needed
;
L9C31	LDAA    L087B			;Added P/S compensation flow
	BEQ     L9C49			;Bra if ==0
;
	SUBA    0,Y			;Subtract delta integrator term
	BCC     L9C3E			;Bra if no underflow
;
	CLRA				;Clear flow    
	BRA     L9C44			;Bra to sace

L9C3E	CMPA    L087B			;Compare to stored P/S compensation flow
	BNE     L9C44			;Bra if non-zero difference
;
;-No change from subtraction of delta integrator term
;
	DECA				;-1 if no change from delta integrator term 
;   
L9C44	STAA    L087B			;Save it, P/S compensation flow
	BRA     L9C5F			;Bra to sve and exit
;
;-Check added initial flow after startup
;
L9C49	LDAA    L086B			;Added initial flow after startup
	BEQ     L9C62			;Bra if ==0
;
	SUBA    0,Y			;Subtract delta integrator term
	BCC     L9C56			;Bra if no underflow
;
	CLRA				;Clear underflow    
	BRA     L9C5C			;Bra to save and exit
;
L9C56	CMPA    L086B			;Compare to added initial flow after startup
	BNE     L9C5C			;Bra if delta integrator was non-zero
;
;-No change from subtraction of delta integrator term
;
	DECA				;-1 from flow
;
L9C5C	STAA    L086B			;Initial flow added after startup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if added flow terms are !=0, dont compute integrator terms yet
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9C5F	JMP     L9CE9			;Bra to save and return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if flow terms have been decayed out
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9C62	LDD     4,Y			;Current idle integrator airflow term
	SUBD    0,Y			;Subtract delta integral term
	BCC     L9C6D			;Bra if no underflow
;
	LDD     #$0000			;Clear underflow
;
;-Check for VSS error
;
L9C6D	BRSET   L0016,#$10,L9C94	;Error word #1, bra if b4==1, err 16, VSS 
;
;-No VSS error
;
	PSHX				;Push addr. in X to stack		    
	LDX     2,Y			;Load coupled IAC flow vs. cool temp 
	PULX				;Restore X    
	BEQ     L9C94			;Bra if cool temp decayed out
;
	PSHB				;Push LSB of current integral term to stack				    
	LDAB    5,X			;Steady state idle integral term, A/C on
	BRSET   L0036,#$01,L9C81	;Status word, bra if b0==1, A/C on
;
;-A/C is off
;
	LDAB    2,X			;Steady state idle integral term, A/C off
;
;-A/C is on
;
L9C81	CBA				;Compare to current integral term     
	PULB				;Get LSB back    
	BCC     L9CBD			;Bra if current integral has risen
;
;-Current integral has fallen below steady state val, reduce cool temp based flow
;
	LDD     2,Y			;Coupled IAC flow vs. cool temp
	SUBD    0,Y			;Subtract delta integral term
	BCC     L9C8F			;Bra if no underflow
;
	CLRA				;Clear flow    
	CLRB				;
;
L9C8F	STD     2,Y			;Save IAC flow vs. cool temp
	BRA     L9CE9			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to check if low integrator is present
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9C94	CPD     #$0000			;Compare integrator to zero
	BNE     L9CBD			;Bra if non-zero integrator is present
;
;-Check for throttle kicker failure
;   
	BRSET   L0009,#$40,L9CBD	;Status word, bra if b6==1, T/K has failed diags.
;
;-Integrator has zero'd out, check RPM error
;
	PSHA				;Push MSB of integrator to stack    
	LDAA    L0858			;RPM error
	CMPA    L50BB			;RPM error threshold to request reset and reposition
					;IAC
	BLS     L9CBC			;Bra if RPM error is <=
;
	BRSET   L003B,#$10,L9CBC	;Status word, bra if b4==1, in mode 4
;
	BRSET   L0050,#$10,L9CBC	;Status word, bra if b4==1, in diags.
;   
;-Integrator has zero'd out and RPM error present, reposition IAC and req. reset
;
	BCLR    L0009,#$04		;Status word, clear b2, request reset
	LDAA    L0002			;Loop counter
	CMPA    L50BC			;Counter val., time threshold to begine adding
					;steps and force IAC to extend
	BCC     L9CBC			;Bra if counter >=
;
	INC     L0007			;+1, stored current IAC steps
;
L9CBC	PULA				;Get MSB of integrator back   
;
;-Check for VSS fault
;
L9CBD	BRCLR   L0016,#$10,L9CDC	;Error word #1, bra if b4==1, err 16, VSS  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; VSS fault present, make sure integrator doesnt fall below defualt value
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	PSHB				;Push LSB to stack    
	LDAB    L4EA8			;Default value for integrator term, drive
	BRSET   L0036,#$02,L9CCC	;Status word, bra if b1==1, in drive
;
;-In park/neutral
;
	LDAB    L4EA7			;Default value for integrator term, park/neutral
;
	BRCLR   L0036,#$01,L9CD3	;Bra if b0==0, A/C off
;
;-A/C is on
;
	ADDB    L4EA9			;Added flow if A/C is on
;
L9CD3	CBA				;Compare MSB of integrator to default value     
	BCS     L9CD9			;Bra if integrator was <
;
;-Integrator is >= to default value, save and return
;
	PULB				;Get LSB back    
	BRA     L9CDC			;Bra to save and return
;
;-Integrator is < then default value, load default integrator value instead
;
L9CD9	TBA				;Get default value into A     
	PULB				;Pull LSB    
	CLRB				;Clear LSB 
; 
;-Here if no VSS fault
;
L9CDC	STD     4,Y			;Save current integrator to stack
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Save integrator terms and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
	BRCLR   L0036,#$01,L9CE7	;Status word, bra if b1==0, no A/C
;
;-A/C is on
;
	STD     3,X			;Save current integrator to A/C on idle cell
	BRA     L9CE9			;
;
;-Here if no A/C
;
L9CE7	STD     0,X			;Save current integrator to A/C off idle cell
;
L9CE9	LDD     2,Y			;Coupled IAC flow vs. cool temp
	STD     6,X			;Save it to idle cell
	STD     L0871			;Save it, added coupled IAC flow vs. cool temp
	LDD     8,X			;IAC flow vs. cool temp
	STD     L0873			;Save it, stored IAC flow vs. cool temp
	LDD     4,Y			;Current idle integrator
	STD     L0862			;Save it, stored idle integrator
;
;-Restore stack
;
	LDAB    #$06			;+6
	ABY				;Add in as offset     
	TYS				;Transfer to stack pointer
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to look up idle proportional term
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9D03	BRSET   L0036,#$02,L9D13	;Status word, bra if b1==1, in drive
;
;~~~~~~~~~~~~~~~~~
; In neutral here
;~~~~~~~~~~~~~~~~~
;
	LDX     #L4FC2			;Idle proportional term, low RPM and P/N
	BRCLR   L0036,#$80,L9D53	;Bra if b7==0, low idle RPM
;
;-In neutral and high idle present
;
	LDX     #L4FCD			;Idle proportional term, high RPM and P/N
	BRA     L9D53
;
;~~~~~~~~~~~~~~~
; In drive here
;~~~~~~~~~~~~~~~
;
L9D13	CLRB				;Clear table index    
	BRCLR   L0036,#$01,L9D1A	;Bra if b0==0, A/C is off
;
;-A/C is on
;
	ADDB    #$08			;Advance ahead four tables if A/C is on
;
;-A/C is off
;
L9D1A	BRCLR   L0036,#$08,L9D20	;Bra if b3==0, closed loop idle not enabled
;
;-Closed loop idle
;
	ADDB    #$04			;Advance ahead two tables if in closed loop
;
;-Here if open loop idle, check for high/low idle
;
L9D20	BRCLR   L0036,#$80,L9D26	;Status word, bra if b7==0, low idle
;
;-High idle present
;
	ADDB    #$02			;Advance one table if high idle
;
;-Low idle present
;
L9D26	LDX     #L9D79			;Start of proportional table indexes
	ABX 				;Add in offset for lookup
	LDX     0,X			;Load table
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for limiting proportional action if high idle and in motion
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0036,#$80,L9D53	;Bra if b7==0, low idle
;
;-High idle present, if in motion, limit proportional action
;
	LDAA    L02A7			;MPH
	CMPA    L4FBF			;Lower threshold to limit prop. action
	BCS     L9D3D			;Bra if current MPH >
;
;-In motion, limit proportional action
;
	BSET    L0037,#$40		;Status word, set b6, limiting idle proportional 
					;action  
	BRA     L9D4B			;Bra to continue
;
;-Check if speed low enough to restore full proportional control
;
L9D3D	CMPA    L4FC0			;Upper threshold to allow full prop. control 
	BCC     L9D47			;Bra if speed >=, dont restore proportional action
;
;-Not in motion, allow full proportional control
;
	BCLR    L0037,#$40		;Clear b6, not limiting proportional action
	BRA     L9D53			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Limit proportional action if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9D47	BRCLR   L0037,#$40,L9D53	;Bra if b6==0, not limiting proportional action
;
;-Limiting proportional action
;
L9D4B	LDAA    L4FC1			;Upper limit for RPM error if limiting action
	CMPA    L0858			;RPM error
	BLS     L9D56			;Bra if RPM error is >= to threshold
;
;-Here if not limiting proportional action
;
L9D53	LDAA    L0858			;RPM error
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Scale RPM error for lookup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 200 < RPM error 
;  value for lookup = (RPM error/6.25) + 80
;
; 50 < RPM error <= 200 RPM
;  value for lookup = (RPM error/3.125) + 48
;
; RPM error <= 50
;  value for lookup = (RPM error/.78125) 
;
L9D56	CMPA    #40			;500 RPM
L9D58	BLS     L9D5E			;Bra if RPM error <=
;
	LDAA    #160			;500 RPM, max scaled RPM for lookup 
	BRA     L9D72			;Bra to continue
;
;-RPM error <= 500 RPM
;
L9D5E	ASLA				;x2    
	CMPA    #32			;200 RPM				
	BLS     L9D67			;Bra if RPMs <=					
;
;-RPM error > 200 RPM
;
	ADDA    #80			;Add in  offset			
	BRA     L9D72			;Bra to continue				
;
;-RPM error <= 200 RPM
;
L9D67	ASLA				;x2    					
	CMPA    #16			;50 RPM				
	BLS     L9D70			;Bra if RPMs <=				
;
;-RPM error > 50 RPM
;
	ADDA    #48			;Add in offset				
	BRA     L9D72			;Bra to continue				
;
;-RPM error <= 50 RPM
;
L9D70	ASLA				;x2     
	ASLA				;x2    
; 
L9D72	JSR     LF15E			;2D lookup 				
;
	STAA    L086D			;Save it, proportional idle term
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle proportional flow tables vs. RPM error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-A/C off, in drive, and open loop idle
;                   
L9D79   FCB L4FD8			;Low idle
L9D7B   FCB L4FE3			;High idle
;
;-A/C off, in drive, and closed loop idle
;
L9D7D   FCB L4FEE			;Low idle
L9D7F   FCB L4FE9			;High idle
;
;-A/C on, in drive, and open loop idle
;				
L9D81   FCB L5004			;Low idle
L9D83   FCB L500F			;high idle
;
;-A/C on, in drive, and closed loop idle
;
L9D85   FCB L501A			;Low idle
L9D87   FCB L5025			;High idle
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to construct derivative idle term
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9D89	LDX	#L5032			;IAC derivative term table vs. transient RPM ratio 	  
	LDAA    L006C			;Transient RPM ratio
	SUBA    #96			;.75, offset for lookup
	BCC     L9D95			;Bra if no underflow
;
	CLRA				;Clear underflow    
	BRA     L9D9F			;Bra to do lookup
;
L9D95	CMPA    #64			;1.25, upper limit for lookup
	BCS     L9D9D			;Bra if less
;
	LDAA    #255			;Load max value
	BRA     L9D9F			;Bra to do lookup
;
;-Scale ratio for lookup
;
L9D9D	ASLA				;x2    
	ASLA				;x2
L9D9F	JSR     LF15E			;2D lookup
;
;-Check if derivative term is changing
;
	LDX     L086E			;Stored idle derivative term
	CLRB				;Clear LSB    
	CMPA    L086E			;Compare term from lookup to stored term
	BEQ     L9DDF			;Bra if ==, return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for limiting derivative action
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Needed derivative term has changed
;
	BRSET   L0037,#$80,L9DB7	;Status word, bra if b7==1, positive derivative term
;
;-Derivative term was negative
;
	BHI     L9DC2			;Bra if derivative action is decreasing
;
;-Negative derivative action is increasing, check for low idle
;
	BRCLR   L0036,#$80,L9DC2	;Status word, bra if b7==0, low idle, limit 
					;derivative action
;
;-High idle present
;
	BRA     L9DC8			;Bra, dont limit derivative action
;
;-Here if derivative term was positive
;
L9DB7	BCS     L9DBD			;Bra if derivative action is decreasing
;
;-Positive derivative action is increasing, check for low idle
;
	BRCLR   L0036,#$80,L9DC8	;Bra if b7==1, low idle, dont limit action
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to limit positive derivative action
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9DBD	LDAB    L5030			;Filter coeff. for limiting positive derivative
					;action
	BRA     L9DC5			;Bra to go filter derivative term
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to limit negative derivative action 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9DC2	LDAB    L5031			;Filter coeff. for limiting negative derivative
					;action
L9DC5	JSR     LF0F6			;Filter routine
;
L9DC8	STD     L086E			;Save it, stored derivative idle term
	SUBA    #128			;Subtract 128, make signed value
	BCC     L9DD5			;Bra if derivative term is positive
;
;-Derivative term is negative
;			
	NEGA				;Get abs. value 	   
	BCLR    L0037,#$80		;Clear b7, negative derivative term
	BRA     L9DD8			;Bra to save
;
;-Derivative term is positive
;
L9DD5	BSET    L0037,#$80		;Set b7, derivative term is positive
;
L9DD8	LSRA				;/2    
	LSRA    			;/2
	ADCA    #$00			;Round up if needed
	STAA    L0870			;Save it, derivative idle flow term
L9DDF	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Throttle follower routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9DE0	LDAA    L01FC			;TPS
	ASLA				;x2
	BCS     L9DE9			;Bra if overflow
;
	ASLA				;x2   
	BCC     L9DEB			;Bra if overflow
;										
L9DE9	LDAA    #255			;Clear overflow
;
L9DEB	CMPA    L0882			;Hi res filtered TPS
	BLS     L9E16			;Bra if current TPS is <=
;
;-TPS is rising
;											
	LDAB    L5064			;Max TPS for P/N throttle follower
;
	BRCLR   L0036,#$02,L9E0F	;Status word, bra if b1==0, in P/N
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up TPS filtering delay timer 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	PSHA				;Push current TPS to stack    
;
	LDAA    L02A7			;MPH
	CMPA    #80			;80 MPH, upper limit for lookup
	BLS     L9E01			;Bra if MPH are less
;
	LDAA    #80			;Load upper limit instead
;				
L9E01	ASLA				;MPH x 2 for lookup
	LDX     #L5067			;TPS filtering period vs. MPH 
	JSR     LF15E			;2D lookup
;
	STAA    L0884			;Save it, TPS filtering period
;
	PULA				;Get current TPS back				    
	LDAB    L5065			;Max TPS for drive throttle follower
;
;-Here if TPS is rising and in P/N
;
L9E0F	CBA				;Compare TPS to limit     
	BLS     L9E13			;Bra if TPS is less

	TBA				;Get limit in instead
;     
L9E13	CLRB				;Clear LSB   
	BRA     L9E51			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if TPS is falling, filter TPS back down
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9E16	LDAB    L0884			;Load TPS filtering period
	BEQ     L9E20			;Bra if ==0
;
;-Timer !=0
;
	LDD     L0882			;Stored hi res filtered TPS
	BRA     L9E51			;Bra to continue
;
;-Here if timer has expired, time to filter TPS
;
L9E20	PSHA				;Push TPS to stack    
	BRSET   L0036,#$02,L9E2A	;Status word, bra if b1==1, in drive 
;
;-In park/neutral
;
	LDAA    L5066			;P/N TPS filter coeff.
	BRA     L9E3A			;Bra to filter and continue
;
;-Here if in drive
;
L9E2A	LDAA    L02A7			;MPH
	CMPA    #80			;80 MPH, upper limit for lookup
	BLS     L9E33			;Bra if MPH <=
;
	LDAA    #80			;Load upper limit instead
;
L9E33	ASLA				;MPH x2   
	LDX     #L5072			;TPS filtering coeff. vs. MPH
	JSR     LF15E			;2D lookup
;
L9E3A	LDAB    L01E3			;SD MAP
	CMPB    L507E			;Low MAP threshold to scale down filter coeff.
	BCC     L9E46			;Bra if MAP >=
;
;-Low MAP present, scale down filter coeff.	
;
	LDAB    L507F			;Low MAP multiplier for filter coeff.
	MUL				;TPS filter coeff. x multiplier
;     
L9E46	TAB				;Get filter coeff. into B     
	BNE     L9E4A			;Bra if !=0
;
	INCB				;+1, lowest allowable filter coeff.  
;  
L9E4A	PULA				;Get TPS back off stack   
	LDX     L0882			;Load high res filtered TPS
	JSR     LF0F6			;Filter routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Throttle was rising, skip filtering
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for cool engine temp
;
L9E51	PSHB				;Push filtered TPS to stack    
	PSHA				;   
;
	BRSET   L0037,#$01,L9E70	;Status word, bra if b0==1 warm engine
					;already flagged
;
	LDAB    L02A5			;Initial cool temp (engine off)
	CMPB    L5090			;Lower temp limit for cool engine T/F operation
	BCS     L9E6D			;Bra if cool temp was <
;											
	CMPB    L5091			;Temp threshold for cool engine
	BCC     L9E6D			;Bra if cool temp >=, warm engine temps present
;
;-Check time limit for cool engine status to be set
;
	LDX     L00F8			;Engine run time
	CPX     L5092			;Upper time limit to flag cool engine temps										
	BHI     L9E6D			;Bra if run time was greater
;
	BRA     L9E70			;Bra to continue
;
;-Warm engine temps
;
L9E6D	BSET    L0037,#$01		;Status word, set b0, engine is warm
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if throttle is above threshold for open throttle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~							
;				
L9E70	BRSET   L0039,#$80,L9EB2	;Status word, bra if b7==1, throttle is open
;
;-Throttle is closed here
;
	TST     L0884			;TPS filtering delay period
	BNE     L9EB2			;Bra if !=0
;
;-Filtered TPS has been updated
;
	BRSET   L0036,#$04,L9EB2	;Bra if b2==1, closed loop idle quals met
;
;-Closed loop idle not pending
;							
	BRCLR   L0046,#$08,L9E8D	;Bra if b3==0, DFCO not in effect
;
;-DFCO in effect
;
	LDAB    L4E85			;IAC option byte
	BITB    #$02			;Test b1, maintain T/F action during DFCO
	BNE     L9E8D			;Bra if ==1, perform lower limit for ensuring 
					;added T/F flow
;
;-Here for limited or no T/F action during DFCO
;
	BSET    L0039,#$40		;Status word, set b6, manditory post-DFCO  
					;T/F flow update
;
	BRA     L9ECF			;Bra to skip and continue			
;
;-Check lower limit for filtered TPS during closed throttle to ensure some added flow
;
L9E8D	LDAA    L02A6			;Cool temp
	LDX     #L5080			;TPS limit for minimum added T/F flow 
	JSR     LF15E			;2D lookup
;
	CLRB				;Clear LSB    
;
	BRSET   L0037,#$01,L9EA8	;Status word, bra if b0==1, engine is warm
;
;-Cool engine temps present, scale up lower limit to add aditional flow
;
	LDAB    L5096			;Multiplier for limit
	MUL				;Limit x multiplier     
	ASLD				;x2    
	BCS     L9EA5			;Bra if no overflow
;
	ASLD				;x2, now result /64    
	BCC     L9EA8			;Bra if no overflow
;
L9EA5	LDD     #$FFFF			;Clear overflow
;
L9EA8	TSX				;Get current stack pointer into X    
	CPD     0,X			;Compare to lower limit for TPS
	BLS     L9EBE			;Bra if TPS is greater
;
	STD     0,X			;Save limit instead
	BRA     L9EBE			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if throttle open/not updating filtered TPS this pass/closed loop idle pending
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9EB2	LDAB    #$FF			;Max value for timer if closed loop pending
	BRSET   L0036,#$04,L9ECC	;Status word, bra if closed loop quals met
;
;-Closed loop idle not pending
;										
	CLRB				;Reset timer    
;
	BCLR    L0037,#$02		;Status word, clear b1, reduce throttle follower
					;action
	BRA     L9ECC			;Bra to save and continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Closed throttle present, limit T/F action after period of time
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9EBE	LDAB    L0886			;Timer to limit T/F action during closed throttle
	CMPB    L508D			;Compare to threshold to reduce T/F action
	BCS     L9ECB			;Bra if timer is <
;
;-Enough time has passed to limit T/F action
;
	BSET    L0037,#$02		;Status word, set b1, limit T/F action
	BRA     L9ECF			;Bra to continue
;
;-Not enough time, inc. timer 
;
L9ECB	INCB				;+1
;
L9ECC	STAB    L0886			;Save timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if throttle follower action sill required
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9ECF	PULA				;Get filtered TPS back    
	PULB				;    	
	STAA    L0882			;Save it, MSB of filtered TPS
;
;-Check TPS limits for save
;
	BNE     L9EDB			;Bra if MSB !=0, save and continue
;
	CMPB    #$0028			;2.73%, lower limit for TPS
	BCC     L9EDB			;Bra if TPS >
;
	CLRB				;Clear TPS, throttle closed  
;  
L9EDB	STAB    L0883			;Save it, LSB of filtered TPS
	SUBA    L0885			;Subtract closed throttle TPS
	BCC     L9EE9			;Bra if TPS >=, throttle open
;
;-TPS below limit, clear throttle follower flow and exit
;
	LDD     #$0000			;Clear flow
	JMP     L9F78			;Bra to save and exit
;
;-Reduce throttle follwer action if needed
;
L9EE9	BRCLR   L0037,#$02,L9EFE	;Bra if b1==0, not limiting action
;
;-Reduced action ok'd
;
	PSHB				;Push %TPS to stack    
	PSHA    			;
	TSX				;Get current stack pointer into X     
	LDAA    L5094			;Multiplier for TPS, cool engine
	BRCLR   L0037,#$01,L9EFA	;Bra if b0==0, cool engine temps
;
;-Warm engine temps present
;
	LDAA    L5095			;Multiplier for TPS, warm engine
;
L9EFA	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Clean up stack
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Begin applying proportional T/F gains
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;   
;-Apply RPM based gain
;
L9EFE	PSHB				;Push %TPS to stack    
	PSHA				;    
	LDAA    L0063			;RPM/12.5
	LDX     #L505A			;Throttle follower gain vs. RPMs
	JSR     LF153			;2D lookup w/ line count
;
	TSX				;Get current stack pointer into X     
	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Clean up stack 	   
	ASLD				;Result x2    
	BCS     L9F13			;bra if overflow
;
	ASLD				;Result x2, now result /64			    
	BCC     L9F18			;Bra if no overflow
;
L9F13	LDD     #$FFFF			;Clear overflow
	BRA     L9F31			;Bra to continue
;
;-Apply cool temp based gain
;
L9F18	PSHB				;Push result to stack    
	PSHA				;    
	LDX     #L504D			;Throttle follower gain vs. cool temp
	LDAA    L02A6			;Cool temp
	JSR     LF15E			;2D lookup
;
	TSX				;Get current stack pointer     
	JSR     LF1ED			;(A x X*)/256

	PULX				;Clean up stack   
	ASLD				;Result x 2    
	BCS     L9F2E			;Bra if overflow
;
	ASLD				;Result x2, now result /64    
	BCC     L9F31			;Bra if no overflow
;
L9F2E	LDD     #$FFFF			;Clear overflow
;
L9F31	BRSET   L0037,#$01,L9F48	;Bra if b0==1, engine is warm
;
;-Cool engine temps present, apply additional throttle follower gain
;
	PSHB				;Push result to stack   
	PSHA				;    
	TSX				;Get current stack pointer into X     
	LDAA    L5097			;Load added gain
	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Clean up stack   
	ASLD				;x2    
	BCS     L9F45			;Bra if overflow
;
	ASLD				;x2, now /64    
	BCC     L9F48			;Bra if no overflow
;
L9F45	LDD     #$FFFF			;Clear overflow
;
;-Here if warm engine temps present
;
L9F48	BRCLR   L0039,#$80,L9F60	;Status word, br aif b7==0, throttle closed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Throttle is open, check limits for updating T/F flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	PSHB				;Push throttle follower airflow to stack    
	PSHA				;    	
	PULX				;Get flow into X    
	SUBD    L0880			;Subtract previous flow
	BCC     L9F58			;Bra if added flow increasing
;
	NEGB				;Get abs. value    
	ADCA    #$0000			;
	NEGA				;
;    
L9F58	CMPA    L507D			;Min allowed change in flow to update
	BCS     L9F7B			;Bra if current delta flow is <, no update

;
;-Enough flow to update
;
	XGDX				;Get updated flow back    
	BRA     L9F78			;Bra to save and return			
;
;~~~~~~~~~~~~~~~~~~~~
; Throttle is closed
;~~~~~~~~~~~~~~~~~~~~
;
L9F60	BRSET   L0046,#$08,L9F6D	;Bra if b3==1. DFCO in effect
;
;-Check if manditory post DFCO update in effect
;
	BRCLR   L0039,#$40,L9F6D	;Bra if b6==0, no manditory update
;
;-Manditory update in effect
;
	BCLR    L0039,#$40		;Clear b6, manditory update flag
	BRA     L9F78			;Bra to save and exit
;
L9F6D	LDX     L0880			;Load stored T/F flow
	BEQ     L9F78			;Bra if ==0, save and return
;
	CPD     L0880			;Compare updated flow to stored flow
	BCC     L9F7B			;Bra if flow was rising
;
;-Here to save flow
;
L9F78	STD     L0880			;Added T/F IAC flow
;
;-Here to return w/o updating
;
L9F7B	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Initial startup idle handling and idle integrator coordination routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9F7C	BRSET   L004F,#$80,L9F83	;Status word, bra if b7==1, engine is running
;
;-Engine is off
;
	JMP     LA370			;Bra to skip routine
;
;-Here if engine is running
;
L9F83	JSR     L997F			;Routine to construct desired RPMs
;   
	BRSET   L0009,#$02,L9FAD	;Status word, bra if b1, first run flag for 
					;kickdown logic, ==1 
;
;-First run here
;
	LDAA    L02A7			;MPH
	CMPA    L4EB6			;Upper MPH limit to decay out initial IAC flow
					;(kickdown)
	BLS     L9FAD			;Bra if MPH <=
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Time to start decaying out initial flows (kickdown)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L4EB7			;IAC flow vs. cool temp kickdown multiplier
	LDX     #L02C6			;Coupled IAC flow vs. cool temp, P/N
	JSR     LF1ED			;(A x X*)/256
;
	STD     L02C6			;Coupled IAC flow vs. cool temp, P/N
;
	LDAA    L4EB7			;IAC flow vs. cool temp kickdown multiplier
	LDX     #L02D0			;Coupled IAC flow vs. cool temp, drive 
	JSR     LF1ED			;(A x X*)/256
;
	STD     L02D0			;Save it, Coupled IAC flow vs. cool temp, drive  
	BSET    L0009,#$02		;Status word, set b1, first run flag for kickdown
					;logic
;
;-Have been running here
;
L9FAD	LDAA    L0887			;Added IAC flow when in DFCO
	BEQ     L9FCD			;Bra if ==0
;
	BRSET   L0046,#$08,L9FCD	;Status word, bra if b3==1, DFCO in effect
;
;-No DFCO here, decay out the added flow
;
	DEC     L0888			;Load DFCO flow decay rate
	BNE     L9FCD			;Bra if !=, dont decay flow down yet
;
	LDAB    L50B5			;Load decay rate
	STAB    L0888			;Save it, DFCO decay rate
	SUBA    L50B4			;Subtract DFCO flow decay ammount
	BCC     L9FCA			;Bra if no underflow
;
	CLRA				;    
	BCLR    L0038,#$20		;Status word, clear b5, DFCO added flow sign
;
L9FCA	STAA    L0887			;Save DFCO added flow
;
L9FCD	LDAA    L4E85			;IAC option byte
	BITA    #$04			;Test b2, throttle kicker enabled
	BNE     L9FD6			;Bra if ==1, throttle kicker is enabled
;
;-No throttle kicker 
;
	BRA     LA01C			;Bra to continue			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Throttle kicker option selected
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 004B, b7==0, T/K enabled
; 0037, b4==1, T/K enabled
;
L9FD6     BRSET   L0037,#$04,L9FDD  	;Status word, bra if b2==1, throttle kicker 
					;is active
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Throttle kicker is inactive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	JMP     LA05F			;Go check quals for re-enabling kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Throttle kicker is active here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L9FDD	BRSET   L0036,#$0C,L9FE3	;Status word, bra if b2, closed loop quals met, and
					;b3, closed loop idle enabled, ==1
;
;-Still in open loop idle here, no throttle kicker diags.
;
	BRA     L9FEC			;				
;
;-In closed loop idle, update base TPS for diagnostics
;											
L9FE3	LDAA    L0319			;Base TPS for closed throttle
	STAA    L02D4			;Save it, base throttle kicker TPS
	BSET    L0039,#$01		;Status word, set b0, throttle kicker TPS updated
;
;-Check if disable request has been set
;
L9FEC	BRSET   L0037,#$08,LA031	;Status word, bra if b3==1, throttle kicker
					;disable request set 
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L50BD			;Temp threshold to enable throttle kicker
	BCC     LA000			;Bra if cool temp is >=, throttle kicker will be 
					;active for limited time only
;
;-Cool temp low, allow throttle kicker at all times untill warm
;
	LDAA    L50C2			;Time for throttle kicker to be active
	STAA    L088D			;Save it, throttle kicker timer
	JMP     LA0B1			;Continue with throttle kicker enabled
;
;-Check if disable request has been set
;
LA000	BRSET   L0037,#$10,LA031	;Status word, bra if b4==1, throttle kicker disable
					;request has been set
;
;-Check baro threshold
;
	LDAA    L0317			;Baro
	CMPA    L50C3			;Upper baro threshold for throttle kicker
	BCC     LA031			;Bra if baro >=, check quals for disabling the
					;Throttle kicker
;
;-Check idle RPMs
;
	BRCLR   L0036,#$80,LA01C	;Status word, bra if b7==0, low idle RPMs present
;
;-High idle speed present, check integrator
;
	LDAA    L02CA			;Idle integrator term, A/C off
	CMPA    L50C5			;Integrator threshold for disabling throttle kicker
	BCC     LA01C			;Bra if integrator >=, dont disable the kicker
;
;-Low integrator is present
;
	BRSET   L0036,#$08,LA01F	;Status word, bra if b3==1, closed loop idle enabled
;
;-Here if in open loop idle or low idle is present
;
LA01C	JMP     LA0B4			;Continue with throttle kicker still enabled
;
;-Here if in closed loop idle
;
LA01F	LDAA    L50C7			;Idle RPM error threshold for disabling throttle
					;kicker (drive) 
	BRSET   L0036,#$02,LA029	;Status word, bra if b1==1, in drive
;
;-In P/N
;
	LDAA    L50C8			;Idle RPM error threshold for disabling throttle
					;kicker (park/neutral)
;											
LA029	CMPA    L0858			;Idle RPM error
	BLS     LA031			;Bra if RPM error is less, continue checking quals
;
;-Excessive RPM error is present
;
	BSET    L0037,#$10		;Set b4, throttle kicker disable request
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue checking quals for disabling throttle kicker
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA031	BRCLR   L0036,#$40,LA03A	;Status word, bra if b6==0, throttle kicker 
					;has not yet been active
;
;-Throttle kicker active at least once, check timer
;
	LDAA    L088D			;Throttle kicker timer
	BNE     LA053			;Bra if !=0, continue with kicker endabled
;
;-Timer has run out, check quals for keeping kicker enabled
;
LA03A	LDAA    L01FC			;TPS
	CMPA    L50C1			;TPS threshold for throttle kicker (low baro)
	BHI     LA089			;Bra if >, go check baro
;
	LDAA    L02A7			;MPH
	CMPA    L50C0			;MPH threshold for throttle kicker (low baro)
	BHI     LA089			;Bra if >, go check baro
;
;-Low speed/TPS present with nominal baro pressure, keep kicker enabled 
;
	BRSET   L0036,#$40,LA0B1	;Bra if b6==1, kicker has alreay been active
;
	LDAA    L088D			;Throttle kicker timer
	BEQ     LA089			;Bra if ==0, continue checking quals to
					;disable the throttle kicker for diags.
;
;-Here if timer has not expired yet
;
LA053	LDAB    L0002			;Loop counter
	ANDB    #$F0			;Mask upper four bits
	BNE     LA0B1			;Bra if !=0
;
	DECA				;-1
	STAA    L088D			;Save timer
	BRA     LA0B1			;Bra to enable kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if throttle kicker isnt active
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA05F	LDAA    L088D			;Throttle kicker timer
	CMPA    #15			;15 seconds, min time for re-enabling the T/K			
	BLS     LA07D			;Bra if time <=
;
;-Throttle kicker has been inactive for more then 15 seconds
;
	BRSET   L0036,#$0C,LA06C	;Bra if b2, closed loop idle quals met, and
					;b3, closed loop idle enabled, ==1
;
;-In open loop, dont update base TPS for diags.
;
	BRA     LA075			;
; 
;-In closed loop, update base TPS for diags.
;
LA06C	LDAA    L0319			;Base TPS for closed throttle
	STAA    L02D5			;Save it, post throttle kicker base TPS
	BSET    L0039,#$02		;Status word, set b1, post T/K base TPS updated
;
;-Here if in open loop
;
LA075	LDAA    L088D			;Throttle kicker timer
	CMPA    L50CD			;Min time before re-enabling the throttle kicker 
	BEQ     LA089			;Bra if ==, check quals for throttle kicker

LA07D	LDAB    L0002			;Loop counter
	ANDB    #$F0			;Mask upper four bits
	BNE     LA09C			;Bra if !=0 
;
	INCA				;+1, throttle kicker timer
	STAA    L088D			;Throttle kicker time
	BRA     LA09C			;Bra to disable throttle kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for disabling throttle kicker
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for low baro
;
LA089	LDAA    L0317			;Filtered baro
	CMPA    L50C4			;Baro threshold for throttle kicker
	BLS     LA0A1			;Bra if baro is <=, continue
;
;-Nominal baro present here, check integrator
;
	LDD     L02CA			;Idle integrator, A/C off
	ADDD    L02D0			;Coupled IAC flow vs. cool temp
	CMPA    L50C6			;Lower IAC flow threshold for enabling kicker
	BHI     LA0A1			;Bra if flow is >, enable T/K
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to disable the throttle kicker
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA09C	JSR     L92F1			;Routine to disable throttle kicker
	BRA     LA0B4			;Bra to continue
;
;-Continue checking quals for throttle kicker, check TPS
;
LA0A1	LDAA    L01FC			;TPS
	CMPA    L50C1			;TPS threshold to enable throttle kicker (low baro)
	BHI     LA0B1			;Bra if TPS >, enable kicker
;
;-Check MPH threshold
;											
	LDAA    L02A7			;MPH
	CMPA    L50C0			;Min speed to enable throttle kicker (low baro)
	BLS     LA0B4			;Bra if MPH <=, dont enable throttle kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to enable throttle kicker
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LA0B1	JSR     L9309			;Routine to enable throttle kicker
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if throttle kicker not optioned
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA0B4	LDAA    L02C8			;IAC flow vs. cool temp (park)
	ORAA    L02D2			;IAC flow vs. cool temp (drive)
	BNE     LA0BF			;Bra if both !=0 yet
;
	JMP     LA1AE			;Jump to continue
;
LA0BF	LDAA    L0875			;IAC flow decay delay timer
	BEQ     LA0C7			;Bra if ==0
;                
	DECA				;-1 from timer
	BRA     LA13F			;Bra to save and continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Time to start decaying out initial IAC flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA0C7	LDAA    L4EB3			;Decay multiplier for inital IAC flows  
	LDX     #$02C8			;Added IAC flow vs. cool temp (P/N)
	JSR     LF1ED			;(A x X*)/256
;
	TSTA				;Test MSB    
	BNE     LA0D5			;Bra if !=0 yet
;
	CLRA				;Clear flow    
	CLRB				;
;    
LA0D5	STD     L02C8			;Save it, IAC flow vs. cool temp (P/N)
	BEQ     LA0EC			;Bra if ==0, save
;
;-Flow vs. cool temp is not decayed out yet
;
	LDAA    L4EB4			;Decay multiplier (P/N)
	LDX     #$02C6			;Coupled IAC flow vs. cool temp (P/N)
	JSR     LF1ED			;(A x X*)/256
;
	CPD     L02C8			;IAC flow vs. cool temp (P/N)
	BLS     LA0EC			;Bra if flow is <=
;
	LDD     L02C8			;Use IAC flow vs. cool temp instead
;
LA0EC	STD     L02C6			;Save it, IAC flow vs. cool temp (P/N)
;
	LDAA    L4EB3			;Decay multiplier for inital IAC flows
	LDX     #$02D2			;IAC flow vs. cool temp (drive)
	JSR     LF1ED			;(A x X*)/256
;
	TSTA				;Test MSB    
	BNE     LA0FD			;Bra if !=0
;
	CLRA				;Clear flow    
	CLRB				;
;    
LA0FD	STD     L02D2			;Save it, IAC flow vs. cool temp (drive)
	BEQ     LA114			;Bra if ==0
;
	LDAA    L4EB5			;IAC flow decay multiplier (drive)
	LDX     #$02D0			;Coupled IAC flow vs. cool temp (drive)
	JSR     LF1ED			;(A x X*)/256
;
	CPD     L02D2			;IAC flow vs. cool temp (drive)
	BLS     LA114			;Bra if <=
;
	LDD     L02D2			;Use IAC flow vs. cool temp instead
;
LA114	STD     L02D0			;Save it, IAC flow vs. cool temp (drive)
;
	LDAA    L02C8			;IAC flow vs. cool temp (P/N)
	ORAA    L02D2			;OR with IAC flow vs. cool temp (drive)
	BEQ     LA13F			;Bra if ==0, initial flow decayed out
;
;-Initial IAC flows have not yet been decayed out
;
	LDAA    L02A6			;Range limited cool temp
	LDX     #L4ED2			;IAC decay delay period vs. cool temp			
	JSR     LF15E			;2D lookup
;
	PSHA				;Push to stack    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Construct decay delay period from airflow and multiplier
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4EDF			;Decay delay mult. vs. gms/sec airflow
	LDAA    L0255			;Gms/sec airflow
	CMPA    #64			;UL for lookup
	BLS     LA135			;Bra if airflow is less
;
	LDAA    #64			;64 gms/sec, UL for lookup
;
LA135	JSR     LF15E			;2D lookup
;
	PULB				;Get decay delay period    
	MUL				;Decay delay period x multiplier     
	ASLD				;x2, now /128   
	BCC     LA13F			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
LA13F	STAA    L0875			;Save it, added IAC flow decay delay period
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to make sure that initial IAC flows in P/N, drive are not too far apart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Used during transition from P/N, drive to prevent sudden change in airflow
;
	BRSET   L0036,#$02,LA176	;Status word, bra if b1==1, in drive
;
;-In park/neutral here
;
	LDAA    L02C6			;Coupled IAC flow vs. cool temp (P/N)
	BEQ     LA1AC			;Bra if ==0, flow decayed out
;
;-Check bounds for saving flow, no save if:
;  
;  L02D0 <= L02C6 + allowable percentage
;  L02D0 > L02C6 - allowable percentage
;
	LDAB    L4EE6			;Max allowable percentage difference
	BEQ     LA15B			;Bra if allowable difference ==0
;
	MUL				;Coupled IAC flow vs. cool temp (P/N) x multiplier     
	ADCA    L02C6			;Add in IAC flow, now IAC flow + delta flow
	BCS     LA15B			;Bra if overflow
;
	CMPA    L02D0			;Compare to coupl'd IAC flow vs. cool temp (drive)			
	BCS     LA170			;Bra if <, save flow
;
LA15B	LDAA    L02C6			;IAC flow (P/N)
	LDAB    L4EE7			;Min allowable percentage difference
	BEQ     LA1AC			;Bra if allowable difference ==0
;
	MUL				;IAC flow x multiplier     
	ADCA    #$0000			;round if needed
	TAB				;Get result into B     
	LDAA    L02C6			;IAC flow vs. cool temp (P/N)
	SBA				;Subtract the delta      
	CMPA    L02D0			;Compare to IAC flow in drive
	BCS     LA1A9			;Bra if flow <, no update
;
;-Save here if IAC flow in park is within a +/- percentage of IAC flow in drive   
;
LA170	CLRB				;   
	STD     L0899			;Save it, updated initial IAC flow in drive			
	BRA     LA1A4			;Bra to continue
;
;-Here if in drive
;
LA176	LDAA    L02D0			;IAC flow vs. cool temp (drive)
	BEQ     LA1AC			;Bra if flow is already decayed out
;
;-Check bounds for saving flow, no save if:
;  
;  L02C6 <= L02D0 + allowable percentage
;  L02C6 > L02D0 - allowable percentage
;
	LDAB    L4EE4			;Load max allowable difference
	BEQ     LA18B			;Bra if allowable difference is ==0
;
	MUL				;Coupled IAC flow (drive) x multiplier     
	ADCA    L02D0			;Add in IAC flow to delta
	BCS     LA18B			;Bra if overflow
;
	CMPA    L02C6			;Coupled IAC flow vs. cool temp (P/N)
	BCS     LA1A0			;Bra if flow is less, save
;
LA18B	LDAA    L02D0			;Coupl'd IAC flow (drive)
	LDAB    L4EE5			;Load min allowable difference
	BEQ     LA1AC			;Bra if allowable difference is ==0
;
	MUL				;IAC flow x allowable difference     
	ADCA    #$0000			;Round if needed
	TAB				;Get result into B     
	LDAA    L02D0			;Load coupled IAC flow (drive)
	SBA				;Subtract delta from IAC flow     
	CMPA    L02C6			;Compare to IAC flow vs. cool temp (P/N)
	BCS     LA1A9			;Bra if initial flow in drive is less
;
;-Save here if IAC flow in drive is within a +/- percentage of IAC flow in park  
;
LA1A0	CLRB				;    
	STD     L0893			;Save it, updated initial IAC flow in P/N
;
LA1A4	BSET    L0038,#$10		;Status word, set b4, initial stored IAC flow
					;has been updated		
	BRA     LA203			;Bra to continue
;
LA1A9	BCLR    L0038,#$10		;Clear b4, IAC intial flow not updated
LA1AC	BRA     LA203			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if initial IAC flow has been decayed out, update steady state integrator cells
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA1AE	BRSET   L0036,#$0C,LA1B4	;Status word, bra if b2==1, closed loop quals met, 
					;and b3==1, closed loop idle
;
;-Not in full closed loop idle, skip integral update
;
	BRA     LA203
;
;-In closed loop idle
;
LA1B4	LDAA    L0006			;Cool temp, linearized
	CMPA    L4FB5			;Lower temp threshold for steady state idle
					;check
	BCS     LA203			;Bra if cool temp is <
;
	CMPA    L4FB6			;Upper cool temp threshold for steady state idle
					;check
	BHI     LA203			;Bra if cool temp >
;
;-Temp within range, check for steady state idle
;
	LDAA    L0858			;Idle speed RPM error
	CMPA    L4FB4			;Upper RPM error for updating integral cells
	BHI     LA203			;Bra if error is >
;
	LDAA    L0859			;Filtered RPM error
	CMPA    L4FB4 			;Upper RPM error for updating integral cells
	BHI     LA203			;Bra if rpm error >
;
;-RPM error within limits
;
	BCLR    L0018,#$08		;Error word #3, clear b3, err 35, IAC error 
	BRSET   L0036,#$02,LA1EB	;Status word, bra if b2==1, in drive
;
;-In park/nutral
;
	BRSET   L0036,#$01,LA1E3	;Status word, bra if b0==1, A/C is on
;
;-A/C off
;
	LDAA    L02C0			;Current idle integral, P/N, A/C off
	STAA    L02C2			;Save it, steady state idle integral, P/N, A/C off
	BRA     LA203			;Bra to continue
;
;-A/C is on
;
LA1E3	LDAA    L02C3			;Current idle integral, P/N, A/C on
	STAA    L02C5			;Save it, steady state idle integral, P/N, A/C on
	BRA     LA203			;Bra to continue
;
;-In drive here
;
LA1EB	BRSET   L0036,#$01,LA1FA	;Status word, bra if b0==1, A/C is on
;
;-A/C is off
;
	LDAA    L02CA			;Current idle integral, drive, A/C off
	STAA    L02CC			;Save it, steady state idle integral, drive,
					;A/C off 
	BSET    L0009,#$10		;Status word, set b4, stable idle attained, A/C off
	BRA     LA203			;Bra to continue
;
;-A/C is on here
;
LA1FA	LDAA    L02CD			;Current idle integral, drive, A/C on
	STAA    L02CF			;Save it, steady state idle integral, drive,
					;A/C on 
	BSET    L0009,#$20		;Status word, set b4, stable idle attained, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if initial IAC flows not updated, check for A/C transition
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA203	LDAA    L0876			;Added IAC flow for A/C transition
	BEQ     LA22A			;Bra if ==0
;
	LDAB    L0877			;A/C on/off transition timer
	BNE     LA22A			;Bra if !=0, still in transition
;
;-A/C on/off transition complete
;
	BRCLR   L0036,#$01,LA226	;Status word, bra if b0==0, A/C is off
;
	LDAB    L0878			;A/C transition flow decay period
	BEQ     LA21B			;Bra if ==0, decay out flow this pass
;
;-Not time to decay out flow yet
;
	DEC     L0878			;-1 from decay period
	BNE     LA22A			;Bra if !=0, dave and continue
;
;-A/C has been off, time to decay out the flow
;
LA21B	LDAB    L4F18			;Decay period
	STAB    L0878			;Save it, A/C transition decay period
	SUBA    L4F17			;IAC flow decay rate for A/C transition
	BCC     LA227			;Bra if no underflow
;
;-A/C is off, clear out flow immediatly
;
LA226	CLRA				;Clear out added flow 
;  
LA227	STAA    L0876			;Added IAC flow for A/C transition				
;
;-Here if no delta IAC flow or not decaying out flow yet
;
LA22A	LDAB    L0036			;Status word
	BITB    #$0008			;Test b3
	BEQ     LA238			;Bra if ==0, closed loop idle not enabled
;
;-Closed loop idle has been enabled
;
	BITB    #$10			;Test b4, stall saver
	BNE     LA238			;Bra if stall saver it active
;
	BRCLR   L003E,#$04,LA23B	;Bra if ==0, batt volts within range
;
;-In open loop, stall saver active, or battery volts are out of range for IAC operation
;
LA238	JMP     LA35E
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to make sure P/N and drive integrater terms arnt getting too far apart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA23B	CLRB    
	BRSET   L0036,#$01,LA249	;Status word, bra if b0==1, A/C on
;
;-A/C off
;
	LDX     #L02C0			;Idle integrator term, P/N, no A/C
	LDY     #L088F			;Start of updated integrator flows, no A/C
	BRA     LA250			;Bra to continue
;
;-A/C on
;
LA249	LDX     #L02C3			;Idle integrator term, P/N, A/C
	LDY     #L0891			;Start of updated integrator flows, A/C			
;
LA250	LDAA    $00,X			;Integrator term P/N
	SUBA    $0A,X			;Subtract integrator term for drive
	BCS     LA273			;Bra if term for P/N was <
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Integrator term for P/N is larger then drive
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CMPA    L4FBC			;Min flow difference to update integrators
	BLS     LA291			;Bra if delta flow is <=
;
;-Enough difference, close the gap between the integrator terms
;
	BRSET   L0036,#$02,LA269	;Bra if b1==1, in drive
;
;-In park/neutral
;
	LDAA    0,X			;P/N integrator term
	SUBA    L4FBC			;Subtract allowable difference
	STD     6,Y			;Save it, updated integral flow for drive 
	BRA     LA2B1			;Bra to contiue
;
;-In drive
;
LA269	LDAA    $0A,X			;Drive integrator term
	ADDA    L4FBC			;Add in the allowable difference
	STD     0,Y			;Save it, updated integral flow for drive
	BRA     LA2B1			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Integrator term for drive is larger then P/N
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA273	NEGA				;Get abs. value of result    
	CMPA    L4FBB			;Max allowable difference
	BLS     LA291			;Bra if <=
;
;-Enough difference, close the gap between the integrator terms
;
	BRSET   L0036,#$02,LA287	;Bra if b2==1, in drive
;
;-In park/neutral
;
	LDAA    0,X			;Load idle integrator term, P/N
	ADDA    L4FBB			;Add in allowable flow difference
	STD     6,Y			;Save it, updated integral flow for drive
	BRA     LA2B1			;Bra to continue
;
;-In drive
;
LA287	LDAA    $0A,X			;Load idle integral term, drive
	SUBA    L4FBB			;Subtract allowable difference
	STD     0,Y			;Save it, updated integral flow for drive
	BRA     LA2B1			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Integral terms are within limits here, clear flags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA291	BRSET   L0036,#$02,LA2A3	;Bra if b1==1, in drive
;
	BRSET   L0036,#$01,LA29E	;Bra if b0==1, A/C on
;
;-In P/N, no A/C
;
	BCLR    L0038,#$04		;Clear update integral term flag, drive, no A/C
	BRA     LA2CF			;
;
;-In P/N, A/C on
;
LA29E	BCLR    L0038,#$08		;Clear update integral term flag, drive, A/C on
	BRA     LA2CF			;
;
;-Here if in drive
;
LA2A3	BRSET   L0036,#$01,LA2AC	;Bra if b0==1, A/C on
;
;-In drive, A/C off
;
	BCLR    L0038,#$01		;Clear update integral term flag, P/N, no A/C		
	BRA     LA2CF			;
;
;-In drive, A/C on
;
LA2AC	BCLR    L0038,#$02		;Clear update integral term flag, P/N, A/C on
	BRA     LA2CF			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if idle integral terms where out of limits and adjusted, set flags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA2B1	BRSET   L0036,#$02,LA2C3	;Bra if b1==1, in drive
;
	BRSET   L0036,#$01,LA2BE	;Bra if b0==1, A/C on
;
;-In P/N, no A/C
;
	BSET    L0038,#$04		;Set update integral term flag, drive, no A/C		
	BRA     LA2CF			;
;
;-In P/N, A/C on
;
LA2BE	BSET    L0038,#$08		;Set update integral term flag, drive, A/C on
	BRA     LA2CF			;
;
;-Here if in drive
;
LA2C3	BRSET   L0036,#$01,LA2CC	;Bra if b0==1, A/C on
;
;-In drive, A/C off
;
	BSET    L0038,#$01		;Set update integral term flag, P/N, no A/C
	BRA     LA2CF			;
;
;-In drive, A/C on
;
LA2CC	BSET    L0038,#$02		;Clear update integral term flag, P/N, A/C on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to make sure A/C and non-A/C integral terms arnt getting too far aprart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA2CF	BRSET   L0036,#$02,LA2E0	;Status word, bra if b1==1, in drive
;
;-In park/neutral 
;
	LDX     #L088F			;Updated integral term, P/N, no A/C
	PSHX				;To stack
	LDX     #L02C0			;Idle integral term, P/N, no A/C
	LDY     #L4FB7			;Load min allowable difference, P/N
	BRA     LA2EB			;			
;
;-In drive here
;
LA2E0	LDX     #L0895			;Updated integral term, drive no A/C
	PSHX				;
	LDX     #L02CA			;Idle integrator term, drive, no A/C
	LDY     #L4FB9			;Load min allowable flow difference
											
LA2EB	LDAB    0,Y			;Load allowable flow difference
	PSHB				;To stack
	LDD     3,X			;Load A/C integral term
	SUBD    0,X			;Subtract integral term, no A/C
	PULB				;Get allowable difference back
	BLS     LA2FF			;Bra if non-A/C integral was >=, update flow
;
;-Non-A/C integral term <, check lower limit for difference
;
	CBA				;Compare delta integral flow to difference
	BCS     LA2FF			;Bra if difference is less, update 
;
;-Check upper limit for integral flow difference
;
	LDAB    1,Y			;Load max allowed flow difference
	CBA				;Compare delta flow to difference
	BLS     LA31F			;Bra if delta flow was <= allowable difference
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; A/C and non-A/C integral terms have become too far apart, update flows
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA2FF	BRSET   L0036,#$01,LA313	;Status word, bra if b0==1, A/C on
;
;-A/C off
;
	LDAA    0,X			;Load integrator term, no A/C
	ABA				;Add in allowable difference
	BCC     LA30D			;Bra if no overflow
;										
	LDD     #$FFFF			;Clear overflow
	BRA     LA30E			;				
;											
LA30D	CLRB				;Clear MSB
;	
LA30E	PULX				;Get addr. of updated integral terms back
	STD     2,X			;Save it, updated integral term, A/C
	BRA     LA340			;Bra to continue
;
;-A/C is on
;
LA313	LDAA    3,X			;Load integral term, A/C
	SBA				;Subtract out the allowable difference     
	BCC     LA319			;Bra if no underflow
;
	CLRA				;Clear underflow
;
LA319	CLRB				;Clear LSB    
	PULX				;Get addr. of updated integral terms back   
	STD     0,X			;Save it, updated integral term, no A/C
	BRA     LA340			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if A/C and non-A/C integral terms where not too far apart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA31F	PULX				;Get addr. back off stack
	BRSET   L0036,#$02,LA332	;Bra if b1==1, in drive
;
	BRSET   L0036,#$01,LA32D	;Bra if b0==1, A/C is on
;
;-In P/N, no A/C
;
	BCLR    L0038,#$02		;Clear update integral term flag, P/N, A/C on 
	BRA     LA35E			;
;
;-In P/N, A/C on
;
LA32D	BCLR    L0038,#$01		;Clear update integral term flag, P/N, no A/C
	BRA     LA35E			;
;
;-In drive here
;
LA332	BRSET   L0036,#$01,LA33B	;Bra if b0==1, A/C on 
;
;-In drive, no A/C
;											
	BCLR    L0038,#$08		;Clear update integral term flag, drive, A/C
	BRA     LA35E			;
;
;-In drive, A/C on
;
LA33B	BCLR    L0038,#$04		;Clear update integral term flag, drive, no A/C
	BRA     LA35E			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if A/C and non-A/C integral terms where too far apart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA340	BRSET   L0036,#$02,LA352	;Status word, bra if b1==1, in drive
;
	BRSET   L0036,#$01,LA34D	;Bra if b0==1, A/C on
;
;-In P/N, no A/C
;
	BSET    L0038,#$02		;Set b1, update integral term flag, P/N, no A/C
	BRA     LA35E			;
;
;-In P/N, A/C on
;
LA34D	BSET    L0038,#$01		;Set set b0, update integral term flag, P/N, A/C on
	BRA     LA35E			;
;
;-In drive
;
LA352	BRSET   L0036,#$01,LA35B	;Bra if b0==1, A/C is on 
;
;-In drive, A/C off
;
	BSET    L0038,#$08		;Set b3, update integral term flag, drive, A/C
	BRA     LA35E			;
;
;-In drive, A/C on
;
LA35B	BSET    L0038,#$04		;Set b2, update integral term flag, drive, no A/C
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Decrement closed loop delay terms
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA35E	LDAA    L0866			;Closed loop idle delay, low idle
	BEQ     LA367			;Bra if already ==0
;
	DECA				;-1 from timer    
	STAA    L0866			;Save it
;
LA367	LDAA    L0867			;Closed loop idle delay, high idle
	BEQ     LA370			;Bra if already ==0
;
	DECA				;-1 from timer 
	STAA    L0867			;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Update stored steady state integral term
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA370	LDX     #$02CA			;Start of idle integrator terms, drive
	BRSET   L0036,#$02,LA37A	;Status word, bra if b1==1, in drive
;
;-In park/neutral
;
	LDX     #$02C0			;Start of idle integrator terms, P/N
;
LA37A	LDAA    2,X			;Load steady state integral term, no A/C
;
	BRCLR   L0036,#$01,LA382	;Bra if b0==0, A/C not currently active
;
;-A/C on 
;
	LDAA    5,X			;Load steady state integral term, A/C on
;
LA382	STAA    L086A			;Stored steady state idle integral term
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to decay out various idle terms
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA386	BRSET   L004F,#$80,LA38D	;Status word, bra if b7==1, engine is running
;
;-Engine not running
;
	JMP     LA4DC			;Return
;
;-Engine is running here
;
LA38D	JSR     L9DE0			;Throttle follower routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Decay out added P/S IAC flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L087B			;Load P/S compensation IAC flow
	BEQ     LA3B0			;Bra if ==0, flow already decayed out
;
;-Flow not yet decayed out
;
	LDAB    L087C			;P/S compensation flow decay period
	BEQ     LA39F			;Bra if ==0, decay out the flow
;
	DEC     L087C			;Decr. decay period
	BNE     LA3B0			;Bra if !=0, dont decay flow yet
;
;-Time to decay the flow
;
LA39F	SUBA    L4F27			;Subtract P/S compensation flow decay rate
	BCC     LA3A5			;Bra if no underflow
;
	CLRA				;Clear underflow
;   
LA3A5	STAA    L087B			;Save it, P/S compensation flow
	BEQ     LA3AD			;Bra if flow ==0
;
;-Reset decay period timer
;
	LDAA    L4F26			;Decay period for P/S compensation flow
;
LA3AD	STAA    L087C			;Save decay period
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Decay out initial IAC flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA3B0	LDAA    L086B			;Initial flow added after startup
	BEQ     LA3D0			;Bra if ==0
;
	BRCLR   L003F,#$40,LA3BC	;Status word, bra if b6==0, not clearing initial
					;idle terms
;
;-Here to clear intial added IAC flow
;
	CLRA				;Clear flow    	
	BRA     LA3CD			;Bra to save	 
;
;-Check if time to decay out flow
;
LA3BC	LDAB    L086C			;Decay period for initial added IAC airflow
	BEQ     LA3C6			;Bra if ==0, dec flow
;
;-Decay period not yet ==0
;
	DEC     L086C			;-1, IAC flow decay period
	BNE     LA3D0			;Bra if !=0
;
;-Here to decay the flow
;
LA3C6	LDAB    L4EAF  			;Initial added flow decay period
	STAB    L086C			;Save it
;
	DECA				;-1, initial added IAC flow
;
LA3CD	STAA    L086B			;Save initial IAC flow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Decay out added desired idle speed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA3D0	LDAA    L085C			;Load added desired idle speed
	BEQ     LA400			;Bra if already decayed out
;
;-Still additional idle speed to be decayed out
;
	BRCLR   L003F,#$40,LA3DC	;Bra if b6==0, not clearing initial idle terms
;
;-Here to clear added desired idle speed
;
	CLRA				;Clear added desired idle speed   
	BRA     LA3FD			;Bra to save
;
LA3DC	LDAB    L085E			;Timer to begin decaying out init. added idle speed
	BEQ     LA3EC			;Bra if ==0, decay out idle speed
;
	LDAB    L0002			;Loop counter
	BITB    #$F0			;Test upper four bits
	BNE     LA400			;Bra if !=, not time to decrement timer
;
	DEC     L085E			;Dec timer
	BRA     LA400			;Bra to continue
;
;-Enough time has passed to begin decaying out added desired idle speed
;
LA3EC	LDAB    L085D			;Decay period for added idle speed
	BEQ     LA3F6			;Bra if ==0, decay out added desired idle speed
;
;-Not decaying out added idle speed yet
;
	DEC     L085D			;Added desired idle speed decay period
	BNE     LA400			;Bra if !=0, dont decay idle speed yet
;
;-Decay out added desired idle speed
;
LA3F6	LDAB    L4EB1			;Decay period for added desired idle speed
	STAB    L085D			;Save it
;
	DECA				;Decr. added initial idle speed
;
LA3FD	STAA    L085C			;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Limit current integral if too far away from steady state integral
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Helps limit integrator wind-up if selected
;
LA400	LDAA    L0036			;Status word
	BITA    #$02			;Test b1, P/N, drive flag 
	BEQ     LA432			;Bra if ==0, in P/N 
;
;-In drive
;
	BITA    #$0C			;Test b2, closed loop idle quals met, and b3, 
;					;in closed loop idle
	BNE     LA432			;Bra if in closed loop or closed loop idle pending
;
;-No closed loop idle pending, check integral terms
;
	BITA    #$01			;Test b0, A/C on flag 
	BNE     LA421			;Bra if b0==1, A/C is on
;
;-A/C off
;			
	LDAA    L02CC			;Steady state idle integral, drive, A/C off
	ADDA    L4FBD			;Add in difference in flow limit for current
					;integral
	BCS     LA432			;Bra if overflow
;											
	CMPA    L02CA			;Compare to current idle integral, drive, no A/C
	BCC     LA432			;Bra if integral is <=
;
;-Current integral is greater then allowed
;										
	CLRB				;Clear LSB    
	STD     L02CA			;Save upper limit instead
	BRA     LA432			;Continue
;
;-A/C is on here
;
LA421	LDAA    L02CF			;Steady state idle integral, drive, A/C on
	ADDA    L4FBE			;Add in difference in flow limit for current 
					;integral
	BCS     LA432			;Bra if overflow
;											
	CMPA    L02CD			;Compare to current idle integral, drive, A/C on			
	BCC     LA432			;Bra if integral is <=
;
;-Current integral is greater then allowed
;										
	CLRB				;Clear LSB    
	STD     L02CD			;Save upper limit instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform throttle kicker diagnostics
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA432	LDAA    L4E85			;IAC option byte
	BITA    #$04			;Test b2, throttle kicker enabled flag
	BEQ     LA46E			;Bra if ==0, no throttle kicker in use
;
;-Throttle kicker is in use
;
	LDAA    L5B02			;Error mask 3
	BITA    #$04			;Test b2, will be flagging err 36,
					;throttle kicker actuator faulure
	BEQ     LA46E			;Bra if ==0, not flagging error
;
;-Erorr 36 enabled
;
	BRSET   L0039,#$04,LA46E	;Bra if thottle kicker diags. performed already
;
	BRSET   L0039,#$03,LA44A	;Bra if stored base closed throttle TPS
					;readings have been updated
;
	BRA     LA46E			;No update yet, skip diagnostics
;
;-Check base closed throttle positions before and after kicker to see if actuator ok
;
LA44A	LDAA    L02D4			;Throttle kicker base TPS
	SUBA    L02D5			;-initial base TPS
	BCS     LA457			;Bra if initial base TPS <
;
;-Check if kicker exteding far enough
;
	CMPA    L50CC			;Min TPS difference between readings
	BCC     LA465			;Bra if >=, dont set error
;
;-Kicker isnt functional or not extending far enough, set error
;
LA457	BRSET   L0009,#$40,LA460	;Status word, bra if b6==1 kicker has already failed

	BSET    L0009,#$40		;Status word, set b6, throttle kicker failed diags.
	BRA     LA46B			;Bra to continue
;
;-Here to set error
;
LA460	BSET    L0018,#$04		;Error word #3, set b2, error 36, throttle kicker
	BRA     LA46B			;Bra to coninue
;
;-Here if diags passed
;
LA465	BCLR    L0018,#$04		;Clear b2, throttle kicker ok
	BCLR    L0009,#$40		;Clear b6, throttle kicker ok
;
LA46B	BSET    L0039,#$04		;Set b2, throttle kicker actuator diags. performed
;
;-Alternate passes for next portion of code
;
LA46E	BRSET   L0002,#$20,LA4DC	;Loop counter, bra if b5==1, dont run this pass
;
;~~~~~~~~~~~~~~~~~~~~
; Perform IAC diags.
;~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L5B02			;Error mask #3
	BITA    #$08			;Test b3, error 35, IAC fault
	BEQ     LA4BC			;Bra if ==0, not setting err. 35
;
;-Error 35 being recognized, check quals for setting error
;
	BRSET   L0016,#$10,LA4B6	;Error word #1, bra if b4==1, error 16, VSS error
;
	BRSET   L0016,#$01,LA4B6	;Bra if b0==1, error 21, high TPS error
;
	BRSET   L0017,#$80,LA4B6	;Error word #2, bra if b7==1, err 22, low TPS
;
	BRSET   L003E,#$04,LA4B6	;Status word, bra if b2==1, low batt volts
;
;-Check for closed loop idle
;
	BRCLR   L0036,#$08,LA4B6	;Status word, bra if b3==0, no closed loop idle
;
;-In closed loop idle
;
	BRSET   L0009,#$40,LA4B6	;Status word, bra if b6==1, throttle kicker
					;failed diags. 
;
	LDX     L02D0			;Load coupled IAC flow vs. cool temp, drive
	BNE     LA4B6			;Bra if !=0, dont perform diags.
;	
	LDX     L02C6			;Load coupled IAC flow vs. cool temp, P/N
	BNE     LA4B6			;Bra if !=0, dont perform diags.
;
;-All quals met, perform IAC diags.
;
	LDAB    L0859			;Filtered idle RPM error
	CMPB    L50B6			;Sustained RPM error threshold to set err 35, 
					;IAC fault
;							
	BLS     LA4B6			;Bra if RPM error less, dont set error
;
;-Large RPM error present, check if enough time has passed to set error
;
	LDAB    L088E			;Error 35 timer
	CMPB    L50B7			;Error 35 timer threshold	
	BHI     LA4B1			;Bra if >, set error 35
;
;-Not enough time has passed yet
;
	INCB				;+1
	STAB    L088E			;Save err 35 timer
	BRA     LA4BC			;Bra to continue
;
;-RPM error has been sustained for long enough to set error
;
LA4B1	BSET    L0018,#$08		;Error word #3, set b3, error 35, IAC fault
	BRA     LA4BC			;Bra to continue
;
;-Here if quals not met/not setting error
;
LA4B6	CLR     L088E			;Clar err 35 timer
	BCLR    L0018,#$08		;Clear b3, error 35, IAC fault		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if IAC reset needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA4BC	BRSET   L0009,#$01,LA4DC	;Status word, bra if b0==1, IAC reset in progress
;
	BRSET   L0009,#$04,LA4DC	;Bra if b2==1, IAC reset not requested
;
;-IAC reset has been requested, check quals for reset
;
	BRSET   L0044,#$10,LA4D0	;Status word, bra if b4==1, ign. off, perform reset
;
;-Check VSS limit for reset
;
	LDAA    L02A7			;MPH
	CMPA    L4EAD			;Lower MPH limit to perform IAC reset
	BCS     LA4DC			;Bra if MPH <, no reset this pass
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Entry point to close IAC for reset
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA4D0	BSET    L0009,#$01		;Status word, set b0, IAC reset in progress
	BCLR    L0036,#$1C		;Status word, clear b2, closed loop idle quals met,
					;b3, closed loop on RPM enabled, and b4, stall 
					;saver in effect
	CLRA				;Preclear A   
	STAA    L0008			;Clear desired IAC steps
	DECA				;-1, now 255    
	STAA    L0007			;Save as current IAC position, force IAC to
					;rapidly close and seat
;
;-Here if engine off, return
;
LA4DC	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~
;
; ALDL IAC routine
;
;~~~~~~~~~~~~~~~~~~
;
LA4DD	BRSET   L0044,#$10,LA53B	;Status word, bra if b4==1, ignition is off
;
;-Ignition is on here
;
	BRSET   L0009,#$01,LA53B	;Status word, bra if b0==1, IAC reset in progress
;
	LDAB    L0393			;ALDL status word word
	BITB    #$20			;Test b5, reset IAC
	BEQ     LA4F0			;Bra if ==0, not resetting IAC
;
	PULX				;    
	JMP     LA4D0			;Continue with reset
;
;
;
;
;                                  
LA4F0	LDAB    L0397			; ALDL CNT'L WD 7
	ANDB    #$01			; 0000 0001
;
	LDAA    L0390+1			; $F4, ALDL MODE 4, DISRETE ENABLES
	ANDA    #$40			; b6, ??? 
	ABA				;     
	BEQ     LA53B			;
;
	CMPA    #$41			;
	BEQ     LA53B			;
;
	BITA    #$01			;
	BEQ     LA521			;
;
	LDAA    L0397			; ALDL CNT'L WD 7
	BITA    #$02			; b1
	BNE     LA516			; BR IF b1
;
; DIACMW2, NON-VOL IDLE CNT'L MD WD
;
	BCLR    L0036,#$0C		; CLR $0C, DIAG MD WD #3
;
	PULX				;    
	LDAA    L0398			; ALDL CNT'L WD 8
	JMP     L997C			;
;
LA516	LDAA    L0398			; ALDL CNT'L WD 8
	STAA    L0857			; DESIRED IDLE RPM/12.5
;
	BSET    L0038,#$40		;
	BRA     LA53B			;
;
; CK ALDL CW 3
;
LA521	PULX				;    
	LDAA    L0392			; (ALDL CNT'L WD 2)
	BITA    #$40			; b6,
	BEQ     LA532			;
;
	JSR     L9305			;
;
;---------------------------
; IAC DIAG MD WD 3	
; 	b2 1 = THROTTLE KICKER ACTIVE    
;----------------------------- 
	BSET    L0037,#$04		; SET b2, THROTTLE KICKER ACTIVE
;
	JMP     L997E			;
;
LA532	JSR     L931F			;Energize throttle kicker
;---------------------------
; IAC DIAG MD WD 3	
; 	b2 1 = THROTTLE KICKER ACTIVE    
;----------------------------- 
;
	BCLR    L0037,#$04		;Status word, clear b2, throttle kicker active
	JMP     L997E			;Jump to continue
;
LA53B	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Spark minor loop 
;
; Run 80x a second
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Calculate vacuum
;
LA53C	LDAB    #151			;
;
	LDAA    L0317			;Load filtered baro
	SUBA    L01E9			;Subtract A/D MAP
	BHI     LA548			;Bra if Baro > MAP
;
;-MAP >= Baro
;
	LDAA    #$01			;Clear underflow
;
;-MAP < Baro
;
LA548	MUL				;(A/D Baro - A/D MAP) x 151     
	ADDD    #64			;+64 to round up if needed
	ASLD 				;x2   
	BCC     LA552			;Bra if overflow
;
	LDD     #$FFFF			;Clear overflow
;
LA552	NEGA				;change sign  
	STAA    L01EC			;Store it, vacuum = 256 - 1.18(Delta A/D counts) 
;
;-Calc. S/D MAP
;
	LDAB    #151			;Multiplier for S/D MAP
	LDAA    L01E9			;A/D MAP
	SUBA    #26			;
	BCC     LA562			;Bra if underflow
;
	CLRA 				;Clear underflow  
	BRA     LA56C			;Bra to save
;
LA562	MUL				;151 x (A/D MAP - 64)     
	ADDD    #64			;+64 to round up if needed
	ASLD 				;x2   
	BCC     LA56C			;Bra if overflow

	LDD     #$FFFF			;Clear overflow

LA56C	STAA    L01E3			;S/D map
;
;-Calculate ratio of MAP kPa to baro kPa
;
	LDAA    L01F1			;baro factor x 256 for MAP/baro ratio
	CLRB				;Preclear B   
	LDX     L027A			;MAP kPa x 256
	XGDX				;Get baro factor into X and MAP into D  
	FDIV				;Fract. divide   
	XGDX				;Get result into D    
	SUBD    #8192			;-8192d
	BCC     LA581             	;Bra if no underflow
;
	LDD     #$0000			;Clear underflow
;
LA581	ASLD				;x2    
	BCC     LA586			;Bra if overflow
;
	LDAA    #255			;Clear overflow
;
;-Now = 256 x 1.25 x [MAP kPa/(baro kPa - 5)] - 64
;
LA586	STAA    L01F2			;MAP/baro ratio
;
;~~~~~~~~~~~~
; MAP diags.
;~~~~~~~~~~~~
;
;-Perform low MAP test
;
	BCLR    L0018,#$10		;Error word #3, clear b4, err 34, MAP sensor low
;
	BCLR    L006F,#$08		;Status word, clear b3, low MAP 
;
	BRSET   L006F,#$04,LA5B7	;
;
	LDAA    L082E              	;Load A/D MAP
	CMPA    L4E5A              	;Lower MAP limit to set Err. 34
	BCC     LA5B7			;Bra if MAP >=
;
;-Low MAP present, check quals. to set err 34
;
	LDAA    L024C              	;Err. 34 timer
	CMPA    L4E5C			;Timer threshold to set err
	BHI     LA5BC			;Bra if >
;
	LDAA    L0061			;Scaled RPMs
	CMPA    L4E5B              	;1200 RPM, upper limit for err 34
	BCS     LA5B2			;Bra if RPMs less
;
	LDAA    L01FC			;%TPS
	CMPA    L4E5D			;Lower %TPS limit for err 34 
	BLS     LA5B7			;Bra if TPS <=, no err 34
;
;-Quals. met for err 34, increment timer
;
LA5B2	INC     L024C			;+1, err 34 timer
	BRA     LA5C2			;Bra
;
;-Quals. not met for err 34, bra to continue
;
LA5B7	CLR     L024C			;
	BRA     LA5C2			;
;
;-Err 34 timer elapsed, set err 34, MAP sensor low
;
LA5BC	BSET    L0018,#$10		;Err. word #3, set b4, err 34, MAP low
	BSET    L006F,#$08		;Status word, set b3, MAP low 
;
;-Here if not setting error
;
LA5C2	BRCLR   L0050,#$20,LA613	;Status word, bra if b5==0, no DRP yet 
;
;-DRP occured here
;
	BCLR    L0050,#$20		;Clear b5 in prep. for next DRP
	BSET    L0050,#$04		;Set b2, DRP occured, 6.25 msec test
	CLRA				;    
	CLRB				;
	STD     L0283			;Time since last DRP
;
;-Decay out dynamic dwell
;
	LDD     L020D			;Dwell
	LSRD				;/2    
	LSRD				;/2   
	LSRD				;/2    
	COMA				;1's comp.    
	COMB				;
	ADDD    L020D			;Add in negative dwell/8
	BPL     LA5E0			;Bra if result is +
;
	CLRA				;Clear out dwell   
	CLRB				;
;
LA5E0	STD     L020D			;Save dwell
	CLR     L0225			;Clear counter, DRP occured
	BRCLR   L004F,#$80,LA616	;Status word, bra if b7==0, engine not running
;
;~~~~~~~~~~~~~~~~~~~~~
; Engine running here
;~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L004F,#$10,LA5F1	;Status word, bra if engine above threshold for cranking
;
	JSR     LA657			;Engine running/Cranking status routine
;
LA5F1	BRCLR   L004F,#$40,LA655	;(???) BR IF NOT b6, MINOR LOOP EST MONITOR ??
;
	BRSET   L0051,#$40,LA655	;Status word, bra if b6==1, all SA is ramped in 
;
;-Bring in SA after startup
;
	LDAB    L414D			;Filter coeff. for SA
	LDX     L0215			;SA ramping multiplier
	CPX     #65264			;Upper value for multipluer
	BHI     LA60E			;Bra if higher, all SA is ramped in
;
	LDAA    #255			;.996, multipler to filter to
	JSR     LF0F6			;Lag filter
	STD     L0215			;Save it
	BRA     LA655			;Bra to continue


LA60E	BSET    L0051,#$40		;Status word, set b6, all SA ramped in 
	BRA     LA655			;
;
LA613	JMP     LA671			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;Engine off/cranking here
;~~~~~~~~~~~~~~~~~~~~~~~~~
;   
LA616	BRSET   L0044,#$08,LA620	;Bra if first valid DRP already recieved
;
	BSET    L0044,#$08		;Set b3, first valid DRP revieved
	JMP     LAD0C			;RPM calculation routine
;
LA620	BRSET   L004F,#$10,LA627  	;Status word, bra if b4==1, engine transitioning to run
;
	JSR     LA657			;Engine running/cranking status routine
;
;-See if RPMs high enough for engine running
;
LA627	LDD     L3FC0			;DRP
	CPD     L4134			;DRP threshold for engine to be running 
	BCS     LA636			;Bra if DRP <, rpms higher then threshold for run
;
;-Engine still cranking/off here
;
	CLR     L0233			;Clear DRP counter, used for setting engine running flag
	JMP     LAD0C			;
;
;-Engine running here
;
LA636	INC     L0233			;+1, 
	LDAA    L0233			;DRP counter, used for setting engine running flag
	CMPA    L4143			;# of counts for engine to be running 
	BCC     LA644			;Bra if >=, set engine running flag and continue
;
;-Not enough DRPs for engine to be running yet
;
	JMP     LAD0C			;RPM calc. routine
;
;-Engine is now running, perform resets
;
LA644	BSET    L004F,#$80		;Status word, set b7, engine is now running
	CLR     L0233			;Clear DRP counter
	BSET    L0004,#$08		;Set b3, bad shutdown
	BCLR    L0051,#$40		;Status word, clear b6, ramp in SA
	CLRA				;
	CLRB				;
	STD     L0215			;SA ramping multiplier
;
LA655	BRA     LA6BB			;Bra to calc rpms
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Engine running/Cranking status routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA657	LDD     L3FC0			;DRP counter
	CPD     L4136			;DRP threshold for engine to be running
	BCC     LA66C			;Bra if DRP >=
;
;-Engine RPMs above cranking threshold
;
	LDAA    L0234			;Transition from crank to run delay DRP counter
	INCA				;+1
	CMPA    L4144			;Threshold to transition from crank to run
	BCS     LA66D			;Bra if # of DRPs is less
;
;-Engine now running...
;
	BSET    L004F,#$10		;Set b4, engine now transitioning to run
;
LA66C	CLRA				;Clear transition from crank to run DRP counter
LA66D	STAA    L0234			;Save it
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if no valid DRPs recieved
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA671	LDX     L0283			;Time since last DRP
	CPX     L4958			;Max time to run pump with no DRPs
	BCC     LA67F			;Bra if >=, shut down the pump

	INX				;+1
	STX     L0283			;Save the timer
	BRA     LA683			;Bra to continue
;
;-Timer elapsed, shut down the pump
;
LA67F	CLRA 				;   
	STAA    L306F			;Hardware, fuel pump relay control
;
;-Here if not shutting down fuel pump
;
LA683	CPX     #0160			;Max time window for next DRP
	BCS     LA694			;Bra if timer <
;
;-Assume engine has stalled/failed to start 
;
	SEI				;Disable interrupts
	LDAA    L4D8C			;Value to init cranking DRP counter to
	CMPA    L02F1			;Compare to cranking DRP counter
	BCC     LA694			;Bra if <=
;
	STAA    L02F1			;Save value as cranking DRP counter
;
LA694	CLI				;Re-enable interrups
	LDAA    L0225			;DRP period counter
	CMPA    #23			;.287 sec., max period for engine to be running
	BCS     LA6B0			;Bra if <=
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DRPs outside of window here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BCLR    L004F,#$90		;Clear b7=engine running, b4=now transitioning to run
	BCLR    L0044,#$08		;Clear b3, 1st DRP valid 
;
	LDD     #65535			;Reset DRP to max period
	STD     L005F			;Stored DRP
;											
	LDX     #L3060	            	;???
	BCLR    0,X,#$10		;Clear b4,  
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Do software interrupt
;~~~~~~~~~~~~~~~~~~~~~~~
;
LA6AD	SWI				;Software interrupt    
	BRA     LA6AD			;Loop 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; DRPs within window here
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
LA6B0	BRSET   L004F,#$80,LA6B7	;Bra if engine is running
;
;-Here if engine isnt running
;
	JMP     LAD0C			;RPM calc. routine
;
LA6B7	INCA				;+1, DRP period counter    
	STAA    L0225			;Sace it
;
;~~~~~~~~~~~~~~~~~
; Calculate RPMs
;~~~~~~~~~~~~~~~~~
;
;-RPM = (25 x 256 x 307)/(2 x (# cyl/8) x DRP)
;
;-DRP = (65536 x 120) / (RPM x # cyl)
;
LA6BB	LDD     L3FC0			;DRP counter
	STD     L005F             	;Stored DRP value
	STD     L020B			;Stored DRP value
;											
	LDX     #L005F			;Stored DRP
	LDAA    L4142			;# of cylinders
	LDAB    #32			;mult.
	MUL				;32 x # of cylinders     
	TBA				;Get LSB into A (/256), now # of cylinders relative to V8
	BEQ     LA6D4			;Bra if ==0, no cylindr count set
;
	JSR     LF1ED			;(A x X*)/256, # of cylinders x DRP
;
	STD     L005F			;Save result
;
LA6D4	LDD     L005F			;Load result,DRPs
	ASLD				;x2
	XGDX				;Get result into X, denominator
	LDD     #307			;Numerator
	FDIV				;Fract. divide    
	XGDX				;Get result into D
	STD     L083D			;Save calculated RPMs
;
;~~~~~~~~~~~~~~~~
; Do scaled RPMs
;~~~~~~~~~~~~~~~~
;
	CMPA    #96			;2400 rpm
	BCS     LA6ED			;Bra if <, do 12.5 rpm/count portion
;
;-2400 - 4800 rpm
;
	ADDD    #$4080			;MSB = 64, offset, LSB = 128, round up if needed  
	BCC     LA6F4			;Bra if no overflow
; 
	LDAA    #255			;Clear overflow, 
	BRA     LA6F4			;Bra to save
;
;-400 - 2400
;
LA6ED	ASLD				;x2, RPM/12.5    
	SUBD    #$1F80			;MSB = 31, 400 rpm offser, LSB = 128, round down if needed
	BCC     LA6F4             	;Bra if no underflow
;
	CLRA				;Clear underflow
;    
LA6F4	STAA    L0061			;Scaled RPMs
;
;~~~~~~~~~~~~~~~~~~~~
; Do RPM/25
;~~~~~~~~~~~~~~~~~~~~
;
	LDD     L083D			;Stored RPMs from calc.
	ADDD    #128			;Round up if needed
	SBCA    #$00			;-1 if overflow
	STAA    L0062			;Save it, RPM/25
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Filter RPM for governor
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L02B1			;Governor RPM/25
	LDAB    L50DA			;Governor RPM filter coeff
	JSR     LF0F6			;Lag filter routine
	STD     L02B1			;RPM/25
	ADDD    #128			;Round if needed
	LDAB    L0002			;Loop counter
	ANDB    #$1F			;Clear all but lower 5 bits
	CMPB    #$04			;0000 0100
	BNE     LA721			;Bra if b2==1
;
	TAB				;Get rpm/25 into B     
	SUBB    L02AF			;Previous governor rpm/25 term
	STAB    L02B0			;Delta governor RPM/25
	STAA    L02AF			;Save current RPM/25 as previous term
;
;-Do rpm/6.25
;
LA721	LDD     L083D			;Stored RPM/25
	ASLD				;x2    
	BCS     LA72F			;Bra if overflow
;
	ASLD				;x2    
	BCS     LA72F			;Bra if overflow
;
	ADDD    #128			;Round if needed
	BCC     LA731			;Bra if no overflow
;
LA72F	LDAA    #255			;Clear overflow
;
LA731	STAA    L0067			;RPM/6.25
;
	CLRB				;Clear LSB    
	LDX     L0068			;
	BEQ     LA742			;Bra if filtered RPMs are ==0, save new value instead
;                
;-Filter RPMs/6.25
;
	LDX     #L0068			;Addr. of stored RPMs
	LDY     #L450D			;Addr. of filter coeff.
	JSR     LF116			;RPM filter routine
LA742	STD     L0068			;Save filtered RPMs/6.25
;
	LDD     L083D			;Stored RPMs/25
	ASLD				;x2
	BCC     LA74D			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;										
LA74D	STAA    L0837			;Save it, stored RPMs/12.5
	LDX     L0063			;Filtered RPM/12.5
	BEQ     LA75B			;Bra if ==0, save new value instead

	LDY     #L4152			;Addr. of filter coeff
	JSR     LF0D3			;Lag filter routine
LA75B	STD     L0063			;Filtered RPMs/12.5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Calculate needed dwell
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Do dynamic dwell
;
	LDAA    #255			;3.89 msec, max dyn. dwell
	LDAB    L01E3			;S/D MAP
	SUBB    L01E5			;S/D MAP, two delayed
	BCS     LA76B			;Bra if MAP falling
;
;-S/D MAP steady/rising
;
	CMPB    #32			;Delta S/D MAP, 30 kPa
	BCC     LA77A			;Bra if delta SD MAP >=, set max dwell
;
LA76B	LDD     L0209			;DRP, one delayed
	SUBD    L020B			;Subtract Stored DRP 
	ASLD				;x2
	SUBD    L020D			;Subtract previous dynamic dwell
	BMI     LA77D			;Bra if result negative, bra if RPMs falling/dynamic dwell was greater
;
;-RPMs rising, add in additional dwell = (DRP, one delayed - DRP) 
;
	ADDD    L020D			;Get delta DRPs x 2 back
;
;-Here to set max dwell
;
LA77A	STD     L020D			;Save it, dynamic dwell
;
;-Limit dynamic dwell to DRP/8, or 11.25 degrees
;
LA77D	LDD     L020B			;Stored DRP
	LSRD				;/2  
	LSRD				;/2
	LSRD				;/2, now DRP/8, total time available for dynamic dwell
	SUBD    L020D			;subtract dyn. dwell
	BCC     LA78E			;Bra if dwell is <= DRP/8
;
	ADDD    L020D			;Get DRP/8 back
	STD     L020D			;Save DRP counts/8 instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Calculate static dwell 
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LA78E	LDD     L020B			;DRP
	STD     L0209			;DRP, one delayed
	LSRD				;/2, now .5 x DRP    
	SUBD    #229			;
	BCC     LA79F			;Bra if DRP/2 is >=
;
;-DRP < 7 msec, dwell = .5 x DRP + 1.2 msec
;
	ADDD    #308			;
	BRA     LA7AF			;Bra to save
;
;-DRP >= 7 msec
;
LA79F	LSRD				;/2, now .25 x DRP - 1.74 msec
	SUBD    #295			;
	BCS     LA7AA			;Bra if DRPs < 1636
;
;-DRP >= 25 msec, dwell = .25 x DRP - .41 msec 
;
	ADDD    #382			;
	BRA     LA7AF			;Bra to save
;
;-7 <= DRP < 25, dwell = .0625 DRP + 4.7 msec
;
LA7AA	ADDD    #1527			;
	LSRD				;/2    
	LSRD				;/2	
; 
LA7AF	STD     L083F			;Save it, static dwell
;
;-Compensate for low batt. voltage
;
	LDAA    #120			;12V, batt volts
	SUBA    L00A1			;Subtract A/D batt volts, now delta batt volts
	BCC     LA7B9			;Bra if batt volts are <=
;
	CLRA				;Clear delta batt volts 
;   
LA7B9	LDAB    #04			;Delta batt volts multiplier, .6 msec per volt below 12 volts
	MUL				;4 x Batt volts
	ADDD    L083F			;Add in static dwell
	ADDD    L020D			;Add in dynamic dwell
	STD     L020F			;Save it, outputted dwell
;
;-Limit dwell to ensure at least 595 usecs of off time between coil firings
;
	LDD     L3FC0			;DRP counter
	SUBD    #39			;595 usecs
	SUBD    L020F			;Outputed dwell
	BCC     LA7D6			;Bra if off time > 595 usec
;
	ADDD    L020F			;Get DRPs - 595 usecs back
	STD     L020F			;Save as outputted dwell
;
;-Shuffle the MAP around
;
LA7D6	LDAB    L01E4			;SD MAP, one delayed
	STAB    L01E5			;Save it, SD MAP two delayed
	LDAB    L01E3			;SD MAP
	STAB    L01E4			;Save it, SD MAP, one delayed
;
;~~~~~~~~~~~~
; Look up SA
;~~~~~~~~~~~~
;
	LDX     #L4165			;Main SA table
	BRCLR   L0050,#$40,LA7EC	;Status word, bra if b6==0, idle spark not enabled
;
	LDX     #L4289			;Closed throttle SA table 
;
;-Load in RPM and MAP for lookup
;
LA7EC	LDAB    L01E3			;SD MAP
	LDAA    L0061			;Scaled RPMs
	CMPA    #64			;1200 RPM, upper limit to use scaled RPMs
	BLS     LA7FD			;Bra if RPMs < 1200 RPM, use scaled RPMs
;
;-Use RPM/25 if RPMs high enough
;
	LDAA    L0062			;RPM/25
	ADDA    #16			;400 RPM offset for crossing point
	BCC     LA7FD			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;-RPMs now 400-1200 in 12.5 RPM inc., 1200-5975 in 25 rpm inc.
; 
LA7FD	JSR     LF17B			;3D lookup
;
	STAA    L021B			;Save it, looked up SA
;
;-Look up cool temp SA correction
;
	LDX     #L43AD			;Addr. of MAP/VAC option byte
	LDAB    L01EC			;Load vacuum
	LDAA    0,X			;Load it in
	BEQ     LA810			;Bra if ==0, use vac
;
	LDAB    L01E3			;Load SD MAP
LA810	INX				;+1, advance to start of table
	LSRB				;Vac,MAP/2
	LDAA    L0006			;Cool temp, linear
	CMPA    #244			;128 deg C, max temp for lookup
	BLS     LA81A			;Bra if cool temp <=

	LDAA    #244			;Load max
LA81A	JSR     LF17B			;3D lookup
;
	LDAB    L0050			;Status word
	BPL     LA830			;Bra if b7==0, not idling
;
;-Idling here, check and limit negative SA
;
	LDAB    L0006			;Cool temp
	CMPB    L4141			;Cool temp threshold for 
	BCC     LA830			;Bra if cool temp is >=, skip check

	CMPA    L413D			;Cool temp SA bias
	BCC     LA830			;Bra if cool temp SA corrections greater
;
	LDAA    L413D			;Use bias if SA is less
;
;-Here if not idling
;
LA830	STAA    L021C			;Save it, cool temp spark correction
	LDAA    L400D			;Option byte 
	BITA    #$04			;Test b2, backpressure EGR
	BEQ     LA849			;Bra if not using back pressure EGR
;	
;-Lookup alt. SA correction
;
	LDAA    L01EF			;Baro val. for lookup
	LDAB    L01EC			;Vacuum
	LDX     #L44CB			;Addr. of alt. SA correction table
	JSR     LF17B			;3D lookup routine
;
	STAA    L021E			;Save it, alt. SA correction
;
;-Look up low octane SA retart
;
LA849	LDAB    L0841			;Low octane RPM mult.
	LDAA    L01E3			;SD MAP
	LDX     #L45BD			;Addr. of low octane MAP mult.  
	JSR     LF15E			;2D lookup
;
;-low octane SA mult. = (MAP mult x rpm mult) / 256
;
	MUL				;Low octane map mult. x low octane rpm mult.
	ADCA    #0			;Round if needed
	LDAB    L022D			;Low octane base SA retard
	MUL				;Low octane SA mult. x base SA retard
	ADCA    #0			;Round if needed
	STAA    L022E			;Save it, low octane SA retard
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up EGR sA correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
	LDAA    L413F			;Load EGR bias SA
	CLRB				;Clear B
	BRCLR   L006E,#$80,LA8A3	;Status word, bra if b7==0, EGR not active
;
;-EGR is active
;
	LDX     #L4855			;Load EGR spark correction table
	LDAB    L01D5			;Filt. % EGR flow
	LDAA    #192			;Scalar for %EGR flow
	MUL				;Scalar x EGR flow
	TAB				;MSB to B
	LDAA    0,X			;Get load selection byte
	BEQ     LA88D			;Bra if ==0, use % EGR flow
;
;-Scale vacuum for lookup
;
	LDAB    L01EC			;Vacuum
	NEGB				;Neg., now 0-80 kPa
	CMPB    #64			;20 kPa, lower limit to scale vac 
	BHI     LA882			;Bra if vacuum kPa >
;
;-Vac kPa < 20, val for lookup = vac x 2
;
	ASLB				;x2
	BRA     LA88D			;Bra to continue				
;
;-Vac kPa >= 20, val for lookup = (vac - 64)/2 + 128
;											
LA882	SUBB    #64			;Subtract offset
	LSRB				;/2    
	ADDB    #128			;+128
	CMPB    #192			;60 kPa, upper limit for lookup
	BLS     LA88D			;Bra if kPa <=
;
	LDAB    #192			;Load max
;
;-Check RPM for lookup
;											
LA88D	LDAA    L0062			;RPM/25
	CMPA    #160			;4000 RPM, UL for lookup
	BLS     LA895			;Bra if RPMs <=
;
	LDAA    #160			;Load max
;
LA895	LSRA				;/2 for lookup  
	INX				;+1, index start of table
	JSR     LF17B			;3D lookup
;					
	LDAB    L4854			;EGR SA correction filt. coeff
	LDX     L0217			;EGR correction SA
	JSR     LF0F6			;Filter routine
;
;-Here if EGR not on
;											
LA8A3	STD     L0217              	;Filtered EGR SA
;
;~~~~~~~~~~~~~~~~~~
;-Sum up SA so far
;~~~~~~~~~~~~~~~~~~
;
	ADDD    #128			;Round if needed
	TAB				;Get result into B
	LDX     #$0000			;Clear X
	ABX				;Add in EGR SA
	LDAB    L021E			;Load in alt. SA corr.
	ABX				;Add it in
	LDAB    L021B			;Load in main SA
	ABX				;Add it in
	LDAB    L021F			;PE SA
	ABX				;Add it in
	LDAB    L021C			;Cool temp SA corr.
	ABX     			;Add it in
	LDAB    L02EE			;Startup SA
	ABX				;Add it in     
	XGDX				;Get result into D    
;
;-Sub out bias' and retard
;
	SUBB    L413C          		;Main SA bias
	SBCA    #$00			;Perform carry if needed
	SUBB    L413D			;Cool correction SA bias
	SBCA    #$00			;
	SUBB    L413E          		;Alt. SA corr. bias
	SBCA    #$00			;
	SUBB    L413F			;EGR SA bias
	SBCA    #$00			;
	SUBB    L022E			;Low octane SA retard
	SBCA    #$00			;
	SUBB    L0154			;(???)
	SBCA    #$00			;
	STD     L0220			;Save it, final SA
;
;~~~~~~~~~~~~~~~~~~~~~~
;-Do MAT SA correction
;~~~~~~~~~~~~~~~~~~~~~~
;
;
;-Look up MAT SA correction mult for negative SA correction
;
	LDAA    L01E3			;SD MAP
	LDX     #L4493			;Addr of negative MAT SA correction mult. vs. SD MAP
	BRSET   L0041,#$02,LA8F1   	;Status word, bra if b1==1, SA correction is negative                  
;
;-Look up MAT SA correction mult for positive SA correction
;
	LDX     #L44A4             	;Addr. of positive MAT SA correction mult. vs. SD MAP
LA8F1	JSR     LF15E			;2D lookup
;
	LDAB    L021D			;MAT SA correction
	MUL				;MAT SA corr. x MAT SA mult.
	STAA    L083C			;Save it, Final MAT SA correction

	BRCLR   L0041,#$02,LA90C	;Status word, bra if b1==0, MAT SA corr. >=0
;
;-Subtract MAT SA correction 
;
	LDD     L0220			;Final SA 
	SUBB    L083C			;-Final MAT SA 
	SBCA    #0			;Round if needed
	STD     L0220			;Save it, Final SA 
	BRA     LA914
;
;-Add in MAT SA correction
;
LA90C	TAB				;Get MAT correction SA into B     
	LDX     L0220			;Load final SA 
	ABX				;Add in MAT SA
	STX     L0220			;Save final SA 

LA914	LDX     L00F8			;Engine run time
	CPX     L415D			;Min run time for idle SA adj.
	BCC     LA91D			;Bra if runtime is >=
;
	BRA     LA977			;Bra to skip idle SA adj.			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Idle under/overspeed SA proportional control
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check quals for idle SA adj.
;
LA91D	LDX     #L44F8			;Addr. of engine idle underspeed SA adj. table
	LDAA    L02A7			;MPH
	CMPA    L4159			;Upper MPH limit for idle SA adj.
	BCC     LA977			;Bra if VSS >=
;
	LDAA    L415A			;Upper %TPS limit for idle SA adj., idle SA ok'd
	BRCLR   L0050,#$40,LA932	;Status word, bra if idle SA not ok'd 
;
	LDAA    L415B			;Upper TPS limit for idle SA adj., idle SA not ok'd
;
LA932	CMPA    L01FC			;%TPS
	BHI     LA939			;Bra if %TPS is less, continue
;
	BRA     LA977			;Bra, TPS exceeds limits
;
LA939	LDAB    L0006			;Cool temp, linear
	CMPB    L415C			;Min temp for SA adj.
	BLS     LA977			;Bra if cool temp less
;
	CLRB				;
	LDAA    L0857			;Desired idle speed										;
	BRSET   L0050,#$80,LA954	;Status word, bra if b7==1, engine idling
;
;-Check desired idle speed
;
	ADDA    L415F			;RPM offset if not idling
	BCC     LA954			;Bra if no overflow
;
;-Here if overflow from addition of bias
; 
	BCLR    L0053,#$01		;Status word, clear b0, engine underspeed
;
	SUBD    L0063			;Subtract RPM/12.5, now delta RPMs										;
	BRA     LA977			;Bra, quals not passed for idle SA control
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if quals passed for proportional idle SA control
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA954	SUBD    L0063			;Subtract RPM/12.5
	BCS     LA95D			;Bra if eng. speed > then desired idle speed
;
	BCLR    L0053,#$01		;Status word, clear b0, engine speed <= desired idle speed
	BRA     LA967			;Bra to continue
;
;-Here if engine speed > desired idle speed
;
LA95D	BSET    L0053,#$01		;Status word, set b0, engine speed > then desired idle speed
	NEGA 				;Make error term positive
	NEGB    			;
	SBCA    #$00			;Perform carry if needed	
	LDX     #L44E6			;Addr. of engine overspeed SA correction
;
;-Here if engine speed <= desired idle speed
;
LA967	PSHX				;Table addr. to stack
	ASLD				;RPM error x 2, now RPM / 6.25
	BCS     LA973			;Bra if overflow
;
;-Scale the RPM error for lookup, 0 - 50 rpm in .78 rpm inc., 50 - 1250 rpm in 6.25 rpm inc.
;
	CMPA    #08			;50 rpm, RPM error limit for RPM x 1.28
	BCS     LA97D			;Bra if RPM error is < 

	ADDA    #56			;Offset for RPM x 1.28
	BCC     LA980			;Bra 
;
LA973	LDAA    #255			;Load max
	BRA     LA980			;Bra 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if quals not passed for idle SA control
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA977	BCLR    L0050,#$40		;Status word, clear b6, idle SA adj. not active
	JMP     LA9CC			;Bra to skip idle SA adj.
;
;-Here to continue with idle SA adj.
;
LA97D	ASLD				;x2
	ASLD				;x2
	ASLD				;x2, now RPM x 1.28  
;
LA980	JSR     LF136			;2D lookup with UL
;
	PULX				;Get start addr. back into X    
	PSHA				;Push SA corr. to stack  
;
;-Look up S/D MAP SA corr. multiplier
;
	LDAB    #$08			;Addr. offset for SD MAP SA corr. mult.
	ABX				;Add in the offset 
	LDAA    L01E3			;S/D MAP
	JSR     LF136			;2D lookup with UL
;
	PULB				;Get idle SA correction
	MUL				;Idle SA x idle SA mult.
	BRCLR   L0053,#$01,LA995  	;Status word, bra if b0==0, engine idle underspeed

	NEGA				;Make negative signed val. if SA corr. negative
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform idle SA derivative control
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA995	PSHA				;Push proportional idle SA corr. to stack
	LDX     #L4511			;Addr. of transient RPM idle SA corr. table
	LDAA    L006C			;Transient RPM ratio
	SUBA    #96			;limit to .75 RPM ratio
	BCC     LA9A2			;Bra if no underflow

	CLRA				;Clear underflow   
	BRA     LA9A8			;Bra to continue
;
;-Check upper limit for lookup
;
LA9A2	CMPA    #63			;1.25 RPM ratio
	BLS     LA9A8			;Bra if <=
;
	LDAA    #63			;Load max
;
LA9A8	ASLA				;x2
	ASLA				;x2, now spans from .75-1.25 in .00195 increments
	JSR     LF15E			;2D lookup
;
	PULB				;Get idle SA corr. off the stack
	ABA				;Add it in
	SUBA    L450A			;20 deg., SA bias for transient RPM SA corr.
	BMI     LA9C0			;Bra if SA corr is negative
;
	CMPA    L450B			;Max positive SA corr.
	BLS     LA9BC			;Bra if SA corr. <=

	LDAA    L450B			;Load max SA corr.
;
LA9BC	TAB     			;Get SA corr. into B
	CLRA				;Preclear A
	BRA     LA9C3
;
;-Here if SA corr. is negative
;
LA9C0	TAB				;Get SA corr. into B
	LDAA    #$FF			;Preload with 0xFF, negative SA corr.
;
;-Here if SA corr. is positive
;
LA9C3	ADDD    L0220			;Add in SA corr.
	STD     L0220			;Save it, final SA
	BSET    L0050,#$40		;Status word, set b6 for next pass, idle SA enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-SA derivative engine control routine, used with manual transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LA9CC	LDAA    L0006			;Cool temp, linear
	CMPA    L46E8			;Lower limit for SA adj.
	BCS     LAA40			;Bra if cool temp less, no SA adj.
;
	CMPA    L46E9			;upper limit for SA adj.
	BHI     LAA40			;Bra if cool temp is higher, no SA adj.

;
;-Check to see if manual trans present
;
	LDAA    L400F			;Opt. byte
	BITA    #$80			;Test b7, manual trans/TCC
	BEQ     LAA40			;Bra if ==0, TCC present, skip routine
;
;-Check to make sure engine not idling
;
	BRCLR   L0050,#$80,LA9EC	;Status word, bra if b7==0, not idling
;
	LDAA    L0837			;Stored RPMs/12.5
	CLRB				;    
	STD     L0838			;Stored RPMs/12.5, filtered
	BRA     LAA40			;Bra to skip routine
;
;-All quals met here
;
LA9EC	LDAA    L0063			;RPM/12.5
	SUBA    L0838			;Subtract stored RPMs/12.5, filtered
	STAA    L083A			;Save it, RPM error
;
;-Look up filter coeff for filtered RPMs/12.5 using TPS
;
	LDX     #L46EA			;Addr. of filter coeff. vs. TPS table
	LDAA    L01FC			;TPS
	LSRA				;/2
	LSRA				;/2, now TPS/4 for lookup    
	JSR     LF15E			;2D lookup
;
	TAB				;Get filt. coef. into B     
	LDAA    L0837			;RPM/12.5
	LDX     L0838			;RPM/12.5, filtered
	JSR     LF0F6			;Filter routine
;
	STD     L0838			;Save filtered RPMs
;
	LDX     #L46E2			;Addr. of gain terms
	LDAA    L083A			;RPM error
	BPL     LAA18			;Bra if RPMs rising

;
;-RPMs falling here
;
	INX				;curr. addr. +1    
	INX				;+1
	INX				;+1, now at params for falling RPMs
	NEGA				;Make absolute value of RPM error
;
;-RPMs rising here
;
LAA18	LDAB    0,X			;Load RPM gain
	MUL				;RPM error x gain    
	ADDA    1,X			;Add in der. term bias
	CMPA    2,X			;Upper limit for der. term
	BLS     LAA23			;Bra if less
;
	LDAA    2,X			;Load max SA der. term
;
LAA23	STAA    L083B			;SA derivative term
	LDAA    L083A			;RPM error
	BPL     LAA35			;Bra if RPMs rising
;
;-RPMs falling here, add in SA der. term
;
	LDD     L0220			;Final SA
	ADDB    L083B			;Add in SA der. term
	ADCA    #$00			;Perform carry if needed
	BRA     LAA3D			;Bra to save
;
;-RPMs rising here, subtract out the SA der. term
;
LAA35	LDD     L0220			;Final SA
	SUBB    L083B			;Subtract out the SA der. term 
	SBCA    #$00			;Perform carry if needed
LAA3D	STD     L0220			;Final SA adv.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Perform Decel Fuel Cut Off SA corrections
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LAA40	LDD     L0220			;Load final SA
	BRCLR   L0046,#$08,LAA69	;Status word, bra if b3==0, DFCO not enabled
;
;-Subtract out DFCO SA correction if entering DFCO
;
	BSET    L0051,#$20		;Status word, set b5, DFCO SA correction enabled
;
	CLRA				;
	CLRB				;
	STD     L0215			;SA ramping mult.
	LDAB    L4151			;DFCO SA 
;
	LDAA    L021C			;Cool temp corr. SA
	SUBA    L413D			;Subtract bias
	BMI     LAA5C			;Bra if SA corr. is negative
;
	ABA				;Add in DFCO SA
	TAB				;Get result into B
;
LAA5C	STAB    L022B			;Save it, DFCO SA correction											;
	LDD     L0220			;Final SA
	SUBB    L022B			;Subtract DFCO SA correction
	SBCA    #$00			;Perform carry if needed
	BRA     LAAA3			;Bra to save SA
;
;-Check to see if previously performing DFCO SA corr.
;
	BRCLR   L0051,#$20,LAAA6	;Status word, bra if b5==0, no DFCO SA corr. 

	LDAB    L414E			;Low %TPS filter coeff. for SA ramping mult.
	LDAA    L01FC			;TPS
	CMPA    L4150			;Upper TPS threshold for filter coeff.
	BLS     LAA7B			;Bra if TPS is <=
;
;-Ramp DFCO SA corr. back into main SA
;
	LDAB    L414F			;High %TPS filter coeff. for SA ramping mult.
;
LAA7B	LDX     L0215			;SA ramping multiplier
	CPX     #65264			;Upper limit to filter ramp-in mult.
	BHI     LAA8D			;Bra if higher, all SA ramped in
;
	LDAA    #255			;Value to filter ramp-in mult. to
	JSR     LF0F6			;Filter routine
;
	STD     L0215			;Save it, DFCO SA ramp-in multiplier
	BRA     LAA90			;Bra, still ramping in SA
;
;-Here if all DFCO SA ramped back in
;
LAA8D	BCLR    L0051,#$20		;Status word, clear b5, no longer performing DFCO SA corr. 
;
LAA90	LDAB    L022B			;DFCO SA corr.
	LDAA    L0215			;SA ramping multiplier
	MUL				;DFCO SA x ramping mult.     
	ADCA    #$00			;round if needed
	TAB				;Get SA into B     
	CLRA				;   
	ADDD    L0220			;Add in partial DFCO SA corr. into final SA
	SUBB    L022B			;Subtract DFCO SA corr., now only part of DFCO SA corr. is in effect
	SBCA    #$00			;Perform carry if needed
;
LAAA3	STD     L0220			;Save it, final SA
;
LAAA6	BRCLR   L0082,#$40,LAAAD	;Status word, bra if b6==0, no heads-up yet 
;
	JSR     L1812			;Heads up vector table
;
;-Check if P/S pressure switch in use
;
LAAAD	LDAA    L4E86			;Opt. byte
	BITA    #$02			;Test b1, power steering switch in use
	BEQ     LAAE0			;Bra if ==0, no PS switch in use
;    
;-Check if P/S active
;
	BRCLR   L0036,#$20,LAADD	;Bra if b5==0, P/S compensation not in effect
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for power steering SA compensation
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check cool temp
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L4160			;Lower temp threshold for P/S SA compensation
	BLS     LAADD			;Bra if cool temp is <=
;
;-Check TPS
;
	LDAA    L01FC			;TPS
	BRSET   L0053,#$10,LAACD	;Status word, bra if b4==1, P/S SA compensation 
					;already underway, check threshold to disable
;
;-P/S compensation not yet underway, check TPS threshold to enable compensation
;
	CMPA    L4163			;TPS threshold for enabling P/S SA compensation 
	BHI     LAADD			;Bra if TPS >, no SA compensation
;
	BRA     LAAD2			;Bra to enable P/S SA compensation				
;
;-P/S compensation underway, check TPS threshold to disable compensation
;
LAACD	CMPA    L4164			;TPS threshold for disabling P/S SA compensation
	BHI     LAADD			;Bra if TPS > 
;
;-Enable P/S SA compensation
;
LAAD2	LDD     L4161			;Fixed SA for P/S compensation
	STD     L0220			;Save it, final SA
;									
	BSET    L0053,#$10   		;Status word, set b4, P/S SA compensation in effect
	BRA     LAAE0			;Bra to continue		
;
;-Here if no P/S compensation
;											
LAADD	BCLR    L0053,#$10   		;Clear b4, P/S compensation not in effect
;
;-Subtract base SA
;											
LAAE0	LDD     L0220			;Final SA
	SUBB    L4133			;Base SA
	SBCA    #0			;Perform carry if needed
	STD     L0211			;Save it, total SA
;
;-Check limits on SA
;											
	LDD     L4145			;Max allowable SA
	SUBD    L0211			;Subtract total SA
	BGT     LAAF9			;Bra if SA <
;
	ADDD    L0211			;Add in total SA to get max allowable SA back
	STD     L0211			;Save max allowable SA instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform knock prevention 
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LAAF9	LDAA    L400F			;Opt. byte
	BITA    #$08			;Test b3, enable ESC
	BEQ     LAB47			;bra if b3==0, bra if no ESC
;
	BRSET   L0050,#$10,LAB47	;Bra if b4==1, in diags. mode
;
;-Check cool temp quals
;
	LDAA    L0006			;Cool temp, linear
	CMPA    L45D0			;Min cool temp for spark retard
	BLS     LAB47			;Bra if cool temp less, no retard
;
;-Check to see if knock prevention in effect
;
	BRCLR   L006E,#$02,LAB24	;Bra if knock prevention not currently in effect

	DEC     L0231			;Burst retard timer
	BNE     LAB17			;Bra if !=0, perform burst retard
;
	BCLR    L006E,#$02		;Status word, clear b1, knock prevention no longer in effect
;
;-Knock prevention in effect here
;
LAB17	LDD     L0211			;Load total SA
	SUBB    L0842			;Subtract burst retard
	SBCA    #$00			;Perform carry if needed
	STD     L0211			;Save total SA
	BRA     LAB47			;Bra to continue
;
;-Check quals for knock prevention
;				
LAB24	LDAA    L01E3			;Load SD MAP
	CMPA    L46D5			;50 kPa
	BCC     LAB47			;Bra if >=
;
	LDAB    L01FC			;%TPS
	CMPB    L46D6			;Upper limit for
	BCC     LAB47			;Bra if TPS >=
;
	SUBB    L01FD			;Subtract TPS, one delayed
	BCS     LAB47			;Bra if throttle is closing
;
	CMPB    L46D7			;Delta %TPS threshold for knock prevention
	BCS     LAB47			;Bra if delta TPS <=
;									
	BSET    L006E,#$02		;Status word, set b1, knock prevention ok'd
;
	LDAA    L46D8			;Time for burst retard to be in effect
	STAA    L0231			;Save it, burst retard timer
;
;-Here if knock prevention not ok'd
;
LAB47	SEI				;Disable interrupts
	LDAB    L0230			;Load knock counts into B
	CLR     L0230			;Clear knock counts
	CLI				;Enable interrupts
	BRSET   L006E,#$02,LAB60	;Status word, bra if knock prevention in effect
;
	BRCLR   L0016,#$60,LAB59	;Error word, bra if b5, b6==0, no cool temp sens. errors
;
	BRA     LAB63			;Bra to continue with SA retard quals if errors set.				
;
;~~~~~~~~~~~~~~~~~~~~
; Knock retard quals
;~~~~~~~~~~~~~~~~~~~~
;									
LAB59	LDAA    L0006			;Load cool temp
	CMPA    L45D0			;Min temp for knock retard 
	BCC     LAB63			;Bra if cool temp >=
;
;-Here if knock prevention already in effect
;
LAB60	CLRA				;
	BRA     LAB91			;
;
;-Check MPH 
;
LAB63	LDAA    L02A7			;MPH
	CMPA    L45CE			;Lower limit for SA retard
	BCC     LAB72			;Bra if speed >=
;
;-Check RPMs
;
	LDAA    L0063			;RPM/12.5
	CMPA    L45CF			;Lower RPM limit for SA retard
	BCS     LABA2			;Bra if RPMs <=, no retard
;
;-Check for ESC error
;
LAB72	BRCLR   L0019,#$10,LAB7B	;Error word #4, bra if no ESC failure
;
	LDAA    L4E6D			;Default SA for ESC faulure
	BRA     LAB91			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; All quals passed, calc. retard
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Retard SA = .5 x [(knock attack rate x knock counts)/128]
;
LAB7B	LDAA    L0843			;Knock attack rate
	MUL				;Knock counts x knock attack rate     
	ASLD				;x2    
	BCS     LAB87			;Bra if no overflow
;
	ADDA    L022F			;Add in previous retard
	BCC     LAB89			;Bra if no overflow
;
LAB87	LDAA    #255			;Clear overflow
;
LAB89	TAB				;Knock retard to B     
	LDAA    L0844			;Max knock retard
	CBA				;     
	BLS     LAB91			;Bra if knock retard is less

	TBA				;Get max knock retard into A
;     
LAB91	STAA    L022F			;Save it, knock retard 
	LSRA				;/2    
	PSHA				;Push to stack	    
	TSX				;Get current stack pointer into X     
	LDD     L0211			;Load total SA
	SUBB    0,X			;Subtract retard
	SBCA    #$00			;Perform carry if needed
	STD     L0211			;Save total SA
	INS				;Restore stack pointer     
LABA2	LDAA    L0154			;(???)				 
	BEQ     LABB2			;Bra if ==0
;
	LDD     L414B			;max retard during torque management fuel cutoff 
	CPD     L0211			;Total SA 
	BLT     LABD5			;Bra if timing is > 
;
	BRA     LABD2			;Bra to save max retard instead
;
LABB2	BRCLR   L0051,#$20,LABC9	;Bra if no longer performing DFCO SA correction
;
;-Performing DFCO SA correction here
;
	LDAA    L01FC			;TPS
	CMPA    L48D0			;Max closed throttle TPS
	BHI     LABC9			;Bra if TPS >
;
;-Throttle is closed, limit retard
;
	LDD     L4149			;Max retard during DFCO
	CPD     L0211			;Total SA
	BLT     LABD5			;Bra if timing > 

	BRA     LABD2			;Bra to save max retard instead


LABC9	LDD     L4147			;Max allowable retard
	CPD     L0211			;Total SA
	BLT     LABD5			;Bra if timing >
;
LABD2	STD     L0211			;Save total SA
;
LABD5	LDD     L0211			;Load total SA
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Check for ALDL mode 4
;~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L003B,#$10,LABF9	;Bra if not in mode 4
;
;-In mode 4
;
	LDX     #L0397			;
	BRCLR   0,X,#$08,LABF9		;
;
	BRSET   0,X,#$10,LABE9		;  
;
	CLRA				;
	CLRB				;
;
LABE9	BRSET   0,X,#$20,LABF4		; 
;
	ADDB    L039A			;
	ADCA    #$00			; 
;
	BRA     LABF9			;				
;
LABF4	SUBB    L039A			;
	SBCA    #$00			;
;
;-Here if no mode 4
;
LABF9	STD     L0211			;Save total SA
	STD     L0213			;
;
;-Check sign of SA and set status bit accordingly
;											
	BCLR    L004F,#$01		;Status word, clear b0, SA positive
;											
	LDD     L0211			;Load total SA
	BPL     LAC0B			;Bra if >0
;
	BSET    L004F,#$01		;Status word, set b0, SA negative
	NEGB				;Get abs. value of SA
;
LAC0B	TBA				;SA to A
;
;-Check if SA ramping still in effect
;
	BRSET   L0051,#$40,LAC1D	;Status word, bra if b6==1, all SA ramped back in
;
	LDAB    L0215			;SA ramping multiplier
	LDX     #L0216			;Index LSB for rounding
	BRCLR   0,X,#$80,LAC1B		;Bra if b7==0, LSB < 128 	
;
	INCB				;+1, round up
;
LAC1B	MUL				;SA x ramping multiplier
	INCA				;+1, compensate for the fact that multiplier only goes to 255
;
;-Check for heads up
;											
LAC1D	BRCLR   L0082,#$40,LAC24	;Status word, bra if b6==0, no heads up yet 
;				
	JSR     L180F			;To heads up vector table
;
;~~~~~~~~~~~
; Output SA
;~~~~~~~~~~~
;
;-Perform spark latency correction
;
LAC24	PSHA				;Push SA to stack    
	LDAA    L0062			;RPM/25
	LDX     #L4540			;Addr. of spark latency correction table
	JSR     LF136			;2D lookup with UL
;
	STAA    L0224			;Save it, spark latency correction
;
;-Finalize SA for output
;
	PULA				;Get SA off the stack    
	LDX     #L005F			;DRPs
	JSR     LF1ED			;(A x X*)/256
;
	BRSET   L004F,#$01,LAC3F	;Status word, bra if b0==1, SA negative
;
	NEGA				;Negate, 65536 - time based SA    
	NEGB 				;   
	SBCA    #$00			;
;
LAC3F	SUBB    L0224			;Subtract spark latency
	SBCA    #$00			;Perform carry if needed
	PSHB				;Push result to stack    
	PSHA				;    
	TSX 				;Get current stack pointer into X    
	CLRA				;Clear AB    
	CLRB				;    
	SUBD    L3FC0			;Subtract DRP counter
	LSRD				;/2    
	LSRD				;/2
	LSRD				;/2
	LSRD				;/2  
	ORAA    #$F0			;Clear lower 4 bits of MSB
	ADDD    L3FF6			;Add in EST fall counter
	SUBD    0,X			;Subtract origional result on stack
	BMI     LAC5D			;Bra if msb is ==1
;
	ADDD    0,X			;Add origional result back in
	STD     0,X			;Save 
;
LAC5D	LDD     0,X			;Finalized SA value
	SUBD    L3FF6			;Subtract EST fall counter again
	JSR     LF08A			;Short delay
;
	STD     L3FE8			;
	JSR     LF08A			;Short delay
;
	ADDD    L3FDC			;
	SUBD    L020F			;Subtract stored dwell
	NOP				;Very short delay     
	LDX     L020F			;Load dwell
	STD     L3FE6			;
	JSR     LF08A			;Short delay
;
	STX     L3FDC			;
	JSR     LF08A			;Short delay
;
	PULA				;Get SA value back off stack    
	PULB				;
	STD     L3FF6			;Save it, EST fall counter
;
;~~~~~~~~~~~~~~~~~~~
; Perform EST diag.
;~~~~~~~~~~~~~~~~~~~
;    
	BRCLR   L0044,#$08,LACEC	;Status word, bra if b3==0, no valid DRP yet 
;
	BRCLR   L0050,#$04,LACCB	;Bra if b2==0, no DRP yet
;
;-First DRP occured, perform EST check
;
	LDD     L3FCA			;EST circuit info
	PSHB				;    
	PSHA				;
	PULX				;Transfer into X
;
	LDY     #L5B03			;Error mask 4
	BRCLR   0,Y,#$20,LACD7		;Test b5, EST mon. falure, bra if ==0, not setting error
;
	BRSET   L004F,#$40,LACE0	;Bra if b6==1, EST bypass diag. already passed 
;
;-No EST diag. yet, check for open/faulty EST circuit
;  
	BRSET   L0044,#$80,LACD1	;EST failure already flagged
;
	SUBD    L0228			;Previous EST circuit info
	TSTA				;Test MSB    
	BNE     LACB9			;Bra if EST circuit info value > 255, EST open 
;
	CMPB    L4E67			;Number of counts to set error
	BHI     LACB9			;Bra if >, faulty EST, set error
;
;-EST circuit counter value within limits to be grounded
;   
	BRSET   L0044,#$40,LACD7	;Status word, bra if b6==1, EST mon. already set
;
	BSET    L0044,#$40		;Status word, set b6, EST monitor
	BRA     LACC8			;Bra to save EST info and exit.
;
LACB9	LDAB    L024F			;Load error 42 counter
	CMPB    L4E68			;# of EST errors to set code 42
	BHI     LACCE			;Bra if >, set error
;
;-Not setting code 42 yet here
;
	INCB				;Inc. error 42 counter
	STAB    L024F			;Save it
	BCLR    L0044,#$40		;Clear b6, EST monitor 											; CLR b6
LACC8	STX     L0228			;Save EST circuit info
;			
LACCB	JMP     LAD5E			;Exit				
;
;-Setting code 42 here
;    
LACCE	BSET    L0044,#$80		;Set b7, EST failure
;
LACD1	BSET    L0019,#$20		;Error word #4, set code 42, EST failure
	JMP     LAD5E			;Bra to exit
;
;-Here if EST passed diag.
;
LACD7	BSET    L004F,#$40		;Set b6, EST bypass diag. passed 
	CLR     L024F			;Clear EST error counter
	STX     L0228			;Save EST circuit info
;  
LACE0	BCLR    L0044,#$08		;Status word, clear b3, no valid DRP yet
;
	LDX     L3FEC			;
	JSR     LF08A			;Short delay
;											
	STX     L3FE4			;
;
LACEC	BSET    L004B,#$10		;I/O word, set b4
;
;-Check for EST active fault
;
	BRCLR   L0004,#$80,LACFC	;Bra if EST active fault not set
;
	BRSET   L0044,#$04,LACFC	;Status word, bra if b2==1, skip EST due to ALDL
;
;-Here to set code 42, EST 
;
	BSET    L0019,#$20		;Error word #4, set code 42, EST
	BRA     LAD5B			;Bra
;
;-Here if no EST fault/skipping EST error
;
LACFC	BRCLR   L003B,#$10,LAD5E	; BR IF NOT b4, IN MODE 4, ($F4) 

	LDAA    L0393			;
	BITA    #$08			;
	BEQ     LAD5E			;
;   
	BSET    L0044,#$04		;(???)
	BRA     LAD5B			;
;
;~~~~~~~~~~~~~~~~~~~~
;
; RPM calc. routine 
;
;~~~~~~~~~~~~~~~~~~~~
;
;-RPM = (25 x 256 x 307)/(2 x (# cyl/8) x DRP)
;
;-DRP = (65536 x 120) / (RPM x # cyl)
;
LAD0C	LDX     #$FFFF			;Max DRP period    
	BRCLR   L0044,#$08,LAD59	;Bra if no valid DRPs recieved yet
;
	LDD     L3FC0			;DRP counter 
	STD     L005F             	;DRP period
	STD     L020B			;DRP period
	LDX     #$005F             	;DRP period
	LDAA    L4142              	;# cylinders
	LDAB    #32			;
	MUL				;# cylinders x 32     
	TBA				;Get result into A     
	BEQ     LAD2C			;Bra if 8 cylinders
;
	JSR     LF1ED			;(A x X*)/256
	STD     L005F             	;D = (# cyl. x DRP) / 8, now relative to 8 cyl. engine
;
LAD2C	LDD     L005F             	;Stored DRP
	ASLD				;x2
	XGDX 				;Swap DRP x 2 into X   
	LDD     #307			;
	FDIV 				;Fract. divide, X = (307/(DRPs x 2))   
	PSHX				;Push X to stack  
	PULA				;Get results into D, now RPMs/25
	PULB				; 
;   
;~~~~~~~~~~~~~~~~
; Do scaled RPMs
;~~~~~~~~~~~~~~~~
;
;-400 - 2400 in 12.5 rpm inc., 2400-4800 in 25 rpm increments
;
	CMPA    #96			;2400 rpm
	BCS     LAD44			;Bra if less
;
;-RPMs >= 2400 rpm
;
	ADDD    #$4080			;dec. 64, offset for 2400-4800 rpm, $80= round up if needed
	BCC     LAD4B			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
	BRA     LAD4B			;Bra to save.
;
;-RPMs < 2400 here
;
LAD44	ASLD				;x2, now in   
	SUBD    #$1F80			;dec. 31, 400 rpm minimum, $80, round down if needed
	BCC     LAD4B			;Bra if no underflow
;
	CLRA				;Clear underflow
;    
LAD4B	STAA    L0061			;Save it, scaled rpms
;
;~~~~~~~~~~~
; Do rpm/25
;~~~~~~~~~~~
;
;-0 - 6375 in 25 rpm increments
;
	PSHX				;Push calc'd rpms to stack    
	PULA				;Get back into D
	PULB				;
	ADDD    #$80			;
	SBCA    #$00			;Round if needed
	STAA    L0062			;Save it, RPM/25
	BRA     LAD5B			;Bra 
;
LAD59	STX     L005F			;Stored DRP value

LAD5B	BCLR    L004B,#$10		;I/O word, clear b4
;
LAD5E	BCLR    L0050,#$04		;CLR b2, reset DRP test bit
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LAD62	LDX     #L400E			;Opt. byte
	BRSET   0,X,#$04,LAD6C		;Bra if b2==1, shift light enabled
;
	JMP     LAE64			;No shift light, exit routine
;
;-Here of using shift light
;
LAD6C	BRCLR   L0050,#$10,LAD76	;Status word, bra if b4==1, in diag. mode
;
;-In diag. mode
;
	BRSET   L004F,#$80,LAD76	;Status word, bra if b7==1, engine running
;
;-Engine is off, turn on S/L 
;
	BRA     LAD8B			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check for mode 4 operation
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LAD76	BRCLR   L003B,#$10,LAD8E	;Status word, bra if b4==0, not in mode 4
;								
	LDX     #L0390+1		; $F4, ALDL MODE 4, DISRETE ENABLES
	BRCLR   0,X,#$01,LAD8E		; BR IF NOT b0, 1 = OVERSPEED LIGHT ENABLE 
;
	LDX     #$0392			; $F4, ALDL MODE 4, DISRETE STATES
	BRSET   0,X,#$01,LAD8B		; BR IF b0, 1 = OVERSPEED LIGHT ON 
;
	JMP     LAE03			;
;
LAD8B	JMP     LAE08			;
;
;
;
LAD8E	LDD     L3FE0			;
	PSHB    			;
	PSHA				;    
	SUBD    L0847			;
	STD     L0849			;
;
	PULA				;    
	PULB    			;
	STD     L0847			;
;
;-----------------------------------------------
; HIGH ET RATIOS FOR UPPER ENG RPM/TRANS RPM 
; OF A PAIR USED  
;
;  ESTABLISH CORRECT GEAR RANGE FOR SPECIFIED GEAR
;  TO SET SHIFT LIGHT TRIP POINT
;
;	MANUAL XMISSION & TH700R4
;-----------------------------------------------
;
	LDX     #L5109			;
	LDAA    L0006			; COOL
	CMPA    $0C,X			;
	BLS     LADF3			;
;
	LDAA    $0D,X			;
	LDAB    L0845			;
	CMPB    #$02			;
	BLS     LADB2			;
;
	LDAA    $0E,X			;
;
LADB2	CMPA    L01FC			; TPS
	BHI     LADF3			;
;
	LDAA    L02A7			; MPH/1
	CMPA    #$05			; 5 MPH
	BCS     LADF3			; BR IF Vss LT 5 MPH
;
	LDAA    L0062			; RPM/25
	CMPA    $0F,X			;
	BHI     LAE08			;
;
	CMPA    #40			;
	BCS     LADF3			;
;
	LDAB    #$01			;
	STAB    L0845			;
	PSHX				;
	LDD     #$0F			;
	LDX     L005F			;
	FDIV				;
	LDD     L0849			;
	LSRD				;
	ADDD    L0849			;
	XGDX				;
	IDIV				;
	PSHX				;
	PULA				;
	PULB				;
	STAB    L084B			;
	PULX				;
;
LADE4	CMPB    0,X			;
	BCC     LAE0D			;
;
	INC     L0845			;
	INX				;
	LDAA    L0845			;
	CMPA    #$05			;
	BCS     LADE4			;
;
LADF3	LDAA    L5119			;
	LDAB    L0845			;
	CMPB    #$02			;
	BLS     LAE00			;
;
	LDAA    L511A			;
;
LAE00	STAA    L0846			;
;
LAE03	BCLR    L0053,#$04		; CLR b2, SHIFT LIGHT ON
	BRA     LAE64			;				
;											
LAE08	BSET    L0053,#$04		; CLR b2, SHIFT LIGHT ON
	BRA     LAE64			;				
;											
LAE0D	LDAA    L0062			; RPM/25
	CMPA    4,X			;
	BLS     LADF3			;
;
	LDAA    8,X			;										;
	LDAB    L01FC			; TPS
	MUL				;
	ASLD				;
	BCS     LAE21			;
;
	ADDD    #128			;
	BCC     LAE23			;
;
LAE21	LDAA    #255			; FORCE MAX VALUE
;
LAE23	PSHA   
; 					
;--------------------------------------------------
; LK UP LOAD LMT Vs. RPM
; TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;---------------------------------------------------
;
	LDX     #L511B			; INDEX LOAD LMT Vs. RPM TBL
	LDAB    L0845			;
	CMPB    #$02			;
	BLS     LAE31			;
;
;--------------------------------------------------
; LK UP LOAD LMT Vs. RPM
; TH700R4, (NON-ELECTRONIC)
; USED BY UPSHIFT LIGHT CODE TO GET A TPS THRESH 
;
;--------------------------------------------------
;
	LDX     #L5131			; INDEX	LOAD LMT Vs. RPM
;										
LAE31	LDAB    #11			;
	BRSET   L0053,#$04,LAE38	; BR IF b2, SHIFT LIGHT ON
;
	ABX 				;
;
LAE38	LDAB    #40			;
	LDAA    L0062			; ENG RPM/25
	CMPA    #200			; 5000 RPM
	BCS     LAE42			; BR IF RPM LT 5000 RPM
;
	LDAA    #200			; FORCE 5000 RPM
;
LAE42	JSR     LF15A			; 2D LK UP W/OFFSET
;	
	PSHA				;
;
;--------------------------------------------------
; BARO CORRECTION TO TBL'S L5113 th L513E (ABOVE)
; TH700R4, (NON-ELECTRONIC)
;
;--------------------------------------------------
;
	LDAA    L01EF			; BARO
	LDAB    #96			; OFFSET VALUE
;											
;--------------------------------------------------
; BARO CORRECTION TO TBL'S L5113 th L513E (ABOVE)
; TH700R4, (NON-ELECTRONIC)
;
;--------------------------------------------------
;
	LDX     #L5147			; INDEX BARO CORRECTION TBL
	JSR     LF15A			; 2d LK UP W/OFFSET
;										
	PULB				;
	MUL				;
	ASLD				;
	BCC     LAE58			;
;
	LDAA    #255			; FORCE MAX VALUE
;
LAE58	PULB				;
	CBA				;
	BCS     LADF3			;
;
	LDAA    L0846			;
	BEQ     LAE08			;
;
	DECA				;
	BRA     LAE00			;
;
LAE64	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Non CC trans. TCC handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;							
LAE65	LDAA    L400F			;Opt. byte
	BITA    #$40			;Test b6, TCC (non CC trans)
	BNE     LAE6F			;Bra if ==1, using TCC 
;
	JMP     LAF16			;Skip routine				
;
;-Here if using TCC
;
LAE6F	LDAA    L02A7			;MPH
	LDAB    #205			;Scalar for lookup
	MUL				;MPH x scalar
	ASLA				;x2, now scaled to 10 mph increments for lookup
	LDX     #L515E			;Lower load limit for TCC to lock
	JSR     LF15E			;2D lookup
											
	TAB				;Load limit to lock TC into B
	LDX     #L5156			;Addr. of MPH limit for mand. TCC lockup
	BRCLR   L0085,#$20,LAE8B	;Status word, bra if b5==0, TCC unlocked
;
;-TCC locked here
;
	INX				;+1, MPH limit for TCC to remain in mand. lockup
	SUBB    L5151			;TPS hyst. for TCC locked
	BCC     LAE8B			;Bra if no underflow
;
	CLRB				;Clear underflow	
;
;-Here if TCC unlocked
;	
LAE8B	LDAA    L01FC			;%TPS
	CBA				;Compare %TPS to load limit to lock TC
	BCC     LAE99			;Bra if TPS >=
;
;-Here if TPS less then limit for TCC to lock
;
	LDAA    L5155			;Coast relock delay
	STAA    L0853			;Save it 
;
	BRA     LAF0D			;Bra to unlock TCC and return				
;
;-Check for manditory lockup speed
;
LAE99	LDAA    L02A7			;MPH
	CMPA    0,X			;Manditory TCC lockup speed
	BCS     LAEA2			;Bra if MPH less, no manditory lockup
;											
	BRA     LAF02			;Bra to lock the TCC and return				
;
;-Check cool temp quals
;											
LAEA2	LDAA    L0006			;Cool temp, linearized
	CMPA    L5150			;Lower temp limit for TCC lockup
	BCS     LAF07			;Bra if cool temp less, no TCC lockup
;
;-Check throttle opening/closing rate
;
	LDAA    L01FC			;%TPS
	SUBA    L0854			;Sub. %TPS, one delayed
	BCC     LAEB7			;Bra if TPS increasing/steady
;
;-Here if throttle closing
;
	NEGA				;Get abs. val. of delta TPS
	LDAB    L5152			;Delta throttle closing rate to force TCC to unlock
	BRA     LAEBA			;Bra to contine															
;
;-Here if throttle is opening
;
LAEB7	LDAB    L5153			;Delta throttle opening rate to force TCC to unlock
;
LAEBA	CBA				;Compare to delta TPS
	BHI     LAF07			;Bra if delta TPS >, unlock TCC
;
;-Check MPH thesholds
;
	LDX     #L515A			;TCC lock/unlock MPH thresholds
	CLRB				;
;
;-Check if A/C active
;
	BRCLR   L004D,#$01,LAEC7	;I/O port C, bra if no A/C 
;
;-A/C on, adv. to next set of thresholds
;
	INX				;+1
	INX				;+1, move to next set of thresholds
;
LAEC7	BRCLR   L0085,#$20,LAECC	;Bra if b5==0, TCC not commanded to lock
;
	INX				;+1, MPH threshold to unlock TCC
;
LAECC	LDAA    L02A7			;MPH
	CMPA    0,X			;Check threshold
	BLS     LAF07			;Bra if MPH <=, unlock TCC
;
;-Check TCC load limits to lock/remain locked
;
	LDY     #L5158			;Lower RPM limit for TCC to remain locked
	LDX     #L5167			;Addr. of load limit to remain locked vs. mph
	BRSET   L0085,#$20,LAEE3	;Bra if b5==1, TCC commanded to lock
;
;-TCC unlocked here
;
	LDX     #L5174			;Addr. of load limit to lock vs. mph
	INY				;+1, rpm limit for TCC lockup
;
LAEE3	ABX				;Add in offset in B, if present
	LDAB    #205			;Scalar for MPH
	MUL				;Scalar x MPH
	ASLA				;x2
	ASLA				;x2, MPH now in 5 mph increments
	LDAB    #64			;20 MPH offset
	JSR     LF15A			;2D lookup with SBA
;											
	CMPA    L01FC			;Compare to %TPS
	BCS     LAF07			;Bra if TPS >, no lockup
;
;-Check RPM limit
;
	LDAA    L0063			;RPM/12.5
	CMPA    0,Y			;Compare to limit
	BCS     LAF07			;Bra if RPMs are less, unlock TCC
;
;-Check time delay to lock
;											
	LDAA    L0853			;TCC relock delay timer
	BEQ     LAF02			;Bra if ==0, allow TCC to lock
;
	DECA				;-1 from timer
	BRA     LAF0A			;Bra to save and return				
;
;~~~~~~~~~~~~~~~~~~~~~
; Here if lockup ok'd
;~~~~~~~~~~~~~~~~~~~~~
;
LAF02	BSET    L0085,#$20		;Status word, set b5, TCC commanded to lock
	BRA     LAF10			;bra to return															
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; HHere if lockup not ok'd
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LAF07	LDAA    L5154			;Time delay to relock TCC
;
LAF0A	STAA    L0853			;TCC relock delay timer
;
LAF0D	BCLR    L0085,#$20		;Clear b5, No TCC lockup
;	
LAF10	LDAA    L01FC			;%TPS
	STAA    L0854			;Save it, %TPS, one delayed
;
LAF16	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     				   			  
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check VATS
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LAF17	LDAA    L400D			;Opt. byte
	BITA    #$40			;Test b6
	BEQ     LAF3C			;Bra if not using VATS
;
;-Vats in use here
;
	BRSET   L003D,#$02,LAF3F	;Status word, bra if b1==1, VATS passed
;
	LDX     L3012			;Load TIC 2 timer val
	PSHX				;Push to stack
	PULA				;Get into AB
	PULB				;
;
	SUBD    L0851			;Previous stored TIC 2 timer val
	BEQ     LAF3F			;Bra if result ==0, VATS freq. =0
;
	STX     L0851			;Save as previous TIC 2 result
	CPD     L5181			;Upper period limit for VATS freq.
	BHI     LAF3F			;Bra if period greater, VATS fail
;
	CPD     L5183			;Lower period limit for VATS freq.
	BCS     LAF3F			;Bra if less, VATS fail
;
;-VATS passed
;
LAF3C	BSET    L003D,#$02		;Set b1, VATS passed
;
;-Here if VATS failed
;
LAF3F	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
;~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~
;
LAF40	JSR     LAF5C			;
;
	JSR     LAF62			;
;
	JSR     LB106			;Routine to check for manual 2nd gear select
;
	JSR     LB12A			;
;
	JSR     LB291			;
;
	JSR     LB2DD			;
;
	JSR     LB375			;
;
	JSR     LF42B			;
;
	JSR     LF2EB			;
;
	RTS     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LAF5C	JSR     LB35E			; GET ERR 24 DEFAULT RATIOS
;
	STX     L00F3			; SAVE RATIOS 
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LAF62	BCLR    L0076,#$80		;
	LDAA    L3000			; PORT A
	BITA    #$40			; b6
	BEQ     LAF6F			; BR IF NOT b6
;
	BSET    L0076,#$80
;
LAF6F	LDAB    L3002			; PORT G
	COMB				;    
	ANDB    #$0F			;
	LDAA    L3060			; 
	EORA    L3062			; TOGGLE I/O PORT D
	ANDA    #$03			;
	ASLA				;   
	ASLA				;
	ASLA				;
	ASLA				;    
	ABA				;     
	STAA    L0098			;
	LDX     #L004B			;
	LDAB    L00D3			; GEAR NUMBER 
	CMPB    #0			;
	BNE     LAF9B			; BR IF NON Z
;
	BRCLR   0,X,#$08,LAF96		; BR IF NOT b3
;
	BSET    L0084,#$10		; SET b4
	BRA     LAFB5			;
;
LAF96	BCLR    L0084,#$10		; CLR b4
	BRA     LAFB5			;
;
LAF9B	BRSET   0,X,#$08,LAFAB		; BR IF b3, 
;
	BRCLR   L0084,#$08,LAFA6	; BR IF MOT b3, 
;
	BSET    L0084,#$10		; SET b4
;
LAFA6	BCLR    L0084,#$08		; SET b3
	BRA     LAFB5			;
;
LAFAB	BRSET   L0084,#$08,LAFB2	; BR IF b3, 
;
	BSET    L0084,#$10		; SET b4
;
LAFB2	BSET    L0084,#$08		; SET b3
;
LAFB5	LDX     #L004B			;
	BRSET   0,X,#$80,LAFC5		; BR IF b7, 
;
	BRSET   0,X,#$04,LAFCE		; BR IF b2, 
;
	BCLR    L0085,#$02		; CLR b1, TCC ENABLE SOLENIOD VALID
	BRA     LAFD1			;
;
LAFC5	BRCLR   0,X,#$04,LAFCE		; BR IF NIT b2
;
	BCLR    L0085,#$02		; CLR b1, TCC ENABLE SOLENIOD
	BRA     LAFD1			;
;
LAFCE	BSET    L0085,#$02		; SET b1, TCC ENABLE SOLENIOD
;
LAFD1	LDAA    L0096			;
	STAA    L0097
	BCLR    L0096,#$04		; CLR b2, 
;
;----------------------------------    
; AFR MD WORD 0,	
; 	b5 1 = PWR ENR IS ACTIVE   
;---------------------------------- 
;
	BRCLR   L003D,#$20,LAFDF	; CLR b5
;
	BSET    L0096,#$04		; SET b2, 
;
LAFDF	BCLR    L0096,#$80		; CLR b7, 
	BRCLR   L0050,#$10,LAFED	; bR IF NOT b4, DIAG SW IN DIAG POSIT.
;
	BRSET   L0082,#$80,LAFED	; BR IF b7, 
;
	BSET    L0096,#$80		; SET b7, 
;
LAFED	LDY     #L5D02			;	
;
;--------------    
; I/O PORT C     	
;--------------
;  
	LDAB    L004D			; I/O PORT C
	TBA				; B --> A
	EORA    L0095			;
	STAB    L0095			;
	BITA    #$01			;
	BEQ     LB001			; BR IF NOT b0, 
;
	BRSET   1,Y,#$04,LB00B		; BR IF b2, (1 = Filter A/C input) 
;													
LB001	BCLR    L0096,#$02		; CLR b1
	BITB    #$01			; b0
	BEQ     LB00B			; BR IF NOT b0
;
	BSET    L0096,#$02		; SET b1
;			
LB00B	BITA    #$80			; b7
	BEQ     LB01C			; BR IF NOT b7
;
	XGDX				;
	LDAA    L5D23			; 4 sec DISABLE ERR 72 4 SEC DURING 4WD 
	STAA    L019C			; ERR 72 TIMER
	XGDX				;  
	BRSET   1,Y,#$10,LB026		; BR IF b4, (1 = Filter 4 wheel drive low input)  
;
LB01C	BSET    L0096,#$20		; SET b5, 
;									
	BITB    #$80			; b7
	BEQ     LB026			; BR IF NOT b7
;
	BCLR    L0096,#$20		; CLR b5, 
;								
LB026	TST     L019C			; ERR 72 TIMER
	BEQ     LB02E			; BR IF TIMER = Z
;
	DEC     L019C			; DECR ERR 72 TIMER
;										
LB02E	BITA    #$1C			; 0001 1100
	BEQ     LB037			;
;
	BRSET   1,Y,#$02,LB054		; BR IF b1, (1 = Filter pattern inputs)
;
;-----------------------------------------
; 8 LINE TABLE 
; INDEXED LK UP AT LB03B
; WASXXX
;----------------------------------------- 
;
LB037	ANDB    #$1C			; 0001 1100
	LSRB				; SHIFT LEFT 2 PL
	LSRB				;
	LDX     #LB0FE			; INDEX A 8 LINE TABLE
	ABX				; ADJ INDEX 
	LDAB    0,X			; GET VAL FM TABLE
;	
	LDAA    L009B			;
	INCA				;
	BEQ     LB048			; BR IF Z
;
	STAA    L009B			;
;											
LB048	LDAA    L009C			; PRNDL
	STAA    L009D			;
	CBA				;
	BEQ     LB054			; BR IF B = A
;
	CLR     L009B			;
	STAB    L009C			; PRNDL
;										
LB054	LDAB    L0076			;
	TBA				;
	EORA    L0077			;
	STAB    L0077			;
	BITA    #$80			; b7
	BEQ     LB064			; BR IF NOT b7
;
	BRSET   1,Y,#$08,LB06E		; BR IF b3,
;
LB064	BSET    L0096,#$40		;
	BITB    #$80			; b7
	BEQ     LB06E			; BR IF NOT b7
; 
;---------------------
;
;---------------------
;
	BCLR    L0096,#$40		; CLR b6
;											            
LB06E	LDD     #0120			;
	LDX     L005F			; LAST DRP PERIOD
	FDIV				;   
	XGDX				;    
	CPD     #0120			;
	BHI     LB07D			;
;
	CLRA				; 	   
	CLRB				;    
LB07D	STD     L00B1			;
;
	LDD     L00F3			;
	LDX     L00CB			; XMISH OUTPUT SPD
	JSR     LF23F			;16 x 16 mult. routine
;
	ASLD				;x2    
	BCS     LB096			;
;
	ASLD				;    
	BCS     LB096			;
;
	XGDX				;    
	ROLA				;    
	ROLA				;    
	ROLA				;    
	ANDA    #$0003			;
	TAB				;     
	ABX				;     
	BRA     LB099			;
;
LB096	LDX     #$FFFF			;
;
LB099	STX     L00B7			;
	STX     L00BE			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Determine transmission output shaft speed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L3FE0			;TOS pulse accumulator
	LDY     #L3FC2			;TOS 65,536 Hz free running counter, captured					;on each edge detected
;
; SPD SENSOR SOURCE 
; 0010 0001 
;	b0 1 = Allow tps hist buffer every 25 Msec 
;	b5 1 = Force 2nd Gr if in D2 and not manual
;
;      b4, 0 = Output speed from dig. ratio adaptor.			
;
	LDAA    #$10			; b4
	BITA    L5D02			;Opt. byte, test b4 
	BEQ     LB0B2			;Bra if ==0, speed from dig. ratio adaptor
;
	LDX     #L3FC6			;Alternate TOS PA
	LDY     #L3FF8			;Alternate TOS counter
;
LB0B2	SEI				;Disable interrupts     
	LDD     0,X			;Load accumulated pulse counts
	JSR     LF08A			;Short delay
;
	PSHY				;Push counter value to stack    
	LDY     0,Y			;Load counter value
	JSR     LF08A			;Short delay
;
;-Check to see if another pulse has been recieved since accumulated TOS counts loaded
;
	CPD     0,X			;Compare acc. counts to current 
	BEQ     LB0D0			;Bra if accumulated counts have not changed
;
;-Another edge has been detected
;
	JSR     LF08A			;Short delay
;
	PULY				;Get counter addr. back off stack    
	LDY     0,Y			;Update free running counter value
	INCB				;+1, accumulated counts
	BRA     LB0D2			;Bra to continue
;
;-Here if no new edge detected
;
LB0D0	INS				;+1    
	INS				;+1, clean up stack   
;
;-Save the counter values
;
LB0D2	LDX     #L00C2			;Start addr. of stored TOS params
	STAB    8,X			;Store accumulated pulse counts at L00CA
	STY     6,X			;Store captured free running counter val. 
					;at L00C8,C9
	CLI				;Renable interrupts     
	LDY     #L00C2			;Addr. of accumulated pulse counts
	LDX     L5D13			;# pulses per revolution
	LDAB    L5D12			;Max time to wait for TOS signal
;
	JSR     LE34C			;Routine to calculate transmission output
;
;-Check if 4WD low is in use
;
	BRCLR   L0096,#$20,LB0FB	;Status word, bra if b5==0, no 4WD low
;
;-4WD low is in use
;
	LDX     L5D16			;Load 4WD low ratio reduction
	JSR     LF23F			;16 x 16 mult. routine
;
	ASLD				;x2
	BCS     LB0F8			;Bra if no overflow
;
	ASLD				;x2, now result/16384
	BCC     LB0FB			;Bra if no overflow
;
LB0F8	LDD     #$FFFF			;Clear overflow
;
;-Here to save trans output rotational speed
;
LB0FB	STD     L00C6			;Save it, trans output speed
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;-----------------------------------------
; 8 LINE TABLE 
; INDEXED LK UP AT LB03B
;
;----------------------------------------- 
LB0FE	FCB	$88	 	;
	FCB	$08	 	;
	FCB	$88	 	;
	FCB	$04	 	;
	FCB	$20	 	;
	FCB	$40	 	;
	FCB	$01	 	;
	FCB	$02	 	;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for manual 2nd gear select
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB106	LDAA    L0099			;Trans shift pattern word
	STAA    L009A			;Previoud trans shift pattern 
;
	CLR     L0099			;Preclear trans shift pattern
;
	LDX     #L5D02			;Opt byte
	BRCLR   0,X,#$20,LB121		;Bra if b5==0, not forcing 2nd gear when in manual D2
;
	BRSET   L0092,#$04,LB121	;Bra if b2==0, trans. press. switch. error
;
;-Here if no errors, check for manual second
;
	BRCLR   L009C,#$02,LB121	;Bra if not in second gear
;
	BSET    L0099,#$04		;Set b2, manual pattern requested
	BRA     LB124			;Bra to return
;
	BSET    L0099,#$01		;Set b0, normal pattern requested 
;
LB124	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~
;   
LB125	FCB	$09		;
LB126	FCB	$01		;
LB127	FCB	$02		;
LB128	FCB	$04		;
LB129	FCB	$09		;
;
;*********************************************** 
;*
;*
;*
;***********************************************
;
LB12A	JSR     LE677			;
;
	JSR     LEA7B			;
;
	JSR     LE4BA			;
;
	BRCLR   L0092,#$04,LB13B	;Status word, bra if b4==0

	LDAA    #$88			; 1000 1000
	STAA    L009C			;
;											;
LB13B	LDX     #L5B00			; INDEX DIAGNOSTIC MODE WORD MASKS
	LDAA    L0099			; 
	BRCLR   $32,X,#$20,LB14E	; $5B32, BR IF NOT b5, ERR 77, MNP SWITCH 
;										; .. else
LB144	BRCLR   L001D,#$20,LB14E	; BR IF NOT b5
;
	ANDA    #$F0			; 1111 0000
	ORAA    #$09			; b3 & b0
	BRA     LB15D			;				
;
LB14E	BITA    #$04			; b2
	BEQ     LB15F			; BR IF NOT b2
;										 	; ... else
	BRSET   L0092,#$04,LB15B	; BR IF NOT b2
;
	LDAB    L5D0D			; 0, NON Z TO DISABLE MANUAL MODE <----****
	BEQ     LB15D			; BR IF Z					
;
LB15B	EORA    #$05			
;
LB15D	STAA    L0099			;
;
LB15F	JSR     LE576			;
;
	JSR     LE5B7			;
;
	JSR     LE38F			;
;
	JSR     LE96F			;
;
; CK DIG I/O MD WD
;
	LDX     #L400F			; MODE WD, DIG I/O
	BRSET   0,X,#$80,LB175		; BR IF b7, 1 = MAN, (0 = TCC)
;
	JSR     LE5F6			; 
;
; here if manual xmish 
;
LB175	JSR     LEDD4			; EXIT VIA RTS
;
	JSR     LE930			;
;
	JSR     LE3CB			;
;
	JSR     LE4A4			;
;
	JSR     LE3B1			;
;
	RTS				;Return     
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; TPS handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~
;
;-Check for TPS errors
;
;-Check for error 21, high TPS
;
LB185	LDX     #L5B00			;Start addr. of diag masks	
	BRSET   L0092,#$01,LB1B5	;Status word, bra if b0==1, Trans. TPS error flagged
;
	BRCLR   $2B,X,#$01,LB199	;Error mask, bra if b0==0, not setting error 21, High TPS
;
	BRSET   $34,X,#$01,LB199	;Alt. error mask, bra if b0==1, not setting error 21. 
;
	LDAA    L015B			;Error 21 timer
	BNE     LB1A6			;Bra if !=0
;
;-Check for error 22, low TPS
;
LB199	BRCLR   $2C,X,#$80,LB1B7	;Error mask, bra if b7==0, not setting error 22, TPS high
;
	BRSET   $35,X,#$80,LB1B7	;Alt. mask, bra if b7==1, not setting error 22

	LDAA    L015C			;Error 22 timer
	BEQ     LB1B7			;Bra if ==0, continue normally 
;
;~~~~~~~~~~~~~~~~~~~
; Here if TPS error 
;~~~~~~~~~~~~~~~~~~~
;
LB1A6	LDX     #L5D02			;Option byte
	BRCLR   0,X,#$01,LB1B2		;Bra if b0==0, dont allow TPS hyst. buffer every 25 msecs
;
;-Use four delayed TPS here
; 
	LDAA    L019B			;%TPS, four delayed
	BRA     LB219			;Bra
;
LB1B2	JMP     LB223			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if trans TPS error set 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB1B5	BRA     LB213			;Bra to load defaults
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Here if no TPS error flagged, check and filter closed TPS down to lowest A/D reading
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB1B7	LDAA    L00A0			;A/D TPS
	CMPA    L0319			;Base TPS for closed throttle
	BHI     LB1CD			;Bra if A/D TPS is
;
;-Filter base TPS down to A/D TPS
;
	LDAB    #128			;Set LSB
	LDX     L0319			;Base TPS for closed throttle
	LDY     #L5B25			;%TPS filter coeff.
	JSR     LF0D3			;Lag filter routine
;
	STD     L0319			;Save it, base TPS
;
;-Here if throttle kicker TPS was less
;
LB1CD	LDAA    L00F1			;MPH, one delayed
	SUBA    L00D1			;MPH, filtered
	BCC     LB1D8			;Bra if speed decreasing
;
;-Here if speed increasing
;
	BCLR    L0094,#$04		;Status word, clear b4, will be adding TPS on decel
	BRA     LB201			;Bra
;
;-Here if speed decreasing
;
LB1D8	BRSET   L0094,#$04,LB201	;Bra if b2==1, already added in decel TPS
;
	BRSET   L0018,#$02,LB201	;Error word #5, bra if b1==1, error 37, TCC brake switch stuck on.
;
	BRSET   L0018,#$01,LB201	;Error word #5, bra if b0==1, error 38, TCC brake switch stuck off
;
	BRCLR   L0096,#$01,LB201	;Bra if kickdown not ok'd

	CMPA    L5B2A			;Threshold for bumping idle TPS
	BLS     LB205			;Bra if MPH less
;
;-Speed greater then 5 mph here and speed decreasing, increase throttle kicker TPS
;
	LDAA    L0319			;Base TPS for closed throttle
	ADDA    L5B29			;Additional TPS when in decel		
	CMPA    L5B24			;Max value for idle TPS
	BLS     LB1FB			;Bra if less
;
	LDAA    L5B24			;Load max
;
LB1FB	STAA    L0319			;Idle TPS
	BSET    L0094,#$04		;Set b1, additional TPS added in for decel
;
;-Here if speed increasing
;
LB201	LDAA    L00D1			;Filtered MPH
	STAA    L00F1			;Save it, MPH, one delayed
;
;-Shuffle %TPS values
;
; %TPS -> %TPS, one delayed -> %TPS, two delayed -> %TPS, three delayed -> %TPS, four delayed
;
LB205	LDD     L0199			;%TPS, two delayed/three delayed
	STD     L019A			;Save it, %TPS, three delayed/four delayed
	LDD     L0197 			;Current TPS/TPS, one delayed
	STD     L0198			;Save it, TPS, one delayed/two delayed
	BRA     LB219			;Bra
;
;-Here to load default TPS value if error
;
LB213	LDAA    L5B22			;Default TPS
	CLRB    			;Clear LSB
	BRA     LB221			;Bra to save
;
;-Here if no error
;
LB219	LDX     L00AA			;Trans. TPS
	LDAB    L5B28			;Filter coeff for trans. TPS
	JSR     LF0F6			;Filter routine
;
LB221	STD     L00AA			;Store it, trans. TPS

LB223	LDAA    L00AA			;Trans %TPS
	SUBA    #128			;Subtract 50% TPS
	ADDA    L0101			; (???)
	BVC     LB230			;Bra if no 2's comp. overflow
;
;-Clear 2's overflow
;
	LDAA    #$7F			;Load max signed %TPS
	ADCA    #$00			;Perform carry if needed
;
LB230	ADDA    #128			;Add 50% tps back in
	STAA    L00AC			;Save trans %TPS
;
;-Check kickdown
;
	LDAB    L5D1C			;90.2% TPS, threshold to disable kickdown 
	BRSET   L0096,#$10,LB23E	;Bra if kickdown enabled
;
	LDAB    L5D1B			;90.2% TPS, threshold for kickdown 
;
LB23E	BCLR    L0096,#$10		;Clear b4, kickdown enable
;											
	CMPB    L00AA			;Trans. TPS
	BCC     LB24C			;Bra if TPS <=
;
;-TPS above threshold, enable kickdown if no manual pattern requested
;											
	BRSET   L0099,#$04,LB24C	;Bra if b2==1, manual pattern requested 
;
	BSET    L0096,#$10		;Set b4, enable kickdown
;											
LB24C	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; TPS self calibration routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB24D	LDAA    L00A0			;A/D TPS
	CMPA    L0319			;Base TPS for closed throttle
	BLS     LB26F			;Bra if A/D TPS <= base %TPS, return
;
;-Filter idle TPS if A/D TPS >
;
	LDAB    #128			;Use 128 as LSB of filtered value
	LDX     L0319			;Old %TPS
	LDY     #L5B27			;TPS filter coeff.
	JSR     LF0D3			;Lag filter routine
;
	STD     L0319			;Save it, filtered base TPS
	CMPA    L5B24			;Max val. for %TPS
	BCS     LB26F			;Bra if <
;
	LDAA    L5B24			;Load max
	CLRB    			;
	STD     L0319			;Save it, Base TPS for closed throttle
;
LB26F	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to construct TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB270	LDD     L0319			;Throttle kicker TPS
	ADDD    #128			;Round if needed
	TAB				;Throttle kicker TPS to B     
	LDAA    L00A0			;Load A/D TPS
	SBA				;Subtract idle TPS from A/D TPS    
	BCC     LB27D			;Bra if no underflow

	CLRA				;Clear underflow 
;  
;-Scale TPS for save
;
LB27D	LDAB    L5B26			;Scalar for TPS
	MUL				;TPS x scalar 
	ADDD    #32			;Round if needed
	ASLD				;x2
	BCS     LB28A			;Bra if overflow
;
	ASLD				;x2   
	BCC     LB28D			;Bra if overflow
;
LB28A	LDD     #$FFFF			;Clear overflow
;
;-TPS = (L5B26 x (A/D TPS-base TPS)/64
;
LB28D	STAA    L0197			;Current TPS
	RTS 				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-----------------------------------
; speed sensor calibration param's
;
; ECM $0D
;-----------------------------------
;
;------------------------
; RPM FILTER
;------------------------
;
LB291	LDD     L00B1			;
	LDX     L019D			; RPM * 8
	LDY     #L5D0F 			; 87 msec, RPM filter
	JSR     LF0D3			; TRANSMISSION LAG FILTER ROUTINE
;
	STD     L019D			; RPM * 8
;
;-------------------------
; INPUT SPD FILT
;-------------------------
;
	LDD     L00B7			;
	LDX     L00BC			;
	LDY     #L5D10			; 6.3 msec, INPUT SPD FILTER
	JSR     LF0D3			; TRANSMISSION LAG FILTER ROUTINE
;
	STD     L00BC			; FILT TIS
;
;------------------------
; XMISH Input spd filter 
;------------------------
;
	LDD     L00BE			;
	LDX     L00C0			; TIS
;
LB2B1	LDY     #L5D11			; 6.3 msec, XMISH INPUT SPD FILTER
	JSR     LF0D3			; TRANSMISSION LAG FILTER ROUTINE
;
	STD     L00C0			; FILT TIS
;
	LDD     L00B1			;
	SUBD    L00BE			;
	RORA				;    
	ROLA				; 	   
	BVC     LB2C9			;
	LDD     #32767			;
	ADCB    #$0000			;
	ADCA    #$0000			;
;
;---------------------------------------------
; FILT TCC SLIP 
;---------------------------------------------
;
LB2C9	LDX     L00E5			; TCC SLIP 
	LDY     #L5D0B			; 110 msec, converter slip filter, 2 MSEC/bit)
	JSR     LF0BD			; FILT
;
	STD     L00E5			; TCC SLIP 
	BPL     LB2DA			; BR IF 
;
	NEGA				;    
	NEGB				;    	
	SBCA    #$00			; PREVENT OVERFLOW
;
LB2DA	STD     L00E7			; NEG TCC SLIP
	RTS				;Return     	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB2DD	BRCLR   L0093,#$04,LB2FF	;Status word, bra if b2==0, no loss of output speed
;
;-Error, generate default output speed
;
	JSR     LB35E			;Read in gear ratio
;
;-Output speed = (RPM x 4 / ratio) x 65536
;
	LDD     L00B1			;RPM x 8
	LSRD				;/2    
	LSRD				;/2
	FDIV				;frac. divide
	XGDX				;Get result into D
	BRCLR   L0096,#$20,LB318	;Status word, bra if b5==0, not in 4WD
;
;-In 4WD here
;
	LDX     L5D16			;Additiona reduction ratio for xfer case
	JSR     LF23F			;16 x 16 multiply routine
;
	ASLD				;x2    
	BCS     LB2FA			;Bra if overflow
;
	ASLD				;x2    
	BCC     LB318			;Bra if no overflow
;
LB2FA	LDD     #$FFFF			;Clear overflow
	BRA     LB318			;Bra to save and continue
;
;-Here if no error
;
LB2FF	LDAA    L015D			;Error 24 timer, VSS
	ORAA    L016E			;Error 72 timer, output speed loss
	BNE     LB316			;Bra if !=0
;
;-No errors pending here
;
	LDD     L00C6			;
	LDX     L00CD			; TOS
	BRSET   L0082,#$08,LB312	;Status word, bra if b3==1, ignition is on
;
	LDX     #$0000			;
;
LB312	STX     L00CF			;
	BRA     LB318			;
;
LB316	LDD     L00CF			;
;
LB318	STD     L00CB			; XMISH OUTPUT SPD
;
;-Transmission output speed filter
;
	LDX     L00CD			;TOS
	LDY     #L5D15			;Trans. output speed filter coeff.
	JSR     LF0D3			;Filter routine
;
	STD     L00CD			;Save it, TOS
;
;--------------------------
;  NO/VS RATIO
;  VAL = RATIO * 1024
;--------------------------
;
	LDD     L00CD			; TOS
	LDX     L5D18			; 44.7:1 NO/VS RATIO <-------*
	FDIV				;    
	XGDX				;    	
	SUBA    #128			;
	ADDA    L0102			;
	BVC     LB33A			; BR IF 
;
	LDD     #32767			; FORCE MAX VAL 32,767
	ADCB    #0			;
	ADCA    #0			;
;
LB33A	ADDA    #128			;
	ADDD    #128			;
	BCC     LB344			;
;
	LDD     #$FFFF			;
;
LB344	STD     L0814			;
;
;-----------------------
;  Vss filter
;
;-----------------------
;
	LDX     L00D1			; Vss
	LDY     #L5D1A			; 6.3 msec, Vss filter
	JSR     LF0D3			; TRANSMISSION LAG FILTER ROUTINE
;
	STD     L00D1			; FILT  Vss
	LDAB    L00D1			; Vss
	CLRA				;    
	XGDX				;
	LDD     L019D			; RPM * 8
	IDIV				;    
	STX     L0190			;
;
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to fetch trans gear ratios
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB35E	LDX	L5B43			;Load ratio for reverse gear 
	BRSET   L009C,#$20,LB374	;Bra if b5==1, in reverse
;
	LDX     #L5B49			;Trans ratios for gears 1st-4th
	LDAB    L00D3			;Load gear number 
	BRCLR   L0092,#$04,LB370	;Status word, bra if b2==0, no press. switch. man. error
;
;-Error, load default gear #
;
	LDAB    #2			;Error, load 1st as default
;
LB370	ASLB				;x2 for 16 bit addr. 
	ABX				;Add in offset     
	LDX     0,X			;Load gear ratio
;
;-Here if in reverse
;
LB374	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Look up force motor 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Trans temp value for lookup = (trans temp x 8)/256, limit value to <8 for indexed lookup
;
LB375	LDAA    L00AF			;Trans temp, filtered
	LDAB    #08			;8, scale for table lookup
	MUL				;Trans temp x 8     
	SUBD    #01			;-1
	BLT     LB384			;Bra if < 0
;
	CMPA    L014C			;Previously stored result
	BGE     LB38C			;Bra if >= previously stored result, save
;
;-Here if trans temp = -40 deg C or XXX < previously stored result 
;
LB384	ADDD    #17			;+17, 1.5 deg C hyst.
	CMPA    L014C			;Previously stored result		
	BGE     LB38F			;Bra if >= previously stored result, dont save
;
;-Here if trans temp > stored value or temp difference less then 1.5 deg C
;
LB38C	STAA    L014C			;Save it, trans temp value used for lookup
;
LB38F	LDAB    L014C			;Load in stored temp value
	LDX     #LB3A5			;Get table addr.
	ABX				;Add in offset     
	LDAA    0,X			;Load table value
	STAA    L014D			;Save it
	LDAA    8,X			;Load value 8 bytes ahead
	STAA    L014E			;Save it
	RTS 				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;--------------------------------------------------
;
;                                
;--------------------------------------------------
;
LB3A1  FCB   3			;
LB3A2  FCB   2			;
LB3A3  FCB   0			;
LB3A4  FCB   1			;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Force motor 
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	val.			;Deg C			
;
LB3A5	FCB   70		;-40
	FCB   64     		;-16
	FCB   60    		;  8
	FCB   58     		; 32
	FCB   54     		; 55
	FCB   52     		; 80
	FCB   52     		;103
	FCB   52     		;127
;
	FCB   41     		;-40
	FCB   35     		;-16
	FCB   31     		;  8
	FCB   28     		; 32
	FCB   24     		; 55
	FCB   21     		; 80
	FCB   19     		;103
	FCB   17    		;127
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;

LB3B5	LDX	#L400F			;	   
	BRCLR   $0C,X,#$18,LB3C8	; BR IF NOT b3 & b4
	BRCLR   L0011,#$CE,LB3F7	; 1100 0111
	SEI				;
;     
;-----------------------------------------------
; CK IF TCC FOR TH700
;
; JSR HER FM L7
;-----------------------------------------------
;
;  DIG I/O MODE WD, 0000 1000
;
	BRCLR   0,X,#$C0,LB3BE		; IF BIT 7 & 8 SET
					;
					; b7 1 = MAN, (0 = TCC)
					; b6 1 = TCC (Non Elect xmish)
					;                    
	BRA     LB3C7			; EXIT via RTS
;
LB3BE	JSR     LB3C8			; CK POWER TRAIN MOTION PARAMS
;
	JSR     LB3FB			;
;
	JSR     LB486			;
;
LB3C7	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-------------------------------------------------
; CK POWER TRAIN MOTION PARAMS
;
;-------------------------------------------------
;
LB3C8	LDD     L019D			;Trans output RPM x 8	
	CPD     L5D1D			;Min RPM for powertrain to be in motion
	BCC     LB3F4			;Bra if trans output rpm >
;
	LDD     L00CD			;Trans. output speed
	CPD     L5D1F			; 8191.9 RPM VEH SPD MIN 
;											; FOR POWER TRAIN IN MOTION
	BCC     LB3F4			;
;
	LDD     L00C0			;
	CPD     L5D21			;
	BCC     LB3F4			;
;
	BRCLR   L0082,#$80,LB3FA	;
;
	INC     L00FA			;
	LDAA    L5D0C			;
	CMPA    L00FA			;
	BCC     LB3FA			;
;
	BCLR    L0082,#$80		;
;
	BRA     LB3FA			;
;
LB3F4	CLR     L00FA			;
;
LB3F7	BSET    L0082,#$80		;
;
LB3FA	RTS				;     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-------------------------------------------------
;
;
;
;-------------------------------------------------
;
LB3FB	CLR     L01C9			;
	LDAA    L01CA			;
	STAA    L01CD			;
;
	LDD     L01CB			;
	STD     L01CE			;
;
	LDX     #L019D			; RPM * 8
;
LB40D	INX				;     
	INX				;     	
	PSHB				;    
	LDAB    L01C9			;
	INCB				;    
	CMPB    L5D0E			;
	BEQ     LB426			;
;
	STAB    L01C9			;
	PULB				;    
	SUBD    0,X			;
	BCC     LB424			;
;
	DEC     L01CA			;
;
LB424	BRA     LB40D			;
;
LB426	PULB				;    
	STD     L01CB			;
	LDD     L019D			; RPM * 8
	ADDD    0,X			;
	PSHB				;    
	BCC     LB43D			;
;
	LDAB    L5D0E			;
	DECB				;    
	LSRB				;    
	ADDB    L01CA			;
	STAB    L01CA			;
;
LB43D	LDAB    L5D0E			;
	DECB				;   
	LSRB				;    
	PSHB				;    
	MUL				;     
	ADDD    L01CA			;
	STD     L01CA			;
	PULA				;    
	PULB				;    
	MUL				;     
	ADDD    L01CB			;
	STD     L01CB			;
	BCC     LB458			;
;
	INC     L01CA			;
;
LB458	LDD     L01CA			;
	LSRD				;    
	LSRD				;    
	LSRD				;    
	ADCB    #$0080			;
	STAB    L01D0			;
	BSET    L0081,#$01		;
;
	LDD     L01CA			;
	CPD     L01CD			;
	BLS     LB472			;
;
	BCLR    L0081,#$01		;
;
LB472	LDX     #L019B			;
	LDAB    L5D0E			;
	ASLB				;    
	ABX				;
;     
LB47A	LDD     0,X			;
	STD     2,X			;
	DEX				;     
	DEX				;     
	CPX     #L019D			; RPM * 8
	BCC     LB47A			;
;
	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
;-------------------------------------------------
;
;
;-------------------------------------------------
;  
LB486	LDAB    L00D5			;
	INCB				;
	BEQ     LB48D			;
;								
	STAB    L00D5			;
;
LB48D	BRSET   L0081,#$02,LB4DD	;
;										
	BRCLR   L007F,#$09,LB4E8	;
;									
	BSET    L0081,#$02		;
	BCLR    L0081,#$91		;
	BCLR    L007F,#$12		;
	BRCLR   L007F,#$01,LB4A5	;
;							
	BSET    L007F,#$02		;
LB4A5	BRCLR   L007F,#$08,LB4AC	;
;							
	BSET    L007F,#$10		;
;
LB4AC	BCLR    L008A,#$08		;
;										
	LDAA    L009B			;
	BNE     LB4B6			;
;										
LB4B3	BSET    L008A,#$08		;
;									
LB4B6	LDAA    L00D5			;
	STAA    L0181			;
	CLRA				;
	STAA    L00D4			;
	STAA    L00D5			;
	STAA    L00F7			;
	LDAA    #$007F			;
	STAA    L00D9			;
	STAA    L00DA			;
	CLRA				;
	LDAB    L009A			;
	EORB    L0099			;
	ANDB    #$0007			;
	BEQ     LB4D3			;
;
	LDAA    #$0001			;
;
LB4D3	STAA    L008B			;
	CLRA				;
	STAA    L008C			;
	LDAA    L00AC			;
	STAA    L018B			;
;
LB4DD	BRSET   L007F,#$01,LB4E8	;
;									
	BRSET   L007F,#$08,LB4E8	;
;									
	BCLR    L0081,#$02		;
;								
LB4E8	BRSET   L0081,#$80,LB552	;
;									
	LDAA    L00D5			;
	SUBA    L00D4			;
	STAA    L00D6			;
	LDAB    L00D3			; GEAR NUMBER 
	BRSET   L007F,#$02,LB504	; BR IF b1
;
	LDAA    L00D5			;
	LDX     #L5FE6			; 
	ABX				;
	CMPA    0,X			;
	BCS     LB552			;
;										
	BRA     LB549			;
;									
LB504	LDX     #L5FCF			; 2.0 SEC'S  TIME  SUB'ED PERIOD FOR NEXT LINE
	ASLB				;
	ABX				;
	LDD     L01CA			;
	BRSET   L0081,#$10,LB524	;
;						
	BRCLR   L0081,#$01,LB51E	;

	CPD     0,X			;
	BGE     LB51E			;
;
	BSET    L0081,#$10		; SET b4, 
	BRA     LB52D			;				
;										
LB51E	LDAA    L00D5			;
	STAA    L00D4			;
	BRA     LB52D			;				
;											
LB524	BRSET   L0081,#$01,LB52D	;
;
	CPD     6,X			;
	BGT     LB543			;
;
;-----------------------------    
; TCC MODE WD	     
;
;  b6 1 = TCC IS BEING APPLIED    
;  b5 1 = TCC IS IN LOCK ADJ MODE   
;  b4 1 = TCC IS IN RELEASE MODE SLIPPING
;-----------------------------  
;   
LB52D	LDAA    L008C			;
	BRSET   L0085,#$20,LB53B	; BR IF b5, TCC IS IN LOCK ADJ MODE 
;
	BRCLR   L0085,#$50,LB53B	; BR IF NOT b4 & b6, 
;
	ORAA    #$20			;
	STAA    L008C			;
;
LB53B	JSR     LB553			;
;										
	LDAA    L00D5			;
	INCA				;
	BNE     LB552			;
;
LB543	JSR     LB5FE			;
;											
	JSR     LEBB1			;
;											
LB549	BSET    L0081,#$80		;
	BCLR    L0081,#$02		;
	BCLR    L007F,#$12		;
;										
LB552	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
LB553	LDAA    L008B			;
	LDX     #L5FC5			;
										
	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ABX				;
	BRCLR   L008A,#$04,LB562	;
;										
	ORAA    #$0008			;
;
LB562	LDY     #L601D			;
	BRCLR   0,Y,#$01,LB574		;
;											
	LDAB    L00D4			;
	CMPB    $004F,X			;
	BLS     LB574			;
;										
	BSET    L008C,#$80		;
											
LB574	LDAB    L00D6			;
	CMPB    1,X			;
	BLS     LB57C			;
;										
	ORAA    #$20			;
;
LB57C	LDAB    L00AC			;	
	CMPB    $0030,X			;
	BLS     LB586			;
;											
	CMPB    $33,X			;
	BLS     LB588			;
;											
LB586	ORAA    #$04			;
;
LB588	LDX     #L5FC5			;
	SUBB    L018B			;
	BCC     LB591			;
;										
	NEGB				;
;
LB591	CMPB    $36,X			;
	BCS     LB597			;
;										
	ORAA    #$0080			;
;
LB597	BRSET   L0083,#$02,LB59F	;
;										
	BRCLR   L0099,#$04,LB5A1	;
;										
LB59F	ORAA    #$01			;
;
LB5A1	LDAB    L00AF			; XMISH TEMP
	CMPB    $2E,X			;
	BLS     LB5AB			;
;											
	CMPB    $2F,X			;
	BCS     LB5AD			;
;											
LB5AB	ORAA    #$02			;
;
LB5AD	BRCLR   L009C,#$03,LB5B3	;
;											
	ORAA    #$10			;
;
LB5B3	LDAB    0,X			;
	CMPB    L00D5			;
	BNE     LB5BF			;
;											
	CMPB    L00D4			;
	BLS     LB5BF			;
;										
	ORAA    #$0040			;
;
LB5BF	STAA    L008B			;
	PSHX				;
	JSR     LE414			;
;											
	PULX				;
	LDAA    L008C			;
	BRCLR   L0092,#$10,LB5CE	;
;											
	ORAA    #$0008			;
;											
LB5CE	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ABX				;
	LDAB    L0181			;
	CMPB    $0040,X			;
	BCC     LB5DB			;
;											
	ORAA    #$01			;
;											
LB5DB	LDAB    L009B			;
	CMPB    $43,X			;
	BCC     LB5E3			;
;											
	ORAA    #$02			;
;											
LB5E3	LDAB    L00D1			; FILT  Vss
	SUBB    L0180			;
	BPL     LB5EB			;
;											
	NEGB				;
;
LB5EB	CMPB    $46,X			;
	BLS     LB5F1			;
;											
	ORAA    #$04			;
;
LB5F1	STAA    L008C			;
	BCLR    L008D,#$01		;
;											
	BRCLR   L0096,#$20,LB5FD	;
;											
	BSET    L008D,#$01		;
;											
LB5FD	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;------------------------------------
; TABLE INDEX						 
;										
; 03-11-1996  Dissassemby of BDWM
;
;------------------------------------
;
LB5FE	LDY     #LB74F			;
	LDAB    L0099			;
	ANDB    #$06			;
	ABY				;
	LDY     0,Y			;
	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ASLB				;
	ABY				;
	LDAA    L0114			;
	BNE     LB64D			;
;											
	LDX     6,Y			;
	LDAA    L00AC			;
	JSR     LF15E			; 2D LK UP
;											
	PSHA				;
	CLRA				;
	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ASLB				;
	LDX     #LB76D			;
	ABX				;
	LDX     0,X			;
	BEQ     LB631			;
;											
	LDAA    L00AC			;
	JSR     LF15E			; 2D LK UP
;											
LB631	PSHA				;
	TSX				;
	JSR     LD96D			;
;							
	INS				;
	ADDD    #$0040			;
	ASLB				;
	TAB				;
	ANDA    #$0000			;
	ROLB				;
	ROLA				;
	XGDX				;
	PULA				;
	CLRB				;
	IDIV				;
	XGDX				;
	TSTA				;
	BEQ     LB64C			;
;										
	LDAA    #$00FF			;
	BRA     LB64D			;
;										
LB64C	TBA				;
;
LB64D	LDX     #L0132			;
	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ABX				;
	LDAB    L00D5			;
	SUBB    L00D4			;
	STAB    L00D6			;
	STAB    0,X			;
	SBA				;
	RORA				;
	ROLA				;
	BVC     LB665			;
;											
	LDAA    #$007F			;
	ADCA    #$0000			;
;
LB665	STAA    L00D7			;
	STAA    3,X			;
	LDX     #L600E			;
;											
	LDAB    L00D3			;GEAR NUMBER 
	DECB				;
	ABX				;
	LDAA    L008B			;
	LDAB    L5FC5			;
	CMPB    L00D5			;
	BCS     LB67D			;
;										
	ORAA    #$0040			;
	STAA    L008B			;
;
LB67D	LDAA    L008C			;
	PSHX				;
	LDX     #L6017			;
	LDAB    L00D3			; GEAR NUMBER 
	DECB				;
	ABX				;
	LDAB    L00D6			;
	CMPB    0,X			;
	BCC     LB691			;
;										
	ORAA    #$0040			;
	STAA    L008C			;
;
LB691	PULX				;
	ORAA    L008B			;
	ORAA    L008D			;
	BEQ     LB69B			;
;										
	JMP     LB74E			;
;									
LB69B	LDAA    #$0001			;
	ANDA    L601D			;
	BNE     LB6AC			;
;											
	LDAA    L00D4			;
	CMPA    6,X			;
	BCS     LB6AC			;
;										
	LDAA    $0C,X			;
	BRA     LB6CE			;
;											
LB6AC	LDAA    #$FF			;
	STAA    L00F7			;
	LDAA    L00D7			;
	CMPA    0,X			;
	BGE     LB6BA			;
;											
LB6B6	LDAA    3,X			;
	BRA     LB6CE			;
;											
LB6BA	LDAA    L00D7			;
	ADDA    #$0008			;
	BGE     LB6C1			;
;											
	CLRA				;
;
LB6C1	CMPA    #$10			;
	BLS     LB6C7			;
;											
	LDAA    #$10			;
;
LB6C7	LDX     $0C,Y			;
	TAB				;
	ABX				;
	LDAA    0,X			;
;
LB6CE	STAA    L00DB			;
	LDX     0,Y			;
	LDAB    L0145			;
	ABX				;
	LDAB    0,X			;
	EORB    #$0005			;
	ANDB    #$0003			;
	STAB    L00D8			;
	TSTA				;
	BPL     LB6FA			;
;										
	LDAB    L00D9			;
	BGT     LB6E9			;
;										
	CLRA				;
	BRA     LB6F8			;
;											
LB6E9	NEGB				;
	ASLB				;
	ASLB				;
	BCC     LB6F8			;
;											
	ADDB    L00D8			;
	SUBB    #$0003			;
	BCS     LB6F8			;
;											
	CBA				;
	BCC     LB6F8			;
;											
	TBA				;
;
LB6F8	BRA     LB70B			;
;											
LB6FA	LDAB    L00DA			;
	BGT     LB701			;
;											
	CLRA				;
	BRA     LB70B			;
;										
LB701	ASLB				;
	ASLB				;
	BCS     LB70B			;
;											
	ADDB    L00D8			;
	CBA				;
	BLS     LB70B			;
;											
	TBA				;
;
LB70B	ADDA    0,X			;
	BVC     LB713			;
;										
	LDAA    #$007F			;
	ADCA    #$0000			;
;
;------------------------------------
; TABLE INDEX						 
;										
; 03-11-1996  Dissassemby of BDWM   
;
;------------------------------------
;
LB713	LDY     #LB74F			;
	LDAB    L0099			;
	ANDB    #$0006			;
	ABY				;
	LDY     0,Y			;
	PSHX				;
	LDX     $0012,Y			;
	CMPA    0,X			;
	BGE     LB72A			;
;											
	LDAA    0,X			;
;
LB72A	LDX     $14,Y			;
	CMPA    0,X			;
	BLE     LB733			;
;											
	LDAA    0,X			;
;
LB733	PULX				;
	TST     L0113			;
	BNE     LB74E			;
;										
	BRCLR   L0082,#$08,LB74E	;
;									
	LDY     $16,Y			;
	TAB				;
	NEGB				;
	ADDB    0,X			;
	ADDB    0,Y			;
	SEI				;
	STAA    0,X			;
	STAB    0,Y			;
	CLI				;
;
LB74E	RTS				;     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
;--------------------------------------------------
;										
;										
; 03-11-1996  Dissassemby of BDWM  Lines= 256 
;
;--------------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Addr of set of cells to use
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Cell RAM addr. table		;Shift pattern
;
LB74F   FDB LB755			;Normal pattern
	FDB LB755			;Performance pattern
	FDB LB755			;Manual Pattern
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Addr. of adaptive modifier cells for each gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Start addr.		;Gear #
;
LB755	FDB L031B		;2nd
	FDB L031F		;3rd
	FDB L0323		;4th
;      
LB75B   FDB L658F		; DESIRED SHIFT TIME 1 -> 2 SHFT
	FDB L65A0		; DESIRED SHIFT TIME 2 -> 3 SHFT
	FDB L65B1		; DESIRED SHIFT TIME 3 -> 4 SHFT
;
;----------------------------------------------------------------
; ADAPTIVE PRESSURE MODIFIER  LINE PRESSURE Vs. SHIFT TIME ERROR
;
;
;----------------------------------------------------------------
;
LB761   FDB L65C2		; 1 -> 2 SHIFT
	FDB L65D3		; 2 -> 3 SHIFT
	FDB L65E4		; 3 -> 4 SHIFT
;
LB767   FDB L5FFC		;
	FDB L5FFD		;
	FDB L0327		;
;
LB76D   FDB L6044		; 2nd GEAR, DESIRED SHIFT TIME ALTITUDE GAIN
	FDB L6055 		; 3rd GEAR, DESIRED SHIFT TIME ALTITUDE GAIN
	FDB L6066		; 4th GEAR, DESIRED SHIFT TIME ALTITUDE GAIN
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB773	LDX     #L400F			;Opt. byte
	BRCLR   0,X,#$C0,LB77C		;Bra if b7==0, auto trans and b6==0, CC transmission 
;
;-Non CC transmission here
;
	BRA     LB78B			;Bra to return
;
;-CC transmission here
;
LB77C	JSR     LB78C			;
;
	JSR     LBCED			;
;
	JSR     LBDF3			;
;
	JSR     LBD4D			;
;
	JSR     LBE8F			;
;
LB78B	RTS				;    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB78C	LDAA    L0111			;
	BEQ     LB794			;
;
	JMP     LBACB			;
;
LB794	LDAB    L0099			;Transmission shift pattern word
	ANDB    #$06			;Clear all but b1=performance pattern req, 
					;b2=manaul pattern requested
	LDX     #LBB48			;Addr. of line pressure table(s) for 0-64 mph
	CLRA				;Preclear A   
	BRSET   L009C,#$20,LB7A2	;Status word, bra if b5==1, trans in reverse
;
;-Here to load MPH
;
	LDAA    L00D1			;Load MPH
;
LB7A2	ASLA				;MPH x 2
	BCC     LB7A8			;Bra if <=

	LDX     #LBB4E			;Addr. of line pressure table(s) for 64-128 mph
;
LB7A8	ABX				;Add in the offset
	LDX     0,X			;Load addr. of Line pressure table
	TAB				;MPH to B
	LDAA    L00AC			;Trans %TPS
	JSR     LF17B			;3D lookup
;											
	LDAB    L00D3			;Gear # 
	DECB				;-1
	BRCLR   L007F,#$10,LB7B9	; (???)
;
	INCB				;+1  
; 
LB7B9	BMI     LB7E8			;Bra if in first
;	
	PSHA				;Push line pressure to stack
	LDX     #L0115			;
	ABX				;Add in gear # as offset
	LDAA    0,X			;Load 
	BNE     LB7E0			;
;
	BRCLR   L0099,#$06,LB7D0	;Trans shift pattern word, bra if b2==0,
					;manual pattern not selected, and b1==0,
					;performance pattern not requested.
;											
	ADDB    #03			;Skip ahead to second set of offset tables
;
	BRSET   L0099,#$02,LB7D0	;Bra if b1==1, performance pattern requested
;											
LB7CE	ADDB    #$03			;Skip ahead again to third set of tables
;
;-Look up pressure offset vs. %TPS table addr
;
LB7D0	LDX     #LBB54			;Pressure offset
	ASLB				;x2 
	ABX				;Add in gear number as offset
	LDX     0,X			;Load table addr 
	BEQ     LB7E0			;Bra if addr. ==0
;
	LDAA    L00AC			;Trans TPS
	JSR     LF15E			;2D lookup
									
	SUBA    #128			;Make pressure offset signed
;
;-Here if address ==0
;
LB7E0	PULB				;Get looked up line pressure back
	ABA				;Add in offset
	BVC     LB7E8			;Bra if no 2's overflow
;											
	LDAA    #127			;Clear overflow
	ADCA    #$00			;Perform carry if needed
;
LB7E8	PSHA				;Push line pressure to stack
	JSR     LBACE			;Routine to look up adaptive modifer
;
	PULB				;Get line pressure back
	ABA				;Add in adaptive pressure modifier
	BVC     LB7F4			;Bra if no 2's overflow
;										
	LDAA    #127			;Clear overflow
	ADCA    #$00			;Perform carry if needed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Load in temp corr. table addr. based on gear #
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB7F4	LDX     #LBB78			;Start addr. of table addresses
	LDAB    L00D3			;Gear # 
	ASLB				;x2 for lookup
	ABX				;Add in as offset
	LDX     0,X			;Load in table address
	BNE     LB802			;Bra if !=0,
;
;-Here if table not in use
;
	JMP     LB882			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up break points and prepare to perform look up
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB802	PSHA				;Line pressure to stack
	PSHX				;Push table addr. to stack
	LDAA    L00AF			;Load trans temp
	LDAB    #$A0			;multiplier for lookup, 11 cols. in table
	MUL				;(Trans temp x multiplier)
	PSHA				;Push formatted trans temp to stack
;
;-Put some fluff on stack in case following scaling op. is skipped
;
	PSHX				;Table addr to stack
	PSHX				;
	PSHX				;											;
	LDAA    #00			;Zero offset											;
	LDAB    L00AC			;Trans. TPS
	CMPB    L6001			;Lower TPS limit for lookup
	BLS     LB870			;Bra if TPS <=, use zero offset
;
	LDAA    #$30			;4 line offset											;
	CMPB    L6004			;Upper TPS limit for lookup
	BCC     LB870			;Bra if >=, use 4 line offset
;
	LDAA    #$10			;16 counts/table line											;
	LDX     #L6002			;Start addr. of break points for lookup
;
;-Calculate offset to current break point
;
LB822	CMPB    0,X			;Current TPS break point
	BCS     LB82B			;Bra if TPS <
;
	INX				;Advance to next break point
	ADDA    #$10			;+16 for next break point
	BRA     LB822			;Bra back to check next break point
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Scale %TPS to break point table for lookup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LB82B	TSY				;Get current stack pointer     
	STAB	5,Y			;Save trans TPS
	STAA	4,Y			;Save break point offset
;
;-Calc delta %TPS between each set of break points
;
	LDAA	0,X			;Load break point from table
	DEX				;-1     
	LDAB	0,X			;Load previous break point
	SBA				;Get delta TPS between points     
	STAA   	3,Y			;Save delta TPS between break points
;
;-Delta %TPS x offset
;
	LDAB   	4,Y			;Load break point offset
	MUL				;delta TPS x offset    
	STD    	1,Y			;Save result, now %TPS offset
;
;-Trans %TPS x 16
;
	LDAB   	5,Y			;Load trans TPS
	LDAA	#$10			;16			
	MUL				;%TPS x 16     
	STD	4,Y			;Save result
;
	LDAA	1,X			;Load current %TPS break point from table
	LDAB	#$10			;16
	MUL				;Break point x 16     
	COMA				;Flip sign    
	COMB				;    
	ADDD	#$01			;
	ADDD	1,Y			;[(Delta %TPS x offset) - (%TPS BP x 16)],
					;Now %TPS above current break point
	ADDD	4,Y			;Add result to Trans TPS x 16
	STAA	4,Y			;Save result
;
;-Finish scaling it for look up
;			
	CLRA				;    
	STAA	2,Y			;Preclear addr.
	LDX	2,Y			;Get delta TPS between break points into X
	LDAA	4,Y			;Load previous result
	IDIV				;Int. divide     
	STX	0,Y			;Store it, X = Total BP %TPS / delta BP %TPS
	LDAA	1,Y			;Load in result for lookup
;
;~~~~~~~~~~~~~~~~~~~~
; Here to do look up
;~~~~~~~~~~~~~~~~~~~~
;
;-Clean up the stack
;
LB870	PULX				;    
	PULX				;
	PULX				;
	PULB				;Get trans temp back
	PULX				;Get table addr. back    
	JSR     LF17B			;3D lookup
;
	SUBA    #$0080			;Make pressure correction signed
	PULB				;Get line pressure back    
	ABA				;Add in temp. compensation     
	BVC     LB882			;Bra if no 2's overflow
;
	LDAA    #$007F			;Clear overflow
	ADCA    #$0000			;Perform carry if needed
;
LB882	PSHA				;Push line pressure to stack    
	JSR     LBC0C			;Shift pressure mod. routine

	PULB				;Get line pressure back    
	ABA				;Add in the pressure modification				     
	BVC     LB88E			;Bra if no 2's overflow
;
	LDAA    #$007F			;Clear overflow
	ADCA    #$0000			;Perform carry if needed
;
LB88E	JSR     LBCEC			;RTS
;
	JSR     LBB86			;
;
	BRCLR   L007F,#$10,LB8BE	;

	LDAB    L00D3			; GEAR NUMBER 
	BRCLR   L0099,#$06,LB8A6	;
;
	ADDB    #$0003			;
	BRSET   L0099,#$02,LB8A6	;
;
	ADDB    #$0003
;
;--------------------------------------------------
; PRESSURE MOD, NORMAL RANGE LINE PRESSURE Vs. Vss
; (Select table addres 1st.)
;
;  Dissassemby of BBWM
;  (INDEXED ADDR TABLE AT LBB66)
;
; INDEX POINTS TO 3 8 BIT VALUES
;	1. BP START VALUE (-1 BP Increment value)
;	2. BP RANGE, (MAX VAL - MIN VAL)
;	3. BP INCREMENT VALUE
;
;  TBL =  1  * (PSI MOD + 128 
;--------------------------------------------------
;
LB8A6	LDX     #LBB66			; INDEX ADDRESS TABLE
	ASLB				;
	ABX				;
	LDX     0,X			; GET TABLE ADDRESS FOR CURRENT GEAR
	BEQ     LB8BE			; BR IF ADDRESS = Z
;
	TAB				;
	LDAA    L00D1			; FILT  Vss
	JSR     LF141			; 2d LK UP WITH BP QUAL'S
;										
	SUBA    #128			; SUB OFF OFF SET
	ABA				; 
	BVC     LB8BE			;
;
	LDAA    #127			;
	ADCA    #$00			; ROUND
;
LB8BE	BRCLR   L0096,#$04,LB8D5	; BR IF NOT b2, 
;
	TAB				;     
	LDAA    L019D			; RPM * 8
	LDX     #L6022			;
	JSR     LF15E			; 2D LK UP
;
	SUBA    #$0080			;
	ABA				;     
	BVC     LB8D5			;
;
	LDAA    #$007F			;
	ADCA    #$0000			;
;
LB8D5	TSTA				;   
	BPL     LB8D9			;
;
	CLRA				;
;
LB8D9	TAB				;
	LDAA    L0252			; MAT VAL
	SUBA    #48			;
	BCS     LB8E8			; BR IF UNDERFLOW
;
	ASLA				;
	BCC     LB8E9			;
;
	LDAA    #$FF			; FORCE MAX VALUE
	BRA     LB8E9			;
;
LB8E8	CLRA 
;  
;--------------------------------------------------
; LK UP MAT TEMPERATURE PRESSURE OFFSET
;
;--------------------------------------------------
;
LB8E9	LDX     #L6033			; MAT TEMPERATURE PRESSURE OFFSET
	JSR     LF15E			; 2D LK UP
;										
	SUBA    #128			; 128 PSI PRESS 0FF SET
	ABA				;
	BVS     LB8F8			;
;										
	BMI     LB8FC			;
;										
	BRA     LB8FD			;
;										
LB8F8	LDAA    #127			;
	BRA     LB8FD			;
;										
LB8FC	CLRA				;
;
;------------------------------------------------------
; PRESSURE ALTITUDE GAIN FACTOR Vs. %TPS
; INDEXED ADDRESS TBL, 1ST, 2ND & 3RD GEAR
;------------------------------------------------------
;
LB8FD	PSHA				;    
	LDAB    L00D3			; GEAR NUMBER 
	BRCLR   L007F,#$10,LB905	; BR IF NOT b4
;
	INCB				; INCR GRAR NUM
;										
LB905	CLRA				;
	DECB				; DECR GRAR NUM    
	BMI     LB917			;
;											
	ASLB				;
	LDX     #LBB80			; ADDR INDEX TBL
	ABX				; ADJ INDEX FOR GEAR
	LDX     0,X			; GET TABLE ADDRES FROM INDEX TBL
	BEQ     LB917			;
;
	LDAA    L00AC			;
	JSR     LF15E			; 2D LK UP
;											
LB917	PSHA				;
	TSX				;
	JSR     LD96D			;
;											
	INS				;
	ADDD    #128			;
	PULB				;
	MUL				;
	ASLD				;
	BVS     LB927			;
;											
	BPL     LB929			;
;											
LB927	LDAA    #$007F			;
;
LB929	STAA    L013E			;
	BCLR    L008A,#$04		;
	BRCLR   L007F,#$09,LB942	;
;											
	CLR     L00E2			;
	LDX     L00E9			;
	CPX     L5FFF			;
	BLT     LB94B			;
;											
	LDAB    L5FFE			;
	STAB    L00E2			;
;
LB942	LDAB    L00E2			;
	BEQ     LB94B			;
;											
	DECB				;
	STAB    L00E2			;
	BRA     LB988			;
;											
LB94B	BRCLR   L0092,#$04,LB954	;
											
	LDX     #L60BB			;
	BRA     LB976			;
;											
LB954	LDAB    L00D3			; GEAR NUMBER 
	CMPB    #$0003			;
	BEQ     LB988			;
;											
	BRCLR   L009C,#$07,LB988	;
											
	LDX     #L60CC			;
	CMPB    #$02			;
	BEQ     LB976			;
;											
	BRCLR   L009C,#$03,LB988	;
;											
	LDX     #L60BB			;
	TSTB				;
	BNE     LB976			;
;											
	BRCLR   L009C,#$01,LB988	;
;											
	LDX     #L60AA			;
;
LB976	TAB				;
	LDAA    L00D1			; FILT  Vss
	JSR     LF15E			; 2D LK UP
;											
	STAA    L013F			;
	CBA				;
	BCS     LB987			;
;											
	BSET    L008A,#$04		;
	BRA     LB988			;
;											
LB987	TBA				;
;
LB988	LDX     L00E5			; TCC SLIP
	STX     L00E9			;
;											
	STAA    L0141			;
	LDAB    L00D1			; FILT  Vss
	BRCLR   L009C,#$50,LB9AB	; BR IF NOT b4 & b6

	BCLR    L008A,#$30		;
	CMPB    L5FE1			;
	BCS     LB9A0			;
;											
LB99D	JMP     LBA76			;
;											
LB9A0	BCLR    L008A,#$02		;
	LDX     #L60DD			;
	LDAB    L5FE3			;
	BRA     LB9F7			;
;											
LB9AB	CMPB    L5FE2			;
	BCC     LB9BA			;
;											
	BRCLR   L009C,#$0F,LB9BF	;
;											
	BRCLR   L009D,#$0F,LB9CA	;
;																					
LB9B8	BRA     LB9C3			;
;											
	BCLR    L008A,#$30		;
	BRA     LB99D			;
;											
LB9BF	BRCLR   L009D,#$20,LB9CA	;
;											
LB9C3	BRSET   L008A,#$02,LBA21	;
;											
	JMP     LBA7C			;
;											
LB9CA	BSET    L008A,#$02		;
;											
	BRSET   L009C,#$20,LB9E5	;
;											
	BCLR    L008A,#$10		;
	BSET    L008A,#$20		;
	LDAA    L5FDD			;
	STAA    L013D			;
	LDX     #L60DD			;
	LDAB    L5FE4			;
	BRA     LB9F7			;
;											
LB9E5	BSET    L008A,#$10		;
	BCLR    L008A,#$20		;
	LDAA    L5FDF			;
	STAA    L013D			;
	LDX     #L6168			;
	LDAB    L5FE5			
;
LB9F7	STAB    L013C			;
	LDD     L019D			; RPM * 8
	ASLD				;
	BCS     LBA03			;
;											
	ASLD				;
	BCC     LBA05			;
;											
LBA03	LDAA    #$00FF			;
;
LBA05	ADDD    #$0080			;
	SBCA    #$0000			;
	PSHA				;
	LDAA    L00AF  			; XMISH TEMP
	LDAB    #$009A			;
	MUL				;
	ADCA    #$0000			;
	CMPA    #$0070			;
	BLS     LBA18			;
;											
	LDAA    #$0070			;
;
LBA18	PULB				;
	JSR     LF17B			; 3d LOOK UP
;											
	SUBA    #$0080			;
	STAA    L0142			;
;
LBA21	LDX     #L61F3			;
	LDAA    L00AC			;
	LDAB    L00D1			; FILT  Vss
	CMPB    #$20			;
	BLS     LBA2E			;
;
	LDAB    #$20			;

LBA2E	ASLB				;    
	JSR     LF17B			; 3d LOOK UP
;
	SUBA    #$0080			;
	ADDA    L0142			;
	BVC     LBA3D			;
;
	LDAA    #$007F			;
	ADCA    #$0000			;

LBA3D	ADDA    #$0080			;
	LDAB    L013D			;
	BEQ     LBA5D			;
;
	BRCLR   L008A,#$20,LBA4D	;
;
	ADDA    L5FDE			;
	BRA     LBA54			;
;
LBA4D	BRCLR   L008A,#$10,LBA54
;
	ADDA    L5FE0
;
LBA54	DECB				;    
	STAB    L013D			;
	STAA    L0140			;
	BRA     LBA63			;
;
LBA5D	STAA    L0140			;
	BCLR    L008A,#$30		;
;
LBA63	LDAB    L0140			;
	LDAA    L0141			;
	ADDB    L013C			;
	BCS     LBA71			;
;
	CBA				;     
	BGE     LBA76			;
;
LBA71	LDAA    L0140			;
	BRA     LBA7C			;
;
LBA76	BCLR    L008A,#$02		;
	CLR     L013D			;
;
LBA7C	BRCLR   L0096,#$02,LBA91	;

	LDAB    L00D3			; GEAR NUMBER 
	LDX     #L5FE9			;
	ABX				;
	SUBA    0,X			;
	BVC     LBA8E			;
;
	LDAA    #$007F			;
	ADCA    #$0000			;
;
LBA8E	BPL     LBA91			;
;
	CLRA				;
;    
LBA91	TAB				;     
	LDAA    L601E			;
	PSHA				;    
	SBA				;     
	RORA				;    	
	ROLA				;    
	BVC     LBA9F			;
;
	LDAA    #$007F			;
	ADCA    #$0000			;
;
LBA9F	CMPA    L00DA			;
	BGE     LBAA5			;
;
	STAA    L00DA			;
LBAA5	PULA				;    
	CMPB    L00D9			;
	BGE     LBAAC			;
;
	STAB    L00D9			;
;
LBAAC	BRSET   L0092,#$08,LBABF
;
	PSHB				; 	   
	PSHA				;    
	JSR     LE424			;
;
	PULA				;    
	PULB				;    
	BRSET   L0092,#$20,LBABF	;
;
	CBA				;     
	BLS     LBABF			;
;
	TBA				; 
;    
LBABF	ADDA    L0112			;
	BVC     LBAC8			;
;
	LDAA    #$007F			;
	ADCA    #$0000			;
;
LBAC8	BPL     LBACB			;
;
	CLRA				;
; 	   
LBACB	STAA    L00DC			;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to change/load adaptive modifier cell
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LBACE	LDAB    L00D3			;Load gear #
	BRSET   L007F,#$02,LBADB	;forced to upshift (???)
;
	BRCLR   L007F,#$10,LBAE7	;forced to downshift (???)
;
	INCB				;+1, gear #    
	BRA     LBAE7			;Bra
;
LBADB	BRSET   L007F,#$01,LBAE7	;Forced to upshift (???)
;
	LDAA    L008B			;
	ORAA    L008C			;			
	ORAA    L008D			;
	BEQ     LBB44			;
;
LBAE7	CLRA				;Preclear A    
	DECB				;-1, gear #    
	BMI     LBAFD			;Bra if already in first
;
;
;
	LDX     #LB74F			;Addr of set of cells to use based on S.P.
	PSHB				;Gear number to stack    
	LDAB    L0099			;Shift pattern word
	ANDB    #$06			;Clear all but b1=performance pattern req.,
					;b2=manual pattern requested
	ABX				;Add in as offset     
	PULB				;Get gear number back    
	LDX     0,X			;Load next table addr. based on shift pattern req.
	ASLB				;Gear #, x2 for indexed lookup    
	ABX				;Add in the offset    
	LDX     0,X			;Load in start addr of cells
	BNE     LBB02			;Bra if !=0
;
;-Here if not using adaptive modifier cells
;
LBAFD	STAA    L0145			;Clear adaptive modifier cell #
	BRA     LBB41			;Bra to clear current mod. and continue
;
;-Here if using adaptive modifier cells
;
LBB02	PSHX				;Push RAM addr. to stack    
	LDX     #L5FEE			;Base addr. for cell TPS thresholds
	LDY     #L5FEC			;Base addr. for cell TPS thresholds
	LDAA    L00AC			;Trans. TPS
	LDAB    L0145			;Current adaptive modifier cell #
	BEQ     LBB1D			;Bra if in cell #0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to check/change adaptive modifier cell #
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	ASLB				;x2 for indxed lookup
	ABY				;Add in offset
	CMPA    0,Y			;Lower TPS limit for current cell
	BCS     LBB23			;Bra if TPS is less, change cells
;
	CMPB    #6			;Cell 3, uppermost cell
	BEQ     LBB36			;Bra if already in uppermost cell
;
LBB1D	CMPA    1,Y			;Upper TPS limit for current cell
	BCS     LBB36			;Bra if TPS is <=, remain in current cell

	DEX				;-1, point to upper TPS limit to remain in cell
;
;-Here to change cells
;
LBB23	CLRB				;Clear cell #
	CMPA    0,X			;TPS limit to remain in cell #0
	BCS     LBB33			;Bra if <, use cell #0
;
	INCB				;Advance to cell #1 
	CMPA    2,X			;TPS limit to remain in cell #1
	BCS     LBB33			;Bra if <, use cell #1
;
	INCB				;Advance to cell #2
	CMPA    4,X			;TPS limit to remain in cell #2
	BCS     LBB33			;Bra if TPS <, use cell #2

	INCB				;Advance to cell #3 
;
LBB33	STAB    L0145			;Save current adaptive modifier cell 
;
LBB36	PULX				;Get address of current set of cells
	LDAB    L0145			;Load up adaptive modifier cell # 
	ABX				;Add in as offset
	LDAA    0,X			;Load contents of cell
	ASRA				;/2
	ASRA				;/2
	ADCA    #$0000			;Round if needed
;
LBB41	STAA    L0144			;Save it, current adaptive pressure modifier 
;
LBB44	LDAA    L0144			;Current adaptive modifer
	RTS				;Return     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Addresses of transission related tables
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Load based line pressure
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;Shift pattern
;
LBB48	FDB L62D8   			;Normal  
	FDB L62D8   			;Perf.
	FDB L62D8   			;Manual 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Load based line pressure
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;Shift pattern
;
LBB4E   FDB L63FC			;Normal  
	FDB L63FC			;Perf. 
	FDB L63FC			;Manual 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Pressure offset vs %TPS, normal pattern
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;Gear #
;
LBB54   FDB L6520			;2nd 
	FDB L6531   			;3rd 
	FDB L6542   			;4th 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Pressure offset vs %TPS, performance pattern
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;Gear #
;
LBB5A	FDB L6520   			;2nd 
	FDB L6531   			;3rd 
	FDB L6542			;4th 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Pressure offset vs %TPS, manual pattern
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Addr.				;Gear #
;
LBB60   FDB L6520   			;2nd
	FDB L6531   			;3rd
	FDB L6542			;4th
;
;------------------------------------------------------
; PRESSURE MOD, DOWN SHIFT, 9 LINES
;  LINE PRESSURE Vs. Vss
;------------------------------------------------------
;
LBB66   FDB L6553		; 2 -> 1, NORMAL RANGE
	FDB L6567		; 3 -> 2, NORMAL RANGE
	FDB L657B		; 4 -> 3, NORMAL RANGE
;
LBB6C   FDB L6553		; 2 -> 1, NORMAL RANGE
	FDB L6567		; 3 -> 2, NORMAL RANGE
	FDB L657B		; 4 -> 3, NORMAL RANGE
;
LBB72   FDB L6553		; 2 -> 1, NORMAL RANGE
	FDB L6567		; 3 -> 2, NORMAL RANGE
	FDB L657B		; 4 -> 3, NORMAL RANGE
;
;------------------------------------------------------
;  XMISH TEMPERATURE DEPENDENT LINE PRESSURE Vs.
;  %TPS Vs. DEG c XMISH TEMP
;
;------------------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Addr. of transmission dependant line pressure vs TPS and trans temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Table addr.		;Gear #
;
LBB78	FDB $0000		;1st 
	FDB L624B		;2nd 
	FDB L627A		;3rd
	FDB L62A9		;4th
;
;------------------------------------------------------
; PRESSURE ALTITUDE GAIN FACTOR Vs. %TPS
; INDEXED ADDRESS TBL
;------------------------------------------------------
;
LBB80   FDB L6077		; 2nd GEAR
	FDB L6088		; 3rd GEAR
	FDB L6099		; 4th GEAR
;
;~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~
;
;
LBB86	PSHA				;Line pressure to stack    
	BRSET   L0081,#$20,LBBCA	;
;
	BRSET   L007F,#$08,LBBFD	;
;
	BRCLR   L007F,#$01,LBBD6	;
;
	LDAB    L00D3			; GEAR NUMBER 
	CMPB    #$01			;
	BNE     LBBA1			;

	LDAA    L5FC9			; 1.0 SEC'S  TIME CK FOR JUMP SHFT AFTER 1 -> 2
	STAA    L018C			;
	BRA     LBBD6			;
;
LBBA1	CMPB    #$02			;
	BNE     LBBB8			;
;
	LDAA    L5FCA			; 1.0 SEC'S  TIME CK FOR JUMP SHFT AFTER 2 -> 3
	STAA    L018D			;
	LDAA    L018C			;
	BEQ     LBBD6			;
;
	LDAA    L5FCB			; 2.0 SEC'S  TIME PERIOD FOR NEXT LINE
	LDAB    L5FCC			; 20 PSI ADDED FOR 1 -> 3 SHIFT
	BRA     LBBD0			;				
;											
LBBB8	LDAA    L018C			;
	BEQ     LBBC5			;
;
	LDAA    L5FCD			; 2.0 SEC'S  TIME  PERIOD FOR NEXT LINE
	LDAB    L5FCE			; 20 PSI ADDED FOR 1 -> 4 SHIFT						
	BRA     LBBD0			;				
;											
LBBC5	LDAA    L018D			;
;
LBBC8	BEQ     LBBD6			;
;
LBBCA	LDAA    L5FCF			; 2.0 SEC'S  TIME  SUB'ED  PERIOD FOR NEXT LINE
	LDAB    L5FD0			; 10 PSI ADDED FOR 2 -> 4 SHIFT
;
LBBD0	STAA    L018E			;
	STAB    L018F			;
;										
LBBD6	PULA				;
	LDAB    L018E			;
	BEQ     LBBE9			;
;
	DECB				;
	STAB    L018E			;
	ADDA    L018F			;
	BVC     LBBE9			;
;
	LDAA    #$7F			;
	ADCA    #$00			;
;
LBBE9	LDAB    L018C			;
	BEQ     LBBF2			;
;
	DECB				;
	STAB    L018C			;
;
LBBF2	LDAB    L018D			;
	BEQ     LBBFB			;
;											
	DECB				;
	STAB    L018D			;
;
LBBFB	BRA     LBC0B			;
;										
LBBFD	CLRA				;
	STAA    L018E			;
	STAA    L018C			;
	STAA    L018D			;
	STAA    L018F			;
	PULA				;
;
LBC0B	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Line pressure shift modification routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;			
LBC0C	BRSET   L0092,#$04,LBC14	;Status word, bra if b2==1, 
					;press. switch. man. error
;	
	BRCLR   L009C,#$70,LBC1C	;Trans range sel. word, bra if b4-b6==0,
					;Not in ?, P/N, Rev. 
;
;-Here to skip routine
;
LBC14	BCLR    L008A,#$01		;
	CLRA				;
	CLRB				;
	JMP     LBCE8			;
;											
LBC1C	BRSET   L007F,#$08,LBC5A	;Status word, bra if b3==1, forced to downshift (???)
;											;
	BRCLR   L007F,#$01,LBC33	;Status word, bra if b0==0, not forced to upshift (???)
;											;
	BSET    L008A,#$01		;
	LDD     #$0000			;
	STAA    L0139			;Post shift timer
	STAA    L0138			;Start of shift timer
	JMP     LBCE8			;
;
LBC33	BRCLR   L008A,#$01,LBC5A	;Trans shift not in progress (???)
;											
	LDAB    L00D3			;Gear #
	DECB				;-1
	LDX     #L601F			;
	ABX				;Add in gear # as offset
	LDAA    L00D5			;Shift timer (???)
	CMPA    0,X			;
	BCC     LBC5A			;
;
;
;		
	LDAA    #$0011			;17 line tables
	MUL				;# lines/table x gear #
	LDX     #L6628			;Start of pressure ramp delay time tables
	ABX				;Add in calc'd offset
	LDAA    L00AC			;Load trans TPS
	JSR     LF15E			;2D lookup
;										
	CMPA    L00D5			;Shift timer (???)
	BLS     LBC5C			;Bra if timer is >=
;
;-Here if ramp delay timer is < delay time
;											
	LDD     #$0000			;
	JMP     LBCE8			;
;											
LBC5A	BRA     LBCCB			;
;
;-Here if timer is >= delay time
;											
LBC5C	BRSET   L008C,#$10,LBCCB	;
;					
	BRCLR   L0081,#$10,LBC84	;Trans shift stat. word,
					;bra if b4==0, shift has not yet started
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Shift is underway here
;~~~~~~~~~~~~~~~~~~~~~~~~
;											
	LDAA    L0138			;Start of shift time
	BNE     LBC6E			;Bra if !=0
;											
	LDAA    L00D5			;Shift timer (???)
	STAA    L0138			;Save it as start of shift time
;
LBC6E	LDX     #L665B			;Start addr. of pressure ramp delay extention tbls.
	ABX				;Add in calc'd offset
	LDAA    L00AC			;Trans %TPS
	JSR     LF15E			;2D lookup
;
	ADDA    L0138			;Add in delay time 
	BCC     LBC7E			;Bra if no overflow
;
	LDAA    #$00FF			;Clear overflow
;
LBC7E	CMPA    L00D5			;Shift timer (???)
	BLS     LBC8E			;Bra if <=
;											
	BRA     LBC89			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if shift has not yet started
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LBC84	TST     L0138			;Start of shift time
	BNE     LBC6E			;Bra if !=0
											
LBC89	LDX     #L668E			;Press. diff. vs %TPS
	BRA     LBCAE			;Bra to do lookup
;		
LBC8E	BRSET   L0081,#$80,LBC9A	;Trans shift status word,
					;Bra if b7==1, shift complete
;
;-Shift not yet complete here
;
	CLR     L0139			;Clear post shift timer
	LDX     #L66C1			;Start addr. of ramp 2 pressure diffs. vs %TPS
	BRA     LBCAE			;Bra to go do lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Shift is complete here
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LBC9A	LDX     #L66F4			;Start addr of ramp time vs %TPS tables
	ABX				;Add in cal'd offset based on gear #
	LDAA    L00AC			;Load trans TPS
	JSR     LF15E 			;2D lookup
;											
	CMPA    L0139			;Post shift timer
	BLS     LBCCB			;Bra if timer >=
;											
	INC     L0139			;+1, post shift timer
	LDX     #L66C1			;Start addr. of ramp 2 press. diffs. vs %TPS
;
LBCAE	ABX				;Add in cal'd offset based on gear #
	LDAA    L00AC			;Load trans TPS
	JSR     LF15E			;2D look up
;											
	TAB				;Looked up value to B
	CLRA				;Preclear A
	SUBB    #$0080			;Make signed value
	SBCA    #$0000			;Perform carry if needed
	ASLD				;x2
	ASLD				;x2
	ASLD				;x2
	ADDD    L013A			;Accumulated pressure
	BVC     LBCC9			;Bra if overflow
;											
	LDD     #$7FFF			;Clear overflow
	ADCB    #$0000			;Perform carry if needed
	ADCA    #$0000			;
;
LBCC9	BRA     LBCE8			;Bra to save and exit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here it timer is >= ramp time
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LBCCB	CLR     L0138			;Clear start of shift timer
	BCLR    L008A,#$01		;
;											
	LDAB    L00D3			;Gear #
	BNE     LBCD8			;Bra if in 2-4th
;
;-Clear accumulated pressure if in 1st
;											
	CLRA				;Preclear A
	BRA     LBCE8			;Bra to clear accumulated pressure
;
;-
;											
LBCD8	DECB				;-1, from gear #
	LDAA    #$0011			;17 lines/table
	MUL				;Gear # x lines per table
	LDX     #L65F5			;Start addr of gear pressure offset vs %TPS
	ABX				;Add in calc'd value for lookup
	LDAA    L00AC			;Trans TPS
	JSR     LF15E			;2D lookup
;											
	SUBA    #$0080			;Make signed value
	CLRB				;Clear LSB
LBCE8	STD     L013A			;Save it, accumulated pressure
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; Not used...
;
;~~~~~~~~~~~~~~~~~~~~~~
;											
LBCEC	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LBCED	BRCLR   L0093,#$08,LBCF5	;
;										
	CLRA				;
	JMP     LBD44			;
;											
LBCF5	LDAA    L00AF  			; XMISH TEMP
	ASLA				;
	BCS     LBCFE			;
;
	ADDA    L00AF  			; XMISH TEMP
	BCC     LBD00			;
;
LBCFE	LDAA    #$FF			;
;
LBD00	LDX     #L6B72			;
	JSR     LF15E			; 2d LK UP
;		
	TAB				;
	LDAA    L0143			;
	SBA				;
	BCS     LBD11			;
;											
	CMPA    L00DC			;
	BHI     LBD29			;
										
LBD11	LDAA    L0143			;
	ABA				;
	BCS     LBD1B			;
;											
	CMPA    L00DC			;
	BCS     LBD21			;
;											
LBD1B	BRSET   L008A,#$40,LBD21	;
;											
	BRA     LBD29			;
;											
LBD21	BSET    L008A,#$40		;
	LDX     #L692A			;
	BRA     LBD2F			;
;											
LBD29	BCLR    L008A,#$40		;
;											
	LDX     #L6A4E			;
LBD2F	LDAA    L00DC			;Desired line pressure
	PSHA				;
	LDAB    #170			;Scalar for lookup
	MUL				;
	PULB				;
	ASLB				;
	BCS     LBD3C			;
;
	ABA				;
	BCC     LBD3E			;
;
LBD3C	LDAA    #255			;
;
LBD3E	TAB				;
	LDAA    L00AF  			; XMISH TEMP
	JSR     LF17B			; 3d LOOK UP
;
LBD44	STAA    L0147			;
	LDAA    L00DC			;
	STAA    L0143
;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;			
;----------------------------------------------
; TCC ENABLE FLAGS 
;
;
;----------------------------------------------
;
LBD4D	LDX     #L6727			; INDEX TCC CONSTANTS 
	LDAB    L0184			;
	BEQ     LBD59			;
;
	DECB				;
	STAB    L0184			;
;
LBD59	LDD     L00AC			;
	STAA    L00AD			;
	SBA				;
	BCC     LBD68			;
;
	CMPA    $1A,X			; $6741, 173%/SEC, DIFF TPS 
	BHI     LBD71			;
;
	LDAA    $1D,X			; $6744,  DIFF TPS OFF 0 SEC'S
;
	BRA     LBD77			;				
;											
LBD68	CMPA    $1B,X			; $6742, 141%/SEC, DIFF TPS RELEASE THRESH
	BCS     LBD71			;
;
	LDAB    $1C,X			; $6743, STAY IN RELEASE 0 SEC'S
	STAB    L0184			;
;
LBD71	LDAA    L0183			;
	BEQ     LBD7A			;
;
	DECA				;
;
LBD77	STAA    L0183			;
;
LBD7A	LDD     L00E5			; TCC SLIP
	CPD     $10,X			; $6737, -1023 RPM, IF SLP L.T. THEN TCC OFF
	BGE     LBD86			;
;
	BSET    L0085,#$80		; SET b7, NEG SLIP RECENTLY PREVENTS TCC APPLY
	BRA     LBD8D			;
;											;
LBD86	SUBD    $12,X			; $6739, -200 RPM, IF OFF,
	BLE     LBD8D			;
;
	BCLR    L0085,#$80		; CLR b7, NEG SLIP RECENTLY PREVENTS TCC APPLY
;											;
LBD8D	LDAB    $16,X			; $673D, 0.8%, VERY LO SPD TPS THRESH
	BRSET   L0085,#$40,LBD99	;
;
	BRSET   L0085,#$10,LBD99	; BR IF b4, (TCC IS IN RELEASE MODE, SLIPPING)
	LDAB    $17,X			; $673E, 1.6%, LO SPD TPS THRESH
;
LBD99	LDAA    $14,X			; $673B, 38 MPH Vss THRESH FOR TPS THRESH
	BRCLR   L0085,#$08,LBDA1	; BR IF N0T b3, (USE HYST FOR VEHICLE SPEED)
;
	LDAA    $15,X			; $673C, 36 MPH Vss THRESH FOR TPS THRES
;
LBDA1	BCLR    L0085,#$08		; CLR b3, (USE HYST FOR VEHICLE SPEED)
	CMPA    L00D1			; FILT  Vss
	BHI     LBDB7			;
;
	LDAB    $18,X			; $673F, 2%, HI SPD TPS THRESH 
	BRSET   L0085,#$40,LBDB4	; BR IF NOT b6, (TCC IS BEING APPLIED) 
;
	BRSET   L0085,#$10,LBDB4	; BR IF b4, (TCC IS IN RELEASE MODE, SLIPPING) 
;
	LDAB    $19,X			;  $6740, 2.7%, HI SPD TPS THRESH 
;
LBDB4	BSET    L0085,#$08		; SET b3,  USE HYST FOR VEHICLE SPEED
;
LBDB7	BRCLR   0,X,#$04,LBDF2		; BR IF NOT b2,  VERY LOW TPS TURNS OFF TCC

	CMPB    L00AC			;
;
LBDBD	BLS     LBDF2			;
;
	BSET    L0087,#$08		; SET b3
	BRSET   L0085,#$40,LBDCC	; BR IF b6, (TCC IS BEING APPLIED) 
;
	BRSET   L0087,#$20,LBDCC	; BR IF b5, 
;
	BRA     LBDF2			;
;				
;------------------------
; CODE FOR TCC BUSYNESS
: (TIMERS)
;-----------------------
;
LBDCC	BRCLR   L0087,#$10,LBDF2	; BR IF NOT b4, 

	BSET    L0087,#$80		; SET b7
	BCLR    L0087,#$10		; CLR b4
	LDD     L0119			; TCC COAST RELEASE TIMER2
	CPD     L674A			; 4 Sec MAX BETWEEN COAST RELEASES 
					; PRIOR TO DELAY IS INCR
	BHI     LBDED			;
;
	LDD     L011F			; TCC DELAY TIMER3
	ADDD    L674E			; 0 SEC AMT TO INCREMENT DELAY
	BCC     LBDEA			; BR IF NO OVERFLOW
;
	LDD     #$FFFF			; USE MAX VALUE
;
LBDEA	STD     L011F			; TCC DELAY TIMER3
;
LBDED	CLRA				;
	CLRB				;
	STD     L0119			; TCC COAST RELEASE TIMER2
;
LBDF2	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     					
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;																						
LBDF3	LDX     L0119			; TCC COAST RELEASE TIMER2
	INX				; INCR TCC COAST TIMER
	BEQ     LBDFC			; BR IF TIMER = Z
;
	STX     L0119			; TCC COAST RELEASE TIMER2
;
LBDFC	LDX     L011B			; TCC DELAY TIMER1
	INX				; INCR TCC DELAY TIMER1
	BNE     LBE03			;
;
	DEX				; DECR TCC DELAY TIMER1
;
LBE03	STX     L011B			; TCC DELAY TIMER1
	CPX     L674C			; 4 SEC INTERVAL USED TO INCR TCC DELAY1
	BCS     LBE1D			; BR IF DELAY LT THRESH
;
	CLRA				;
	CLRB				;
	STD     L011B			; SAVE TCC DELAY TIMER1
	LDD     L011F			; TCC DELAY TIMER3
	SUBD    L6750			; 0.5 SEC AMT TO DECREMENT DELAY
	BCC     LBE1A			; BR IF TIMER GT INCREMENT
;
	CLRA				; ZERO OUT TCC DELAY TIMER
	CLRB				;
;
LBE1A	STD     L011F			; TCC DELAY TIMER3
;
LBE1D	LDD     L011F			; TCC DELAY TIMER3
	CPD     L6748			; 0 SEC MIN LK DLY TIME
	BCC     LBE2C			; BR IF  TCC DELAY TIMER GT THRESH
;
	LDD     L6748			; 0 SEC MIN LK DLY TIME
	STD     L011F			; TCC DELAY TIMER3
;
LBE2C	LDX     #L6727			; INDEX TCC CONSTANTS
	BRCLR   L0087,#$20,LBE46	;
;										
	LDAA    L0121			;
	CMPA    L6752			; 1 SEC TO CONTINUE
	BCC     LBE43			; BR IF 
;
	INCA				;
	BEQ     LBE49			;
;
	STAA    L0121			;
	BRA     LBE49			;				
;											
LBE43	BCLR    L0087,#$20		;
										
LBE46	CLR     L0121			;
;
LBE49	LDAB    L0129			;
	INCB				;
	BEQ     LBE52			;
;
	STAB    L0129			;
;
; HOUSEKEEP TCC ENGAGE DELAY TIMER
;
LBE52	LDAB    L012A			; TCC ENGAGE DELAY TIMER
	INCB				; INCR TIMER
	BEQ     LBE5B			; BR IF TIMER = Z
;
	STAB    L012A			; TCC ENGAGE DELAY TIMER
;
LBE5B	BRSET   L0085,#$40,LBE6C	; BR IF b6, (TCC IS BEING APPLIED)
;
	BRSET   L0085,#$10,LBE6C	; BR IF b4, (TCC IS IN RELEASE MODE, SLIPPING)
;
	LDAB    L0123			;
	INCB				;
	BEQ     LBE6C			;
;
	STAB    L0123			;
;
LBE6C	LDAA    L0182			;
	BEQ     LBE74			;
;
	DECA				;
	BRA     LBE7A			;				
;											
LBE74	BRCLR   L007F,#$08,LBE7D	;

	LDAA    $1E,X			;
;
LBE7A	STAA    L0182			;
;
LBE7D	LDAA    L0122			;
	BEQ     LBE85			;
;
	DECA				;
	BRA     LBE8B			;
;											
LBE85	BRCLR   L007F,#$01,LBE8E	;
;											
	LDAA    $1F,X			;
;
LBE8B	STAA    L0122			;
;
LBE8E	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LBE8F	BRSET   L0086,#$10,LBE9E	;
;
	BRSET   L0087,#$04,LBEA4	;
;
	BRSET   L0087,#$02,LBEA1	;
;
	JMP     LC065			;				
;											
LBE9E	JMP     LC0B7			;
;					
LBEA1	JMP     LBF79			;
;				
LBEA4	BRSET   L0083,#$02,LBEC9	;
;
	BRCLR   L0087,#$80,LBEC9	;
;
	LDD     L011D			;
	CPD     L011F			; TCC DELAY TIMER3
	BCC     LBEC6			;
;											
	BSET    L0087,#$40		;
	ADDD    #$01			;
	BCC     LBEC0			;
;
	LDD     #$FFFF			;
;
LBEC0	STD     L011D			;
	JMP     LC06A			;				
;											
LBEC6	BCLR    L0087,#$80		;
;											
LBEC9	CLRA				;
	CLRB				;
	STD     L011D			;
	BCLR    L0087,#$40		; CLR b6, 
;											
	BRSET   L0085,#$40,LBEE5	; BR IF b6, (TCC IS BEING APPLIED) 
;
	BSET    L0085,#$40		; SET b6, (TCC IS BEING APPLIED
	BCLR    L0085,#$10		; CLR b4, (TCC IS IN RELEASE MODE, SLIPPING)
	CLRA				;
	STAA    L0123			;
	STAA    L0129			;
	STAA    L012A			; CLR TCC ENGAGE DELAY TIMER
;
LBEE5	BRSET   L0086,#$04,LBEFF	; BR IF b2, 
;
	BSET    L0086,#$08		; SET b3, 
	LDAA    L012A			; TCC ENGAGE DELAY TIMER 
	CMPA    L691F			; 0 SEC'S DELAY ENGAGE TO SOLONOID ON
	BCC     LBEF6			; BR IF 
;
	BRA     LBF0B			;				
;											
LBEF6	BSET    L0086,#$06		; SET b1 & b2
	CLR     L012A			; TCC ENGAGE DELAY TIMER
	BCLR    L0086,#$08		; CLR b3
;											
LBEFF	BRSET   L0086,#$01,LBF1D	; BR IF b0, 

	LDAA    L012A			; TCC ENGAGE DELAY TIMER
	CMPA    L6920			; 0 SEC'S DELAY TCC SOLONOID ON TO ENGAGE
	BCC     LBF14			;
;											
LBF0B	LDD     L691B			; 0% MIN TPS D.C
	STD     L0124			;
	JMP     LC0B7			;			   
;									
LBF14	BSET    L0086,#$01		;
	CLR     L012A			; TCC ENGAGE DELAY TIMER
	CLR     L0129			;
;
LBF1D	BSET    L0087,#$10		;
	LDAB    L0129			;
	CMPB    L6923			; 0 SEC'S ENGAGE DURATION 
	BCC     LBF76			;
;
;-----------------------------------------------
; TABLE INDEX
; INDEX NORMAL TCC ENGAGE OPERATING POINT,
; ( %D.C. Vs. %TPS)
; 
;-----------------------------------------------
;
	LDX     #LC1E1			; TABLE INDEX, 
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;											
	BCC     LBF35			;
;
;-----------------------------------------------
; NORMAL ENGAGE OPERATING POINT,
; (%D.C. Vs. %TPS  TBL)
; 3rd GEAR 
;
;-----------------------------------------------
;
	LDX     #L68B5			; NORMAL ENGAGE OPERATING POINT	TABLE
;
LBF35	LDY     #L010B			;
	JSR     LC0B8			;
;											
	LDAA    L0110			;
	BNE     LBF53			;
;			
;----------------------------------------------
; TABLE INDEX
; NORMAL ENGAGE RATE,  %D.C./SEC Vs. %TPS
;
;----------------------------------------------
;
	LDX     #LC243			; TBL INDEX,
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;											
	BCC     LBF4E			;
;
;----------------------------------------------
; NORMAL ENGAGE RATE,  %D.C./SEC Vs. %TPS
; 3rd GEAR
;
;----------------------------------------------
;
	LDX     #L68D7			; NORMAL ENGAGE RATE TABLE
;
LBF4E	LDAA    L00AC			;
	JSR     LF15E			; 2d LK UP
;											
LBF53	LDAB    #$08			;
	MUL				;
	STAA    L0185			;
	ADDB    L0185			;
	ADDB    L0125			;
	BCC     LBF62			; BR IF NOT OVERFLOW
;
	INCB				;
;
LBF62	ADCA    L0124			;
	BCC     LBF6A			; BR IF NOT OVERFLOW
;
	LDD     #$FFFF			; USE MAX VALUE
;
LBF6A	CPD     L00EB			;
	BCC     LBF71			;
;
	LDD     L00EB			;
;
LBF71	STD     L00ED			;
;
	JMP     LC046			;				
;											
LBF76	JMP     LC054			;				
;											
LBF79	BRSET   L0085,#$40,LBF84	; BR IF b6, (TCC IS BEING APPLIED)
;
	BRSET   L0085,#$10,LBF95	; BR IF b4, (TCC IS IN RELEASE MODE, SLIPPING)
;
	JMP     LC065			;				
;											
LBF84	BSET    L0085,#$10		; SET b4, (TCC IS IN RELEASE MODE, SLIPPING) 
	BCLR    L0085,#$60		; CLR b5 & b6 (TCC IS BEING APPLIED)
	CLRA				;
	CLRB				;
	STD     L011D			;
	STAA    L0129			;
	STAA    L012A			; TCC ENGAGE DELAY TIMER
;
LBF95	BRCLR   L0086,#$01,LBFAE	; CLR b0, 
;
	BRCLR   L0086,#$04,LBFAE	;
;
	LDAA    L0129			;
	CMPA    L6924			;
	BLS     LBFE6			;
;										
	BCLR    L0086,#$01		;
	CLR     L012A			; TCC ENGAGE DELAY TIMER
	CLR     L0129			;
;
LBFAE	LDD     L691B			; 0% MIN TPS D.C
	STD     L0124			;
	BRSET   L0086,#$01,LBFD2	;
;
	BRCLR   L0086,#$04,LBFD2	;
;
	LDAA    L012A			; TCC ENGAGE DELAY TIMER
	CMPA    L6921			; 0 SEC'S DELAY FM END OF RELEASE TO SOLONOID OFF
	BHI     LBFC6			;
;
	BRA     LBFDA			;
;			
LBFC6	BCLR    L0086,#$04		;
	CLR     L012A			; TCC ENGAGE DELAY TIMER
	CLR     L0129			;
	BCLR    L0086,#$20		;
;										
LBFD2	LDAA    L012A			; TCC ENGAGE DELAY TIMER
	CMPA    L6922			; 0 SEC'S  DELAY FM SOLONIOD OFF TO TCC DC MAX
	BHI     LBFE0			;
;
LBFDA	BSET    L0086,#$20		;
	JMP     LC0B7			;				
;											
LBFE0	BCLR    L0086,#$22		;
	JMP     LC065			;				
;
LBFE6	LDX     #LC212			;
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;										
	BCC     LBFF3			;
;
;--------------------------------------------------
; RELEASE OPERATING POINT NORMAL MODE CONDITIONS
; %D.C. Vs. %TPS
; GEAR 3
; TBL = MPH * 2
;--------------------------------------------------
;
	LDX     #L6871			; RELEASE OPERATING POINT NORMAL MODE
;
LBFF3	LDY     #L010C			;
	JSR     LC0B8			;
;										
	LDAA    L0110			;
	BNE     LC01C			;
;
	LDAA    L0184			;
	BEQ     LC00A			;
;
	LDAA    L6747			; DIFF TPS CHANGE TCC DC BY 4000%/SEC,
					; IF DISS TPS G.T. L6742  
	CLRB				;
	BRA     LC025			;				
;											
;--------------------------------------------------
; INDEX ADDRES TABLE ...
; NORMAL RELEASE RATE, %D.C./SEC Vs. %TPS
;
;--------------------------------------------------
;
LC00A	LDX     #LC274			; INDEX ADDRES TABLE 
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;
	BCC     LC017			;
;
;--------------------------------------------------
; NORMAL RELEASE RATE,
; (%D.C./SEC Vs. %TPS)
; 3rd GEAR
; TLB =  %D.C./SEC * 204
;--------------------------------------------------
;
	LDX     #L6893			; NORMAL RELEASE RATE TABLE
;
LC017	LDAA    L00AC			;
	JSR     LF15E			; 2d LK UP
;										
LC01C	LDAB    #$08			;
	MUL				;
	STAA    L0185			;
	ADDB    L0185			;
;
LC025	SUBB    L0125			;
	BCC     LC02B			;
;
	DECB				;
;
LC02B	SBCA    L0124			;
	BCS     LC034			;
;										
	CLRA				;
	CLRB				;
	BRA     LC03F			;
;										
LC034	NEGA				;
	NEGB				;
	SBCA    #$00			;
	CPD     L00EB			;
	BLS     LC03F			;
;								
	LDD     L00EB			;
;
LC03F	STD     L00ED			;
	BRA     LC046			;				
;											
	JMP     LC065			;				
;											
LC046	LDD     L00ED			;
	CPD     L691B			; 0% MIN TPS D.C
	BCS     LC05C			;
;
	CPD     L0127			;
	BCS     LC05F			;
;
LC054	LDD     L0127			;
	BSET    L0085,#$20		; SET b5, (TCC IS IN LOCK ADJ MODE) 
	BRA     LC05F			;
;											
LC05C	LDD     L691B			; 0% MIN TPS D.C
;
LC05F	STD     L0124			;
	JMP     LC0B7			;				
;											
LC065	CLRA				;
	CLRB				;
	STD     L011D			;
;
;-----------------------------    
; 30, TCCMODE, TCC MODE WD	     
;
;  b6 1 = TCC IS BEING APPLIED    
;  b5 1 = TCC IS IN LOCK ADJ MODE   
;  b4 1 = TCC IS IN RELEASE MODE SLIPPING
;-----------------------------   
; 
LC06A	BCLR    L0085,#$70		; CLR b, (0111 0000)
	BCLR    L0086,#$05		; CLR b0 & b2
	BCLR    L0086,#$28		; CLR & b5, b3 
	CLR     L012A			; TCC ENGAGE DELAY TIMER
	BRCLR   L0086,#$02,LC083	; BR IF NOT b1, 
;
	LDAA    L6921			; 0 SEC'S DELAY FM END OF RELEASE TO SOLONOID OFF
	STAA    L012B			;
	BCLR    L0086,#$02		; CLR b1
;											
LC083	LDAA    L012B			;
	BEQ     LC08E			;
;
	DECA				;
	STAA    L012B			;
	BRA     LC0A8			;				
;
; CK TCC Vss LOW SPEED QUAL'S
;
LC08E	LDAA    L00D1			; FILT  Vss
	CMPA    L691D			; 6 MPH VSS FOR MAX TCC D.C.
	BCC     LC0A3			; BR IF Vss LT 6 MPH
;
	CMPA    L691E			; 4 MPH VSS FOR MIN TCC D.C.
	BLS     LC0A8			; BR IF Vss GT 4 MPH
;
	LDD     L0124			;
	CPD     L0127			;
	BNE     LC0A8			;
;
LC0A3	LDD     L0127			;
	BRA     LC0AB			;
;											
LC0A8	LDD     L691B			; 0% MIN TPS D.C
;
LC0AB	TST     L010A			;
	BNE     LC0B4			;
;
	BRSET   L0093,#$08,LC0B7	;
;
LC0B4	STD     L0124			;
;
LC0B7	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~
;											
LC0B8	LDAA    0,Y			;
	TAB				;
	BNE     LC10A			;
;
	PSHX				;
	CLR     L0188			;
;
;-----------------------------------------
; OPERATING POINT MULT Vs. LINE PRESSURE
;
;-----------------------------------------
;
	LDX     #L690A			;
	LDAA    L00DC			;
	ASLA				;
	BCC     LC0CC			; BR IF NO OVERFLOW
;											
	LDAA    #$FF			; FORCE MAX VALUE
;
LC0CC	JSR     LF15E			; 2D LK UP
	PULX				;
	PSHA				;
	LDAB    0,X			;
	MUL				;
	STD     L0186			;
	PULB				;
	LDAA    L00AC			;
	JSR     LF15E			; 2D LK UP
;											
	MUL				;
	SUBD    L0186			;
	ROL     L0188			;
	NEG     L0188			;
	ASLD				;
	ROL     L0188			;
	ADDA    0,X			;
	PSHB				;
	LDAB    L0188			;
	ADCB    #$0000			;
	PULB				;
	BGE     LC0F8			;
;										
	CLRA				;
	CLRB				;
;
LC0F8	BNE     LC107			;
;											
	STAA    L0185			;
	ADDB    L0185			;
	BCC     LC10A			;
;											
	ADDD    #L0101			;
	BCC     LC10A			;
;											
LC107	LDD     #$FFFF			;
;
LC10A	SUBA    #$0080			;
	ADDA    1,Y			;
	BVC     LC118			;
;											
	LDD     #$7FFF			;
	ADCB    #$00			;
	ADCA    #$00			;
;
LC118	ADDA    #120			;
	STD     L00EB			;
;
	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;***************************************************
;* XMISSION TCC TABLES POINTER TABLE
;*
;* TYPE $E6
;*************************************************** 
;              
;--------------------------------------------------
; TCC CONTROLLED ENGAGE THRESH ADDRES TABLE'S 
;
; 09-10-1996  Dissassemby of BDWM  Lines= 2048 
;
;  TBL =  1  * 
;--------------------------------------------------
;    
LC11D   FCB $8			; 8 BYTES/BLOCK

LC11E   FDB $0000		; 1st GR not used
	FDB L681C		; 2nd GR Hot tcc controlled engage thresh
	FDB L682D		; 3rd GR Hot tcc controlled engage thresh
	FDB L683E		; 4th GR Hot tcc controlled engage thresh
;
LC126   FDB $0000		; 1st GR not used
	FDB $0000		; 2nd GR not used
	FDB L67FA		; 3rd Gear normal TCC Engage thresholds
	FDB L680B		; 4th Gear normal TCC Engage thresholds
;
LC12E   FDB $0000		; 1st GR not used
	FDB $0000		; 2nd GR not used
	FDB L67FA		; 3rd GR Cruise controlled TCC Engage thresh
	FDB L680B		; 4th GR Cruise controlled TCC Engage thresh
;
LC136   FDB $0000		; 1st GR not used
	FDB $0000		; 2nd GR not used
	FCB L684F		; 3rd Gear normal TCC Engage thresholds
	FCB L6860		; 4th Gear normal TCC Engage thresholds
;
;--------------------------------------------------
; TCC APPLY DETENT THRESHOLDS
;                                
;--------------------------------------------------
;
LC13E   FDB $0000		;
	FDB $0000		;
	FDB L67FA		;
	FDB L680B		;
;
LC146   FDB $0000		;
	FDB $67E9		;
	FDB L67FA		;
	FDB L680B		;
;
;--------------------------------------------------
;  TCC ON/OFF CAL'S
;                                
;--------------------------------------------------
;
LC14E   FCB $8			; 8 BYTES/BLOCK

LC14F   FDB $0000		;
	FDB $675B		; MPH 2nd GR Hot engage detent thresh
	FDB $675C		; MPH 3RD GR Hot engage detent thresh
	FDB $675D		; MPH 4TH GR Hot engage detent thresh
;
LC157   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC15F   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC167   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC16F   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;

LC177   FDB L0000		;
	FDB L6755		; MPH 2nd GR Engage detent thresh
	FDB L6756		; MPH 3rd GR Engage detent thresh
	FDB L6757		; MPH 4th GR Engage detent thresh
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LC17F   FCB $8			; 8 BYTES/BLOCK
;
;--------------------------------------------------
;  CONTROLED HOT TCC RELEASE THRESH, MPH Vs. %TPS
;
;--------------------------------------------------
;
LC180   FDB $0000		;
	FDB L6794		; 2nd GR Controled hot tcc release thresh
	FDB L67A5		; 3rd GR Controled hot tcc release thresh
	FDB L67B6		; 4th GR Controled hot tcc release thresh
;
;--------------------------------------------------
; NORM CONTROLED RELEASE THRESH IN MPH Vs. %TPS
;
;--------------------------------------------------
;
LC188   FDB $0000		;
	FDB $0000		;
	FDB L6772		; 3rd GR Norm controled release thresh
	FDB L6783		; 4th GR Norm controled release thresh
;
LC190   FDB $0000		;
	FDB $0000		;
	FDB L6772		; 3rd GR Norm controled release thresh
	FDB L6783		; 4th GR Norm controled release thresh
;
;--------------------------------------------------
; CRUISE CONTROLED TCC RELEASE THRESH, MPH Vs. %TPS
; 
;--------------------------------------------------
;
LC198   FDB $0000		;
	FDB $0000		;
	FDB L67C7		; 3rd GR Cruise controled tcc release thresh
	FDB L67D8		; 4th GR Cruise controled tcc release thresh
;
LC1A0   FDB $0000		;
	FDB $0000		;
	FDB L6772		; 3rd GR Norm controled release thresh
	FDB L6783		; 4th GR Norm controled release thresh
;
;------------------------------------------------------
; NORM CONTROLED RELEASE THRESH IN MPH Vs. %TPS
; 
;------------------------------------------------------
;
LC1A8   FDB $0000		;
LC1AA   FDB L6761		;
LC1AC   FDB L6772		; 3rd GR Norm controled release thresh
LC1AE   FDB L6783		; 4th GR Norm controled release thresh
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LC1B0   FCB $8			; 8 BYTES/BLOCK
;
;------------------------------------------------------
; MPH HOT RELEASE DETENT THRESH
;
;------------------------------------------------------
;
LC1B1   FDB $0000		;
	FDB L675E		; 2nd GR MPH Hot release detent thresh
	FDB L675F		; 3rd GR MPH Hot release detent thresh
	FDB L6760		; 4th GR MPH Hot release detent thresh
;
LC1B9   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC1C1   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC1C9   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC1D1   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
;--------------------------------------------------
;  MPH 2nd GR RELEASE DETENT THRESH
;
;--------------------------------------------------
;
LC1D9   FDB $0000		;
	FDB L6758		; 2nd GR MPH 2nd GR Release detent thresh
	FDB L6759		; 3rd GR MPH 2nd GR Release detent thresh
	FDB L675A		; 4tH GR MPH 2nd GR Release detent thresh
;
;--------------------------------------------------
; NORMAL TCC ENGAGE OPERATING POINT, %D.C. Vs. %TPS
; 
;--------------------------------------------------
;
LC1E1   FCB $8			; 8 BYTES/BLOCK
;
LC1E2   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
LC1EA   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
LC1F2   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
LC1FA   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
LC202   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
LC20A   FDB $0000		;
	FDB $0000		;
	FDB L68B5		; 3rd GR, NORMAL TCC ENGAGE OPERATING POINT
	FDB L68C6		; 4th GR, NORMAL TCC ENGAGE OPERATING POINT
;
;--------------------------------------------------
; RELEASE OPERATING POINT NORMAL MODE CONDITIONS
; (%D.C. Vs. %TPS)
; 
;--------------------------------------------------
;
LC212   FCB $8			; 8 BYTES/BLOCK
;
LC213   FDB $0000		;
	FDB $0000		;
	FDB L6871		;  3rd GR, Release operating point normal mode condition
	FDB L6882		;  4th GR, Release operating point normal mode condition
;
LC21B   FDB $0000		;
	FDB $0000		;
	FDB L6871		;  3rd GR, Release operating point normal mode condition
	FDB L6868		;  4th GR, 	 ????
;
LC223   FDB $0000		;
	FDB $0000		;
	FDB L6871		;  3rd GR, Release operating point normal mode condition
	FDB L6882		;  4th GR, Release operating point normal mode condition
;
LC22B   FDB $0000		;
	FDB $0000		;
	FDB L6871		; 3rd GR, Release operating point normal mode condition
	FDB L6881		; 4th GR  ?????
;
LC233   FDB $0000		;
	FDB $0000		;
	FDB L6871		;  3rd GR, Release operating point normal mode condition
	FDB L6882		;  4th GR, Release operating point normal mode condition
;
LC23B   FDB $0000		;
	FDB $0000		;
	FDB L6871		;  3rd GR, Release operating point normal mode condition
	FDB L6882		;  4th GR, Release operating point normal mode condition
;
;--------------------------------------------------
; NORMAL ENGAGE RATE,  %D.C./SEC Vs. %TPS
;
;
;--------------------------------------------------
;
LC243   FDB $8			; 8 BYTES/BLOCK
;
LC244   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
LC24C   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
LC254   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
LC25C   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
LC264   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
LC26C   FDB $0000		;
	FDB $0000		;
	FDB L68D7		; 3rd GR Normal engage rate, %D.C./SEC Vs. %TPS
	FDB L68E8		; 4th GR Normal engage rate, %D.C./SEC Vs. %TPS
;
;--------------------------------------------------
; NORMAL RELEASE RATE, %D.C./SEC Vs. %TPS 3rd GEAR
;
;
;--------------------------------------------------
;
LC274   FCB $8			; 8 BYTES/BLOCK

LC275   FDB $0000		;
	FDB $0000		;
	FDB L6893		;  3rd GR, Normal release rate
	FDB L68A4		;  4tH GR, Normal release rate
;
LC27D   FDB $0000		;
	FDB $0000		;
	FDB L6893		;
	FDB L68A4		;
;
LC285   FDB $0000		;
	FDB $0000		;
	FDB L6893		;
	FDB L68A4		;
;
LC28D   FDB $0000		;
	FDB $0000		;
	FDB L6893		;
	FDB L68A4		;
;
LC295   FDB $0000		;
	FDB $0000		;
	FDB L6893		;
	FDB L68A4		;
;
LC29D   FDB $0000		;
	FDB $0000		;
	FDB L6893		;
	FDB L68A4		;
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LC2A5   FDB $8			; 8 BYTES/BLOCK

LC2A6   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2AE   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC2B6   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2BE   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2C6   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2CE   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LC2D6   FCB $8			; 8 BYTES/BLOCK

LC2D7   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2DF   FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
LC2E7   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2EF   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2F7   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
LC2FF   FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 40 Hz entry point for TPS handling
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC307	JSR	LB185			;TPS handling routine
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Trans error handling subroutines jump table
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC30B	JSR	LE6B4			;	
;
	JSR	LE74D			;
;
	JSR	LEC7F			;
;
	JSR	LED0A			;
;
	JSR	LED63			;
;
	JSR	LE9DC			;
;
	JSR	LEAAE			;
;
	JSR	LEDD5			;
;
	JSR	LEDD6			;
;
	JSR	LEE44			;
;
	RTS     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~             
;
;--------------------------------------------             
;
;
;--------------------------------------------
;
LC32A	LDAB    L00D3			; GEAR NUMBER
;
LC32C	LDX     #LB3A1			;
	ABX				;
;
LC330	LDAA    0,X			;
;											
LC332	LDAB    L004C			; I/O PORT D 
	ANDB    #$FC			; 1111 1100
;
LC337	ABA				;
	STAA    L004C			;
;
LC33B	LDX     #L039B			; INDEX ALDL CNT'L WD 11
	BRCLR   1,X,#$40,LC348		; BR IF NOT b6
;
	BRSET   2,X,#$40,LC35C		; BR IF b5
;
	BRA     LC361
;
LC348	BRSET   L0093,#$08,LC361	; BR IF b3
;
	BRSET   L001C,#$02,LC361	; BR IF b1
;										 	
	BRSET   L001D,#$80,LC361	; BR IF b7
;										 	
	BRSET   L0082,#$01,LC361	; BR IF b0, 1 = REIVE OR REV GEAR
;										 	
	BRSET   L008A,#$80,LC361	; BR IF b7
;										 	
LC35C	BSET    L004C,#$20		; SET b5, I/O PORT D 
;
LC35F	BRA     LC364			;
;
LC361	BCLR    L004C,#$20		; CLR b5, I/O PORT D
;
;-----------------------------------------
;
;
;-----------------------------------------
;
LC364	LDAA    L004B
	LDX     #L039B
;
; SERIAL DATA MD WORD	
;  	b7 1 = 2nd BYTE 8192 TX IS PENDING	
;
	BRCLR   L003B,#$08,LC37B	; BR IF NOT b3, IN MODE 4, ($F5)
;
	BRCLR   1,X,#$20,LC37B		; BR IF NOT b5
;
	ORAA    #$80				;
	BRSET   2,X,#$20,LC383		; BR IF b5,
;
	ANDA    #$7F			;
	BRA     LC383			;				
;										
LC37B	ORAA    #$80			;
	BRSET   L0086,#$04,LC383	; BR IF b2, 
;
	ANDA    #$7F			; CLR b7
;
LC383	STAA    L004B			;
;
; DIG I/O MODE WD,
; 1 = TCC FOR TH700R4, A4 NON ELECT XMISH
;
	LDX     #L400F			; MODE WD, DIG I/O
	BRSET   0,X,#$40,LC3A5		;
;
	BCLR    L0087,#$01		;
	LDD     L0124			;
	CPD     L691B			; 0% MIN TPS D.C
	BLS     LC39F			;
;
	BRCLR   L0086,#$04,LC39F	; BR IF NOT b2, 
;
	BSET    L0087,#$01		; SET b0, 
;											
LC39F	TAB				;
	LDAA    #$7F			; 0111 1111
	STD     L306A			;
;											
LC3A5	BRSET   0,X,#$01,LC3B9		; BR IF b0, 
;
	LDX     #L400E			; MODE WD, AFR 4 
	BRSET   0,X,#$04,LC3B9		; BR IF b2, 1 = SHIFT LIGHT ENABLE 
;
	LDAB    L012E			;
	LDAA    L012F			;
	STD     L306C			;
;
LC3B9	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; A/D lead-in, get fuel pump volts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC3BA   LDX     #L3000			;CPU reg's base
	LDAA    #$02			;
	JSR     LEF12			;Port D config routine
;
	LDAA    #$01			;
	SEI     			;Disable interrupts
	JSR     LEEFC			;A/D routine
;
	LDAB    $34,X			;Get A/D result from channel 4
	CLI				;Re-enable interrupts
	STAB    L0055			;Fuel pump volts x 10
	RTS 				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~			    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine for MAP/Baro handling
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC3CE	LDX     #L5D02			;Opt. byte
	BRCLR   0,X,#$04,LC3F1		;Bra if b2==0, use MAP only
;
;-Here if using MAP and Baro
;
	LDX     #L3000			;Base CPU reg. addr.
	SEI				;Disable interrupts     
	LDAA    #$0005			;Select MAP channel
	JSR     LEF12			;Port D config routine
;
	LDAA    #$0001			;Select channel
	JSR     LEEFC			;A/D routine
;
	CLI				;Enable interrupts     
	LDAA    $34,X			;Get in A/D value
	STAA    L0316			;Save it, A/D baro
	ADDA    #11			;14.5 kPa
	BCC     LC454			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
	BRA     LC454			;Bra to continue with baro calcs.
;
;-Here to use MAP only
;
LC3F1	CLRA				;  
	BRSET   L0044,#$10,LC44A	;Status word, bra if b4==1, ign. off

	LDAB    L01E9			;A/D MAP
	CMPB    L0317			;
	BHI     LC44A			;Bra if A/D MAP is >

	BRSET   L006F,#$40,LC464	;Status word, Bra if b6=1, high MAP error
;
	LDAA    L006F			;Status word
	ANDA    #$0C			;Clear all but b2=TPS high error, b3=Low MAP error
	BEQ     LC40D			;Bra if b2, b3==0
;
	CMPB    L4E5E			;Default MAP val
;											
	BCS     LC464			;Bra if MAP is less
;
LC40D	LDAA    L0061			;Load scaled rpms
	CMPA    L4153			;Upper rpm limit for pseudo-baro
	BHI     LC45F			;Bra if RPMs are >
;
	CMPA    L4154			;Lower limit for pseudo-baro
	BCS     LC45F			;Bra if rpms are <
;
	LDAA    L0006			;Cool temp, linear
	CMPA    L4158			;Min cool temp for pseudo-baro
;
	BCS     LC45F			;Bra if cool temp is less
;
	LDAA    L01FC			;%TPS
	CMPA    L4155			;Min %TPS for pseudo-baro
	BLS     LC45F			;Bra if %TPS is <=
																								
	SUBA    L0201			;Subtract slow filtered %TPS
	BCC     LC42E			;Bra if %TPS >=
;
	NEGA 				;Make delta tps positive   
;
LC42E	CMPA    L4156			;2% delta tps, max delta TPS for pseudo-baro
	BHI     LC45F			;Bra if delta TPS is >, no pseudo-baro
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-All quals passed, do pseudo-baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0062			;RPM/25
	LDAB    #171			;RPM multiplier
	MUL					;RPMs x Mult. 
	ADCA    #0			;Round if needed
	CMPA    #128			;Upper limit
	BLS     LC440			;Bra if <=
;
	LDAA    #128			;Load max

LC440	LDAB    L01FC			;%TPS
	LSRB				;/2 for lookup
	LDX     #L454E			;Baro correction table
	JSR     LF17B			;3D look up

	ADDA    L01E9			;Add it into current MAP value
	BCC     LC451			;Bra if no overflow

	LDAA    #255			;Clear overflow	
;
LC451	STAA    L0316			;Save it, pseudo-baro
;
LC454	LDAB    L4157			;Baro filter coeff.
	LDX     L0317			;Load old baro value
	JSR     LF0F6			;Filter routine
;
        BRA     LC46B			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Baro Init and Lookup Routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC45F	LDAA    L0317			;Filtered baro
	BNE     LC46E			;Bra if !=0
;
LC464	LDAA    L4E5E			;90.8 Kpa default MAP 
	CLRB    			;Preclear B
	STAA    L0316			;Save it, Baro
LC46B	STD     L0317			;Save it, filtered Baro
;
;-Here if Baro already updated
;
; Baro val. for lookup = .590 x Baro - 7.26
; kPa = .625 x baro val. for lookup + 14.9
; 
LC46E	TAB 				;Baro into B
	LDAA    #143			;Use max baro if baro zero'd out
	SUBB    #13			;A/D baro-13
	BCS     LC47A			;Bra if underflow, baro zero'd out
;
	LDAA    #151			;Multiplier for baro val.
;
	MUL				;[143 x (A/D baro - 13)]/256     
	ADCA    #0			;Round if needed
;
;-Look up delta TPS AE mult. factor vs. baro
;
LC47A	STAA    L01EF			;Save it, baro val. for lookup
	LDAB    #96			;offset for lookup
	LDX     #L4B56			;TPS AE mult. factor vs. baro
	JSR     LF15A			;2D lookup with SBA
;
	STAA    L0207			;Save it, delta TPS AE baro factor

;
;-Look up PE baro TPS factor
;
	LDAA    L01EF			;Baro val. for lookup
	LDAB    #96			;offset for lookup
	LDX     #L4C7F			;PE baro TPS factor
	JSR     LF15A			;2D lookup with SBA
;
	STAA    L0206			;Save it 
;
;-Lookup PE RPM qual. threshold vs. Baro
;
	LDAA    L01EF			;Load baro
	LDAB    #96			;Offset for lookup
	LDX     #L496B			;PE RPM qual. vs baro table
	JSR     LF15A			;2D lookup with SBA
	STAA    L01F0			;Save it

;
;-Lookup alt. comp. value for MAP
;
	LDAA    L01EF			;Load baro for lookup
	LDAB    #96			;offset
	LDX     #L49C7			;Baro val vs. baro table
	JSR     LF15A			;2D lookup with SBA
;	
	STAA    L01F1			;Baro val for MAP/baro ratio calc
	RTS     			;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Filtered trans baro routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC4B3	LDX	#L5B00			;Start addr. of diag. words
	LDY     #L5D02			;Opt. byte
	BRCLR   $30,X,#$04,LC4C4	;Err. word #6 mask, bra if b2==0, not recognising
					;err. 63, high baro press.
;
	BRCLR   L001B,#$04,LC4C4	;Err word #6, bra if b2==0, no err. 63 set
;
	BRA     LC4D1			;Bra if error flagged
;
;-Here if no high baro sens. error flagged, check MAP
;	
LC4C4	BRCLR   $2D,X,#$20,LC4D5	;Err. word #3 mask, bra if b5==0, err. 32, 
					;high MAP sens. not being recognised
;
	BRCLR	L0018,#$20,LC4D5	;Err. word #3, bra if b5==0, err. 32,
					;high MAP sens. not flagged
;
	BRSET   0,Y,#$04,LC4D5		;Bra if b2==1, bra if using baro/MAP
;
;-Here if baro sens./MAP high error set
;
LC4D1	LDD     $006B,X			;Load default baro
	BRA     LC503			;Bra to continue
;
;-Here if no error flagged, check for low MAP/baro
;											
LC4D5	BRCLR   $0030,X,#$02,LC4DF	;Err. word #6 mask, bra if b1==0, not recognising
					;err. 64, low baro
;
	BRCLR   L001B,#$02,LC4DF	;Err word #6, bra if b1==0, no err 64, 
					;low baro set
;
	BRA     LC4EC			;Bra if error flagged
;											
LC4DF	BRCLR   $2D,X,#$10,LC4F0	;Error word #3 mask, bra if b4==0, not recognising
					;err. 33, low MAP sens.

	BRCLR   L0018,#$10,LC4F0	;Error word #3, bra if b4==0. no err 33 flagged 
;
	BRSET   0,Y,#$04,LC4F0		;Bra if b2==1, bra if using baro/MAP
;
LC4EC	LDD     $6F,X			;Load default baro
	BRA     LC503			;Bra to save and return		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Filter baro if no error
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC4F0	LDAA    L0316			;Load baro
	LDAB    L5D05			;Baro scalar
	MUL				;Baro x baro scalar
	ADDD    L5D06			;Add in bias  
	LDX     L00A6			;Load trans baro press
	LDY     #$5D08			;Laod filter coeff.
	JSR     LF0D3			;Filter routine
;
;-Trans baro kPa x 256=44.65x(baro +28.2) + kPa bias
;
LC503	STD     L00A6			;Stored trans. baro
	RTS				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;													
;--------------------------------------------------
;
;
;--------------------------------------------------
;
LC506	LDX     #L6727			; TCC ENABLE FLAGS											;
	LDD     #$00			;
	STD     L0088			;
;											
	BRCLR   0,X,#$08,LC51D		; BR IF NOT b3, SOME PK/NT SW POSITS TURN OFF TCC
;
	BRCLR   L009C,#$03,LC51D	;
;
	BRSET   L0083,#$02,LC51D	;
;
	BSET    L0088,#$01		;
;											
LC51D	BRCLR   0,X,#$20,LC530		; BR IF NOT b5, TCC off for cold xmish
;
; CK TCC XMISH TEMP QUAL'S
;
	LDAA    4,X			; $672B, 20c COLD XMISH THRESH FOR TCC OFF 
	BRCLR   L0087,#$01,LC529	; BR IF NOT b0, 
;
	LDAA    5,X			; $672C, 17c COLD XMISH THRESH FOR TCC ON
;
LC529	CMPA    L00AF			; XMISH TEMP
	BLS     LC530			; BR IF TEMP LT THRESH
;
	BSET    L0088,#$02		; SET b1, 
;											
LC530	BRCLR   0,X,#$40,LC543		; BR IF NOT b6, (TCC OFF FOR COLD ENGINE)
;
; CK TCC ENG COOL QUAL'S
;
	LDAA    2,X			; $6729, 60c COLD ENG THRESH FOR TCC OFF 
	BRCLR   L0087,#$01,LC53C	;
;
	LDAA    3,X			; $672A, 56c COLD ENG THRESH FOR TCC ON
; 
LC53C	CMPA    L00A3			; ENG COOL FOR XMISH
	BLS     LC543			;
;
	BSET    L0088,#$04		; SET b2, 
;											
LC543	BRCLR   L0096,#$01,LC54A	; BR IF NOT b0, 
;
	BSET    L0088,#$08		; SET b3, 
'											
LC54A	BRCLR   0,X,#$02,LC55D		;  BR IF NOT b1, RAPID TPS DECEL TURNS OFF TCC
;
	LDAA    L0183			;
	BEQ     LC55D			;
;
	BRCLR   L0085,#$40,LC55A	; BR IF NOT b6, (TCC IS BEING APPLIED) 
;
	BSET    L0087,#$20		; SET b5,
;
LC55A	BSET    L0088,#$10		; SET b4, 
;											
LC55D	BRCLR   0,X,#$01,LC569		; BR IF NOT b0,	(DN SHIFT TURNS OFF TCC)
;
	LDAA    L0182			;
	BEQ     LC569			;
;
	BSET    L0088,#$20		;
;											
LC569	BRCLR   1,X,#$10,LC575		;
;
	LDAA    L0122			;
	BEQ     LC575			;
;
;	BSET    L0089,#$01		;
											
LC575	BRCLR   1,X,#$02,LC595		;
;
	BRSET   L0083,#$02,LC595	;
;
	BRCLR   L0096,#$02,LC595	;

	LDAB    L00D3			; GEAR NUMBER
	BEQ     LC595			;
;
	ABX				;
	LDAA    7,X			;
	BRSET   L0087,#$01,LC58E	;
;
	LDAA    $0A,X			;
;
LC58E	CMPA    L00D1			; FILT  Vss
	BLS     LC595			;
;
	BSET    L0088,#$40		;
;											
LC595	LDX     #L6727			; INDEX TCC CONSTANTS
	BRCLR   1,X,#$01,LC5A3		; BR IF NOT b0, (SLIP & NOT IN HOT MODE..
;
	BRCLR   L0085,#$80,LC5A3	; BR IF NOT b7,  (NEG SLIP RECENTLY PREVENTS 
;															 .. TCC APPLY)
	BSET    L0088,#$80		;
;											
LC5A3	BRCLR   1,X,#$04,LC5B1		; BR IF NOT b2, (MIN TPS TURNS OFF TCC)
;
	BRCLR   L0087,#$08,LC5B1	;
;
	BCLR    L0087,#$08		;
	BSET    L0089,#$02		;
;											
LC5B1	BRCLR  1,X,#$04,LC5E2		; BR IF NOT b2, (MIN TPS TURNS OFF TCC)
;
	JSR     LE434			;		
;		
	BRCLR   L0092,#$40,LC5D5	;
;
;-----------------
; 2  LINE TABLE
; IF TCC OFF FOR ERRORS
; & TEMP LT or GT 
;-----------------
;
	LDX     #L6735			; INDEX 2  LINE TABLE 
	BRSET   L0085,#$04,LC5C4	; BR IF NOT b2,  LOW THRESH FOR COPE TCC SELECTED 
;
	INX				;
;
LC5C4	LDAA    L00AF			; XMISH TEMP
	CMPA    0,X			; XMISH TEMP THRESH, (TCC OFF)
	BHI     LC5D2			;
;
	BCLR    L0085,#$04		; CLR b2, LOW THRESH FOR COPE TCC SELECTED?
	BSET    L0089,#$04		;											;
	BRA     LC5D5			;
;																					;
LC5D2	BSET    L0085,#$04		; SET b2,  LOW THRESH FOR COPE TCC SELECTED
;											
LC5D5	BRCLR   L0093,#$04,LC5E2	;
											
	LDAA    L00D3			; GEAR NUMBER
	CMPA    #$03			;
	BEQ     LC5E2			;
;
	BSET    L0089,#$08		;
;
;-----------------------------------------
; LOCKED TCC CALIBRATIONS
; MAX TCC D.C. Vs. PSI 
;
; TBL = %D.C. * 2.56
;-----------------------------------------
;
LC5E2	LDX     #L68F9			; INDEX  LOCKED TCC CALIB TBL
	LDAA    L00DC			;
	ASLA				; n x 2
	BCC     LC5EC			; BR IF NO OVERFLOW
;
	LDAA    #$FF			; USE MAX VALUE
;
LC5EC	JSR     LF15E			; 2D LK UP
;										
	TAB				;
	STD     L0127			;
	LDAA    L010A			;
	BEQ     LC622			;
;
	CMPA    #200			;
	BLS     LC606			;
;
	BRCLR   L0086,#$10,LC603	; BR IF NOT b4, 
;
	BCLR    L0086,#$14		; CLR b4 & b2
;			
LC603	JMP     LC6CA			;				
;																					
LC606	CMPA    #100			;
	BLS     LC614			;
;
	BRCLR   L0086,#$10,LC611	; BR IF NOT b4, 
;							
	BCLR    L0086,#$14		; CLR b4 & b2
;										
LC611	JMP     LC6C2			;				
;											
LC614	LDAB    #$00A3			;
	MUL				;
	ASLD				;
	ASLD				;
	STD     L0124			;
	BSET    L0086,#$14		; SET b2, & b4
	JMP     LC6D0			;				
;											
LC622	BRCLR   L0093,#$08,LC62E	;
;
	CLRA				;
	CLRB				;
	STD     L0124			;
;
	JMP     LC6BD				
;											
LC62E	BRCLR   L0086,#$10,LC635	; BR IF NOT b4
;
	BCLR    L0086,#$14		; CLR b2, & b4
;					 
LC635	BRSET   L0088,#$08,LC64A	; BR IF b3,  
;
	BRSET   L0088,#$20,LC64A	; BR IF b5, 
;
	BRCLR   L0093,#$04,LC64A	; BR NOT b2,
;
	LDAA    L00D3			; GEAR NUMBER
	CMPA    #$03			; 4 TH GRAR
	BNE     LC64A			; BR IF 
;
	JMP     LC6C2			;				
;											
LC64A	LDD     L0088			;
	BNE     LC6BD			; BR IF NZ
;
	LDAA    L0184			;
	BNE     LC6CA			; BR IF NZ
;
	LDX     #L5B2B			; INDEX XMISH ERR MASK'S
;
; CURRENT ERR WD 3
; $F5
;
	BRCLR   L0018,#$30,LC65E	; BR IF NOT b4 & b5
;
	BRSET   2,X,#$30,LC66D		; BR IF b0 & b1
;
LC65E	LDAB    L6753			; 0d
;
	BRSET   L0085,#$40,LC668	; BR IF b6, (TCC IS BEING APPLIED) 
;
	LDAB    L6754			; TCC on/off cal
;
LC668	CMPB    L01E3			; S/D MAP
	BHI     LC6CA			;
;
;---------------------------------------------
; TCC CONTROLLED ENGAGE THRESH ADDRES TABLE'S
;
;---------------------------------------------
;
LC66D	LDX     #LC11D			; TCC Controlled engage table's
;											 
	BRCLR   L0085,#$40,LC677	; BR IF NOT b6, (TCC IS BEING APPLIED) 
;
	LDAB    #$0062			;
	ABX				;
;
LC677	PSHX				;
	BRCLR   L0096,#$10,LC68F	;
;											
	LDAB    #$31			;
	ABX				;
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;	
	BCS     LC68F			;
;				
	PULY				;
	LDAA    0,X			;
	STAA    L0126			;
;											
	BRA     LC6A1				
;											
LC68F	PULX				;
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;
	BCS     LC6BD			;
;
	LDAA    0,X			;
	STAA    L0126			;
;					
	LDAA    L00AC			;
	JSR     LF15E			; 2d LK UP
;											
;-------------------------------------------------
;										
;										
;										
;-------------------------------------------------
;
LC6A1	LDX     #LC2A5			; INDEX A BLOCK OF ADDRESSES
;										
	BRCLR   L0096,#$10,LC6AB	; BR IF NOT b4
;					
	LDAB    #$0031			;
	ABX				;
;    
LC6AB	CLRB				;    
	JSR     LD934			;
;
	CMPA    L0126			;
	BCC     LC6B7			;
;						
	LDAA    L0126			;
;
LC6B7	CMPA    L00D1			; FILT  Vss
	BHI     LC6CA			;
;
	BRA     LC6C2			;
;
LC6BD	BCLR    L0087,#$06		; CLR b1 & b2
;
	BRA     LC6D0
;
LC6C2	BCLR    L0087,#$02		; CLR b1
	BSET    L0087,#$04		; SET b2
	BRA     LC6D0			;
;
LC6CA	BSET    L0087,#$02		; CLR b1
;
	BCLR    L0087,#$04		;
;
LC6D0	RTS				;Return     
;--------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC6D1	JSR     LEC80			;
;
	JSR     LECCD			;
;
	JSR     LEAEE			;
;
	JSR     LEB2F			;
;
	JSR     LEB70			;
;
	JSR     LE7EF			;
;
	JSR     LE82B			;
;
	JSR     LEA28			;
;
	JSR     LE8C6			;
;
	JSR     LE8C7			;
;
	JSR     LE8C8			;
;
	JSR     LE8FC			;
;
	RTS				;     
;--------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to look up linear trans temp
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC6F6	LDAA    L009F			;Transmission temp
	LDX     #LF8EF			;Index cool linear temp table
	BRSET   L0043,#$80,LC706	;
;
	BRSET   L004E,#$02,LC706	;Status word, bra if b1==1, use cool linear temp table
;
	LDX     #LF9EF			;Index warm linear temp table
;
LC706	TAB				;Get into B, use as offset for lookup     
	ABX				;Add in offsert 
	LDAA    0,X			;Load linear temp
;
;-Check if cool temps present
;
	CMPA    #120			;50 deg C, upper hyst. threshold
	BHI     LC717			;Bra if temp is > use warm linear temp table
;
	CMPA    #106			;40 deg C, lower hyst. threshold
	BHI     LC71A			;Bra if temp is >, dont change temp status
;
;-Cold trans temps present
;
	BSET    L004E,#$02		;Set b1, use cool linear table for trans temp lookup
	BRA     LC71A			;Bra to save and return
;
;-Here if warm trans temps present
;
LC717	BCLR    L004E,#$02		;Clear b1, flag to use cool linear temp table 
;
LC71A	STAA    L00AE			;Save linearized trans temp
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to handle trans related temp items
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC71D	LDX     #L5B00			;Diag. masks.
	LDAA    L00AE			;Linearized trans temp
	BRCLR   $30,X,#$40,LC72A	;Diag. word #6 mask, bra if b6==0,
					;not flagging code 58, high trans temp
;
;-Check for error 58
;
	BRSET   L001B,#$40,LC732	;Err. word #6, bra if b6==1, high trans temp err.
;
LC72A	BRCLR   $30,X,#$20,LC734	;Bra if b5==0, not flagging code 59, low trans temp
;
;-Check for error 59
;
	BRCLR   L001B,#$20,LC734	;Bra if b5==0, no low trans temp err. present 
;
;-Load default here
;
LC732	LDAA    $66,X			;Default trans temp
;
LC734	LDAB    #128			;Load as LSB for unfiltered temp
	LDX     L00AF			;Transmission temp, filtered
	LDY     #L5D09			;Trans temp lag filter
	JSR     LF0D3			;Lag filter routine
;
	STD     L00AF			;Trans temp, filtered
;
;-Check trans temp and set status bits accordingly
;
	LDAB    L672E			;Threshold to clear hot transmission status bit
	BRSET   L0083,#$02,LC74B	;Trans status word, bra if hot trans flagged
;
	LDAB    L672D			;Threshold to set hot transmission status bit
;
LC74B	BCLR    L0083,#$02		;Preclear b1
;	
	CBA				;Compare trans temp to threshold
	BCS     LC754			;Bra if trans temp <
;
	BSET    L0083,#$02		;Set b1, hot transmission
;
;-Check 4th gear temp limits
;								
LC754	LDAB    L00A3			;Load engine cool temp for trans
	CMPB    L5D28			;Lower temp threshold to set status bit
	BCC     LC75F			;Bra if temp >
;
	BSET    L0083,#$01		;Set b0, disallow shift into OD
											
LC75F	CMPB    L5D29			;Lower temp threshold to clear status bit
	BLS     LC767			;Bra if cool temp is less
;
	BCLR    L0083,#$01		;Clear b0, allow shift into OD
;											
LC767	CLRA				;
	CMPB    L5D2A			;Lower threshold for cold shift
	BHI     LC770			;Bra if engine cool temp >
;
	COMA				;255
	BRA     LC787			;Bra to save and return
;
LC770	CMPB    L5D2B			;Upper threshold for cold shifr
	BCC     LC787			;Bra if cool temp >
;
;-Generate cold shift temp term
;
	LDAA    L5D2B			;Upper cool temp threshold
	SUBA    L5D2A			;Subtract lower threshold
	CLRB				;Clear LSB
	XGDX				;Swap result into X
	LDAA    L00A3			;Load engine cool for transmission
	SUBA    L5D2A			;Subtract lower threshold
	CLRB				;Clear LSB
	FDIV				;Fract divide
	XGDX				;Get result into D
	COMA				;Ones comp.
;
;-Cold shift temp term = 255 - (engine temp - lower temp thresh)/(upper - lower thresh)
;
LC787	STAA    L00A5			;Save it, cold trans temp term
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Lookup linear cool temp routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC78A	LDAA    L082D			;Load A/D cool temp
	LDX     #LF8EF			;Addr. of 'cool' linear temp table
	BRSET   L0043,#$80,LC79B	;Bra if b7==1
;
	BRSET   L004E,#$01,LC79B	;Bra if b0==1, CTS <= 40 deg C
;
	LDX     #LF9EF			;Addr. of 'warm' linear temp table table
;
LC79B	TAB				;Get A/D cool temp into B     
	ABX				;Add in offset to X    
	LDAA    0,X			;Load linaer cool temp val. 
	STAA    L00A2			;Store it, linear cool temp
;
;-Figure out the crossing points of the two tables
;
	CMPA    #120			;Compare to 50 deg C, upper hyst. threshold 
	BHI     LC7AE			;Bra if cool temp >

	CMPA    #106			;Compare to 40 deg C, lower hyst. threshold
	BHI     LC7B1			;Bra if cool temp >
;
;-Here if cool temp <= 40 deg C
;
	BSET    L004E,#$01		;Set b0 of L004E, cool temp <= 40 deg C
	BRA     LC7B1
;
;-Here if cool temp > 50 deg C
;
LC7AE	BCLR    L004E,#$01		;Clear b0 of L004E, cool temp > 50 deg C
;
LC7B1	BRCLR   L0016,#$60,LC7C6	;Bra if b5 and b6==0, no CTS errors flagged
;
;-If error flagged, use default CTS
;
	LDAA    L5B1A			;63.5 deg C, high defualt cool temp
	LDX     L00F8			;Load engine run time
	CPX     L5B18			;Runtime threshold to use high defualt CTS 
	BHI     LC7C2			;Bra if >, use high defualt cool temp
;
;-Engine still 'cold', use low default CTS val
;
	LDAA    L5B1B			;20 deg C, low default CTS
;
LC7C2   STAA    L0006			;Save it, cool temp, linear
	BRA     LC7CA			;
;
;-Here if no CTS error
;
LC7C6   LDAA    L00A2			;Linear cool temp			
	STAA    L0006			;Save it, cool temp, linear
;
LC7CA   BCLR    L0043,#$80		;Clear b7
	LDAA    L0006			;Cool temp, linear
;
;-Check lower bound on cool temp
;
	SUBA    #16			;subtract 12 deg C
	BCC     LC7D6			;Bra if cool temp >=
;
	CLRA				;Clear cool temp    
	BRA     LC7DC			;Bra to save
;
LC7D6	CMPA    #192			;104 deg C
	BLS     LC7DC			;Bra if cool temp < 
;
	LDAA    #192			;104 deg C, upper bound on cool temp
;
LC7DC	STAA    L02A6			;Save it, range limited cool temp
	RTS     			;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to generate cool temp for trans.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC7E0	LDX     #L5B00			;Start addr. of diag. masks.
	LDAA    L00A2			;Linear cool temp
	BRCLR   $2B,X,#$40,LC7ED	;Err word #1 mask, bra if b6==0, not
					;flagging high cool temp
;
;-Check for error 14, high cool temp
;
	BRSET   L0016,#$40,LC7F5	;Error word #1, bra if b6==1, high cool temp

LC7ED	BRCLR   $2B,X,#$20,LC7F7	;Bra if b5==0, not flagging low cool temp
;
;-Check for error 15, low cool temp
;
	BRCLR   L0016,#$20,LC7F7	;Bra if b5==0, no low cool temp flagged
;
LC7F5	LDAA    $17,X			;Load default cool temp
;
LC7F7	LDAB    #128			;Load val for LSB
	LDX     L00A3			;Engine cool for transmission
	LDY     #L5D0A			;Filter coeff. for engine coolant, transmission
	JSR     LF0D3			;Lag filter routine
;
	STD     L00A3			;Save it
	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   					
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Lookup routine of various temp. based items
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Look up AE TPS filter coeff.
;
LC805	LDAA    L02A6			;Range limited cool temp
	LDX	#L4B5A			;delta TPS AE cool temp correction factor vs temp
	JSR     LF15E			;2D lookup 
	STAA    L0208			;Store it, delta TPS AE cool temp corr. factor
;
;-Look up min decel fuel cut-off rpm 
;
	LDAA    L02A6			;Range limited cool temp
	LSRA 				;/2 for lookup
	LDX     #L4C83			;DFCO rpm vs cool temp
	JSR     LF15E 			;2D lookup
	STAA    L0266			;Save it, min DFCO rpm
;
;-Look up min idle open loop AFR 
;
	LDX     #L4BA3			;Min idle open loop AFR vs cool temp
	LDAA    L0006			;Cool temp, linear
	CMPA    #192			;104 deg C, upper limit for lookup
	BLS     LC829			;Bra if cool temp is less 
;
	LDAA    #192			;Load max
;	
LC829	JSR     LF15E			;2D lookup											;
	BRSET   L003F,#$40,LC83E	;Bra if b6==1 

	LDAB    L0006			;Cool temp, linear
	CMPB    L48D9 			;90 deg C, open loop AFR limit threshold
	BHI     LC83E			;Bra if CTS higher 
;
	SUBA    L48DE			;1.0:1 AFR ratio bias for open loop idle
	BCC     LC83E			;Bra if no underflow
;										
	LDAA    #0			;Clear underflow
;
LC83E	STAA    L0295			;Save it, open loop idle AFR
;
;-Look up slo filtered MAP filter coeff. 
;
	LDX     #L4B32			;MAP filter coeff. vs cool temp table
	LDAA    L02A6			;Range limited cool temp
	JSR     LF15E 			;2D lookup
;
	STAA    L01EE			;Save it, slo filtered MAP filter coeff	
;
;-Look up desired egr correction factor
;
	LDX     #L4755			;EGR correction factor vs. cool temp
	LDAA    L0006			;Cool temp, linear
	LDAB    #80			;offset
	JSR     LF137			;2D lookup with UL
;
	STAA    L01DE			;Save it, EGR correction factor
;
;-Scale and offset cool temp for lookup
;
	LDAA    L0006			;Cool temp, linear
	SUBA    #153			;Sub out 75 deg C
	BCC     LC862			;Bra if temp >=
;
	LDAA    #0			;
;				
LC862	ASLA				;x2
	ASLA 				;x2
	BCC     LC868			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;-Look up burst knock retard
;
LC868	LDAB    #153			;
	MUL				;[4 x 153 x (cool temp - 153)]/256
	ADCA    #0			;Round if needed
	LDX     #L46D9			;Burst knock retard table
	JSR     LF136			;2D lookup with UL
;
	STAA    L0842			;Save it, burst knock retard
	JMP     LC922			;Jump to return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to do SA and Knock related look ups
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-See if MAT present
;
LC879	CLRA				;Preclear A			
	LDX     #L400B			;Opt. byte
	BRCLR	0,X,#$40,LC8BF		;Bra if b6==0, not using MAT sensor
;
;-Check upper bound
;
	LDAA    L0252			;Load MAT
	CMPA    #192			;104 deg C
	BCS     LC88C			;Bra if MAT less

	LDAA    #192			;Load max
	BRA     LC893			;Bra past min temp check				
;
;-Check lower bound
;											
LC88C	CMPA    #80			;19 deg C
	BCC     LC893			;Bra if MAT >=
;
	CLRA				;Clear MAT
;
	BRA     LC8BF			;Bra, continue				
;
;-Look up MAT SA correction, based on Vac and MAT
;
LC893	LDX     #L442F			;Base MAT SA corr. INDEX BASE MAT SPK ADV CORR
	LDAB    0,X			;Load flag
	BEQ     LC8A4			;Bra if ==0. use vac
;
;-Use RPM
;
	LDAB    L0062			;RPM/25
	CMPB    #176			;4400 RPM
	BLS     LC8AD			;Bra if RPMs are <=
;
	LDAB    #176			;Load Max

	BRA     LC8AD			;Bra to continue
;
;-Using vacuum
;
LC8A4	LDAB    L01EC			;Load vacuum	
	SUBB    #80			;55 kPa offset
	BCC     LC8AD			;Bra if vacuum >

	LDAB    #$0000			;Clear Vac
;
LC8AD	INX				;+1, advance to table
	JSR     LF17B			;Bra to do 3D lookup
;										
	SUBA    L4140			;Spark bias for MAT SA correction
	BMI     LC8BB			;Bra if SA negative
;
;-SA corr >= 0
;
	BCLR    L0041,#$02		;Clear b1, MAT SA correction is positive 
	BRA     LC8BF			;Bra to save
;
;-SA corr < 0
;

LC8BB	BSET    L0041,#$02		;Set b1, MAT AS correction is negaive
	NEGA				;Flip sign 
;   
LC8BF	STAA    L021D			;Save it, MAT SA correction
	CLRA 				;Preclear A
	LDAB    L0006			;Cool temp, linear
	CMPB    L45D0			;75 deg C, min cool temp for spark retard
	BLS     LC8E0			;Bra if cool temp is less
;
;-Look up PE spark SA corr. 
;
	BRSET   L0019,#$10,LC8E0	;Error word #4, bra if b4==1, knock circuit	
;
	BRCLR   L003D,#$20,LC8E0	;Status word, bra if b5=0, not in PE
;
;-In PE here
;
	LDX     #L44B5			;PE SA vs rpm table
	LDAA    L0062			;RPM/25
	JSR     LF15E			;2D look up
;
	LDAB    L029B			;(???) 
	MUL				;			     
	ADCA    #00			;Round if needed
;
;-Store PE SA
;
LC8E0     STAA    L021F			;PE SA adder
;
;-Look up low octane mult.
;
	LDAA    L0062			;RPM/25
	LSRA				;/2 for lookup
	LDX     #L45B4			;Low octane mult. vs RPM
	JSR     LF15E			;2D lookup
;
	STAA    L0841			;Save it, low octane RPM mult.
;
;-Look up knock attack rate
;

	LDX     #L458A			;Knock attack rate vs. RPM
	LDAA    L0062			;RPM/25
	JSR     LF15E			;2D lookup 
;
	STAA    L0843			;Store it, knock attack rate
;
;-Look up max PE knock retard
;
	BRCLR   L003D,#$20,LC90B	;Status word, bra if b5==0, not in PE
;
	LDX     #L457B			;Max PE knock retard vs. RPM
	LDAA    L0062			;RPM/25
	LSRA 				;/2 for lookup   
	LDAB    #16			;800 rpm offset 
	JSR     LF15A			;2D look up with SBA
	BRA     LC91F			;Bra to store
;
;-Look up max non-PE knock retard
;

LC90B	LDAA	#255			;Zero vacuum, use if MAP error
	LDAB    L006F			;Status word
	BITB    #$48			;Test b6=High MAP err, b3=Low MAP err
	BNE     LC916			;Bra if error set
;
	LDAA    L01EC			;Load vac
;	
LC916	LSRA				;/2 for lookup    
	LDAB    #32			;offset, 20 kPa of vac
	LDX     #L4583			;Max non-PE retard vs. vac
	JSR     LF15A			;2D look up with SBA
;
LC91F	STAA    L0844			;Store it, max SA retard
;
LC922	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Adaptive A/C control routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Do ALDL
;
LC923	SEI				;Disable interrupts     
	BCLR    L0050,#$18		;Status word, clear b3=ALDL mode, b4=diags. mode
;
	LDAA    L082F			;ALDL volts
	CMPA    #40			;781 mV
	BCS     LC93B			;Bra if ALDL less, in diags. mode
;
	CMPA    #100			;2 V
	BCC     LC93E			;Bra if ALDL volts greater, ALDL open
;
	BRCLR   L0044,#$01,LC93E	;Bra if b0==0, factory test requested
;
;-ALDL volts > 2 volts, in ALDL mode
;
	BSET    L0050,#$08 		;Set b3, ALDL mode
	BRA     LC93E			;Bra to continue
;
;-In diags. mode
;
LC93B     BSET    L0050,#$10		;Set b4, in diags. mode
;
LC93E     CLI				;Re-enable interrupts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check option byte for A/C control method
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L400F			;Option byte
	BRSET   0,X,#$04,LC949		;Bra if adaptive A/C compressor control selected
;
;-Here if no adaptive A/C control
;
	JMP     LCA42			;Bra to return				
;
;-Here if adaptive A/C control
;
LC949	LDD     L00F8			;Engine run time
	CPD     L4022			;Min time for A/C to be enabled
	BCS     LC955			;Bra if <, not time for A/C yet
;
	BRSET   L004D,#$01,LC963	;I/O port C word, bra if b0==1, A/C requested 
;  
;-No A/C requested here
;
LC955	LDAA    L4012			;.1 sec. delay 
	STAA    L0830			;Save it, min time to enable A/C timer
;	
;-Here if one or more limits exceeded for A/C
;										
LC95B	LDAA    L4013			;A/C re-enable delay timer
	STAA    L0831			;Save it, A/C renable delay timer
	BRA     LC994			;Bra to continue				
;
;-A/C requested here
;
LC963	LDAA    L0830			;.1 sec delay to activate A/C
	BEQ     LC96D			;Bra if ==0
;											
	DEC     L0830			;-1,
	BRA     LC994			;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check TPS limits for A/C
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
LC96D	LDAA    L4011			;Upper %TPS threshold for A/C to remain on
	BRSET   L0041,#$10,LC977	;Bra if A/C active
;
;-A/C off here
;
	LDAA    L4010			;Upper %TPS threshold for A/C to come on
;
;-A/C on here
;
LC977	CMPA    L01FC			;%TPS
	BCS     LC988			;Bra if TPS is greater
;
;-Here if TPS doesnt exceed limit
;
	LDX     #$0000			;
	STX     L0834			;Reset High TPS A/C disable timer
;
LC982	BRCLR   L0036,#$10,LC9C8	;Status word, bra if b4==0, no stall saver, dont disable A/C
;
;-Stall saver in effect, disable A/C
;
	BRA     LC9C3			;Bra to disable the A/C				
;
;-TPS exceeds limits
;										
LC988	LDX     L0834			;High TPS disable timer
	CPX     L4020			;Threshold to re-enable A/C
	BHI     LC982			;Bra if greater,  re-enable A/C if rpms where within limits
;
	INX				;+1
;
	STX     L0834			;Save it
LC994	BRCLR   L004F,#$80,LC9C0	;Status word, bra if b7==0, engine off
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check RPM limits if high tps present
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0062			;RPM/25
	CMPA    L4019			;Upper RPM limit for A/C to remain on
	BLS     LC9AD			;Bra if less
;
;-RPMs exceeded threshold for A/C to remain on
;
	BSET    L0052,#$10		;Status word, set b4, A/C disabled due to high rpm

	CLR     L0833			;Clear high rpm A/C re-enable delay timer
	LDAA    L4013			;A/C re-enable timer val
	STAA    L0831			;Save it
	BRA     LC9C0			;Bra to disable A/C
;
;-Here if rpms less then threshold
;
LC9AD	LDAA    L0833			;High RPM A/C re-enable delay timer
	CMPA    L4016			;Threshold to re-enable A/C
	BCS     LC9BA			;Bra if less
;
	BCLR    L0052,#$10		;Status word, clear b4, A/C disabled due to high rpms
	BRA     LC9C0			;Bra 
;
LC9BA	INCA				;+1    
	BEQ     LC9C0			;Bra if roll-over

	STAA    L0833			;Save it
;
LC9C0	BCLR    L0052,#$20		;CLR b5, A/C not ok'd
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to disable the A/C and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC9C3	BCLR    L0041,#$10		;Clear b4, disable A/C
	BRA     LCA42			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if not disabling the A/C, check cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LC9C8	LDAA    L401B			;Upper cool temp thresh for A/C to remain on
	BRSET   L0041,#$10,LC9D2	;Bra if A/C on
;
	LDAA    L401A			;Upper CTS threshold for A/C to come on
;
LC9D2	CMPA    L0006			;Cool temp, linear
	BCS     LC95B			;Bra if cool temp greater
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Check for launch mode
;~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L401C			;Upper mph threshold if A/C on
	BRSET   L0041,#$10,LC9E0	;Status word, bra if b4==1, A/C on
;
	LDAA    L401D			;Upper mph threshold if A/C off
;
LC9E0	BRSET   L0016,#$10,LCA0A	;Error word #1, bra if b4==1, error 16, VSS
;
	CMPA    L02A7			;filtered MPH
	BLS     LCA0A			;Bra if speed <=, continue
;
;-MPH higher then threshold here
;
	LDAA    L401E			;Upper tps threshold for A/C to come on
	BRCLR   L0041,#$10,LC9F9	;Status word, bra if b4==0, A/C off
;
;-A/C on here
;
	LDAA    L401F			;Upper tps threshold for A/C to remain on
	LDAB    L4014			;timer val
	STAB    L0836			;Launch mode A/C re-enable delay timer
;
;-A/C off here
;
LC9F9	CMPA    L01FC			;Compare to TPS
	BCC     LCA0A			;Bra if TPS <, continue
;
	LDAA    L0836			;A/C launch disable timer		
	BEQ     LCA0A			;Bra if ==0, continue
;
	DECA 				;-1   
	STAA    L0836			;Save it, A/C launch mode disable timer
	JMP     LC95B			;Bra to check rpm limits and exit
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check max rpm limits
;~~~~~~~~~~~~~~~~~~~~~~
;
LCA0A	LDAA    L4017			;Upper rpm threshold for A/C to come on
	BRSET   L0041,#$10,LCA14	;Status word, bra if b4==1, A/C on
;
	LDAA    L4018			;Upper rpm threshold for A/C to remain on
;
LCA14	CMPA    L0062			;RPM/25
	BCS     LCA1D			;Bra if rpms > threshold
;
;-RPMs less then threshold here
;
	CLR     L0832			;Clear max rpm limit A/C disable timer
	BRA     LCA2B			;Bra to continue
;
;-RPMs higher or same as threshold here 
;
LCA1D	LDAA    L0832			;High rpm A/C disable timer
	CMPA    L4015			;Threshold to disable A/C
	BCC     LCA2F			;Bra if timer is >=
;
	INCA				;+1   
	BEQ     LCA2B			;Bra if roll-over
;
	STAA    L0832			;Save timer
;
LCA2B	BRCLR   L0052,#$10,LCA32	;Status word, bra if b4==0, A/C not disabled due to high rpms
;
LCA2F	JMP     LC994			;Bra to check rpm limits for A/C
;
LCA32	BSET    L0052,#$20		;Status word, set b5, A/C ok'd
;
	LDAA    L0831			;A/C re-enable delay timer
	BEQ     LCA3F			;Bra if ==0, activate A/C
;
	DEC     L0831			;-1
	BRA     LCA42			;Bra to return
;
LCA3F	BSET    L0041,#$10		;Status word, set b4, A/C on
;
LCA42	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Hardware config routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCA43	BRSET   L004F,#$80,LCA56	;Status word, bra if b7==1, engine running
;
	LDAA    L0006			;Cool temp, linearized
	STAA    L02A5			;Initial cool temp (engine off)
	CLRB				;Pre-clear B   
	LDAA    L48B4			;Intitial value for O2
	STD     L01F3			;Save it, flitered O2
	STAA    L01F8			;Save it, A/D O2
;
LCA56	JMP     LCA59			;[likely work-around]
;
LCA59	LDAA    L03B2			;
	BEQ     LCA61			;
;
	BSET    L003A,#$10		;Status word, set b4
;
LCA61	LDX     #L3000			;Base CPU addr.
	BSET    $22,X,#$A0		;TMSK1, set b5, enable 
	SEI				;Disable interrupts     
	LDD     L3FFC           	;I/O port
	ANDB    #$FE			;Clear b0
;
	LDY     #L400B			;Opt byte
	BRSET   0,Y,#$01,LCA7C		;Bra if b0==1, in CPI/PFI mode
;
;-In TBI mode
;
	ORAB    #$32			;
	ORAA    #$F9			;Set 1111 1001 0011 0010
	BRA     LCA80			;Bra to continue
;
;-In CPI/PFI mode
;
LCA7C	ORAB    #$12			;
	ORAA    #$79			;Set 0111 1001 0001 0010
;
LCA80	JSR     LF08A			;Delay
;
	STD     L3FFC			;Save it, I/O port
;
	CLI				;Enable interrupts     
	BCLR    L004C,#$80		;I/O port status word, clear b7
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Entry point for MPU Register config 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCA8A	CLRA				;Preclear A    
	STAA    $0C,X			;OC1 action mask Reg.
	STAA    $0D,X			;OC1 action data Reg.	
	STAA    $2C,X			;SCI control Reg. 1
	STAA    $0B,X			;Compare Force Reg.
	STAA    $28,X			;SPI control reg
					; b7=SPI interrupt enable
					; b6=SPI system enable
					; b5=Port D wired OR mode select
					; b4=Master/Slave mode select
					; b3=Clock polarity select
					; b2=Clock phase select
					; b1=SPI bit rate select
					; b0=SPI bit rate select
;
	STAA    $3E,X			;Factory Test Control Reg.
	STAA    $5C,X			;
	STAA    $03,X			;PRTC (I/O Port C)
	LDAA    #$0026			;0010 0110
	STAA    $0021,X			;TCTL2 (Timer Control Reg. 2)
					; b7= -
					; b6= -
					; b5=EDG1B (Input caputure Edge Control Bit)
					; b4=EDG1A (Input caputure Edge Control Bit)
					; b3=EDG2B (Input caputure Edge Control Bit)
					; b2=EDG2A (Input caputure Edge Control Bit)
					; b1=EDG3B (Input caputure Edge Control Bit)
					; b0=EDG3A (Input caputure Edge Control Bit)		
;
	LDAA    #$0040			;0100 0000
	STAA    $0026,X			;PACTL (Pulse accumulator control) Reg.
					; b7=DDRA7 (Data Direction Control for Port A)
					; b6=PAEN (Pulse accumulator Enable)
					; b5=PAMOD (Pulse Accumulator Mode Select)
					; b4=PEDGE (Pulse Accumulator Edge Select)
					; b3= -
					; b2= -
					; b1=RTR1 (Real Time Interrupt Rate select)
					; b0=RTR0 (Real Time Interrupt Rate select)
;
	LDAA    #$0038			;0011 1000		
	STAA    1,X			;
	LDAA    #$0038			;0011 1000
	STAA    9,X			;DDRD (Data Direction for Port D)
					; b7= -
					; b6= -
					; b5=DDRD5 (Data Direction Control for Port D b5)
					; b4=DDRD4 (Data Direction Control for Port D b4)
					; b3=DDRD3 (Data Direction Control for Port D b3)
					; b2=DDRD2 (Data Direction Control for Port D b2)
					; b1=DDRD1 (Data Direction Control for Port D b1)
					; b0=DDRD0 (Data Direction Control for Port D b0)
;
	LDAA    #$04			;0000 0100
	STAA    $2B,X			;BAUD (SCI baud rate control)
					; b7=Clear baudrate timing chain
					; b6= -
					; b5=SCI baudrate prescale select
					; b4=SCI baudrate prescale select
					; b3=SCI baudrate clock test
					; b2=SCI baudrate select
					; b1=SCI baudrate select
					; b0=SCI baudrate select
;
	LDAA    #$15			;0001 0101
	STAA    $3C,X			;HYPI0 (Highest Priority I Bit and Misc.)
					; b7=Read bootstrap ROM
					; b6=Special mode
					; b5=Mode A select
					; b4=Interval read visibility
					; b3=Priority select
					; b2=Priority select
					; b1=Priority select
					; b0=Priority select
;
	LDAA    #$AC			;1010 1100		
	STAA    $5D,X			;
	LDAA    #$CB			;1100 1011
	STAA    $5F,X			;
	LDAA    #$00			;0000 0000
	STAA    $5E,X			;
	LDAA    #$90			;
	STAA    L3061			;
	LDAA    #$FF			;
	STAA    L3063			;
	LDAA    #$00			;
	STAA    L3065			;
	RTS   				;Return  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Output handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Filter O2 for RTS loops
;
LCACF	LDX     L01F3			;Filtered O2 
	LDAB    L4E7F			;Load filter coeff.
	LDAA    L01F8			;A/D O2 volts
	JSR     LF0F6			;Filter routine
;
	STD     L01F3			;Save it, filtered O2
	LDX     #L400B			;Opt. byte
	BRSET   0,X,#$02,LCAE8		;Bra if b1==1, perform AIR injection handling
;
	JMP     LCB3A			;Skip AIR			
;
;-Check for ALDL 
;
LCAE8	CLRB				;Preclear B    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if in ALDL mode 4
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L003B,#$10,LCAFE	;Status word, bra if b4==1
;
	LDX     #L0390+1		;ALDL word, descrete enables
	BRCLR   0,X,#$02,LCAFE		;Bra if b1==0, no AIR diag.
;
	LDX     #$0392			;ALDL word, descrete states
	BRSET   0,X,#$02,LCB2F		;Bra if b1==1, enable AIR system
;
	JMP     LCB34			;Bra to disable AIR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if normal operation, direct air to manifolds if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCAFE	LDAA    L0006			;Cool temp, linearized
	CMPA    L4E82			;Min temp for AIR
	BCS     LCB34			;Bra if temp <=, no AIR
;
	BRSET   L0071,#$01,LCB34	;(???) 
;
;-Check for PE
;											
	BRCLR   L003D,#$20,LCB18	;Status word, bra if b5==0, no PE
;
;-In PE, check if in PE long enough to disallow AIR
;
	LDAB    L029C			;Time in PE
	CMPB    L4E83			;Threshold to disable AIR
	BHI     LCB34			;Bra if >, disable air
;
	INCB				;+1
	BRA     LCB2F			;Bra to continue
;
;-PE not active here, check MAP/RPM thresholds for AIR
;
LCB18	LDAA    L0061			;Scaled RPMs
	CMPA    L4E80			;RPM threshold to disable AIR
	BHI     LCB34			;Bra if RPMs greater, disable AIR
;											
	LDAA    L01E9			;A/D MAP
	CMPA    L4E81			;MAP threshold to disable AIR
	BCS     LCB34			;Bra if MAP <, disable air
;
;-Check if in open loop idle, enable AIR
;
	BRSET   L0050,#$02,LCB2F	;Status word, bra if b1==1, open loop idle enabled
;
;-Check if closed loop enabled
;
	BRSET   L003E,#$80,LCB34	;Status word, bra if b7==1, in closed loop, no AIR
;
;~~~~~~~~~~~~~~~~~~~~
; Here to enable AIR
;~~~~~~~~~~~~~~~~~~~~
;											
LCB2F	BSET    L0046,#$04		;Status word, set b2, enable AIR
	BRA     LCB37			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~
; Here to disable air
;~~~~~~~~~~~~~~~~~~~~~
;
LCB34	BCLR    L0046,#$04		;Clear b2, disable AIR
;
LCB37	STAB    L029C			;Save time in PE
;
LCB3A	BRA     LCB3C			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if excessive batt. volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCB3C	LDAA    L00A1			;Batt volts
	CMPA    #171			;17.1 volts, threshold for high batt. volts
	BCS     LCB4B			;Bra if batt volts less
;
;-High batt voltage present
;
	BRSET   L0051,#$10,LCB66	;Status word, bra if b4==1, high batt volts already
					;flagged
;
	BSET    L0051,#$10		;Set b1, high batt volts present
	BRA     LCB4E			;Bra to continue
;
;-Here if batt volts within limits
;
LCB4B	BCLR    L0051,#$10		;Clear b4, batt volts within limits

LCB4E	BRSET   L004F,#$80,LCB75	;Status word, bra if b7==1, engine running
;
;-Engine off here
;
	BRCLR   L0071,#$80,LCB66	;Status word, bra if b7==0, diags. not in effect
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Diagnostics in effect, enable outputs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    #255			;Load max CCP DC
	STAA    L01F9			;Save it, CCP DC
	BSET    L0046,#$04		;Status word, set b2, enable AIR
	BSET    L0041,#$10		;Status word, set b4, A/C active
	BSET    L0052,#$08		;Status word, set b3, enable CPI tuning valve
	BRA     LCB75			;Bra to continue			
;
;-No diags. and engine off, disable outputs
;
LCB66	CLR     L01F9			;Clear CCP DC
	BCLR    L0046,#$04		;Clear b2, disable AIR
	BCLR    L0053,#$04		;Clear b2, turn off shift light
	BCLR    L0041,#$10		;Clear b4, disable A/C
	BCLR    L0052,#$08		;Cleear b3, disable tuning valve
;
;~~~~~~~~~~~~~~~~~~~~~
; Engine running here
;~~~~~~~~~~~~~~~~~~~~~
;
LCB75	LDD     #$DFFF			;
	BRSET   L0046,#$04,LCB7F	;Status word, bra if b2==1, AIR enabled
;											
	LDD     #$D000			;
;
LCB7F	STD     L3FDA			;Output to AIR bypass solenoid
;
;~~~~~~~~~~~~~~~~~~~~
; Check if in mode 4
;~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L003B,#$10,LCB92	;Status word, bra if b4==0, not in mode 4
;
;-In mode 4
;
	LDX     #L0395			;
	BRCLR   0,X,#$04,LCB92		;
;
	LDAB    L0396			;
	BRA     LCB95			;
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Here to output CCP DC
;~~~~~~~~~~~~~~~~~~~~~~~
;
LCB92	LDAB    L01F9			;Load CCP DC
;
LCB95	CLRA				;Preclear A    
	ASLD				;x2    
	ASLD				;x2    
	ASLD				;x2    
	ORAA    #$B0			;
	STD     L3FD6			;Save it, output to CCP 
;
	LDX     #$0395			;
	BRCLR   0,X,#$38,LCBB2		;
;
	CLRA				;    
	LDAB    L0396			;
	ASLD				;    
	ASLD				;    
	ASLD				;    
	ASLD				;    
	ORAA    #$0070			;
	XGDX				;    
	BRA     LCBD9			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to output overspeed light/ A/C clutch cont'l / CPI variable tuning valve
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCBB2	LDX     #$7FFF			;Preload full DC for output
;
;-Check which opt
;
	LDY     #L400F			;Opt. byte
	BRCLR   0,Y,#$01,LCBC7		;Bra if b0==0, governor not optioned
;
;-Governor in use, output to overspeed light
;
	LDAA    L0062			;RPM /25
	CMPA    L50D2			;RPM threshold to enable overspeed light
	BCC     LCBD9			;Bra if RPMs >, enable light 
;
	BRA     LCBD6			;RPMs < threshold, no overspeed light
;
;-Check if CPI variable tuning valve enabled
;
LCBC7	BRSET   L0052,#$08,LCBD9  	;Status word, bra if b3==1, tuning valve enabled
;
;-Check if A/C clutch control enabled
;
	LDAA    L400F			;Opt. byte
	BITA    #$04			;Test b2
	BEQ     LCBD6			;Bra if ==0, CPI tuning valve in use instead 
;
;-Controlling A/C clutch
;
	BRCLR   L0041,#$10,LCBD9	;Status word, bra if b4==0, A/C not enabled
;
;-Here to disable output
;							
LCBD6	LDX     #$7000			;Load min DC
;
;-Here to enable output
;
LCBD9	STX     L3FD4			;Save to output A/C / overspeed lgt / tuning valve
;
;~~~~~~~~~~~~~~~~~~~~~~
; Output to S/L or TCC
;~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L400E			;Opt. byte
	BRCLR   0,X,#$04,LCBF0		;Bra if b2==0, TCC in use instead
;
;-Here to output to shiftlight
;
	LDD     #$1FFF			;Preload max DC
;
	BRSET   L0053,#$04,LCBED	;Status word, bra if b2==1, shiftlight enabled
;
	LDD     #$1F00			;Load min DC
;
LCBED	STD     L306C			;Save it, SL / TCC output
;
;~~~~~~~~~~~~~~~
; Output to TCC
;~~~~~~~~~~~~~~~
;
LCBF0	LDX     #L400F			;Opt byte			
	BRCLR   0,X,#$40,LCC04		;Bra if

	LDD     #$7FFF			;Preload max DC
	BRSET   L0085,#$20,LCC01	;BR IF b5, (TCC IS IN LOCK ADJ MODE)
;
	LDD     #7F00			;Load min DC 
;
LCC01	STD     L306A			;Save it, TCC ouput
;
LCC04	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to output to EGR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC05	CLRB				;Preclear B    
	BRSET   L0051,#$10,LCC18	;Status word, bra if b4==1, high batt volts 
;
	BRSET   L004F,#$80,LCC15	;Status word, bra if b7==1, engine running
;
;-Engine off, check if diags. in effect
;
	BRCLR   L0071,#$80,LCC18	;Status word, bra if b7==0, no diags. in effect
;
	DECB				;Load with 255, enable EGR with full DC    
	BRA     LCC18			;Bra ot output and return
;
;-Here to output to EGR
;
LCC15	LDAB    L01D2			;Load EGR DC
;
LCC18	LDAA    #$F0			;   
	STD     L3FD8			;Ouput EGR DC to EGR
;
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Low octaine handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC1E	LDAA    L0002			;Loop counter
	CMPA    #$06			;
	BNE     LCC89			;Bra if counter !=, return 
;
;-Time to run the loop
;
	LDAB    L022C			;Low octaine SA ramping multiplier
	BRSET   L0019,#$10,LCC72	;Error word #4, bra if b4==1, knock sensor error
;
;-Check cool temp threshold
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L45AC			;Min temp threshold for low octain/high knock control
	BLS     LCC86			;Bra if cool temp is <=
;
;-Check MAP threshold
;
	LDAA    L01E3			;Load SD MAP
	CMPA    L45AD			;Lower MAP threshold for low octain/high knock control
	BCS     LCC86			;Bra if SD MAP < 
;
;-Check rate that MAP is changing
;
	SUBA    L01E5			;Subtract delayed SD MAP
	BCS     LCC44			;Bra if MAP is falling
;
	CMPA    L45AE			;Max rate of increase for low octain/high knock control
	BHI     LCC86			;Bra if >, MAP is rising quickly
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if there is low knock activity
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC44	LDAA    L022F			;Load knock retard
	CMPA    L45B0			;Threshold to flag low knock activity  
	BLS     LCC66			;Bra if retard is <=
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if there is high knock activity
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CMPA    L45AF			;Knock retard threshold to flag high knock activity 
	BLS     LCC86			;Bra if retard is <
;
;-Flag high knock activity
;
	BRSET   L0052,#$01,LCC5D	;Status word, bra if b0==1, high knock activity already
					;flagged 
;
	BSET    L0052,#$01		;Set b0, high knock activity
	BCLR    L0052,#$02		;Clear b1, low knock activity
	BRA     LCC78			;Bra to continue
;
;-High knock activity has been flagged
;
LCC5D	ADDB    L45B1			;Ramp up low octaine SA multiplier
	BCC     LCC78			;Bra if no overflow
;
	LDAB    #255			;Clear overflow
	BRA     LCC78			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Flag low knock activity
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC66	BRSET   L0052,#$02,LCC72	;Status word, bra if b1==1, low knock activity already
					;flagged
;
	BSET    L0052,#$02		;Set b1, low knock activity
	BCLR    L0052,#$01		;Clear b0, high knock activity
	BRA     LCC78			;Bra to continue
;
;-Here if low knock activity has been flagged
;
LCC72	SUBB    L45B2			;Ramp down low octain SA multiplier
;	BCC     LCC78			;Bra if no underflow

	CLRB 				;Clear underflow
;   
LCC78	STAB    L022C			;Save low octaine SA ramping multiplier
	LDAA    L45B3			;Load low octaine retard SA 
	MUL				;Low octaine SA x ramping multiplier
	ADCA    #$00			;Round if needed
	STAA    L022D			;Save it, low octaine SA retard
	BRA     LCC89			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if quals not met for low octaine/high knock activity check
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC86	BCLR    L0052,#$03		;Status word, clear b0, high knock, and b1, low knock
					;activity
;
LCC89	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Knock counter interrupt routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCC8A	LDAA    #$80			;1000 0000, clear b7, TOC1
	STAA    L3023			;Timer flag 1 reg
	LDD     L3FC8			;Knock counter
	PSHB				;Push to stack    
	PSHA				;    
	SUBD    L0226			;subtract knock counts, one delayed, now delta knock counts
	TSTA				;Test MSB    
	BEQ     LCC9C			;Bra if knock counts >255
;
	LDAB    #255			;Load max counts
LCC9C	PULX				;Get knock counts    
	STX     L0226			;Save it, knock counts, one delayed
	TBA				;Transfer knock counts to A
;
;-Look up min knock counts vs. RPMs
;
	LDX     #L45D1			;Addr. of min knock counts vs. RPM table
	LDAB    L0062			;RPM/25
	LSRB				;/2
	LSRB				;/2
	ABX				;Add in RPM offset to X
	SUBA    0,X			;Subtract knock counts
	BLS     LCCC8			;Bra if underflow, dont update knock counts
;
;-Look up added knock count bias vs RPM
;
	LDX     #L4612			;Addr. of added knock counts vs RPM table
	LDAB    L0062			;RPM/25
	LSRB				;/2
	LSRB				;/2
	ABX				;Add in the RPM offset
	ADDA    0,X			;Add knock counts bias in
	BCC     LCCBD			;Bra if no overflow
;
	LDAB    #255			;Clear overflow
	BRA     LCCC5			;Bra to save
;
LCCBD	TAB				;Knock counts to B
	ADDB    L0230			;Add in to accumulated knock counts
	BCC     LCCC5			;Bra if no overflow
;
	LDAB    #255			;Clear overflow
;
LCCC5	STAB    L0230			;Save it, knock counts
;
LCCC8	RTI				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCCC9	BRSET   L0002,#$10,LCCE9	;Loop counter, bra if b5==1, dont run the routine yet
;
;-5 Hz portion, handle knock retard decay
;
	LDX     #L459B			;Knock recovery rate
	LDAA    L0062			;RPM/25
	JSR     LF15E			;2D lookup
;											
	LDAB    L022F			;Load knock retard
	MUL				;Knock retard x recovery rate
	ADCA    #$00			;Perform carry if needed
	NEGA				;Negate, make negative
	BNE     LCCE0			;Bra if !=0
;
	LDAA    #255			;Load maximum ammount of decay
;
LCCE0	ADDA    L022F			;Knock retard - decay
	BCS     LCCE6			;Bra if no underflow
;
	CLRA				;Clear out knock retard   
;
LCCE6	STAA    L022F			;Save it, knock retard
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Knock sensor diag. handling
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCCE9	LDAA    L5B03			;Error mask 4
	ANDA    #$10			;Clear all but b4, err 43, knock sensor
	BEQ     LCD23			;Bra if ==0, not flagging error
;
;-Flagging code 43 here
;
	LDX     #$3000			;Base CPU addr.
	LDAA    #$00			;Select A/D knock diag.
	JSR     LEF12			;Port D config routine
;
;-Read in knock sensor diag. voltage
;
	SEI				;Disable interrupts    
	LDAA    #$01			;Select channel B
	JSR     LEEFC			;A/D routine
;
	CLI				;Enable interrupts     
	LDAA    $34,X			;Load A/D result
	CMPA    L4E6B			;Upper voltage threshold to set error
	BHI     LCD0B			;Bra if voltage >, set error
;
	CMPA    L4E6C			;Lower voltage limit
	BCC     LCD1D			;Bra if voltage >=
;
;-Here to set code 43
;
LCD0B	LDAA    L022A			;Error 43 timer
	CMPA    L4E6A			;Time threshold to set error
	BHI     LCD18			;Bra if error timer >, set error 43
;
;-Not setting error yet
;
	INC     L022A			;Inc error timer
	BRA     LCD23			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to set code 43, knock sensor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCD18	BSET    L0019,#$10 		;Error word #4, set b4, code 43, knock sensor
	BRA     LCD23			;Bra to continue
;
;-Here if not setting error
;
LCD1D	BCLR    L0019,#$10		;Clear b4, knock sensor ok
	CLR     L022A			;Clear error 43 timer
;
LCD23	LDAA    L0130			;
	INCA				;    
	BEQ     LCD2C			;
;
	STAA    L0130			;
;
LCD2C	LDAA    L0118			;
	BEQ     LCD41			;
;
	LDAB    #$A3			;
	MUL				;     
	ASLD				;    
	ASLD				;    
	STAA    L012E			;
;
	CLR     L0130			; CLR  SHIFT TIMER
	BCLR    L007F,#$80		; CLR b7
	BRA     LCD78			;
;
LCD41	BRCLR   L0093,#$08,LCD4A	; BR IF NOT b3
;
	CLR     L012E			;
	BRA     LCD78			;
;
LCD4A	BRSET   L007F,#$80,LCD58	; BR IF b7,
;
	BRCLR   L007F,#$40,LCD60	; BR IF NOT b6,
;
	BSET    L007F,#$80		; SET b7
	CLR     L0130			; CLR  SHIFT TIMER
;
;*******************************************************
;* 3 -> 2 DOWNSHIFT PATTERN 1994 4L60E XMISSION
;*
;*******************************************************
;
LCD58	LDAA    L0130			; SHIFT TIMER 
	CMPA    L5E8E			; 2 SEC'S, PERIOD OF 3 -> 2 SHIFT
	BCS     LCD7B			;
;
LCD60	BCLR    L007F,#$80		; CLR b7
	BCLR    L0084,#$07		; CLR b3
	CLR     L0130			; CLR  SHIFT TIMER
	LDAA    L5E8B			; 90%, MAX ALLOWED %D.C. FOR 3 -> 2 SHIFT
;
	LDAB    L00D3			; GEAR NUMBER
	CMPB    #$00			;
	BNE     LCD75			;
;
	LDAA    L5E8A			; 0%,  MIN ALLOWDED %D.C. FOR 3 -> 2 SHIFT
;
LCD75	STAA    L012E			;
;
LCD78	JMP     LCE3C			;
;
LCD7B	BRCLR   L0084,#$07,LCD81	; BR IF NOT b3

	BRA     LCD98			;
;
LCD81	BRCLR   L009C,#$03,LCD8C	; BR IF NOT b0 & b2
;
	BRSET   L0092,#$04,LCD8C	; BR IF b2
;
	BSET    L0084,#$01		; SET b0
;
LCD8C	BRCLR   L0093,#$04,LCD95	; BR IF NOT b2

	BSET    L0084,#$02		; SET b1
	BRA     LCD98			;
;
LCD95	BSET    L0084,#$04		; SET b2
;											
LCD98	BRCLR   L0084,#$01,LCDA5	; BR IF NOT b0

	LDAA    L5E8C			; 0 % D.C. OVERRIDE IN D3 - D2
	STAA    L012E			;
;
	JMP     LCE29
;
LCDA5	BRCLR   L0084,#$02,LCDB2	; BR IF NOT b1, 
;
	LDAA    L5E8D			; 0%, 2 - 3 SHFT IN CASE OF NO LOSS 
	STAA    L012E			;
	JMP     LCE29			;				
;																						
LCDB2	LDD     L00A6			;
	SUBD    #L4000			; 16,384
	BCC     LCDBC			;
;
	LDD     #$0000			;
;
LCDBC	CPD     #$51EB			; 20,971 
	BLS     LCDC5			;
;
	LDD     #$51EB			; 20,971
;
LCDC5	LDX     #$51EB			; 20,971
	FDIV				;
	XGDX				;
;
	LDAB    L00D1			; FILT  Vss
	SUBB    #20			;
	BCC     LCDD1			;
;
	CLRB				;
;
LCDD1	ASLB				;
	BCC     LCDD6			;
;											
;--------------------------------------------------
; BASE D.C. Vs. MPH Vs. BARO
;
; TBL = %D.C. * 2.56
;--------------------------------------------------
;
	LDAB    #255			;
;
LCDD6	LDX     #L5E90			; BASE D.C.	TBL
	JSR     LF17B			; 3d LOOK UP
;											
	STAA    L012E			;
;											
	LDY     #L5E89			; ENABLE FLAGS MY94 4L60E XMISSION 
	BRCLR   0,Y,#$02,LCE07		; BR IF NOT b1, TEMP COMP ENABLED 
;
;--------------------------------------------------
; TEMP COMPENSATION %DC Vs. XMISH TEMP
;
;  TBL = %DC * 1.27+128 IF DC E.Q. or G.T. 0
;  TBL = %DC * 1.28+128 IF DC L.T. 0
;--------------------------------------------------
;
	LDAA    L00AF			; XMISH TEMP
	LDX     #L5FB4			; TEMP COMPENSATION %DC TBL
	JSR     LF15E			; 2d LK UP
;
	SUBA    #128			;
	ASLA				;
	BCS     LCDFE			; BR IF OVERFLOW
;
	ADDA    L012E			;
	BCC     LCE04			; BR IF NO OVERFLOW
;
	LDAA    #255			; USE MAX VALUE
	BRA     LCE04			;
;
LCDFE	ADDA    L012E			;
	BCS     LCE04			; BR IF OVERFLOW
;
	CLRA				; 
;
LCE04	STAA    L012E			;
;
LCE07	BRCLR   0,Y,#$04,LCE29		; BR IF NOT b2,
;
	BRCLR   L0096,#$02,LCE29	; BR IF NOT b1,
;
	LDAA    L5E8F			; 2.7% D.C., A/C COMP OFFSET
	SUBA    #128			;
	BCS     LCE20			; BR IF UNDERFLOW
;
	ADDA    L012E			;
	BCC     LCE26			; BR IF NO OVERFLOW
;
	LDAA    #255			; USE MAX VALUE
	BRA     LCE26			;
;
LCE20	ADDA    L012E			;
	BCS     LCE26			;
;
	CLRA				;
;
LCE26	STAA    L012E			;
;				
LCE29	LDAB    L5E8A			; 0%,  MIN ALLOWED %D.C. FOR 3 -> 2 SHIFT
	CMPB    L012E			;
	BCC     LCE39			;
;
	LDAB    L5E8B			; 90%, MAX ALLOWED %D.C. FOR 3 -> 2 SHIFT
	CMPB    L012E			;
	BCC     LCE3C			;
;
LCE39	STAB    L012E			;
;
LCE3C	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check params for EGR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCE3D	LDX     #L46EF			;Index quals for EGR
	LDAA    L400B			;Opt. byte
	BITA    #$40			;Test b6, MAT sensor in use
	BEQ     LCE55			;Bra if ==0, no MAT
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Mat sensor in use, check MAT quals
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0253			;Current MAT
	LDAB    4,X			;MAT threshold to disable EGR 									
	BRSET   L006E,#$80,LCE52	;Status word, bra if b7==1, EGR enabled
;
	LDAB    3,X			;MAT threshold to enable EGR
;
LCE52	CBA				;Compare MAT to threshold
	BLS     LCEB0			;Bra if MAT <= threshold, disable EGR
;
;-Check initial cool temp at startup
;
LCE55	LDAA    L02A5			;Initial cool temp 
	CMPA    0,X			;Threshold for warm startup
	BLS     LCE64			;Bra if initial cool temp was <=
;
;-Cool temp threshold for EGR if warm startup
;
	LDAA    2,X			;Cool temp threshold to enable EGR for warm startup
	CMPA    L0006			;Cool temp, linearized
	BHI     LCEB0			;Bra if cool temp is <, temp threshold not met for EGR
;
	BRA     LCE6A			;Bra, temp threshold met
;
;-Cool temp threshold for EGR if cool startup
;
LCE64	LDAA    1,X			;Cool temp threshold to enable EGR for cool startup
	CMPA    L0006			;Cool temp, linearized
	BHI     LCEB0			;Bra if cool temp was <, temp threshold not met for EGR
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check MAP thresholds
;~~~~~~~~~~~~~~~~~~~~~~
;
LCE6A	BRCLR   L0018,#$30,LCE70	;Error word #3, bra if b4, low MAP, and b5, high MAP 
					;errors not set 
;
	BRA     LCEB0			;Bra, no EGR, MAP errors			
;
	LDAA    $0A,X			;MAP threshold to enable EGR
	BRCLR   L006E,#$10,LCE78	;Status word, bra if b4==0, MAP thresholds for EGR not
					;met
;
	LDAA    $0B,X			;MAP threshold to disable EGR
; 
LCE78	CMPA    L01E3			;SD MAP 
	BCS     LCE82			;Bra if MAP > 
;											
	BCLR    L006E,#$10		;Clear b4, MAP threshold for EGR not met
	BRA     LCEB0			;Bra, EGR not ok'd
;
;-MAP thresholds met for EGR
;
LCE82	BSET    L006E,#$10		;Set b4, MAP threshold for EGR met
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check TPS thresholds
;~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L006F			;Status word
	BITA    #$24			;Test b2, high TPS, and b5, low TPS errors
	BNE     LCEA0			;Bra if !=0, errors where set
;
	LDAA    8,X			;TPS threshold to enable EGR
	BRCLR   L006E,#$20,LCE93	;Status word, bra if b5==0. TPS thresholds not met for 
					;EGR
;
	LDAA    9,X			;TPS threshold to disable EGR
;
LCE93	CMPA    L01FC			;% TPS
	BCS     LCE9D			;Bra if TPS >
;
;-Threshold not met for EGR
;
	BCLR    L006E,#$20		;Clear b5, TPS thresholds not met for EGR
	BRA     LCEB0			;Bra, EGR not ok'd
;
;-Threshold met for EGR
;
LCE9D	BSET    L006E,#$20		;Set b5, TPS thresholds met
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check RPM thresholds
;~~~~~~~~~~~~~~~~~~~~~~
;
LCEA0	LDAB    L0062			;RPM/25
	LDAA    6,X			;RPM threshold for enabling EGR
	BRCLR   L006E,#$40,LCEAA	;Bra if b6==0, RPM EGR thresholds for EGR not met
;
	LDAA    7,X			;RPM threshold for disabling EGR
;
LCEAA	CBA				;Compare threshold to RPM/25
	BLS     LCEB4			;Bra if RPMs >=
;
	BCLR    L006E,#$40		;Clear b6, RPM thresholds not met for EGR
;
;~~~~~~~~~~~~~~~~~~~~~~
; Here if EGR not ok'd
;~~~~~~~~~~~~~~~~~~~~~~
;
LCEB0	CLRA				;    
	JMP     LCF37			;Jump to continue
;
;-RPM threshold for EGR has been met
;
LCEB4	BSET    L006E,#$40		;Set b6, RPM threshold for EGR has been met
;
;~~~~~~~~~~~~~~~~~~~~~~
; Check MPH thresholds
;~~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L0016,#$10,LCEC3	;Error word #1, bra if b4==1, VSS errors
;
	LDAA    L02A7			;MPH
	CMPA    L46F4			;MPH threshold to disable EGR
	BCS     LCEB0			;Bra if MPH <, no EGR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Check vacuum thresholds
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCEC3	LDAA    $0C,X			;Vac threshold for disabling EGR
	BRSET   L006E,#$04,LCECB	;Bra if b2==1, vac thresholds for EGR met
;
	LDAA    $0D,X			;Vac threshold for enabling EGR
;
LCECB	CMPA    L01EC			;Compare to current vacuum
	BCC     LCED5			;Bra if vacuum is <=
;
	BCLR    L006E,#$04		;Clear b2, vac thresholds for EGR not met
	BRA     LCEB0			;Bra, no EGR
;
LCED5	BSET    L006E,#$04		;Set b2, vac thresholds for EGR have been met
;
;~~~~~~~~~~~~~~~
; Check max TPS
;~~~~~~~~~~~~~~~
;
	LDAA    $0E,X			;Max TPS for EGR
	CMPA    L01FC			;Compare to TPS
	BCS     LCEB0			;Bra if TPS >, no EGR
;
;~~~~~~~~~~~
; Check AFR
;~~~~~~~~~~~
;
	LDAA    $0F,X			;Max AFR for EGR
	CMPA    L026D			;AFR
	BHI     LCEB0			;Bra if AFR is richer, no EGR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if DFCO or in open loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L0046,#$08,LCEB0	;Status word, bra if b3==1, DFCO in effect
;
;-Check if EGR allowed in open loop
;
	LDAA    L400D			;Opt. byte
	BITA    #$08			;Test b3, disable EGR in open loop
	BEQ     LCEF5			;Bra if ==0, allow EGR in open loop
;
	BRCLR   L003E,#$80,LCEB0	;Status word, bra if b7==0, in open loop, no EGR
;
;~~~~~~~~~~~~~~~~~~~~~
; Look up desired EGR
;~~~~~~~~~~~~~~~~~~~~~
;
LCEF5	LDX     #L4700			;Desired EGR table
;
;-Load desired load variable
;
	LDAB    L01F2			;MAP/Baro ratio
	LDAA    0,X			;Load option
	CMPA    #$02			;Option 2, use MAP/Baro ratio
	BEQ     LCF0B			;Bra if ==, use ratio
;
	LDAB    L01EC			;Vacuum
	LDAA    0,X			;Load option
	BEQ     LCF0B			;Bra if option==0, use vacuum
;
	LDAB    L01E3			;SD MAP
;
LCF0B	INX				;+1, advance to table
	LSRB				;load variable/2
;
;-Check RPM limits
;
	LDAA    L0062			;RPM/25
	CMPA    #160			;4000 RPM, upper limit for lookup 
	BLS     LCF15			;Bra if <=
;
	LDAA    #160			;Load upper limit
;
LCF15	JSR     LF17B			;3D lookup
;
	TAB				;Get result into B     
	LDAA    L01DE			;EGR correction factor vs. cool temp
	MUL				;Factor x desired EGR     
	ASLD				;x2, now /128    
	BCC     LCF22			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up MAP/Baro EGR correction factor 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCF22	PSHA				;Push desired EGR to stack    					
	LDX     #L475D			;EGR correction factor table
	LDAB    L01EF			;Baro
;
	LDAA    L01E3			;Load SD MAP
	LSRA				;/2 for lookup
	JSR     LF17B			;3D lookup
;
	PULB				;Get desired EGR back    
	MUL				;EGR x correction factor    
	ASLD				;x2, now /128    
	BCC     LCF37			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if EGR activation ok
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCF37	CMPA    L46FF			;Min allowed desired EGR
	BCC     LCF3E			;Bra if desired EGR >=
;
;-Too little EGR requested, clear desired EGR
;
	BRA     LCF48			;Bra to clear desired EGR
;
;-Check for excessive batt volts
;
LCF3E	BRSET   L0051,#$10,LCF48	;Status word, bra if b4==1, high batt volts
;
;-Check if linear EGR failed diags.
;
	BRSET   L0072,#$20,LCF48	;Status word, bra if b5==1, linear EGR failed diags.
;
;-EGR activation ok'd
;
	BRA     LCF49			;Bra to save desired EGR
;
;-Here to clear desired EGR
;
LCF48	CLRA				;Clear desired EGR
;    
LCF49	STAA    L01D1			;Save it, desired EGR
	BRCLR   L0082,#$40,LCF53	;HU status word, bra if b6==0, no HU
;
	JSR     L1815			;To HU vector table
;
;-Check if mode 4 in effect
;
LCF53	BRCLR   L003B,#$10,LCF64	;Status word, bra if b4==0, no mode 4
;
;-Mode 4 in effect
;
	LDAA    L0395			;
	BITA    #$02			;
	BEQ     LCF64			;
;
	LDAA    L0396			;
	STAA    L01D1			;Desired EGR
;
LCF64	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to look up/calculate EGR flowrate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCF65	LDX     #L400D			;Opt. byte
	BRSET   0,X,#$20,LCF70		;Bra if b5==1, use table to look up EGR flow
;
;-Conditionally calculate EGR flow if no backpressure EGR present
;
	BRCLR   0,X,#$04,LCFAF		;Bra if b2==0, no backpressure EGR present
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Using table to look up %EGR flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCF70	BCLR    L006E,#$80		;Clear b7, disable EGR
;									
	BRSET   L0070,#$01,LCF80	;Status word, bra if b0==1, EGR failed diags.
;
	BRSET   L0070,#$04,LCF86	;Status word, bra if b2==1, EGR diags. underway, 
					;disable EGR for diag. purposes
;
	LDAA    L01D2			;% EGR
	BNE     LCF83			;Bra if !=0, continue
;
;-No EGR here, clear flow and continue
;
LCF80	CLRA				;Clear A    
	BRA     LCFAB			;Bra to save and exit			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up EGR flow as a percentage of total airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCF83	BSET    L006E,#$80		;Set b7, EGR is active
;
;-Here if EGR diags. underway, disable EGR
;
LCF86	LDX     #L4780			;EGR flow table
;
;-Scale vacuum for lookup
;												
	LDAB    L01EC			;Vacuum
	NEGB				;Neg., now 0-80 kPa    
	CMPB    #64			;20 kPa, lower limit to scale vac
	BHI     LCF94			;Bra if vacuum kPa >
;
;-Vac kPa < 20, val for lookup = kPa x 2
;
	ASLB				;x2    
	BRA     LCF9F			;Bra to continue
;
;-Vac kPa >= 20, val for lookup = (kPa - 64)/2 + 128
;
LCF94	SUBB    #64			;Subtract offset
	LSRB				;/2    
	ADDB    #128			;+128
	CMPB    #192			;60 kPa, upper limit for lookup
	BLS     LCF9F			;Bra if kPa <=
;												
	LDAB    #192			;Load max
;
LCF9F	LDAA    L0062			;Load RPMs/25
	CMPA    #160			;4000 RPM, max RPM for lookup
	BLS     LCFA7			;Bra if RPMs <=
;
	LDAA    #160			;Load max
;
LCFA7	LSRA				;/2 for lookup
	JSR     LF17B			;3D lookup
;
LCFAB	PSHA				;Push fuel correction to stack   
	JMP     LD048			;Continue...
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for enabling EGR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LCFAF	BCLR    L006E,#$80		;Clear b7, EGR energized
	BRSET   L0070,#$01,LD02A	;Status word, bra if b0==1, EGR faild diags.
;
	BRSET   L0072,#$20,LD02A	;Status word, bra if b5==1, linear EGR failed diags
;
	BRSET   L0070,#$04,LCFF3	;Bra if b4==1, EGR diags in progress
;
	LDX     #L400D			;Opt. byte
	BRCLR   0,X,#$02,LCFDE		;Bra if b1==0, EVRV EGR
;
;-Here if linear EGR in use
;
	BRCLR   0,X,#$10,LCFCD		;Bra if b4==0, allowing EGR at idle
;
;-Not allowing EGR during idle
;
	BRSET   L0050,#$80,LD02A	;Status word, bra if b7==1, idling, no EGR
;
;-Check to see if pintle position great enough for EGR flow
;
LCFCD	LDAB    L01DC			;% EGR
	CMPB    L4850			;Min pintle position for EGR flow
	BCS     LD02A			;Bra if pintle position is <, zero flow
;
;-Check for sufficient engine run time
;
	LDX     L00F8			;Engine run time
	CPX     L4851			;Min run time to enable EGR
	BCS     LD02A			;Bra if run time <
;
;-Quals met for EGR
;
	BRA     LCFE6			;Bra to enable EGR
;
;-Here if standard EGR is in use
;
LCFDE	LDAB    L01D2			;% EGR
	CMPB    L4853			;Min % EGR for EGR flow
	BCS     LD02A			;Bra if % EGR <, no flow
;
;-Enable EGR
;										
LCFE6	BSET    L006E,#$80		;Set b7, EGR active
;
;~~~~~~~~~~~~~~~~~~~~
; Calculate EGR flow
;~~~~~~~~~~~~~~~~~~~~
;									
	LDAA    L01DC			;% EGR
	LDX     #L400D			;Opt. byte
	BRSET   0,X,#$02,LCFF6		;Bra if b1==1, liner EGR in use 
;
;-Here if standard EGR in use or if EGR diags. underway
;
LCFF3	LDAA    L01D1			;Desired EGR
;
LCFF6	LDAB    #160			;Multiplier, scale %EGR
	MUL				;%EGR x multiplier      
	ADCA    #$00			;Round up if needed
	PSHA				;Push %EGR to stack    
;
;-Look up EGR backpressure
;
	LDAA    L0255			;gms/sec of airflow
	LDX     #L47C9			;EGR exhaust back press. vs airflow
	JSR     LF15E			;2D lookup
;
	LDAB    L01EC			;Vacuum
	NEGB				;Neg, get manifold pressure    
	ABA				;Add vacuum in, now total delta pressure				     
	BCC     LD00E			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
LD00E	STAA    L01D3			;Save it, delta pressure across EGR
	CMPA    #64			;20 kPa
	BCS     LD020			;Bra if delt press <
;
;-Pressure across EGR >= 20 kPa, scaled kPa EGR press = .63 x (val - 64) + 10
;
	SUBA    #64			;-20 kPa offset			
	LSRA				;/2    
	ADDA    #64			;Add in 20 kPa bias
	CMPA    #144			;32 kPa			
	BCS     LD020			;Bra if <
;
	LDAA    #144			;Load max
;
LD020	TAB				;delta pressure to B     
	PULA				;Get desired EGR back  
	LDX     #L47DB			;%EGR flow vs. delta pressure
	JSR     LF17B			;3D lookup

	BRA     LD02B			;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no EGR/no EGR flow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD02A	CLRA 				;Clear EGR flow 
;  
;-EGR active here
;
LD02B	STAA    L01D4			;Save it, EGR flow
	LDAB    L47DA			;Gms/sec EGR flow scalar
	MUL				;scalar x EGR flow     
	LSRD				;/2    
	BCC     LD038			;Bra if b0==0

	ADDD    #01			;Round up
;
;-Get EGR flow to total airflow
;			
LD038	LDX     L0255			;Gms/sec airflow
	FDIV				;Divide EGR flow by airflow    
	PSHX				;Result to stack    
	PULA				;Get result into D    
	PULB				;    
	CMPA    #$FF			;
	BEQ     LD047			;Bra if ==255
;
	TSTB				;Test LSB    
	BPL     LD047			;Bra if ==0
;
	INCA				;Round up
;    
LD047	PSHA				;Result to stack
; 
;-Apply baro correction to flow %
;
LD048	LDX     #L484C			;EGR baro correction
	LDAA    L01EF			;Baro
	LDAB    #96			;46 kPa, lower limit for lookup
	JSR     LF15A			;2D lookup w/ SBA
;
	PULB				;Get %EGR to airflow back    
	MUL				;%flow x baro factor     
	TSTB				;Test LSB    
	BPL     LD059			;Bra if msb ==0

	INCA				;Round up if needed 
;
;-Lookup EGR flow filter coeff. vs airflow
;
LD059	PSHA				;%EGR flow to stack
	LDAA    L0255			;Airflow, gms/sec
	CMPA    #64			;64 gms/Sec, max for lookup
	BLS     LD063			;Bra if airflow > 
;
	LDAA    #64			;Load max
;
LD063	LDX     #L47C4			;EGR flow filter coeff vs. airflow
	JSR     LF15E			;2D lookup
;
	TAB				;Filter coeff. to B     
	PULA				;Get %EGR flow back    
	LDX     L01D5			;Filtered %EGR flow
	JSR     LF0F6			;Filter routine
;
	STD     L01D5			;Save it, filtered %EGR flow
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 			
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; EGR pintle pos. read in routine 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD075	LDAA    L400D			;Option byte
	BITA    #$02			;b1, 1=linear EGR, 0=EVRV EGR 
	BNE     LD083			;Bra if using linear EGR
;
;-Here if using EVRV EGR
;
	CLRA				;Clear A   
	STAA    L01DC			;% EGR 
	JMP     LD11C			;Bra to return
;
;-Here if using linear EGR
;
LD083	LDX     #L3000			;Base Reg. addr.
	SEI  				;Disable interrupts
	LDAA    #$03			;
	BCLR    $08,X,#$38		;Port D, clear b3-b5
;
	ASLA				;shift left
	ASLA				;
	ASLA				;now 0001 1000
	ORAA    $08,X			;OR b3 with b3 in Port D
;
	STAA    8,X			;Store it, port D									;
	LDAA    #$01			;Configure A/D converter, single channel read
	BCLR    L001A,#$02		;Clear b1, error 55, faulty PCM 
	STAA    L3030			;Save it, A/D control reg
;		
	LDAB    #12			;Delay counter, loop untill 0 to wait for result
;								
LD09D	BRSET   $30,X,#$80,LD0AA	;Bra if b7==1, conversion complete
;
	DECB				;-1 from delay counter
	BNE     LD09D			;Bra if !=0, continue to wait for data
;
;-A/D conversion failed 
;
	BSET    L003A,#$01		;Error word, set b0, A/D converter failed
	BSET    L001A,#$02		;Error word #5, set b1, error 55, faulty PCM 
;
;-Here if A/D conversion successful
;
LD0AA	CLI				;Enable interrupts 
	LDAA    $34,X			;Read in A/D EGR pintle value
	STAA    L01D7			;Save it, linear EGR pos.
	CMPA    L01D8			;Closed EGR pintle pos., 
	BCC     LD0CA			;Bra if current pintle pos. >=
;
;-Filter EGR pintle position down to lowest current pintle position, serves as pos. for closed pintle
;											
	LDX     L01D8			;Lag filtered closed EGR pintle pos.
	LDAB    L489D			;Pintle closing lag filter coeff.
	JSR     LF0F6			;Lag filter routine
;											
	CMPA    L489C			;Threshold for EGR closed
	BCC     LD0C7			;Bra if >=
;
;-EGR below threshold for closed position
;
	LDAA    L489C			;Load A/D value for closed pintle position
	CLRB				;Clr LSB
;
LD0C7	STD     L01D8			;Save it, lag filtered closed EGR pintle pos.
;	
LD0CA	LDAA    L01D7			;A/D EGR pintle pos.
	LDAB    #128			;Load LSB with 128
	SUBD    L01D8			;Subtract closed EGR pintle position
	BCC     LD0D5			;Bra if current EGR pintle pos. is greater  
;
	CLRA				;Clear pintle position
;
;-Calculate % that EGR is open
;
LD0D5	LDAB    L489A			;EGR pintle position scalar
	MUL				;(EGR pintle position) x scalar 
	CPD     #3FC0			;Upper limit for EGR pos. value
	BLS     LD0E2			;Bra if <=
;
	LDD     #$3FC0			;Load upper limit instead
;
LD0E2	ASLD				;x2
	ASLD				;x2
	LDX     L01DA			;Filtered %EGR
	LDY     #L489E			;Filter coeff for %EGR
	JSR     LF0D3			;Lag filter
;
	STD     L01DA			;Save it, filtered %EGR
	ADDD    #128			;Round if needed
	STAA    L01DC			;Save it, %EGR
;
;-See if position for closed EGR needs adjusting 
;
	CMPA    #128			;50% EGR
	BLS     LD100			;Bra if less
;
;-EGR position > 50%
;
	BSET    L0041,#$01		;Set b1, adjust position for EGR closed
	BRA     LD11C			;Bra, return
;
;-Check and adjust closed pintle position if desired EGR ==0
;
LD100	TST     L01D1			;Test desired %EGR posit.
	BNE     LD11C			;Bra if !=0, return
;
	BRCLR   L0041,#$01,LD11C  	;Status word, bra if b0==0, dont adjust EGR closed pinlte position
;
	BCLR    L0041,#$01		;Clear b0, pintle position adjusted
;
	LDAA    #02			;Add in two counts
	ADDA    L01D8			;Add in closed EGR pintle pos.
	CMPA    L489B			;Max value for closed position
	BLS     LD119			;Bra if less

	LDAA    L489B			;load max
;
LD119	STAA    L01D8			;Save it, closed EGR pintle pos.
;
LD11C	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; EGR PID position control routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD11D	BRSET   L0070,#$04,LD15A	;Status word, bra if b2==1, EGR diags. in progress
;
	LDX     #L400D			;Opt. byte
	BRSET   0,X,#$02,LD12E		;Bra if b==1, using linear EGR
;
;-Using standard EGR here
;
	LDAA    L01D1			;Load desired %EGR posit.
	JMP     LD1D5			;Save and return
;
;-Using linear EGR
;
LD12E	BRCLR   L003B,#$10,LD139	;Status word, bra if b4==0, not in mode 4
;
	LDAA    L0395			;(???)
	BITA    #$02			; b1,
	BNE     LD141			;
;
LD139	BRSET   L0070,#$01,LD15A	;Bra if b0==1, EGR failed diags.
;
	BRSET   L0072,#$20,LD15A	;Status word, bra if b5==1, linear EGR failed diags. 
;
;-Calc. EGR error
;
LD141	LDAA    L01D1			;Load desired %EGR position
	BCLR    L006D,#$08		;Status word, clear b3, EGR position error sign 
;											
	SUBA    L01DC			;Subtract %EGR
	BCC     LD150			;Bra if desired EGR >=

	NEGA				;Make abs. val. of EGR pos. error
	BSET    L006D,#$08		;Status word, set b3, EGR pos. error < 0
;											
LD150	STAA    L01DD			;Save it, %EGR position error
	TST     L01D1			;Desired EGR
	BNE     LD160			;Bra if !=0
;
;-Desired EGR ==0
;
	BRA     LD1CD			;Bra to perform resets and exit
;
LD15A	CLRA				;
	STAA    L01DD			;Clear EGR position error
	BRA     LD1CE			;Bra to perform resets				
;
;-Here if desired EGR >0
;
LD160	LDD     L01DF			;Load EGR integral
	BNE     LD172			;Bra if !=0
;
;-Init EGR integral
;
	LDAA    L01D1			;Load desired %EGR position
	LDX     #L489F			;Addr. of EGR int. init vs. desired %EGR pos.
	JSR     LF153			;2D lookup with line count
;
	CLRB				;Clear LSB    
	STD     L01DF			;Save it, EGR integral
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up EGR proportional term 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD172	LDAA	L01DD			;EGR position error
	LDX     #L48A5			;Addr. of EGR proportional gain vs. EGR error
	JSR     LF153			;2D lookup with line count
;
	LDAB    L01DD			;EGR error
	MUL				;EGR error x gain
	STD     L084F			;Save it, EGR proportional term
;
;Add it to the EGR integrator
;
	LDD     L01DF			;Load EGR Integrator
;
	BRSET   L006D,#$08,LD193	;Status word, bra if b3==1, error <0 
;
;-Positive EGR proportional term
;
	ADDD    L084F			;Add in the prop. term
	BCC     LD191			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     LD19A			;Bra to save
;
;-Negative EGR proportional term
;
LD193	SUBD    L084F			;Subtract the prop. term
	BCC     LD19A			;Bra if no underflow
;
	CLRA				;Clear underflow    
	CLRB				;
;   
LD19A	STD     L01DF			;Save it, EGR integrator
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up EGR integral gain
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L01DD			;EGR position error
	LDX     #L48AB         		;Addr. of EGR gain multiplier vs. EGR error 
	JSR     LF153			;2D lookup with line count
;
	LDAB    L01DD			;EGR position error
	MUL				;gain x error
	ASLD				;x2
	BCC     LD1B0			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
	CLRB				;
;    
LD1B0	STD     L01E1			;Save it, delta EGR integral term
	LDD     L01DF			;Load integral
	BRSET   L006D,#$08,LD1C4	;Status word, bra if negative
;
;-Add in delta integral term here
;
	ADDD    L01E1			;Add in the delta integral term
	BCC     LD1C2			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
	BRA     LD1D5			;Bra to save and exit		
;
;-Subtract out the delta integral term here
;
	SUBD    L01E1			;Subtract the delta integral term
	BCC     LD1D5			;Bra if no underflow
;
	CLRA				;Clear underflow    
	CLRB				;
	BRA     LD1D5			;Bra to save and return
;
;-Here to perform resets
;
LD1CD	CLRA				;Clear MSB	
;			   
LD1CE	CLRB				;Clear LSB
	STD     L01DF			;Save it, EGR Integrator
	STD     L01E1			;Delta EGR integrator term
;
;-Here to update and return
;
LD1D5	STAA    L01D2			;Desired %EGR
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Charcoal canister purge routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-5 Hz routine
;
LD1D9	BRCLR   L0002,#$10,LD1E0	;Loop counter, bra if b4==0, run the routine  
;
;-Not time to run the routine yet
;
	JMP     LD2D6			;Bra to return
;
;-Check quals for CCP
;
LD1E0	LDAA    L400C			;Opt byte 
	BITA    #$80			;Test b7, CCP enabled
	BEQ     LD21A			;Bra if b7==0, no CCP

	LDAA    L0006			;Cool temp, linearized
	CMPA    L402C			;Cool temp threshold for full DC purge on startup
	BLS     LD1FE			;Bra if cool temp is <=
;
	LDD     L00F8			;Engine run time
	CPD     L402D			;Engine run time for full DC purge
	BHI     LD1FE			;Bra if run time is higher 
;
;-Warm engine temps and engine has just started, set full purge
;
	LDAA    #255			;Max duty cycle
	STAA    L01F9			;Save it, CCP duty cycle
	JMP     LD2CB			;Return
;
;-Check if DFCO is active
;
LD1FE	BRSET   L0046,#$08,LD21A	;Status word, bra if b3==1, DFCO in effect, no CCP
;
;-Check cool temp
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L402B			;Min temp for CCP
	BLS     LD21A			;Bra if cool temp is <=, no CCP
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check params to enable/disable CCP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4030			;Index params for enabling CCP
	BRCLR   L0041,#$80,LD213	;Status word, bra if CCP solenoid not active
;
;-Load params for disabling CCP
;
	LDX     #L4033			;Index params for disabling CCP
;
;-Check speed
;									
LD213	LDAB    L02A7			;MPH
	CMPB    0,X			;MPH threshold to enable/disable CCP
	BCC     LD22E			;Bra if MPH >=, not disabling CCP yet
;
;~~~~~~~~~~~~~~~~
; Here if no CCP
;~~~~~~~~~~~~~~~~
;							   				
LD21A	CLR     L01F9			;Clear CCP duty cycle
	CLR     L01FB			;Clear CCP update timer
;											
	LDAA    L02A7			;MPH
	CMPA    L402F			;Lower MPH threshold to clear CCP DC multiplier
	BCC     LD22B			;Bra if MPH >=
;
	CLR     L01FA			;Clear CCP DC multiplier
;
LD22B	JMP     LD2CB			;Bra to exit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue checking quals
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check TPS
;
LD22E	LDAB    L01FC			;TPS 
	CMPB    2,X			;TPS threshold to enable/disable CCP
	BCS     LD21A			;Bra if TPS <, disable CCP
;
;-Check MAP 
;
	LDAB    L027A			;MSB, kPa of MAP
	CMPB    1,X			;Compare to MAP threshold to enable/disable CCP
	BCS     LD21A			;Bra if MAP <, disable CCP
;
;-Check to make sure CCP is allowed in current BLM cell
;
	LDX     #L4058			;Load in table of allowed cells to purge in
	LDAB    L026A			;Load BLM cell number
	ABX				;Add in as offset
	LDAA    0,X			;Load logic value
	BEQ     LD21A			;Bra if ==0, purge not allowed
;
;-Check if closed loop is in effect
;
	BRCLR   L003E,#$80,LD28D	;Status word, bra if b7==0, not in closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In closed loop, check if updates to CCP DC are allowed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L01EC			;Vacuum
	CMPB    L4024			;Lower vac threshold to allow update
	BHI     LD288			;Bra if vacuum is <, no update
;
	LDAA    L0005			;Status word 
	BITA    #$C0			;Test b6, TPS AE, and b7, MAP AE in effect
	BNE     LD288			;Bra if either AE is in effect, no update
;
;-Check CCP DC update timer
;
	LDAB    L01FB			;CCP update timer
	CMPB    L4025			;Min time between updates 
	BCC     LD266			;Bra if time >=, update CCP DC
;
;-Not time to update yet
;
	INC     L01FB			;+1, CCP update timer
	BRA     LD2A8			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Adjust CCP duty cycle to target desired INT range 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD266	LDAA    L01FA			;Closed loop CCP DC multiplier
	LDAB    L0232			;Integrator
	CMPB    L4026			;Int threshold to increase CCP DC 
	BCC     LD27E			;Bra if int >=
;
	CMPB    L4027			;Int threshold to decrease CCP
	BCC     LD288			;Bra if int >=, no adjustments
;
;-Here to decrease CCP DC
;
	SUBA    L402A			;Rate to decrease multiplier for reduced DC
	BCC     LD285			;Bra if no underflow
;
	CLRA				;Clear underflow
	BRA     LD285			;Bra to save and continue
;
;-Here to increase CCP DC
;
LD27E	ADDA    L4029			;Rate to increase multiplier for additional DC
	BCC     LD285			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
LD285	STAA    L01FA			;Save it, closed loop CCP multiplier
;
;-Here if not updating yet
;
LD288	CLR     L01FB			;CCP update timer
	BRA     LD2A8			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Calculate open loop CCP duty cycle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD28D	LDX     #L4047			;Minimum CCP DC 
	LDAA    L0255			;Gms/sec airflow
	JSR     LF15E			;2D lookup
;
	LDAB    L4028			;Load open loop CCP DC multiplier
	MUL				;DC x multiplier     
	ADDD    #$0040			;round up if needed
	ASLD				;x2, now /128    
	BCC     LD2A3			;Bra if no overflow
;
	LDD     #$FFFF			;Clear overflow
;
LD2A3	STAA    L01F9			;Save it, CCP dutycycle
	BRA     LD2CB			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Calculate closed loop CCP duty cycle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD2A8	LDX     #L4036			;Closed loop CCP DC
	LDAA    L0255			;Gms/sec airflow
	JSR     LF15E			;2D lookup
;
	LDAB    L01FA			;Closed loop CCP DC multiplier	
	MUL				;CCP DC x multiplier
	ADCA    #0			;Round if needed
	STAA    L01F9			;CCP duty cycle
;
;-Check to make sure there is a minimum ammount of CCP DC
;
	LDX     #L4047			;Minimum CCP duty cycle
	LDAA    L0255			;Gms/sec airflow
	JSR     LF15E			;2D lookup
;
	CMPA    L01F9			;CCP DC
	BLS     LD2CB			;Bra if DC is greater
;
	STAA    L01F9			;Save minimum DC instead
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to update CCP status
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
LD2CB	BCLR    L0041,#$80		;Status word, clear b7, CCP not energized										
	LDAA    L01F9			;CCP DC
	BEQ     LD2D6			;Bra if CCP ==0
;
	BSET    L0041,#$80		;Status word, set b7, CCP energized
;
LD2D6	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for catalytic converter reaction overtemp
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD2D7	LDX     #L400F			;Opt. byte
	BRSET   0,X,#$10,LD2E1		;Bra if b4==1, check for cat overtemp
;
;-Not checking for catalytic converter reaction overtemp
;
	JMP     LD398			;Jump to clear overtemp flag and return
;
;-Checking for cat reaction overtemp
;
LD2E1	LDAA    L0002			;Loop counter
	CMPA    #$05			;0000 1001
	BNE     LD2EB			;Bra if !=, dont run loop
;
	BRSET   L004F,#$80,LD2EE	;Status word, bra if b7==1, engine is running
;
;-Engine off/not time to run the loop yet, return
;
LD2EB	JMP     LD398			;Jump to clear overtemp flag and return

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if under high load, and retain current state if high loads, low RPMs present
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD2EE	LDAA    L01FC			;TPS
	CMPA    L4074			;TPS threshold to maintain current cat
					;reaction  temp state
	BHI     LD2FB			;Bra if TPS is >=, check for low RPMs
;
;-Skip test and continue to check for overtemps
;
	CLR     L007E			;Clear cat overtemp protection test timer
	BRA     LD313			;Bra to continue
;
;-Check for low RPM operation
;
LD2FB	LDAA    L0062			;RPM/25
	CMPA    L4075			;Threshold to check quals for maintaining 
					;current cat reaction temp state
	BCC     LD309			;Bra if RPMs >=, continue
;
;-High load, low RPM operation present
;
	LDAA    L007E			;Cat overtemp protection test timer
	INCA				;+1    
	BEQ     LD309			;Bra if ==0, dont save
;
	STAA    L007E			;Save it
;
LD309	LDAA    L007E			;Load timer
	CMPA    L4076			;Timer threshold to skip reaction temp test and 	
					;retain current cat reaction temp state if high
					;load, low RPMs present 
	BCS     LD313			;Bra if less, continue
;
;-Here to retain current cat reaction temperature state and skip update
;
	JMP     LD398			;Exit, dont perform test
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Portion of routine to monitor catalytic converter temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Look up cat temp filter coeff.
;
LD313	LDAA    L0255			;Gms/sec airflow
	TAB				;Get into B     
	LDX     #L4077			;Cat temp filter coeff. vs. airflow
	JSR     LF15E			;2D lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up flow based reaction temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	STAA    L007C			;Save it, cat temp filter coeff.
	LDAA    L0062			;RPM/25
	LSRA				;/2 for lookup    
	LDX     #L408F			;RPM/airflow reaction component table
	JSR     LF17B			;3D lookup
;
	STAA    L007B			;RPM/airflow cat reaction component
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up reaction temp bias vs. AFR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L026D			;AFR
	CMPA    #155			;15.5, max numerical AFR for lookup
	BLS     LD333			;Bra if <=
;
	LDAA    #155			;Load upper limit
;
LD333	SUBA    #107			;Subtract 10.7 AFR bias
	BCC     LD338			;Bra if no underflow
;
	CLRA				;Clear underflow 
;
LD338	ASLA				;AFR x2 for lookup    
	LDX     #L4088			;Cat reaction temp. bias vs. AFR
	JSR     LF15E			;2D lookup
;
	STAA    L007D			;Save cat reaction AFR temp. bias
	SUBA    #$80			;-128, make signed
	BMI     LD34D			;Bra if result was negative
;
;-Positive bias here
;
	ADDA    L007B			;Add in flow based reaction temp
	BCC     LD352			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
	BRA     LD352			;Bra to continue
;
;-Negative bias here
;
LD34D	ADDA    L007B			;Add in flow based reaction temp 
	BCS     LD352			;Bra if result is now positive
;
	CLRA
;    
LD352	STAA    L007A			;Save it, cat reaction temperature
	LDAA    L007A			;Load reaction temp
	LDAB    L007C			;Load flow based filter coeff.
	LDX     L0078			;Filtered cat reaction temperature
	JSR     LF0F6			;Filter routine
;
	STD     L0078			;Save it, filtered cat reaction temp.

	BRCLR   L003E,#$80,LD380	;Status word, bra if b7==0, not in closed loop
;
;~~~~~~~~~~~~~~~~
; In closed loop
;~~~~~~~~~~~~~~~~
;
	LDAB    L0078			;Filtered cat reaction temp
	CMPB    L406D			;Upper allowed threshold for cat reaction temp
	BLS     LD37B			;Bra if reaction temp is <=
;
	LDAA    L084C			;Cat conv. overtemp timer
	INCA				;+1
	BNE     LD371			;Bra if no roll-over
;											
	DECA				;-1, roll back to 255
;
LD371	STAA    L084C			;Cat conv. overtemp timer
	CMPA    L4073			;Compare to max time allowed for overtemp
	BCC     LD395			;Bra if time >=, flag cat. conv. overtemp
;
	BRA     LD386			;Bra to continue
;
LD37B	CMPB    L406E			;Upper allowed threshold for cat reaction temp
					;to clear overtemp condition
	BHI     LD386			;Bra if temp >
;
;-Catalytic converter reaction temp is within allowed range
;
LD380	CLRA				;
	STAA    L084C			;Clear overtemp tiemr
	BRA     LD390			;Bra to clear overtemp flag and return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Check maximum reaction temp. limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD386	CMPB    L406F			;Maximum allowed cat reaction temp
	BHI     LD395			;Bra if temp greater, flag cat overtemp
;
	CMPB    L4070			;Upper allowed raction temp to clear overtemp condition
	BHI     LD398			;Bra if temp >, dont reset
;
;-Here to clear overtemp flag
;
LD390	BCLR    L0052,#$40		;Status word, clear b6, cat converter overtemp flag
	BRA     LD398			;Bra to return
;
;-Here to set overtemp flag
;
LD395	BSET    L0052,#$40		;Set b6, cat converter overtemp flag
;
LD398	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; CPI variable tuning valve control routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD399	LDX     #L400E			;Opt. byte
	BRSET   0,X,#$08,LD3A2		;Bra if b3==1, CPI variable tuning enabled
;
	BRA     LD3C6			;Bra if ==0, no variable tune
;
LD3A2	LDX     #L412B			;Start of CPI variable tune params
;								
	BRSET   L0052,#$08,LD3B0  	;Status word, bra if b3==1, CPI tuning valve enabled
;
;-Check quals to enable tuning valve
;
	LDAA    L00A2			;Linear cool temp
	CMPA    6,X			;Lower cool temp threshold to enable tuning valve
	BCS     LD3C6			;Bra if cool temp <, dont enable tuning valve
;
;-Here to check quals for enabling CPI tuning valve
;											
	INX				;+1, advance to params for enabling
;
;-Here to check quals for disabling the CPI tuning valve
;
LD3B0	LDAA    L0062			;RPM/25
	CMPA    0,X			;Check lower RPM hyst. bound
	BLS     LD3C6			;Bra if RPMs <=, disable tuning valve
;
	CMPA    2,X			;Check upper RPM hyst. bound
	BHI     LD3C6			;Bra if RPMs >, disable tuning valve
;
	LDAA    L01FC			;TPS
	CMPA    4,X			;Lower TPS hyst. bound to disabling tuning valve
	BLS     LD3C6			;Bra if TPS <=, disable tuning valve
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here to enable CPI tuning valve
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BSET    L0052,#$08  		;Status word, set b3, enable tuning valve
	BRA     LD3C9			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here to disable CPI tuning valve
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD3C6	BCLR    L0052,#$08		;Clear b3, disabling tuning valve
;
LD3C9	RTS				;Return 	 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~
;
; VSS handling
;
;~~~~~~~~~~~~~~
;
LD3CA	LDAB    L080C			;# of VSS pulses recieved since last update
	BNE     LD3DD			;Bra if pulse(s) recived
;
;~~~~~~~~~~~~~~~~~~~~
; No VSS pulses here
;~~~~~~~~~~~~~~~~~~~~
;
	CLRA				;Preclear A
	LDAB    L0811			;VSS pulse timer
	BEQ     LD3D8			;Bra if ==0, clear current MPH
;
	DECB				;-1
	BNE     LD410			;Bra to save and exit
;
;-VSS timed out, clear MPH and exit
;
LD3D8	STD     L0812			;Clear MPH
	BRA     LD410			;Bra to save and exit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if VSS pulse recieved
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD3DD	LDAA    L0811			;VSS timer
	BEQ     LD405			;Bra if =0, too few VSS pulses to update, perform resets
;
;-Calculate vehicle speed
;
	LDAA    #230			;Mult. for VSS
	MUL				;# VSS pulses recieved x 230
	ASLD				;x2
	XGDX				;Get result into X
	LDD     L080D			;Load VSS counter
	SUBD    L080F			;-VSS counter, one delayed
	XGDX				;Swap previous result into D and get VSS period into X
	FDIV				;fractional div., (# VSS pulses x 460) / VSS period
	LDD     L0812			;Current MPH
	CMPA    L4132			;Lower threshold for MPH
	XGDX				;Get result of FDIV into D
	BCC     LD402			;Bra if MPH where greater then threshold
;
;-MPH less then lower threshold here
;
	CMPA    L0812			;Compare calc'd mph to stored MPH
	BCS     LD402			;Bra if calc'd mph are less, save.
;
;-Calc'd mph where greater then stored mph
;
	INC     L0812			;+1, Current MPH
	BRA     LD405			;Bra to continue
;
LD402	STD     L0812			;Current MPH
;
;-Here to perform resets
;
LD405	CLR     L080C			;Clear # VSS pulses recieved counter
	LDX     L080D			;Load current VSS counter
	STX     L080F			;Save it, VSS counter, one delayed
	LDAB    #$27			;Max time to update VSS
;
LD410	STAB    L0811			;VSS pulse timer
	RTS 				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
; MPH filtering routine
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LD414	LDD     L0812			;Load current MPH
	LDX     L02A7			;MPH
	LDY     #L4E84			;Filter coeff for MPH
	JSR     LF0D3			;Filt. routine
;
	STD     L02A7			;Save it, filtered MPH

	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~
;
LD425	JSR     LE444			;Check for heat related transmission errors
;
	JSR     LE46C			;Check for trans related errors
;
	JSR     LE45C			;Check for external errors that can effect trans.
;
	CLRA				;
	STAA    L0080			;
;											
	LDAB    L00D3			;Gear #
	CMPB    #03			;4th gear
	BCC     LD491			;Bra if in OD
;
;-Not in overdrive here
;
	LDX     #LD71E			; TABLE
	JSR     LD8FE			;
;
	BEQ     LD444			;Bra if in 1st/P/N/R
;
;-Not in 1st/P/N/R
;
	BSET    L0080,#$08		; SET b3
	BRA     LD478			;
;
;~~~~~~~~~~~~~~
; In 1st/P/N/R
;~~~~~~~~~~~~~~
;
LD444	LDX     #LD6FA			;Range select shift RPM params
	JSR     LD8DC			;Do lookup
;											
	BCS     LD451			;Bra if table not in use

	BSET    L0080,#$04		;
	BRA     LD478			;				
;
LD451	BRCLR   L0096,#$10,LD46C	;Status word, bra if b4==0, no kick down pattern 
;
;-Kickdown pattern active
;
	LDY     #LD605			;Table addr., point to start shift params 
	JSR     LD854			;
;
	BCS     LD46C			; 
;
	PSHA				;    
	LDY     #$D61D			; KICK DOWN (UP) MODE THRESH INDEX TBL 
	JSR     LD8B7			;
;
	PULA				;
	BSET    L0080,#$02		; SET b1, 
;
	BRA     LD47B
;
;-Kickdown pattern not active
;
LD46C	LDY     #$D605			; TABLE POINTER TO FURTHER INDEXES
	JSR     LD7FB			;
;
	BCS     LD491			;
;
	BSET    L0080,#$01		; SET b0
;
;-
;											
LD478	LDX     #$0000			;Clear X
;
;- 
;
LD47B	LDAB    #$01			;
	CMPA    #$FF			;Bra if no limit
	BEQ     LD491			;

	CMPA    L00D1			;MPH
	BHI     LD491			;Bra if shift limit > MPH
;
;-Shift threshold
;
	BRCLR   L0093,#$20,LD48C	;(???)
;
	LDX     #$0000			;Clear X
;
LD48C	CPX     L019D			;RPM x 8
	BLS     LD4DA			;Bra if <=

LD491	CLRA				;Clear     
	LDAB    L00D3			;Gear #
	DECB				;-1
	BMI     LD4D9			;Bra if in 1st/P/N
;
	LDX     #LD743			; 
	JSR     LD8FE			;
;											
	BEQ     LD4A4			;Bra if in 2nd gear
;
	BSET    L0080,#$80		; SET b7
	BRA     LD4CF			;
;
;-In second gear here
;
LD4A4	LDX     #$D70C			; <---- ???? 
	JSR     LD8DC			;
;											
	BCS     LD4B1			;Bra if addr. ==09

	BSET    L0080,#$40		;
	BRA     LD4CF			;
;
;
;
;
LD4B1	BRCLR   L0096,#$10,LD4C3	;Status word, bra if b4==0, no kickdown pattern
;											
	LDY     #$D611			; SHIFT MODE INDEX
	JSR     LD854			;
;											
	BCS     LD4C3			;
;
	BSET    L0080,#$20		; SET b5,
;											
	BRA     LD4CF				

	LD4C3	LDY     #$D611		; SHIFT MODE INDEX
	JSR     LD7FB			;
;
	BCS     LD4D9			;
;
	BSET    L0080,#$10		;
;
;
;											
LD4CF	LDAB    #255			;
	CMPA    #$00			;
	BEQ     LD4D9			;

	CMPA    L00D1			;MPH
	BHI     LD4DA			;Bra if higher
;
;-Here if in 1st/P/N/R
;
LD4D9	CLRB				;
;
LD4DA	ADDB    L00D3			;Add in Gear #
	CMPB    L00D3			;Gear #
	BEQ     LD4E3			;
;
	STAA    L0180			;
;
LD4E3	BRSET   L0083,#$01,LD4EB	;Bra if cold temperature threshold set
;
	BRCLR   L0092,#$80,LD4F1	;Bra if no heat related trans. errrors set
;
;-Heat related errors set here
;
LD4EB	CMPB    #$0002			;
	BLS     LD4F1			;
;
	LDAB    #$0002			;
;
;-No heat related errors set
;
LD4F1	BRCLR   L0093,#$08,LD4F7	;Bra if no high system voltage errors present
;
	LDAB    #$0002			;
;
LD4F7	BRCLR   L0093,#$01,LD50F	;Status word, bra if b0==0, no ext. errors set
;
	CMPB    L00D3			; GEAR NUMBER
	BLS     LD505			;
;
	CMPB    #$0002			;
	BLS     LD50F			;
;
	BRA     LD50D			;
;
LD505	CMPB    L00D3			; GEAR NUMBER
	BCC     LD50F			;
;
	CMPB    #$0002			;
	BCC     LD50F			;
;
LD50D	LDAB    L00D3			; GEAR NUMBER
;
;-No external errors set here
;
LD50F	BRSET   L0092,#$08,LD517	;Status word, bra if b3==1, trans related errors
;
	BRCLR   L0093,#$02,LD519	;Status word, bra if 

LD517	LDAB    #$0002			;
LD519	BRCLR   L0093,#$04,LD549	;

	CMPB    L00D3			; GEAR NUMBER
	BLS     LD527			;
;
	CMPB    #$0001			;
	BLS     LD549			;
;
	BRA     LD547			;
;
;
;
LD527	CMPB    L00D3			; GEAR NUMBER
	BCC     LD547			;
;
	CMPB    #$01			;
	BHI     LD549			;
;
	LDAA    #$0001			;
	CMPA    #$0001			;
	BNE     LD547			;
;
	LDAA    L00D3			; GEAR NUMBER
	CMPA    #$02			;
	BNE     LD547			;
;
	LDX     L019D			; RPM * 8
	CPX     L5D2D			; 650 RPM
	BCC     LD547			; BR IF RPM GT 650 RPM
;
	LDAB    #$0001			;
	BRA     LD549



LD547	LDAB    L00D3			; GEAR NUMBER
;
; CURRENT ERR WD 2
; $F5
;
LD549	BRCLR   L0017,#$20,LD556	; BR IF NOT b5, ERR 24, LOW Vss
;
	LDAA    L5B2C			; MASK XMISSH ERR WD 2, 1010 0010,
	ANDA    #$20			; b5, ERR 24, OUTPUT XMISH SPD LOW 
	BEQ     LD556			; BR IF NOT b5
;
	LDAB    #$01			;
;
LD556	BCLR    L007F,#$24		; CLR 0010 0100
	CMPB    L00D3			; GEAR NUMBER
	BEQ     LD567			; BR IF GEAR ..
;
	BCS     LD564			;
;
	BSET    L007F,#$04		;
	BRA     LD567			;
;
LD564	BSET    L007F,#$20		;
;
LD567	BRCLR   L007F,#$20,LD57D
;
	LDAA    L00D3			; GEAR NUMBER
	CMPA    #$02			; 
	BNE     LD57D			;
;
	BRSET   L007F,#$40,LD589	;
;
	BSET    L007F,#$40		;
;
	BCLR    L007F,#$80		;
	BRA     LD589			;
;
LD57D	BCLR    L007F,#$40		;
	LDAA    L0131			;
	INCA				;    
	BEQ     LD589			;
;
	STAA    L0131			;
LD589	BRSET   L007F,#$04,LD5C2	;
;
	BRCLR   L007F,#$20,LD5C2	;

	LDAA    L00D3			; GEAR NUMBER
	CMPA    #$03			;
	BNE     LD59A			;
;
	CLR     L0131			;
;
;***************************************************
;* DATA SHIFT POINT CONTROL
;* (shift pattern params)
;***************************************************
;
LD59A	BRCLR   L007F,#$40,LD5B8	;
;
	LDAA    L0131			;
	CMPA    L5D26			; 2  SEC'S, 4 -> 2 shift delay lo lmt
	BLS     LD5B8			;
;
	CMPA    L5D27			; 15 SEC'S, 4 -> 2 shift delay hi lmt
	BCC     LD5B8			;
;
	LDAA    L0118			;
	BNE     LD5B8			;
;
	LDAA    L0130			;
	CMPA    L5D25			;
	BCS     LD5C0			;
;
LD5B8	LDAA    L0123			;
	CMPA    L5D24			;
	BCC     LD5C2			; 

LD5C0	LDAB    L00D3			; GEAR NUMBER
LD5C2	TBA				;     
	BCLR    L0081,#$20		; CLR B5
;											
	BRCLR   L009C,#$04,LD5D6	; BR IF NOT b2

	CMPB    #$03			; 
	BNE     LD5D6			;
;
	TST     L018D			;
	BEQ     LD5D6			;
;
	BSET    L0081,#$20		; SET b5, 

LD5D6	JSR     LE322			;Check range routine

	BCLR    L007F,#$09		;
	LDAB    L0103			;Gear select counter
	BEQ     LD5F4			;bra if ==0, in first
;
	DECB				;-1 gear select counter   
	CMPB    #$03			;OD
	BLS     LD5EC			;Bra if <= continue
;
	LDAB    #$04			;
	STAB    L0103			;
	DECB				;
;
;-
;   
LD5EC	LDAA    #255			;
	STAA    L0180			;
	TBA				;Get gear select counter into A    
	BRA     LD602			;Bra to save as gear #
;
;-
;
LD5F4	CMPA    L00D3			;Compare allowed gear to gear #
	BEQ     LD604			;Bra if in same gear
;
	BCS     LD5FF			;Bra if gear # greater then allowed gear
;
;-Here if current gear < then allowed gear
;
	BSET    L007F,#$01		;Set b0, forced to upshift
	BRA     LD602			;Bra to save 
;
;-Here if current gear > then allowed gear 
;
LD5FF	BSET    L007F,#$08		;Set b3, forced to downshift here
;
LD602	STAA    L00D3			;Save allowed gear as gear #
;
LD604	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;----------------------------------------------
; TABLE POINTER TO FURTHER INDEXES
;
; 09-13-1996  Dissassemby of bdwm  
;
;----------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Point to Kickdown mode params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD605   FDB LD6A4		;Point start of kick down mode shift point tables
	FDB LD6C9		;Kickdown mode vs. gear number table, cold modifer
	FDB LD799		;
;
	FDB LD623		; MANUAL SHIFT 1 -> 2 SHIFT Vs. %TPS	TBL
	FDB LD648		; INDEC COLD SHIFT PRESS MOD TABLES
	FDB LD768		;
;
;--------------------------------------------------
;
;
;--------------------------------------------------
;		
LD611   FDB LD6CF		; KICK DOWN MODE THRESH TABLE
	FDB LD6F4		; KICK DOWN MODE THRESH TABLE, (COLD MODIFIER)
	FDB LD799		;
;
	FDB LD64E		; DOWN SHIFT TABLE  Vs. %TPS 
	FDB LD673		; COLD MOD DOWN SHIFT Vs. %TPS
	FDB LD768		;
;--------------------------------------------------
;		
;--------------------------------------------------
; KICK DOWN (UP) MODE THRESH
;
;--------------------------------------------------
;		
LD61D   FDB LD679		; KICK DOWN (UP) MODE THRESH Vs RPM (6 blocks)
	FDB LD69E		; KICK DOWN (UP) MODE THRESH VS GR, (COLD MOD)
	FDB LD7CA		;
;--------------------------------------------------
;		
;--------------------------------------------------
; MANUAL SHIFT 1 -> 2 SHIFT Vs. %TPS	TBL
;
;--------------------------------------------------
;		
LD623   FCB $06			;
;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
	FDB L5D57		; MANUAL SHIFT 1 -> 2 SHIFT Vs. %TPS	TBL
	FDB L5DCE		; NORMAL SHIFT 2 -> 3 SHIFT Vs. %TPS	TBL
	FDB L5DDF		; NORMAL SHIFT 3 -> 4 SHIFT Vs. %TPS	TBL
;
	FDB L5DBD		;
	FDB L5D79		; NORM/CRUISE SHIFT 2 -> 3 SHIFT Vs. %TPS TBL
	FDB L5D8A		; NORM/CRUISE SHIFT 3 -> 4 SHIFT
;
	FDB L5DBD		;
	FDB L5D79		; NORM/CRUISE SHIFT 2 -> 3 SHIFT Vs. %TPS TBL
	FDB L5D8A		; NORM/CRUISE SHIFT 3 -> 4 SHIFT
;
	FDB L5DBD		;
	FDB L5DCE		; NORMAL SHIFT 2 -> 3 SHIFT Vs. %TPS	TBL
	FDB L5DDF		; NORMAL SHIFT 3 -> 4 SHIFT Vs. %TPS	TBL
;
	FDB L5DBD		;
	FDB L5DCE		; NORMAL SHIFT 2 -> 3 SHIFT Vs. %TPS TBL
	FDB L5DDF		; NORMAL SHIFT 3 -> 4 SHIFT Vs. %TPS	TBL
;-------------------------------------------------		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cold shift modifier vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 	table addr.			;Shift
;
LD648   FDB L5E23   			;1 -> 2 
	FDB L5E34   			;2 -> 3 
	FDB L5E45   			;3 -> 4 
;--------------------------------------------------
;		
;--------------------------------------------------
; DOWN SHIFT TABLE INDEX
;
;--------------------------------------------------
;
LD64E   FCB $06      		; 6 BIT'S/BLOCK

	FDB $0000		; 2 -> 1 SHIFT
	FDB $0000		; 3 -> 2 SHIFT
	FDB $0000		; 4 -> 3 SHIFT
;
	FDB L5D68		; MANUAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS	TBL
	FDB L5E01		; NORMAL DN SHIFT, 3 -> 2 SHIFT Vs. %TPS TBL
	FDB L5E12		; NORMAL DN SHIFT, 4 -> 3 SHIFT Vs. %TPS TBL
;
	FDB L5DF0		; NORMAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS TBL
	FDB L5D9B		; NORM/CRUISE DN,  3 -> 2 SHIFT Vs. %TPS	TBL
	FDB L5DAC		; NORM/CRUISE DN,  4 -> 3 SHIFT Vs. %TPS	TBL
;
	FDB L5DF0		; NORMAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS TBL
	FDB L5D9B		; NORM/CRUISE DN   3 -> 2 SHIFT Vs. %TPS	TBL
	FDB L5DAC		; NORM/CRUISE DN,  4 -> 3 SHIFT Vs. %TPS	TBL
;
	FDB L5DF0		; NORMAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS TBL
	FDB L5E01		; NORMAL DN SHIFT, 3 -> 2 SHIFT Vs. %TPS TBL
	FDB L5E12		; NORMAL DN SHIFT, 4 -> 3 SHIFT Vs. %TPS TBL
;
	FDB L5DF0		; NORMAL DN SHIFT, 2 -> 1 SHIFT Vs. %TPS TBL
	FDB L5E01		; NORMAL DN SHIFT, 3 -> 2 SHIFT Vs. %TPS TBL
	FDB L5E12		; NORMAL DN SHIFT, 4 -> 3 SHIFT Vs. %TPS TBL
;--------------------------------------------------
;		
;--------------------------------------------------
;  COLD MOD DOWN SHIFT Vs. %TPS
;
;--------------------------------------------------
;
LD673   FDB L5E56		;  2 -> 1, COLD MOD SHIFT Vs. %TPS
	FDB L5E67		;  3 -> 2, COLD MOD SHIFT Vs. %TPS
	FDB L5E78		;  4 -> 3, COLD MOD SHIFT Vs. %TPS	
;--------------------------------------------------
;		
;--------------------------------------------------
; KICK DOWN (UP) MODE THRESH Vs RPM, (HOT)
;
;--------------------------------------------------
;		
LD679   FCB $06			; 6 BLOCKS 

	FDB L5D4B		; 1 -> 2 KICK DOWN MODE THRESH Vs RPM, (HOT)
	FDB L5D4B		; 1 -> 2 KICK DOWN MODE THRESH Vs RPM, (HOT)
	FDB L5D4F		; 3 -> 4 KICK DOWN MODE THRESH Vs RPM, (HOT)
;
	FDB L0000		; 1 -> 2  not used ???
	FDB L0000		; 2 -> 3 
	FDB L0000		; 3 -> 4 
;
	FDB L5D45		; 1 -> 2 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D47		; 2 -> 3 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D49		; 3 -> 4 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
;
	FDB L5D45		; 1 -> 2 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D47		; 2 -> 3 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D49		; 3 -> 4 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
;
	FDB L5D45		; 1 -> 2 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D47		; 2 -> 3 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D49		; 3 -> 4 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
;
	FDB L5D45		; 1 -> 2 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D47		; 2 -> 3 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
	FDB L5D49		; 3 -> 4 KICK DOWN MODE  THRESH Vs RPM, (NORMAL)
;--------------------------------------------------
;		
;--------------------------------------------------
;  KICK DOWN MODE (UP) THRESH VS GR, (COLD MOD)
;
;--------------------------------------------------
;		
LD69E   FDB $5D51		; 1 -> 2 KICK DOWN MODE THRESH VS GR, (COLD MOD)
	FDB $5D53		; 2 -> 3 KICK DOWN MODE THRESH VS GR, (COLD MOD)
	FDB $5D55		; 3 -> 4 KICK DOWN MODE THRESH VS GR, (COLD MOD)
;--------------------------------------------------
;
;--------------------------------------------------
;  KICK DOWN MODE Vs GEAR TABLES
;
;--------------------------------------------------
;
LD6A4   FCB $6			;

	FDB L5D39		; 1 -> 2 KICK DOWN MODE Vs GEAR TABLE, (HOT)
	FDB L5D3A		; 2 -> 3 KICK DOWN MODE Vs GEAR TABLE, (HOT)
	FDB L5D3B		; 3 -> 4 KICK DOWN MODE Vs GEAR TABLE, (HOT)
;
	FDB $0000		; 1 -> 2 
	FDB $0000		; 2 -> 3 
	FDB $0000		; 3 -> 4 
;
	FDB L5D33		; 1 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D34		; 2 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D35		; 3 -> 4 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;
	FDB L5D33		; 1 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D34		; 2 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D35		; 3 -> 4 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;
	FDB L5D33		; 1 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D34		; 2 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D35		; 3 -> 4 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;
	FDB L5D33		; 1 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D34		; 2 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D35		; 3 -> 4 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;--------------------------------------------------
;		
;--------------------------------------------------
; KICK DOWN MODE Vs GEAR TABLE, (COLD MODIFER)
;
;--------------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Kickdown mode vs. gear table, cold modifier
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	MPH modifier		;Shift
;
LD6C9   FDB L5D3F		; 1 -> 2 
	FDB L5D40		; 2 -> 3  
	FDB L5D41		; 3 -> 4  
;--------------------------------------------------
;		
;--------------------------------------------------
; KICK DOWN MODE  THRESH TABLE
;
;--------------------------------------------------
;
LD6CF   FCB $06			;

	FDB L5D3C		; 2 -> 1 KICK DOWN MODE  THRESH TABLE, (HOT)
	FDB L5D3D		; 3 -> 2 KICK DOWN MODE  THRESH TABLE, (HOT)
	FDB L5D3E		; 4 -> 3 KICK DOWN MODE  THRESH TABLE, (HOT)
;
	FDB $0000		; 2 -> 1 
	FDB $0000		; 3 -> 2 
	FDB $0000		; 4 -> 3 
;
	FDB L5D36		; 2 -> 1 KICK DOWN MODE Vs GEAR TABLE, (NORMAL) 
	FDB L5D37		; 3 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL) 
	FDB L5D38		; 4 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL) 
;
	FDB L5D36		; 2 -> 1 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D37		; 3 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D38		; 4 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;
	FDB L5D36		; 2 -> 1 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D37		; 3 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D38		; 4 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;
	FDB L5D36		; 2 -> 1 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D37		; 3 -> 2 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
	FDB L5D38		; 4 -> 3 KICK DOWN MODE Vs GEAR TABLE, (NORMAL)
;--------------------------------------------------
;		
;--------------------------------------------------
; KICK DOWN MODE  THRESH TABLE
;
;--------------------------------------------------
;
LD6F4   FDB L5D42		; 2 -> 1  KICK DOWN MODE  THRESH TABLE
	FDB L5D43		; 3 -> 2  KICK DOWN MODE  Vs. GEAR TABLE, (COLD MODIFER)
	FDB L5D44		; 4 -> 3  KICK DOWN MODE  Vs. GEAR TABLE, (COLD MODIFER)
;
;--------------------------------------------------
;
; LOW PK/NEUT PARAMS MANUAL TABLE 
;
;--------------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Range select shift point table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-1st selected			;Current gear #
;
LD6FA   FDB L5D31		;1st
	FDB L5D30		;2nd
	FDB L5D30		;3rd
;
;-2nd selected
;
	FDB $0000		;1st
	FDB L5D30		;2nd
	FDB L5D30		;3rd
;
;-3rd selected
;
	FDB $0000		;1st
	FDB $0000		;2nd
	FDB $0000		;3rd
;
;----------------------------------------------
;
;
;
;---------------------------------------------- 
;   
LD70C   FDB L5D32		; LOW PK/NEUT PARAMS MANUAL LOW,  2 -> 1 SHIFT THRESH
	FDB L5D2F		; MIN/MAX SHIFT POINT VAL'S, MIN VAL FOR SHIFT POINT
	FDB L5D2F		; MIN/MAX SHIFT POINT VAL'S, MIN VAL FOR SHIFT POINT
;
	FDB $0000		;
	FDB L5D30		; MAX VAL FOR SHIFT POINT
	FDB L5D2F		; MIN/MAX SHIFT POINT VAL'S
;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;----------------------------------------------			
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-
;~~~~~~~~~~~~~~~~~~~~~~~~
;   
LD71E   FCB  $06		;3 address' per lookup	
;
;	Addr.			;Gear #
;
	FDB  L0104		;
	FDB  L0105		;
	FDB  L0106		;
;
	FDB  L0104		;
	FDB  L0105		;
	FDB  L0106		;
;
	FDB  L0104		;
	FDB  L0105		;
	FDB  L0106		;
;
	FDB  L0104		;
	FDB  L0105		;
	FDB  L0106		;
;
	FDB  L0104		;
	FDB  L0105		;
	FDB  L0106		;
;
	FDB  L0104		;
	FCB  L0105		;
	FCB  L0106		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD743   FCB $06			;6 line address offset for each lookup
;
;				;Gear #
;
LD744   FCB L0107		;1st
	FCB L0108      		;2nd
	FCB L0109		;3rd
;
	FCB L0107     		;
	FCB L0108      		;
	FCB L0109      		;
;
	FCB L0107      		;
	FCB L0108      		;
	FCB L0109      		;
;
	FCB L0107      		;
	FCB L0108      		;
	FCB L0109      		;
;
	FCB L0107      		;
	FCB L0108      		;
	FCB L0109      		;
;
	FCB L0107      		;
	FCB L0108      		;
	FCB L0109      		;
;--------------------------------------------------
;		
;--------------------------------------------------
;
;
;--------------------------------------------------
;
LD768   FCB $08			;
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;--------------------------------------------------
;		
;--------------------------------------------------
;
;
;--------------------------------------------------
;
LD799   FCB $08			;

	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;--------------------------------------------------
;
;--------------------------------------------------
;
;
;--------------------------------------------------
;
LD7CA   FCB $08			;
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5DC2		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
	FDB $0000		;
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
	FDB L5D2C		; Base shift point comp gain
;
;----------------------------------------------
;  
;
;----------------------------------------------
;
LD7FB	PSHB				;
	CLRA				;
	PSHA				;
	PSHA				;
	PSHA				;
	LDX     $08,Y			;										;
	ABX				;
	ABX				;
	LDX     0,X			;
	BEQ     LD81B			;
;
	LDAA    L00AC			;
	JSR     LF15E			; 2d LK UP
;											
LD80E	SUBA    #128			;
;
LD810	LDAB    0,X			;
;
LD812	SUBB    #128			;
;
LD814	TSX				;
	STAB    2,X			;
	STAA    0,X			;
	LDAB    3,X			;
;
LD81B	LDX     6,Y			;
;
LD81E	JSR     LD90A			;
;										
	LDAA    #$00			;
	BCC     LD82A			;
;
	PULB				;
;
LD826	PULB				;
	PULB				;    					
	BRA     LD852			;
;
LD82A	LDAA    L00AC			;
	JSR     LF15E			; 2D LK UP
;
LD82F	LDAB    0,X			;
	TSX				;     
	STAB    1,X			;
	CLRB				;    
	XGDX				;    
	PULA				;    
	CLRB				;    
	JSR     LD984			;
;
LD83B	LDX     $0A,Y			;
	JSR     LD934			;
;
LD841	XGDX 				;   
	PULA				; 
;   
LD843	CLRB				;    
	XGDX				; 
;   
LD845	TAB				;     
	PULA				;  
;  
LD847	PSHB				;    
	CLRB				; 
;   
LD849	JSR     LD984			;
;
	PULB				;
;    
LD84D	CBA				;     	
	BCC     LD852			;
;
	TBA				;
;     
LD851	CLC				;
;    
LD852	PULB				;  
;  
LD853	RTS				;     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to do do shift point lookups when kickdown pattern active
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD854	PSHB				;Gear # to stack
	CLRA				;    
	PSHA				;Clear space on stack
	PSHA				;    
	PSHA				;    
	LDX     2,Y			;Load addr., points to kickdown cold modifier table
	ABX				;Add in gear #     
	ABX				;Add in gear #, x2 for double byte addr.     
	LDX     0,X			;Load addr.
	BEQ     LD869			;Bra if ==0, table not in use
;
;-Table in use here
;
	LDAA    0,X			;Load in kickdown cold modifer
	SUBA    #$0080			;Make signed value
	TSX				;Get current stack pointer into X
	STAA    0,X			;Save modifer to stack
;
LD869	LDX     $0008,Y			;Load table addr., point to shifr mod. vs %TPS table
	ABX				;Add in gear # as offset     
	ABX				;Add in gear #, x2 for double byte addr.     
	LDX     0,X			;Load table addr.
	BEQ     LD879			;Bra if table not in use
;
;-Table in use here
;
	LDAA    0,X			;Load in first shift mod. value
	SUBA    #$0080			;Make value signed
	TSX				;Get current stack pointer     
	STAA    2,X			;Save to stack
;
LD879	LDX     6,Y			;Load addr., points to shift calib. vs %tps
	JSR     LD90A			;Go do lookup
;
	BCS     LD886			;Bra if table not in use
;
	LDAA    0,X			;Load in first shift point calib. val.
	TSX				;Get current stack pointer      
	STAA    1,X			;Save to stack
;
LD886	LDX     0,Y			;Load addr., upper mph thresh. to perform upshift
	JSR     LD90A			;Go do lookup
;
	LDAA    #$0000			;Preclear A
	BCC     LD895			;Bra if table in use
;
;-Here to clean up stack and return if talble not in use
;
	PULB				;   
	PULB				;    
	PULB 				;   
	BRA     LD8B5			;
;
;-Here to continue
;
LD895	LDAA    0,X			;Load upshift mph from table
	CLRB				;Clear LSB    
	XGDX				;Swap X and D    
	PULA				;Pull kickdown mode cold modifer from stack   
	CLRB				;Clear LSB    
	JSR     LD984			;Apply cold modifier
;
	LDX     4,Y			;Addr. pointing to base shift point gain
	JSR     LD934			;
;
	XGDX				;    
	PULA				;    
	CLRB				;    
	XGDX				;    
	TAB				;     
	PULA				;    
	PSHB				;    
	CLRB				;    
	JSR     LD984			;
;
	PULB				;	 		   
	CBA				;     
	BCC     LD8B5			;
;
	TBA				;     
	CLC				; 	
;    
LD8B5	PULB				;    
	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD8B7	PSHB				;Push gear number to stack    
	LDX     2,Y			;
	ABX				;     
	ABX 				;    
	LDX     0,X			;
	BEQ     LD8C3			;
;
	LDX     0,X			;
;
LD8C3	PSHX				;    
	LDX     0,Y			;
	JSR     LD90A			;
;
	BCS     LD8CE			;
;
	LDX     0,X			;
;
LD8CE	PULA				; 	   
	PULB				;    
	JSR     LD984			;
;
	LDX     4,Y			;
	JSR     LD934			;
;
	XGDX				;    
	PULB				;    
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to look up shift point based on range select
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD8DC	PSHB				;Gear # to stack    
	BRSET   L0092,#$04,LD8FA	;Status word, bra if b2==1,				;pressure swich man. error
;
;-No error set here
;
	LDAA    L009C			;Range select word
	ANDA    #$07			;Clear all but b0-b2
	BEQ     LD8FA			;Bra if in OD/P/N/R
;
;-Here if 1st/2nd/Drive selected
;
	LSRA				;Logical shift left, only 2nd/Drive status    
	PSHB				;Push gear # to stack    
	LDAB    #$0003			;3 lines/table
	MUL				;3 x range select status     
	PULA				;Get gear number back in    
	ABA				;Add it in for lookup     
	ASLA				;x2 for double byte vals.  
	TAB				;Get result into B     
	ABX				;Add in as offset for lookup
	LDX     0,X			;Load table addr.
	BEQ     LD8FA			;Bra if addr. ==0
;
;-Table addr. in use
;
	LDAA    0,X			;Load shiftpoint from table
	CLC				;Clear C bit     
	BRA     LD8FC			;Bra to return
;
;-Here if in OD/P/N/R selected or table not in use
;
LD8FA	CLRA				;Clear A
	SEC				;Set C bit, table not in use
;
LD8FC	PULB				;Get gear number
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~
;
LD8FE	PSHB				;Gear # to stack
	BSR     LD90A			;
;											
	BCC     LD906			;Bra if looked up addr. !=0
;
;-Addr. ==0
;
	CLRA				;Clear A  
	BRA     LD908			;Bra to return
;
;-Addr. !=0
;
LD906	LDAA    0,X			;Load A from addr.
;
LD908	PULB				;Get gear # back
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to look up shift point related items based on various params
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD90A	PSHB				;Gear # to stack	
	LDAA    0,X			;Load in address offset for lookups from table
	INX				;+1, next address
	ASLB				;gear # x2
	ABX				;Add in gear number as offset
	TAB				;Offset into B											;
	BRCLR   L0083,#$02,LD91B	;Temp. status word, bra if b1==0, no hot 
					;trans temp flagged 
;
;-Here if hot trans temp threshold flagged
;
	LDAA    0,X			;Load in table addr.
	ORAA    1,X			;
	BNE     LD92C			;Bra if !=0
;
LD91B	ABX				;Add in offset
	BRSET   L0099,#$04,LD92C	;Shift pattern word,
					;bra if b2==1, manual pattern requested
;
;-Manual pattern not requested
;
	ABX				;Add in gear # as offset
	BRSET   L0096,#$40,LD927	;Status word, bra if b6==1, cruise low active
;
;-Cruise low not active
;
	ABX				;Add in gear # as offset
	ABX				;
LD927	BRSET   L0099,#$02,LD92C	;Bra if b1==1, peformance pattern requested
;
;-Performance pattern not requested
;
	ABX				;Add in offset
;
LD92C	CLC				;Clear carry
	LDX     0,X			;Load in address values
	BNE     LD932			;Bra if !=0
;
	SEC				;Set carry, looked up addr ==0
;
LD932	PULB				;Get gear # back
;
	RTS				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;----------------------------------------------
; XMISH SUB ROUTINE
;
;
;----------------------------------------------	
;										
LD934	PSHB				;
	PSHA				;
	LDAB    L00D3			; GEAR NUMBER
	JSR     LD90A			;
;											
	BCS     LD94C			; EXIT via RTS
;											
	JSR     LD94F			;
;											
	TSX				;
	JSR     LF1ED			; 8 x 16 Mult w/16b result rounded to upper 16b
;											
	ASLD				;
	BCC     LD94A			; BR IF NO OVERFLOW, (EXIT)
;
	LDD     #$FFFF			; USE MAX VAL
LD94A	PULX				;
;
	RTS				; RETURN TO CALLER     
			

LD94C	PULA				;    	
	PULB				;    
	RTS				; RETURN TO CALLER     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;----------------------------------------------
;
;
;
;----------------------------------------------
;
LD94F	CLRA				;    
	LDAB    0,X			;
	SUBB    #$0080			;
	PSHB				;    
	BPL     LD959			;
;
	NEGB				;    
	DECA				;    
;
LD959	PSHA				;    
	LDAA    L00A6			;
	MUL				;     
	ASLD				;    
	TSX				;     
	TST     0,X			;
	BEQ     LD967			;
;
	NEGA				;    
	NEGB				;    
	SBCA    #$0000			;
;
LD967	SUBA    1,X			;
	ADDA    #$0080			;
	PULX				;    
	RTS				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LD96D	LDAA    L00A6			;
	SUBA    #$0080			;
	LDAB    0,X			;
	MUL				;     
	TST     L00A6			;
	BMI     LD97B			;
;
	SUBA    0,X			;
;
LD97B	ADDA    #$0040			;
	BGT     LD982			;
;
	LDD     #$0000			;
;
LD982	ASLD				;    
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to apply temp based modifiers
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD984	PSHX				;    
	PSHA				;Push modifier to stack    
	TSTA				;Test for sign    
	BPL     LD98D			;Bra if > 0
;
;-Modifier is <= 0 here, make val
;
	NEGA				;Make abs. value   
	NEGB				;    
	SBCA    #$0000			;Perform carry if needed
;
;-Modifer > 0 here
;
LD98D	PSHB				;Push LSB to stack 			   
	PSHA				;Push MSB to stack    
	TSX				;Get current stack pointer     
	LDAA    L00A5			;Cold temp trans term
	JSR     LF1ED			;(A x X*)/256
;
	PULX				;Clean up stack by pulling |modifier| 
	TSX				;Get current stack pointer     
	TST     0,X			;Test sign of modifier
	BPL     LD99F			;Bra if plus
;
;-Modifier is negative here
;
	NEGA				;Make result negative				    
	NEGB				;    
	SBCA    #$0000			;Perform carry if needed
;
LD99F	INS				;+1 to stack pointer			     
	PSHA				;Push MSB of result to stack    
	ADDD    1,X			;Add to origional 16 bit value on stack
	BCS     LD9AF			;Bra if overflow
;
;-Filter out positive values
;
	PSHA				;Push MSB of final value to stack    
	ANDA    0,X			;And final value with previous result
	PULA				;Get MSB of final value back    
	BPL     LD9B8			;Bra if both values arnt negative
;
;-Clear underflow here
;
	CLRA				;Clear result   
	CLRB				;    
	BRA     LD9B8			;Bra to return
;
;-Filter out change of sign carries
;
LD9AF	PSHA				;    
	ORAA    0,X			;
	PULA				;    
	BMI     LD9B8			;Bra if either value negative
;
;-Clear overflow
;
	LDD     #$FFFF			;Clear overflow
;
;-Clean up the stack
;
LD9B8	INS				;+1, stack pointer     
	PULX				;Pull X from stack
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to handle MAT 
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
LD9BB	LDX     #L3000			;Base CPU hardware addr.
	SEI				;Disable interrrupts     
	LDAA    #$04			;Select MAT
	JSR     LEF12			;Port D config routine
;
	LDAA    #$01			;
	JSR     LEEFC			;A/D routine
	CLI				;Re-enable interrupts     
	LDAA    $34,X			;Channel 4, get A/D MAT
	COMA				;Ones component, invert value
	STAA    L0253			;Save it, A/D MAT
;
	LDX     L00F8			;Engine run time
	CPX     L4E3B			;Min engine run time before performing MAT diags.
	BLS     LDA32			;Bra if engine run time is <=
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform code 23 diags., low MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L02A7			;MPH
	LDAA    L0253			;A/D MAT
	LDX     #L5B01			;Error mask #2
	BRCLR   0,X,#$40,LD9FE		;Bra if b6==0, not setting err 23, low MAT
;
	BCLR    L0017,#$40		;Error word #2, clear b6, error 23 flag
;
	CMPA    L4E37			;MAT threshold to set error 23 
	BCC     LD9FE			;Bra if MAT is >=, MAT ok
;
;-MAT is below threshold to set error, check time 
;
	LDAA    L0240			;Error 23 counter
	CMPA    L4E38			;Time threshold to set error
	BHI     LDA03			;Bra if counter >, set error
;
;-Check MPH
;
	CMPB    L4E3D			;MPH boundry for error 23/25
	BHI     LD9FE			;Bra if MPH >, dont set code yet
;
;-Inc counter
;
	INC     L0240			;+1, error 23 counter
	BRA     LDA06			;Bra to continue
;
;-Here if not setting error 
;
LD9FE	CLR     L0240			;Clear error 23 counter
	BRA     LDA06			;Bra to continue
;
;-Here to set error
;
LDA03	BSET    L0017,#$40		;Set b6, error 23, low MAT
;	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform code 25 diags., high MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;						
LDA06	LDX     #L5B01			;Error mask #2
	BRCLR   0,X,#$10,LDA2A		;Bra if b4==0, not setting error 25, high MAT
;
	BCLR    L0017,#$10		;Clear b4, error 25, high MAT
;
	LDAA    L0253			;Load A/D MAT
	CMPA    L4E3F			;Upper temp threshold to set error
	BCS     LDA2A			;Bra if MAT <=, MAT ok
;
	LDAA    L0241			;Error 25
	CMPA    L4E40			;Time threshold to set error
	BHI     LDA2F			;Bra if counter >, set error
;
	CMPB    L4E3D			;MPH boundry for error 23/25
	BLS     LDA2A			;Bra if MPH are <=, dont set error
;
;-Inc counter
; 
	INC     L0241			;+1, error 25 counter
	BRA     LDA32			;Bra to continue
;
;-Here if not setting error
;
LDA2A	CLR     L0241			;Clear error 25 counter
	BRA     LDA32			;Bra to continue
;
;-Here to set error
;
LDA2F	BSET    L0017,#$10		;Set b4, error 25, high MAT
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform lookup to linearize MAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA32	LDAA    L0253			;A/D MAT
	LDX     #LFAEF			;MAT temp vs. A/D MAT
	JSR     LF15E			;2D lookup
;
	STAA    L0855			;Save it, MAT, linearized
;
;-Check if errors set
;
	BRCLR   L0017,#$50,LDA45	;Bra if b4 and b6==0, no errors set 
;
;-Errors set, load default MAT
;
	LDAA    L4E3E			;Default MAT if errors set
;
LDA45	STAA    L0252			;MAT temp
	RTS				;Return 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Engine error code/diagnostics handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA49	BSET    L006F,#$80		;Status word, pre-set b7, one second has elapsed
;									
	BRCLR   L0002,#$F0,LDA53	;Loop counter, bra if upper bits clear, one second
					;has elapsed
;
;-One second has not yet passed
;
	BCLR    L006F,#$80		;Clear b7, one second has not yet elasped 
;											
LDA53	BRSET   L0050,#$10,LDA60	;Status word, bra if b4==1, in ALDL diags.
;								
	BCLR    L0071,#$80		;Status word, clear b7, diags not in effect
	BCLR    L0043,#$1C		;Status word, clear b4, fueling state change 
					;flag, b3, SES fueling diags. in effect, and b2,
					;SES in use to relay fueling information   
	JMP     LDAB5			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~
; ALDL diags in effect
;~~~~~~~~~~~~~~~~~~~~~~
;
LDA60	BSET    L0071,#$80		;Status word, set b7, ALDL diags. in effect
;
	CLR     L024E			; 
	BRSET   L004F,#$80,LDA70	;Status word, bra if b7==1, engine is running
;
;-Engine not running 
;
	BCLR    L0043,#$1C		;Status word, clear b4, fueling state change 
					;flag, b3, SES fueling diags. in effect, and b2,
					;SES in use to relay fueling information 
	JMP     LDAC6			;Jump to continue
;
;-Engine is running here
;
LDA70	BRSET   L003E,#$80,LDA82	;Status word, bra if b7==1, in closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In open loop toggle SES light @ 1hZ
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA74	LDAA    L0043			;Load status word
	ANDA    #$F7			;Clear b4, change in fueling state
	EORA    #$40			;Toggle b6, used to toggleSES on/off 
	STAA    L0043			;Save it
	BITA    #$40			;Test b6
	BNE     LDAAA			;Bra if ==1 dont toggle SES this pass
;
	BRA     LDA9E			;Toggle SES
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In closed loop, toggle SES light when rich/lean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA82	BRSET   L0043,#$08,LDA93	;Status word bra if b3==1, ALDL fueling
					;diagnostics previously active
;
;-Diags not yet active
;
	BRCLR   L006F,#$80,LDA74	;Bra if b7==0, one second has not yet elapsed,
					;start toggling SES light in mean time
;
;-One second has passed, initiate diags.
;
	BSET    L0043,#$08		;Set b3, diags now in effect

LDA8D	BRSET   L003E,#$40,LDAA2	;Status word, bra if b6==1, going richer

	BRA     LDAA7			;Bra to continue
;
;-Here if diags previously active
;
LDA93	BRCLR   L006F,#$80,LDAAA	;Bra if b7==0, one second has not passed, dont 
					;update SES light
;
	BRCLR   L0043,#$10,LDA8D	;Status word, bra if b4==0, no change in fueling
					;state
;
;-fUeling state has changed, toggle SES
;
	BCLR    L0043,#$10		;Clear b4, fueling state change flag
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Entry point to toggle SES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA9E	BRSET   L0072,#$80,LDAA7	;Status word, set b7, turn on SES light
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Fueling is going richer
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAA2	BSET    L0072,#$80		;Status word, set b7, turn on SES
	BRA     LDAAA			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Fueling is going leaner
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAA7	BCLR    L0072,#$80		;Clear b7, turn off SES
;
;-Here if one second has not yet passed and initiating SES fueling diags, perform clears 
;
LDAAA	CLRA				;Pre-clear A    
	STAA    L003C			;Clear status word, SES in use for fueling diags
	STAA    L0239			;Clear current error number, SES in use for
					;fueling diags.
	BSET    L0043,#$04		;Status word, set b2, SES in use to relay
					;state of fueling
	BRA     LDAD4			;Bra to continue
;
;-Here if no ALDL diags, perform clears
;
LDAB5	CLRA				;Pre-clear A      
	STAA    L003C			;Clear status word, SES in use for fueling diags
	STAA    L0239			;Clear current error number, SES in use for
	BRCLR   L001A,#$20,LDAC2	;Error word #5, bra if b5==0, no PROM error
;
;-Error 51 in effect
;
	JMP     LDFA8			;Turn on SES and return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if engine is running
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAC2	BRSET   L004F,#$80,LDAD4	;Status word, bra if b7==1, engine running
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if engine off perform clears
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAC6	CLRA				;Preclear A    
	CLRB				;Preclear B    
	STAA    L024B			;Error 33 timer
	STAA    L023C			;Error 44 timer
	STD     L023D			;Error 45 timer
	JMP     LDEDA			;Continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Here if engine running
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAD4	BRSET   L0043,#$02,LDB00	;Status word, bra if b1==1, engine run time > 
					;10 secs 
;
	LDAB    L00F9			;LSB, engine run time
	CMPB    #10			;10 secs 
	BCS     LDB00			;Bra if run time is less
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine has been running for more than 10 secs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BSET    L0043,#$02		;Set b1, engine run time > 10 secs
	INC     L0014			;# of error free startups 
	DEC     L0015			; DIAGNOSTIC CKSUM
;
;-Check if enough error free startups have passed to clear error words
;
	LDAA    L0014			;# of error free startups
	CMPA    L5B12			;# of error free startups to clear error words
	BLS     LDB00			;Bra if <= threshold to clear errors
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Enough error free starts have passed to clear error codes
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	CLRA				;Preclear A    
	LDX     #$0009			;9 error words
;
LDAF2	STAA    $0A,X			;Clear error word
	DEX				;-1, move to next error word     
	BNE     LDAF2			;Bra if !=0, continue clearing error words
;
	STAA    L0014			;Clear # error free startups
	STAA    L003C
	JSR     LEFC3			; CK SUM KA RAM
;
	STAA    L0015			; DIAGNOSTIC CKSUM

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 13, O2 sensor diags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDB00	BCLR    L0016,#$80		;Error word #1, clear b7, err 13, O2 sensor
;
;-Check if TPS errors
;				
	LDAB    L006F			;Status word
	BITB    #$24			;Test b2, high TPS, and b5, low TPS errors
	BNE     LDB72			;Bra if error(s) set
;
;-Check if engine running long enough
;
	BRSET   L0071,#$40,LDB18	;Status word, bra if b6==1. run time threshold
					;met for O2 diags
;
	LDD     L00F8			;Engine run time
	LSRD				;/2
	CMPB    L4E28			;Run time for err 13, O2 sens. diags.
	BCS     LDB72			;Bra if run time is <, no diags.
;
	BSET    L0071,#$40		;Set b6, run time threshold for O2 diags. met
;
;-Check if DFCO in effect
;
LDB18	LDAA    L0158			;Time DFCO active, O2 diags
	BRCLR   L0046,#$08,LDB29	;Status word, bra if b3==0, not in DFCO  
;
	CMPA    L4E29 			;Upper limit for DFCO active timer											; --- TIME ACCUM
	BCC     LDB72			;Bra if timer >=, no O2 diags
;
	INC     L0158			;Inc timer
	BRA     LDB72			;Bra to continue
;
LDB29	TSTA				;Test timer    
	BEQ     LDB2D			;Bra if DFCO active timer ==0
;
	DECA				;-1, decay timer
; 		   
LDB2D	STAA    L0158			;Save timer
	CMPA    L4E2A			;Max time in DFCO for O2 diags.
	BCC     LDB72			;Bra if >=, no O2 diags.
;
;-Check if O2 volts dwelling around .450 volts
;
	LDAB    L01F8			;A/D O2 volts
	CMPB    L4E2C			;Upper window bound for O2 error
	BHI     LDB72			;Bra if O2 volts >, O2 functional 
;
	CMPB    L4E2B			;Lower window bound for O2 error 
	BLS     LDB72			;Bra if O2 volts <=, O2 functional
;
;-Check time threshold
;
	LDAB    L023F			;Error 13 timer
	CMPB    L4E2E			;Time threshold to set O2 error
	BHI     LDB77			;Bra if >, set O2 error
;
;-Check quals for incrementing O2 timer
;
	LDAA    L0002			;Loop counter
	ANDA    #$F0			;Clear lower bits
	BNE     LDB7A			;Bra if !=0, one second has not yet passed
;
	BRSET   L00F9,#$01,LDB7A	;LSB, engine run time, bra if b0==1, dont increment
					;timer this pass
;
;-Two seconds have elapsed since last pass
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L4E2F			;Cool temp threshold for O2 diags.
	BLS     LDB7A			;Bra if cool temp <=, no diags.
;
;-Check TPS quals for incrementing timer
;
	LDAA    L01FC			;TPS
	CMPA    L4E2D			;Lower TPS limit to inc. error 13 timer
	BHI     LDB6D			;Bra if TPS >
;
;-Decay out O2 timer if low TPS/idling
;
	TST     L023F			;Test error 13 timer
	BEQ     LDB7A			;Bra if ==0
;
	DEC     L023F			;Dec error 13 timer
	BRA     LDB7A			;Bra to continue
;
;-Increment error 13 timer
;
LDB6D	INC     L023F			;+1, error 13 timer
	BRA     LDB7A			;Bra to continue
;
;-Here to clear error 13 timer
;
LDB72	CLR     L023F			;Clear timer
	BRA     LDB7A			;Bra to continue
;
;-Here to set error 13, O2 sensor failure
;
LDB77	BSET    L0016,#$80		;Error word #1, set b7, error 13, O2 sensor
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for setting error 16, VSS buffer
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDB7A	BCLR    L0016,#$10		;Clear b4, error 16, VSS buffer
;
;-Check if MAP errors
;
	LDAA    L006F			;Status word 
	BITA    #$48			;Test b6=High MAP err, b3=Low MAP err
	BNE     LDBAE			;Bra if MAP error set
;
;-Check MPH to see if diags. required
;
	LDAA    L02A7			;MPH
	CMPA    L4E30			;MPH limit for VSS diags
	BHI     LDBAE			;Bra if MPH >
;
;-Check timer threshold to set error
;
	LDAA    L0817			;Error 16 timer
	CMPA    L4E35			;Error timer thresold to set error
	BHI     LDBC4			;Bra if >, set error
;
;-Check MAP threshold for diags.
;
	LDAA    L01E9			;A/D MAP
	CMPA    L4E33			;Upper MAP threshold for VSS buffer diags.
	BCC     LDBAE			;Bra if MAP is >, engine under load
;
;-Check cool temp threshold for diags.
;
	LDAA    L0006			;Cool temp, linearized
	CMPA    L4E34			;Lower cool temp threshold for VSS buffer diags
	BLS     LDBAE			;Bra if cool temp <=, no diags
;
;-Check RPM limits for diags.
;
	LDAA    L0062			;RPM/25
	CMPA    L4E31			;Lower RPM limit for VSS buffer diags.
	BLS     LDBAE			;Bra if RPMs <=, no diags.
;
	CMPA    L4E32			;Upper RPM limit for VSS buffer diags.
	BLS     LDBB3			;Bra if RPMs <=, inc. timer
;
;-Quals not met for setting error
;
LDBAE	CLR     L0817			;Clear error 16 timer
	BRA     LDBC7			;Bra to continue
;
;-Check TPS quals for inc. error 16 timer
;
LDBB3	LDAA    L01FC			;TPS
	CMPA    L4E36			;Upper TPS limit to increment err. timer
	BCC     LDBAE			;Bra if TPS >=
;
;-Vehicle coasting, increment error 16 timer
;
	LDAA    L006F			;Status word
	BPL     LDBC7			;Bra if b7==0, one second has not yet passed
;
	INC     L0817			;Inc. error 16 timer
	BRA     LDBC7			;Bra to continue
;
;-Here to set error 16, 2002 PPM VSS buffer signal lost
;
LDBC4	BSET    L0016,#$10		;Error word #1, set b4, error 16, VSS buffer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 24, VSS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDBC7	LDAA    L400F			;Opt byte
	BITA    #$80			;Test b7, transmission option
	BEQ     LDBFA			;Bra if ==0, TCC/auto in use
;
;-Manual transmission in use, perform diags.
;
	LDAA    L5B01			;Error mask #2
	BITA    #$20			;Test b5, flag for error 24, VSS
	BEQ     LDBFA			;Bra if ==0, not flagging error 24
;
	LDD     L0849			;Stored TOS pulses
	BEQ     LDBE2			;Bra if ==0, no pulses recieved
;
;-Pulses recieved
;
	BCLR    L0017,#$20		;Clear b5, err 24, VSS
	CLR     L081C			;Clear error 24 timer
	BRA     LDBFA			;Bra to continue
;
;-Check timer quals for setting error
;
LDBE2	LDAA    L081C			;Error 24 timer
	CMPA    L4E39			;Time threshold to set error 24, VSS 
	BLS     LDBEF			;Bra if <=, dont set error yet
;
;-Here to set error 24, VSS
;
	BSET    L0017,#$20		;Error word #2, set error 24, VSS
	BRA     LDBFA			;Bra to continue
;
;-Check MPH threshold to increment timer
;
LDBEF	LDAA    L02A7			;MPH
	CMPA    L4E3A			;Max speed to set error 24
	BLS     LDBFA			;Bra if MPH <=
;
	INC     L081C			;Inc. error 24 timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 31, Governor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDBFA	BCLR    L0018,#$80		;Error word #3, clear b7, err 31, governor
;
	LDX     #L400F			;Opt. byte
	BRCLR   0,X,#$01,LDC16		;Bra if b0==0, rev limiter not enabled
;
	BRSET   L006F,#$10,LDC10	;Status word, bra if b4==1, error 31 previously set
;
	LDAA    L02AB			;Governor actuator integral term
	CMPA    L4E41			;Threshold to set error
	BCS     LDC16			;Bra if integrator <
;
;-Here to set error
;
LDC10 	BSET    L0018,#$80		;Error word #3, ser b7, error 31, gov'r
	BSET    L006F,#$10		;Set b4, error 31 previously set
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform EGR diags and check quals for error 32, EGR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDC16	LDX     #L5B02			;Error word mask #3
	BRCLR   0,X,#$40,LDC24		;Bra if b6==0, not setting error 32
;
;-Error 32 enabled, pre-clear error word and perform diags
;
	BCLR    L0018,#$40		;Preclear b6, error 32, EGR flag
	BRCLR   L0070,#$08,LDC27 	;Status word, bra if b3==0, perform EGR diags.
;
;-Here if not setting error 32, EGR or single cycle EGR diags. optioned
;
LDC24	JMP     LDD14			;Skip EGR diags
;
;-Perform EGR diags.
;
LDC27	LDX     #L400D			;Opt. byte
	BRCLR   0,X,#$02,LDC35		;Bra if b1==0, standard EGR in use
;
;-Linear EGR in use
;
	BRCLR   L0070,#$01,LDC35	;Status word, bra if b0==0, EGR hasnt previously
					;failed diags.
;
	JMP     LDD0D			;Bra to continue, linear EGR failed diags. 
					;previously
;
;-Check quals for egr diags.
;
LDC35	BRSET   L003E,#$80,LDC3C	;Status word, bra if b7==1, in closed loop
;
LDC39	JMP     LDCFD			;Bra to suspend EGR diags.
;
;-Check if DFCO in effect
;
LDC3C	BRSET   L0046,#$08,LDC39	;Status word, bra if b3==1, DFCO in effect

	LDAA    L0242			;EGR diag. cycling timer
	BEQ     LDC52			;Bra if ==0, perform diags.
;
;-Cycle timer has not yet run down, skip diags.
;
	BRSET   L006F,#$80,LDC4B	;Status word, bra if b7==1, one second has passed
;
	BRA     LDC4F			;Bra to continue
;
LDC4B	DECA				;Dec EGR diags. cycling timer
	STAA    L0242			;Save it
;
LDC4F	JMP     LDD03			;Skip diags.				
;
;-Check desired EGR position
;
LDC52	LDAA    L01D1			;Load desired EGR position
	CMPA    L4E47			;Threshold to perform EGR diags.
	BCS     LDC8E			;Bra if desired EGR is <, no diags.
;
;-Check vac window for diags.
;
	LDAA    L01EC			;vacuum
	CMPA    L4E43			;Lower vac threshold to perform diags.
	BLS     LDC8E			;Bra if <=, vac too low for diags 
;
	CMPA    L4E44			;Upper vac threshold to perform diags
	BHI     LDC8E			;Bra if >, vac too high for diags 
;
;-Check TPS window for diags.
;
	LDAA    L01FC			;TPS 
	CMPA    L4E45			;Lower TPS threshold to perform diags.
	BLS     LDC8E			;Bra if TPS <=, no diags.
;
	CMPA    L4E46			;Ipper TPS threshold to perform diags.
	BHI     LDC8E			;Bra if TPS >, no diags.
;
;-Check to ensure TPS is stable
;
	SUBA    L0201			;Subtract slow filtered TPS
	BCC     LDC7A			;Bra if no underflow
;
	NEGA				;Get abs. value
;
LDC7A	CMPA    L4E4A			;Upper change in TPS allowed for EGR diags.
	BHI     LDC8E			;Bra if >, changes in TPS are too large for diags.
;
;-Check for sufficient MPH
;
	LDAA    L02A7			;MPH
	CMPA    L4E4D			;Min speed for EGR diags.
	BCS     LDD03			;Bra if speed <, no diags.
;
;-Check if INT reset or BLM cell change
;
	BRCLR   L006E,#$01,LDC90	;Status word, bra if b0==0, no INT reset or BLM cell
					;change
;
;-INT reset/BLM cell change in effect
;
	BCLR    L006E,#$01		;Clear b0
LDC8E	BRA     LDD03			;Bra, no EGR diags.
;
; 
;
LDC90	LDAA    L0232			;INTegrator
	BRSET   L0070,#$04,LDCBB	;Status word, bra if b2==1, EGR diagnostics underway
;											
	SUBA    #128			;Subtract neutral INT 
	BCC     LDC9C			;Bra if INT <= 128
;
	NEGA				;Get abs. value
;
;-Check if changes in fueling are too great
;
LDC9C	CMPA    L48ED			;Max INT deviation from 128 to perform diags.
	BHI     LDD03			;Bra if deviation is >, no diags.
;
;-Steady fueling, check time to perform diags.
;
	LDAA    L0243			;Delay timer for EGR diags.
	CMPA    L4E48			;Min time to perform diags.
	BHI     LDCAC			;Bra if time >, perform EGR diags.
;
;-Not time to perform EGR diags. yet
;
	INCA				;+1
	BRA     LDCB6			;Bra to save and continue
;
;-Here to initialize EGR diags.
;
LDCAC	BSET    L0070,#$04		;Set b2, EGR diags. underway, temperarily disable
					;EGR
;								
	LDAA    L0232			;INT
	STAA    L0245			;Stored INTegrator reference for EGR diag.
	CLRA				;Clear A
;
LDCB6	STAA    L0243			;Save it, delay timer for EGR diags.
	BRA     LDD0D			;Bra to continue
;
;-Check INT to see if EGR is functional
;
LDCBB	SUBA    L0245			;Subtract reference INT
	BCS     LDCC5			;Bra if current INT was <, EGR not functional
;
	CMPA    L4E4C			;Min delta INT for EGR to be functional		
	BCC     LDCE5			;Bra if delta INT >=, EGR ok
;
;-EGR not yet functional, check duration for error to be set
;
LDCC5	LDAA	L0244			;Load EGR integrator diags. timer
	CMPA    L4E4B			;Max time before EGR fails diags.
	BCC     LDCD3			;Bra if timer >=, EGR failed diags.
; 
	INCA				;Inc. timer
	STAA    L0244			;Save it int EGR diags. timer
	BRA     LDD0D			;Bra to 
;
;-EGR not functional, set error
;
LDCD3	LDAA    L0246			;EGR fail timer
	INCA				;Inc. timer
	CMPA    L4E49			;Time threshold to set error
	BCS     LDCE0			;Bra if time <, dont set error yet
;
	BSET    L0070,#$01		;Status word, set b0, EGR failed diags.											;
	DECA				;Dec. timer to hold at current position
;
LDCE0	STAA    L0246			;Save timer
	BRA     LDCFD			;Bra to continue
;
;-Here if EGR passed diags
;
LDCE5	LDAA    L0246			;EGR fail timer
	BEQ     LDCEB			;Bra if ==0
;
	DECA				;Dec. counter toward 0
;
LDCEB	BNE     LDCE0			;Bra if !=0, dont reset EGR failed diags. flag yet
;
;-EGR passed diags. and sufficient time has passed to reset
;
	BCLR    L0070,#$01		;Clear b0, EGR failed diags. flag
	STAA    L0246			;Save EGR fail timer
;
;-Check if single EGR diag. cycle optioned
;							
	LDX     #L400D			;Opt. byte
	BRCLR   0,X,#$80,LDCFD		;Bra if b7==0, multiple cycles optioned 
;
	BSET    L0070,#$08		;Set b3, EGR diag. cycle performed
;	
LDCFD	LDAA    L4E42			;Time between EGR diag. cycles
	STAA    L0242			;Save it, EGR diag. cycle timer
;	
;-Clear timers for next pass
;									
LDD03	CLRA				;Preclear A
	STAA    L0243			;Clear delay timer for EGR diags.
	STAA    L0244			;Clear integral EGR diag. timer
	BCLR    L0070,#$04		;Status word, clear b2, EGR diags. underway flag
;
LDD0D	BRCLR   L0070,#$01,LDD14	;Bra if b0==0, EGR passed diags.
;
;-Here to set EGR error
;
	BSET    L0018,#$40		;Error word #3, set b6, error 32, EGR
;
;-Check if linear EGR in use
;									
LDD14	LDX     #L400D			;Opt byte 
	BRCLR   0,X,#$02,LDD8A		;Bra if b1==0, standard EGR in use 
;
;-Linear EGR in use, perform additional diags.
;								
	LDX     #L5B02			;Error word mask #3
	BRCLR   0,X,#$40,LDD8A		;Bra if b6==0, not setting error 32
;
	BRSET   L0070,#$01,LDD7E	;Bra if b0==1, EGR previously failed diags.
;
;-Check lower bound for A/D pintle position
;
	LDAA    L01D7			;A/D EGR pintle position
	CMPA    L4E4F			;Min allowed pintle position
	BCC     LDD41			;Bra if pintle position >=
;
;-A/D pintle position less then that allowed
;
	LDAA    L024A			;Linear EGR position low error timer
	CMPA    L4E55			;Time threshold to fail diags.
	BCS     LDD3B			;Bra if timer <, dont flag diag. failure yet
;
	BSET    L0072,#$20		;Status word, set b5, linear EGR failed diags.					
	BRA     LDD7B			;Bra to continue	
;										
LDD3B	INCA				;Inc. timer
	STAA    L024A			;Save it, linear EGR position low error timer
	BRA     LDD44			;Bra to continue							
;											
LDD41	CLR     L024A			;Clear pintle position low timer
;
;-Check if time for linear EGR diags. cycle
;
LDD44	BRCLR   L0070,#$08,LDD59	;Status word, bra if b3==0, diag. cycle not yet
					;completed 
;
	LDX     L0248			;Linear EGR diag. cycle timer
	CPX     L4E4F			;Time between diag. cycles
	BCC     LDD56			;Bra if timer >=, perform diags.
;
	INX				;Inc timer
	STX     L0248			;Store it
	BRA     LDD8A			;Bra to skip diags.
;
;-Check pintle position error
;
LDD56	BCLR    L0072,#$20		;Status word, clear b5, linear EGR diag. failure 
					;flag 
;
LDD59	LDAA    L01D1			;Load desired EGR position
	CMPA    L4E52			;Upper  position limit to check pintle position 
					;error 
	BHI     LDD86			;Bra if desired position is >, skip diag.
;
	LDAA    L01DD			;EGR position error
	CMPA    L4E50			;Upper position error limit
	BLS     LDD86			;Bra if position error is <=
;
;-Excessive EGR pintle position error
;
	LDAB    L0247			;Pintle position error diag. failure timer
	CMPB    L4E51			;Time threshold to set error
	BCC     LDD74			;Bra if timer is >=, EGR failed diags.
;
	INCB				;Inc position error timer
	BRA     LDD87			;Bra to continue
;
;-Here if EGR failed diags.
;
LDD74	BSET    L0072,#$20		;Status word, set b5, linear EGR failed diags.										;
	BRCLR   L0070,#$08,LDD83	;Bra if b3==0, flag diag. cycle complete
					;before setting error
;
LDD7B	BSET    L0070,#$01		;Status word, set b0, EGR failed diags.
;
;-Here to set error 32, EGR
;
LDD7E	BSET    L0018,#$40		;Error word #3, set b6, error 32, EGR
	BRA     LDD8A			;Bra to continue
;
LDD83	BSET    L0070,#$08		;Set b3, EGR diag. cycle completed
;
LDD86	CLRB				;
;
LDD87	STAB    L0247			;Clear pintle position diag. timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 33, MAP sensor high
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDD8A	BCLR    L0018,#$20		;Error word #3, preclear b5, error 33, MAP
					;sensor high
;
	LDAB    L006F			;Status word
	ANDB    #$BF			;Mask all but b6, MAP high error
	BITB    #$24			;Test b2, high TPS, and b5, low TPS errors
	BNE     LDDC1			;Bra if errors set 
;
;-Check baro kPa for diags.
;											
	LDAA    L4E57			;Lower baro limit for MAP high diags.
	CMPA    L0317			;Filtered baro
	BLS     LDDA0			;Bra if baro kPa <=, use lower limit
;
	LDAA    L0317			;Load baro
;
LDDA0	CMPA    L082E			;Compare to A/D MAP
	BCC     LDDC1			;Bra if A/D MAP is <=, MAP functional
;
	LDAA    L024B			;Error 33 timer
	CMPA    L4E58			;Time threshold to set error
	BHI     LDDC6			;Bra if timer >, set error
;
;-Check TPS thresholds to set error
;
	LDAA    L01FC			;Load TPS
	SUBA    L4E56			;Lower TPS threshold to set error 33
	BCC     LDDC1			;Bra if TPS >=, dont set error yet
;
;-Check RPM thresholds to set error
;
	LDAA    L0061			;Scaled RPM
	CMPA    L4E59			;Scaled RPM threshold to set error 33
	BCS     LDDC1			;Bra if RPMs <, dont set error yet
;
	INC     L024B			;Inc error 33 timer
	BRA     LDDCB			;Bra to continue
;
;-Here if not setting error yet
;
LDDC1	CLR     L024B			;Clear error 33 timer
	BRA     LDDCB			;Bra to continue
;
;-Here to set error 33
;
LDDC6	BSET    L0018,#$20		;Error word #3, set b5, error 33, MAP sens. high
	ORAB    #$40			;Set b6, MAP high
;
LDDCB	STAB    L006F			;Save status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 42, EST
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
	BRSET   L0044,#$04,LDE01	;Status word, bra if b2==1, skip EST test
;
	BRSET   L0050,#$08,LDE01	;Status word, bra if b3==1, in ALDL diags.,
					;skip error 42 diags.
;
	BRSET   L0002,#$10,LDE01	;Loop counter, bra if b4==1, no diags. this
					;pass (5 Hz alt. passes)
;
	BRCLR   L004F,#$40,LDE01	;Status word, bra if b6==0, EST has not yet passed
					;bypass diags.
;
	CLRB				;Preclear B    
	LDX     L3FCA			;Load EST circuit info
	LDAA    L0061			;Scaled RPMs
	CMPA    L4E66			;Lower RPM limit for EST diags.
	BLS     LDDFB			;Bra if RPMs <=, no diags.
;
	CPX     L0228			;Compare to stored EST info
	BNE     LDDFB			;Bra if !=
;
;-EST fault detected
;
	LDAB    L024F			;Error 42 timer
	CMPB    L4E69			;Time threshold to set error 42
	BHI     LDDF8			;Bra if time >, set error
;
	INCB				;Inc counter    
	BRA     LDDFB			;Bra to continue
;
;-Here to set error 42, EST
;
LDDF8	BSET    L0004,#$80		;Status word, set b7, EST failure
;
LDDFB	STAB    L024F			;Save error 42 timer
	STX     L0228			;Save EST info
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 44, O2 lean
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDE01	BCLR    L0019,#$08		;Error word #4, clear b3, error 44, O2 lean
;
	LDAA    L4E6E			;Lower O2 volt threshold to set error
	CMPA    L01F3			;Compare to filtered O2
	BLS     LDE39			;Bra if O2 >=, O2 functional
;
	LDAA    L023C			;Error 44 timer
	BRCLR   L0072,#$40,LDE1E	;Status word, BR IF NOT b6, ERROR 44, o2 LEAN
;
	CMPA    L4E70			;Timer threshold to set error
	BHI     LDE41			;Bra if timer >, set error 44
;
	BRSET   L00F9,#$01,LDE44	;LSB engine run time, bra if b0==1, alternate
					;passes each second
;
	BRA     LDE30			;Bra to skip remainder of diags.
;
LDE1E	CMPA    L4E6F			;Timer threshold to set error 44
	BLS     LDE28			;Bra if timer <=, dont set error yet
;
;-Enough time has passed to flag O2 error
;
	BSET    L0072,#$40		;Set b6, O2 lean
	BRA     LDE3C			;Bra to cintune
;
;-Check if error 44 allowed to be set
;
LDE28	BRCLR   L003E,#$80,LDE39	;Status word, bra if b7==0, not in closed loop
;
	BRSET   L0071,#$04,LDE39	;Status word, bra if b2==1, INT just reset
;
LDE30	BRCLR   L006F,#$80,LDE44	;Status word, bra if b7==1, one second has
					;not yet passed
;
;-.5 Hz execution rate
;
	INC     L023C			;Inc. error 44 timer
	BRA     LDE44			;Bra to continue
;
;-Here if not flagging error
;
LDE39	BCLR    L0072,#$40		;Clear b6, O2 lean
;
;-Here to reset for next pass
;
LDE3C	CLR     L023C			;Clear error 44 timer
	BRA     LDE44			;Bra to continue
;
;-Here to set error 44
;
LDE41	BSET    L0019,#$08		;Error word #4, set b3, error 44, O2 lean
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 45, O2 rich
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDE44	LDX     #L400E			;Opt. byte
	BRSET   0,X,#$20,LDE4E		;Bra if b5==1, error 45 to remain set if O2					
					;has previously failed diags. 
;
	BCLR    L0019,#$04		;Error word #4, preclear b2, error 45, O2 rich

LDE4E	LDAA    L01F3			;Filtered O2 volts
	CMPA    L4E73			;Threshold to set error
	BLS     LDE96			;Bra if O2 volts <=, O2 functional
;
	LDX     L023D			;Error 45 timer
;
;-Check if high MAT temps present
;
	BRSET   L0044,#$20,LDE6F	;Status word, bra if b5==1, high MAT temps present

	LDAA    L0252			;MAT
	CMPA    L4E72			;Compare to threshold to use alternate time
					;qual to set error 45
	BHI     LDE6C			;Bra if MAT >, high MAT temps present
;
;-Normal MAT temps present
;
	CPX     L4E74			;Check timer threshold to set error 45
	BHI     LDE9E			;Bra if timer threshold >, set error
;
	BRA     LDE74			;Bra to continue
;
;-Here if high MAT temops present
;
LDE6C	BSET    L0044,#$20		;Set b5, high MAT temps present (error 45 logic)
;
LDE6F	CPX     L4E76			;Alternate timer threshold to set error 45 if 
	BHI     LDE9E			;Bra if timer >, set error 45
;
;-Check if error 45 allowed to be set
;
LDE74	BRCLR   L003E,#$80,LDE96	;Status word, bra if b7==0, not in closed loop

	BRSET   L0071,#$04,LDE96	;Status word, bra if b2==1, INT just reset
;
;-Check TPS quals to set error
;
	LDAA    L01FC			;TPS
	CMPA    L4E78			;Lower % TPS bound to set error 45
	BHI     LDE89			;Bra if TPS >, setting error 45
;
	CMPA    L4E79			;Upper % TPS bound to set error 45
	BCC     LDE96			;Bra if TPS >=, dont set error
;
;-Here to procede with setting error 45
;
LDE89	BRCLR   L006F,#$80,LDEA1	;Status word, bra if b7==0, one second has not
					;yet passed
;
	LDX     L023D			;Error 45 timer
	INX				;Inc timer 	    
	STX     L023D			;Save it
	BRA     LDEA1			Bra to continue
;
;-Here if not setting error
;
LDE96	LDX     #$0000			;
	STX     L023D			;Clear error 45 timer
	BRA     LDEA1			;Bra to continue
;
;-Here if setting error
;
LDE9E	BSET    L0019,#$04		;Error word #4, set b2, error 45, O2 rich
;
LDEA1	BCLR    L0071,#$04		;Status word, clear b2, high MAT temp flag
;
;-Check BLM limits if optioned as part of O2 diags
;
	LDAB    L400C			;Opt. byte
	BITB    #$02			;Test b1, check BLM limits as part of error 44/45
					;diags.
	BEQ     LDEB6			;Bra if ==0, dont check BLM limits
;
;-Check limits for BLMs if O2 errors have not been set
;
	BRSET   L0019,#$04,LDEB3	;Bra if b2==1, error 45, O2 rich
;	
	BRCLR   L0072,#$40,LDEB6	;Status word, bra if b6==0, O2 lean flag
;
;-Check limits on BLM cells
;
LDEB3	JSR     LEF2B			;BLM clamp routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for error 46, VATS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDEB6	LDAA    L5B03			;Error mask #4
	BITA    #$02			;Test b1, error 46, VATS
	BEQ     LDEDA			;Bra if ==0, not flagging error
;
	LDAA    L00A1			;A/D batt volts
	CMPA    #90			;9.0 volts
	BCS     LDEDA			;Bra if batt. volts < 9 volts, dont set VATS error
;
;-Check if VATS passed
;
	BRSET   L003D,#$02,LDEDA	;Status word, bra if b1==1, VATS passed
;
	LDAA    L0856			;Error 46 timer
	CMPA    			;Time threshold to set error 46, VATS
	BHI     LDED7			;Bra if timer >, set error
;
	INCA				;Inc error timer
	BEQ     LDEDA			;Bra if roll over
;
	STAA    L0856			;Save timer
	BRA     LDEDA			;Bra to continue
;
;-Here if setting error 46, VATS
;
LDED7	BSET    L0019,#$02		;Error word #4, set b1 error 46, VATS
;
LDEDA	BRCLR   L0043,#$04,LDEE1	;Status word, bra if b2==0, SES not in use to relay
					;state of fueling
;
;-SES currently being used to relay status of fueling
;
	JMP     LDFAB			;Bra to return
;
;-SES not in use here
;
LDEE1	BRCLR   L0071,#$80,LDEEB	;Status word, bra if b7==0, not in ALDL diag.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; In ALDL diags., blink out error codes and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	JSR     LDFAC			;Routine to blink out error codes through SES 
;
	JMP     LDF9F			;Jump to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; No ALDL diags., check transmission errors
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    
LDEEB	BRCLR   L0044,#$10,LDEF2	;Status word, bra if b4==0, ignition is still on
;
;-Ignition off
;
	JMP     LDFAB			;Return
;
;-Ignition on, check if any stored errors
;
LDEF2	LDY     #L5B08			;Load diagnostics masks
	CLRA				;Preclear A    
	LDX     #L0009			;Load start addr. for error words
;
LDEFA	ORAA    $55,X			;OR with stored error words
	DEX				;-1, move onto next error word     
	BNE     LDEFA			;Bra if !=0, continue checking
;
	TSTA				;Test result   
	BNE     LDF20			;Bra if !=0, errors have been set previously
;
;-No errors where stored, update stored error words
;
	LDX     #L0009			;Start addr. for error words
;
LDF05	LDAA    0,Y			;Load error mask in
	ANDA    $15,X			;And mask in with error word, clear errors that 
					;are not flagged in mask
	STAA    $55,X			;Save it, stored error words
	DEY				;-1, move onto next mask     
	DEX				;-1, move onto next error word     
	BNE     LDF05			;Bra if !=0, not done updating 
;
	LDAA    L024E			;
	BEQ     LDF1B			;Bra if ==0, turn off SES light
;
	DEC     L024E			;Dec 
	BRA     LDF87			;Bra to continue
;
LDF1B	BCLR    L0071,#$01		;Turn off SES, no codes have been set
	BRA     LDF87			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~
; Stored errors present
;~~~~~~~~~~~~~~~~~~~~~~~
;
LDF20	LDX     #L0009			;Start addr. for error words
	CLRA				;Preclear A
;    
;-Check if transmission errors have been set
;
LDF24	LDAB    $15,X			;Load error word
	ANDB    $55,X			;Mask out previously set errors
	ANDB    0,Y			;Error mask, mask out only errors that will
					;be flagged
	STAB    $55,X			;Save updated error word
	ORAA    $55,X			;OR with stored error words
	DEY				;-1, move onto next error mask     
	DEX				;-1, move onto next error word     
	BNE     LDF24			;Bra if !=0, continue
;
	INC     L024E			;Inc 
	LDX     #L4E24			;
	BRCLR   L0071,#$01,LDF40	;Status word, bra if b0==0, SES not commanded to be 
					;on
;
;-SES commanded to be on
;
	INX				;    
	INX				;
;
;-
;   
LDF40	TSTA				;Test if any errors where set    
	BEQ     LDF44			;Bra if ==0, no errors set
;
	INX				;
;     
LDF44	LDAB    0,X			;
	CMPB    L024E			;
	BCC     LDF87			;
;
	STAB    L024E			;Save it, 
	TSTA				;    
	BEQ     LDF87			;Bra if no errors where set
;
	LDAA    L4E26			; ERR LOG CNST 3, 10 SEC'S
	STAA    L024E			;
;
	CLRB				;Preclear B   
	LDX     #L0009			;Addr. for error words/params
;
;
;
LDF5B	LDAA    $0A,X			;Offset for last error word
	ORAA    $55,X			;OR with stored errors
	STAA    $0A,X			;Save it, error word
	STAB    $55,X			;Clear out stored error words from previous pass
	DEY				;-1 [doesnt appear to be used in this loop]      
	DEX				;-1, move onto the next error word     
	BNE     LDF5B			;Bra if !=0, continue
;
;
;
	STAB    L0014			;Clear # of error free starts, errors have been set
	JSR     LEFC3			;RAM checksum routine, check error words
;
	STAA    L0015			;Save it, error word checksum
;
;-Check if transmission errors have been set
;
	LDX     #L0009			;Start addr for error words/params			
	LDY     #L5B00-4		;Start for transmission diag. masks
;
LDF76	LDAB    $15,X			;
	BITB    $15,Y			;
	BNE     LDF84			;
;
	DEY				;				     
	DEX				;     
	BNE     LDF76			;
;
	BRA     LDF87			;
;
LDF84	BSET    L0071,#$01		;Turn on SES light
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no transmission errors where set/stored
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDF87	BRSET   L004F,#$80,LDF98	;Status word, bra if b7==1, engine is running
;
;-Turn on SES if engine off
;
	BRSET   L004F,#$02,LDFA8	;Status word, bra if b1==1, illuminate SES
;
	BRSET   L0004,#$08,LDF98	;Status word, bra if b3==1, bad shutdown
;
	BSET    L004F,#$02		;Set b1, illuminate SES light
	BRA     LDF9B			;Bra to continue		
;
;-Turn off SES light if running/bad shutdown
;
LDF98	BCLR    L004F,#$02		;Status word, clear b1, turn off SES if no malf.
;										
LDF9B	BRSET   L0050,#$08,LDFA8	;Status word, bra if b3==1, in ALDL diags.
;
;-Here if in ALDL diags., turn on SES if commanded to do so
;
LDF9F	BRSET   L0071,#$01,LDFA8	;Status word, bra if b0==1, SES light to be on
;					
	BCLR    L0072,#$80		;Status word, clear b7, turn SES off										;
	BRA     LDFAB			;Bra to return
;
LDFA8	BSET    L0072,#$80		;Set b7, turn SES light on
;
LDFAB	RTS				;Return	    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to blink out error codes through SES 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDFAC	BRCLR   L003C,#$40,LE018	;Status word, bra if b6==0, at begining of codes

	DEC     L023B			;SES blink timer
	BNE     LDFCF			;Bra if timer !=0, return
;
	LDAB    #$04			;.4 sec, time for SES to remain off
					;between blinks
	BRSET   L0071,#$01,LE033	;Status word, bra if SES currently on
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Blink out 10's/1's portion of error code
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L0237			;10's and 1's portions of error codes to blink out
	BRCLR   L003C,#$20,LDFC3	;Status word, bra if b5==0, blink out 10's portion
					;of code

	INX				;Move to 1's portion of error code 
;    			
LDFC3	DEC     0,X			;-1 blink
	BMI     LDFD1			;Bra if roll-over, blinkout complete
;
;-Activate SES light and blink out portion of code
;
	BSET    L0071,#$01		;Set b1, turn on SES light											;
	LDAB    #$04			;.4 sec, time for SES to remain on
	STAB    L023B			;SES blink timer
;
LDFCF	BRA     LE039			;Bra to return				
;
;-Upper portion of error code has been displayed through the SES
;											
LDFD1	BRSET   L003C,#$20,LDFDC	;Status word, bra if 1's portion completed
;
	BSET    L003C,#$20		;Set b5, move onto 1's portion of error code
;											
	LDAB    #$08			;.8 sec, time between 10's and 1's portion of 
					;error code
	BRA     LE033			;Bra to turn off SES and return				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to reset for next code
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDFDC	BCLR    L003C,#$20		;Status word, clear b5, display 1's portion flag										;
	BRCLR   L003C,#$03,LDFE8	;Status word, bra if b0==0, and b1==0, error code
					;not set this pass
;
	DEC     L003C			;Clear b0
	BRA     LE01B			;Bra to look up next code
;
;-Move onto next error code
;
LDFE8	LDAB    L0239			;Load current error # to blink through SES
	CMPB    #71			;71 codes
	BLS     LDFF7			;Bra if <=, still codes remaining to display
;
;-Here to loop to begining of error code list
;
	CLR     L0239			;Clear current error #
	BCLR    L003C,#$40		;Clear b6, at start of error code list 
	BRA     LE036			;Bra to return
;
;-Still have codes to display
;
LDFF7	BITB    #$07			;Test lower three bits of current error #
	BNE     LE010			;Bra if !=0, continue
;
;-Load in next diagnostics mask
;
	LSRB				;/2  
	LSRB				;/2    
	LSRB				;/2, now /8 for 8 bit masks    
	LDY     #L5B00			;Start of diag. masks
	LDX     #L000B			;Error word #1
	ABX				;Add current error # in as offset     
	ABY				;     
	LDAB    0,X			;Load diag. mask
	ANDB    0,Y			;Clear errors that arnt optioned to be set
	STAB    L023A			;Save set errors
;
LE010	INC     L0239			;Error # counter
	ASL     L023A			;Shift stored errors left
	BCC     LDFE8			;Bra if error not set
;
LE018	BSET    L003C,#$02		;Status word, set b1, error set this pass
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up numerical SES blink out
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE01B	LDAB    L0239			;Load error # counter
	LDX     #LFB00			;SES error blink out table
	ABX				;Add in offset
	LDAA    0,X			;Load upper/lower nibble for error 
					;code blink out
	TAB				;Move results to B
;
;-Get 1's number of blinks in B
;
	ANDB    #$0F			;Mask out lower nibble
;
;-Get 10's number of blinks in A
;
	LSRA				;Shift right
	LSRA				;    	
	LSRA				;    
	LSRA				;Now upper nibble     
	STD     L0237			;Save result, number of blinks for error code
	LDAB    #28			;2.8 second delay between display of each code										;
	BSET    L003C,#$40		;Status word, set b6, still have codes remaining
					;to be displayed
;
LE033	STAB    L023B			;SES blink timer
;										
LE036	BCLR    L0071,#$01		;Status word, clear b0, turn off SES light
;											
LE039	BRSET   L0071,#$01,LE042	;Bra if b0==1, turn on SES light
;
;-Here to turn off SES light
;
	BCLR    L0072,#$80		;Status word, clear b7, turn off SES										;
	BRA     LE045			;Bra to return
;
;-Here to turn on SES light
;
LE042	BSET    L0072,#$80		;Status word, set b7, turn on SES light

LE045	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine for handling closed loop entry and non time critical lookups
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE046	LDX     #L5B04			;Error word #5 mask
	BRCLR   0,X,#$04,LE088		;Bra if b2==0, dont flag fuel pump volts error
;
;-Flagging error 
;
	BCLR    L001A,#$04		;Error word #5, clear b2, err 54, fuel pump volts
	BRSET   L0072,#$01,LE085	;Bra if b1==1, low fuel pump volts flagged

	LDAB    L00A1			;Batt volts
	CMPB    L4E7E			;Lower volt. threshold to perform diags.
	BCS     LE088			;Bra if batt. volts less, skip diags.
;
;-Perform fuel pump diags.
;
	LDAA    L0055			;Load fuel pump volts
	BRCLR   L0072,#$02,LE06C	;Bra if diags. not in progress
;
	BRCLR   L004F,#$10,LE088	;Status word, bra if b4==0, engine not above 
					;theshold to be cranking/not running
;
;-Engine running
;
	CMPA    L4E7D			;Lower pump volts threshold to set error
	BCC     LE088			;Bra if volts are greater, dont set error
;
	BRA     LE085			;Bra to set error
;
;-Here to check quals for set error
;
LE06C	LDAB    L024D			;Error 54 timer
	INCB				;+1
	STAB    L024D			;Save it
	CMPB    L4E7B			;Timer threshold to set error
	BHI     LE082			;Bra if timer >, set error
;
	CMPA    L4E7C			;Fuel pump volts threshold for setting error
	BCS     LE088			;Bra if volts >
;
;-Low voltage present
;
	BSET    L0072,#$02		;Status word, set b1, fuel pump volts
					;diags. in progress
	BRA     LE088			;Bra to continue
;
;-Here to set error
;
LE082	BSET    L0072,#$01		;Status word, set b0, low fuel pump volts
;
LE085	BSET    L001A,#$04		;Error word #5, set b1, error 54, low FP volts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up inverse air density based on blended intake air temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE088	LDAA    L0006			;Cool temp, linear
	LDX     #L400B			;Opt. byte
	BRCLR   0,X,#$40,LE0AD		;Bra if b6==0, MAT not in use
;
	LDAA    L0255			;Gms/sec airflow
	LDX     #L4AD9			;MAT/CTS blend multiplier
	JSR     LF15E			;2D lookup
;											
	LDAB    L0006			;Cool temp, linear
	SUBB    L0252			;Sub MAT
	BCC     LE0A2			;Bra if >=0
;
;-MAT is greater, clear out val for lookup
;										   	
	CLRB				;Clear result
;
LE0A2	MUL				;(CTS - MAT) x multiplier
	ASLD				;x2, now /128
	BCS     LE0AB			;Bra if overflow
										   	
	ADDA    L0252			;Add in MAT
;
	BCC     LE0AD			;Bra if no overflow
;
LE0AB	LDAA    #$FF			;Clear overflow
;
LE0AD	LDX     #L4AEA			;Inv. air density vs. blended temp table
	JSR     LF15E			;2D lookup
;
	CLRB				;Clear LSB    
	LSRD				;/2, now x 128    
	ADDD    #29824			;.662 l/g
	STD     L0259			;Save it, inverse air density
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up injector offset vs. battery volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L00A1			;Batt. volts
	LDX     #L4AFB			;Inj. offset bias table verses batt. bolts 
	JSR     LF15E			;2D lookup
;										
	STAA    L0279			;Save it, injector bias vs. fuel pump volts
;
;-Alternate passes of second portion
;										
	BRCLR   L0002,#$10,LE0CB	;Loop counter, bra if b5==0, run loop
;											
	RTS				;Return if not time to run loop yet   
;
;~~~~~~~~~~~~~~~~~~~~~
; Second 5 Hz section
;~~~~~~~~~~~~~~~~~~~~~
;
;-Look up decel enlean factor
;
LE0CB	LDAA    L0006			;Cool temp, linarized
	LDX     #L4B0C			;Decel enlean factor vs. cool temp
	JSR     LF153			;Bra to do lookup
;
	STAA    L0265			;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up async accel enrich correction factor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Look up cool temp based portion
;
	LDAA    L0006			;Cool temp
	LDX     #L4B67			;Accel enrich coor. factor vs. cool temp
;
	JSR     LF15E			;Bra to do lookup
	TAB				;Get result into B  
;
;-Look up MAT based portion
;
	LDAA    L0252			;Load MAT
	LDX     #L4B78			;Accel enrich corr. factor vs. MAT
	JSR     LF15E			;2D lookup
;
	MUL				;Multiply factors together
	ASLD				;x2, now /128
	BCC     LE0EE			;Bra if no overflow
;
	LDAA    #255			;Clear overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up sync accel enrich correction factor
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE0EE	STAA    L025F			;Accel enrich corr. factor vs. cool temp
	LDAA    L0006			;Cool temp, linearized
	LDX     #L4B89			;AE correction fact. vs cool temp
	JSR     LF15E			;2D lookup
;
	STAA    L0260			;Save it, AE temp correction mult.
	BRSET   L004F,#$10,LE14F	;Status word, bra if b4==1, engine above threshold 
					;to be cranking
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine off or still cranking here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRSET   L0004,#$08,LE136	;Status word, bra if b3==1, bad shutdown
;
;~~~~~~~~~~~~~~~~~~~
; Look up choke AFR
;~~~~~~~~~~~~~~~~~~~
;
	LDAA    L0006			;Cool temp, linarized
	LDX     #L4C29			;Choke AFR vs. cool temp
	JSR     LF15E			;2D lookup
;
	STAA    L02EB			;Save it, choke AFR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up added startup spark advance
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4522			;Addr. of startup SA adder table vs. cool temp
	LDAA    L0006			;Cool temp, linear
	JSR     LF153			;2D lookup with line count
;
	STAA    L02EE         		;Save it, startup SA 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up startup SA decay rate
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L452C        		;Startup SA decay delay timer
	LDAA    L0006			;Cool temp
	JSR     LF153			;2D lookup w/ line count
;
	STAA    L02EF			;Startup SA decay delay timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up various initial AFR parameters
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4C93			;AFR crank transition ratio vs. cool temp
	LDAA    L0006			;Cool temo, linearized 
	JSR     LF15E			;2D lookup

	STAA    L02EC			;Save it, AFR crank transition ratio
;
	LDAB    L491F           	;Time after initial startup to decay out choke AFR
	STAB    L02ED			;Choke AFR decay delay timer
;
;-Load up choke AFR decay rate
;
LE136	LDX     L4CA4			;Choke AFR decay rate vs. cool temp
	LDAA    L0006			;Cool temp, linearized
	JSR     LF15E			;2D lookup
;
	STAA    L028A			;Save it, AFR crank transition ratio decay rate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Look up choke SA decay multiplier
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L4536			;Choke SA decay 
	LDAA    L0006			;Cool temp, linearized 
	JSR     LF153			;2D lookup w/ line count
;
	STAA    L0222			;Startup SA decay multiplier
;
	JMP     LE237			;Jump to return										
;
;~~~~~~~~~~~~~~~~~~~
; Engine is running 
;~~~~~~~~~~~~~~~~~~~
;
;-Update status bits for O2 handing at idle
;
LE14F	SEI				;Disable interrupts
	LDAB    L003F			;Status word
	ANDB    #$F0			;Clear lower four bits
	LDAA    L0066			;RPM/12.5, one delayed
	SUBA    L0063			;Subtract RPM/12.5
	BCC     LE15D			;Bra if RPMs rising
;
;-RPMs falling here
;
	ORAB    #$01			;Status word, set b1, RPMs falling 
	NEGA				;Get abs. value of result
;
LE15D	CMPA    L494A			;Delta RPM threshold for stable idle
	BCS     LE164			;Bra if delta RPMs <
;											
	ORAB    #$02			;Set b1, RPMs changing too rapildy for idle
;
LE164	LDAA    L0063			;RPM/12.5
	STAA    L0066			;Save it, RPM/12.5, one delayed
;
	LDAA    L0858			;Delta RPM from target idle speed
	CMPA    L4FB4			;12.5 RPM, upper RPM limit for steady state idle
	BLS     LE172			;Bra if delta RPMs less
;
;-Outside of desired idle range
;
	ORAB    #$08			;Set b3, outside target idle range
;
;-Check for high idle
;
LE172	BRCLR   L0036,#$80,LE178	;Status word, bra if b7==0, no high idle speed
;
	ORAB    #$04			;Set b2, high idle speed
;
LE178	STAB    L003F			;Save it
	CLI				;Re-enable interrupts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform choke functions
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    L02ED			;Time after initial startup to decay choke AFR
	BNE     LE1F4			;Bra if !=0, dont decay out yet
;
;-Enough time has passed to begin decaying out AFR
;
	LDAA    L02EB			;Load choke AFR
	BNE     LE188			;Bra if !=0
;
;-Choke AFR has been decayed out
;
	JMP     LE1FC			;Bra to continue
;
;-Choke AFR has not been decayed out yet
;
LE188	LDAA    L02A0			;Choke AFR park to drive transition timer
	BEQ     LE1A6			;Bra if ==0, continue
;
	CMPA    L494F			;Park to drive transition period 
					;transition
	BNE     LE19D			;Bra if !=, continue to count down
;
;-Park to drive transition time met, check temp thresholds
;
	LDAB    L0006			;Cool temp
	CMPB    L494D			;Upper cool temp limit for cold choke park to
					;drive transition
	BHI     LE19D			;Bra if cool temp was >
;
	BRSET   L0041,#$20,LE1FC	;Status word, bra if b5==1, in P/N
;
;-Here to decrement park to drive transition timer
;
LE19D	DECA				;-1
	STAA    L02A0			;Choke AFR park to drive transition timer
	BNE     LE1FC			;Bra if !=0, dont decay out choke yet
;
;-Park to drive transition complete
;
	BSET    L003E,#$08		;Status word, set b3, cold choke decay delay 
					;complete 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Time to decay out the choke
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check choke decay period
;											
LE1A6	LDAA    L0293			;Choke AFR decay period
	BNE     LE1F9			;Bra if !=0, dont decay out choke this pass
;
;-Time to decay out the choke, look up decay period
;
	LDX     #L4C3A			;Choke AFR decay period vs. cool temp 
	LDAA    L0006			;Cool temp, linearized
	JSR     LF15E			;2D lookup
;
	STAA    L0293			;Choke AFR decay period
;
;-Adjust decay period based on airflow
;
	LDX     #L4C4B			;Decay period multiplier vs. airflow
	LDAA    L0255			;Gms/sec airflow
	CMPA    #64			;64 g/sec, UL for lookup
	BLS     LE1C2			;Bra if airflow <=
;
	LDAA    #64			;64 g/sec, UL for lookup
;
LE1C2	JSR     LF15E			;2D lookup
;
	TAB				;Get multiplier into B
	LDAA    L0293			;Get decay period
	MUL				;Decay period x airflow modifier 
	ASLD				;x2, now /128
	BCC     LE1CF			;Bra if no overflow

	LDAA    #255			;Load UL
;
LE1CF	STAA    L0293			;Save it, choke AFR decay period
	LDAA    L02EB			;Load choke AFR
	LDAB    L491E			;Choke AFR decay multiplier
	MUL				;Choke AFR x decay multiplier
	BRSET   L003E,#$08,LE1EF	;Bra if b3==1, cold park to drive transition 
					;complete
;
;-Choke AFR park to drive transition is still in effect
;
	CMPA    L494E			;Lower limit for choke enrichment during 
					;transition
	BHI     LE1EF			;Bra if AFR is >, save
;
;-Low/no choke enrichment present, check temp limit to enable transition
;
	LDAB    L0006			;Cool temp, linearized
	CMPB    L494D			;Upper cool temp limit to enable park to 
					;drive choke AFR transition
	BHI     LE1EF			;Bra if cool temp >, no transition
;
	LDAB    L494F			;Park to drive transition period                			
	STAB    L02A0			;Save it
;
LE1EF	STAA    L02EB			;Save it, choke AFR
	BRA     LE1FC			;Bra to continue
;
;-Here to decr. choke AFR decay delay timer
;
LE1F4	DEC     L02ED			;Choke AFR decay delay timer
	BRA     LE1FC			;Br to continue
;
;-Here to decr. choke AFR decay period
;
LE1F9	DEC     L0293  			;Choke AFR decay period
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform added initial spark functions
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE1FC	LDAA    L02EF			;Added intial SA decay delay timer
	BEQ     LE20C			;Bra if ==0, decay out SA
;
	LDAA    L0002			;Loop counter
	ANDA    #$F0			;Mask out lower four bits
	BNE     LE237			;Bra if ==0, dont decrement timer yet
;
;-Here to decr. timer
;
	DEC     L02EF			;Initial SA decay delay timer
	BRA     LE237			;Bra to continue
;
;-Here to continue decaying out added SA
;
LE20C	LDAA    L02EE			;Initial added SA
	BEQ     LE237			;Bra if ==0
;
;-Decay out SA
;
	LDAA    L0223			;Initial added SA decay period
	BEQ     LE21B			;Bra if decay period ==0, decay out SA
;
	DEC     L0223			;SA decay period
	BRA     LE237			;Bra to continue
;
;-Look up SA decay period
;
LE21B	LDAA    L0255			;Gms/sec airflow
	CMPA    #64			;64 gms/sec, limit for lookup
	BLS     LE224			;Bra if airflow is less
;
	LDAA    #64			;use upper limit instead
;
LE224	LDX     #L44C6			;SA decay period vs. airflow
	JSR     LF15E			;2D lookup
;
	STAA    L0223			;Save it, SA decay period
;
	LDAA    L02EE			;Added initial SA
	LDAB    L0222			;Added initial SA decay multiplier
	MUL				;SA x multiplier
	STAA    L02EE			;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check quals for entering closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE237	BRCLR   L004F,#$10,LE250	;Status word, bra if b4==0, engine still off/
					;cranking
;
;-Chekc for O2 errors
;  
	BRCLR   L0019,#$0C,LE241	;Error word #4, clear b2, err 44, lean O2, and	
					;b3=err. 45, rich O2
;
;-O2 errors here, clear dwell timer and disable closed loop 
;
	BRA     LE24D			;Clear O2 timer and continue
;
;-No O2 errors here, check if errors pending
;
LE241	BRSET   L0072,#$40,LE24D	;Bra if b6==1, lean O2
;
;-Check for MAP errors
;
	BRCLR   L0018,#$30,LE253	;Error word #3, bra if b4==0, err 34, low map
					;and b5==0, err 35, high MAP
;
;-High or low MAP errors present, continue normally if not idling
;

	BRCLR   L0050,#$80,LE253	;Status word, bra if not idling
;
;-Here if idling, clear O2 dwell timer and disable closed loop
;
LE24D	CLR     L0264			;Clear timer	
;
;-Here to disable closed loop
;
LE250	JMP     LE2D6		;Jump to disable closed loop
;
;-Perform ALDL diags. if needed
;
LE253	BRCLR   L003B,#$10,LE264	;Bra if not b4, in mode 4 
;
;-In mode 4
;
	LDX     #$0393			;
	BRCLR   0,X,#$01,LE264		; 
;
	BRCLR   1,X,#$01,LE2D6		;
;									   
	BRA     LE2BC			;
;
;-Here if no diags. needed
;							
LE264	LDAA    L0264			;O2 dwell timer
	CMPA    L48C8			;Max time allowed for O2 to remain in window										
	BCC     LE272			;Bra if timer was >=, O2 is dwelling around stoich 
;
	INCA				;+1
	STAA    L0264			;Save it, O2 dwell timer
	BRA     LE275			;Bra to continue
;
;-O2 is dwelling in window
;
LE272	BCLR    L0004,#$01		;Status word, clear b0, O2 no longer functional
;
;-Here if dwell time in O2 window still within limits
;
LE275	BRCLR   L0004,#$01,LE2D6	;Status word, bra if b0==0, O2 no longer functional
;
;-O2 is still functional here
;
	BRSET   L0050,#$10,LE2AA	;Status word, bra if b4==1, in diags. mode
;
;-Not in diags. mode
;
	BRSET   L0004,#$02,LE2AA	;Status word, set b1, quals for closed loop fueling
					;met
;
	LDD     L00F8			;Engine run time
	LSRD				;/2
;
	LDAA    L02A5			;Initial cool temp (engine off)
	CMPA    L48C2			;Threshold for hot restart
	BLS     LE293			;Bra if cool temp was <
;
;-Hot restart in effect
;
	CMPB    L48C5			;Min time for full closed loop (hot restart)
	BCS     LE2CB			;Bra if time <, dont allow full closed loop
;
;-Here to enter closed loop
;
	BRA     LE2A4			;Go enter closed loop
;
;-Here if cool restart in effect
;
LE293	CMPA    L48C1			;Upper temp threshold for extended closed loop delay
	BHI     LE29F			;Bra if cool temp >
;
;-Cold engine, have extended closed loop delay
;
	CMPB    L48C4			;Min time for closed loop (cold engine)
	BCC     LE2A4			;Bra if run time is >=, enter closed loop
;
	BRA     LE2CB			;Bra if time <, no closed loop yet
;
;-Here if cool engine
;
LE29F	CMPB    L48C3			;Min time for closed loop (cool engine) 
	BCS     LE2CB			;Bra if time <, no closed loop yet
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to enter closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE2A4	BSET    L0004,#$02		;Status word, set b1, quals for closed loop fueling
					;met
	BCLR    L0052,#$80		;Status word, clear b7, disable quasi-closed loop
					;for closed loop
;
LE2AA	LDAA    L0006			;Cool temp, 
	CMPA    L48C6			;Min temp to enter closed loop
	BLS	LE2D6			;Bra if cool temp is <=
;	
	BRCLR   L0082,#$40,LE2BC	;Status word, bra if b6==0, no HU	
;
;-Here for HU
;
	LDAA    L0801			;
	ANDA    #$03			;
	BNE     LE2D9			;
;
LE2BC	BSET    L0046,#$80		;Status word, set b7, have entered closed loop since 
					;startup
	BSET    L003E,#$A0		;Status word, set b5, and b7, closed loop enabled
	BRCLR   L0050,#$02,LE2DE	;Status word, bra if b1==0, open loop idle not enabled
;
;-Open loop idle in effect
;
	BCLR    L003E,#$82		;Clear b7, closed loop fueling, and b1, BLM update
					;enable flag
	BRA     LE321			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here for quasi-closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE2CB	BSET    L0052,#$80		;Status word, set b7, quasi-closed loop enabled
;
	LDAA    L026D			;AFR
	CMPA    L48DF			;Lower AFR threshold for quasi-closed loop
	BCC     LE2D9			;Bra if AFR >=, allow quasi-closed loop 
;
;-Disable closed loop 
;
LE2D6	BCLR    L0052,#$80		;Clear b7, no quasi-closed loop idle if richer
					;then stoich
;
;-Clear closed loop flags
;
LE2D9	BCLR    L003E,#$A2		;Status word, clear b7, closed loop flag, b5, 
					;b1, BLM update enable flag
	BRA     LE321			;Bra to return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Subroutine to check quals for BLM update enable
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check quals for BLM updats
:
LE2DE	LDAA    L006F			;Status word
	ANDA    #$48			;Test b6, high MAP error, and b3, low MAP error
	BNE     LE31E			;Bra if !=0, errors set
;
;-Check cool temp
;
	LDAA    L0006			;Cool temp
	CMPA    L48CC			;Min temp for BLM update enable
	BLS     LE31E			;Bra if cool temp is <=
;
;-Check AFR
;
	LDAA    L026D			;AFR
	CMPA    L48DD			;Stoich AFR
	BNE     LE31E			;Bra if AFR is something other then stoich, return
;
;-Check vacuum
;
	LDAA    L01EC			;kPa vacuum
	CMPA    L48C9			;Max vac for BLM update enable
	BHI     LE31E			;Bra if vacuum is greater, no BLM update
;
;-Check MAP
;
	LDAA    L01F2			;Load MAP/baro ratio
	LDAB    L400E			;Opt. byte
	BITB    #$01			;Test b1, use MAP/baro ratio						
	BNE     LE308			;Bra if ==1, use MAP/baro ratio
;
	LDAA    L01E9			;Load A/D MAP
;
LE308	CMPA    L48CB			;Upper MAP limit for BLM update enable
	BHI     LE31E			;Bra if >, no BLM update
;
	CMPA    L48CA			;Lower MAP limit for BLM update enable
	BCS     LE31E			;Bra if MAP >, no BLM update
;
;-Check RPMs
;
	LDAA    L0062			;RPMs/25
	CMPA    L48CD			;Upper RPM limit for BLM update enable
	BCC     LE31E			;Bra if RPMs >=
;
;-Here to enable BLM updates
;
	BSET    L003E,#$02		;Status word, set b1, BLM update enable flag
	BRA     LE321			;Bra to return
;
LE31E	BCLR    L003E,#$02		;Clear b1, dont allow BLM updates
;
LE321	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Rountine to check range select 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE322	LDAB    L009C			;Status word
	ANDB    #$07			;Clear all but b2-b0
	BNE     LE32A			;Bra if any set
;
;-In overdrive here
;
	LDAB    #$06			;Offset for last table
;
;In manual 1st/2nd, drive here
;
LE32A	LSRB				;/2, shift range
	PSHA				;Push gear number to stack
	LDAA    #$04			;4 bytes/table
	MUL				;Range select x table offset
	LDX     #LE33C			;Addr of first table
	ABX				;Add in offset, select appropriate table
	PULB				;Get gear # back off stack
	ABX				;Add it in as offset
	LDAA    0,X			;Get allowed gear off stack
	CBA				;Compare current gear # to looked up val
	BLS     LE33B			;Bra if gear # less
;	
	TBA				;Upper gear limit to A
;	
LE33B	RTS				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Table of upper gear limits for gear selected
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                   
;	Allowed gear #		;Current gear
;
;-Manual 1st
;
LE33C   FCB  0			;1st
	FCB  1			;2nd 
	FCB  1			;3rd
	FCB  1			;4th
;
;-Manual second
;
	FCB  0			;1st 
	FCB  1			;2nd
	FCB  1			;3rd
	FCB  1			;4th
;
;-Drive
;
	FCB  0			;1st
	FCB  1			;2nd
	FCB  2			;3rd
	FCB  2			;4th
;
;-Overdrive
;
	FCB  0			;1st
	FCB  1			;2nd
	FCB  2			;3rd
	FCB  3			;4th
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to calculate transmission output shaft rotation speed
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE34C	LDAA    $08,Y			;Load MSB of accumulated pulse counts
	SUBA    0,Y			;- stored pulse counts, one delayed
	BNE     LE364			;Bra if !=0, edges have been detected
;
;-No new edges have been detected, check time allowed for signal loss
;
	LDAB    3,Y			;Load timer to wait for TOS signal
	BEQ     LE35F			;Bra if ==0, signal lost
;
	DECB				;-1 from timer
	STAB    3,Y			;Save it
	BNE     LE38E			;Bra if !=0, return without updating
;
;-Signal lost, clear output speed
;
LE35F	STD     4,Y			;Clear trans output speed
	BRA     LE38E			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; New edges have been detected
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE364	PSHB				;Push max allowed period to stack
	LDAB    3,Y			;
	BEQ     LE37B			;
;
	TAB				;Get delta pulse counts into B
	CLRA				;
	ASLD				;x2
	ASLD				;x2
	ASLD				;x2, now x8
	FDIV				;[(Delta pulse countsx8) / #counts/rev x 1092] x 65536,
					;now number of revs x 480
	LDD     6,Y			;Load captured free running counter value
	SUBD    1,Y			;Subtract counter val., one delayed, now time between
					;calculation interval, which is secs x 65536
	XGDX				;Swap revs into D, elapsed time into X
	FDIV				;[(revs x 480) / (secs x 65536)] x 65536
	STX     4,Y			;Save result, RPS x 480
;
LE37B	LDX     6,Y			;Load captured free running counter
	STX     1,Y			;Save it, counter, one delayed
;									
	LDAA    $08,Y			;Load accumulated pulses
	STAA    0,Y			;Save it, accumulated pulses, one delayed
	PULA				;Get max time to wait for TOS signal back
	STAA    3,Y			;Reset time to wait for TOS signal timer
	LDD     4,Y			;Load trans output speed
;											
LE38E	RTS				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


E38F:  LE38F     LDAA    L5B34
E392:            COMA    

						;-----------------------------
L5B2B      FCB $61      ; 1100 0001, MASK XMISSH ERR WD 1
                        ;
                        ; b7 1 = ERR 13, o2 FAIL
                        ; b6 1 = ERR 14, HIGH COOLANT TEMP
                        ; b5 1 = ERR 15, LOW COOLANT TEMP
                        ; b4 1 = ERR 16, 2002 PPM Vss FAIL
                        ;
                        ; b3 1 = ERR 17
                        ; b2 1 = ERR 18
                        ; b1 1 = ERR 19
                        ; b0 1 = ERR 21,        HIGH TPS
                        ;------------------------------         

E393:            ANDA    L5B2B
E396:            ANDA    L0016
E398:            ANDA    #$0001
E39A:            BNE     LE3A9

E39C:            LDAA    L5B35
E39F:            COMA    
E3A0:            ANDA    L5B2C

				;
				; CURRENT ERR WD 2
				; $F5
				;
E3A3:            ANDA    L0017
E3A5:            ANDA    #$80
E3A7:            BEQ     LE3AD

E3A9:  LE3A9     BSET    L0092,#$01

E3AC:            RTS     

E3AD:  LE3AD     BCLR    L0092,#$01

E3B0:            RTS     
				;-----------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for high system voltages
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE3B1	LDAA    L5B2F			;Diag. word #5 mask
	ANDA    L001A			;And with error word #5		
	ANDA    #$18			;Mask out errors 52, 53
	BNE     LE3C3			;Bra if errors set
;
	BRSET   L0082,#$80,LE3C7	;Status word, bra if b7==1, if powertrain in motion
;
;-Powertrain still here
;
	TST     L0100			;(???)
	BNE     LE3C7			;Bra if !=0
;
;-Here to flag error
;
LE3C3	BSET    L0093,#$08		;High system voltage present
	RTS				;Return     
;
;-No error/powertrian currently in motion, dont flag error
;
LE3C7	BCLR    L0093,#$08		;High system voltage present
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   

				;------------------------------------------
				; 
				;
				;------------------------------------------
E3CB:  LE3CB     LDAA    L5B35
E3CE:            COMA    
E3CF:            ANDA    L5B2C

				;
				; CURRENT ERR WD 2
				; $F5
				;
E3D2:            ANDA    L0017
E3D4:            ANDA    #$20
E3D6:            BNE     LE3E5

E3D8:            LDAA    L5B3A
E3DB:            COMA    
E3DC:            ANDA    L5B31
E3DF:            ANDA    L001C
E3E1:            ANDA    #$04
E3E3:            BEQ     LE3E9

E3E5:  LE3E5     BSET    L0092,#$02

E3E8:            RTS     

E3E9:  LE3E9     BCLR    L0092,#$02

E3EC:            RTS     
				;------------------------------------------
   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to filter out related errors
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE3ED	LDY     #$5B00			;Start of diag. words
	LDAB    #$09			;Last diag. word
;
;-Loop here to check for errors
;
LE3F3	LDAA    $3C,Y			;Load diag. word
	ANDA    $33,Y			;And with diag. word mask
	LDX     #L0015			;Start addr. of error words
	ABX				;Add in current offset     
	ANDA    0,X			;And with current error word
	LDX     #LE4CF-1		;Start addr. of filter masks
	ABX				;Add in offset
	ANDA    0,X			;And with filter mask
	BNE     LE410			;Bra if errors set
;
;-No errors here, continue
;
	DEY				;-1, go to previous diag. word
	DECB				;-1, previous error word/diag. mask
	BNE     LE3F3			;Bra if !=0, loop to check rest of errors
;
;-No errors found
;
	BCLR    L0092,#$08		;Status word, clear b3, 
					;no general trans related faults
	RTS     
;
;-Errors found here
;
LE410	BSET    L0092,#$08		;Set b3, general trans related faults 
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   

				;------------------------------------------
				; 
				;
				;------------------------------------------
E414:  LE414     LDX     #$E4D7
E417:            JSR     LE47C

E41A:            BNE     LE420

E41C:            BCLR    L0092,#$10

E41F:            RTS     

E420:  LE420     BSET    L0092,#$10

E423:            RTS     
				;------------------------------------------
   

				;------------------------------------------
				; MYSTERY TABLE ??? 
				;  XMISH ERR	 L0092,#$10
				;------------------------------------------
E424:  LE424     LDX     #$E4E0				; INDEX 
E427:            JSR     LE47C				;
											;
E42A:            BNE     LE430				; BR IF NZ, SET ERR & EXIT
											;
E42C:            BCLR    L0092,#$20			; CLR b4, XMISH ERR

E42F:            RTS     

E430:  LE430     BSET    L0092,#$20			; SET b4, XMISH ERR

E433:            RTS     
				;------------------------------------------
   

				;------------------------------------------
				; 
				;
				;------------------------------------------
E434:  LE434     LDX     #$E4E9
E437:            JSR     LE47C

E43A:            BNE     LE440

E43C:            BCLR    L0092,#$40

E43F:            RTS     

E440:  LE440     BSET    L0092,#$40

E443:            RTS     
				;------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Check for heat related trans errors
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE444	BRSET   L001D,#$80,LE458	;Bra if b7==1, error 75, system voltage low
;
	BRCLR   L0083,#$02,LE454	;Bra if b1==0, trans not above hot temp threshold
;
;-Trans above hot temp threshold here, check for heat related errors
;
	LDX     #LE504			;Start of error word filter masks
	JSR     LE47C			;Routine to check for and filter errors
;
	BNE     LE458			;Bra if any errors set
;
LE454	BCLR    L0092,#$80		;No heat related transmission errors set
	RTS				;Return  
;
LE458	BSET    L0092,#$80		;Heat related transmission errors set
	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Check for external errors that effect trans
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE45C	LDX     #LE4F2			;Start of error word filter masks
	JSR     LE47C			;Bra to filtere out related errors
;
	BNE     LE468			;Bra if errors set
;
;-No errors set here
;
	BCLR    L0093,#$01		;Status word, no external errors set
	RTS				;Return     
;
;-Errors set here
;
LE468	BSET    L0093,#$01		;External errors set
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Check for trans related errors
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE46C	LDX     #LE4FB			;Start of error word filter masks
	JSR     LE47C			;Bra to filter out related errors
;
	BNE     LE478			;Bra if errors set
;
;-No errors set here
;
	BCLR    L0093,#$02		;Status word, clear b2, shift error not set 
	RTS				;Bra to return     
;
;-Errors set here
;
LE478	BSET    L0093,#$02		;Status word, clear b2, shift error set 
	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to filter out related errors
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE47C	PSHY				;Y to stack    
	PSHB				;B sto stack    
	LDY     #L5B00			;Start addr. of diag. masks
	LDAB    #$09			;Start with error word #10
	ABX				;Add in offset 
;
;-Loop here to check for errors
;    
LE486	LDAA    $3C,Y			;Load in diag. word 			
	COMA				;Ones comp.    
	ANDA    $33,Y			;And with diag. word mask
	PSHX				;Push X to stack    
	LDX     #L0015			;Start address of error words
	ABX				;Add in the offset     
	ANDA    0,X			;And in error word, clear out any codes not set
	PULX				;Get addr. of table of filter masks    
	ANDA    0,X			;And those in to filter out related errors
	BNE     LE49F			;Bra if result !=0, errors found
;
;-Here if no errors found yet, continue
;
	DEX				;-1, go to previous error word     
	DEY				;-1, go to previous diag. word/mask     
	DECB				;-1, go to previous error filter mask  
	BNE     LE486			;Bra if B !=0, not done checking all codes yet
;
;-Here to exit with error/return
;
LE49F	PULB				;Restore B    
	PULY				;Restore Y
	TSTA				;Test for set errors before returning
	RTS				;Return with results in cond. code reg.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for error 72
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE4A4	LDAA    L5B3A			;Transmission err. word #7
	COMA				;Ones comp.   
	ANDA    L5B31			;transmission err. word #7 mask, mask errors being recognized
	ANDA    L001C			;Err. word #7, mask errors flagged
	ANDA    #$04			;Mask out b2, error 72, output speed loss		
	BEQ     LE4B5			;Bra if error not flagged
;
;-Error 72 flagged
;
	BSET    L0093,#$04		;Status word, set b2, error, output speed loss
	RTS				;Return     
;
;-Error 72 not flagged
;
LE4B5	BCLR    L0093,#$04		;Clear b2, no error
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     

E4B9:  LE4B9     RTS     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to check for error 28
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE4BA	LDAA    L5B35			;Error word #2
	COMA				;1's comp.    
	ANDA    L5B2C			;Error word #2 mask, mask errors being recognized
	ANDA    L0017			;Error word #2, mask errors flagged
	ANDA    #$02			;Mask out error 28, trans press. manifold switch
	BEQ     LE4CB			;Bra if error not set
;
;-Error 28 here
;
	BSET    L0092,#$04		;Status word, set b2, trans press. switch man. error
	RTS				;Return     
;
;-No error 28 here
;
LE4CB	BCLR    L0092,#$04		;Clear b2, trans press. switch man. error 
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
				;------------------------------------------


;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Diag. filter masks, used to filter out general trans related faults
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	binary 1=flag error	;Err. word #
;
LE4CF   FCB $01			;1
	FCB $A2			;2
	FCB $00			;3
	FCB $00			;4
	FCB $00			;5
	FCB $3D			;6
	FCB $87			;7
;
LE4D7   FCB $44			;8
LE4D8   FCB $61     		;9
;
LE4D9   FCB $F2     ;
LE4DA   FCB $70     ;
LE4DB   FCB $3C     ;
LE4DC   FCB $18     ;
LE4DD   FCB $66     ;
LE4DE   FCB $B7     ;
LE4DF   FCB $8E     ;
				;------------------------------------------
   

				;------------------------------------------
				; MYSTERY TABLE ???
				;	  XMISH ERR	 L0092,#$10
				;------------------------------------------
LE4E0   FCB $74     ;
LE4E1   FCB $01     ;
LE4E2   FCB $A0     ;
LE4E3   FCB $00     ;
LE4E4   FCB $00     ;
LE4E5   FCB $00     ;
LE4E6   FCB $00     ;
LE4E7   FCB $A4     ;
LE4E8   FCB $06     ;
				;------------------------------------------
   

				;------------------------------------------
				; 
				;
				;------------------------------------------
LE4E9   FCB $74     ;
LE4EA   FCB $01     ;
LE4EB   FCB $82     ;
LE4EC   FCB $01     ;
LE4ED   FCB $00     ;
LE4EE   FCB $80     ;
LE4EF   FCB $00     ;
LE4F0   FCB $69     ;
LE4F1   FCB $85     ;
				;------------------------------------------


;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Diag. filter mask, used to filter out external errors
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; binary 1=flag error		;Associated error word #
;
LE4F2   FCB $30			;1
	FCB $00			;2
	FCB $20			;3
	FCB $00			;4
	FCB $00			;5
	FCB $00			;6
	FCB $00			;7
	FCB $80			;8
	FCB $80			;9
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Diag. filter mask, used to filter out trans related errors
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; binary 1=flag error		;Associated error word #
;
LE4FB   FCB $00			;1
	FCB $00			;2
	FCB $00			;3
	FCB $00			;4
	FCB $00			;5
	FCB $08			;6
	FCB $00			;7
	FCB $00			;8
	FCB $04			;9
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Diag. filter masks, used to filter out heat related trans errors
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; binary 1=flag error		;Associated error word #
;
LE504   FCB $30     		;1
	FCB $01    		;2
	FCB $82			;3
	FCB $03			;4
	FCB $00			;5
	FCB $00			;6
	FCB $00			;7
	FCB $68			;8
	FCB $01			;9
;
LE50D	FCB $00			;
;
;------------------------------------------
; CK FOR ERROR 15, LO COOL TEMP
;
;
;------------------------------------------
;
; SERIAL DATA MD WORD
; 
LE50E	BRSET   L003B,#$04,LE541	;Status word, bra if b2==1, trans diags disabled
;
	LDX     #L5B00			;Index diag. word masks
	BRCLR   0,X,#$40,LE53D		; BR IF NOT b6,ERR 14, HIGH COOLANT TEMP
;
	LDAA    L0159			; GET ERR 14 TIMER
;
	LDAB    L082D			; COOL A/D
	CMPB    $13,X			; 42d, A/D BIN COOLANT MAX TO ENBLE ERR 14
	BCS     LE531			;
;
	BRCLR   L0016,#$40,LE53D	; BR IF NOT b6, ERR 14, COOL SENSOR, HIGH
;
	INCA				; INCR ERR 14 TIMER
	CMPA    $14,X			; 1 SEC REG FOR ERR 14
	BCS     LE53E			;
;
	BCLR    L0016,#$40		; CLR b6, ERR 14, COOL SENSOR, HIGH
	BRA     LE53D			;
;
LE531	BRSET   L0016,#$40,LE53D	; BR IF b6, ERR 14, COOL SENSOR, HIGH

	INCA				; INCR ERR 14 TIMER
	CMPA    $14,X			; 1 SEC REG FOR ERR 14
	BCS     LE53E			;
;
	BSET    L0016,#$40		; SET b6, ERR 14, COOL SENSOR, HIGH
;
LE53D	CLRA				; CLR ERR 14 TIMER
;
LE53E	STAA    L0159			; ERR 14 TIMER
;
LE541	RTS				;     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


				;------------------------------------------
				; CK FOR ERROR 15, LO COOL TEMP
				;
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; 
E542:  LE542     BRSET   L003B,#$04,LE575	; BR IF b2, XMISH DIAG DISABLED

E546:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS

E549:            BRCLR   0,X,#$20,LE571		; BR IF NOT b5, ERR 15, LOW COOLANT TEMP 

E54D:            LDAA    L015A				; ERR 15 TIMER

E550:            LDAB    L082D          	; COOL A/D
E553:            CMPB    $15,X				; 254d, A/D BIN COOL MIN TO ENBLE ERR 15
E555:            BHI     LE565				; BR IF A.D GT ERR THRESH

E557:            BRCLR   L0016,#$20,LE571	; BR IF NOT b5, ERR 15, COOL SENSOR, LOW

E55B:            INCA    					; INCE ERR 15 TIMER
E55C:            CMPA    $16,X				; 2 SEC REG FOR ERR 15 
E55E:            BCS     LE572

E560:            BCLR    L0016,#$20			; CLR b5, ERR 15, COOL SENSOR, LOW

E563:            BRA     LE571				; EXIT W/NO ERROR


E565:  LE565     BRSET   L0016,#$20,LE571	; BR IF b5, ERR 15, COOL SENSOR, LOW

E569:            INCA    					; INCR ERR TIMER
E56A:            CMPA    $16,X				; 2 SEC REG FOR ERR 15
E56C:            BCS     LE572

E56E:            BSET    L0016,#$20			; SET b5, ERR 15, COOL SENSOR, LOW

E571:  LE571     CLRA    					; CLR ERR 15 TIMER
E572:  LE572     STAA    L015A				;  ERR 15 TIMER

E575:  LE575     RTS     
			;----------------------------------------------


			;----------------------------------------------
			; CK FOR ERR 21,HIGH TPS
			;
			;
			;----------------------------------------------
E576:  LE576     BRSET   L003B,#$04,LE5B6	; BR IF b2, XMISH DIAG DISABLED

E57A:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E57D:            BRCLR   0,X,#$01,LE5B2		; BR IF NOT b0, ERR 21,HIGH TPS 
											;
E581:            LDAA    L015B				; ERR 21 TIMER
											;
E584:            LDAB    L00A0          	; TPS A/D
E586:            CMPB    $1C,X				; A/D TPS MIN FOR ERR 21
E588:            BHI     LE5A5				; BR IF TPS A/D GT THRESH

E58A:            BRSET   L008E,#$01,LE5B2	;

E58E:            BSET    L008E,#$01			;
											;
E591:            BRCLR   L0016,#$01,LE5B2	; BR IF NOT b0, ERR 21, TPS SENSOR HIGH

E595:            LDAB    L001F				; ERR 21 CNT'R
E597:            CMPB    L5B1E				; IF ERR 21 CNT'S L.T. ENABLE RESET OF ERR  21
E59A:            BCC     LE5B2				; BR IF CNT'R GT THRESH

E59C:            INCB    					; DBM INCE OF ERR 21 CNT'R
E59D:            INCB    					;
E59E:            STAB    L001F				; ERR 21 CNT'R
											'
E5A0:            BCLR    L0016,#$01 		; CLR b0, ERR 21, TPS SENSOR HIGH

E5A3:            BRA     LE5B2

E5A5:  LE5A5     BRSET   L0016,#$01,LE5B2	; BR IF b0, ERR 21, TPS SENSOR HIGH

E5A9:            INCA    
E5AA:            CMPA    L5B1D
E5AD:            BCS     LE5B3

E5AF:            BSET    L0016,#$01 		; SET b0, ERR 21, TPS SENSOR HIGH

E5B2:  LE5B2     CLRA    					; CLR ERR 21 TIMER
E5B3:  LE5B3     STAA    L015B				; ERR 21 TIMER

E5B6:  LE5B6     RTS     
				;------------------------------------------


				;------------------------------------------
				; CK FOR LOW TPS CONDITIONS
				; ERR 22
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; 
E5B7:  LE5B7     BRSET   L003B,#$04,LE5F5	; BR IF b2, XMISH DIAG DISABLED

E5BB:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS

E5BE:            BRCLR   1,X,#$80,LE5F1		; BR IF NOT b7, ERR 22, TPS LOW 

E5C2:            LDAA    L015C				; ERR 22 TIMER

E5C5:            LDAB    L00A0          	; TPS A/D
E5C7:            CMPB    $1F,X				; A/D TPS MAX FOR ERR 22
E5C9:            BCS     LE5E5				; BR IF TPS A/D LT THRESH

E5CB:            BRSET   L008E,#$02,LE5F1	; BR IF b1

E5CF:            BSET    L008E,#$02			; SET b1
											;


				;
				; CURRENT ERR WD 2
				; $F5
				;
E5D2:            BRCLR   L0017,#$80,LE5F1	; BR IF NOT b7, ERR 22, LOW TPS 

E5D6:            LDAB    L0020              ; ERR 22 CNT'R
E5D8:            CMPB    $21,X				; IF ERR 22 CNT'S L.T. ENABLE RESET OF ERR 22
E5DA:            BCC     LE5F1				; BR IF ERR TIMER GT THRESH

E5DC:            INCB    					; DBL INCR ERR 22 CNTR 
E5DD:            INCB    
E5DE:            STAB    L0020              ; ERR 22 CNT'R

				;
				; CURRENT ERR WD 2
				; $F5
				;
E5E0:            BCLR    L0017,#$80			; CLR b7, ERR 22, LOW TPS

E5E3:            BRA     LE5F1


				;
				; CURRENT ERR WD 2
				; $F5
				;
E5E5:  LE5E5     BRSET   L0017,#$80,LE5F1	; BR IF b7, ERR 22, LOW TPS 

E5E9:            INCA    					; INCR ERR TIMER
E5EA:            CMPA    $20,X				; 4 SEC QUAL TIME FOR ERR 22
E5EC:            BCS     LE5F2				; BR IF ERR 22 TIMER LT THRESH


				;
				; CURRENT ERR WD 2
				; $F5
				;
E5EE:            BSET    L0017,#$80			; SET b7, ERR 22, LOW TPS

E5F1:  LE5F1     CLRA    					; CLR  ERR 22 TIMER
E5F2:  LE5F2     STAA    L015C				; ERR 22 TIMER

E5F5:  LE5F5     RTS     
				;------------------------------------------


				;------------------------------------------
				; CK FOR  OUTPUT XMISH SPD LOW
				; ERR 24
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; 
E5F6:  LE5F6     BRSET   L003B,#$04,LE676	; BR IF b2, XMISH DIAG DISABLED

E5FA:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E5FD:            BRCLR   1,X,#$20,LE672		; ERR 24, OUTPUT XMISH SPD LOW

E601:            LDAA    L015D				; ERR 24 TIMER
											;
E604:            BRSET   L008E,#$04,LE61E	; BR IF b2, 

E608:            BSET    L008E,#$04			; SET b2
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
E60B:            BRCLR   L0017,#$20,LE672	; BR IF NOT b5, ERR 24, LOW Vss
		
E60F:            LDAB    L0021              ; ERR 24 CNT'R
E611:            CMPB    $42,X				; 255 ERR CNTS MIN TO SET ERR 24
E613:            BCC     LE672				; BR IF ERR CNT GT THRESH

E615:            INCB    					; DBL INCR TIMER
E616:            INCB    					;
E617:            STAB    L0021              ; ERR 24 CNT'R
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
E619:            BCLR    L0017,#$20			; CLR b5, ERR 24, LOW Vss 

E61C:            BRA     LE672




				;
				; CURRENT ERR WD 2
				; $F5
				;
E61E:  LE61E     BRSET   L0017,#$20,LE672	; BR IF b5, ERR 24, LOW Vss


				;
				; CURRENT ERR WD 3
				; $F5
				;
E622:            BRSET   L0018,#$20,LE672	; BR IF  b5, ERR 33, MAP SENSOR HI

E626:            BRSET   L0018,#$10,LE672	; BR IF b4, ERR 34, MAP SENSOR LOW

E62A:            BRSET   L0016,#$01,LE672	; BR IF b0,	ERR 21, TPS SENSOR HIGH


				;
				; CURRENT ERR WD 2
				; $F5
				;
E62E:            BRSET   L0017,#$80,LE672	; BR IF b7, ERR 22, LOW TPS

E632:            LDAB    L01E3				; S/D MAP
E635:            CMPB    L5B45				; IF LD L.T. 100 Kpa, DISABLE ERR 24 TEST
E638:            BCS     LE672				; THR IF MAP LT THRESH

E63A:            CMPB    L5B46				; IF LD G.T. 255 Kpa,  DISABLE ERR 24 TEST
E63D:            BHI     LE672				; BR IF LD GT THRESH

E63F:            LDAB    L00AC				;
E641:            CMPB    L5B47				; IF TPS L.T. 10% TPS,  DISABLE ERR 24 TEST
E644:            BCS     LE672				; BR IF TPS LT THRESH

E646:            CMPB    L5B48				; IF TPS G.T. 99.6% TPS,  DISABLE ERR 24 TES
E649:            BHI     LE672				; BR IF TPS GT THRESH

E64B:            LDY     L00CB				; XMISH OUTPUT SPD
E64E:            CPY     $3D,X				; 250 XMISH OUTPUT SPD MAX TO SET ERR 24
E651:            BCC     LE672				; BR IF XMISH OUTPUT SPD GT THRESH

E653:            BRSET   L001C,#$01,LE672	; BR IF b0,


				;
				; CURRENT ERR WD 2
				; $F5
				;
E657:            BRSET   L0017,#$02,LE672	; BR IF b1, ERR 28, PRESS SW MANIFOLD

E65B:            LDY     L019D				; RPM * 8
E65F:            CPY     $3F,X				; 3000 RPM MIN TO SET ERR 24 
E662:            BLS     LE672				; BR IF RPM LT THRESH

E664:            BRCLR   L009C,#$50,LE66A	; BR IF NOT b4 & b6
											; .. else
E668:            BRA     LE672



E66A:  LE66A     INCA    					; INCE ERR 24 TIMER
E66B:            CMPA    $41,X				; 3 SEC TIME QUALIFICATION FOR ERR 24
E66D:            BCS     LE673				; BR IF TIME LT THRESH


				;
				; CURRENT ERR WD 2
				; $F5
				;
E66F:            BSET    L0017,#$20			; SET b5, ERR 24, LOW Vss
											;
E672:  LE672     CLRA    					;
E673:  LE673     STAA    L015D				; ERR 24 TIMER

E676:  LE676     RTS     
				;------------------------------------------


				;------------------------------------------
				; PRESS SW MANIFOLD
				; ERR 28
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD		;		
				; 							;
E677:  LE677     BRSET   L003B,#$04,LE6B3	; BR IF b2, XMISH DIAG DISABLED

E67B:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E67E:            BRCLR   1,X,#$02,LE6AF		; BR IF NOT b1, ERR 28

E682:            LDAA    L015E				;
E685:            BRSET   L009C,#$80,LE6A3	;

E689:            BRSET   L008E,#$08,LE6AF	;

E68D:            BSET    L008E,#$08			;
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
E690:            BRCLR   L0017,#$02,LE6AF	; BR IF NOT b1, ERR 28, PRESS SW MANIFOLD

E694:            LDAB    L0022              ; ERR 28 CNT'R
E696:            CMPB    $52,X				; 255 ERR CNTS MIN TO SET ERR 28
E698:            BCC     LE6AF				; BR IF CNT'R GT THRESH

E69A:            INCB    					; DBL INCR CNT'R
E69B:            INCB    					;
E69C:            STAB    L0022              ; ERR 22 CNT'R

				;
				; CURRENT ERR WD 2
				; $F5
				;
E69E:            BCLR    L0017,#$02			; CLR b1, ERR 28, PRESS SW MANIFOLD
											
E6A1:            BRA     LE6AF			

	
											

				;
				; CURRENT ERR WD 2
				; $F5
				;
E6A3:  LE6A3     BRSET   L0017,#$02,LE6AF	; BR IF b1, ERR 28, PRESS SW MANIFOLD

E6A7:            INCA    					; INCR ERR 22 TIMER
E6A8:            CMPA    $51,X				; 2 Sec CRITERIA FOR ERR 28
E6AA:            BCS     LE6B0				; BR IF TIME LT ERR 28 TIMER


				;
				; CURRENT ERR WD 2
				; $F5
				;
E6AC:            BSET    L0017,#$02			; SET b1, ERR 28, PRESS SW MANIFOLD
											;
E6AF:  LE6AF     CLRA    					; CLR ERR 22 TIMER
E6B0:  LE6B0     STAA    L015E				; ERR 22 TIMER

E6B3:  LE6B3     RTS     					
				;------------------------------------------											
											
;
;------------------------------------------
; CK FOR ERR 37, BRAKE STUCK ON
;
;
;------------------------------------------
;
;							
; SERIAL DATA MD WORD
; 
LE6B4	BRSET   L003B,#$04,LE6E5	; BR IF b2, XMISH DIAG DISABLED

	LDX     #L5B00			; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
	BRCLR   2,X,#$02,LE6DF		; BR IF NOT b1, ERR 37, BRAKE ON 
;
	BRSET   L0096,#$01,LE6E8	; BR IF b0, 
;
	BCLR    L008E,#$30		; CLE b5 & b6
;
; CURRENT ERR WD 3
; $F5
;
	BRCLR   L0018,#$02,LE6DF	; BR IF NOT b1, ERR 37, TCC BRAKE SW STUCK ON
;
	LDAA    L015F			;
	INCA				;
	CMPA    $57,X			; 7 ERR CNTS MIN TO ENABLE ERR 37
	BCS     LE6E2			;
;
	LDAB    L0023			; ERR 37 CNT'R
	CMPB    $58,X			; 255 ERR CNTS MIN TO SET ERR 37
	BCC     LE6DF			; BR IF ERR 37 CNT'R GR THRESH
;
	INCB				; DBL INCR ERR 37 CNT'R
	INCB				;
	STAB    L0023			; ERR 37 CNT'R
;
; CURRENT ERR WD 3
; $F5
;
	BCLR    L0018,#$02		; CLR b1, ERR 37, TCC BRAKE SW STUCK ON
;
LE6DF	JMP     LE748			;
;
LE6E2	JMP     LE749			;
;
LE6E5	JMP     LE74C			;
;
; CURRENT ERR WD 3
; $F5
;
LE6E8	BRSET   L0018,#$02,LE748	; BR IF b1
;
	LDAB    L00D1			; FILT  Vss
	CMPB    $53,X			; IF 5 MPH, CK FOR HI MPH BRAKE ON
	BHI     LE6FE			; BR IF Vss GT 5 MPH
;
	BSET    L008E,#$10		; SET b4, 
	BCLR    L008E,#$20		; CLR b5
	CLRA				; CLR ERR 37 TIMER
	STAA    L017B			; ERR 37 TIMER
	BRA     LE74C			;
;
LE6FE	BRCLR   L008E,#$10,LE74C	; BR IF NOT b4
;
	CMPB    $54,X			; 6 SECS CRITERIA FOR ERR 37
	BCC     LE71A			; BR IF TIMER GT THRESH
;
	BRSET   L008E,#$20,LE72E	; SET b5, 
;
	LDAA    L017B			; ERR 37 TIMER
	ADDA    #$01			; ADD 1 COUNT
	BEQ     LE715			; BR IF OVERFLOW
;
	STAA    L017B			; SAVE NEW ERR 37 TIMER
	CLRA				;
    
LE715	STAA    L017C			;
	BRA     LE74C			;
;
LE71A	BSET    L008E,#$20		;
	LDAA    L017C			;
	ADDA    #$01			; ADD 1 COUNT
	BEQ     LE727			; BR IF OVERFLOW
;
	STAA    L017C			;
;
LE727	LDAA    L017B			; ERR 37 TIMER
	CMPA    $55,X			; 6 SECS CRITERIA FOR ERR 37
	BHI     LE733			; BR IF TIMER HT THRESH
;
LE72E	BCLR    L008E,#$30		;
	BRA     LE74C			;
;
LE733	LDAA    L017C			;
	CMPA    $0056,X			;
	BLS     LE74C			;
;
	BCLR    L008E,#$30		;
	LDAA    L015F			;
	INCA				;    
	CMPA    $0057,X			;
	BCS     LE749			;
;
; CURRENT ERR WD 3
; $F5
;
	BSET    L0018,#$02		; SET b1, ERR 37, TCC BRAKE SW STUCK ON
;
LE748	CLRA				; 
;   
LE749	STAA    L015F			;
;
LE74C	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
				;------------------------------------------


				;------------------------------------------
				; CK FOR ERR 38, BRAKE OFF
				;
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; 
E74D:  LE74D     BRSET   L003B,#$04,LE781	; BR IF b2, XMISH DIAG DISABLED

E751:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E754:            BRCLR   2,X,#$01,LE77B		; BR IF NOT b0, ERR 38, BRAKE OFF 
											;
E758:            BRCLR   L0096,#$01,LE784	; BR IF NOT b0,
											;
E75C:            BCLR    L008E,#$80			; CLR b7
E75F:            BSET    L008E,#$40			; SET b6


				;
				; CURRENT ERR WD 3
				; $F5
				;
E762:            BRCLR   L0018,#$01,LE77B	; BR IF NOT b0, TCC BRAKE SW STUCK OFF

E766:            LDAA    L0160				; ERR 38 ERR CNT'R
E769:            INCA    					; INCR ERR CNT'R
E76A:            CMPA    $5D,X				; 7 ERR CNTS MIN TO ENABLE ERR 37
E76C:            BCS     LE77E

E76E:            LDAB    L0024              ; ERR 24 CNT'R
E770:            CMPB    $5E,X				; 255 ERR CNTS MIN TO SET ERR 37
E772:            BCC     LE77B

E774:            INCB    
E775:            INCB    
E776:            STAB    L0024              ; ERR 24 CNT'R

				;
				; CURRENT ERR WD 3
				; $F5
				;
E778:            BCLR    L0018,#$01			; CLR b0, TCC BRAKE SW STUCK OFF

E77B:  LE77B     JMP     LE7EA

E77E:  LE77E     JMP     LE7EB

E781:  LE781     JMP     LE7EE


				;
				; CURRENT ERR WD 3
				; $F5
				;
E784:  LE784     BRSET   L0018,#$01,LE7EA	; BR IF b0, TCC BRAKE SW STUCK OFF

E788:            LDAB    L00D1				; FILT  Vss
E78A:            CMPB    $59,X				; IF G.T. 20 MPH CK LO MPH BRAKE OFF
E78C:            BLS     LE7AC				; BR IF Vss LT THRESH

E78E:            BRCLR   L008E,#$40,LE796	; BR IF NOT b6

E792:            CLRA    
E793:            STAA    L017E
E796:  LE796     BCLR    L008E,#$40			; CLR b6
E799:            BSET    L008E,#$80			; CLR b7

E79C:            LDAA    L017E
E79F:            ADDA    #$01				; ADD 1 COUNT
E7A1:            BEQ     LE7A7				; BR IF OVER FLOW

E7A3:            STAA    L017E
E7A6:            CLRA    
E7A7:  LE7A7     STAA    L017D
E7AA:            BRA     LE7EE

E7AC:  LE7AC     BRCLR   L008E,#$80,LE7EE

E7B0:            CMPB    $5A,X				; IF L.T. 5 MPH CK LO MPH BRAKE OFF
E7B2:            BLS     LE7C3				; BR IF Vss LT THRESH

E7B4:            BSET    L008E,#$40

E7B7:            LDAA    L017D
E7BA:            ADDA    #$01				; ADD 1 COUNT
E7BC:            BEQ     LE7EE				; BR IF OVER FLOW

E7BE:            STAA    L017D
E7C1:            BRA     LE7EE

E7C3:  LE7C3     LDAA    L017D
E7C6:            CMPA    $5B,X				; 6 SECS CRITERIA FOR ERR 38
E7C8:            BLS     LE7D1

E7CA:            LDAA    L017E
E7CD:            CMPA    $5C,X				; 6 SECS CRITERIA FOR ERR 38
E7CF:            BHI     LE7D9

E7D1:  LE7D1     BCLR    L008E,#$80			; CLR b7
E7D4:            BSET    L008E,#$40			; SET B6

E7D7:            BRA     LE7EE


E7D9:  LE7D9     BCLR    L008E,#$80			; CLR b7
E7DC:            BSET    L008E,#$40			; SET B6

E7DF:            LDAA    L0160				; ERR 38 ERR CNT'R
E7E2:            INCA    					; INCR ERR CNT'R
E7E3:            CMPA    $5D,X				; 7 ERR CNTS MIN TO ENABLE ERR 37
E7E5:            BCS     LE7EB				; BR IF ERR CNT'R LT THRESH


				;
				; CURRENT ERR WD 3
				; $F5
				;
E7E7:            BSET    L0018,#$01			; SET b0, TCC BRAKE SW STUCK OFF

E7EA:  LE7EA     CLRA    					; CLR ERR CNT'R
E7EB:  LE7EB     STAA    L0160				; ERR 38 ERR CNT'R
E7EE:  LE7EE     RTS     
				;------------------------------------------


				;------------------------------------------
				; CK ERR 52, HIGH SYSTEM VOLTAGE
				;
				;
				;------------------------------------------

   				;
				; CK SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E7EF:  LE7EF     BRSET   L003B,#$04,LE82A	; BR IF b2, XMISH DIAG DISABLED


E7F3:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E7F6:            BRCLR   4,X,#$10,LE822

E7FA:            LDY     L0162

E7FE:            LDAB    L00A1				; BATTERY A/D
E800:            CMPB    $5F,X				; IF BAT G.T. 16 VDC ENABLE ERR 52
E802:            BHI     LE814				; BR IF 

E804:            BRSET   L0091,#$01,LE822	; BR IF b0

E808:            BSET    L0091,#$01			; SET b0


				;
				; CURRENT ERR WD 5
				; $F5
				;
E80B:            BRCLR   L001A,#$10,LE822	; BR IF NOT b4, ERR 52, MISSING FUEL CALPACK 

E80F:            BCLR    L001A,#$10			; CLR b4, ERR 52, MISSING FUEL CALPACK 

E812:            BRA     LE822

E814:  LE814     BRSET   L001A,#$10,LE822	; BR IF b4, ERR 52, MISSING FUEL CALPACK

E818:            INY     
E81A:            CPY     $60,X
E81D:            BCS     LE826

E81F:            BSET    L001A,#$10			; SET b4, ERR 52, MISSING FUEL CALPACK

E822:  LE822     LDY     #$0000
E826:  LE826     STY     L0162

E82A:  LE82A     RTS     
				;------------------------------------------


				;------------------------------------------
				; CK ERR 53, HI SYS VOLTAGE
				;
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E82B:  LE82B     BRSET   L003B,#$04,LE85F	; BR IF b2, XMISH DIAG DISABLED


E82F:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E832:            BRCLR   4,X,#$08,LE85B

E836:            LDAA    L0164

E839:            LDAB    L00A1              ; BATTERY A/D
E83B:            CMPB    $62,X				; IF BATT G.T. 19.5 VDC ENABLE ERR 53 
E83D:            BHI     LE84F				; BR IF BAT GT THRESH

E83F:            BRSET   L008F,#$02,LE85B	; BR IF b1,

E843:            BSET    L008F,#$02			; SET b1


				;
				; CURRENT ERR WD 5
				; $F5
				;
E846:            BRCLR   L001A,#$08,LE85B	; BR IF NOT b3, ERR 53, HI SYS VOLTAGE

E84A:            BCLR    L001A,#$08 		; CLR b3, ERR 53, HI SYS VOLTAGE

E84D:            BRA     LE85B


E84F:  LE84F     BRSET   L001A,#$08,LE85B	; BR IF b3, ERR 53, HI SYS VOLTAGE

E853:            INCA    					; INCR ERR 53 TIMER
E854:            CMPA    $63,X				; IF COND G.T 2 SEC, SET ERR 53
E856:            BCS     LE85C				; BR IF TIMER LT THRESH

E858:            BSET    L001A,#$08 		; CLR b3, ERR 53, HI SYS VOLTAGE

E85B:  LE85B     CLRA    					; CLR ERR 53 TIMER
E85C:  LE85C     STAA    L0164				; SAVE NEW ERR 53 TIMER

E85F:  LE85F     RTS     
				;------------------------------------------



				;------------------------------------------
				; CK FOR ERR 58, HI XMISH TEMP
				;
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; 
E860:  LE860     BRSET   L003B,#$04,LE892	; BR IF b2, XMISH DIAG DISABLED


E864:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E867:            BRCLR   5,X,#$40,LE88E		; BE ID NOT b6, ERR 58, HI XMISH TEMP 

E86B:            LDAA    L0165
E86E:            LDAB    L009F				; GET XMISH TEMP
E870:            CMPB    $64,X				; IF TRANS TEMP (A/D) L.T. 17 ENABLE ERR 58
E872:            BCS     LE882				; BR IF TEMP LT THRESH
											; .,.. else
				;
				; CURRENT ERR WD 6
				; $F5
				;
E874:            BRCLR   L001B,#$40,LE88E	; BR IF NOT b6, ERR 58, XMISH TEMP HI
											; .,.. else
E878:            INCA    					; INCR TIMER
E879:            CMPA    $65,X				; 1 SEC CRITERIA
E87B:            BCS     LE88F				; BR IF TIMER LT THRESH

E87D:            BCLR    L001B,#$40			; CLR b6, ERR 58, XMISH TEMP HI

E880:            BRA     LE88E


E882:  LE882     BRSET   L001B,#$40,LE88E	; BR IF b6, ERR 58, XMISH TEMP HI
											; .,.. else
E886:            INCA    					; INCR TIMER    
E887:            CMPA    $65,X				; 1 SEC CRITERIA
E889:            BCS     LE88F				; BR IF TIMER LT THRESH

E88B:            BSET    L001B,#$40			; SET b6

E88E:  LE88E     CLRA    					; CLR ERR TIMER
E88F:  LE88F     STAA    L0165				; SAVE NEW ERR 58 TIMER

E892:  LE892     RTS     
				;------------------------------------------


				;------------------------------------------
				;
				;
				; 
				;------------------------------------------

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E893:  LE893     BRSET   L003B,#$04,LE8C5	; BR IF b2, XMISH DIAG DISABLED


E897:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E89A:            BRCLR   5,X,#$20,LE8C1

E89E:            LDAA    L0166
E8A1:            LDAB    L009F
E8A3:            CMPB    $67,X
E8A5:            BHI     LE8B5

				;
				; CURRENT ERR WD 6
				; $F5
				;
E8A7:            BRCLR   L001B,#$20,LE8C1
												; .,.. else
E8AB:            INCA    
E8AC:            CMPA    $68,X
E8AE:            BCS     LE8C2

E8B0:            BCLR    L001B,#$20
												; .,.. else
E8B3:            BRA     LE8C1

E8B5:  LE8B5     BRSET   L001B,#$20,LE8C1
												; .,.. else
E8B9:            INCA    
E8BA:            CMPA    $68,X
E8BC:            BCS     LE8C2

E8BE:            BSET    L001B,#$20
												; .,.. else
E8C1:  LE8C1     CLRA    
E8C2:  LE8C2     STAA    L0166
E8C5:  LE8C5     RTS     

E8C6:  LE8C6     RTS     

E8C7:  LE8C7     RTS     


   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E8C8:  LE8C8     BRSET   L003B,#$04,LE8FB	; BR IF b2, XMISH DIAG DISABLED


E8CC:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E8CF:            BRCLR   5,X,#$04,LE8F7

E8D3:            LDAA    L0167
E8D6:            LDAB    L0316
E8D9:            CMPB    $0069,X
E8DB:            BHI     LE8EB

				;
				; CURRENT ERR WD 6
				; $F5
				;
E8DD:            BRCLR   L001B,#$04,LE8F7
											; .,.. else
E8E1:            INCA    
E8E2:            CMPA    $6A,X
E8E4:            BCS     LE8F8

E8E6:            BCLR    L001B,#$04

E8E9:            BRA     LE8F7

E8EB:  LE8EB     BRSET   L001B,#$04,LE8F7
											; .,.. else
E8EF:            INCA    
E8F0:            CMPA    $6A,X
E8F2:            BCS     LE8F8

E8F4:            BSET    L001B,#$04

E8F7:  LE8F7     CLRA    
E8F8:  LE8F8     STAA    L0167
E8FB:  LE8FB     RTS     


   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E8FC:  LE8FC     BRSET   L003B,#$04,LE92F	; BR IF b2, XMISH DIAG DISABLED


E900:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E903:            BRCLR   5,X,#$02,LE92B

E907:            LDAA    L0168
E90A:            LDAB    L0316
E90D:            CMPB    $006D,X
E90F:            BCS     LE91F

				;
				; CURRENT ERR WD 6
				; $F5
				;
E911:            BRCLR   L001B,#$02,LE92B

E915:            INCA    
E916:            CMPA    $006E,X
E918:            BCS     LE92C

E91A:            BCLR    L001B,#$02

E91D:            BRA     LE92B

E91F:  LE91F     BRSET   L001B,#$02,LE92B

E923:            INCA    
E924:            CMPA    $006E,X
E926:            BCS     LE92C

E928:            BSET    L001B,#$02

E92B:  LE92B     CLRA    
E92C:  LE92C     STAA    L0168

E92F:  LE92F     RTS     
				*******************************************


				*******************************************
				*  TRANSMISSION
				*  ERR 71,  LOW ENGINE SPD
				*
				*******************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E930:  LE930     BRSET   L003B,#$04,LE96E	; BR IF b2, XMISH DIAG DISABLED

E934:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS

                 ;----------------------
				 ; 0000 0000, ERR MASK 9
                 ; 	b3 1 = ERR 88, 
                 ;----------------------
E937:            BRCLR   6,X,#$08,LE96A		; $5B08, BR IF NOT b3, ERR 88

E93B:            LDAA    L016D				; ERR 71 TIMER
											;
E93E:            LDY     L00B1				; ENG SPEED, (Xmish)
E941:            CPY     $80,X				; $5B80,  IF ENG SPD L.T  200 RPM ENABLE ERR 71
E944:            BCS     LE954				; BR IF IF ENG SPD L.T. THRESH

E946:            BRCLR   L001C,#$08,LE96A	; BR IF NOT b3,

E94A:            INCA    					; INCR ERR 71 TIMER
E94B:            CMPA    $82,X				; $5B82, 2 SECS CRITERIA FOR ERR 71
E94D:            BCS     LE96B				; BR IF ERR 71 TIMER LT THRESH

E94F:            BCLR    L001C,#$08			; CLR b3, ERR 71
											;
E952:            BRA     LE96A				; CLR ERR TIMER & EXIT
											;
E954:  LE954     BRSET   L001C,#$08,LE96A	; BR IF b3, ERR 71


				;
				; CURRENT ERR WD 2
				; $F5
				;
E958:            BRSET   L0017,#$02,LE96A	; BR IF b1, ERR 28, PRESS SW MANIFOLD

E95C:            LDAB    L009C				;
E95E:            ANDB    #$50				; 0000 0101, CLR ERR TIMER & EXIT
E960:            BNE     LE96A				;

E962:            INCA    					; INCR ERR 71 TIMER
E963:            CMPA    $82,X				; $5B82, 2 SECS CRITERIA FOR ERR 71
E965:            BCS     LE96B				; BR IF TIMER LT THRESH 
											;	
E967:            BSET    L001C,#$08			; SET b3, ERR 71
											;
E96A:  LE96A     CLRA    					; CLR ERR TIMER & EXIT
E96B:  LE96B     STAA    L016D				; UPDATE ERR 71 TIMER

E96E:  LE96E     RTS     
				*******************************************


				*******************************************
				*  TRANSMISSION
				*  ERR 72, OUTPUT SPD LOSS
				*
				*******************************************

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E96F:  LE96F     BRSET   L003B,#$04,LE9DB	; BR IF b2, XMISH DIAG DISABLED

E973:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
				;------------------------------
				; 1101 0110, ERR MASK 7
				; b2 1 = ERR 72, OUTPUT SPD LOSS
				;------------------------------
E976:            BRCLR   6,X,#$04,LE9D7		; $5B06,  ERR 72, 

E97A:            LDD     L00CF				;
E97C:            SUBD    L00C6				;
E97E:            BPL     LE984				;

E980:            NEGB    					;
E981:            NEGA    					;
E982:            SBCA    #$00				;
											;
E984:  LE984     BRCLR   L009C,#$50,LE98E	; BR IF NOT b4 & b6

E988:            CPD     L5B87				; IF ABS G.T. 2048 RPM ENABLE ERR 72
											;
E98C:            BRA     LE992				;
											;
E98E:  LE98E     CPD     L5B85				; IF ABS G.T. 1000 RPM ENABLE ERR 72
                       						; (USED IF NOT IN PK/NEUT)
E992:  LE992     BHI     LE9AF				; BR IF 

E994:            BRSET   L008F,#$10,LE9D7	; BR IF b4

E998:            BSET    L008F,#$10			; SET b4
											;
E99B:            BRCLR   L001C,#$04,LE9D7   ; BR IF NOT b2, Err 72 

E99F:            LDAB    L0029              ; ERR 29 CNT'R
E9A1:            CMPB    L5B8B				; IF ERR CNT'R G.T. 255 SET ERR 72
E9A4:            BCC     LE9D7				; BR IF CNT GT THRESH

E9A6:            INCB    					; INCR ERR 72 CNT'R 
E9A7:            INCB    					;
E9A8:            STAB    L0029              ; UPDATE ERR 29 CNT'R
E9AA:            BCLR    L001C,#$04			; CLR b2, Err 72 
											;
E9AD:            BRA     LE9D7				;
											;
E9AF:  LE9AF     BRSET   L001C,#$04,LE9D7	; BR IF b2, 

E9B3:            LDAA    L019C				;
E9B6:            BNE     LE9D7				;

E9B8:            LDD     L019D				; RPM * 8
E9BB:            CPD     L5B89				; IF NE L.T. 200 RPM SKIP TEST
E9BF:            BCS     LE9D7				; BR IF ENG RPM LT THRESH

E9C1:            LDAA    L009B				;
E9C3:            CMPA    #255				;
E9C5:            BNE     LE9D7				;


				;
				; CURRENT ERR WD 2
				; $F5
				;
E9C7:            BRSET   L0017,#$02,LE9D7	; BR IF b1, ERR 28, PRESS SW MANIFOLD

E9CB:            LDAA    L016E				; ERR 72 TIMER
E9CE:            INCA    					; INCR ERR 72 TIMER
E9CF:            CMPA    L5B8C				; 2 SECS CRITERIA FOR ERR 72
E9D2:            BCS     LE9D8				; BR IF TIMER LT THRESH

E9D4:            BSET    L001C,#$04			; SET b2, Err 72
											;
E9D7:  LE9D7     CLRA    					; CLEAR ERR 72 TIMER
E9D8:  LE9D8     STAA    L016E				; UPDATE ERR 72 TIMER

E9DB:  LE9DB     RTS     
			***********************************************


			***********************************************
			* TRANSMISSION
			*  ERR 73,  FORCE MOTOR CURRENT
			*
			***********************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
E9DC:  LE9DC     BRSET   L003B,#$04,LEA27	; BR IF b2, XMISH DIAG DISABLED

											;
E9E0:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
E9E3:            BRCLR   6,X,#$02,LEA23		; BR IF NOT b1, 

E9E7:            LDAA    L016F				; Err 73 TIMER
											;
E9EA:            BRSET   L008A,#$80,LEA12	; BR IF b7, 

E9EE:            LDAB    L0149				; FORCE MOTOR D.C.
E9F1:            BPL     LE9F4				; BR IF FM D.C. LT THRESH

E9F3:            NEGB    					;
E9F4:  LE9F4     CMPB    $8D,X				; $5B8F,IF ERR CNT'R G.T. 10 SET ERR 72 
E9F6:            BHI     LEA12				;

E9F8:            BRSET   L008F,#$20,LEA23	; BR IF b5, CLEAR Err 73 TIMER & EXIT 

E9FC:            BSET    L008F,#$20			; SET b5, 
											;
E9FF:            BRCLR   L001C,#$02,LEA23	; BR IF NOT b1

EA03:            LDAB    L002A              ; ERR 73 CNT'R
EA05:            CMPB    $8F,X				; $5B8F, IF ERR CNT'R G.T. 10 SET ERR 72 
EA07:            BCC     LEA23				; IF LT 10, CLEAR Err 73 TIMER & EXIT

EA09:            INCB    					; INCR Err 72 TIMER
EA0A:            INCB    					;
EA0B:            STAB    L002A              ; ERR 73 CNT'R
EA0D:            BCLR    L001C,#$02			; CLR b1, Err 73
											;
EA10:            BRA     LEA23				; CLEAR Err 73 TIMER & EXIT
											;
EA12:  LEA12     BRSET   L001D,#$80,LEA23	; BR IF b7, 

EA16:            TST     L0171				;
EA19:            BNE     LEA23				; CLEAR Err 73 TIMER & EXIT 

EA1B:            INCA    					; INCR Err 73 TIMER
EA1C:            CMPA    $8E,X				; $5B8E, 2 SECS CRITERIA FOR ERR 73 
EA1E:            BCS     LEA24				; BR IF  Err 73 TIMER LT THRESH

EA20:            BSET    L001C,#$02			; SET b1, Err 

EA23:  LEA23     CLRA    					; CLEAR Err 73 TIMER
EA24:  LEA24     STAA    L016F				; UPDATE Err 73 TIMER

EA27:  LEA27     RTS     
			***********************************************


			***********************************************
			*  TRAANSMISSION
			*  Err 75, SYSTEM LOW VOLTAGE
			*
			***********************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EA28:  LEA28     BRSET   L003B,#$04,LEA7A	; BR IF b2, XMISH DIAG DISABLED


EA2C:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EA2F:            BRCLR   7,X,#$80,LEA76

EA33:            LDD     L019D				; RPM * 8
EA36:            CPD     L5B95				; IF NE L.T. 200 RPM SKIP TEST
EA3A:            BCS     LEA76				; BR IF ENG RPM lt THRESH

EA3C:            BRSET   L001D,#$80,LEA4B	; BR IF b7,  

EA40:            LDAB    $91,X				; $5B91, 11.4 VDC HI TEMP VOLTAGE
EA42:            SUBB    $90,X				; $5B90,  7.3 VDC LO TEMP VOLTAGE
EA44:            LDAA    L00AF  			; XMISH TEMP
EA46:            MUL     					;
EA47:            ADCA    $90,X				; $5B90,  7.3 VDC LO TEMP VOLTAGE
EA49:            BRA     LEA54				;
											;
EA4B:  LEA4B     LDAB    $93,X				; $5B93, 12.4 VDC HI TEMP RECOVERY VOLTAGE
EA4D:            SUBB    $92,X				; $5B92,  8.3 VDC LO TEMP RECOVERY VOLTAGE
EA4F:            LDAA    L00AF  			; XMISH TEMP
EA51:            MUL     					;
EA52:            ADCA    $92,X				; $5B92,  8.3 VDC LO TEMP RECOVERY VOLTAGE
EA54:  LEA54     TAB     					;
EA55:            LDAA    L0171				; Err 75 TIMER
											;
EA58:            CMPB    L00A1              ; BATTERY A/D
EA5A:            BHI     LEA6A				; BR IF BATT VOLTS ... 	

EA5C:            BRCLR   L001D,#$80,LEA76	; BR IF NOT b7, 

EA60:            INCA    					;
EA61:            CMPA    $94,X				; $5B94, 4 SECS CRITERIA FOR ERR 75
EA63:            BCS     LEA77				; UPDATE Err 75 TIMER & EXIT

EA65:            BCLR    L001D,#$80			; CLR b7,  Err 75
											;
EA68:            BRA     LEA76				; CLEAR Err 75 TIMER & EXIT
											;
EA6A:  LEA6A     BRSET   L001D,#$80,LEA76	; SET b7,  Err 75

EA6E:            INCA    					; INCR ERR TIMER
EA6F:            CMPA    $94,X				; $5B94, 4 SECS CRITERIA FOR ERR 75
EA71:            BCS     LEA77				; BR IF ERR TIMER LT THRESH

EA73:            BSET    L001D,#$80			;
											;
EA76:  LEA76     CLRA    					; CLEAR Err 75 TIMER
EA77:  LEA77     STAA    L0171				; UPDATE Err 75 TIMER

EA7A:  LEA7A     RTS     					;
			***********************************************


			***********************************************
			*
			* ERR 77
			*
			***********************************************

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EA7B:  LEA7B     BRSET   L003B,#$04,LEAAD	; BR IF b2, XMISH DIAG DISABLED

EA7F:            LDX     #$5B00	            ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EA82:            BRCLR   7,X,#$20,LEAA9		; $5B07, BR IF NOT b5, ERR 77, MNP SWITCH  

EA86:            LDAA    L0172				; Err 77 TIMER
											;
EA89:            BRSET   L0099,#$08,LEA9D	; BR IF b3, 

EA8D:            BRSET   L008F,#$40,LEAA9	; BR IF b6, CLEAR Err 77 TIMER & EXIT  
											;
EA91:            BSET    L008F,#$40			; SET b6,
											;
EA94:            BRCLR   L001D,#$20,LEAA9	; BR IF NOT b5,CLEAR Err 77 TIMER & EXIT  

EA98:            BCLR    L001D,#$20			; CLR b5, Err 77 
											;
EA9B:            BRA     LEAA9				; CLEAR Err 77 TIMER & EXIT 
											;
EA9D:  LEA9D     BRSET   L001D,#$20,LEAA9	; BR IF b5, CLEAR Err 77 TIMER & EXIT  

EAA1:            INCA    					; INCR Err 77 TIMER
EAA2:            CMPA    $97,X				; $5B97,1 Sec. CRITERIA FOR ERR 77
EAA4:            BCS     LEAAA				; BR IF ERR TIMER LT THRESH

EAA6:            BSET    L001D,#$20			; SET b5, Err 77, 
											;
EAA9:  LEAA9     CLRA    					; CLEAR Err 77 TIMER
EAAA:  LEAAA     STAA    L0172				; UPDATE Err 77 TIMER

EAAD:  LEAAD     RTS     					
			***********************************************											


			***********************************************
			*
			*
			*
			***********************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EAAE:  LEAAE     BRSET   L003B,#$04,LEAED	; BR IF b2, XMISH DIAG DISABLED

EAB2:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EAB5:            BRCLR   7,X,#$08,LEAE5		;
											;
EAB9:            LDY     L0173				;
EABD:            LDAA    L00AF  			; XMISH TEMP
EABF:            BRCLR   L001D,#$08,LEAD3	;
											;
EAC3:            CMPA    $98,X				; $5B98
EAC5:            BCC     LEAE5				;
											;
EAC7:            INY     					;
EAC9:            CPY     $009A,X			;
EACC:            BCS     LEAE9				;
											;
EACE:            BCLR    L001D,#$08			;
											;
EAD1:            BRA     LEAE5				;
											;
EAD3:  LEAD3     CMPA    $99,X				;
EAD5:            BCS     LEAE5				;
											;
				;
				; CURRENT ERR WD 6
				; $F5
				;
EAD7:            BRSET   L001B,#$40,LEAE5	; BR IF b6, ERR 58, XMISH TEMP HI
											;
EADB:            INY     					; 
EADD:            CPY     $009A,X			;
EAE0:            BCS     LEAE9				;
											;
EAE2:            BSET    L001D,#$08			;
											;
EAE5:  LEAE5     LDY     #$0000				;
EAE9:  LEAE9     STY     L0173				;
EAED:  LEAED     RTS     					;
											;

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EAEE:  LEAEE     BRSET   L003B,#$04,LEB2E	; BR IF b2, XMISH DIAG DISABLED

EAF2:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EAF5:            BRCLR   7,X,#$04,LEB2A		;
											;
EAF9:            LDAA    L0175				;
EAFC:            BRCLR   L0098,#$01,LEB04	;
											;
EB00:            BRCLR   L0098,#$20,LEB1E	;
											;
EB04:  LEB04     BRSET   L0090,#$01,LEB2A	;
											;
EB08:            BSET    L0090,#$01			;
			
			;-----------------------------------------
			;
			;
			;-----------------------------------------										
EB0B:            BRCLR   L001D,#$04,LEB2A	;
											;
EB0F:            LDAB    L002B              ; ERR 81 CNT'R
EB11:            CMPB    $9D,X				;
EB13:            BCC     LEB2A				;
											;
EB15:            INCB    					;
EB16:            INCB    					;
EB17:            STAB    L002B              ; ERR 81 CNT'R
EB19:            BCLR    L001D,#$04			;
											;
EB1C:            BRA     LEB2A				;
											;
EB1E:  LEB1E     BRSET   L001D,#$04,LEB2A	;
											; 
EB22:            INCA    					;
EB23:            CMPA    $9C,X				;
EB25:            BCS     LEB2B				;
											;
EB27:            BSET    L001D,#$04			;
											;
EB2A:  LEB2A     CLRA    					;
EB2B:  LEB2B     STAA    L0175				;

EB2E:  LEB2E     RTS     					
			;-----------------------------------------
			

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EB2F:  LEB2F     BRSET   L003B,#$04,LEB6F	; BR IF b2, XMISH DIAG DISABLED

EB33:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EB36:            BRCLR   7,X,#$02,LEB6B		;
											;
EB3A:            LDAA    L0176				;
EB3D:            BRCLR   L0098,#$01,LEB45	;

EB41:            BRCLR   L0098,#$10,LEB5F	;

EB45:  LEB45     BRSET   L0090,#$02,LEB6B	;

EB49:            BSET    L0090,#$02			; SET b1


			;----------------------------------------
EB4C:            BRCLR   L001D,#$02,LEB6B	;
											;
EB50:            LDAB    L002C              ; ERR 82 CNT'R
EB52:            CMPB    $9F,X				;
EB54:            BCC     LEB6B				;
											;
EB56:            INCB    					;
EB57:            INCB    					;
EB58:            STAB    L002C              ; ERR 82 CNT'R
EB5A:            BCLR    L001D,#$02			;
											;
EB5D:            BRA     LEB6B				;
											; 
EB5F:  LEB5F     BRSET   L001D,#$02,LEB6B	;
											;
EB63:            INCA    					;
EB64:            CMPA    $9E,X				;
EB66:            BCS     LEB6C				;
											;
EB68:            BSET    L001D,#$02			; SET b1
											;
EB6B:  LEB6B     CLRA    					;
EB6C:  LEB6C     STAA    L0176				;

EB6F:  LEB6F     RTS     					
			;-----------------------------------------
											

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EB70:  LEB70     BRSET   L003B,#$04,LEBB0	; BR IF b2, XMISH DIAG DISABLED

EB74:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EB77:            BRCLR   7,X,#$01,LEBAC		;
											;
EB7B:            LDAA    L0177				;
EB7E:            BRCLR   L0098,#$01,LEB86	;
											;
EB82:            BRSET   L0098,#$30,LEBA0	;
											;
EB86:  LEB86     BRSET   L0090,#$04,LEBAC	;
											;
EB8A:            BSET    L0090,#$04			; SET b2
			
			
			;-----------------------------------------
EB8D:            BRCLR   L001D,#$01,LEBAC	; BR IF NOT b0

EB91:            LDAB    L002D              ; ERR 83 CNT'R
EB93:            CMPB    $A1,X				;
EB95:            BCC     LEBAC				;
											;
EB97:            INCB    					;
EB98:            INCB    					;
EB99:            STAB    L002D              ; ERR 83 CNT'R
EB9B:            BCLR    L001D,#$01			; CLR b0,
											
EB9E:            BRA     LEBAC				
											
EBA0:  LEBA0     BRSET   L001D,#$01,LEBAC	;

EBA4:            INCA    					;
EBA5:            CMPA    $A0,X				;	
EBA7:            BCS     LEBAD				;

EBA9:            BSET    L001D,#$01			; SET b0
											; 
EBAC:  LEBAC     CLRA    					;
EBAD:  LEBAD     STAA    L0177				;

EBB0:  LEBB0     RTS     					;
			;-----------------------------------------
											

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EBB1:  LEBB1     BRSET   L003B,#$04,LEC13	; BR IF b2, XMISH DIAG DISABLED

EBB5:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EBB8:            BRCLR   8,X,#$04,LEC13		;
											;
EBBC:            BRSET   L0090,#$40,LEBD6	;
											;
EBC0:            BSET    L0090,#$40			;
		
			;-----------------------------------------
EBC3:            BRCLR   L001E,#$04,LEC13	;
											;
EBC7:            LDAB    L0031				; ERR 89 CNT'R
EBC9:            CMPB    $B8,X				;
EBCB:            BCC     LEC13				;
											;
EBCD:            INCB    					;
EBCE:            INCB    					;
EBCF:            STAB    L0031				; ERR 89 CNT'R
EBD1:            BCLR    L001E,#$04			;
											;
EBD4:            BRA     LEC13				;
											;
EBD6:  LEBD6     BRSET   L001E,#$04,LEC13	; BR IF b2, 

EBDA:            LDAA    L0144				;
EBDD:            ASLA    					;
EBDE:            BCS     LEBE1				;

EBE0:            ASLA    					;
EBE1:  LEBE1     BCC     LEBE5				;

EBE3:            LDAA    #$FF				;

EBE5:  LEBE5     LDY     #$B74F				;
EBE9:            LDAB    L0099				;
EBEB:            ANDB    #$06				;
EBED:            ABY     					;
EBEF:            LDY     0,Y				;
EBF2:            CMPA    $14,Y				;
EBF5:            BLT     LEC13				;

EBF7:            LDAB    L00D3				; GEAR NUMBER
EBF9:            DECB    					;
EBFA:            BMI     LEC13				;

EBFC:            BNE     LEC15				;

EBFE:            LDAB    L0132				;
EC01:            CMPB    $B2,X				;
EC03:            BLS     LEC4E				;

EC05:            JSR     LEC4F				;
											;
EC08:            BCS     LEC4E				;

EC0A:            LDAA    L0032              ; ERR 89 CNT'S
EC0C:            INCA    					;
EC0D:            CMPA    $B5,X				;
EC0F:            BCC     LEC4B				;

EC11:            STAA    L0032              ; ERR 89 CNT'S
EC13:  LEC13     BRA     LEC4E				;
											



EC15:  LEC15     CMPB    #$01				;
EC17:            BNE     LEC30				;
											;
EC19:            LDAB    L0133				;
EC1C:            CMPB    $00B3,X			;
EC1E:            BLS     LEC4E				;
											;
EC20:            JSR     LEC4F				;
											;
EC23:            BCS     LEC4E				;
											;
EC25:            LDAA    L0033              ; ERR 89 CNT'R
EC27:            INCA    					;
EC28:            CMPA    $B6,X				;
EC2A:            BCC     LEC4B				;
											;
EC2C:            STAA    L0033              ; ERR 89 CNT'R
EC2E:            BRA     LEC4E				;
											

EC30:  LEC30     CMPB    #$0002				;
EC32:            BNE     LEC4E				;
											;
EC34:            LDAB    L0134				;
EC37:            CMPB    $B4,X				;
EC39:            BLS     LEC4E				;
											;
EC3B:            JSR     LEC4F				;
											;
EC3E:            BCS     LEC4E				;
											;
EC40:            LDAA    L0034				; ERR 89 CNT'R
EC42:            INCA    					;
EC43:            CMPA    $B7,X				;
EC45:            BCC     LEC4B				;
											;
EC47:            STAA    L0034				; ERR 89 CNT'R
EC49:            BRA     LEC4E				;
											;
EC4B:  LEC4B     BSET    L001E,#$04			;
											
EC4E:  LEC4E     RTS     					
				*******************************************


				*******************************************
				*  TRANSMISSION
				*  
				*
				*******************************************
EC4F:  LEC4F     SEC     					;
				;
				; CURRENT ERR WD 6
				; $F5
				;
EC50:            BRSET   L001B,#$40,LEC7E	; BR IF b6, ERR 58, XMISH TEMP HI

EC54:            BRSET   L001B,#$20,LEC7E	;

EC58:            LDAB    L00AF  			; XMISH TEMP
EC5A:            CMPB    $AF,X				;
EC5C:            BCS     LEC7E				;
											;
EC5E:            SEC     					;
EC5F:            BRSET   L0016,#$01,LEC7E	; BR IF b0, ERR 21, TPS SENSOR HIGH


				;
				; CURRENT ERR WD 2
				; $F5
				;
EC63:            BRSET   L0017,#$80,LEC7E	; BR IF b7, ERR 22, LOW TPS

EC67:            LDAB    L00AC				;
EC69:            CMPB    $B0,X				;
EC6B:            BCS     LEC7E				;
											;
EC6D:            SEC     					;

				;
				; CURRENT ERR WD 2
				; $F5
				;
EC6E:            BRSET   L0017,#$20,LEC7E	; BR IF b5, ERR 24, LOW Vss

EC72:            BRSET   L001C,#$04,LEC7E	; BR IF b2,

EC76:            BRSET   L001C,#$01,LEC7E	; BR IF b0,

EC7A:            LDAB    L00D1				; FILT  Vss
EC7C:            CMPB    $B1,X				;

EC7E:  LEC7E     RTS     					
											;
EC7F:  LEC7F     RTS     					;
				*******************************************


				*******************************************
				*  TRANSMISSION
				*  ERR 66,  3 -> 2 SHIFT QUAD DVR FAIL
				*
				*******************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EC80:  LEC80     BRSET   L003B,#$04,LECCC	; BR IF b2, XMISH DIAG DISABLED

EC84:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EC87:            BRCLR   6.X,#$80,LECC8		; BR IF NOT b7

EC8B:            LDAA    L0169				; ERR 66 TIMER
											;
EC8E:            BRCLR   L0084,#$10,LECAF	; BR IF NOT b4, 

EC92:            BCLR    L0084,#$10			;
											;
EC95:            BRSET   L0090,#$80,LECC8	; BR IF b7,

EC99:            BSET    L0090,#$80			; SET b7
											;
EC9C:            BRCLR   L001C,#$80,LECC8	; BR IF b7, ERR 66

ECA0:            LDAB    L0026              ; ERR 66 CNT'R
ECA2:            CMPB    $72,X				; $5B72, 255 ERR CNTS MIN TO SET ERR 66 
ECA4:            BCC     LECC8				; BR IF ERR CN'R GT THRESH

ECA6:            INCB    					; INCR ERR CNT'R
ECA7:            INCB    					;
ECA8:            STAB    L0026              ; UP DATE ERR 66 CNT'R
ECAA:            BCLR    L001C,#$80			; CLR b3, ERR 66 
											;
ECAD:            BRA     LECC8				; CLR ERR 66 TIMER & EXIT

											
ECAF:  LECAF     BRSET   L001C,#$80,LECC8	; BR IF b7, ERR 66

ECB3:            BRSET   L0093,#$08,LECC8	; BR IF b3

ECB7:            BRSET   L007F,#$80,LECC8	; BR IF b7

ECBB:            TST     L0118				;
ECBE:            BNE     LECC8				;

ECC0:            INCA    					; INCR ERR 66 TIMER
ECC1:            CMPA    $71,X				; $5B71, 4 SEC CRITERIA FOR ERR 66 
ECC3:            BCS     LECC9				; BR IF ERR 66 TIMER LT THRESH

ECC5:            BSET    L001C,#$80			; SET b7, ERR 66
											;
ECC8:  LECC8     CLRA    					; CLR ERR 66 TIMER
ECC9:  LECC9     STAA    L0169				; UPDATE ERR 66 TIMER

ECCC:  LECCC     RTS     					
			***********************************************


			***********************************************
			*  TRANSMISSION
			*  ERR 67,  TCC ENAB QUAD DVR FAIL
			*
			***********************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
ECCD:  LECCD     BRSET   L003B,#$04,LED09	; BR IF b2, XMISH DIAG DISABLED

ECD1:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
ECD4:            BRCLR   6,X,#$40,LED05		; $5B06, BR IF NOT b6, ERR 67,
											;			(TCC ENAB QUAD DVR FAIL)

ECD8:            LDAA    L016A				; UP DATE ERR 67 TIMER
											;
ECDB:            BRCLR   L0085,#$02,LECF9	; BR IF NOT b1, (TCC ENABLE SOLENIOD)

ECDF:            BRSET   L008F,#$80,LED05	; BR IF b7,

ECE3:            BSET    L008F,#$80			; SET b7
											;
ECE6:            BRCLR   L001C,#$40,LED05	; BR IF NOT b6, ERR 67

ECEA:            LDAB    L0027              ; ERR 67 CNT'R
ECEC:            CMPB    $74,X				; $5B74,  255 ERR CNTS MIN TO SET ERR 67
ECEE:            BCC     LED05				; BR IF ERR CNT'R GT THRESH

ECF0:            INCB    					; INCR ERR 67 CNT'R
ECF1:            INCB    					;
ECF2:            STAB    L0027              ; UPDATE ERR 67 CNT'R
											;
ECF4:            BCLR    L001C,#$40			; CLR b6, ERR 67 
											
ECF7:            BRA     LED05				
											

ECF9:  LECF9     BRSET   L001C,#$40,LED05	; BR IF b6, ERR 67 
			
ECFD:            INCA    					; INCR TIME CRITERIA FOR ERR 67
ECFE:            CMPA    $73,X				; $5B73, 2 SEC CRITERIA FOR ERR 67
ED00:            BCS     LED06				; BR IF TIME LT THRESH

ED02:            BSET    L001C,#$40			; SET b6, ERR 67
											;
ED05:  LED05     CLRA    					; ZERO  ERR 67 TIMER
ED06:  LED06     STAA    L016A				; UP DATE ERR 67 TIMER

ED09:  LED09     RTS     					
			***********************************************
											


			***********************************************
			*  ERR 68 ROUTINE
			*
			*  TRANSMISSION SLIPPING, (TCC OFF)
			***********************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
ED0A:  LED0A     BRSET   L003B,#$04,LED62	; BR IF b2, XMISH DIAG DISABLED

ED0E:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
ED11:            BRCLR   6.X,#$20,LED5E		; $5B06, BR IF NOT b4,  ERR 69, TCC ON

ED15:            LDAA    L016B				; ERR 68 TIMER
											;
ED18:            BRSET   L008F,#$04,LED32	; BR IF b2, 
											; 
ED1C:            BSET    L008F,#$04			; SET b2,
											;
ED1F:            BRCLR   L001C,#$20,LED5E	; BR IF NOT b5,

ED23:            LDAB    L0028              ; ERR 68 CNT'R
ED25:            CMPB    $79,X				; $5B79, IF ERR CNT'R G.T. 10 THE SET ERR 68 
ED27:            BCC     LED5E				; BR IF ERR CNT'R GT THRESH

ED29:            INCB    					; INCR ERR COUNTER 
ED2A:            INCB    					;
ED2B:            STAB    L0028              ; UP DATA ERR 68 CNT'R 
											;
ED2D:            BCLR    L001C,#$20			; CLR b5
											
ED30:            BRA     LED5E	
			
											
ED32:  LED32     BRSET   L001C,#$20,LED5E	; BR IF b5,

ED36:            LDY     L00E5				; TCC SLIP
ED39:            CPY     $75,X				; $5B75, IF SLIP G.T. 100 RPM, TCC NOT LOCKED
ED3C:            BLT     LED5E				;

ED3E:            BRCLR   L0085,#$20,LED5E	; BR IF NOT b5, (TCC is in lock adj mode) 

ED42:            LDAB    L00D3				; GEAR NUMBER
ED44:            BEQ     LED5E				; BR IF = Z

ED46:            BRSET   L001C,#$08,LED5E	; BR IF b3

ED4A:            BRSET   L001C,#$01,LED5E	; BR IF b0
	

				;
				; CURRENT ERR WD 2
				; $F5
				;
ED4E:            BRSET   L0017,#$02,LED5E	; BR IF b1, ERR 28, PRESS SW MANIFOLD

ED52:            BRCLR   L009C,#$0C,LED5E	; BR IF NOT 0000 1100, 

ED56:            INCA    					; INCR ERR TIMER
ED57:            CMPA    $77,X				;
ED59:            BCS     LED5F				; $5B77, (25.5 SECS CRITERIA FOR ERR 68)

ED5B:            BSET    L001C,#$20			; SET b5, (ERR 68)  
											;
ED5E:  LED5E     CLRA    					; CLR ERR 68 TIMER
ED5F:  LED5F     STAA    L016B				; UPDATE ERR 68 TIMER
											
ED62:  LED62     RTS     					
				*******************************************



				*******************************************
				* ERR 69 ROUTINE
				* (TCC ON)
				*******************************************
   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
ED63:  LED63     BRSET   L003B,#$04,LEDD3	; BR IF b2, XMISH DIAG DISABLED

ED67:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;

                        ;
     					; 1101 0110, ERR MASK 7
						;
ED6A:            BRCLR   6,X,#$10,LEDCF		; BR IF NOT b4, (1 = ERR 69, TCC ON)
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED6E:            LDAA    L016C				; ERR 69 TIMER
											;
ED71:            BRSET   L008F,#$08,LED81	; BR IF b3,

ED75:            BSET    L008F,#$08			; SET b3,
											;
ED78:            BRCLR   L001C,#$10,LEDCF	; BR IF NOT b4, 
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED7C:            BCLR    L001C,#$10			; CLR b4,
											
ED7F:            BRA     LEDCF				; CLR ERR 69 TIMER & EXIT via RTS
											
			
			;---------------------------
			; CHECK TCC SLIP PARAM'S
			; ERR 69,  TCC ON
			;---------------------------											
ED81:  LED81     BRSET   L001C,#$10,LEDCF	; BR IF b4,
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED85:            BRSET   L001C,#$04,LEDCF	; BR IF b2, 
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED89:            LDY     L00E5				; TCC SLIP
ED8C:            CPY     $7C,X				; $5B7C, (IF SLIP L.T or E.Q. -20 RPM,
											;		  TCC UN-LOCKED)
ED8F:            BLE     LEDCF				; BR IF TCC SLIP 
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED91:            CPY     $7A,X				; $5B7A, ( IF SLIP G.T. 20 RPM, TCC UN-LOCKED
ED94:            BGE     LEDCF				; BR IF TCC SLIP
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED96:            LDAB    L00AC				;
ED98:            CMPB    $7F,X				; $5B7F, IF TPS L.T oR E.Q 25% DISABLE ERR 69 
ED9A:            BLS     LEDCF				; BR IF TCC SLIP
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

ED9C:            BRSET   L0016,#$01,LEDCF	; BR IF b0, ERR 21, TPS SENSOR HIGH
											;		(CLR ERR 69 TIMER & EXIT via RTS) 


				;
				; CURRENT ERR WD 2
				; $F5
				;
EDA0:            BRSET   L0017,#$80,LEDCF	; BR IF b7, ERR 22, LOW TPS
											;		(CLR ERR 69 TIMER & EXIT via RTS) 


                    ;-----------------------------    
					;  TCC MODE WD	     
					;
                    ;  b6 1 = TCC IS BEING APPLIED    
                    ;  b5 1 = TCC IS IN LOCK ADJ MODE   
                    ;  b4 1 = TCC IS IN RELEASE MODE SLIPPING
                    ;-----------------------------    
EDA4:            BRCLR   L0085,#$70,LEDAA	; BR IF NOT b...0111 0000

EDA8:            BRA     LEDCF				; CLR ERR 69 TIMER & EXIT via RT
											


EDAA:  LEDAA     LDAB    L00D3				; GEAR NUMBER
EDAC:            BEQ     LEDCF				; BR IF = Z, (CLR ERR 69 TIMER & EXIT via RTS)

EDAE:            BRSET   L001C,#$08,LEDCF	;
											;
EDB2:            LDY     L019D				; RPM * 8
EDB6:            CPY     $83,X				; $5B83, (IF ENG SPD L.T 300 RPM ENABLE ERR 71)
EDB9:            BLS     LEDCF				; BR IF ENG RPM ...
											;		(CLR ERR 69 TIMER & EXIT via RTS) 
EDBB:            BRSET   L001C,#$01,LEDCF	; BR IF b0, 
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
EDBF:            BRSET   L0017,#$02,LEDCF	; BR IF b1, ERR 28, PRESS SW MANIFOLD
											;		(CLR ERR 69 TIMER & EXIT via RTS) 

EDC3:            BRCLR   L009C,#$0C,LEDCF	;
											;		(CLR ERR 69 TIMER & EXIT via RTS)
 
EDC7:            INCA    					; INCR ERR 69 TIMER
EDC8:            CMPA    $7E,X				; $5B7E, (4 SECS CRITERIA FOR ERR 69)
EDCA:            BCS     LEDD0				; BR IF ERR 69 TIMER LT THRESH

				;
				; SET ERR 69. CLR TIMER & EXIT via RTS 
				;
EDCC:            BSET    L001C,#$10			; SET b4, ERR 69, (TCC ON)
											;
				;
				; CLR ERR 69 TIMER & EXIT via RTS 
				;
EDCF:  LEDCF     CLRA    					; CLR ERR TIMER
EDD0:  LEDD0     STAA    L016C				; ERR 69 TIMER
											;
EDD3:  LEDD3     RTS     					;

EDD4:  LEDD4     RTS     					;
EDD5:  LEDD5     RTS     					;  (NOT USED)
				;-------------------------------------------


   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EDD6:  LEDD6     BRSET   L003B,#$04,LEDFE	; BR IF b2, XMISH DIAG DISABLED

EDDA:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EDDD:            BRCLR   8,X,#$20,LEDFC		;
											;
EDE1:  LEDE1     LDAA    L0179				;
EDE4:            BRSET   L0090,#$10,LEE00	;
											;
EDE8:            BSET    L0090,#$10			;

			;-----------------------------------------
EDEB:            BRCLR   L001E,#$20,LEE3F	; BR IF NOT b5
											;
EDEF:            LDAB    L002F				; ERR 86 CNT'R
EDF1:            CMPB    $A8,X				;
EDF3:            BCC     LEE3F				;

EDF5:            INCB    					;
EDF6:            INCB    					;
EDF7:            STAB    L002F              ; ERR 86 CNT'R
EDF9:            BCLR    L001E,#$20			; CLR b5
											
EDFC:  LEDFC     BRA     LEE3F				
EDFE:  LEDFE     BRA     LEE43				
						
EE00:  LEE00     BRSET   L001E,#$20,LEE3F	; BR IF b5, 

EE04:            LDAB    L00D3				; GEAR NUMBER
EE06:            CMPB    #$01				;
EE08:            BCC     LEE3F				;

EE0A:            LDY     L0190				;
EE0E:            CPY     $A3,X				;
EE11:            BHI     LEE3F				;

EE13:            BRSET   L0016,#$01,LEE3F	; BR IF b0, ERR 21, TPS SENSOR HIGH


				;
				; CURRENT ERR WD 2
				; $F5
				;
EE17:            BRSET   L0017,#$80,LEE3F	; BR IF b7, ERR 22, LOW TPS

EE1B:            LDAB    L00AC				;
EE1D:            CMPB    $A5,X				;
EE1F:            BLS     LEE3F				;


				;
				; CURRENT ERR WD 2
				; $F5
				;
EE21:            BRSET   L0017,#$20,LEE3F	; BR IF b5, ERR 24, LOW Vss

EE25:            BRSET   L001C,#$04,LEE3F	; BR IF b2
											;
EE29:            LDAB    L00D1				; FILT  Vss
EE2B:            CMPB    $A6,X				;
EE2D:            BLS     LEE3F				;
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
EE2F:            BRSET   L0017,#$02,LEE3F	; BR IF b1, ERR 28, PRESS SW MANIFOLD

EE33:            BRCLR   L009C,#$0F,LEE3F	;

EE37:            INCA    					;
EE38:            CMPA    $A7,X				;
EE3A:            BCS     LEE40				;

EE3C:            BSET    L001E,#$20			;
											;
EE3F:  LEE3F     CLRA    					;
EE40:  LEE40     STAA    L0179				;

EE43:  LEE43     RTS     					
			;----------------------------------------------											

   				;
				; SERIAL DATA MD WORD
				; XMISH DIAG DISABLE
				; 
EE44:  LEE44     BRSET   L003B,#$04,LEE6C	; BR IF b2, XMISH DIAG DISABLED

EE48:            LDX     #$5B00             ; INDEX ENGINE DIAGNOSTIC MODE WORD MASKS
											;
EE4B:            BRCLR   8,X,#$10,LEE6A		;
											;
EE4F:            LDAA    L017A				;
EE52:            BRSET   L0090,#$20,LEE6E	;
											;
EE56:            BSET    L0090,#$20			;
											;
			;-----------------------------------------
EE59:            BRCLR   L001E,#$10,LEE6A	; BR IF NOT b4
											;
EE5D:            LDAB    L0030              ; ERR 87 CNT'R
EE5F:            CMPB    $AE,X				;
EE61:            BCC     LEEA5				;
											;
EE63:            INCB    					;
EE64:            INCB    					;
EE65:            STAB    L0030              ; ERR 87 CNT'R
EE67:            BCLR    L001E,#$10			; CLR b4
											
EE6A:  LEE6A     BRA     LEEA5				
											
EE6C:  LEE6C     BRA     LEEA9				
											
EE6E:  LEE6E     BRSET   L001E,#$10,LEEA5	; BR IF b4
											;
EE72:            LDAB    L00D3				; GEAR NUMBER
EE74:            CMPB    #$03				;
EE76:            BCS     LEEA5				;
											;
EE78:            LDY     L0190				;
EE7C:            CPY     $A9,X				;
EE7F:            BCS     LEEA5				;
											;
EE81:            BRSET   L0016,#$01,LEEA5	; BR IF b0, ERR 21, TPS SENSOR HIGH


				;
				; CURRENT ERR WD 2
				; $F5
				;
EE85:            BRSET   L0017,#$80,LEEA5	; BR IF b7, ERR 22, LOW TPS

EE89:            LDAB    L00AC				; 
EE8B:            CMPB    $AB,X				;
EE8D:            BLS     LEEA5				;
											;
EE8F:            LDAB    L00AF  			; XMISH TEMP
EE91:            CMPB    $AC,X				;
EE93:            BLS     LEEA5				;
											;

				;
				; CURRENT ERR WD 2
				; $F5
				;
EE95:            BRSET   L0017,#$02,LEEA5	; BR IF b1, ERR 28, PRESS SW MANIFOLD

EE99:            BRCLR   L009C,#$0F,LEEA5	;

EE9D:            INCA    					;
EE9E:            CMPA    $AD,X				;
EEA0:            BCS     LEEA6				;
											;
EEA2:            BSET    L001E,#$10         ; CURRENT ERR WD #9, SET BIT 4
											;
EEA5:  LEEA5     CLRA    					;
EEA6:  LEEA6     STAA    L017A				;
										   
EEA9:  LEEA9     RTS     				   
			;-----------------------------------------
			
;													   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Lead in for A/D ROUTINE, Single and Multi-channel read													
;  										
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		                                                            
LEEAA	LDX     #L3000			;Index CPU reg.
	LDAA    #$07			;0000 0111				
	JSR     LEF12			;Port D config routine
;
	LDAA    #$01			;0000 0001
	JSR     LEEFC			;A/D channel routine
;									
	LDAA    $34,X			;Get A/D results
	STAA    L082D          		;A/D cool temp
;		
	LDAA    #$06			;0000 0110				
	JSR     LEF12			;Port D config routine
;
	LDAA    #$01			;
	JSR     LEEFC			;A/D channel routine
;											;
	LDAA    $34,X			;Load ch 1 results
	STAA    L0192			;Save it, A/D TPS		
											;
	LDAA    #$01			;
	BSR     LEF12   		;Port D config routine
;											;
	LDAA    #$11			;0001 0001, Set A/D to multi-channel read 								
	BSR     LEEFC			;Go do A/D conversion
;
;-Get each of the results in
;
	LDAA    $32,X			;Get channel 1 results
	STAA    L082F			;Save it, ALDL switch voltage
	LDAA    $33,X			;Get channel 2 retults
	STAA    L009F  			;Save it, A/D transmission temp
	LDAA    $34,X			;Get channel 3 results
	STAA    L00A1			;A/D battery voltage
	BRA     LEEFB			;Bra to return
; 											
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Lead in for A/D routine, Multi-channel read										
;										
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEEE2	LDX     #L3000			;Base reg. address
	LDAA    #$14			;0001 0100, Set up for multi-channel read
	BSR     LEEFC			;A/D routine
;											;
	LDAA    $31,X			;Get channel 4 results
	STAA    L00A0          		;A/D TPS
	BRSET   L0050,#$01,LEEF6	;Bra if b0==1, sync. MAP sensor reads
											;
	LDAA    $32,X			;Get channel 5 results
	STAA    L082E			;A/D MAP voltage
											;
LEEF6	LDAA    $33,X			;Get A/D channel 6 results
LEEF8	STAA    L01F8			;A/D O2 voltage
LEEFB	RTS 				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; A/D Routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
; Channel 0=K/S diag. volts
; Channel 1=ALDL voltage
; Channel 2=A/D fuel pump volts
; Channel 3=
; Channel 4=A/D TPS voltage
; Channel 5=A/D MAP voltage
; Channel 6=A/D O2 voltage
; Channel 7=Force motor current
;
LEEFC	BCLR	L001A,#$02		;Clear b1, ERR 55, faulty PCM 11										;
	STAA    L3030			;Save A, A/D Contorl/Satus reg. 
					; b7=Conversion complete flag
					; b6= -
					; b5=Continuous scan control
					; b4=Multiple/Single channel control
					; b3=Channel select D
					; b2=Channel select C
					; b1=Channel select B
					; b0=Channel select A
;
	LDAB    #12			;A/D wait for data timer counter
											
LEF04	BRSET   $30,X,#$80,LEF11	;Bra if b7==1, A/D conversion complete
;
	DECB				;-1    
	BNE     LEF04			;Bra if !=0, continue
;
;-Here if A/D conversion failed
;
	BSET    L003A,#$01		;Status word, set b0=A/D failure
	BSET    L001A,#$02      	;SET b1, ERR 55, faulty PCM 11
;
;Here if A/D successful
;
LEF11	RTS				;Return with data
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;                                                            
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Port D configuration routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEF12	BCLR    8,X,#$38		;Clear b3-b5, 0x3008, (PORT D data)
	ASLA 				;Shift left   					
	ASLA  				;Shift left  					
	ASLA 				;Shift left   					
	ORAA    8,X			;				
	STAA    8,X			;Store it				
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; BLM reset routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEF1D	LDX     #$02D6			;Start of BLM cells
	LDAA    #128			;Neutral BLM value
;
LEF22	STAA    0,X			;Reset cell
	INX 				;+1, adv. to next cell    
	CPX     #$02EA			;Last cell to clear
	BLS     LEF22			;Bra if <, continue
;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~
;
; BLM clamp routine
;
;~~~~~~~~~~~~~~~~~~~~~
;
LEF2B	LDAA    L48F3			;Upper limit for BLMs
	LDAB    L48F4			;Lower limit for BLMs
;
	LDX     #L02D6			;Addr of first BLM cell
LEF34	CMPA    0,X			;Compare upper lim. to BLM
	BCC     LEF3A			;Bra if BLM less
;
	STAA    0,X			;Save upper limit instead
;
LEF3A	CMPB    0,X			;Compare lower lim. to BLM
	BLS     LEF40			;Bra if lower limit is less
;
	STAB    0,X			;Save lower limit instead
;
LEF40   INX				;+1, advance to next cell
	CPX     #L02EA			;Last BLM cell
	BLS     LEF34			;Bra if not at last cell yet, continue
;
	RTS  				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;                                                            
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Checksum routine
;
; ENTER WITH:
;	 X pointing to start of checksum area
;
; EXIT WITH:
;	Results of checksum in Y
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEF47	LDY     #0			;Preclear Y
	PSHX   				;Start address to stack 
	PULA				;Get MSB of start address off stack    
	PULA 				;Get LSB of start address off stack    
	CLRB				;Clear B, LSB x 256    
	LSRD 				;/2   
	LSRD 				;/2   
	LSRD				;/2, now address/8 for block transfer    
	PSHA				;MSB of lower addressb byte to stack    
	TBA  				;Get LSB into A   
	BEQ     LEF5F			;Bra if ==0, no leftovers, use block checksum
;
;-Single byte checksum
;
LEF56	LDAB    0,X			;Load up byte
	ABY  				;Add it into the checksum   
	INX 				;+1, next address    
	ADDA    #$20			;
	BNE     LEF56			;Bra if !=0
;
;-Block checksum
;
LEF5F	LDAB    #$08			;8 byte offset
	PULA  				;Get MSB of start area to clear  
;
LEF62	XGDY				;Swap Y and D, checksum in D
	ADDB    0,X			;Add in first address
	ADCA    #0			;Perform carry if needed
	ADDB    1,X			;Add in next address
	ADCA    #0			;
	ADDB    2,X			;
	ADCA    #0			;
	ADDB    3,X			;
	ADCA    #0			;
	ADDB    4,X			;
	ADCA    #0			;
	ADDB    5,X			;
	ADCA    #0			;
	ADDB    6,X			;
	ADCA    #0			;
	ADDB    7,X			;Add in last address
	ADCA    #0			;
	XGDY				;Swap Y and D back    
	ABX				;Add in offset, move to next block of memory     
	INCA 				;+1, moved to next block   
	BNE     LEF62			;Bra if no roll-over, continue, else do COP
;
;-Do COP
;
	LDAA    #$55			;0101 0101
	STAA    L303A			;Save it, COP reset
	COMA 				;Toggle bits   
	STAA    L303A			;Save it, COP reset
	CLRA 				;clear A   
	CPX     #0              	;Check for roll-over
	BNE     LEF62			;Bra if no roll-over, continue
;
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; RAM clear routine
;
; Enter:
;
;	X=Start address
;	D=Number of bytes to clear
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEF9A	BITB    #$07			;Test b0, b1, b2
	BEQ     LEFA8			;Bra if b0, b1, b2==0, do mass clear of RAM
;
;-Here to clear byte at a time
;
	CLR     0,X			;Clear address
	INX 				;+1, advance to next address
	SUBD    #1			;-1 from remaining bytes to clear
	BNE     LEF9A			;Bra if !=0, still bytes remaining
;
	BRA     LEFC2			;Bra to return
;
;-Here to clear 8 byte blocks of RAM
;
LEFA8	LSRD				;/2   
	LSRD 				;/2   
	LSRD				;/2    
	TBA 				;Get LSB into A    
	LDAB    #$08			;Clearing  8 byte blocks
	LDY     #$0000 			;Preclear ind. reg. Y
LEFB2	STY     0,X			;clear byte 1,2
	STY     2,X			;clear byte 3,4
	STY     4,X			;ckear byte 5,6
	STY     6,X			;clear byte 7,8
	ABX   				;Add in offset, next block to clear  
	DECA    			;-1 from blocks remaining to clear
	BNE     LEFB2			;Bra if blocks remaining to clear
;
LEFC2	RTS 				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	            
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; RAM checksum routine
; check $000A-$0014, Error words
;
; ENTER WITH:
;	-
; EXIT WITH:
;	A = checksum
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEFC3	LDX     #$0014			;Point to upppermost address to check
	LDAB    #10			;# of bytes to check
	CLRA				;Preclear A    
LEFC9	SUBA    0,X			;- value of RAM addr.
	DEX				;-1, go to previous byte     
	DECB				;-1, byte counter   
	BNE     LEFC9			;Bra if !=0, continue
;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~				     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to clear error flags/timers
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEFD0	LDX     #L0009			;Error word #9
	LDY     #LF01C			;Start of error masks 
;
;-Loop here to clear error words
;
LEFD7	LDAA    $0A,X			;Load error word 
	ANDA    0,Y			;And with mask
	STAA    $0A,X			;Save it
;
	LDAA    $15,X			;Load error word 
	ANDA    0,Y			;And with mask
	STAA    $15,X			;Save it
										
	LDAA    $55,X			;HU error word?
	ANDA    0,Y			;And with mask
	STAA    $55,X			;Save it
	DEY				;-1, move to next error word masks
	DEX				;-1, move to next error words
	BNE     LEFD7			;Bra if !=0, not done
;
	BCLR    L0004,#$80		;Error word #4, clear b6, Err 42, EST
	BCLR    L0044,#$80		;Status word, clear b7, EST failure flag
	BCLR    L0072,#$01		;
	BCLR    L006F,#$10		;
	BCLR    L0070,#$01		;Status word, clear b0, Err 32, EGR 										; 
	CLRA				;Preclear A
	STAA    L001F			;Err 21 counter 
	STAA    L0020			;Err 22 counter
	STAA    L0817			;Err 16 timer
	STAA    L023F			;Err 13 timer
	STAA    L081C			;Err 24 timer
	JSR     LEFC3			;Perform checksum
;
	STAA    L0015			;Diagnostic checksum
	RTS				;Return     					
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Error masks for clearing error flags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Mask			;Error word #
;
LF014	FCB	$0E		;1
LF015	FCB	$0F		;2
LF016	FCB	$03		;3
LF017	FCB	$81		;4
LF018	FCB	$D9		;5
LF019	FCB	$FF		;6
LF01A	FCB	$FF		;7
LF01B	FCB	$FF		;8
LF01C	FCB	$FF		;9
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF01D	LDX	#L0009			;Start of error words   
	LDY     #LF080			;Error word masks
;
;-Loop here to clear error words
;
LF024	LDAA    $0A,X			;Load error word 
	ANDA    0,Y			;And with mask
	STAA    $0A,X			;Save it
;
	LDAA    $15,X			;Load error word 
	ANDA    0,Y			;And with mask
	STAA    $15,X			;Save it
;						
	DEY				;-1, move to next error word masks
	DEX				;-1, move to next error words   
	BNE     LF024			;Bra if !=0, continue
;
	BCLR    L008E,#$F0			; CLR 1111 0000
F03A:            BCLR    L008A,#$80			; BR b7





		;-------------------------------

		;-------------------------------
		;
		;
		;-------------------------------
F03D:            CLRA    
F03E:            STAA    L001F				; ERR 21 CNT'R
F040:            STAA    L0020              ; ERR 22 CNT'R
F042:            STAA    L0021              ; ERR 24 CNT'R, LO OUT XMISH SPD
F044:            STAA    L0022              ; ERR 28 CNT'R
F046:            STAA    L0023              ; ERR 37 CNT'R, BRAKE STUCK ON
F048:            STAA    L0024              ; ERR 38 CNT'R, BRAKE STUCK OFF
F04A:            STAA    L0026              ; ERR 37 CNT'R, 3 -> 2 SHFT QUAD DVR FAIL
F04C:            STAA    L0027              ; ERR 67 CNT'R, TCC ENAB QUAD DVR FAIL
F04E:            STAA    L0028              ; ERR 68 CNT'R
F050:            STAA    L0029              ; ERR 72 CNT'R
F052:            STAA    L002A              ; ERR 73 CNT'R, FORCE MOTOR CURREN
F054:            STAA    L002B              ; ERR 81 CNT'R, QUAD DVR 1 & SHFT B ERR
F056:            STAA    L002C              ; ERR 82 CNT'R, QUAD DVR 1 & SHFT A ERR
F058:            STAA    L002D              ; ERR 83 CNT'R, QUAD DVR 1 ERR
F05A:            STAA    L002F				; ERR 87 CNT'R,	LO RATIO
F05C:            STAA    L0030              ; ERR 87 CNT'R, HI RATIO
F05E:            STAA    L0031				; ERR 89 CNT'R, MAX ADPT LONG SHIFT

F060:            STAA    L017B				; ERR 37 TIMER
F063:            STAA    L017C
F066:            STAA    L017D
F069:            STAA    L017E
F06C:            STAA    L0032              ; ERR 89 CNT'S
F06E:            STAA    L0033              ; ERR 89 CNT'R
F070:            STAA    L0034				; ERR 89 CNT'R

F072:            JSR     LEFC3

F075:            STAA    L0015	            ; DIAGNOSTIC CKSUM

F077:            RTS     
			;----------------------------------------------


;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF078	FCB	$9E
LF079	FCB	$5D
LF07A	FCB	$FC
LF07B	FCB	$7F
LF07C	FCB	$E7
LF07D	FCB	$99
LF07E	FCB	$00
LF07F	FCB	$50
LF080	FCB	$8B
;
;~~~~~~~~~~~~~~~~~~
;
; Hardware routine
;
;~~~~~~~~~~~~~~~~~~~
;    
LF081	LDAA	L3066			;Hardware	
	EORA	#$80			;Toggle b7
	STAA	L3066			;Save it, hardware	    
	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~
;
; Provide short delay
;
;~~~~~~~~~~~~~~~~~~~~~
;
LF08A	RTS			;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
;
;~~~~~~~~~~~~~~
;
; I/O routine
;
;~~~~~~~~~~~~~~
;
LF08B	SEI				;Disable interrupts     
	LDD     L3FFC			;I/O D port
	JSR     LF08A			;Delay


	ORAB    #$08			;Set b3,
	BRCLR   L0072,#$80,LF09A	;Bra if b7==0

	ANDB    #$F7			;Clear b3
;
LF09A	STD     L3FFC          		;Save, I/O port D
	LDAA    L3060			;
	ANDA    #$6F			;Mask, 0110 1111
	LDAB    L004B			;
	ANDB    #$90			;Mask, 1001 0000
	STAB    L3060			;
	ABA				;
	STAA    L004B			;
;
;-Output to I/O port D
;											
	LDAA    L004C			;I/O port D word
	STAA    L3062			;Save, I/O PORT D
;
;-Read in I/O port C
;							
	LDAA    L3064			;I/O port C
	STAA    L004D			;I/O port C word
;											
	LDAA    L004E			;
	STAA    L3067			;
;
	CLI				;Enable interrupts
	RTS				;Return 			    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Entry point for filtering signed values
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Get difference between current and previous filtered value
;
LF0BD	PSHX 				;Push old value to stack
	TSX				;Get current stack pointer into X
	SUBD    0,X			;Subtract old filtered value from current value
	PSHB				;Push LSB to stack
	BLT     LF0CA			;Bra if result was < zero
;
;-Result was >= 0
;
	LDAB    0,Y			;Load filter coeff.
	MUL				;Filter coeff. x MSB delta value
	BRA     LF0E4			;Bra to continue
;
;-Result < 0
;	
LF0CA	LDAB    0,Y			;Load filter coeff.
	MUL				;Filter coeff x MSB of delta value
	SUBA    0,Y			;Subtract filter coeff.
	BRA     LF0E4			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
; Filter routine
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
; Enter with:
;	D = New value 
;	X = Old value 
;	Y = Addr. of filter coeff
;
; Exit with:
;	D = Filtered value
;
;-General form: D =Old value + Filter coeff x (New value - Old value)  
;
LF0D3	PSHX				;Old value to the stack
	TSX 				;Get current stack pointer into X
	SUBD    0,X			;New value - old value 
	PSHB				;LSB to stack
	LDAB    0,Y			;Load filter coeff
	BCS     LF0E0			;Bra if old value was greater
;							
;-Here if new value >= old value
;				
	MUL				;MSB of Delta value x filter coeff.
	BRA     LF0E4			;
;
;-Here if new value < old value
;											
LF0E0	MUL				;-MSB of Delta value x filter coeff
	SUBA    0,Y			;-filter coeff x 256, perform 2's comp., change sign
;
LF0E4	ADDD    0,X			;Add in old value
;
	STD     0,X			;Save result to the stack in place of old value
	PULA				;Get LSB of delta value back
	LDAB    0,Y			;Load filter coeff.
	MUL				;LSB x filter coeff.
	ADCA    1,X			;Add in LSB of previous result on stack and round if needed
	TAB				;MSB of (LSB x filter coeff) to B
	LDAA    0,X			;Load up MSB of previous result on stack
	ADCA    #0			;Perform carry from previous addition op. if applicable
;
;-Clean up the stack
;
	PULX				;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
; Lag filter routine
;
; Enter with:
;  A = New value
;  B = Filter coeff.
;  X = Old value
;
; Exit with:
;  AB = filtered value
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Filtered value = old value + FC x (new value - old value)
;
LF0F6	PSHB				;Filter coeff. to stack
	PSHX				;Previous filtered value to stackl
	TSX				;Get current stack pointer
	SUBA    0,X			;New value - MSB old value
	BCS     LF100			;Bra if new value <
;
;-New value is greater then previous here
;											
	MUL				;Delta x filter coeff
	BRA     LF103			;Bra to continue
;
;-New value is less then previous here
;											
LF100	MUL				;Delta x filter coeff
	SUBA    2,X			;Sub. filter coeff.
;
LF103	PSHA				;Push result to stack
	PSHB				;
	LDD     1,X			;Load LSB of old value + FC
	NEGB				;Change sign of FC
	BEQ     LF10D			;Bra if ==0
;											
	MUL				;LSB Old value x -filter coeff
	ADCA    #0			;Round if needed
;
LF10D	PULB				;Get LSB of previous result off stack
	ABA				;Add it in
	TAB				;REsult to B
	PULA				;Get MSB of result off stack
	ADCA    0,X			;Add in previous value
;
;-Clean up stack
;
	PULX				;Pull X
	INS				;+1, stack pointer
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; RPM filter routine
;
; Enter with:
;  D=Current RPMs
;  X=Addr. of Previous RPMs
;  Y=Addr. of filter coeff
;
; Exit with:
;  D=Filtered RPMs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 
;
;
LF116	SUBD    0,X			;Subtract previous RPMs
	PSHB				;Push LSB of result to stack
	LDAB    0,Y			;Load filter coeff.
	BCS     LF121			;Bra if underflow
;
;-Delta >= 0
;
	MUL				;(MSB of delta rpm) x coeff.
	BRA     LF125			;Bra to continue
;
;-Delta < 0
;
LF121	MUL				;(MSB of delta rpm) x coeff
	SUBA    0,Y			;-coeff., negate, now -coeff. x (65536 - delta)
;
LF125	ADDD    0,X			;Add to previous RPM val
	STD     0,X			;Save it
	PULA				;Get LSB back
	LDAB    0,Y			;coeff.
	MUL				;coeff. x LSB of delta RPMs 
	ADCA    1,X			;Add in LSB from previous calc. with carry
	TAB				;Get LSB of result into B
	LDAA    0,X			;Load MSB of result
	ADCA    #0			;Perform carry if needed
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Entry point for 2D lookup with UL with no offset
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF136     CLRB				;Clear B, no offset
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Entry point for 2D lookup with UL
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF137	CMPA    0,X			;Start address of table upper limit for lookup			
	BLS     LF13D			;Bra if less

	LDAA    0,X			;Load upper limit
LF13D	INX				;+1, go to table
	BSR     LF15A			;Bra to do 2D lookup with SBA
;
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Alternate 2D lookup entry point
;
; Enter with: 
;  A = value used for lookup
;  X = Start addr of table and params
;
; Exit with:
;  A = value from lookup
;
; Table format: 
;  Addr = offset for lookup
;  Addr + 1 = Upper limit for offset value used for lookup 
;  Addr + 2 = # counts per line
;  Addr + 3 = Start of table
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF141	PSHX				;Index to stack
	PSHB				;Push contents of B to stack
;
;-Subtract offset for lookup
;											
	SUBA    0,X			;Subtract offset from val. used for lookup
	BCC     LF148			;Bra if no underflow
;
	CLRA				;Clear underflow
;
;-Check upper limit for offset lookup value
;	
LF148	CMPA    1,X			;Upper limit for offset lookup value
	BLS     LF14E			;Bra if offset lookup value is <=
;
	LDAA    1,X			;Use limit instead
;											
LF14E	LDAB    #2			;2 byte offset
	ABX 				;Add in offset, skip to line count
	BRA     LF155			;Bra to do lookup				
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Entry point for 2D lookup with line count
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LF153	PSHX				;Push addr. to stack
	PSHB				;Pus contents of B to stack
;
LF155	LDAB    0,X			;Load line count
	INX				;+1, adv. to table
	BRA     LF162			;Bra to continue with lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Entry point for 2D lookup with SBA
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF15A	SBA				;subtract offset from value used for lookup
	BCC     LF15E			;Bra if no underflow, do lookup
;
	CLRA  				;Clear underflow  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 2D lookup Routine
;
; Enter with:
;	A=value to use for lookup
;	X=Address of table
;
; Exit with:
;	A=looked up table value
;	B=Previous value on entry
;	X=Previous value on entry 
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF15E	PSHX				;Push table addr. to stack    
	PSHB 				;Push offset to stack 
	LDAB    #$10			;Multiplier for lookup, 16 counts/row
;
;-ALternate entry point
;
LF162	MUL				;Val x multiplier for lookup    
	PSHB				;remainder to stack    
	TAB				;Row offset into B     
	ABX				;Add in offset to X     
	LDD     0,X			;Load in table value and value following that
;
;-Perform interpolate 
;
	SBA 				;Subtract following value to get delta table value     
	PULB 				;Get remainder   
	BCC     LF172			;Bra if underflow, next table value is greater
;
;-Interpolate up
;
	NEGA 				;Make positive again   
	MUL 				;remainder x delta table value    
	ADCA    0,X			;Add in table value to interpolated value and round if needed
	BRA     LF178			;Bra to return
;
;-Interpolate down
;
LF172	MUL  				;remainder x delta table value   
	ADCA    #0			;Round if needed
	NEGA 				;Switch sign   
	ADDA    0,X			;Table value + (-interpolated value)
LF178	PULB				;Restore acc. B    
	PULX 				;Restore acc. X			   
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 3D Lookup Routine
; 
; Enter with:
; 	A=Row value
;	B=Column. value
;	X=Table address
;
; Exit with:
; 	A=value from lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF17B   PSHY				;Reg. Y to stack    
	PSHB				;Col. val. to stack    
	PSHX 				;Table address to stack   
	SUBA    0,X			;Subtract row offset
	BCC     LF184			;Bra if no underflow
;	
	CLRA				;Clear out col. val.
;    
LF184	SUBB    1,X			;Subtract col offset
	BCC     LF189			;Bra if no underflow
;
	CLRB				;Clear underflow 
;   
LF189	PSHX				;Table addr. to stack    
	PULY 				;Get table addr. into Y  
	PSHA				;Row val. to the stack 

	LDAA    #$10			;Mult. for lookup
	MUL				;mult. x col. val, A now offset for lookup, B now remainder     
	PSHB 				;col. remainder to the stack    
	TAB 				;Get MSB into B   
	ABX				;Add the offset into X     
	PULA 				;Get col. remainder into A
	PULB				;Get row value back   
	PSHA				;Put the col. remainder back on the stack
;   
	LDAA    #$10			;mult. for lookup 
	MUL				;row value x mult. for lookup
	PSHB				;row remainder to the stack  
	LDAB    2,Y			;Load # of cols.
	MUL 				;# cols x row offset, skip to row in table    
	ABX				;Add the offset into X     
	PSHX				;Push address (current row) to stack    
	LDAB    2,Y			;Load # cols		
	ABX 				;Add it into X (Now next row)
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Perform interpolation
;~~~~~~~~~~~~~~~~~~~~~~~ 
;
;
;       V1= current stored value in table
;	V2-V4 are values located 
;	around the immediate table
;	value
;
;     -----------------
;   i |   V1  |   V2  |
;     -----------------
; i+1 |   V3  |   V4  |
;     -----------------
;         j      j+1
;
  
	TSY				;Get stack pointer + 1 into Y     
	LDD     3,X			;Get values in next row for interpolation
	SBA 				;Subtract table value in next col. from value in current col., now delta    
	LDAB    3,Y			;Load col. remainder from stack
	BCC     LF1B4			;Bra if delta value was negative
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Interpolate values in next row up
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Interpolate up
;
;	V2 + col. remainder x |(V3-V4)|
;
;
	NEGA				;Make delta positive   
	MUL 				;remainder from col. value x delta  
	ADCA    3,X			;Add it into table value in next row up
	BRA     LF1BA			;Bra
;
;-Interpolate down 
;
;	V2 - col. remainder x |(v3-V4)|
;	
;
LF1B4	MUL				;remainder from col. value x delta     
	ADCA    #0			;round if needed
	NEGA 				;Change sign   
	ADDA    3,X			;Add it into table value in next row up
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Interpolate table values in current row
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF1BA	PULX				;Get current col/row address back    
	PSHA				;Push interpolated table value in next row to stack    
	LDD     3,X			;Get table values in current row		
	SBA				;Subtract table value in next col. from current value     
	LDAB    3,Y			;Load in col. remainder
	BCC     LF1CA			;Bra if next value is less
;											
	NEGA    			;Make positive
;
;-Interpolate up 
;
;	V1 + col. remainder x |(V1-V2)|
;                                            
	MUL				;remainder x delta     
	ADCA    3,X			;Add it into current value
	BRA     LF1D0			;Bra 		
;
;-Interpolate down
;
;	V1 - col. remainder x (V1-V2)
;
LF1CA	MUL				;remainder x delta    
	ADCA    #0			;Round if needed
	NEGA 				;change sign   
	ADDA    3,X			;Add in current value
;
;-Interpolate between the two rows
;
LF1D0	PULB 				;Get interpolated value from next row   
	PSHA				;Push interpolated value from current row to stack    
	SBA				;Current interpolated value - interpolated value in next row 
	LDAB    2,Y			;Load row remainder
	BCC     LF1DF			;Bra if delta was positive
										  
;
;-Interpolate up between rows
;
	NEGA				;change sign    					
	MUL 				;row remainder x delta value    
	ADCA    1,Y			;add to interpolated value in current row
	BRA     LF1E6			;Bra to 
;
;-Interpolate down between rows
;
LF1DF	MUL 				;row remainder x delta value    
	ADCA    #0			;Round up if needed
	NEGA				;change sign   
	ADDA    1,Y			;add it into the current interpolated value
;
;-Clean up the stack and resore X, Y, B
;
LF1E6	INS 				;Inc. stack pointer
	PULX 				;   
	PULX    			;
	PULB    			;
	PULY    			;
	RTS     			;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 8x16 multiply routine, (A x X*)/256
;
; Enter with:
;	A = 8 bit multiplier
;	X = Address of 16 bit multiplicand 
;
; Exit with:
;	AB = (mult. x mult'd) / 256
;
; (*) X points to address of mult'd
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF1ED	PSHA				;Push mult. to stack   
	LDAB    1,X			;Get LSB of multiplicand
	MUL				;LSB x mult.     
	ADCA    #0			;Round if needed
	PULB				;Get multiplier back    
	PSHA				;Save product of LSB x mult., now /256
;  
	LDAA    0,X			;Get MSB of multiplicand
	MUL				;MSB x mult., upper portion of result/256   
	PSHX				;Push address of mult. to stack    
	TSX				;Get current stack pointer into X    
	ADDB    2,X			;Add in (LSB x mult.)/256
	ADCA    #0			;Perform carry if needed
;
;-Clean up the stack
;
	PULX				;Pull contents off stack  
	INS				;+1, reset the stack 			
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 16 x 16 multiply routine   
;
;Enter with:
;
; AB=mult'd
; X=mult.
;
;Exit with:
;
; AB = result = (mult. x mult'd)/256
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF201	PSHA				;Make some space on the stack for tmp storage
	PSHX				;  
	PSHX 				;Push mult'd to stack   
	PSHB				;Push LSB of mult. to stack
	PSHA				;Push MSB of mult. to stack    
	TSX				;Get current stack pointer into X     
	LDAA    3,X			;Get LSB of mult'd
;
;-LSB x LSB
;
	MUL				;LSB of mult. x LSB of mult'd
	ADCA    #0			;Round if needed
	STAA    5,X			;Save result
;
;-LSB x MSB
;
	LDD     1,X			;Get LSB of mult. and MSB of mult'd						            	; & MSB of Mult'cnd in B
	MUL				;LSB mult. x MSB mult'd    
	ADDB    5,X			;Add in previous result
	ADCA    #0			;Perform carry if needed
	STD     4,X			;Save result
;
;-MSB x LSB
;
	LDAA    0,X			;Get MSB of mult.
	LDAB    3,X			;Get LSB of mult'd
	CLR     6,X			;Clear MSB of result
	MUL				;MSB mult. x LSB mult'd
	ADDD    4,X			;Add in previous result
;
	ROL     6,X			;Rotate C bit into MSB of result, perform carry
	STD     4,X			;Save lower two bytes of result
;
;-MSB x MSB
;
	LDAA    0,X			;Get MSB of mult.
	LDAB    2,X			;Get MSB of mult'd
	MUL				;MSB mult. x MSB mult'd  
	ADDB    4,X			;Add in middle byte of result
;
	ADCA    6,X			;Add in MSB of result with carry
;
	STAB    4,X			;Save LSB of result
	STD     2,X			;Save result, upper two bytes of final result
	TSTA				;Test uppermost byte of 32 bit result    
	BEQ     LF239			;Bra if ==0, result within range
;
	LDD     #$FFFF			;Clear overflow, result out of range
	STD     4,X			;Save as final result
;
;-Clean up the stack
;
LF239	PULX 				;  
	PULX				;				    
	PULA				;Get MSB of final result/256    
	PULB				;Get LSB of final result/256   
	INS				;+1, stack pointer     
	RTS				;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 16 x 16 multiply routine   
;
;Enter with:
;
; AB=mult'd
; X=mult.
;
;Exit with:
;
; AB = result = (mult. x mult'd)/65536
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF23F	PSHX			;Push mult. to stack   
	PSHA			;Push MSB of mult'd to stack    
	PSHX			;Push mult. to stack    
	PSHB			;Push mult'd to stack    
	PSHA			;    	
	TSX			;Get current stack pointer in
;
;-Begin multiplying AB x X
;     
	LDAA    3,X		;Load LSB of mult.
	MUL			;LSB of mult. x LSB of mult'd     
	STD     5,X		;Save result
	LDD     1,X		;Load LSB mult'd, MSB of mult.
	MUL			;MSB mult x LSB of mult'd     
	ADDB    5,X		;Add in MSB of previous MSB x LSB result
	ADCA    #0		;Perform carry if needed
	STD     4,X		;Save MSB x LSB of result
	LDAA    0,X		;Load MSB of mult'd
	LDAB    3,X		;Load LSB of mult.
	CLR     3,X		;Pre-clear MSB of result		
	MUL			;LSB of mult. x MSB of mult'd    
	ADDD    4,X		;Add in previous result
	ROL     3,X		;Perform carry if needed
	STD     4,X		;SAve result
	LDAA    0,X		;Load MSB of mult'd
	LDAB    2,X		;Load MSB of mult.
	MUL			;MSB of mult. x MSB of mult'd     
	ADDD    3,X		;Add in previous result
;
;-Clean up stack
;
	INS			;Inc. stack pointer     
	PULX			;   
	PULX			;
	PULX			;
	RTS			;Return     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~
;
; Heads up routine
;
;~~~~~~~~~~~~~~~~~~
;
LF26C	BRCLR   L0082,#$40,LF273	;Status word, bra if b6==0, heads up not online
;
	JSR     L1806			;To HU vector table
;
LF273	LDAA    #$F7			;
	STAA    L0F00			;HU hardware
;
	RTS				;Return    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
; Routine to init. heads up
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF279	LDX     L1800			;Start of heads up section of EPROM
	CPX     #$7E18			;First two stored bytes in HU jump table
	BNE     LF284			;Bra if HU not present
;
;-HU is present
;
	JSR     L180C			;Routine to reset HU ram and enable HU
;											                   
	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; ALDL scheduled message transmission routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF285	LDAA    L0042			;ALDL diag. status word				
	ANDA    #$03			;Clear all but b0, engine diags., and b1, transmission
					;diags. 
	BNE     LF2EA			;Bra if either mode enabled
;
;-Not in transmission or engine diag. mode
;
	LDX     #L5185			;Load in start of ALDL transmission tables
	LDAB    L0002			;Loop counter
	ANDB    #$1F			;Clear all but b0-b4
	ABX				;Use as offset
	LDX     0,X			;Get addr.
	BEQ     LF2EA			;Bra if ==0, return
;
	LDAA    2,X			;Get next addr. 
	BEQ     LF2EA			;Bra if ==0, return
;
;-Check for transmission overrun
;
	BRSET   L003B,#$40,LF2E7	;Status word, bra if b6==1, 8192 xmission still in 
					;progress
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; No overrun, start xmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BSET    L003B,#$40		;Set b6, ALDL transmission in progress											;
	STX     L0364			;Save addr., pointer to ALDL transmission string
	LDAB    L302E			;Load SCI status reg
	STAA    L302F			;Save for transmission
	STAA    L0363			;Save it, ALDL message checksum
	LDAB    4,X			;Load in message length from ALDL transmission params
	STAB    L0367			;Save it, ALDL message length
	SEI				;Disable interrupts
	BEQ     LF2CF			;Bra if message length was ==0
;
	LDAA    3,X			;Load in memory flag
	BITA    #$C0			;Test b6, b7
	BNE     LF2CF			;Bra if b6, b7==1
;
	LDY     5,X			;Load in outgoing ALDL data buffer
;
;-Upload data to ALDL data buffer
;
LF2BF	PSHX    			;Push pointer to ALDL transmission string to stack
	LDX     9,X			;Load in addr. of data to transmit
	LDAA    0,X			;Load A with data
	STAA    0,Y			;Save it to ALDL data buffer
	INY				;+1, advance to next addr.     
	PULX 				;Get pointer back   
	INX				;+1     
	INX				;+1, advance to next addr
	DECB				;-1 from byte counter    
	BNE     LF2BF			;Bra if !=0, still have data to upload
;
;-Here if message length was ==0
;
LF2CF	LDAB    #$01			;Transmit 1 byte
	STAB    L0362			;Save it, ALDL message length
	LDD     L3FFC			;I/O port D
	JSR     LF08A			;Delay
;
	ORAB    #$04			;Set b2
	STD     L3FFC          		;Save it
	CLI				;Enable interrupts
;
;-Request SCI transmission interrupt
; 
	LDAA    #$88			;Set b3, transmit enable and b7, transmit interrupt
					;enable
	STAA    L302D			;Save it, SCI control reg. 2
	BRA     LF2EA			;Bra to return
;
;-Here if transmission exceeded time available
;
LF2E7	BSET    L003B,#$20		;ALDL status word, set b5, ALDL transmission overran
;
LF2EA	RTS				;Return   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  

F2EB:  LF2EB     LDAA    L0088				;
F2ED:            ANDA    #$D9				;
											;
F2EF:            LDAB    L0089				;
F2F1:            ANDB    #$02				;
F2F3:            ABA     					;

F2F4:            LDAB    L0085				; TCC MODE WD	
F2F6:            ANDB    #$20				; b5, TCC IS IN LOCK ADJ MODE 
F2F8:            ABA     					;
F2F9:            STAA    L012C				;
											;
F2FC:            LDAA    L00F7				;
F2FE:            ANDA    #$01				;
											;
F300:            LDAB    L008B				;
F302:            ANDB    #$A4				;
F304:            ABA     					;
											;
F305:            LDAB    L008C				;
F307:            ANDB    #$04				;
F309:            ASLB    					;
F30A:            ASLB    					;
F30B:            ABA     					;
F30C:            LDAB    L0083				;
F30E:            ANDB    #$02				;
F310:            ABA     					;
F311:            STAA    L012D				;

				;
    			; CK L0042, ALDL MODE WD  
    			;	 	b0 = F4
				;		b1 = F5
				;
F314:            BRCLR   L0042,#$02,LF36A	; BR IF NOT b1, (F5)

F318:            LDX     #$039B				; 
F31B:            LDAA    L039B				; ALDL CNT'L WD 11
F31E:            CMPA    #$04				;
F320:            BNE     LF39F				;

F322:            LDD     L036C				; ALDL MODE WD
F325:            BNE     LF39F				; BR IF BZ

F327:            BSET    L003B,#$08			; SET b3, IN MODE 4, ($F5)
F32A:            BRCLR   1,X,#$18,LF35E		; BR IF NOT b4 & b3

F32E:            CLRA    					;
F32F:            BRCLR   1,X,#$08,LF339		; BR IF NOT b3

F333:            BRCLR   2,X,#$08,LF339		; BR IF NOT b3

F337:            ORAA    #$01				; b0
											;
F339:  LF339     BRCLR   1,X,#$10,LF343		; BR IF NOT b4

F33D:            BRCLR   2,X,#$10,LF343		; BR IF NOT b4

F341:            ORAA    #$02				; b1
F343:  LF343     LDY     #$B3A1				;
F347:            CLRB    					;
F348:            CMPA    0,Y				;
F34B:            BEQ     LF35A				;

F34D:            INCB    					;
F34E:            CMPA    1,Y				;
F351:            BEQ     LF35A				;

F353:            INCB    					;
F354:            CMPA    2,Y				;
F357:            BEQ     LF35A				;

F359:            INCB    					;
F35A:  LF35A     INCB    					;
F35B:            STAB    L0103				;
F35E:  LF35E     BRCLR   5,X,#$80,LF36C		;

F362:            LDAA    L03A1				;
F365:            STAA    L010A				;
F368:            BRA     LF376				;
											;
F36A:  LF36A     BRA     LF39F				;
											;
F36C:  LF36C     BRCLR   5,X,#$40,LF376		;
											;
F370:            LDAA    L03A1				;
F373:            STAA    L0118				;

				;
				; SERIAL DATA MD WORD	
                ;  	b7 1 = 2nd BYTE 8192 TX IS PENDING	
				;
F376:  LF376     BRCLR   L003B,#$08,LF399	; BR IF NOT b3, IN MODE 4, ($F5)

F37A:            BRCLR   7,X,#$40,LF399		; BR IF NOT b6

F37E:            LDD     #$0000				;
F381:            STD     L031B				;
F384:            STD     L031D				;
F387:            STD     L031F				;
F38A:            STD     L0321				;
F38D:            STD     L0323				;
F390:            STD     L0325				;
F393:            STD     L0323				;
F396:            STD     L0325				;
											; 
F399:  LF399     LDAA    L03A3				;
F39C:            STAA    L0111				;
											;

				;
				; SERIAL DATA MD WORD
				;  CK FOR XMISH CONTROLLER MODE
				;
F39F:  LF39F     BRCLR   L003B,#$08,LF3BF	; BR IF NOT b3, IN MODE 4, ($F5)


				;
    			; CK L0042, ALDL MODE WD  
    			;	 	b0 = F4
				;		b1 = F5
				;
F3A3:            BRCLR   L0042,#$02,LF3AC	; BR IF NOT b1, (F5)
											;
F3A7:            LDD     L036C				; ALDL MODE WD
F3AA:            BEQ     LF3BF				;
											;
F3AC:  LF3AC     CLRA    					;
F3AD:            STAA    L039B 				; ALDL CNT'L WD 11
F3B0:            STAA    L010A				;
F3B3:            STAA    L0103				;
F3B6:            STAA    L0111				;
F3B9:            STAA    L0118				;
F3BC:            BCLR    L003B,#$08			; CLR b3, IN MODE 4, ($F5)
											
     										

				;
    			; CK L0042, ALDL MODE WD  
    			;	 	b0 = F4
				;		b1 = F5
				;
F3BF:  LF3BF     BRCLR   L0042,#$01,LF3E3	; BR IF NOT b0 (F4)
                                            ; ... else
F3C3:            LDAA    L0390				; ALDL MODE NUMBER
F3C6:            CMPA    #$04 				; CK IF ALDL MODE 4
F3C8:            BNE     LF3E3				; BR IF NOT MODE 4
                                            ; ... else
				;
				; SET ENG ALDL $F4, MODE 4		<----****
				;

F3CA:            BSET    L003B,#$10			; SET b4, IN MODE 4, ($F4), 
F3CD:            LDAA    L0393				; ALDL CNT'L WD 3
F3D0:            BITA    #$10				; b4, RESET BLM = 128
F3D2:            BEQ     LF3E0				; BR IF NOT b4
                                            ; ... else
F3D4:            BRSET   L0045,#$10,LF3E3

F3D8:            JSR     LEF1D

F3DB:            BSET    L0045,#$10			; SET b4

F3DE:            BRA     LF3E3

F3E0:  LF3E0     BCLR    L0045,#$10			; CLR b4,

			
				;
				; SERIAL DATA MD WORD
				;  MODE 10 ID $F4, (ENG)								
				;
F3E3:  LF3E3     BRSET   L003B,#$02,LF3F2	; BR IF b1, MODE 10 ID $F4
                                            ; ... else                  
			
			;-------------------------------------------------
			; ALDL $F4, MODE 4
			;		CLEAN ERROR CODES
			;	
			;	L0393, b6, 1 = CLR ERRORS, (ALDL CNT'L WD 3)
			;-------------------------------------------------

				;
				; SERIAL DATA MD WORD
				;  CK FOR  ENG CONTROLLER MODE
				;
F3E7:            BRCLR   L003B,#$10,LF3FE	; BR IF NOT b4, IN MODE 4, ($F4), 

F3EB:            LDAA    L0393				; ALDL CNT'L WD 3
F3EE:            BITA    #$40				; b6, CLEAR ERROR CODES
F3F0:            BEQ     LF3FE				; BR IF NOT b6
                                   			; ... else
F3F2:  LF3F2     BRSET   L0045,#$80,LF401	; BR IF b7

F3F6:            JSR     LEFD0				;
											;
F3F9:            BSET    L0045,#$80			; SET b7
											;
F3FC:            BRA     LF401				;
											
											
											
F3FE:  LF3FE     BCLR    L0045,#$80			;
			
				;
				; SERIAL DATA MD WORD
				;  MODE 10 ID $F5, (XMISH)								
				;
F401:  LF401     BRCLR   L003B,#$01,LF411	; BR IF NOT b0, ($F5)

F405:            BRSET   L0045,#$40,LF414	;

F409:            JSR     LF01D				;
											;
F40C:            BSET    L0045,#$40			;
F40F:            BRA     LF414				;
											;

F411:  LF411     BCLR    L0045,#$40			;
											
											
	;-------------------------------------------------
	; ALDL 
	;
	; CK FOR MODE ZERO
	; 
	; TURN OFF MODE 4
	;-------------------------------------------------              

				;
				; SERIAL DATA MD WORD
				;  CK FOR  ENG CONTROLLER MODE
				;
F414:  LF414     BRCLR   L003B,#$10,LF42A	; BR IF NOT b4, IN MODE 4, ($F4), 

F418:            BRCLR   L0042,#$01,LF421	; BR IF NOT b0
											; .. else
F41C:            LDD     L036C				; ALDL MODE WD
F41F:            BEQ     LF42A				;
											;
F421:  LF421     BCLR    L003B,#$10			; SET b4, IN MODE 4, (F4)
											;
F424:            CLR     L0390				; ALDL MODE NUMBER
F427:            BCLR    L0044,#$04			;

F42A:  LF42A     RTS     
	;-------------------------------------------------


F42B:  LF42B     SEI     
F42C:            BRCLR   L0042,#$03,LF464

F430:            LDAA    L0369
F433:            INCA    
F434:            BEQ     LF43D

F436:            STAA    L0369
F439:            CMPA    #$C8
F43B:            BCS     LF464

F43D:  LF43D     CLR     L039B				; ALDL CNT'L WD 11
F440:            CLR     L0390				; ALDL MODE NUMBER
F443:            BCLR    L0042,#$03

F446:            BCLR    L0045,#$D0			;
											;
F449:            BCLR    L003B,#$43			;
											;
F44C:            LDD     L3FFC          	; I/O D PORT ..
											;
F44F:            JSR     LF08A				; VERY SHORT DELAY
											;
F452:            ANDB    #$00FB				;
F454:            STD     L3FFC           	; I/O D PORT ..

		;
		;  RX WK UP, RX ENABLE & RX INT ENABLE
		;
F457:            LDAA    #$26
F459:            STAA    L302D				; SCI CNT'L REG 2
											;
											;
F45C:            CLRA    					;
F45D:            CLRB    					;
F45E:            STD     L0364				;
F461:            STD     L0362				;
											;
F464:  LF464     CLI     					;
F465:            BRCLR   L003B,#$18,LF47D	; BR IF NOT $18
											;
F469:            LDX     L036A				;
F46C:            INX     					;
F46D:            STX     L036A				;
F470:            CPX     L51B1				;
F473:            BCS     LF493				;
											;
F475:            LDX     #$0001				;
F478:            STX     L036C				; ALDL MODE WD
F47B:            BRA     LF493				;
											;
F47D:  LF47D     LDX     L036C				; ALDL MODE WD
F480:            BEQ     LF493				;
											;
F482:            INX     					;
F483:            STX     L036C				; ALDL MODE WD
F486:            CPX     L51B3				;
F489:            BCS     LF493				;
											;
F48B:            CLRA    					;
F48C:            CLRB    					;
F48D:            STD     L036C				; ALDL MODE WD
F490:            STD     L036A				;

F493:  LF493     RTS     
	;-------------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; SCI interrupt handling routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF494    LDX     #$3000			;Start of CPU reg.
;
;-Check which function generated interrupt
;                                           
	BRCLR   $2D,X,#$20,LF4A4	;SCI control reg. 2, bra if b5==0, RX interrupt 
;					;not enabled, TX instead	
;-Check if data was recieved
;
	BRCLR   $2E,X,#$20,LF4CB	;SCI status register, bra if b5==0, RX data reg. empty
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; Data has been recieved
;~~~~~~~~~~~~~~~~~~~~~~~~
;
	JSR     LF5B5			;SCI data reception handler
	BRA     LF4CB			;Bra to return
;
;-Check if TX interrupt was enabled
;                                         
LF4A4	BRCLR   $2D,X,#$80,LF4B1	;Bra if b7==0, TX interrupt not enabled
;
;-TX interrupt enabled
;
	BRCLR   $2E,X,#$80,LF4CB	;Bra if b7==0, TX register is empty
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Data is wating to be transmitted
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
	JSR     LF4CC			;ALDL transmission routine
;										
	BRA     LF4CB			;Bra to return
;
;-Check if transmission completed interrupt was set
;
LF4B1	BRCLR   $2D,X,#$40,LF4CB	;SCI control reg 2, bra if b6==0, no TX complete 
					;interrupt was set
;
;-TX complete interrupt was set
;                                            
	BRCLR   $2E,X,#$40,LF4CB	;SCI status register, bra if b6==0, transmitter
					;is buisy
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Transmission complete, reset SCI
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    #$26			;Set b1, reciever wakeup, b2, recieve enable, and 
					;b5, recieve interrupt enable
	STAA    $2D,X			;Save it, SCI control reg. 2
	LDD     L3FFC			;I/O port D
	JSR     LF08A			;Delay
;
	ANDB    #$FB			;Clear b2
	STD     L3FFC              	;Save it
	BCLR    L003B,#$40		;ALDL diag. status register, clear b6, ALDL 
					;transmission complete
;
LF4CB	RTI				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; ALDL transmission routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
LF4CC	LDX     L0364			;Pointer to ALDL transmission string
	LDAB    L0362			;Message length counter
	DECB				;-1
	BNE     LF4FC			;Bra if !=0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to transmit message length
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;							           
	LDAA    4,X			;Load in number of bytes to transmit
	BRCLR   L0042,#$03,LF4F4	;ALDL diag. status word, bra if b0, b1==0, 
					;engine/transmission diags. not enabled
;
;-Engine/transmission diags. enabled
;
	PSHA				;Push byte count to stack    
	LDAB    L0390			;Start of engine diag. buffer, load desired ALDL mode
	LDAA    L0366			;Current ALDL diag. ID
	CMPA    #$F5			;Diag. ID for transmission diags.
	BNE     LF4E9			;Bra if !=
;
;-Transmission diags. enabled
;
	LDAB    L039B			;Load start of trans. diag. buffer instead
;
LF4E9	PULA				;Get number of bytes to tx back    
	CMPB    #$03			;Mode 3, 8 byte addr. dump
	BNE     LF4F4			;Bra if not in mode 3
;
;-In mode 3, 8 byte memory dump here
;                                     
	LDAA    L0367			;ALDL message length
	DECA				;-1    
	ASRA				;/2 to get transmission length  
	INCA				;Restore message length
;
;-In other modes
;
LF4F4	STAA    L0367			;ALDL message length
	ADDA    #$55			;Add $55, used for error checking
	JMP     LF590			;Jump to xmit
;
;-Here if still transmitting data
;
LF4FC	DECB				;-1    
	BNE     LF513			;Bra if !=0

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to transmit ALDL mode
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	BRCLR   L0042,#$03,LF513	;ALDL diag. status word, bra if b1, b2==0, not in
					;engine or trans. diag. mode
;
;-In either engine or transmission diag. mode
;
	LDAA    L0390			;Start of engine diag. buffer, current ALDL mode
	LDAB    L0366			;Current ALDL diag. ID
	CMPB    #$F5			;Transmission diag. ID
	BNE     LF510			;Bra if !=, in engine diags.
;
;-In transmission diags.
;
	LDAA    L039B			;Start of transmission diag. data buffer, load ALDL
					;mode
LF510	JMP     LF590			;Go transmit ALDL mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to continue with general data transmission, find out which addr. mode is desired
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF513	CMPB	L0367			;ALDL message length
	BCC     LF58A			;Bra if stored message length is >=, invalid
					;request
;
	BRSET   L003B,#$80,LF57E	;ALDL diag. status word, bra if b7==1, double
					;byte transmission in progress
;
	BRSET   3,X,#$80,LF52B		;ALDL transmission opt. byte, bra if b7==1, 
					;transmitting addr. from diag. table in prom
;
	BRSET   3,X,#$40,LF536		;ALDL transmission opt. byte, bra if b6==1, 
					;transmitting from ram/PROM in various modes
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform scheduled ALDL transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     5,X			;Load start addr. of ALDL data buffer
	ABX				;Add in byte count as offset  
	LDAA    0,X			;Load stored data from buffer
	BRA     LF590			;Bra to transmit			                                             
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to transmit ALDL using definitions in diagnostic tables in PROM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF52B	BRCLR   L0042,#$03,LF530	;ALDL diag. status word, bra if b0, b1==0, not in 
					;diagnostics mode
;
	DECB				;-1 from byte count
;
LF530	ASLB				;x2 for double byte addressing
	ABX				;Add in as offset
	LDX     9,X			;Load address of data to transmit from table in prom
	BRA     LF562			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to transmit from prom/RAM in various modes
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;										
LF536	DECB				;-1 from byte count
	LDX     5,X			;Load in addr. of outging data buffer
	PSHB				;Push byte count to stack
	LDAA    L0390			;Start of engine diag. data buffer, load ALDL mode								
	LDAB    L0366			;Current ALDL diag. ID
	CMPB    #$F4			;Engine diag. ID
	BEQ     LF54C			;Bra if ==, in engine diagnostics
;
;-Check if in transmission diags.
;                                     
	LDAA    L039B			;Start of transmission diag. data buffer, load ALDL
					;mode
	CMPB    #$F5			;Transmission diag. ID
	BEQ     LF54C			;Bra if ==, in transmission diags.
;
;-Not in engine/transmission diags.
;								
	CLRA				;
;
;-In engine/transmission diags.
;
LF54C	PULB				;Get byte count back
	CMPA    #$02			;ALDL mode 2, 64 byte memory dump 
	BEQ     LF55E			;
;
;-Transmitting from prom
;
	ASLB				;Byte count x2 for double byte addr.
	INCB				;+1
	CMPA    #$04			;ALDL mode 4, controller mode
	BNE     LF559			;Bra if !=
;
;-In mode 4, controller mode
;
	ADDB    #$0A			;Add in 10 byte offset
;
;-In other modes
;
LF559	ABX				;Add in byte count as offset
	LDX     0,X			;Load addr. of value to be transmitted
	BRA     LF562			;Bra to continue				
;
;-In mode 2 here, 64 addr. memory dump
;											
LF55E	INX				;+1
	LDX     0,X			;Load start addr. of data to begin transmitting
	ABX				;Add in byte count as offset     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to see if addr. read will fall in the range of the CPU hardware
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
LF562	CPX     #$1000			;End of RAM
	BCS     LF586			;Bra if <
;
	CPX     #$3FFF			;End of hardware 
	BHI     LF586			;Bra if >
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-In addr. range of CPU hardware, prevent reads from hardware
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	XGDX				;Swap address into D
	BRSET   L0050,#$08,LF573	;Status word, bra if b3==1, factory diag. requested
;
;-Not in factory diags., block reads from addr range $1400-$3000
;
	ANDA    #$CF			;Mask all but b4, b5 from address
;
;-In factory diags. allow all reads
;
LF573	XGDX				;Get address back
	LDD     0,X			;Load in value from addr
	STAB    L0368			;Save LSB for later transmission
	BSET    L003B,#$80		;ALDL diag. status word, set b7, double byte
					;transmission in progress
	BRA     LF590			;Bra to transmit
;
;-Here to transmit LSB of double byte value
;
LF57E	BCLR    L003B,#$80		;Clear b7, double byte transmission complete
	LDAA    L0368			;Load LSB of double byte value to transmit
	BRA     LF590			;Bra to transmit data
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Normal addr range requested
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF586	LDAA    0,X			;Load value from specified location
	BRA     LF590			;Bra to transmit
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no data/invalid request
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF58A	BNE     LF59E			;Bra if message length was !=0, invalid request
;
;-Not transmitting data, just message checksum
;
	LDAA    L0363			;ALDL message checksum
	NEGA				;Negate
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here to save data for transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF590	STAA    L302F			;SCI data register
	ADDA    L0363			;Add into ALDL message checksum
	STAA    L0363			;Save it
	INC     L0362			;+1, message byte counter
	BRA     LF5B4			;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if invalid request
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF59E	CLRA				;Clear regs.
	CLRB				;
	BCLR    L003B,#$80		;ALDL diag. status word, clear b7, double byte
					;transmission flag										
	STD     L0362			;Clear message byte counter, SCI data checksum
	STD     L0364			;Clear pointer for ALDL transmission string 										
	LDAA    L302E			;Access SCI status reg.
	LDAA    L302F			;Access SCI data register										
	LDAA    #$40			;Set b6, interrupt when transmission complete
	STAA    L302D			;SCI control reg. 2
;
LF5B4	RTS				;Return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Routine to handle ALDL data reception
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF5B5	LDAB    L302E			;SCI status register
	LDAA    L302F			;SCI data register
	LDX     L0364			;Pointer to ALDL transmission string
	CLR     L0369			;
;
;-Check for transmission errors
;
	BITB    #$0E			;Test b3=overrun error flag, b2=noise flag, and 
					;b1=framing error flag
	BNE     LF5E3			;Bra if any errors detected
;
;-No errors, 
;
	TAB				;Get data into B     
	ADDB    L0363			;Add data into ALDL message checksum
	STAB    L0363			;Save it, ALDL message checksum
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check if device ID has been recieved
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAB    L0362			;Check message legnth counter 
	BNE     LF5FF			;Bra if !=0, device ID already recieved, continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Device ID has been recieved
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDX     #L51B5			;Start of ALDL entry addresses
	BRCLR   L0050,#$08,LF5DB	;Bra if b3==0, no factory test 
;
;-Factory test requested
;
	LDX     #LF881			;Start of factory diagnostics prams
;
LF5DB	CMPA    2,X			;Check ID code
	BEQ     LF5E5			;Bra if device ID matches current message table
;											
	LDX     0,X			;Skip to next message table
	BNE     LF5DB			;Bra if !=0, continue to follow addr. pointers to 
					;transmission diags. portion
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if errors during transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;											
LF5E3	BRA     LF660			;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check which diagnostic streams to use
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF5E5	CMPA    #$F4			;Device ID for engine diagnostics
	BNE     LF5EE			;Bra if device ID !=
;											
	BSET    L0042,#$01		;ALDL diag. mode word, set b0, ALDL engine diags. flag
	BRA     LF5F5			;Bra to continue
;
;-Check if transmission diagnostics desired
;
LF5EE	CMPA    #$F5			;Device ID for trans. diagnostics
	BNE     LF5F5			;Bra if !=, neither engine/transmission diag. modes 
					;requested
;											
	BSET    L0042,#$02		;Set b1, ALDL transmission diags. flag
;
LF5F5	STX     L0364			;Save current pointer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Set up to recieve next serial transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
	LDAA    #$24			;Set b5, recieve interrupt enable, and b2, enable SCI
					;reciever 
	STAA    L302D			;Save it, SCI control reg. 2
;
	BRA     LF65A			;Bra to inc. message length counter and return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if the remainder of the ALDL request has been recievied
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF5FF	DECB				;-1 from message length counter
	BNE     LF60F			;Bra if !=0, desired mode transmitted
;
;-Check recieved message length to ensure valid request
;
	SUBA    #$55			;-55, used as RX/TX error check
	BCS     LF660			;Bra if <, request not valied
;
	CMPA    #$22			;34, max message length
	BHI     LF660			;Bra if >, buffer overrun
;
	STAA    L0367			;Save it, ALDL message length
	BRA     LF65A			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to see which ALDL mode is desired
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF60F	DECB				;-1 from message length counter
	CMPB    L0367			;ALDL message length
	BCC     LF663			;Bra if mode/desired ALDL transmision bytes already
					;recieved
;
	TSTB				;Test counter
	BNE     LF62E			;Bra if !=0, desired ALDL mode not recieved
;
;-The desired ALDL mode has been recieved
;
	BRCLR   L0042,#$03,LF655	;ALDL diag. status word, bra if b0,b1==0, neither in
					;ALDL engine or transmission diag. modes
;
;-In diagnostics mode, retrieve desired ALDL transmission sring 
;
	CMPA    #10			;Highest allowed mode
	BHI     LF660			;Bra if >, request not valid
;
	PSHB				;Push B to stack    
	TAB				;Get ALDL mode into B
	ASLB				;x2 to use as addr. offset    
	ABX				;Add it in    
	PULB				;Get B back    
	LDX     $0009,X			;Load in addr. desired transmission string
	BEQ     LF660			;Bra if ==0, request not valid
;
	STX     L0364			;Save it, pointer to ALDL transmission string
	BRA     LF655			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Check to see if desired ALDL transmission string has been recieved for mode 1 operation
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF62E	BRCLR   L0042,#$03,LF655	;Bra if b0, b1==0 neither in engine or transmission
					;diag. mode
;
;-In diagnostics mode, check to see which ALDL mode was desired
;
	XGDY				;Swap A, B into Y    
	LDAA    L036E			;Start of ALDL data input buffer
	CMPA    #$01			;Mode 1, ALDL scan			
	XGDY				;Restore A, B   
	BNE     LF655			;Bra if !=1, no ALDL scan currently requested
;
;-Check byte number to verify that the transmission string has been recieved
;
	CMPB    #$01			;2nd byte recieved, desired ALDL transmission string
	BNE     LF655			;Bra if !=, save and return
;
;-Requested ALDL transmission string has been recieved
;
	CMPA    #$03			;First set of transmission params 
	BCS     LF646			;Bra if <, valid request
;
	CLRA				;Clear A, default to first pointer if invalid 
					;request
;  
;-Look up ALDL transmission string pointer for ALDL scan
; 
LF646	PSHB				;Push message length to stack    
	XGDX				;Swap A, B into X    
	SUBD    #$06			;Rewind to pointers
	XGDX				;Get A, B back    
	TAB				;Get recieved data into B     
	ASLB				;x2    
	ABX				;Add in as offset     
	LDX     0,X			;Load pointer
	PULB				;Get message length back    
	STX     L0364			;Save it, pointer to ALDL transmission string
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
; Save ALDL data to buffer
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF655	LDX     7,X			;Load start addr. of data input buffer
	ABX				;Add in message length as offset     
	STAA    0,X			;Save it to the buffer
;
LF65A	INC     L0362			;+1, message length counter
	JMP     LF704			;Jump to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if error recieving transmission 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF660	JMP     LF6F7			;Go reset and return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Perform additional ALDL functions 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF663	LDAB    L0363			;ALDL message checksum
	BNE     LF660			;Bra if !=0, errors transmitting
;
;-No serial transmission errors here
;
	LDAB    2,X			;Load in engine/transmission diag. ID
	STAB    L0366			;Save it, current ALDL diagnostics ID
	LDY     #L0390			;Addr of engine diag. data buffer
	LDAA    L0367			;ALDL message length
	BRSET   L0050,#$08,LF6BA	;Status word, bra if b3==1, factory diag. requested
;
;-No factory diags. requested
;
	CMPB    #$F5			;ALDL transmission mode ID
	BNE     LF680			;Bra if !=, in engine diags. mode
;
;-ALDL in transmission diagnostics mode
;
	LDY     #L039B			;Addr. of transmission diag. data buffer			
;
LF680	BCLR    L003B,#$03		;ALDL diag. status word, clear b0, b1, mode 
					;10 flags for engune and transmission diags.
	LDAB    L036E			;Start of ALDL data buffer, read in desired mode
	STAB    0,Y			;Save it
	BNE     LF69B			;Bra if !=0, not in mode 0
;
;-In mode 0, normal mode, ALDL engine/transmission diag. mode no longer desired
;
	LDAB    #$FE			;Clear b0, ALDL engine diag. mode flag
	CPY     #L039B			;Compare to addr. of transmission diags buffer
	BNE     LF695			;Bra if !=, in engine diag. mode
;
	LDAB    #$FD			;Clear b1, ALDL transmission diag. mode flag
;
LF695	ANDB    L0042			;Clear selected bits
	STAB    L0042			;Save it, ALDL diag. status word word
	BRA     LF6CB			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Engine/transmission diags. requested, find out which mode was desired
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF69B	CMPB    #10			;Mode 10, ALDL error reset
	BNE     LF6B0			;Bra if not in mode 10
;
;-In mode 10, ALDL error reset
;
	LDAB    L0366			;Current ALDL diag. ID
	CMPB    #$F5			;ALDL transmission diag. mode ID
	BEQ     LF6AB			;Bra if transmission diag. mode
;
	BSET    L003B,#$02		;ALDL diag. status word, set b1, in mode 10 
					;(engine diags.)
	BRA     LF6CB			;Bra to continue
;
LF6AB	BSET    L003B,#$01		;ALDL diag. status word, set b0, in mode 10 
					;(trans. diags.)
	BRA     LF6CB			;Bra to continue
;
;-Check if mode 4 is in effect
;
LF6B0	CMPB    #$04			;Mode 4, controller mode
	BNE     LF6CB			;Bra if not in mode 4
;
;-In mode 4, external controller mode
;
	CMPA    #11			;11, max allowed ALDL message length
	BLS     LF6BA			;Bra if <=
;
	LDAA    #11			;Load max message length
;
LF6BA	TSTA				;Test message length    
	BEQ     LF6CB			;Bra if ==0
;
;-Retrieve data from controller
;								
	LDX     #L036E			;Addr. of ALDL data buffer
;
LF6C0	LDAB    0,X			;Load data from ALDL buffer
	STAB    0,Y			;Save it to diag. data buffer
	INX				;+1, move to next addr. 	    
	INY				;+1     
	DECA				;-1, ALDL message length
	BNE     LF6C0			;Bra if !=0, continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Set up for next ALDL transmission
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF6CB	LDX     L0364			;Pointer to ALDL transmission string
	BRSET   4,X,#$80,LF6F7		;Number of bytes to XMIT, bra if b7==1,
					;not responding with data
;
;-Transmitting data here
;
LF6D2	STX     L0364			;Save pointer to ALDL transmission string
	LDAB    L302E			;SCI data register
	LDAA    2,X			;Load in ID byte
	STAA    L302F			;Save it, SCI data register
;
	STAA    L0363			;Save it, ALDL message checksum
	LDAB    #$01			;1, transmit one byte
	STAB    L0362			;Save it, ALDL message length
;
	LDD     L3FFC			;I/O port D
	JSR     LF08A			;Delay
;
	ORAB    #$04			;Set b2
	STD     L3FFC			;Save it
;
;-Enable SCI data transmission
; 
	LDAA    #$88			;Set b3, transmit enable, and b7, transmit interrupt
					;enable
	STAA    L302D			;Save it, SCI control register 2
	BRA     LF704			;Bra to continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Here if no transmission or errors, reset and return
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF6F7	CLRA				;Clear A, B    
	CLRB				;    	
	STD     L0364			;Save it, pointer to ALDL transmission string
	STD     L0362			;ALDL message length and checksum
	LDAA    #$26			;Set b1, reciever wakeup, b2, recieve enable bit, and
					;b5, recieve interrupt enable
	STAA    L302D			;SCI control register 2
;
LF704	RTS				;Return  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 

		;----------------------------------------
		;
		;
		;
		;----------------------------------------
F705:  LF705     LDS     #$03FF         	; SET USR STX
											;
F708:            LDAA    #$01           	; SET UP TO READ DIAG INPUT
											;
F70A:            LDX     #$3000				; INDEX CPU REG'S

F70D:            JSR     LEF12			   	; DELAY ROUTINE

F710:            LDAA    #$01
F712:            JSR     LEEFC

F715:            LDAA    L3031          	; GET A/D RESULT #1,
F718:            CMPA    #100				; 2VDC
F71A:            BCC     LF72C				; BR IF VDC GT 100 bin, (2 VDC)

F71C:            CMPA    #40				; 800 mvdc 
F71E:            BCS     LF72C				: BR IF A/D VAL LT 800 mvdc

F720:            LDAA    #$03
F722:            JSR     LEEFC

F725:            LDAA    L3031          	; GET A/D RESULT #1
F728:            CMPA    #26				;
F72A:            BHI     LF72D

F72C:  LF72C     SWI     
F72D:  LF72D     CLI     
            ;----------------------------------

                ;----------------
                ; TOGGLE COP REG
                ;----------------
F72E:            LDD     #$AA55
F731:            STAA    L303A				; COP RST
F734:            STAB    L303A				; COP RST

F737:            LDAB    L0366				; ENG/XMISH MODE BYTE
F73A:            CMPB    #$02
F73C:            BEQ     LF749

F73E:            JSR     LF081

F741:            CMPB    #$03
F743:            BNE     LF753

F745:            BRCLR   L0001,#$01,LF753	; BR IF BOT b0, 

F749:  LF749     BSET    L0001,#$01			; SET b0

F74C:            LDX     L0390				; ALDL MODE NUMBER
F74F:            JSR     0,X

F751:            BRA     LF771              ; EXIT TO WAIT FOR INTIRUP


F753:  LF753     CMPB    #$01
F755:            BNE     LF774              ; BR IF NOT RAM UP LD MSG

                                                          
                ;---------------------
                ; UPLOAD RX'ED DATA
                ;
                ; XFER TO RAM STARTING
                ; AT  $02AE, (32 BYTES)
                ;---------------------
F757:            BCLR    L0001,#$01			; BR IF b0

F75A:            LDX     L0390				; POINT TO MSG DESTINATION
											; (ALDL MSG MODE BYTE FOR ENGINE)

F75D:            LDY     #$0392             ; POINT TO MSG DATA ADDR
F761:            LDAB    #32                ; 32 BY FIXED LEN MSG'S

F763:  LF763     LDAA    0,Y				; GET DATA BYTE 
F766:            STAA    0,X				; XFER DATA TO DEST RAM LOC
F768:            INY     					; BUMP ADDR POINTERS
F76A:            INX     
F76B:            DECB    					; DEC 32 BYTE CNT'R
F76C:            BNE     LF763				; LOOP TILL CNT'R = 0

F76E:            COM     L0366				; ENG/XMISH MODE BYTE

F771:  LF771     JMP     LF87E              ; DO NOTHING LP, (WAIT FOR INIT ?)
	   ;--------------------------------------------

	
	   ;--------------------------------------------
	   ; CK FOR OUTPUT	CYCLING DISABLE	 CONDITIONS
	   ;
	   ;
	   ;--------------------------------------------
F774:  LF774     LDX     #$F8AB				; 
F777:            TSTB    					; NZ, A VALID SERAIL DATA MSG
											; HASE BEEN RX'ED, DONT CYCLE
											; OUTUTS
F778:            BNE     LF7E3

F77A:            LDY     #$3064				; I/O DEV PORT
F77E:            BRCLR   0,Y,#$80,LF7E3		; BR IF NOT b7

F783:            LDX     #$DFFF             ; 57,343d
F786:            STX     L3FCC
F789:            JSR     LF880              ; SHORT DELAY
											;
F78C:            LDX     #$DFFF             ; 57,343d
F78F:            STX     L3FEA				;
F792:            JSR     LF880              ; SHORT DELAY



             	;---------------------------
            	; OUTPUT CYCLING 
            	; 
            	;---------------------------
F795:            LDD     #197				; SET UP FOR 3msec PULSES
F798:            STD     L3FCE				; SAVE TO EFI PW
F79B:            JSR     LF880				; SHORT CPU DELAY

F79E:            LDX     #66				; SET DWELL TO 1 Msec
F7A1:            STX     L3FDC              ; SPK WP, (DWELL)
F7A4:            JSR     LF880				; EXIT via RTS

F7A7:            LDD     #$FFF1             ; 65,521d
F7AA:            SUBD    #$05
F7AD:            STD     L3FF6              ; EST FALL CNT'R
											; (TIME FM DRP TO FIRE IGN)
F7B0:            LDAB    L0002				; MJR LOOP SEGMENT COUNT; MAJOR LOOP COUNTER
F7B2:            CMPB    #$4F				; 0010 1111
F7B4:            BLS     LF7B7				; BR IF 
											;  ... else
F7B6:            CLRB    

F7B7:  LF7B7     STAB    L0002				; MJR LOOP SEGMENT COUNT
F7B9:            BITB    #$0F				; 0000 1111
F7BB:            BNE     LF771				;

F7BD:            PSHB    

F7BE:            LDAA    L3062				; I/O PORT D
F7C1:            TAB     					; TO B reg
F7C2:            ANDA    #$0C				; MASK 0000 1100
F7C4:            BEQ     LF7CE				; BR IF NOT b2 & b3

F7C6:            CMPA    #$0C				; b2 & b3
F7C8:            BEQ     LF7CE				; BR IF NOT b2 & b3

F7CA:            EORB    #$08				; b3
F7CC:            BRA     LF7D0				;
											;
F7CE:  LF7CE     EORB    #$04				;
F7D0:  LF7D0     ORAB    #$30				;
F7D2:            STAB    L3062				;
F7D5:            PULB    					;
F7D6:            LSRB    					;
F7D7:            LSRB    					;
F7D8:            LSRB    					;
F7D9:            LSRB    					;
F7DA:            LDAA    #$03				;
F7DC:            MUL   						;
  
			;-----------------------------------------
			; MYSTERY TABLE
			;
			;----------------------------------------
F7DD:            LDX     #$F89C				;
F7E0:            ABX     					;
F7E1:            BRA     LF7F4				

				;-----------------
				; I/O D PORT
				;
				;-----------------
F7E3:  LF7E3     LDAA    L3062				; I/O PORT D
F7E6:            ANDA    #$E3				; 0111 0011
F7E8:            STAA    L3062				; I/O PORT D

F7EB:            LDD     #$0000
F7EE:            STD     L3FCE

F7F1:            JSR     LF880				; EXIT via RTS


F7F4:  LF7F4     LDAA    L3060				; I/O PORT
F7F7:            ANDA    #$6F				; 0110 1111
F7F9:            ORAA    0,X
F7FB:            STAA    L3060				; I/O PORT

				;---------------
				; I/O D PORT
				;---------------
F7FE:            LDAA    L3062				; I/O PORT D
F801:            ANDA    #$FC				; 1111 1100
F803:            ORAA    1,X
F805:            STAA    L3062				; I/O PORT D

F808:            SEI     
F809:            LDD     L3FFC          	; I/O D PORT ..

F80C:            JSR     LF880				; EXIT via RTS


F80F:            ANDB    #$F7
F811:            ORAB    2,X
F813:            STD     L3FFC          	; I/O D PORT ..


F816:            JSR     LF880				; EXIT via RTS


F819:            CLI     
F81A:            CPX     #$F8AB
F81D:            BNE     LF842

F81F:            LDX     #$D000
F822:            STX     L3FD4
F825:            BSR     LF880				; EXIT via RTS

F827:            STX     L3FD6
F82A:            BSR     LF880				; EXIT via RTS

F82C:            STX     L3FD8
F82F:            BSR     LF880				; EXIT via RTS

F831:            STX     L3FDA
F834:            STX     L306A
F837:            STX     L306C
F83A:            STX     L306E
F83D:            STX     L3068

F840:            BRA     LF87E


F842:  LF842     LDX     #$D399				; 
F845:            STX     L3FD4
F848:            BSR     LF880				; EXIT via RTS

F84A:            LDX     #$D366
F84D:            STX     L3FD6
F850:            BSR     LF880				; EXIT via RTS

F852:            LDX     #$D332
F855:            STX     L3FD8
F858:            BSR     LF880				; EXIT via RTS

F85A:            LDX     #$D2FF
F85D:            STX     L3FDA

F860:            LDX     #$7FB3
F863:            STX     L306A

F866:            LDX     #$7FA6
F869:            STX     L306C

F86C:            LDX     #$7F66
F86F:            STX     L306E

F872:            LDX     #$0D73
F875:            STX     L3068

F878:            LDX     #$F88A				; INDEX MSG HANDLER
F87B:            JSR     LF6D2

F87E:  LF87E     BRA     LF87E

F880:  LF880     RTS     
		;----------------------------------------


       ORG  $F881
 
    	;--------------------------------------------------
    	; FACTORY TEST MSG LIST 
		;
		; (SERIAL DAT MSG TBL)
		; $0d          
    	;--------------------------------------------------
LF881  FDB  $F88A   ; LINK TO NEXT MSG
LF883  FCB  $01     ; MESSAGE ID
LF884  FCB  $00     ; USE RAM BUFFER
LF885  FCB  $00     ; NUM OUTPUT BYTES
					;
LF886  FDB  $0390   ; OCB ADDR 
LF888  FDB  $036E   ; ICB ADDR
    	;----------------------------------------


    	;----------------------------------------
    	;
    	;                                
    	;----------------------------------------
LF88A  FDB  $F893   ; LINK TO NEXT MSG
LF88C  FCB  $02     ; MESSAGE ID
LF88D  FCB  $00     ; USE RAM BUFFER
LF88E  FCB  $00     ; NUM OUTPUT BYTES
					;
LF88F  FDB  $0390   ; OCB ADDR
LF891  FDB  $035E   ; ICB ADDR
    	;----------------------------------------


    	;----------------------------------------
    	;
    	;                                
    	;----------------------------------------
LF893  FDB  $0000   ; END OF LINKED MSG LIST
LF895  FCB  $03     ; MESSAGE ID
LF896  FCB  $00     ; USE RAM BUFFER
LF897  FCB   24     ; NUM OUTPUT BYTES
					;
LF898  FDB  $036E   ; OCB ADDR
LF89A  FDB  $036E   ; ICB ADDR
		;--------------

    	;----------------------------------------
    	; MYSTERY TABLE
		*************************
		* OUTPUT CYCLING TABLE
		*************************
    	;                                
    	;----------------------------------------
LF89C  	FCB	$10		;
	FCB    	$20   		;
	FCB	$00		;
	FCB	$10   		;
	FCB	$21		;
	FCB	$08  		;
	FCB	$10		;
	FCB	$22  		;
	FCB	$08		;
	FCB	$00  		;
	FCB  	$20		;
	FCB	$08  		;
	FCB	$90		;
	FCB	$20  		;
	FCB  	$08		;
	FCB	$10  		;
	FCB	$00		;
	FCB	$08  		;
;
;~~~~~~~~~~~~~~~~~~~~
;
; SWI vector handler
;
;~~~~~~~~~~~~~~~~~~~~
;
LF8AE	BSET	L0000,#$08		;Set b3 of L0000
LF8B1	BRA	LF8B1			;Loop	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~
;
; XIRQ Vector handler
;
;~~~~~~~~~~~~~~~~~~~~~~
;
LF8B3	BSET 	L0000,#$04		;Set b2 of L0000
	PULA				;
	ORAA	#$40			;
	PSHA				;
	RTI				;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

            ***********************************************
            * INTERUPT HANDLER ROUTINES
            *
            *
            *
            *
            ***********************************************

;
;~~~~~~~~~~~~~~~~~~~~~~
;
; Factory test routine
;
;~~~~~~~~~~~~~~~~~~~~~~
;
LF8BB	BSET    L0000,#$02		;set b1
	LDAA    #$01			;b0, TIC 3
	STAA    L3023			;Timer flag 1 reg. 
	RTI				;Return from interrupt     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


			;---------------------------------------------
			; ILLEAGL OP CODE VECTOR INTERUPT HANDLER
			;
			;
			;---------------------------------------------
LF8C4	BSET    L0000,#$10			; SET b4,

F8C7:  LF8C7     BRA     LF8C7

			;---------------------------------------------
			; COP TIME OUT VECTOR INTERUPT HANDLER
			;
			;---------------------------------------------
LF8C9	BSET    L0000,#$20			; SET b5

F8CC:            BRA     LF8D6


;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Clock fail vector handler
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF8CE	BSET	L0000,#$40		;Set b6
LF8D1	BRA     LF8D1			;Loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


			;---------------------------------------------
			; RESET VECTOR INTERUPT HANDLER
			;
			;---------------------------------------------
LF8D3	BSET    L0000,#$80			; SET b7

F8D6:  LF8D6     JMP     L7200				; START OF ALGO
			;---------------------------------------------
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Interrupt handler for:
; TOC 2, TIC 1, TIC 2, TIC 3, RTI
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF8D9	LDAA    #$A0			;1010 0000, Interrupt for TOC 1 and TOC 3 only
	STAA    L3022			;Timer Mask Reg. 1 (TMSK1)
	LDAA    #$5F			;0101 1111, reset all but TOC 1/3
	STAA    L3023			;Timer Interrupt Flag Reg. 1 (TFLG1)
	RTI 				;Return from interrupt    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    		;--------------------------------------------
			;  VECTOR HANDLER FOR ...
			;
			; PA INPUT EDGE VECTOR
			; PA OVER FLOW
			; TMR OVERFLOW
    		;--------------------------------------------
LF8E4	LDAA    #$03				; TMR PRE SCALE = E/16
F8E6:            STAA    L3024				; TMR MASK REG 2

F8E9:            LDAA    #$FF				; CLR ALL FLAGS
F8EB:            STAA    L3025				; TFLG 2

LF8EE	RTI     
    		;----------------------------------------
 
			*****************************************
			*****************************************
 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 'Cool' linear temp vs. A/D counts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 					;Deg C
;
LF8EF	FCB   255			;151
	FCB   255			;151    
	FCB   255			;151        
	FCB   254			;151         
	FCB   237			;138          
	FCB   225			;129         
	FCB   215			;121          
	FCB   207			;115          
	FCB   201			;111          
	FCB   195			;106          
	FCB   190			;103         
	FCB   185			; 99            
	FCB   181 	   		; 96           
	FCB   178			; 94          
	FCB   174			; 91          
	FCB   171			; 88         
	FCB   168			; 86          
	FCB   166			; 85           
	FCB   163			; 82          
	FCB   161			; 81          
	FCB   159			; 79        
	FCB   157			; 78           
	FCB   155    			; 76           
	FCB   153   			; 75          
	FCB   151    			; 73         
	FCB   149    			; 72          
	FCB   147    			; 70          
	FCB   146    			; 70           
	FCB   144    			; 68          
	FCB   143    			; 67          
	FCB   141    			; 66           
	FCB   140    			; 65       
	FCB   139    			; 64        
	FCB   137    			; 63       
	FCB   136    			; 62          
	FCB   135    			; 61           
	FCB   134    			; 61         
	FCB   133    			; 60         
	FCB   131    			; 58         
	FCB   130    			; 58          
	FCB   129    			; 57          
	FCB   128    			; 56         
	FCB   127    			; 55         
	FCB   126    			; 55         
	FCB   125    			; 54          
	FCB   124    			; 53          
	FCB   124    			; 53     
	FCB   123    			; 52         
	FCB   122    			; 52       
	FCB   121    			; 51      
	FCB   120    			; 50        
	FCB   119    			; 49      
	FCB   118    			; 49 
	FCB   118    			; 49    
	FCB   117   			; 48        
	FCB   116    			; 47         
	FCB   115    			; 46       
	FCB   114    			; 46      
	FCB   114    			; 46      
	FCB   113    			; 45         
	FCB   112    			; 44         
	FCB   112   			; 44         
	FCB   111    			; 43        
	FCB   110    			; 43        
	FCB   110    			; 43        
	FCB   109    			; 42         
	FCB   108    			; 41         
	FCB   108    			; 41         
	FCB   107    			; 40        
	FCB   106    			; 40        
	FCB   106    			; 40       
	FCB   105    			; 39        
	FCB   104    			; 38      
	FCB   104    			; 38       
	FCB   103    			; 37       
	FCB   103   	 		; 37        
	FCB   102    			; 37          
	FCB   101    			; 36       
	FCB   101    			; 36   
	FCB   100    			; 35      
	FCB   100    			; 35      
	FCB   99     			; 34        
	FCB   99     			; 34       
	FCB   98     			; 34        
	FCB   98     			; 34    
	FCB   96     			; 32        
	FCB   96     			; 32      
	FCB   95     			; 31          
	FCB   95     			; 31         
	FCB   94     			; 31          
	FCB   94     			; 31          
	FCB   93     			; 30           
	FCB   93     			; 30         
	FCB   92     			; 29          
	FCB   92     			; 29         
	FCB   91     			; 28          
	FCB   91     			; 28         
	FCB   90     			; 28         
	FCB   90     			; 28          
	FCB   89     			; 27        
	FCB   89     			; 27        
	FCB   88     			; 26         
	FCB   88     			; 26        
	FCB   87     			; 25         
	FCB   87     			; 25        
	FCB   86     			; 25        
	FCB   86     			; 25       
	FCB   86     			; 25       
	FCB   85     			; 24          
	FCB   85     			; 24       
	FCB   84     			; 23     
	FCB   84     			; 23       
	FCB   83     			; 22        
	FCB   83     			; 22      
	FCB   82     			; 22       
	FCB   82     			; 22         
	FCB   81     			; 21       
	FCB   81     			; 21      
	FCB   80     			; 20         
	FCB   80     			; 20       
	FCB   80     			; 20      
	FCB   79     			; 19      
	FCB   79     			; 19       
	FCB   78     			; 19      
	FCB   78     			; 19     
	FCB   77     			; 18        
	FCB   77     			; 18     
	FCB   77     			; 18       
	FCB   76     			; 17      
	FCB   76     			; 17     
	FCB   75     			; 16    
	FCB   75     			; 16    
	FCB   74     			; 16    
	FCB   74     			; 16      
	FCB   73     			; 15     
	FCB   73     			; 15      
	FCB   73     			; 15     
	FCB   72     			; 14       
	FCB   72     			; 14     
	FCB   71     			; 13         
	FCB   71     			; 13      
	FCB   70     			; 13        
	FCB   70     			; 13         
	FCB   70     			; 13     
	FCB   69     			; 12  
	FCB   69     			; 12      
	FCB   68     			; 11    
	FCB   68     			; 11      
	FCB   67     			; 10     
	FCB   67     			; 10  
	FCB   67     			; 10   
	FCB   66     			; 10   
	FCB   66     			; 10 
	FCB   65     			;  9  
	FCB   65     			;  9
	FCB   64     			;  8   
	FCB   64    			;  8     
	FCB   63     			;  7      
	FCB   63     			;  7    
	FCB   63     			;  7      
	FCB   62     			;  7      
	FCB   62     			;  7     
	FCB   61     			;  6         
	FCB   61     			;  6     
	FCB   60     			;  5   
	FCB   60     			;  5       
	FCB   59     			;  4        
	FCB   59     			;  4      
	FCB   59     			;  4     
	FCB   58     			;  4       
	FCB   58     			;  4    
	FCB   57     			;  3      
	FCB   57     			;  3     
	FCB   56     			;  2      
	FCB   56     			;  2        
	FCB   55     			;  1         
	FCB   55     			;  1        
	FCB   54     			;  1        
	FCB   54     			;  1        
	FCB   54     			;  1        
	FCB   53     			; -0     
	FCB   53     			; -0    
	FCB   52     			; -1    
	FCB   52     			; -1       
	FCB   51    			; -2     
	FCB   51     			; -2      
	FCB   50     			; -2      
	FCB   50    			; -2         
	FCB   49     			; -3        
	FCB   49     			; -3         
	FCB   48     			; -4      
	FCB   48     			; -4      
	FCB   47     			; -5       
	FCB   47     			; -5        
	FCB   46     			; -5       
	FCB   45     			; -6     
	FCB   45     			; -6      
	FCB   44     			; -7     
	FCB   44     			; -7        
	FCB   43     			; -8      
	FCB   43     			; -8        
	FCB   42     			; -8        
	FCB   42     			; -8        
	FCB   41     			; -9         
	FCB   40     			;-10       
	FCB   40     			;-10        
	FCB   39     			;-11  
	FCB   39     			;-11       
	FCB   38     			;-11      
	FCB   37     			;-12      
	FCB   37     			;-12       
	FCB   36     			;-13       
	FCB   35     			;-14       
	FCB   35     			;-14       
	FCB   34     			;-14   
	FCB   33     			;-15    
	FCB   33     			;-15      
	FCB   32     			;-16       
	FCB   31     			;-17      
	FCB   31     			;-17        
	FCB   30    			;-17     
	FCB   29     			;-18       
	FCB   28     			;-19       
	FCB   28     			;-19      
	FCB   27     			;-20      
	FCB   26     			;-20      
	FCB   25     			;-21        
	FCB   24     			;-22        
	FCB   23     			;-23       
	FCB   22     			;-23       
	FCB   21     			;-24        
	FCB   20     			;-25         
	FCB   19     			;-26          
	FCB   18     			;-26       
	FCB   17     			;-27     
	FCB   16     			;-28    
	FCB   15     			;-29      
	FCB   13     			;-30        
	FCB   12     			;-31        
	FCB   11     			;-32        
	FCB   9      			;-33       
	FCB   8      			;-34      
	FCB   6      			;-35      
	FCB   4      			;-37       
	FCB   3      			;-38    
	FCB   1      			;-39       
	FCB   0      			;-40    
	FCB   0      			;-40      
	FCB   0     			;-40         
	FCB   0      			;-40        
	FCB   0      			;-40        
	FCB   0      			;-40        
	FCB   0      			;-40         
	FCB   0      			;-40         
	FCB   0      			;-40    
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 'Warm' linear temp vs. A/D counts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; 					;Deg C
;
LF9EF	FCB   255    			;151          
	FCB   255    			;151        
	FCB   255    			;151   
	FCB   255    			;151           
	FCB   255    			;151          
	FCB   255    			;151         
	FCB   255    			;151         
	FCB   255    			;151         
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151           
	FCB   255    			;151           
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151         
	FCB   255    			;151      
	FCB   255    			;151          
	FCB   255    			;151       
	FCB   255    			;151         
	FCB   255    			;151         
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151          
	FCB   255    			;151         
	FCB   255    			;151          
	FCB   255    			;151        
	FCB   253    			;150         
	FCB   251    			;148         
	FCB   249    			;147         
	FCB   247    			;145         
	FCB   245    			;144           
	FCB   243    			;142          
	FCB   241    			;141          
	FCB   239    			;139           
	FCB   237    			;138          
	FCB   236    			;137           
	FCB   234    			;136          
	FCB   232    			;134          
	FCB   231    			;133         
	FCB   229    			;132         
	FCB   228    			;131        
	FCB   227    			;130       
	FCB   225    			;129       
	FCB   224    			;128          
	FCB   222    			;127          
	FCB   221    			;126          
	FCB   220    			;125          
	FCB   219    			;124        
	FCB   217    			;123        
	FCB   216    			;122        
	FCB   215    			;121        
	FCB   214    			;121         
	FCB   213    			;120         
	FCB   211    			;118         
	FCB   210    			;118          
	FCB   209    			;117         
	FCB   208    			;116          
	FCB   207    			;115          
	FCB   206    			;115        
	FCB   205    			;114        
	FCB   204    			;113        
	FCB   203    			;112         
	FCB   202    			;112        
	FCB   201    			;111       
	FCB   200    			;110           
	FCB   199    			;109        
	FCB   198    			;109        
	FCB   197    			;108          
	FCB   196    			;107          
	FCB   195    			;106         
	FCB   195    			;106          
	FCB   194    			;106         
	FCB   193    			;105          
	FCB   192    			;104          
	FCB   191    			;103          
	FCB   190    			;103          
	FCB   189    			;102        
	FCB   189    			;102     
	FCB   188    			;101          
	FCB   187    			;100         
	FCB   186    			;100        
	FCB   185    			; 99         
	FCB   185    			; 99         
	FCB   184    			; 98        
	FCB   183    			; 97          
	FCB   182    			; 97          
	FCB   182    			; 97          
	FCB   181    			; 96          
	FCB   180    			; 95          
	FCB   179    			; 94          
	FCB   179    			; 94          
	FCB   178    			; 94          
	FCB   177    			; 93          
	FCB   176    			; 92          
	FCB   176    			; 92          
	FCB   175    			; 91   
	FCB   174    			; 91        
	FCB   174    			; 91       
	FCB   173    			; 90       
	FCB   172   			; 89        
	FCB   171   			; 88      
	FCB   171    			; 88     
	FCB   170    			; 88       
	FCB   169    			; 87       
	FCB   169    			; 87     
	FCB   168    			; 86       
	FCB   167   			; 85     
	FCB   167    			; 85       
	FCB   166    			; 85     
	FCB   165    			; 84         
	FCB   165    			; 84        
	FCB   164    			; 83      
	FCB   163    			; 82     
	FCB   163    			; 82     
	FCB   162    			; 82   
	FCB   161    			; 81         
	FCB   161    			; 81         
	FCB   160    			; 80        
	FCB   160    			; 80         
	FCB   159    			; 79        
	FCB   158    			; 79      
	FCB   158    			; 79      
	FCB   157    			; 78        
	FCB   156    			; 77       
	FCB   156    			; 77      
	FCB   155    			; 76        
	FCB   155    			; 76     
	FCB   154    			; 76       
	FCB   153    			; 75        
	FCB   153    			; 75         
	FCB   152    			; 74        
	FCB   151    			; 73        
	FCB   151    			; 73         
	FCB   150    			; 73         
	FCB   150    			; 73       
	FCB   149    			; 72   
	FCB   148    			; 71    
	FCB   148    			; 71       
	FCB   147    			; 70     
	FCB   147    			; 70      
	FCB   146    			; 70     
	FCB   145    			; 69        
	FCB   145    			; 69      
	FCB   144    			; 68        
	FCB   143    			; 67      
	FCB   143    			; 67       
	FCB   142    			; 67       
	FCB   142    			; 67       
	FCB   141    			; 66         
	FCB   140    			; 65          
	FCB   140    			; 65          
	FCB   139    			; 64       
	FCB   139    			; 64    
	FCB   138    			; 64     
	FCB   137    			; 63       
	FCB   137    			; 63      
	FCB   136    			; 62          
	FCB   135    			; 61        
	FCB   135    			; 61      
	FCB   134    			; 61        
	FCB   134    			; 61        
	FCB   133    			; 60        
	FCB   132    			; 59        
	FCB   132    			; 59         
	FCB   131    			; 58       
	FCB   130    			; 58         
	FCB   130    			; 58         
	FCB   129    			; 57      
	FCB   128    			; 56        
	FCB   128    			; 56       
	FCB   127    			; 55        
	FCB   126    			; 55        
	FCB   126    			; 55  
	FCB   125    			; 54    
	FCB   125    			; 54     
	FCB   124    			; 53     
	FCB   123    			; 52     
	FCB   122    			; 52     
	FCB   122    			; 52     
	FCB   121    			; 51        
	FCB   120    			; 50       
	FCB   120    			; 50      
	FCB   119    			; 49      
	FCB   118    			; 49       
	FCB   118    			; 49        
	FCB   117    			; 48      
	FCB   116    			; 47       
	FCB   116    			; 47    
	FCB   115    			; 46      
	FCB   114    			; 46      
	FCB   113    			; 45     
	FCB   113    			; 45        
	FCB   112    			; 44        
	FCB   111    			; 43       
	FCB   110    			; 43      
	FCB   109    			; 42         
	FCB   109    			; 42         
	FCB   108    			; 41          
	FCB   107    			; 40          
	FCB   106    			; 40          
	FCB   105    			; 39          
	FCB   105    			; 39          
	FCB   104    			; 38          
	FCB   103    			; 37          
	FCB   102    			; 37          
	FCB   101    			; 36          
	FCB   100    			; 35          
	FCB   99     			; 34          
	FCB   98     			; 34          
	FCB   97     			; 33          
	FCB   97     			; 33          
	FCB   96     			; 32          
	FCB   95     			; 31          
	FCB   94     			; 31          
	FCB   92     			; 29          
	FCB   91     			; 28          
	FCB   90     			; 28          
	FCB   89     			; 27          
	FCB   88    			; 26          
	FCB   87     			; 25          
	FCB   86     			; 25          
	FCB   85     			; 24          
	FCB   83     			; 22          
	FCB   82     			; 22          
	FCB   81     			; 21          
	FCB   79     			; 19          
	FCB   78     			; 19          
	FCB   76     			; 17          
	FCB   75     			; 16          
	FCB   73     			; 15          
	FCB   71     			; 13          
	FCB   70     			; 13          
	FCB   68     			; 11          
	FCB   66     			; 10          
	FCB   64     			;  8          
	FCB   62     			;  7          
	FCB   59     			;  4          
	FCB   57     			;  3          
	FCB   54     			;  1          
	FCB   51     			; -2          
	FCB   47     			; -5          
	FCB   43     			; -8          
	FCB   39     			;-11          
	FCB   34     			;-14          
	FCB   27     			;-20          
	FCB   18     			;-26          
	FCB   3      			;-38          
	FCB   0      			;-40          
	FCB   0      			;-40         
	FCB   0      			;-40      
	FCB   0      			;-40        
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Deg C MAT temp vs. AD MAT counts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;					;Deg C
;
LFAEF  	FCB   0				;-40
	FCB   26			;-28 
	FCB   44			;-16 
	FCB   56			; -4  
	FCB   65			;  8  
	FCB   74			; 20 
	FCB   82			; 32 
	FCB   89			; 44
	FCB   97			; 56
	FCB   105			; 68 
	FCB   113			; 80 
	FCB   122			; 92 
	FCB   133			;104 
	FCB   147			;116 
	FCB   166			;128 
	FCB   199			;140 
	FCB   255			;152 	
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-SES error blink out table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Error #
;	Upper nibble = 10's blink out
;	Lower nibble = 1's blink out	;Error # counter
;
LFB00  	FCB  $12			; 0
;
;-Alternate start point for HU table
;
LFB01  	FCB  $13			; 1
	FCB  $14			; 2
	FCB  $15			; 3
	FCB  $16			; 4
	FCB  $17			; 5
	FCB  $18			; 6
	FCB  $19			; 7
	FCB  $21			; 8
	FCB  $22			; 9
	FCB  $23			;10 
	FCB  $24			;11
	FCB  $25			;12 
	FCB  $26			;13
	FCB  $27			;14
	FCB  $28			;15
	FCB  $29			;16
	FCB  $31			;17 
	FCB  $32			;18
	FCB  $33			;19 
	FCB  $34			;20
	FCB  $35			;21
	FCB  $36			;22
	FCB  $37			;23 
	FCB  $38			;24
	FCB  $39			;25 
	FCB  $41			;26 
	FCB  $42			;27
	FCB  $43			;28
	FCB  $44			;29
	FCB  $45			;30
	FCB  $46			;31
	FCB  $47			;32
	FCB  $48			;33
	FCB  $49			;34
	FCB  $51			;35
	FCB  $52			;36
	FCB  $53			;37
	FCB  $54			;38
	FCB  $55			;39
	FCB  $56			;40
	FCB  $57			;41
	FCB  $58			;42
	FCB  $59			;43
	FCB  $61			;44
	FCB  $62			;45
	FCB  $63			;46
	FCB  $64			;47
	FCB  $65			;48
	FCB  $66			;49
	FCB  $67			;50
	FCB  $68			;51
	FCB  $69			;52
	FCB  $71			;53 
	FCB  $72			;54
	FCB  $73			;55
	FCB  $74			;56
	FCB  $75			;57  
	FCB  $76			;58
	FCB  $77			;59
	FCB  $78			;60
	FCB  $79			;61
	FCB  $81			;62
	FCB  $82			;63
	FCB  $83			;64
	FCB  $84			;65
	FCB  $85			;66
	FCB  $86			;67
	FCB  $87			;68
	FCB  $88			;69
	FCB  $89			;70
	FCB  $91			;71
;
;-Alternate end point for HU table
;
	FCB  $92			;71
;
	

		;-------------------
		; all 0's
		;
		;-------------------
	
			

		;----------------------------------------------
		;
		;
		;
		;----------------------------------------------
        ORG  $FF90		;NEED THIS!!!
        
FF90:   FDB  $7E99
FF92:   FDB  $7C7E
FF94:   FDB  $A4D0
FF96:   FDB  $7EEF
FF98:   FDB  $C300
FF9A:   FDB  $0000
FF9C:   FDB  $0000
FF9E:   FDB  $0000
FFA0:   FDB  $EF47
FFA2:   FDB  $EEFC
FFA4:   FDB  $EF12			;Port D config routine
FFA6:   FDB  $F081
FFA8:   FDB  $0035
FFAA:   FDB  $036E
FFAC:   FDB  $0000
FFAE:   FDB  $0000
FFB0:   FDB  $53D7
FFB2:   FDB  $0000
FFB4:   FDB  $0000
FFB6:   FDB  $0000
FFB8:   FDB  $0000
FFBA:   FDB  $0000
FFBC:   FDB  $0000
FFBE:   FDB  $0000
FFC0:   FDB  $F8EE
FFC2:   FDB  $F8EE
FFC4:   FDB  $F8EE
FFC6:   FDB  $F8EE
FFC8:   FDB  $F8EE
FFCA:   FDB  $F8EE
FFCC:   FDB  $F8EE
FFCE:   FDB  $F8EE
FFD0:   FDB  $F8EE
FFD2:   FDB  $F8EE
FFD4:   FDB  $F8EE

;
;~~~~~~~~~~~~~~
;-Vector Table
;~~~~~~~~~~~~~~
;
	ORG	$FFD6
;
LFFD6	FDB  LF494	;SCI interrupt
LFFD8   FDB  LF8EE	;SPI vector to RTI
LFFDA	FDB  LF8E4	;Pulse acc. input edge vect.
LFFDC   FDB  LF8E4	;Pulse acc. overflow
LFFDE   FDB  LF8E4	;Timer overflow
LFFE0   FDB  L7922	;TOC 5, Inj. handling
LFFE2   FDB  L7986	;TOC 4, Inj. handling
LFFE4   FDB  L79EA	;TOC 3, Main vector handler
LFFE6   FDB  LF8D9	;TOC 2,
LFFE8   FDB  LCC8A	;TOC 1, Knock counter routine
LFFEA   FDB  LF8D9	;TIC 3, Inj. handling 
LFFEC   FDB  LF8D9	;TIC 2, VATS
LFFEE   FDB  LF8D9 	;TIC 1, 
LFFF0   FDB  LF8D9	;RTI
LFFF2   FDB  L7597	;IRQ, DRP/cranking fuel routine
LFFF4   FDB  LF8B3	;XIRQ 
LFFF6   FDB  LF8AE	;SWI 
LFFF8   FDB  LF8C4	;Illegal OP code
LFFFA   FDB  LF8C9	;COP time out
LFFFC   FDB  LF8CE	;Clock fail
LFFFE   FDB  LF8D3	;Power on reset vector

